/*************************************************************************
 *
 *  $RCSfile: sc_validate.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 11:45:11 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

#ifndef PCH
// auto strip #include <svtools/aeitem.hxx>
// auto strip #include <svtools/stritem.hxx>
// auto strip #include <svtools/eitem.hxx>
// auto strip #include <vcl/svapp.hxx>
// auto strip #include <basic/sbmeth.hxx>
// auto strip #include <basic/sbstar.hxx>
// auto strip #include <basic/sbmod.hxx>
// auto strip #include <tools/urlobj.hxx>
// auto strip #include <bf_offmgr/app.hxx>
#endif

// auto strip #include "scresid.hxx"
#include "bf_sc.hrc"       // -> Slot IDs

#include "validat.hxx"

#include "validate.hrc"

#define _VALIDATE_CXX
// auto strip #include "validate.hxx"
#undef _VALIDATE_CXX
namespace binfilter {

// STATIC DATA -----------------------------------------------------------

static USHORT pValueRanges[] =
{
	FID_VALID_MODE,	FID_VALID_ERRTEXT,
	0
};

static USHORT pHelpRanges[] =
{
	FID_VALIDATION,
	FID_VALIDATION,
	0
};

static USHORT pErrorRanges[] =
{
	FID_VALIDATION,
	FID_VALIDATION,
	0
};

//==================================================================

//STRIP001 ScValidationDlg::ScValidationDlg( Window*			pParent,
//STRIP001 					  const SfxItemSet* pArgSet ) :
//STRIP001 		SfxTabDialog( pParent,
//STRIP001 					  ScResId( TAB_DLG_VALIDATION ),
//STRIP001 					  pArgSet )
//STRIP001 {
//STRIP001 	AddTabPage( TP_VALIDATION_VALUES, ScTPValidationValue::Create,  0 );
//STRIP001 	AddTabPage( TP_VALIDATION_INPUTHELP, ScTPValidationHelp::Create,  0 );
//STRIP001 	AddTabPage( TP_VALIDATION_ERROR, ScTPValidationError::Create,  0 );
//STRIP001 	FreeResource();
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 __EXPORT ScValidationDlg::~ScValidationDlg()
//STRIP001 {
//STRIP001 }

//========================================================================
//========================================================================
// Values page

//STRIP001 ScTPValidationValue::ScTPValidationValue( Window*			pParent,
//STRIP001 										  const SfxItemSet& rArgSet )
//STRIP001 
//STRIP001 	:	SfxTabPage		( pParent,
//STRIP001 						  ScResId( TP_VALIDATION_VALUES ),
//STRIP001 						  rArgSet ),
//STRIP001 		aFtAllow  		( this, ScResId( FT_ALLOW ) ),
//STRIP001 		aLbAllow		( this, ScResId( LB_ALLOW ) ),
//STRIP001 		aTsbAllow		( this, ScResId( TSB_ALLOW_BLANKS ) ),
//STRIP001 		aFtValue  		( this, ScResId( FT_VALUE ) ),
//STRIP001 		aLbValue		( this, ScResId( LB_VALUE ) ),
//STRIP001 		aFtMin    		( this, ScResId( FT_MIN ) ),
//STRIP001 		aEdtMin 		( this, ScResId( EDT_MIN ) ),
//STRIP001 		aFtMax    		( this, ScResId( FT_MAX ) ),
//STRIP001 		aEdtMax 		( this, ScResId( EDT_MAX ) ),
//STRIP001 
//STRIP001 		aStrMin      	( ScResId( SCSTR_MINIMUM ) ),
//STRIP001 		aStrMax   		( ScResId( SCSTR_MAXIMUM ) ),
//STRIP001 		aStrValue   	( ScResId( SCSTR_VALUE ) ),
//STRIP001 
//STRIP001 		rSet			( rArgSet )
//STRIP001 {
//STRIP001 	Init();
//STRIP001 	FreeResource();
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 __EXPORT ScTPValidationValue::~ScTPValidationValue()
//STRIP001 {
//STRIP001 }
//STRIP001 
// -----------------------------------------------------------------------

//STRIP001 void ScTPValidationValue::Init()
//STRIP001 {
//STRIP001 	aLbAllow.SetSelectHdl( LINK( this, ScTPValidationValue, SelectAllowHdl ) );
//STRIP001 	aLbValue.SetSelectHdl( LINK( this, ScTPValidationValue, SelectValueHdl ) );
//STRIP001 
//STRIP001 	aLbAllow.SelectEntryPos( 0 );
//STRIP001 	aTsbAllow.EnableTriState( FALSE );
//STRIP001 	aLbValue.SelectEntryPos( 0 );
//STRIP001 
//STRIP001 	SelectAllowHdl( NULL );
//STRIP001 	SelectValueHdl( NULL );
//STRIP001 }

//------------------------------------------------------------------------

//STRIP001 USHORT* __EXPORT ScTPValidationValue::GetRanges()
//STRIP001 {
//STRIP001 	return pValueRanges;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 SfxTabPage* __EXPORT ScTPValidationValue::Create( Window*	pParent,
//STRIP001 										 const SfxItemSet&	rArgSet )
//STRIP001 {
//STRIP001 	return ( new ScTPValidationValue( pParent, rArgSet ) );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void __EXPORT ScTPValidationValue::Reset( const SfxItemSet& rArgSet )
//STRIP001 {
//STRIP001 	const SfxPoolItem* pItem;
//STRIP001 
//STRIP001 	if ( rArgSet.GetItemState( FID_VALID_MODE, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 		aLbAllow.SelectEntryPos( ((const SfxAllEnumItem*)pItem)->GetValue() );
//STRIP001 	else
//STRIP001 		aLbAllow.SelectEntryPos( 0 );		// default: all values
//STRIP001 
//STRIP001 	if ( rArgSet.GetItemState( FID_VALID_CONDMODE, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 		aLbValue.SelectEntryPos( ((const SfxAllEnumItem*)pItem)->GetValue() );
//STRIP001 	else
//STRIP001 		aLbValue.SelectEntryPos( 0 );		// default: equal
//STRIP001 
//STRIP001 	if ( rArgSet.GetItemState( FID_VALID_VALUE1, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 		aEdtMin.SetText( ((const SfxStringItem*)pItem)->GetValue() );
//STRIP001 	else
//STRIP001 		aEdtMin.SetText( EMPTY_STRING );
//STRIP001 
//STRIP001 	if ( rArgSet.GetItemState( FID_VALID_VALUE2, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 		aEdtMax.SetText( ((const SfxStringItem*)pItem)->GetValue() );
//STRIP001 	else
//STRIP001 		aEdtMax.SetText( EMPTY_STRING );
//STRIP001 
//STRIP001 	if ( rArgSet.GetItemState( FID_VALID_BLANK, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 		aTsbAllow.SetState( ((const SfxBoolItem*)pItem)->GetValue() ? STATE_CHECK : STATE_NOCHECK );
//STRIP001 	else
//STRIP001 		aTsbAllow.SetState( STATE_CHECK );	// default: on
//STRIP001 
//STRIP001 	SelectAllowHdl( NULL );
//STRIP001 	SelectValueHdl( NULL );
//STRIP001 }

// -----------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL __EXPORT ScTPValidationValue::FillItemSet( SfxItemSet& rArgSet )
//STRIP001 {
//STRIP001 	rArgSet.Put( SfxAllEnumItem( FID_VALID_MODE, aLbAllow.GetSelectEntryPos() ) );
//STRIP001 	rArgSet.Put( SfxAllEnumItem( FID_VALID_CONDMODE, aLbValue.GetSelectEntryPos() ) );
//STRIP001 	rArgSet.Put( SfxStringItem( FID_VALID_VALUE1, aEdtMin.GetText() ) );
//STRIP001 	rArgSet.Put( SfxStringItem( FID_VALID_VALUE2, aEdtMax.GetText() ) );
//STRIP001 	rArgSet.Put( SfxBoolItem( FID_VALID_BLANK, aTsbAllow.GetState() == STATE_CHECK ) );
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }


// -----------------------------------------------------------------------

//STRIP001 IMPL_LINK( ScTPValidationValue, SelectAllowHdl, ListBox *, pLb )
//STRIP001 {
//STRIP001 	BOOL bEnable = aLbAllow.GetSelectEntryPos() != 0;
//STRIP001 
//STRIP001 	aTsbAllow.Enable( bEnable );	// Leerzellen
//STRIP001 	aFtValue.Enable( bEnable );
//STRIP001 	aLbValue.Enable( bEnable );
//STRIP001 	aFtMin.Enable( bEnable );
//STRIP001 	aEdtMin.Enable( bEnable );
//STRIP001 	aFtMax.Enable( bEnable );
//STRIP001 	aEdtMax.Enable( bEnable );
//STRIP001 
//STRIP001 	return( 0L );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 IMPL_LINK( ScTPValidationValue, SelectValueHdl, ListBox *, pLb )
//STRIP001 {
//STRIP001 	USHORT nPos = aLbValue.GetSelectEntryPos();
//STRIP001 	BOOL bShow = FALSE;
//STRIP001 
//STRIP001 	switch( nPos )
//STRIP001 	{
//STRIP001 		case 0:	// ==
//STRIP001 		case 5: // !=
//STRIP001 			aFtMin.SetText( aStrValue );
//STRIP001 		break;
//STRIP001 
//STRIP001 		case 1: // <
//STRIP001 		case 3: // <=
//STRIP001 			aFtMin.SetText( aStrMax );
//STRIP001 		break;
//STRIP001 
//STRIP001 		case 6: // zwischen
//STRIP001 		case 7: // n. zwischen
//STRIP001 			bShow = TRUE;
//STRIP001 		case 2: // >
//STRIP001 		case 4: // >=
//STRIP001 			aFtMin.SetText( aStrMin );
//STRIP001 		break;
//STRIP001 
//STRIP001 		default:
//STRIP001 			DBG_ERROR( "Wert ist nicht im Bereich der Stringlist!" );
//STRIP001 		break;
//STRIP001 	}
//STRIP001 
//STRIP001 	bShow ? aFtMax.Show() : aFtMax.Hide();
//STRIP001 	bShow ? aEdtMax.Show() : aEdtMax.Hide();
//STRIP001 
//STRIP001 	return( 0L );
//STRIP001 }

//========================================================================
//========================================================================
// Input Help Page

//STRIP001 ScTPValidationHelp::ScTPValidationHelp( Window*			pParent,
//STRIP001 										  const SfxItemSet& rArgSet )
//STRIP001 
//STRIP001 	:	SfxTabPage		( pParent,
//STRIP001 						  ScResId( TP_VALIDATION_INPUTHELP ),
//STRIP001 						  rArgSet ),
//STRIP001 		aTsbHelp		( this, ScResId( TSB_HELP ) ),
//STRIP001 		aFtTitle		( this, ScResId( FT_TITLE ) ),
//STRIP001 		aEdtTitle		( this, ScResId( EDT_TITLE ) ),
//STRIP001 		aFtInputHelp	( this, ScResId( FT_INPUTHELP ) ),
//STRIP001 		aEdInputHelp	( this, ScResId( EDT_INPUTHELP ) ),
//STRIP001         aFlContent      ( this, ScResId( FL_CONTENT ) ),
//STRIP001 
//STRIP001 		rSet			( rArgSet )
//STRIP001 {
//STRIP001 	Init();
//STRIP001 	FreeResource();
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 __EXPORT ScTPValidationHelp::~ScTPValidationHelp()
//STRIP001 {
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void ScTPValidationHelp::Init()
//STRIP001 {
//STRIP001 	//aLb.SetSelectHdl( LINK( this, ScTPValidationHelp, SelectHdl ) );
//STRIP001 
//STRIP001 	aTsbHelp.EnableTriState( FALSE );
//STRIP001 }

//------------------------------------------------------------------------

//STRIP001 USHORT* __EXPORT ScTPValidationHelp::GetRanges()
//STRIP001 {
//STRIP001 	return pValueRanges;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 SfxTabPage* __EXPORT ScTPValidationHelp::Create( Window*	pParent,
//STRIP001 										 const SfxItemSet&	rArgSet )
//STRIP001 {
//STRIP001 	return ( new ScTPValidationHelp( pParent, rArgSet ) );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void __EXPORT ScTPValidationHelp::Reset( const SfxItemSet& rArgSet )
//STRIP001 {
//STRIP001 	const SfxPoolItem* pItem;
//STRIP001 
//STRIP001 	if ( rArgSet.GetItemState( FID_VALID_SHOWHELP, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 		aTsbHelp.SetState( ((const SfxBoolItem*)pItem)->GetValue() ? STATE_CHECK : STATE_NOCHECK );
//STRIP001 	else
//STRIP001 		aTsbHelp.SetState( STATE_NOCHECK );
//STRIP001 
//STRIP001 	if ( rArgSet.GetItemState( FID_VALID_HELPTITLE, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 		aEdtTitle.SetText( ((const SfxStringItem*)pItem)->GetValue() );
//STRIP001 	else
//STRIP001 		aEdtTitle.SetText( EMPTY_STRING );
//STRIP001 
//STRIP001 	if ( rArgSet.GetItemState( FID_VALID_HELPTEXT, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 		aEdInputHelp.SetText( ((const SfxStringItem*)pItem)->GetValue() );
//STRIP001 	else
//STRIP001 		aEdInputHelp.SetText( EMPTY_STRING );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 BOOL __EXPORT ScTPValidationHelp::FillItemSet( SfxItemSet& rArgSet )
//STRIP001 {
//STRIP001 	rArgSet.Put( SfxBoolItem( FID_VALID_SHOWHELP, aTsbHelp.GetState() == STATE_CHECK ) );
//STRIP001 	rArgSet.Put( SfxStringItem( FID_VALID_HELPTITLE, aEdtTitle.GetText() ) );
//STRIP001 	rArgSet.Put( SfxStringItem( FID_VALID_HELPTEXT, aEdInputHelp.GetText() ) );
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }

//========================================================================
//========================================================================
// Error Alert Page

//STRIP001 ScTPValidationError::ScTPValidationError( Window*			pParent,
//STRIP001 										  const SfxItemSet& rArgSet )
//STRIP001 
//STRIP001 	:	SfxTabPage		( pParent,
//STRIP001 						  ScResId( TP_VALIDATION_ERROR ),
//STRIP001 						  rArgSet ),
//STRIP001 		aTsbShow		( this, ScResId( TSB_SHOW ) ),
//STRIP001 		aFtAction		( this, ScResId( FT_ACTION ) ),
//STRIP001 		aLbAction		( this, ScResId( LB_ACTION ) ),
//STRIP001 		aBtnSearch		( this, ScResId( BTN_SEARCH ) ),
//STRIP001 		aFtTitle		( this, ScResId( FT_TITLE ) ),
//STRIP001 		aEdtTitle		( this, ScResId( EDT_TITLE ) ),
//STRIP001 		aFtError		( this, ScResId( FT_ERROR ) ),
//STRIP001 		aEdError		( this, ScResId( EDT_ERROR ) ),
//STRIP001         aFlContent      ( this, ScResId( FL_CONTENT ) ),
//STRIP001 
//STRIP001 		rSet			( rArgSet )
//STRIP001 {
//STRIP001 	Init();
//STRIP001 	FreeResource();
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 __EXPORT ScTPValidationError::~ScTPValidationError()
//STRIP001 {
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void ScTPValidationError::Init()
//STRIP001 {
//STRIP001 	aLbAction.SetSelectHdl( LINK( this, ScTPValidationError, SelectActionHdl ) );
//STRIP001 	aBtnSearch.SetClickHdl( LINK( this, ScTPValidationError, ClickSearchHdl ) );
//STRIP001 
//STRIP001 	aLbAction.SelectEntryPos( 0 );
//STRIP001 	aTsbShow.EnableTriState( FALSE );
//STRIP001 
//STRIP001 	SelectActionHdl( NULL );
//STRIP001 }

//------------------------------------------------------------------------

//STRIP001 USHORT* __EXPORT ScTPValidationError::GetRanges()
//STRIP001 {
//STRIP001 	return pValueRanges;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 SfxTabPage* __EXPORT ScTPValidationError::Create( Window*	pParent,
//STRIP001 										 const SfxItemSet&	rArgSet )
//STRIP001 {
//STRIP001 	return ( new ScTPValidationError( pParent, rArgSet ) );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void __EXPORT ScTPValidationError::Reset( const SfxItemSet& rArgSet )
//STRIP001 {
//STRIP001 	const SfxPoolItem* pItem;
//STRIP001 
//STRIP001 	if ( rArgSet.GetItemState( FID_VALID_SHOWERR, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 		aTsbShow.SetState( ((const SfxBoolItem*)pItem)->GetValue() ? STATE_CHECK : STATE_NOCHECK );
//STRIP001 	else
//STRIP001 		aTsbShow.SetState( STATE_NOCHECK );
//STRIP001 
//STRIP001 	if ( rArgSet.GetItemState( FID_VALID_ERRSTYLE, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 		aLbAction.SelectEntryPos( ((const SfxAllEnumItem*)pItem)->GetValue() );
//STRIP001 	else
//STRIP001 		aLbAction.SelectEntryPos( 0 );
//STRIP001 
//STRIP001 	if ( rArgSet.GetItemState( FID_VALID_ERRTITLE, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 		aEdtTitle.SetText( ((const SfxStringItem*)pItem)->GetValue() );
//STRIP001 	else
//STRIP001 		aEdtTitle.SetText( EMPTY_STRING );
//STRIP001 
//STRIP001 	if ( rArgSet.GetItemState( FID_VALID_ERRTEXT, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 		aEdError.SetText( ((const SfxStringItem*)pItem)->GetValue() );
//STRIP001 	else
//STRIP001 		aEdError.SetText( EMPTY_STRING );
//STRIP001 
//STRIP001 	SelectActionHdl( NULL );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 BOOL __EXPORT ScTPValidationError::FillItemSet( SfxItemSet& rArgSet )
//STRIP001 {
//STRIP001 	rArgSet.Put( SfxBoolItem( FID_VALID_SHOWERR, aTsbShow.GetState() == STATE_CHECK ) );
//STRIP001 	rArgSet.Put( SfxAllEnumItem( FID_VALID_ERRSTYLE, aLbAction.GetSelectEntryPos() ) );
//STRIP001 	rArgSet.Put( SfxStringItem( FID_VALID_ERRTITLE, aEdtTitle.GetText() ) );
//STRIP001 	rArgSet.Put( SfxStringItem( FID_VALID_ERRTEXT, aEdError.GetText() ) );
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 IMPL_LINK( ScTPValidationError, SelectActionHdl, ListBox *, pLb )
//STRIP001 {
//STRIP001 	ScValidErrorStyle eStyle = (ScValidErrorStyle) aLbAction.GetSelectEntryPos();
//STRIP001 	BOOL bMacro = ( eStyle == SC_VALERR_MACRO );
//STRIP001 
//STRIP001 	aBtnSearch.Enable( bMacro );
//STRIP001 	aFtError.Enable( !bMacro );
//STRIP001 	aEdError.Enable( !bMacro );
//STRIP001 
//STRIP001 	return( 0L );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 IMPL_LINK( ScTPValidationError, ClickSearchHdl, PushButton*, pBtn )
//STRIP001 {
//STRIP001 	Window* pOld = Application::GetDefDialogParent();
//STRIP001 	Application::SetDefDialogParent( this );
//STRIP001 
//STRIP001     // choose macro dialog    
//STRIP001     String aScriptURL = OfficeApplication::ChooseMacro(FALSE, TRUE);
//STRIP001 
//STRIP001     Application::SetDefDialogParent( pOld );
//STRIP001 
//STRIP001 	// aScriptURL has the following format:
//STRIP001     // vnd.sun.star.script:language=[language],macro=[macro],location=[location]
//STRIP001     // [language] = StarBasic
//STRIP001     // [macro] = libname.modulename.macroname
//STRIP001     // [location] = application|document
//STRIP001     // e.g. 'vnd.sun.star.script:language=StarBasic,macro=Standard.Module1.Main,location=document'
//STRIP001     //
//STRIP001 	// but for the UI we need this format:
//STRIP001 	// 'macroname'
//STRIP001 
//STRIP001 	if ( aScriptURL.Len() != 0 )
//STRIP001 	{
//STRIP001 		// parse script URL
//STRIP001         BOOL bFound;
//STRIP001         String aValue;
//STRIP001         INetURLObject aINetScriptURL( aScriptURL );
//STRIP001 
//STRIP001         // get language
//STRIP001         String aLanguage;
//STRIP001         bFound = aINetScriptURL.getParameter( String( RTL_CONSTASCII_USTRINGPARAM("language") ), &aValue );
//STRIP001         if ( bFound )
//STRIP001             aLanguage = aValue;
//STRIP001 
//STRIP001         // get macro
//STRIP001         String aMacro;
//STRIP001         String aLibName;
//STRIP001         String aModuleName;
//STRIP001         String aMacroName;
//STRIP001         bFound = aINetScriptURL.getParameter( String( RTL_CONSTASCII_USTRINGPARAM("macro") ), &aValue );
//STRIP001         if ( bFound )
//STRIP001         {
//STRIP001             aMacro = aValue;
//STRIP001             aLibName    = aMacro.GetToken(0, sal_Unicode('.'));
//STRIP001 		    aModuleName = aMacro.GetToken(1, sal_Unicode('.'));
//STRIP001 		    aMacroName  = aMacro.GetToken(2, sal_Unicode('.'));
//STRIP001         }
//STRIP001 
//STRIP001         // get location
//STRIP001         String aLocation;
//STRIP001         bFound = aINetScriptURL.getParameter( String( RTL_CONSTASCII_USTRINGPARAM("location") ), &aValue );
//STRIP001         if ( bFound )
//STRIP001             aLocation = aValue;
//STRIP001 
//STRIP001 		aEdtTitle.SetText( aMacroName );
//STRIP001     }
//STRIP001 
//STRIP001 	return( 0L );
//STRIP001 }


}
