/*************************************************************************
 *
 *  $RCSfile: sc_drtxtob2.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 11:51:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

//-------------------------------------------------------------------------

#include "scitems.hxx"
#include <bf_svx/adjitem.hxx>
// auto strip #include <bf_svx/drawitem.hxx>
#include <bf_svx/fontwork.hxx>
// auto strip #include <bf_svx/frmdiritem.hxx>
// auto strip #include <bf_svx/outlobj.hxx>
#include <bf_svx/svdocapt.hxx>
// auto strip #include <bf_svx/xtextit.hxx>
// auto strip #ifndef _SVX_WRITINGMODEITEM_HXX
// auto strip #include <bf_svx/writingmodeitem.hxx>
// auto strip #endif
// auto strip #include <bf_sfx2/bindings.hxx>
// auto strip #include <bf_sfx2/objsh.hxx>
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #include <sot/formats.hxx>
// auto strip #include <svtools/whiter.hxx>

#include "bf_sc.hrc"
// auto strip #include "drtxtob.hxx"
// auto strip #include "viewdata.hxx"
// auto strip #include "drawview.hxx"
// auto strip #include "tabvwsh.hxx"
// auto strip #include "impex.hxx"
// auto strip #include "docsh.hxx"
// auto strip #include "transobj.hxx"
// auto strip #include "drwtrans.hxx"
namespace binfilter {

//------------------------------------------------------------------------

/*N*/ USHORT ScGetFontWorkId()
/*N*/ {
/*N*/ 	return SvxFontWorkChildWindow::GetChildWindowId();
/*N*/ }

//STRIP001 BOOL ScDrawTextObjectBar::IsNoteEdit()
//STRIP001 {
//STRIP001 	ScTabView* pTabView	= pViewData->GetView();
//STRIP001 	SdrView*   pSdrView	= pTabView->GetSdrView();
//STRIP001 	SdrObject* pObject	= pSdrView->GetTextEditObject();
//STRIP001 	return ( pObject && pObject->GetLayer() == SC_LAYER_INTERN && pObject->ISA( SdrCaptionObj ) );
//STRIP001 }
//STRIP001 
//STRIP001 //	wenn kein Text editiert wird, Funktionen wie in drawsh
//STRIP001 
//STRIP001 void __EXPORT ScDrawTextObjectBar::ExecuteGlobal( SfxRequest &rReq )
//STRIP001 {
//STRIP001 	ScTabView*	 pTabView  = pViewData->GetView();
//STRIP001 	ScDrawView*  pView	   = pTabView->GetScDrawView();
//STRIP001 
//STRIP001 	USHORT nSlot = rReq.GetSlot();
//STRIP001 	switch ( nSlot )
//STRIP001 	{
//STRIP001 		case SID_COPY:
//STRIP001 			pView->DoCopy();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_CUT:
//STRIP001 			pView->DoCut();
//STRIP001 			if (!pTabView->IsDrawSelMode())
//STRIP001 				pViewData->GetViewShell()->SetDrawShell( FALSE );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_PASTE:
//STRIP001 		case FID_PASTE_CONTENTS:
//STRIP001 		case SID_CLIPBOARD_FORMAT_ITEMS:
//STRIP001 		case SID_HYPERLINK_SETLINK:
//STRIP001 			{
//STRIP001 				//	cell methods are at cell shell, which is not available if
//STRIP001 				//	ScDrawTextObjectBar is active
//STRIP001 				//!	move paste etc. to view shell?
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_SELECTALL:
//STRIP001 			pView->MarkAll();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_TEXTDIRECTION_LEFT_TO_RIGHT:
//STRIP001 		case SID_TEXTDIRECTION_TOP_TO_BOTTOM:
//STRIP001 			{
//STRIP001 				SfxItemSet aAttr( pView->GetModel()->GetItemPool(), SDRATTR_TEXTDIRECTION, SDRATTR_TEXTDIRECTION, 0 );
//STRIP001 				aAttr.Put( SvxWritingModeItem( nSlot == SID_TEXTDIRECTION_LEFT_TO_RIGHT ? ::com::sun::star::text::WritingMode_LR_TB : ::com::sun::star::text::WritingMode_TB_RL ) );
//STRIP001 				pView->SetAttributes( aAttr );
//STRIP001 				pViewData->GetScDrawView()->InvalidateDrawTextAttrs();	// Bidi slots may be disabled
//STRIP001 				rReq.Done( aAttr );
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_ENABLE_HYPHENATION:
//STRIP001 			{
//STRIP001 				SFX_REQUEST_ARG( rReq, pItem, SfxBoolItem, SID_ENABLE_HYPHENATION, FALSE);
//STRIP001 				if( pItem )
//STRIP001 				{
//STRIP001 					SfxItemSet aSet( GetPool(), EE_PARA_HYPHENATE, EE_PARA_HYPHENATE );
//STRIP001 					BOOL bValue = ( (const SfxBoolItem*) pItem)->GetValue();
//STRIP001 					aSet.Put( SfxBoolItem( EE_PARA_HYPHENATE, bValue ) );
//STRIP001 					pView->SetAttributes( aSet );
//STRIP001 				}
//STRIP001 				rReq.Done();
//STRIP001 			}
//STRIP001 			break;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void ScDrawTextObjectBar::GetGlobalClipState( SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	//	cell methods are at cell shell, which is not available if
//STRIP001 	//	ScDrawTextObjectBar is active -> disable everything
//STRIP001 	//!	move paste etc. to view shell?
//STRIP001 
//STRIP001 	SfxWhichIter aIter(rSet);
//STRIP001 	USHORT nWhich = aIter.FirstWhich();
//STRIP001 	while (nWhich)
//STRIP001 	{
//STRIP001 		rSet.DisableItem( nWhich );
//STRIP001 		nWhich = aIter.NextWhich();
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void __EXPORT ScDrawTextObjectBar::ExecuteExtra( SfxRequest &rReq )
//STRIP001 {
//STRIP001 	ScTabView*	 pTabView  = pViewData->GetView();
//STRIP001 	ScDrawView*  pView	   = pTabView->GetScDrawView();
//STRIP001 
//STRIP001 	USHORT nSlot = rReq.GetSlot();
//STRIP001 	switch ( nSlot )
//STRIP001 	{
//STRIP001 		case SID_FONTWORK:
//STRIP001 			{
//STRIP001 				USHORT nId = SvxFontWorkChildWindow::GetChildWindowId();
//STRIP001 				SfxViewFrame* pViewFrm = pViewData->GetViewShell()->GetViewFrame();
//STRIP001 
//STRIP001 				if ( rReq.GetArgs() )
//STRIP001 					pViewFrm->SetChildWindow( nId,
//STRIP001 											   ((const SfxBoolItem&)
//STRIP001 												(rReq.GetArgs()->Get(SID_FONTWORK))).
//STRIP001 													GetValue() );
//STRIP001 				else
//STRIP001 					pViewFrm->ToggleChildWindow( nId );
//STRIP001 
//STRIP001 				pViewFrm->GetBindings().Invalidate( SID_FONTWORK );
//STRIP001 				rReq.Done();
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001         case SID_ATTR_PARA_LEFT_TO_RIGHT:
//STRIP001         case SID_ATTR_PARA_RIGHT_TO_LEFT:
//STRIP001             {
//STRIP001                 SfxItemSet aAttr( pView->GetModel()->GetItemPool(),
//STRIP001                                     EE_PARA_WRITINGDIR, EE_PARA_WRITINGDIR,
//STRIP001                                     EE_PARA_JUST, EE_PARA_JUST,
//STRIP001                                     0 );
//STRIP001                 BOOL bLeft = ( nSlot == SID_ATTR_PARA_LEFT_TO_RIGHT );
//STRIP001                 aAttr.Put( SvxFrameDirectionItem(
//STRIP001                                 bLeft ? FRMDIR_HORI_LEFT_TOP : FRMDIR_HORI_RIGHT_TOP,
//STRIP001                                 EE_PARA_WRITINGDIR ) );
//STRIP001                 aAttr.Put( SvxAdjustItem(
//STRIP001                                 bLeft ? SVX_ADJUST_LEFT : SVX_ADJUST_RIGHT,
//STRIP001                                 EE_PARA_JUST ) );
//STRIP001                 pView->SetAttributes( aAttr );
//STRIP001 				pViewData->GetScDrawView()->InvalidateDrawTextAttrs();
//STRIP001 				rReq.Done();		//! Done(aAttr) ?
//STRIP001 
//STRIP001             }
//STRIP001             break;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void ScDrawTextObjectBar::ExecFormText(SfxRequest& rReq)
//STRIP001 {
//STRIP001 	ScTabView*			pTabView	= pViewData->GetView();
//STRIP001 	ScDrawView* 		pDrView 	= pTabView->GetScDrawView();
//STRIP001 	const SdrMarkList&	rMarkList	= pDrView->GetMarkList();
//STRIP001 
//STRIP001 	if ( rMarkList.GetMarkCount() == 1 && rReq.GetArgs() )
//STRIP001 	{
//STRIP001 		const SfxItemSet& rSet = *rReq.GetArgs();
//STRIP001 		const SfxPoolItem* pItem;
//STRIP001 
//STRIP001 		if ( pDrView->IsTextEdit() )
//STRIP001 			pDrView->ScEndTextEdit();
//STRIP001 
//STRIP001 		if (	SFX_ITEM_SET ==
//STRIP001 				rSet.GetItemState(XATTR_FORMTXTSTDFORM, TRUE, &pItem)
//STRIP001 			 && XFTFORM_NONE !=
//STRIP001 				((const XFormTextStdFormItem*) pItem)->GetValue() )
//STRIP001 		{
//STRIP001 
//STRIP001 			USHORT nId				= SvxFontWorkChildWindow::GetChildWindowId();
//STRIP001 			SfxViewFrame* pViewFrm	= pViewData->GetViewShell()->GetViewFrame();
//STRIP001 			SvxFontWorkDialog* pDlg	= (SvxFontWorkDialog*)
//STRIP001 									   (pViewFrm->
//STRIP001 											GetChildWindow(nId)->GetWindow());
//STRIP001 
//STRIP001 			pDlg->CreateStdFormObj(*pDrView, *pDrView->GetPageViewPvNum(0),
//STRIP001 									rSet, *rMarkList.GetMark(0)->GetObj(),
//STRIP001 								   ((const XFormTextStdFormItem*) pItem)->
//STRIP001 								   GetValue());
//STRIP001 		}
//STRIP001 		else
//STRIP001 			pDrView->SetAttributes(rSet);
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void ScDrawTextObjectBar::GetFormTextState(SfxItemSet& rSet)
//STRIP001 {
//STRIP001 	const SdrObject*	pObj		= NULL;
//STRIP001 	SvxFontWorkDialog*	pDlg		= NULL;
//STRIP001 	ScDrawView* 		pDrView 	= pViewData->GetView()->GetScDrawView();
//STRIP001 	const SdrMarkList&	rMarkList	= pDrView->GetMarkList();
//STRIP001 	USHORT				nId = SvxFontWorkChildWindow::GetChildWindowId();
//STRIP001 
//STRIP001 	SfxViewFrame* pViewFrm = pViewData->GetViewShell()->GetViewFrame();
//STRIP001 	if ( pViewFrm->HasChildWindow(nId) )
//STRIP001 		pDlg = (SvxFontWorkDialog*)(pViewFrm->GetChildWindow(nId)->GetWindow());
//STRIP001 
//STRIP001 	if ( rMarkList.GetMarkCount() == 1 )
//STRIP001 		pObj = rMarkList.GetMark(0)->GetObj();
//STRIP001 
//STRIP001 	if ( pObj == NULL || !pObj->ISA(SdrTextObj) ||
//STRIP001 		!((SdrTextObj*) pObj)->HasText() )
//STRIP001 	{
//STRIP001 		if ( pDlg )
//STRIP001 			pDlg->SetActive(FALSE);
//STRIP001 
//STRIP001 		rSet.DisableItem(XATTR_FORMTXTSTYLE);
//STRIP001 		rSet.DisableItem(XATTR_FORMTXTADJUST);
//STRIP001 		rSet.DisableItem(XATTR_FORMTXTDISTANCE);
//STRIP001 		rSet.DisableItem(XATTR_FORMTXTSTART);
//STRIP001 		rSet.DisableItem(XATTR_FORMTXTMIRROR);
//STRIP001 		rSet.DisableItem(XATTR_FORMTXTSTDFORM);
//STRIP001 		rSet.DisableItem(XATTR_FORMTXTHIDEFORM);
//STRIP001 		rSet.DisableItem(XATTR_FORMTXTOUTLINE);
//STRIP001 		rSet.DisableItem(XATTR_FORMTXTSHADOW);
//STRIP001 		rSet.DisableItem(XATTR_FORMTXTSHDWCOLOR);
//STRIP001 		rSet.DisableItem(XATTR_FORMTXTSHDWXVAL);
//STRIP001 		rSet.DisableItem(XATTR_FORMTXTSHDWYVAL);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		if ( pDlg )
//STRIP001 		{
//STRIP001 			SfxObjectShell* pDocSh = SfxObjectShell::Current();
//STRIP001 
//STRIP001 			if ( pDocSh )
//STRIP001 			{
//STRIP001 				const SfxPoolItem*	pItem = pDocSh->GetItem( ITEMID_COLOR_TABLE );
//STRIP001 				XColorTable*		pColorTable = NULL;
//STRIP001 
//STRIP001 				if ( pItem )
//STRIP001 					pColorTable = ((SvxColorTableItem*)pItem)->GetColorTable();
//STRIP001 
//STRIP001 				pDlg->SetActive();
//STRIP001 
//STRIP001 				if ( pColorTable )
//STRIP001 					pDlg->SetColorTable( pColorTable );
//STRIP001 				else
//STRIP001 					{ DBG_ERROR( "ColorList not found :-/" ); }
//STRIP001 			}
//STRIP001 		}
//STRIP001 		SfxItemSet aViewAttr(pDrView->GetModel()->GetItemPool());
//STRIP001 		pDrView->GetAttributes(aViewAttr);
//STRIP001 		rSet.Set(aViewAttr);
//STRIP001 	}
//STRIP001 }




}
