/*************************************************************************
 *
 *  $RCSfile: foptmgr.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 11:59:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef SC_FOPTMGR_HXX
#define SC_FOPTMGR_HXX

// auto strip #ifndef _FIXED_HXX //autogen
// auto strip #include <vcl/fixed.hxx>
// auto strip #endif
// auto strip #ifndef _EDIT_HXX //autogen
// auto strip #include <vcl/edit.hxx>
// auto strip #endif
// auto strip #ifndef _LSTBOX_HXX //autogen
// auto strip #include <vcl/lstbox.hxx>
// auto strip #endif
// auto strip #ifndef _BUTTON_HXX //autogen
// auto strip #include <vcl/button.hxx>
// auto strip #endif
class Dialog;
namespace binfilter {

//----------------------------------------------------------------------------

class FixedInfo;
class ScRefButton;
class MoreButton;
struct ScQueryParam;
class ScDocument;
class ScViewData;

//----------------------------------------------------------------------------

//STRIP001 class ScFilterOptionsMgr
//STRIP001 {
//STRIP001 public:
//STRIP001 			ScFilterOptionsMgr( Dialog*				ptrDlg,
//STRIP001 								ScViewData*			ptrViewData,
//STRIP001 								const ScQueryParam&	refQueryData,
//STRIP001 								MoreButton&			refBtnMore,
//STRIP001 								CheckBox&			refBtnCase,
//STRIP001 								CheckBox&			refBtnRegExp,
//STRIP001 								CheckBox&			refBtnHeader,
//STRIP001 								CheckBox&			refBtnUnique,
//STRIP001 								CheckBox&			refBtnCopyResult,
//STRIP001 								CheckBox&			refBtnDestPers,
//STRIP001 								ListBox&			refLbCopyArea,
//STRIP001 								Edit&				refEdCopyArea,
//STRIP001 								ScRefButton&		refRbCopyArea,
//STRIP001 								FixedText&			refFtDbAreaLabel,
//STRIP001 								FixedInfo&			refFtDbArea,
//STRIP001                                 FixedLine&          refFlOptions,
//STRIP001 								const String&		refStrNoName,
//STRIP001 								const String&		refStrUndefined );
//STRIP001 			~ScFilterOptionsMgr();
//STRIP001 
//STRIP001 	BOOL	VerifyPosStr ( const String& rPosStr ) const;
//STRIP001 
//STRIP001 private:
//STRIP001 	Dialog*			pDlg;
//STRIP001 	ScViewData*		pViewData;
//STRIP001 	ScDocument*		pDoc;
//STRIP001 
//STRIP001 	MoreButton&		rBtnMore;
//STRIP001 	CheckBox&		rBtnCase;
//STRIP001 	CheckBox&		rBtnRegExp;
//STRIP001 	CheckBox&		rBtnHeader;
//STRIP001 	CheckBox&		rBtnUnique;
//STRIP001 	CheckBox&		rBtnCopyResult;
//STRIP001 	CheckBox&		rBtnDestPers;
//STRIP001 	ListBox&		rLbCopyPos;
//STRIP001 	Edit&			rEdCopyPos;
//STRIP001 	ScRefButton&	rRbCopyPos;
//STRIP001 	FixedText&		rFtDbAreaLabel;
//STRIP001 	FixedInfo&		rFtDbArea;
//STRIP001     FixedLine&      rFlOptions;
//STRIP001 
//STRIP001 	const String&	rStrNoName;
//STRIP001 	const String&	rStrUndefined;
//STRIP001 
//STRIP001 	const ScQueryParam&	rQueryData;
//STRIP001 
//STRIP001 #ifdef _FOPTMGR_CXX
//STRIP001 private:
//STRIP001 	void Init();
//STRIP001 
//STRIP001 	// Handler:
//STRIP001 	DECL_LINK( EdPosModifyHdl,		Edit* );
//STRIP001 	DECL_LINK( LbPosSelHdl,			ListBox* );
//STRIP001 	DECL_LINK( BtnCopyResultHdl,	CheckBox* );
//STRIP001 #endif
//STRIP001 };



} //namespace binfilter
#endif // SC_FOPTMGR_HXX
