/*************************************************************************
 *
 *  $RCSfile: sc_dbfunc2.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2004/05/05 16:39:48 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
#include "ui_pch.hxx"
#endif

#pragma hdrstop

// INCLUDE ---------------------------------------------------------------


#include "dbfunc.hxx"
#include "docsh.hxx"
#include "global.hxx"
#include "document.hxx"
#include "bf_sc.hrc"
#include "globstr.hrc"
namespace binfilter {


// STATIC DATA -----------------------------------------------------------


#ifdef WNT
#pragma optimize ( "", off )
#endif

//==================================================================

class ScDrawLayer;
class ScChartCollection;

// wg. CLOOKs in dbfunc4:
/*N*/ USHORT DoUpdateCharts( ScAddress aPos, ScDocument* pDoc,
/*N*/ 						Window* pActiveWin, BOOL bAllCharts );


/*N*/ void ScDBFunc::UpdateCharts( BOOL bAllCharts )
/*N*/ {
/*N*/ 	USHORT nFound = 0;
/*N*/ 	ScViewData* pViewData = GetViewData();
/*N*/ 	ScDocument* pDoc = pViewData->GetDocument();
/*N*/ 
/*N*/ 	if ( pDoc->GetDrawLayer() )
/*?*/ 	{DBG_BF_ASSERT(0, "STRIP"); }//STRIP001 	nFound = DoUpdateCharts( ScAddress( pViewData->GetCurX(),
//STRIP001 /*?*/ 											pViewData->GetCurY(),
//STRIP001 /*?*/ 											pViewData->GetTabNo()),
//STRIP001 /*?*/ 								 pDoc,
//STRIP001 /*?*/ 								 GetActiveWin(),
//STRIP001 /*?*/ 								 bAllCharts );
/*N*/ 
/*N*/ 	if ( !nFound && !bAllCharts )
/*?*/ 	 	ErrorMessage(STR_NOCHARTATCURSOR);
/*N*/ }






}
