/*************************************************************************
 *
 *  $RCSfile: sc_tabvwshh.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:39:30 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

// INCLUDE ---------------------------------------------------------------

// auto strip #include <bf_svx/svdmark.hxx>
// auto strip #include <bf_svx/svdoole2.hxx>
// auto strip #include <bf_svx/svdview.hxx>
// auto strip #include <bf_sfx2/app.hxx>
// auto strip #include <bf_sfx2/objsh.hxx>
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #include <svtools/sbxcore.hxx>
// auto strip #include <so3/ipobj.hxx>
// auto strip #include <svtools/whiter.hxx>

#include "tabvwsh.hxx"
// auto strip #include "client.hxx"
// auto strip #include "document.hxx"
// auto strip #include "docsh.hxx"
#include "bf_sc.hrc"
// auto strip #include "drwlayer.hxx"		// GetVisibleName
namespace binfilter {

//------------------------------------------------------------------

//STRIP001 void ScTabViewShell::ExecuteSbx( SfxRequest& rReq )
//STRIP001 {
//STRIP001 	//	SID_RANGE_OFFSET (Offset),
//STRIP001 	//	SID_PIVOT_CREATE (DataPilotCreate) - removed (old Basic)
//STRIP001 }

//STRIP001 void ScTabViewShell::GetSbxState( SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	//	SID_RANGE_REGION (CurrentRegion) - removed (old Basic)
//STRIP001 }

//------------------------------------------------------------------

//STRIP001 void ScTabViewShell::ExecuteObject( SfxRequest& rReq )
//STRIP001 {
//STRIP001 	USHORT nSlotId = rReq.GetSlot();
//STRIP001 	const SfxItemSet* pReqArgs = rReq.GetArgs();
//STRIP001 
//STRIP001 		//	Objekte aktivieren/deaktivieren immer auf der sichtbaren View
//STRIP001 
//STRIP001 	ScTabViewShell* pVisibleSh = this;
//STRIP001 	if ( nSlotId == SID_OLE_SELECT || nSlotId == SID_OLE_ACTIVATE || nSlotId == SID_OLE_DEACTIVATE )
//STRIP001 	{
//STRIP001 		DBG_ERROR("old slot SID_OLE...");
//STRIP001 	}
//STRIP001 
//STRIP001 	switch (nSlotId)
//STRIP001 	{
//STRIP001 		case SID_OLE_SELECT:
//STRIP001 		case SID_OLE_ACTIVATE:
//STRIP001 			{
//STRIP001 				//	in beiden Faellen erstmal auf der sichtbaren View selektieren
//STRIP001 
//STRIP001 				String aName;
//STRIP001 				SdrView* pDrView = GetSdrView();
//STRIP001 				if (pDrView)
//STRIP001 				{
//STRIP001 					const SdrMarkList& rMarkList = pDrView->GetMarkList();
//STRIP001 					if (rMarkList.GetMarkCount() == 1)
//STRIP001 						aName = ScDrawLayer::GetVisibleName( rMarkList.GetMark(0)->GetObj() );
//STRIP001 				}
//STRIP001 				pVisibleSh->SelectObject( aName );
//STRIP001 
//STRIP001 				//	aktivieren
//STRIP001 
//STRIP001 				if ( nSlotId == SID_OLE_ACTIVATE )
//STRIP001 					pVisibleSh->DoVerb( 0 );
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		case SID_OLE_DEACTIVATE:
//STRIP001 			{
//STRIP001 				ScClient* pClient = (ScClient*) pVisibleSh->GetIPClient();
//STRIP001 				if ( pClient && pClient->IsInPlaceActive() )
//STRIP001 				{
//STRIP001 					pClient->GetProtocol().Reset2Open();
//STRIP001 					SFX_APP()->SetViewFrame(pVisibleSh->GetViewFrame());
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_OBJECT_LEFT:
//STRIP001 		case SID_OBJECT_TOP:
//STRIP001 		case SID_OBJECT_WIDTH:
//STRIP001 		case SID_OBJECT_HEIGHT:
//STRIP001 			{
//STRIP001 				BOOL bDone = FALSE;
//STRIP001 				const SfxPoolItem* pItem;
//STRIP001 				if ( pReqArgs && pReqArgs->GetItemState( nSlotId, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 				{
//STRIP001 					long nNewVal = ((const SfxInt32Item*)pItem)->GetValue();
//STRIP001 					if ( nNewVal < 0 )
//STRIP001 						nNewVal = 0;
//STRIP001 
//STRIP001 					//!	von irgendwas in 1/100mm umrechnen ??????
//STRIP001 
//STRIP001 					SdrView* pDrView = GetSdrView();
//STRIP001 					if ( pDrView )
//STRIP001 					{
//STRIP001 						const SdrMarkList& rMarkList = pDrView->GetMarkList();
//STRIP001 						if (rMarkList.GetMarkCount() == 1)
//STRIP001 						{
//STRIP001 							SdrObject* pObj = rMarkList.GetMark(0)->GetObj();
//STRIP001 							Rectangle aRect = pObj->GetLogicRect();
//STRIP001 
//STRIP001 							if ( nSlotId == SID_OBJECT_LEFT )
//STRIP001 								pDrView->MoveMarkedObj( Size( nNewVal - aRect.Left(), 0 ) );
//STRIP001 							else if ( nSlotId == SID_OBJECT_TOP )
//STRIP001 								pDrView->MoveMarkedObj( Size( 0, nNewVal - aRect.Top() ) );
//STRIP001 							else if ( nSlotId == SID_OBJECT_WIDTH )
//STRIP001 								pDrView->ResizeMarkedObj( aRect.TopLeft(),
//STRIP001 												Fraction( nNewVal, aRect.GetWidth() ),
//STRIP001 												Fraction( 1, 1 ) );
//STRIP001 							else // if ( nSlotId == SID_OBJECT_HEIGHT )
//STRIP001 								pDrView->ResizeMarkedObj( aRect.TopLeft(),
//STRIP001 												Fraction( 1, 1 ),
//STRIP001 												Fraction( nNewVal, aRect.GetHeight() ) );
//STRIP001 							bDone = TRUE;
//STRIP001 						}
//STRIP001 					}
//STRIP001 				}
//STRIP001 				if (!bDone)
//STRIP001 					SbxBase::SetError( SbxERR_BAD_PARAMETER );	// Basic-Fehler
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 	}
//STRIP001 }

//STRIP001 SvInPlaceObjectRef lcl_GetSelectedObj( SdrView* pDrView )		//! Member von ScDrawView?
//STRIP001 {
//STRIP001 	SvInPlaceObjectRef xRet;
//STRIP001 
//STRIP001 	if (pDrView)
//STRIP001 	{
//STRIP001 		const SdrMarkList& rMarkList = pDrView->GetMarkList();
//STRIP001 		if (rMarkList.GetMarkCount() == 1)
//STRIP001 		{
//STRIP001 			SdrObject* pObj = rMarkList.GetMark(0)->GetObj();
//STRIP001 			if (pObj->GetObjIdentifier() == OBJ_OLE2)
//STRIP001 			{
//STRIP001 				SdrOle2Obj* pOle2Obj = (SdrOle2Obj*) pObj;
//STRIP001 				xRet = pOle2Obj->GetObjRef();
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return xRet;
//STRIP001 }

//STRIP001 void ScTabViewShell::GetObjectState( SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	//	SID_OLE_OBJECT - removed (old Basic)
//STRIP001 
//STRIP001 	SfxWhichIter aIter(rSet);
//STRIP001 	USHORT nWhich = aIter.FirstWhich();
//STRIP001 	while ( nWhich )
//STRIP001 	{
//STRIP001 		switch (nWhich)
//STRIP001 		{
//STRIP001 			case SID_ACTIVE_OBJ_NAME:
//STRIP001 				{
//STRIP001 					String aName;
//STRIP001 					SvInPlaceObjectRef xOLE = lcl_GetSelectedObj( GetSdrView() );
//STRIP001 					if (xOLE.Is())
//STRIP001 					{
//STRIP001 						SvInfoObject* pInfoObj = GetViewData()->GetSfxDocShell()->Find( xOLE );
//STRIP001 						if ( pInfoObj )
//STRIP001 							aName = pInfoObj->GetObjName();
//STRIP001 					}
//STRIP001 					rSet.Put( SfxStringItem( nWhich, aName ) );
//STRIP001 				}
//STRIP001 				break;
//STRIP001 			case SID_OBJECT_LEFT:
//STRIP001 			case SID_OBJECT_TOP:
//STRIP001 			case SID_OBJECT_WIDTH:
//STRIP001 			case SID_OBJECT_HEIGHT:
//STRIP001 				{
//STRIP001 					SdrView* pDrView = GetSdrView();
//STRIP001 					if ( pDrView )
//STRIP001 					{
//STRIP001 						const SdrMarkList& rMarkList = pDrView->GetMarkList();
//STRIP001 						if (rMarkList.GetMarkCount() == 1)
//STRIP001 						{
//STRIP001 							SdrObject* pObj = rMarkList.GetMark(0)->GetObj();
//STRIP001 							Rectangle aRect = pObj->GetLogicRect();
//STRIP001 
//STRIP001 							long nVal;
//STRIP001 							if ( nWhich == SID_OBJECT_LEFT )
//STRIP001 								nVal = aRect.Left();
//STRIP001 							else if ( nWhich == SID_OBJECT_TOP )
//STRIP001 								nVal = aRect.Top();
//STRIP001 							else if ( nWhich == SID_OBJECT_WIDTH )
//STRIP001 								nVal = aRect.GetWidth();
//STRIP001 							else // if ( nWhich == SID_OBJECT_HEIGHT )
//STRIP001 								nVal = aRect.GetHeight();
//STRIP001 
//STRIP001 							//!	von 1/100mm in irgendwas umrechnen ??????
//STRIP001 
//STRIP001 							rSet.Put( SfxInt32Item( nWhich, nVal ) );
//STRIP001 						}
//STRIP001 					}
//STRIP001 				}
//STRIP001 				break;
//STRIP001 		}
//STRIP001 		nWhich = aIter.NextWhich();
//STRIP001 	}
//STRIP001 }

//STRIP001 void ScTabViewShell::AddAccessibilityObject( SfxListener& rObject )
//STRIP001 {
//STRIP001 	if (!pAccessibilityBroadcaster)
//STRIP001 		pAccessibilityBroadcaster = new SfxBroadcaster;
//STRIP001 
//STRIP001 	rObject.StartListening( *pAccessibilityBroadcaster );
//STRIP001 	ScDocument* pDoc = GetViewData()->GetDocument();
//STRIP001 	if (pDoc)
//STRIP001 		pDoc->AddUnoObject(rObject);
//STRIP001 }

//STRIP001 void ScTabViewShell::RemoveAccessibilityObject( SfxListener& rObject )
//STRIP001 {
//STRIP001 	if (pAccessibilityBroadcaster)
//STRIP001 	{
//STRIP001 		rObject.EndListening( *pAccessibilityBroadcaster );
//STRIP001 		ScDocument* pDoc = GetViewData()->GetDocument();
//STRIP001 		if (pDoc)
//STRIP001 			pDoc->RemoveUnoObject(rObject);
//STRIP001 	}
//STRIP001 	else
//STRIP001 		DBG_ERROR("kein Accessibility-Broadcaster??!?");
//STRIP001 }

//STRIP001 void ScTabViewShell::BroadcastAccessibility( const SfxHint &rHint )
//STRIP001 {
//STRIP001 	if (pAccessibilityBroadcaster)
//STRIP001 		pAccessibilityBroadcaster->Broadcast( rHint );
//STRIP001 }

/*N*/ BOOL ScTabViewShell::HasAccessibilityObjects()
/*N*/ {
/*N*/ 	return pAccessibilityBroadcaster != NULL;
/*N*/ }




}
