/*************************************************************************
 *
 *  $RCSfile: sc_viewfun5.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:40:35 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

// auto strip #ifndef SVX_UNOMODEL_HXX
// auto strip #include <bf_svx/unomodel.hxx>
// auto strip #endif

// auto strip #ifndef _UTL_STREAM_WRAPPER_HXX_
// auto strip #include <unotools/streamwrap.hxx>
// auto strip #endif

//------------------------------------------------------------------

#include <bf_svx/dbexch.hrc>
// auto strip #include <bf_svx/fmmodel.hxx>
// auto strip #include <bf_svx/svdetc.hxx>
// auto strip #include <bf_svx/svditer.hxx>
// auto strip #include <bf_svx/svdobj.hxx>
// auto strip #include <bf_svx/svdogrp.hxx>
// auto strip #include <bf_svx/svdouno.hxx>
// auto strip #include <bf_svx/svdpage.hxx>
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #include <bf_sfx2/docfile.hxx>
// auto strip #include <so3/ipobj.hxx>
#include <so3/svstor.hxx>
// auto strip #include <bf_offmgr/app.hxx>
// auto strip #include <so3/clsids.hxx>
// auto strip #include <sot/formats.hxx>
// auto strip #include <svtools/pathoptions.hxx>
// auto strip #include <svtools/ptitem.hxx>
// auto strip #include <svtools/stritem.hxx>
// auto strip #include <svtools/transfer.hxx>
// auto strip #include <vcl/graph.hxx>

// auto strip #include <sot/formats.hxx>
#define SOT_FORMATSTR_ID_STARCALC_CURRENT	SOT_FORMATSTR_ID_STARCALC_50

#ifndef SO2_DECL_SVINPLACEOBJECT_DEFINED
#define SO2_DECL_SVINPLACEOBJECT_DEFINED
SO2_DECL_REF(SvInPlaceObject)
#endif
#ifndef SO2_DECL_SVSTORAGE_DEFINED
#define SO2_DECL_SVSTORAGE_DEFINED
SO2_DECL_REF(SvStorage)
#endif

// auto strip #include "viewfunc.hxx"
// auto strip #include "docsh.hxx"
// auto strip #include "drawview.hxx"
// auto strip #include "impex.hxx"
// auto strip #include "dbfunc.hxx"
// auto strip #include "dbcolect.hxx"
#include "bf_sc.hrc"
// auto strip #include "filter.hxx"
// auto strip #include "scextopt.hxx"
// auto strip #include "tabvwsh.hxx"		//	wegen GetViewFrame
// auto strip #include "compiler.hxx"

// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_DBAEXCHANGE_HXX_
// auto strip #include <bf_svx/dbaexchange.hxx>
// auto strip #endif
namespace binfilter {

using namespace ::com::sun::star;

//------------------------------------------------------------------

//STRIP001 BOOL ScViewFunc::PasteDataFormat( ULONG nFormatId,
//STRIP001 					const uno::Reference<datatransfer::XTransferable>& rxTransferable,
//STRIP001 					USHORT nPosX, USHORT nPosY, Point* pLogicPos, BOOL bLink, BOOL bAllowDialogs )
//STRIP001 {
//STRIP001     ScDocument* pDoc = GetViewData()->GetDocument();
//STRIP001     pDoc->SetPastingDrawFromOtherDoc( TRUE );
//STRIP001 
//STRIP001 	Point aPos;						//	inserting position (1/100 mm)
//STRIP001 	if (pLogicPos)
//STRIP001 		aPos = *pLogicPos;
//STRIP001 	else
//STRIP001 	{
//STRIP001 		//	inserting position isn't needed for text formats
//STRIP001 		BOOL bIsTextFormat = ( ScImportExport::IsFormatSupported( nFormatId ) ||
//STRIP001 								nFormatId == FORMAT_RTF );
//STRIP001 		if ( !bIsTextFormat )
//STRIP001 		{
//STRIP001 			//	Window MapMode isn't drawing MapMode if DrawingLayer hasn't been created yet
//STRIP001 
//STRIP001 			ScDocument* pDoc = GetViewData()->GetDocument();
//STRIP001 			USHORT nTab = GetViewData()->GetTabNo();
//STRIP001 			USHORT i;
//STRIP001 			long nXT = 0;
//STRIP001 			for (i=0; i<nPosX; i++)
//STRIP001 				nXT += pDoc->GetColWidth(i,nTab);
//STRIP001 			long nYT = 0;
//STRIP001 			for (i=0; i<nPosY; i++)
//STRIP001 				nYT += pDoc->FastGetRowHeight(i,nTab);
//STRIP001 			aPos = Point( (long)(nXT * HMM_PER_TWIPS), (long)(nYT * HMM_PER_TWIPS) );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	TransferableDataHelper aDataHelper( rxTransferable );
//STRIP001 	BOOL bRet = FALSE;
//STRIP001 
//STRIP001 	//
//STRIP001 	//	handle individual formats
//STRIP001 	//
//STRIP001 
//STRIP001 	if ( nFormatId == SOT_FORMATSTR_ID_EMBED_SOURCE ||
//STRIP001 		 nFormatId == SOT_FORMATSTR_ID_LINK_SOURCE ||
//STRIP001 		 nFormatId == SOT_FORMATSTR_ID_EMBED_SOURCE_OLE ||
//STRIP001 		 nFormatId == SOT_FORMATSTR_ID_LINK_SOURCE_OLE )
//STRIP001 	{
//STRIP001 		SotStorageStreamRef				xStm;
//STRIP001 		TransferableObjectDescriptor	aObjDesc;
//STRIP001 
//STRIP001 		if( aDataHelper.GetTransferableObjectDescriptor( SOT_FORMATSTR_ID_OBJECTDESCRIPTOR, aObjDesc ) &&
//STRIP001 			aDataHelper.GetSotStorageStream( nFormatId, xStm ) )
//STRIP001 		{
//STRIP001 			SvStorageRef xStore( new SvStorage( *xStm ) );
//STRIP001 			if ( aObjDesc.maClassName == SvGlobalName( BF_SO3_SC_CLASSID_30 ) ||
//STRIP001 				 aObjDesc.maClassName == SvGlobalName( BF_SO3_SC_CLASSID_40 ) ||
//STRIP001 				 aObjDesc.maClassName == SvGlobalName( BF_SO3_SC_CLASSID_50 ) ||
//STRIP001 				 aObjDesc.maClassName == SvGlobalName( BF_SO3_SC_CLASSID_60 ) )
//STRIP001 			{
//STRIP001 				//	own format (including old formats)
//STRIP001 				ScDocShellRef xDocShRef = new ScDocShell(SFX_CREATE_MODE_EMBEDDED);
//STRIP001 				if (xDocShRef->DoLoad(xStore))
//STRIP001 				{
//STRIP001 					ScDocument* pSrcDoc = xDocShRef->GetDocument();
//STRIP001 					USHORT nSrcTab = pSrcDoc->GetVisibleTab();
//STRIP001 					if (!pSrcDoc->HasTable(nSrcTab))
//STRIP001 						nSrcTab = 0;
//STRIP001 
//STRIP001 					ScMarkData aSrcMark;
//STRIP001 					aSrcMark.SelectOneTable( nSrcTab );			// for CopyToClip
//STRIP001 					ScDocument* pClipDoc = new ScDocument( SCDOCMODE_CLIP );
//STRIP001 
//STRIP001 					USHORT nFirstCol, nFirstRow, nLastCol, nLastRow;
//STRIP001 					if ( pSrcDoc->GetDataStart( nSrcTab, nFirstCol, nFirstRow ) )
//STRIP001 						pSrcDoc->GetCellArea( nSrcTab, nLastCol, nLastRow );
//STRIP001 					else
//STRIP001 						nFirstCol = nFirstRow = nLastCol = nLastRow = 0;
//STRIP001 					pSrcDoc->CopyToClip( nFirstCol, nFirstRow, nLastCol, nLastRow,
//STRIP001 											FALSE, pClipDoc, FALSE, &aSrcMark );
//STRIP001 					ScGlobal::SetClipDocName( xDocShRef->GetTitle( SFX_TITLE_FULLNAME ) );
//STRIP001 
//STRIP001 					SetCursor( nPosX, nPosY );
//STRIP001 					Unmark();
//STRIP001 					PasteFromClip( IDF_ALL, pClipDoc,
//STRIP001 									PASTE_NOFUNC, FALSE, FALSE, FALSE, INS_NONE, IDF_NONE,
//STRIP001 									bAllowDialogs );
//STRIP001 					delete pClipDoc;
//STRIP001 					bRet = TRUE;
//STRIP001 				}
//STRIP001 				((SfxInPlaceObject*)xDocShRef)->DoClose();
//STRIP001 				xDocShRef.Clear();
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				SvInPlaceObjectRef xIPObj = &( (SvFactory*) SvInPlaceObject::ClassFactory() )->CreateAndLoad( xStore );
//STRIP001 				if ( xIPObj.Is() )
//STRIP001 				{
//STRIP001 					PasteObject( aPos, xIPObj, &aObjDesc.maSize );
//STRIP001 					bRet = TRUE;
//STRIP001 				}
//STRIP001 				else
//STRIP001 					DBG_ERROR("Error in CreateAndLoad");
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			if( aDataHelper.GetTransferableObjectDescriptor(
//STRIP001 				SOT_FORMATSTR_ID_OBJECTDESCRIPTOR_OLE, aObjDesc ))
//STRIP001 			{
//STRIP001 				UniString aEmptyStr;
//STRIP001 				SvStorage* xStore = new SvStorage( aEmptyStr, STREAM_STD_READWRITE );
//STRIP001 				SvInPlaceObjectRef xIPObj= &((SvFactory*)SvInPlaceObject::ClassFactory())
//STRIP001 					->CreateAndInit( rxTransferable, xStore);
//STRIP001 				if ( xIPObj.Is() )
//STRIP001 				{
//STRIP001 					PasteObject( aPos, xIPObj, &aObjDesc.maSize );
//STRIP001 					bRet = TRUE;
//STRIP001 				}
//STRIP001 				else
//STRIP001 					DBG_ERROR("Error in CreateAndInit ( external OLE object)");
//STRIP001 
//STRIP001 			}
//STRIP001 
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if ( nFormatId == SOT_FORMATSTR_ID_LINK )		// LINK is also in ScImportExport
//STRIP001 	{
//STRIP001 		bRet = PasteDDE( rxTransferable );
//STRIP001 	}
//STRIP001 	else if ( ScImportExport::IsFormatSupported( nFormatId ) || nFormatId == SOT_FORMAT_RTF )
//STRIP001 	{
//STRIP001 		if ( nFormatId == SOT_FORMAT_RTF && aDataHelper.HasFormat( SOT_FORMATSTR_ID_EDITENGINE ) )
//STRIP001 		{
//STRIP001 			//	use EditView's PasteSpecial / Drop
//STRIP001 			PasteRTF( nPosX, nPosY, rxTransferable );
//STRIP001 			bRet = TRUE;
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			ScAddress aPos( nPosX, nPosY, GetViewData()->GetTabNo() );
//STRIP001 			ScImportExport aObj( GetViewData()->GetDocument(), aPos );
//STRIP001 
//STRIP001             ::rtl::OUString aStr;
//STRIP001 			SotStorageStreamRef xStream;
//STRIP001 			if ( aDataHelper.GetSotStorageStream( nFormatId, xStream ) && xStream.Is() )
//STRIP001 				bRet = aObj.ImportStream( *xStream, nFormatId );
//STRIP001 			else if ( aDataHelper.GetString( nFormatId, aStr ) )
//STRIP001 				bRet = aObj.ImportString( aStr, nFormatId );
//STRIP001 
//STRIP001 			InvalidateAttribs();
//STRIP001 			GetViewData()->UpdateInputHandler();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if (nFormatId == SOT_FORMATSTR_ID_SBA_DATAEXCHANGE)
//STRIP001 	{
//STRIP001 		//	import of database data into table
//STRIP001 
//STRIP001 		String sDataDesc;
//STRIP001 		if ( aDataHelper.GetString( nFormatId, sDataDesc ) )
//STRIP001 		{
//STRIP001 			SfxStringItem aDataDesc(SID_SBA_IMPORT, sDataDesc);
//STRIP001 
//STRIP001 			ScDocShell* pDocSh = GetViewData()->GetDocShell();
//STRIP001 			ScDocument* pDoc = pDocSh->GetDocument();
//STRIP001 			USHORT nTab = GetViewData()->GetTabNo();
//STRIP001 
//STRIP001 			ClickCursor(nPosX, nPosY, FALSE);				// set cursor position
//STRIP001 
//STRIP001 			//	Creation of database area "Import1" isn't here, but in the DocShell
//STRIP001 			//	slot execute, so it can be added to the undo action
//STRIP001 
//STRIP001 			ScDBData* pDBData = pDocSh->GetDBData( ScRange(nPosX,nPosY,nTab), SC_DB_OLD, FALSE );
//STRIP001 			String sTarget;
//STRIP001 			if (pDBData)
//STRIP001 				sTarget = pDBData->GetName();
//STRIP001 			else
//STRIP001 			{
//STRIP001 				ScAddress aPos( nPosX,nPosY,nTab );
//STRIP001 				aPos.Format( sTarget, SCA_ABS_3D, pDoc );
//STRIP001 			}
//STRIP001 			SfxStringItem aTarget(FN_PARAM_1, sTarget);
//STRIP001 
//STRIP001 			BOOL bAreaIsNew = !pDBData;
//STRIP001 			SfxBoolItem aAreaNew(FN_PARAM_2, bAreaIsNew);
//STRIP001 
//STRIP001 			//	asynchronous, to avoid doing the whole import in drop handler
//STRIP001 			SfxDispatcher& rDisp = GetViewData()->GetDispatcher();
//STRIP001 			rDisp.Execute(SID_SBA_IMPORT, SFX_CALLMODE_ASYNCHRON,
//STRIP001 										&aDataDesc, &aTarget, &aAreaNew, 0L );
//STRIP001 
//STRIP001 			bRet = TRUE;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if (nFormatId == SOT_FORMATSTR_ID_SBA_FIELDDATAEXCHANGE)
//STRIP001 	{
//STRIP001 		//	insert database field control
//STRIP001 
//STRIP001         if ( ::svx::OColumnTransferable::canExtractColumnDescriptor( aDataHelper.GetDataFlavorExVector(), CTF_COLUMN_DESCRIPTOR | CTF_CONTROL_EXCHANGE ) )
//STRIP001 		{
//STRIP001 			MakeDrawLayer();
//STRIP001 			ScDrawView* pDrawView = GetScDrawView();
//STRIP001             SdrObject* pObj = pDrawView->CreateFieldControl( ::svx::OColumnTransferable::extractColumnDescriptor( aDataHelper ) );
//STRIP001 			if (pObj)
//STRIP001 			{
//STRIP001 				Point aInsPos = aPos;
//STRIP001 				Rectangle aRect(pObj->GetLogicRect());
//STRIP001 				aInsPos.X() -= aRect.GetSize().Width()  / 2;
//STRIP001 				aInsPos.Y() -= aRect.GetSize().Height() / 2;
//STRIP001 				if ( aInsPos.X() < 0 ) aInsPos.X() = 0;
//STRIP001 				if ( aInsPos.Y() < 0 ) aInsPos.Y() = 0;
//STRIP001 				aRect.SetPos(aInsPos);
//STRIP001 				pObj->SetLogicRect(aRect);
//STRIP001 
//STRIP001 				if ( pObj->ISA(SdrUnoObj) )
//STRIP001 					pObj->NbcSetLayer(SC_LAYER_CONTROLS);
//STRIP001 				else
//STRIP001 					pObj->NbcSetLayer(SC_LAYER_FRONT);
//STRIP001 				if (pObj->ISA(SdrObjGroup))
//STRIP001 				{
//STRIP001 					SdrObjListIter aIter( *pObj, IM_DEEPWITHGROUPS );
//STRIP001 					SdrObject* pSubObj = aIter.Next();
//STRIP001 					while (pSubObj)
//STRIP001 					{
//STRIP001 						if ( pSubObj->ISA(SdrUnoObj) )
//STRIP001 							pSubObj->NbcSetLayer(SC_LAYER_CONTROLS);
//STRIP001 						else
//STRIP001 							pSubObj->NbcSetLayer(SC_LAYER_FRONT);
//STRIP001 						pSubObj = aIter.Next();
//STRIP001 					}
//STRIP001 				}
//STRIP001 
//STRIP001 				pDrawView->InsertObjectSafe(pObj, *pDrawView->GetPageViewPvNum(0));
//STRIP001 
//STRIP001 				GetViewData()->GetViewShell()->SetDrawShell( TRUE );
//STRIP001 				bRet = TRUE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if (nFormatId == SOT_FORMAT_BITMAP)
//STRIP001 	{
//STRIP001 		Bitmap aBmp;
//STRIP001 		if( aDataHelper.GetBitmap( FORMAT_BITMAP, aBmp ) )
//STRIP001 			bRet = PasteBitmap( aPos, aBmp );
//STRIP001 	}
//STRIP001 	else if (nFormatId == SOT_FORMAT_GDIMETAFILE)
//STRIP001 	{
//STRIP001 		GDIMetaFile aMtf;
//STRIP001 		if( aDataHelper.GetGDIMetaFile( FORMAT_GDIMETAFILE, aMtf ) )
//STRIP001 			bRet = PasteMetaFile( aPos, aMtf );
//STRIP001 	}
//STRIP001 	else if (nFormatId == SOT_FORMATSTR_ID_SVXB)
//STRIP001 	{
//STRIP001 		SotStorageStreamRef xStm;
//STRIP001 		if( aDataHelper.GetSotStorageStream( SOT_FORMATSTR_ID_SVXB, xStm ) )
//STRIP001 		{
//STRIP001 			Graphic aGraphic;
//STRIP001 			*xStm >> aGraphic;
//STRIP001 			bRet = PasteGraphic( aPos, aGraphic, EMPTY_STRING, EMPTY_STRING );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if ( nFormatId == SOT_FORMATSTR_ID_DRAWING )
//STRIP001 	{
//STRIP001 		SotStorageStreamRef xStm;
//STRIP001 		if( aDataHelper.GetSotStorageStream( SOT_FORMATSTR_ID_DRAWING, xStm ) )
//STRIP001 		{
//STRIP001 			MakeDrawLayer();	// before loading model, so 3D factory has been created
//STRIP001 
//STRIP001 			SvtPathOptions aPathOpt;
//STRIP001 			String aPath = aPathOpt.GetPalettePath();
//STRIP001 			FmFormModel* pModel = new FmFormModel(
//STRIP001 									aPath, NULL, GetViewData()->GetDocShell() );
//STRIP001 			pModel->GetItemPool().FreezeIdRanges();
//STRIP001 			xStm->Seek(0);
//STRIP001 
//STRIP001 			::com::sun::star::uno::Reference< ::com::sun::star::io::XInputStream > xInputStream( new utl::OInputStreamWrapper( *xStm ) );
//STRIP001 			SvxDrawingLayerImport( pModel, xInputStream );
//STRIP001 
//STRIP001 			pModel->SetStreamingSdrModel(FALSE);
//STRIP001 
//STRIP001 										// set everything to right layer:
//STRIP001 			ULONG nObjCount = 0;
//STRIP001 			USHORT nPages = pModel->GetPageCount();
//STRIP001 			for (USHORT i=0; i<nPages; i++)
//STRIP001 			{
//STRIP001 				SdrPage* pPage = pModel->GetPage(i);
//STRIP001 				SdrObjListIter aIter( *pPage, IM_DEEPWITHGROUPS );
//STRIP001 				SdrObject* pObject = aIter.Next();
//STRIP001 				while (pObject)
//STRIP001 				{
//STRIP001 					if ( pObject->ISA(SdrUnoObj) )
//STRIP001 						pObject->NbcSetLayer(SC_LAYER_CONTROLS);
//STRIP001 					else
//STRIP001 						pObject->NbcSetLayer(SC_LAYER_FRONT);
//STRIP001 					pObject = aIter.Next();
//STRIP001 				}
//STRIP001 
//STRIP001 				nObjCount += pPage->GetObjCount();			// #105888# count group object only once
//STRIP001 			}
//STRIP001 
//STRIP001 			PasteDraw( aPos, pModel, (nObjCount > 1) );		// grouped if more than 1 object
//STRIP001 			delete pModel;
//STRIP001 			bRet = TRUE;
//STRIP001 		}
//STRIP001 	}
//STRIP001     else if ( (nFormatId == SOT_FORMATSTR_ID_BIFF_5) || (nFormatId == SOT_FORMATSTR_ID_BIFF_8) )
//STRIP001 	{
//STRIP001 		//	do excel import into a clipboard document
//STRIP001 
//STRIP001 		SotStorageStreamRef xStm;
//STRIP001         if( aDataHelper.GetSotStorageStream( nFormatId, xStm ) )
//STRIP001 		{
//STRIP001 			SvStorageRef pStor = new SvStorage( *xStm );
//STRIP001 #if 0
//STRIP001 			SvStorage aDest( "d:\\test.xls" );	// to see the file
//STRIP001 			pStor->CopyTo( &aDest );
//STRIP001 #endif
//STRIP001 			ScDocument* pDoc = GetViewData()->GetDocument();
//STRIP001 			ScDocument* pInsDoc = new ScDocument( SCDOCMODE_CLIP );
//STRIP001 			USHORT nSrcTab = 0;		// Biff5 in clipboard: always sheet 0
//STRIP001 			pInsDoc->ResetClip( pDoc, nSrcTab );
//STRIP001 
//STRIP001 			SfxMedium aMed( pStor, TRUE );
//STRIP001 			FltError eErr = ScImportExcel( aMed, pInsDoc, EIF_AUTO );
//STRIP001 			if ( eErr == eERR_OK )
//STRIP001 			{
//STRIP001 				ScRange aSource;
//STRIP001 				const ScExtDocOptions* pExtOpt = pInsDoc->GetExtDocOptions();
//STRIP001 				const ScExtTabOptions* pTabOpt = pExtOpt ?
//STRIP001 										pExtOpt->GetExtTabOptions(nSrcTab) : NULL;
//STRIP001 				if ( pTabOpt && pTabOpt->bValidDim &&
//STRIP001 						pTabOpt->aDim.aEnd.Col() > pTabOpt->aDim.aStart.Col() &&
//STRIP001 						pTabOpt->aDim.aEnd.Row() > pTabOpt->aDim.aStart.Row() )
//STRIP001 				{
//STRIP001 					//	"end" points behind the data area
//STRIP001 					aSource = ScRange(
//STRIP001 						pTabOpt->aDim.aStart.Col(), pTabOpt->aDim.aStart.Row(), nSrcTab,
//STRIP001 						pTabOpt->aDim.aEnd.Col()-1, pTabOpt->aDim.aEnd.Row()-1, nSrcTab );
//STRIP001 // #92240# don't use selection area: if cursor is moved in Excel after Copy, selection
//STRIP001 // represents the new cursor position and not the copied area
//STRIP001 //                    //  selection can be bigger than the used area
//STRIP001 //                    if ( pTabOpt->bValidSel )
//STRIP001 //                    {
//STRIP001 //                        if ( pTabOpt->aLastSel.aStart.Col() < aSource.aStart.Col() )
//STRIP001 //                            aSource.aStart.SetCol( pTabOpt->aLastSel.aStart.Col() );
//STRIP001 //                        if ( pTabOpt->aLastSel.aStart.Row() < aSource.aStart.Row() )
//STRIP001 //                            aSource.aStart.SetRow( pTabOpt->aLastSel.aStart.Row() );
//STRIP001 //                        //  "end" in selection is really the end
//STRIP001 //                        if ( pTabOpt->aLastSel.aEnd.Col() > aSource.aEnd.Col() )
//STRIP001 //                            aSource.aEnd.SetCol( pTabOpt->aLastSel.aEnd.Col() );
//STRIP001 //                        if ( pTabOpt->aLastSel.aEnd.Row() > aSource.aEnd.Row() )
//STRIP001 //                            aSource.aEnd.SetRow( pTabOpt->aLastSel.aEnd.Row() );
//STRIP001 //                    }
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					DBG_ERROR("no dimension");	//!	possible?
//STRIP001 					USHORT nFirstCol, nFirstRow, nLastCol, nLastRow;
//STRIP001 					if ( pInsDoc->GetDataStart( nSrcTab, nFirstCol, nFirstRow ) )
//STRIP001 						pInsDoc->GetCellArea( nSrcTab, nLastCol, nLastRow );
//STRIP001 					else
//STRIP001 						nFirstCol = nFirstRow = nLastCol = nLastRow = 0;
//STRIP001 					aSource = ScRange( nFirstCol, nFirstRow, nSrcTab,
//STRIP001 										nLastCol, nLastRow, nSrcTab );
//STRIP001 				}
//STRIP001 
//STRIP001 				if ( pLogicPos )
//STRIP001 				{
//STRIP001 					// position specified (Drag&Drop) - change selection
//STRIP001 					MoveCursorAbs( nPosX, nPosY, SC_FOLLOW_NONE, FALSE, FALSE );
//STRIP001 					Unmark();
//STRIP001 				}
//STRIP001 
//STRIP001 				pInsDoc->SetClipArea( aSource );
//STRIP001 				PasteFromClip( IDF_ALL, pInsDoc,
//STRIP001 								PASTE_NOFUNC, FALSE, FALSE, FALSE, INS_NONE, IDF_NONE,
//STRIP001 								bAllowDialogs );
//STRIP001 				delete pInsDoc;
//STRIP001 
//STRIP001 				bRet = TRUE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if ( nFormatId == SOT_FORMAT_FILE )
//STRIP001 	{
//STRIP001 		//!	multiple files?
//STRIP001 		//USHORT nCount = DragServer::GetItemCount();
//STRIP001 		//if (nCount == 0)	// normal handling (not D&D)
//STRIP001 		{
//STRIP001 			String aFile;
//STRIP001 			if ( aDataHelper.GetString( nFormatId, aFile ) )
//STRIP001 				bRet = PasteFile( aPos, aFile, bLink );
//STRIP001 		}
//STRIP001 #if 0
//STRIP001 		else		// use multiple items from drag server
//STRIP001 		{
//STRIP001 			for( USHORT i = 0; i < nCount ; i++ )
//STRIP001 			{
//STRIP001 				String aFile = DragServer::PasteFile( i );
//STRIP001 				SfxStringItem aNameItem( FID_INSERT_FILE, aFile );
//STRIP001 				SfxPointItem aPosItem( FN_PARAM_1, aPos );
//STRIP001 				SfxDispatcher* pDisp =
//STRIP001 					GetViewData()->GetViewShell()->GetViewFrame()->GetDispatcher();
//STRIP001 				if (pDisp)
//STRIP001 					pDisp->Execute( FID_INSERT_FILE, SFX_CALLMODE_ASYNCHRON,
//STRIP001 										&aNameItem, &aPosItem, (void*)0 );
//STRIP001 
//STRIP001 				aPos.X() += 400;
//STRIP001 				aPos.Y() += 400;
//STRIP001 			}
//STRIP001 			bRet = TRUE;
//STRIP001 		}
//STRIP001 #endif
//STRIP001 	}
//STRIP001 	else if ( nFormatId == SOT_FORMATSTR_ID_SOLK ||
//STRIP001 			  nFormatId == SOT_FORMATSTR_ID_UNIFORMRESOURCELOCATOR ||
//STRIP001 			  nFormatId == SOT_FORMATSTR_ID_NETSCAPE_BOOKMARK ||
//STRIP001 			  nFormatId == SOT_FORMATSTR_ID_FILEGRPDESCRIPTOR )
//STRIP001 	{
//STRIP001 		bRet = PasteBookmark( nFormatId, rxTransferable, nPosX, nPosY );
//STRIP001 	}
//STRIP001 
//STRIP001     pDoc->SetPastingDrawFromOtherDoc( FALSE );
//STRIP001 
//STRIP001 	return bRet;
//STRIP001 }

//STRIP001 String lcl_GetSubString( sal_Char* pData, long nStart, long nDataSize, rtl_TextEncoding eEncoding )
//STRIP001 {
//STRIP001 	if ( nDataSize <= nStart /* || pData[nDataSize] != 0 */ )
//STRIP001 	{
//STRIP001 		DBG_ERROR("DDE Data: invalid data");
//STRIP001 		return String();
//STRIP001 	}
//STRIP001 	return String( pData + nStart, eEncoding );
//STRIP001 }

//STRIP001 BOOL ScViewFunc::PasteDDE( const uno::Reference<datatransfer::XTransferable>& rxTransferable )
//STRIP001 {
//STRIP001 	TransferableDataHelper aDataHelper( rxTransferable );
//STRIP001 
//STRIP001 	//	get link data from transferable before string data,
//STRIP001 	//	so the source knows it will be used for a link
//STRIP001 
//STRIP001 	uno::Sequence<sal_Int8> aSequence;
//STRIP001 	if ( !aDataHelper.GetSequence( SOT_FORMATSTR_ID_LINK, aSequence ) )
//STRIP001 	{
//STRIP001 		DBG_ERROR("DDE Data not found.");
//STRIP001 		return FALSE;
//STRIP001 	}
//STRIP001 
//STRIP001 	//	check size (only if string is available in transferable)
//STRIP001 
//STRIP001 	USHORT nCols = 1;
//STRIP001 	USHORT nRows = 1;
//STRIP001 	if ( aDataHelper.HasFormat( SOT_FORMAT_STRING ) )
//STRIP001 	{
//STRIP001 		String aDataStr;
//STRIP001 		if ( aDataHelper.GetString( SOT_FORMAT_STRING, aDataStr ) )
//STRIP001 		{
//STRIP001 			//	get size from string the same way as in ScDdeLink::DataChanged
//STRIP001 
//STRIP001 			aDataStr.ConvertLineEnd(LINEEND_LF);
//STRIP001 			xub_StrLen nLen = aDataStr.Len();
//STRIP001 			if (nLen && aDataStr.GetChar(nLen-1) == '\n')
//STRIP001 				aDataStr.Erase(nLen-1);
//STRIP001 
//STRIP001 			if (aDataStr.Len())
//STRIP001 			{
//STRIP001 				nRows = aDataStr.GetTokenCount( '\n' );
//STRIP001 				String aLine = aDataStr.GetToken( 0, '\n' );
//STRIP001 				if (aLine.Len())
//STRIP001 					nCols = aLine.GetTokenCount( '\t' );
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	//	create formula
//STRIP001 
//STRIP001 	long nSeqLen = aSequence.getLength();
//STRIP001 	sal_Char* pData = (sal_Char*)aSequence.getConstArray();
//STRIP001 
//STRIP001 	rtl_TextEncoding eSysEnc = gsl_getSystemTextEncoding();
//STRIP001 
//STRIP001 	String aApp   = lcl_GetSubString( pData, 0, nSeqLen, eSysEnc );
//STRIP001 	String aTopic = lcl_GetSubString( pData, aApp.Len() + 1, nSeqLen, eSysEnc );
//STRIP001 	String aItem  = lcl_GetSubString( pData, aApp.Len() + aTopic.Len() + 2, nSeqLen, eSysEnc );
//STRIP001 
//STRIP001 	if (!ScCompiler::pSymbolTableNative)
//STRIP001 	{
//STRIP001 		DBG_ERROR("ScCompiler::pSymbolTableNative missing");
//STRIP001 		return FALSE;
//STRIP001 	}
//STRIP001 
//STRIP001 	//!	use tokens
//STRIP001 	String aFormula( '=' );
//STRIP001 	aFormula += ScCompiler::pSymbolTableNative[SC_OPCODE_DDE];
//STRIP001 	aFormula.AppendAscii(RTL_CONSTASCII_STRINGPARAM("(\""));
//STRIP001 	aFormula += aApp;
//STRIP001 	aFormula.AppendAscii(RTL_CONSTASCII_STRINGPARAM("\";\""));
//STRIP001 	aFormula += aTopic;
//STRIP001 	aFormula.AppendAscii(RTL_CONSTASCII_STRINGPARAM("\";\""));
//STRIP001 	aFormula += aItem;
//STRIP001 	aFormula.AppendAscii(RTL_CONSTASCII_STRINGPARAM("\")"));
//STRIP001 
//STRIP001 	//	mark range
//STRIP001 
//STRIP001 	USHORT nTab = GetViewData()->GetTabNo();
//STRIP001 	USHORT nCurX = GetViewData()->GetCurX();
//STRIP001 	USHORT nCurY = GetViewData()->GetCurY();
//STRIP001 	HideAllCursors();
//STRIP001 	DoneBlockMode();
//STRIP001 	InitBlockMode( nCurX, nCurY, nTab );
//STRIP001 	MarkCursor( nCurX+nCols-1, nCurY+nRows-1, nTab );
//STRIP001 	ShowAllCursors();
//STRIP001 
//STRIP001 	//	enter formula
//STRIP001 
//STRIP001 	EnterMatrix( aFormula );
//STRIP001 	CursorPosChanged();
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }


}
