/*************************************************************************
 *
 *  $RCSfile: sch_fudgraut.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:56:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif

// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif

// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif

#pragma hdrstop

#include "schattr.hxx"
#define ITEMID_CHARTLEGENDPOS	SCHATTR_LEGEND_POS

#ifndef _SFXENUMITEM_HXX
#include <svtools/eitem.hxx>
#endif

// auto strip #include <bf_svx/chrtitem.hxx>

#include "app.hrc"
// auto strip #include "schresid.hxx"
#include "strings.hrc"
// auto strip #include "schview.hxx"
// auto strip #ifndef _CHTMODEL_HXX
// auto strip #include "chtmodel.hxx"
// auto strip #endif
// auto strip #include "viewshel.hxx"
// auto strip #include "dlggraut.hxx"
// auto strip #include "undgraut.hxx"
// auto strip #include "fudgraut.hxx"

// auto strip #include "chtscene.hxx"
// auto strip #include "SchRangeChecker.hxx"
#include "glob.hrc"
namespace binfilter {

//STRIP001 TYPEINIT1(SchFuDiagramAutoPilot, SchFuPoor);


/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

//STRIP001 SchFuDiagramAutoPilot::SchFuDiagramAutoPilot(SchViewShell* pViewSh,
//STRIP001 											 SchWindow* pWin, SchView* pView,
//STRIP001 											 ChartModel* pDoc,
//STRIP001 											 SfxRequest& rReq) :
//STRIP001 	SchFuPoor(pViewSh, pWin, pView, pDoc, rReq)
//STRIP001 {
//STRIP001 	SvxChartStyle eOldStyle		= pDoc->ChartStyle();
//STRIP001 //	long nOldGapWidth			= pDoc->GapWidth();
//STRIP001 //	long nOldOverlap			= pDoc->Overlap();
//STRIP001 
//STRIP001 	BOOL   bOldShowMainTitle	= pDoc->ShowMainTitle();
//STRIP001 	String aOldMainTitle		= pDoc->MainTitle();
//STRIP001 	BOOL   bOldShowSubTitle		= pDoc->ShowSubTitle();
//STRIP001 	String aOldSubTitle			= pDoc->SubTitle();
//STRIP001 	BOOL   bOldShowXAxisTitle	= pDoc->ShowXAxisTitle();
//STRIP001 	String aOldXAxisTitle		= pDoc->XAxisTitle();
//STRIP001 	BOOL   bOldShowYAxisTitle	= pDoc->ShowYAxisTitle();
//STRIP001 	String aOldYAxisTitle		= pDoc->YAxisTitle();
//STRIP001 	BOOL   bOldShowZAxisTitle	= pDoc->ShowZAxisTitle();
//STRIP001 	String aOldZAxisTitle		= pDoc->ZAxisTitle();
//STRIP001 	BOOL   bOldShowXAxis		= pDoc->ShowXAxis();
//STRIP001 	BOOL   bOldShowXGridMain	= pDoc->ShowXGridMain();
//STRIP001 	BOOL   bOldShowXGridHelp	= pDoc->ShowXGridHelp();
//STRIP001 	BOOL   bOldShowXDescr		= pDoc->ShowXDescr();
//STRIP001 	BOOL   bOldShowYAxis		= pDoc->ShowYAxis();
//STRIP001 	BOOL   bOldShowYGridMain	= pDoc->ShowYGridMain();
//STRIP001 	BOOL   bOldShowYGridHelp	= pDoc->ShowYGridHelp();
//STRIP001 	BOOL   bOldShowYDescr		= pDoc->ShowYDescr();
//STRIP001 	BOOL   bOldShowZAxis		= pDoc->ShowZAxis();
//STRIP001 	BOOL   bOldShowZGridMain	= pDoc->ShowZGridMain();
//STRIP001 	BOOL   bOldShowZGridHelp	= pDoc->ShowZGridHelp();
//STRIP001 	BOOL   bOldShowZDescr		= pDoc->ShowZDescr();
//STRIP001 	BOOL   bOldSwitchData		= pDoc->IsSwitchData();
//STRIP001 	long   nOldChartShapeType   = pDoc->GetChartShapeType();
//STRIP001 
//STRIP001 	const SfxPoolItem *pPoolItem = NULL;
//STRIP001 	SfxItemSet aAttr(pDoc->GetLegendAttr());
//STRIP001 	SvxChartLegendPos eOldLegendPos =
//STRIP001 		(aAttr.GetItemState(SCHATTR_LEGEND_POS, TRUE, &pPoolItem)
//STRIP001 			== SFX_ITEM_SET) ?
//STRIP001 		((const SvxChartLegendPosItem*)pPoolItem)->GetValue() : CHLEGEND_NONE;
//STRIP001 
//STRIP001 	SchChartDocShell* pChDocSh =
//STRIP001 				new SchChartDocShell(SFX_CREATE_MODE_PREVIEW);
//STRIP001 	SfxObjectShellLock aDocShellRef = pChDocSh;
//STRIP001 	aDocShellRef->DoInitNew(NULL);
//STRIP001 
//STRIP001 	ChartModel &rChDoc    = pChDocSh->GetDoc();
//STRIP001 	BOOL             bOldLegend = pDoc->GetShowLegend();
//STRIP001 	short            nXAngle;
//STRIP001 	short            nYAngle;
//STRIP001 	short            nZAngle;
//STRIP001 
//STRIP001     // #92872# set switch before data !
//STRIP001 	rChDoc.SetSwitchData (pDoc->IsSwitchData());
//STRIP001 	rChDoc.SetChartData(*pDoc->GetChartData());
//STRIP001 	pDoc->GetAngles (nXAngle, nYAngle, nZAngle);
//STRIP001 	rChDoc.SetAngles (nXAngle, nYAngle, nZAngle);
//STRIP001 	rChDoc.SetShowLegend (pDoc->GetShowLegend());
//STRIP001 
//STRIP001 	rChDoc.ChartStyle ()         = eOldStyle;
//STRIP001 //	rChDoc.GapWidth ()           = nOldGapWidth;
//STRIP001 //	rChDoc.Overlap ()            = nOldOverlap;
//STRIP001 	rChDoc.ShowMainTitle ()      = bOldShowMainTitle;
//STRIP001 	rChDoc.MainTitle ()          = aOldMainTitle;
//STRIP001 	rChDoc.SubTitle ()           = aOldSubTitle;
//STRIP001 	rChDoc.ShowSubTitle ()       = bOldShowSubTitle;
//STRIP001 	rChDoc.ShowXAxisTitle ()     = bOldShowXAxisTitle;
//STRIP001 	rChDoc.XAxisTitle ()         = aOldXAxisTitle;
//STRIP001 	rChDoc.ShowYAxisTitle ()     = bOldShowYAxisTitle;
//STRIP001 	rChDoc.YAxisTitle ()         = aOldYAxisTitle;
//STRIP001 	rChDoc.ShowZAxisTitle ()     = bOldShowZAxisTitle;
//STRIP001 	rChDoc.ZAxisTitle ()         = aOldZAxisTitle;
//STRIP001 	rChDoc.ShowXAxis (bOldShowXAxis);
//STRIP001 	rChDoc.ShowXGridMain ()      = bOldShowXGridMain;
//STRIP001 	rChDoc.ShowXGridHelp ()      = bOldShowXGridHelp;
//STRIP001 	rChDoc.ShowXDescr (bOldShowXDescr);
//STRIP001 	rChDoc.ShowYAxis (bOldShowYAxis);
//STRIP001 	rChDoc.ShowYGridMain ()      = bOldShowYGridMain;
//STRIP001 	rChDoc.ShowYGridHelp ()      = bOldShowYGridHelp;
//STRIP001 	rChDoc.ShowYDescr (bOldShowYDescr);
//STRIP001 	rChDoc.ShowZAxis (bOldShowZAxis);
//STRIP001 	rChDoc.ShowZGridMain ()      = bOldShowZGridMain;
//STRIP001 	rChDoc.ShowZGridHelp ()      = bOldShowZGridHelp;
//STRIP001 	rChDoc.ShowZDescr (bOldShowZDescr);
//STRIP001 	rChDoc.DataDescr ()          = CHDESCR_NONE;
//STRIP001 	rChDoc.ShowSym ()            = FALSE;
//STRIP001 /*	In den Achsenattributen enthalten
//STRIP001 	rChDoc.Val Format ()          = pDoc->Va lFormat();
//STRIP001 	rChDoc.Perc entValFormat ()   = pDoc->Per centValFormat();
//STRIP001 	rChDoc.Desc rFormat ()        = pDoc->Des crFormat();
//STRIP001 	rChDoc.Percen tDescrFormat () = pDoc->Des crFormat(); */
//STRIP001 
//STRIP001 	rChDoc.PutTitleAttr(pDoc->GetTitleAttr());
//STRIP001 	rChDoc.PutMainTitleAttr(pDoc->GetMainTitleAttr());
//STRIP001 	rChDoc.PutSubTitleAttr(pDoc->GetSubTitleAttr());
//STRIP001 	rChDoc.PutXAxisTitleAttr(pDoc->GetXAxisTitleAttr());
//STRIP001 	rChDoc.PutYAxisTitleAttr(pDoc->GetYAxisTitleAttr());
//STRIP001 	rChDoc.PutZAxisTitleAttr(pDoc->GetZAxisTitleAttr());
//STRIP001 	rChDoc.PutAxisAttr(pDoc->GetAxisAttr());
//STRIP001 
//STRIP001 	rChDoc.CopyAxisAttributes(pDoc,TRUE);
//STRIP001 
//STRIP001 	rChDoc.PutGridAttr(pDoc->GetGridAttr());
//STRIP001 	rChDoc.PutXGridMainAttr(pDoc->GetXGridMainAttr());
//STRIP001 	rChDoc.PutYGridMainAttr(pDoc->GetYGridMainAttr());
//STRIP001 	rChDoc.PutZGridMainAttr(pDoc->GetZGridMainAttr());
//STRIP001 	rChDoc.PutXGridHelpAttr(pDoc->GetXGridHelpAttr());
//STRIP001 	rChDoc.PutYGridHelpAttr(pDoc->GetYGridHelpAttr());
//STRIP001 	rChDoc.PutZGridHelpAttr(pDoc->GetZGridHelpAttr());
//STRIP001 	rChDoc.PutDiagramAreaAttr(pDoc->GetDiagramAreaAttr());
//STRIP001 	rChDoc.PutDiagramWallAttr(pDoc->GetDiagramWallAttr());
//STRIP001 	rChDoc.PutDiagramFloorAttr(pDoc->GetDiagramFloorAttr());
//STRIP001 	rChDoc.PutLegendAttr(pDoc->GetLegendAttr());
//STRIP001 
//STRIP001 	rChDoc.SetAttributes(CHOBJID_DIAGRAM_STOCKLOSS_GROUP,pDoc->GetAttr(CHOBJID_DIAGRAM_STOCKLOSS_GROUP),FALSE);
//STRIP001 	rChDoc.SetAttributes(CHOBJID_DIAGRAM_STOCKPLUS_GROUP,pDoc->GetAttr(CHOBJID_DIAGRAM_STOCKPLUS_GROUP),FALSE);
//STRIP001 	rChDoc.SetAttributes(CHOBJID_DIAGRAM_STOCKLINE_GROUP,pDoc->GetAttr(CHOBJID_DIAGRAM_STOCKLINE_GROUP),FALSE);
//STRIP001 	//Textgroesse wird falsch skaliert, da alle Textattr. relativ zu aInitialSize sind #47892#
//STRIP001 	rChDoc.InitialSize() = pDoc->InitialSize();
//STRIP001 
//STRIP001 	rChDoc.SetShowDataDescr(FALSE); //die Datenbeschriftung wird im Autopiloten aus Platzmangel verboten
//STRIP001 
//STRIP001     rChDoc.InitDataAttrs();
//STRIP001 
//STRIP001     long nColCnt, nRowCnt, nMax, i,j;
//STRIP001     if( rChDoc.IsPieChart())
//STRIP001     {
//STRIP001         nRowCnt = rChDoc.GetColCount();
//STRIP001         nColCnt = rChDoc.GetRowCount();
//STRIP001     }
//STRIP001 	else
//STRIP001     {
//STRIP001         nRowCnt = rChDoc.GetRowCount();
//STRIP001         nColCnt = rChDoc.GetColCount();
//STRIP001     }
//STRIP001 
//STRIP001 	for (i = 0; i < nRowCnt; i++)
//STRIP001 		rChDoc.PutDataRowAttr(i, pDoc->GetDataRowAttr(i));
//STRIP001 
//STRIP001 	for (i = 0; i < nColCnt; i++)
//STRIP001 		for (j = 0; j < nRowCnt; j++)
//STRIP001 			if (pDoc->IsDataPointAttrSet (i, j))
//STRIP001 				rChDoc.PutDataPointAttr(i, j, pDoc->GetDataPointAttr(i, j));
//STRIP001 
//STRIP001 //      FG: Mit dieser Zeile erhaelt man keinen modalen Dialog => Absturz falls ein Resize im Chart
//STRIP001 //      stattfindet waehrend dieser Dialog geoeffnet ist.
//STRIP001 //	SchDiagramAutoPilotDlg* pDlg = new SchDiagramAutoPilotDlg(&pViewSh->GetViewFrame()->GetWindow(),
//STRIP001 //			                                                  aDocShellRef);
//STRIP001 	SchDiagramAutoPilotDlg* pDlg = new SchDiagramAutoPilotDlg(NULL, aDocShellRef);
//STRIP001 
//STRIP001 	// #74709# this is just a fix for this place again and no general enhancement :-(
//STRIP001 	if( rChDoc.IsPieChart() && rChDoc.IsReal3D() )
//STRIP001 	{
//STRIP001 		ChartScene* pScene = rChDoc.GetScene();
//STRIP001 		if( pScene )
//STRIP001 		{
//STRIP001 			Matrix4D aSceneMatrix;
//STRIP001 			aSceneMatrix.RotateX( -F_PI/3 );
//STRIP001 			pScene->SetTransform( aSceneMatrix );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001     // #101164# number of lines for a combi chart has to be saved
//STRIP001     rChDoc.SetNumLinesColChart( pDoc->GetNumLinesColChart());
//STRIP001 
//STRIP001 		// FG: 13.3.97 folgendes ist aus dem Draw fuinsfil.cxx uebernommen
//STRIP001 		// Ev. wird eine QueryBox geoeffnet ("Links aktualisieren?"),
//STRIP001 		// daher wird der Dialog der aktuelle DefModalDialogParent
//STRIP001 	Window* pDefParent = GetpApp()->GetDefDialogParent();
//STRIP001 	GetpApp()->SetDefDialogParent(pDlg);
//STRIP001 
//STRIP001 	pDlg->SetLegendPos(eOldLegendPos);
//STRIP001 
//STRIP001 	USHORT nResult = pDlg->Execute();
//STRIP001 
//STRIP001 	GetpApp()->SetDefDialogParent(pDefParent);
//STRIP001 
//STRIP001 	delete pDlg;
//STRIP001 
//STRIP001 	if (nResult == RET_OK)
//STRIP001 	{
//STRIP001 		rReq.Done();
//STRIP001 
//STRIP001 		if( pViewSh )
//STRIP001 			pViewSh->GetViewFrame()->GetDispatcher()->Execute(
//STRIP001 				SID_TOOL_SELECT, SFX_CALLMODE_SYNCHRON );
//STRIP001 
//STRIP001 		SvxChartStyle eNewStyle		= rChDoc.ChartStyle();
//STRIP001 //		long nNewGapWidth			= rChDoc.GapWidth();
//STRIP001 //		long nNewOverlap			= rChDoc.Overlap();
//STRIP001 
//STRIP001 		CheckRange (pDoc, eNewStyle);
//STRIP001 
//STRIP001 		BOOL   bNewShowMainTitle	= rChDoc.ShowMainTitle();
//STRIP001 		String aNewMainTitle		= rChDoc.MainTitle();
//STRIP001 		BOOL   bNewShowSubTitle		= rChDoc.ShowSubTitle();
//STRIP001 		String aNewSubTitle			= rChDoc.SubTitle();
//STRIP001 		BOOL   bNewShowXAxisTitle	= rChDoc.ShowXAxisTitle();
//STRIP001 		String aNewXAxisTitle		= rChDoc.XAxisTitle();
//STRIP001 		BOOL   bNewShowYAxisTitle	= rChDoc.ShowYAxisTitle();
//STRIP001 		String aNewYAxisTitle		= rChDoc.YAxisTitle();
//STRIP001 		BOOL   bNewShowZAxisTitle	= rChDoc.ShowZAxisTitle();
//STRIP001 		String aNewZAxisTitle		= rChDoc.ZAxisTitle();
//STRIP001 		BOOL   bNewShowXAxis		= rChDoc.ShowXAxis();
//STRIP001 		BOOL   bNewShowXGridMain	= rChDoc.ShowXGridMain();
//STRIP001 		BOOL   bNewShowXGridHelp	= rChDoc.ShowXGridHelp();
//STRIP001 		BOOL   bNewShowXDescr		= rChDoc.ShowXDescr();
//STRIP001 		BOOL   bNewShowYAxis		= rChDoc.ShowYAxis();
//STRIP001 		BOOL   bNewShowYGridMain	= rChDoc.ShowYGridMain();
//STRIP001 		BOOL   bNewShowYGridHelp	= rChDoc.ShowYGridHelp();
//STRIP001 		BOOL   bNewShowYDescr		= rChDoc.ShowYDescr();
//STRIP001 		BOOL   bNewShowZAxis		= rChDoc.ShowZAxis();
//STRIP001 		BOOL   bNewShowZGridMain	= rChDoc.ShowZGridMain();
//STRIP001 		BOOL   bNewShowZGridHelp	= rChDoc.ShowZGridHelp();
//STRIP001 		BOOL   bNewShowZDescr		= rChDoc.ShowZDescr();
//STRIP001 		BOOL   bNewSwitchData		= rChDoc.IsSwitchData();
//STRIP001 		BOOL   bNewShowLegend		= rChDoc.GetShowLegend();
//STRIP001 		long   nNewChartShapeType   = rChDoc.GetChartShapeType();
//STRIP001 
//STRIP001 		if (nNewChartShapeType != nOldChartShapeType   ||
//STRIP001 			eNewStyle != eOldStyle || /*nNewGapWidth != nOldGapWidth ||
//STRIP001 			nNewOverlap != nOldOverlap ||*/
//STRIP001 			bNewShowMainTitle != bOldShowMainTitle ||
//STRIP001 			aNewMainTitle != aOldMainTitle ||
//STRIP001 			bNewShowSubTitle != bOldShowSubTitle ||
//STRIP001 			aNewSubTitle != aOldSubTitle ||
//STRIP001 			bNewShowXAxisTitle != bOldShowXAxisTitle ||
//STRIP001 			aNewXAxisTitle != aOldXAxisTitle ||
//STRIP001 			bNewShowYAxisTitle != bOldShowYAxisTitle ||
//STRIP001 			aNewYAxisTitle != aOldYAxisTitle ||
//STRIP001 			bNewShowZAxisTitle != bOldShowZAxisTitle ||
//STRIP001 			aNewZAxisTitle != aOldZAxisTitle ||
//STRIP001 			bNewShowXAxis != bOldShowXAxis ||
//STRIP001 			bNewShowXGridMain != bOldShowXGridMain ||
//STRIP001 			bNewShowXGridHelp != bOldShowXGridHelp ||
//STRIP001 			bNewShowXDescr != bOldShowXDescr ||
//STRIP001 			bNewShowYAxis != bOldShowYAxis ||
//STRIP001 			bNewShowYGridMain != bOldShowYGridMain ||
//STRIP001 			bNewShowYGridHelp != bOldShowYGridHelp ||
//STRIP001 			bNewShowYDescr != bOldShowYDescr ||
//STRIP001 			bNewShowZAxis != bOldShowZAxis ||
//STRIP001 			bNewShowZGridMain != bOldShowZGridMain ||
//STRIP001 			bNewShowZGridHelp != bOldShowZGridHelp ||
//STRIP001 			bNewShowZDescr != bOldShowZDescr ||
//STRIP001 			bNewSwitchData != bOldSwitchData ||
//STRIP001 			bNewShowLegend != bOldLegend )
//STRIP001 		{
//STRIP001 /*			for (i = 0; i < nPieSegCnt; i++)
//STRIP001 				pDoc->PieSegOfs (i) = pNewPieSegOfs[i];
//STRIP001 */
//STRIP001 			pDoc->ShowMainTitle ()  = bNewShowMainTitle;
//STRIP001 			pDoc->MainTitle ()      = aNewMainTitle;
//STRIP001 			pDoc->ShowSubTitle ()   = bNewShowSubTitle;
//STRIP001 			pDoc->SubTitle ()       = aNewSubTitle;
//STRIP001 			pDoc->ShowXAxisTitle () = bNewShowXAxisTitle;
//STRIP001 			pDoc->XAxisTitle ()     = aNewXAxisTitle;
//STRIP001 			pDoc->ShowYAxisTitle () = bNewShowYAxisTitle;
//STRIP001 			pDoc->YAxisTitle ()     = aNewYAxisTitle;
//STRIP001 			pDoc->ShowZAxisTitle () = bNewShowZAxisTitle;
//STRIP001 			pDoc->ZAxisTitle ()     = aNewZAxisTitle;
//STRIP001 			pDoc->ShowXAxis (bOldShowXAxis);
//STRIP001 			pDoc->ShowXGridMain ()  = bNewShowXGridMain;
//STRIP001 			pDoc->ShowXGridHelp ()  = bNewShowXGridHelp;
//STRIP001 			pDoc->ShowXDescr (bNewShowXDescr);
//STRIP001 			pDoc->ShowYAxis (bNewShowYAxis);
//STRIP001 			pDoc->ShowYGridMain ()  = bNewShowYGridMain;
//STRIP001 			pDoc->ShowYGridMain ()  = bNewShowYGridMain;
//STRIP001 			pDoc->ShowYGridHelp ()  = bNewShowYGridHelp;
//STRIP001 			pDoc->ShowYDescr (bNewShowYDescr);
//STRIP001 			pDoc->ShowZAxis (bNewShowZAxis);
//STRIP001 			pDoc->ShowZGridMain ()  = bNewShowZGridMain;
//STRIP001 			pDoc->ShowZGridHelp ()  = bNewShowZGridHelp;
//STRIP001 			pDoc->ShowZDescr (bNewShowZDescr);
//STRIP001             if( bNewSwitchData != bOldSwitchData )
//STRIP001                 pDoc->ChangeSwitchData (bNewSwitchData);
//STRIP001 			pDoc->SetShowLegend (bNewShowLegend);
//STRIP001 
//STRIP001 			if(nNewChartShapeType != nOldChartShapeType)
//STRIP001 			{
//STRIP001 				SfxItemSet aSet(pDoc->GetPool(),SCHATTR_STYLE_SHAPE,SCHATTR_STYLE_SHAPE);
//STRIP001 				aSet.Put(SfxInt32Item(SCHATTR_STYLE_SHAPE,nNewChartShapeType));
//STRIP001 //				long nCnt=pDoc->GetRowCount();
//STRIP001 //				while(nCnt--)
//STRIP001 				pDoc->PutDataRowAttrAll(aSet);
//STRIP001 			}
//STRIP001 
//STRIP001 
//STRIP001 			//	Get a list of offsets of the pie segments for passing it to the undo object.
//STRIP001 			short nOldPieSegCnt = pDoc->PieSegCount();
//STRIP001 			long * pOldPieSegOfs = new long [nOldPieSegCnt];
//STRIP001 			for (i=0; i<nOldPieSegCnt; i++)
//STRIP001 				pOldPieSegOfs[i] = pDoc->PieSegOfs(i);
//STRIP001 
//STRIP001 			pDoc->ChangeChart( eNewStyle );
//STRIP001 			pDoc->BuildChart(FALSE);
//STRIP001 			
//STRIP001 			//	Again get a list of offsets of the pie segments.  The call to ChangeChart
//STRIP001 			//	may have changed the offsets.  Both lists are passed to the undo action which
//STRIP001 			//	also takes care of deleting them.
//STRIP001 			short nNewPieSegCnt = pDoc->PieSegCount();
//STRIP001 			long *pNewPieSegOfs = new long [nNewPieSegCnt];
//STRIP001 			for (i=0; i<nNewPieSegCnt; i++)
//STRIP001 				pNewPieSegOfs[i] = pDoc->PieSegOfs(i);
//STRIP001 
//STRIP001 
//STRIP001 			SchUndoDiagramAutoPilot* pUndo =
//STRIP001 				new SchUndoDiagramAutoPilot(*pDoc, 
//STRIP001 					//	Old values.
//STRIP001 					eOldStyle,
//STRIP001 					pOldPieSegOfs, nOldPieSegCnt, 
//STRIP001 					bOldShowMainTitle, aOldMainTitle, 
//STRIP001 					bOldShowSubTitle, aOldSubTitle, 
//STRIP001 					bOldShowXAxisTitle, aOldXAxisTitle, 
//STRIP001 					bOldShowYAxisTitle, aOldYAxisTitle, 
//STRIP001 					bOldShowZAxisTitle, aOldZAxisTitle, 
//STRIP001 					bOldShowXAxis, bOldShowXGridMain, bOldShowXGridHelp, bOldShowXDescr,
//STRIP001 					bOldShowYAxis, bOldShowYGridMain, bOldShowYGridHelp, bOldShowYDescr,
//STRIP001 					bOldShowZAxis, bOldShowZGridMain, bOldShowZGridHelp, bOldShowZDescr,
//STRIP001 					bOldSwitchData,
//STRIP001 					eOldLegendPos,
//STRIP001 					//	New values.
//STRIP001 					eNewStyle,
//STRIP001 					pNewPieSegOfs, nNewPieSegCnt,
//STRIP001 					bNewShowMainTitle, aNewMainTitle,
//STRIP001 					bNewShowSubTitle, aNewSubTitle,
//STRIP001 					bNewShowXAxisTitle, aNewXAxisTitle,
//STRIP001 					bNewShowYAxisTitle, aNewYAxisTitle,
//STRIP001 					bNewShowZAxisTitle, aNewZAxisTitle,
//STRIP001 					bNewShowXAxis, bNewShowXGridMain, bNewShowXGridHelp, bNewShowXDescr,
//STRIP001 					bNewShowYAxis, bNewShowYGridMain, bNewShowYGridHelp, bNewShowYDescr,
//STRIP001 					bNewShowZAxis, bNewShowZGridMain, bNewShowZGridHelp, bNewShowZDescr,
//STRIP001 					bNewSwitchData,
//STRIP001 					bNewShowLegend);
//STRIP001 					
//STRIP001 			pUndo->SetComment(String(SchResId(STR_UNDO_AUTOFORMAT)));
//STRIP001 
//STRIP001 			pViewSh->GetViewFrame()->GetObjectShell()->
//STRIP001 				GetUndoManager()->AddUndoAction(pUndo);
//STRIP001 
//STRIP001 			return;
//STRIP001 		}
//STRIP001 	}
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SchFuDiagramAutoPilot::Activate()
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SchFuDiagramAutoPilot::Deactivate()
//STRIP001 {
//STRIP001 }



//STRIP001 void	SchFuDiagramAutoPilot::CheckRange	(ChartModel * pChartModel,
//STRIP001 											SvxChartStyle nStyle)
//STRIP001 {
//STRIP001 	SchRangeChecker	RangeChecker (pChartModel);
//STRIP001 	
//STRIP001 	if (RangeChecker.TestAbsoluteValues (nStyle))
//STRIP001 	{
//STRIP001 		InfoBox	aInfoBox (NULL, String(SchResId(STR_ONLY_ABS_VALUES)));
//STRIP001 		aInfoBox.Execute();
//STRIP001 	}
//STRIP001 	else if (RangeChecker.TestNegativeValues (nStyle))
//STRIP001 	{
//STRIP001 		InfoBox	aInfoBox (NULL, String(SchResId(STR_NO_MIN_VALUES)));
//STRIP001 		aInfoBox.Execute();
//STRIP001 	}
//STRIP001 
//STRIP001 	if (RangeChecker.TestLogarithmicValues ())
//STRIP001 	{
//STRIP001 		InfoBox	aInfoBox (NULL,String(SchResId(STR_NO_LOGARITHMIC_MIN_VALUES)));
//STRIP001 		aInfoBox.Execute();
//STRIP001 	}
//STRIP001 }
}
