/*************************************************************************
 *
 *  $RCSfile: sch_fuinsleg.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:58:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop
// auto strip #include <bf_svx/flstitem.hxx>
// auto strip #ifndef _CTRLTOOL_HXX //autogen
// auto strip #include <svtools/ctrltool.hxx>
// auto strip #endif
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif
// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_OBJSH_HXX //autogen
// auto strip #include <bf_sfx2/objsh.hxx>
// auto strip #endif

#include "schattr.hxx"
#define ITEMID_CHARTLEGENDPOS	SCHATTR_LEGEND_POS

#ifndef _SFXENUMITEM_HXX
#include <svtools/eitem.hxx>
#endif

// auto strip #include <bf_svx/chrtitem.hxx>

#include "app.hrc"
// auto strip #ifndef _CHTMODEL_HXX
// auto strip #include "chtmodel.hxx"
// auto strip #endif
// auto strip #include "viewshel.hxx"
// auto strip #include "schresid.hxx"
#include "strings.hrc"
// auto strip #include "legend.hxx"
// auto strip #include "uninsleg.hxx"
// auto strip #include "fuinsleg.hxx"
namespace binfilter {

//STRIP001 TYPEINIT1(SchFuInsertLegend, SchFuPoor);


/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

//STRIP001 SchFuInsertLegend::SchFuInsertLegend(SchViewShell* pViewSh, SchWindow* pWin,
//STRIP001 									 SchView* pView, ChartModel* pDoc,
//STRIP001 									 SfxRequest& rReq) :
//STRIP001 	SchFuPoor(pViewSh, pWin, pView, pDoc, rReq)
//STRIP001 {
//STRIP001 	nMarkedID           = 0;
//STRIP001 
//STRIP001 	const SfxItemSet* pArgs = rReq.GetArgs();
//STRIP001 	SfxItemSet aAttr(pDoc->GetFullLegendAttr());
//STRIP001 	
//STRIP001 	//	Determine current position of the legend.
//STRIP001 	const SfxPoolItem * pLegendPosItem = aAttr.GetItem (SCHATTR_LEGEND_POS);
//STRIP001 	SvxChartLegendPos eOldPos = pLegendPosItem!=NULL 
//STRIP001 		? static_cast<const SvxChartLegendPosItem*>(pLegendPosItem)->GetValue()
//STRIP001 		: CHLEGEND_NONE;
//STRIP001 	if (!pDoc->GetShowLegend ())
//STRIP001 		eOldPos = CHLEGEND_NONE;
//STRIP001 
//STRIP001 	if (!pArgs)
//STRIP001 	{
//STRIP001 //      FG: Mit dieser Zeile erhaelt man keinen modalen Dialog => Absturz falls ein Resize im Chart
//STRIP001 //      stattfindet waehrend dieser Dialog geoeffnet ist.
//STRIP001 //  		SchLegendDlg* pDlg = new SchLegendDlg(&pViewSh->GetViewFrame()->GetWindow(), aAttr);
//STRIP001 		SchLegendDlg* pDlg = new SchLegendDlg(NULL, aAttr);
//STRIP001 
//STRIP001 		if (pDlg->Execute() == RET_OK)
//STRIP001 		{
//STRIP001 			pDlg->GetAttr(aAttr);
//STRIP001 			rReq.Done(aAttr);
//STRIP001 			pArgs = rReq.GetArgs();
//STRIP001 			delete pDlg;
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			delete pDlg;
//STRIP001 			return;
//STRIP001 		}
//STRIP001 
//STRIP001 		pChDoc->CanRebuild (TRUE);
//STRIP001 	}
//STRIP001 	else pChDoc->CanRebuild (FALSE);
//STRIP001 
//STRIP001 	pViewSh->GetViewFrame()->GetDispatcher()->Execute(SID_TOOL_SELECT, SFX_CALLMODE_SYNCHRON);
//STRIP001 
//STRIP001 	SvxChartLegendPos eNewPos = ((const SvxChartLegendPosItem&)pArgs->Get(SCHATTR_LEGEND_POS)).GetValue();
//STRIP001 
//STRIP001 	if (eOldPos != eNewPos)
//STRIP001 	{
//STRIP001 		pDoc->SetLegendHasBeenMoved(FALSE);//#50913#
//STRIP001 		pDoc->SetShowLegend (eNewPos != CHLEGEND_NONE);
//STRIP001 		pDoc->ChangeLegendAttr(*pArgs);//, FALSE);
//STRIP001 		SchUndoInsertLegend* pUndo = new SchUndoInsertLegend(*pDoc, eOldPos, eNewPos, eOldPos != CHLEGEND_NONE,
//STRIP001 															 eNewPos != CHLEGEND_NONE);//#36258# != statt ==
//STRIP001 		pUndo->SetComment(String(SchResId(STR_UNDO_INSERT_LEGEND)));
//STRIP001 		pViewSh->GetViewFrame()->GetObjectShell()->GetUndoManager()->AddUndoAction(pUndo);
//STRIP001 	}
//STRIP001 
//STRIP001 	RemarkObject ();
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SchFuInsertLegend::Activate()
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SchFuInsertLegend::Deactivate()
//STRIP001 {
//STRIP001 }



}
