/*************************************************************************
 *
 *  $RCSfile: dgrdata.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:33:29 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SCH_DGRDATA_HXX
#define _SCH_DGRDATA_HXX

#ifndef _SFXLSTNER_HXX
#include <svtools/lstner.hxx>
#endif
#ifndef _STDCTRL_HXX
#include <svtools/stdctrl.hxx>
#endif
#ifndef _SV_TOOLBOX_HXX
#include <vcl/toolbox.hxx>
#endif
#ifndef _SFX_BINDINGS_HXX
#include <bf_sfx2/bindings.hxx>
#endif
#ifndef _SFX_CHILDWIN_HXX
#include <bf_sfx2/childwin.hxx>
#endif
#ifndef _BASEDLGS_HXX
#include <bf_sfx2/basedlgs.hxx>
#endif
#ifndef _COMPHELPER_STLTYPES_HXX_
#include <comphelper/stl_types.hxx>
#endif

#include "databrws.hxx"
namespace binfilter {

/** This is an implementation of SfxChildWindow.  Its purpose is to track and
    store the window position and size (stored in Views.xml)
 */
class SchDiagramDataWrapper : public SfxChildWindow
{
 public:
	SchDiagramDataWrapper(Window* pParent, USHORT nId,
						  SfxBindings* pBindings, SfxChildWinInfo* pInfo);

	SFX_DECL_CHILDWINDOW(SchDiagramDataWrapper);
};

/** This is the data edit dialog window
 */
//STRIP001 class SchDiagramDataWindow : public SfxFloatingWindow, public SfxListener
//STRIP001 {
//STRIP001 private:
//STRIP001 	BOOL                bReadOnly;
//STRIP001 	ChartDataBrowseBox	aBrwData;
//STRIP001 	ToolBox				aTbxData;
//STRIP001 	SfxBindings*		pBindings;
//STRIP001 
//STRIP001 	ImageList		maToolboxImageList;
//STRIP001 	ImageList		maToolboxImageListHighContrast;
//STRIP001 
//STRIP001     /// handles actions of the toolbox
//STRIP001 	DECL_LINK( ToolboxHdl, void* );
//STRIP001     /// is called, if the cursor of the table has moved
//STRIP001 	DECL_LINK( BrowserCursorMovedHdl, void*);
//STRIP001     /// this is called if MiscOptions change, esp. High-Contrast mode
//STRIP001     DECL_LINK( MiscHdl, void* );
//STRIP001     /// is called when the contents of the edit cell changes
//STRIP001     DECL_LINK( CellModified, void* );
//STRIP001 
//STRIP001 	void UpdateData();
//STRIP001     void Transfer ();
//STRIP001     void ApplyImageList();
//STRIP001 
    /** notifySystemWindow adds or remove the given window _pToRegister at the Systemwindow found when search _pWindow.
		@param	_pWindow
			The window which is used to search for the SystemWindow.
		@param	_pToRegister
			The window which should be added or removed on the TaskPaneList.
		@param	_rMemFunc
			The member function which should be called at the SystemWindow when found.
			Possible values are: 
			::comphelper::mem_fun(&TaskPaneList::AddWindow) 
			::comphelper::mem_fun(&TaskPaneList::RemoveWindow)

        @note this code is taken from dbaccess/source/ui/inc/UITools.hxx
	*/
//STRIP001 	void notifySystemWindow( Window* _pWindow,
//STRIP001                              Window* _pToRegister, 
//STRIP001                              ::comphelper::mem_fun1_t< TaskPaneList, Window* > _rMemFunc );
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void SFX_NOTIFY( SfxBroadcaster & rBC, const TypeId & rBCType,
//STRIP001                              const SfxHint & rHint, const TypeId & rHintType );
//STRIP001 	virtual void FillInfo( SfxChildWinInfo & ) const;
//STRIP001 
//STRIP001 public:
//STRIP001 	void SetReadOnly( const BOOL b );
//STRIP001 	SchDiagramDataWindow( Window* pParent, SfxBindings * pBind, SfxChildWindow * pChild );
//STRIP001 	virtual ~SchDiagramDataWindow();
//STRIP001 
//STRIP001     // FloatingWindow
//STRIP001 	virtual void Resize();
//STRIP001 
//STRIP001     // SystemWindow (base of FloatingWindow)
//STRIP001 	virtual BOOL Close();
//STRIP001 };

} //namespace binfilter
#endif	// _SCH_DGRDATA_HXX
