/*************************************************************************
 *
 *  $RCSfile: sch_viewshel.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:26:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
//------------------------------------------------------------------
//
// dieses Define dient nur zum Testen und darf auf keinen Fall aktiv bleiben
// Bei Umstellungen alle Files nach SIG_CHARTMODELDEFSCHDOC durchsuchen
// #define ChartModel SchChartDocument
//------------------------------------------------------------------
#pragma hdrstop

#define ITEMID_LRSPACE			EE_PARA_LRSPACE
#define ITEMID_ULSPACE			EE_PARA_ULSPACE

// auto strip #ifndef _B3D_BASE3D_HXX
// auto strip #include "goodies/base3d.hxx"
// auto strip #endif

// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif
// auto strip #ifndef _SFXSTBMGR_HXX //autogen
// auto strip #include <bf_sfx2/stbmgr.hxx>
// auto strip #endif
// auto strip #ifndef _CTRLTOOL_HXX //autogen
// auto strip #include <svtools/ctrltool.hxx>
// auto strip #endif
// auto strip #ifndef _SFXAPP_HXX //autogen
// auto strip #include <bf_sfx2/app.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif
// auto strip #include <bf_svx/flstitem.hxx>

#include <svtools/style.hrc>
#include <bf_svx/dialogs.hrc>

#include "res_bmp.hrc"
#include "viewshel.hxx"
#include "chwindow.hxx"
// auto strip #include "schview.hxx"
// auto strip #include "docshell.hxx"
// auto strip #include "fupoor.hxx"
// auto strip #include "eetext.hxx"

// auto strip #include "AccessibleDocumentView.hxx"
namespace binfilter {

/*************************************************************************
|*
|* Diese Methode deaktiviert und loescht die aktuelle Funktion. Falls es
|* eine alte Funktion gibt, wird sie als aktuelle Funktion eingesetzt und
|* aktiviert.
|*
\************************************************************************/

//STRIP001 void SchViewShell::Cancel()
//STRIP001 {
//STRIP001 	if (pFuActual)
//STRIP001 	{
//STRIP001 		SchFuPoor* pTemp = pFuActual;
//STRIP001 		pFuActual	  = NULL;
//STRIP001 		pTemp->Deactivate();
//STRIP001 		delete pTemp;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pFuOld)
//STRIP001 	{
//STRIP001 		pFuActual = pFuOld;
//STRIP001 		pFuActual->Activate();
//STRIP001 	}
//STRIP001 }

/*************************************************************************
|*
|* Aktivierung: Arbeitsfenster den Fokus zuweisen
|*
\************************************************************************/

//STRIP001 void SchViewShell::Activate(BOOL bIsMDIActivate)
//STRIP001 {
//STRIP001     SfxViewShell::Activate(bIsMDIActivate);
//STRIP001 	bFirstStart = FALSE;
//STRIP001 
//STRIP001 	if (pFuActual)
//STRIP001 		pFuActual->Activate();
//STRIP001 
//STRIP001 	pChView->UpdateSelectionClipboard( FALSE );
//STRIP001 
//STRIP001     // notify accessible document view
//STRIP001     SchWindow* pWin = GetWindow();
//STRIP001     if( pWin )
//STRIP001     {
//STRIP001         ::accessibility::AccessibleDocumentView * pAccDocView =
//STRIP001               pWin->GetAccessibleDocumentView();
//STRIP001 
//STRIP001         if( pAccDocView )
//STRIP001         {
//STRIP001             pAccDocView->GainFocus();
//STRIP001         }
//STRIP001     }
//STRIP001 }

/*************************************************************************
|*
|* Deaktivierung
|*
\************************************************************************/

//STRIP001 void SchViewShell::Deactivate(BOOL bIsMDIActivate)
//STRIP001 {
//STRIP001     if (pFuActual)
//STRIP001 		pFuActual->Deactivate();
//STRIP001 
//STRIP001 	if (bIsMDIActivate) GetView ()->EndTextEdit ();
//STRIP001 
//STRIP001 	SfxViewShell::Deactivate(bIsMDIActivate);
//STRIP001 
//STRIP001     // notify accessible document view
//STRIP001     SchWindow* pWin = GetWindow();
//STRIP001     if( pWin )
//STRIP001     {
//STRIP001         ::accessibility::AccessibleDocumentView * pAccDocView =
//STRIP001               pWin->GetAccessibleDocumentView();
//STRIP001 
//STRIP001         if( pAccDocView )
//STRIP001         {
//STRIP001             pAccDocView->LoseFocus();
//STRIP001         }
//STRIP001     }
//STRIP001 }

/*************************************************************************
|*
|* innere Groessenanpassung
|*
\************************************************************************/

//STRIP001 void SchViewShell::InnerResizePixel(const Point &rOfs, const Size &rSize)
//STRIP001 {
//STRIP001 	SchWindow* pWin = GetWindow();
//STRIP001 	pWin->SetViewSize(pWin->PixelToLogic(rSize));
//STRIP001 
//STRIP001 	SetBorderPixel(SvBorder());
//STRIP001 
//STRIP001 	GetView()->SetWorkArea(GetWindow()->PixelToLogic(Rectangle(Point(0,0), rSize)));
//STRIP001 }

/*************************************************************************
|*
|* aeussere Groessenanpassung
|*
\************************************************************************/

//STRIP001 void SchViewShell::OuterResizePixel(const Point &rOfs, const Size &rSize)
//STRIP001 {
//STRIP001 	SchWindow* pWin = GetWindow();
//STRIP001 	pWin->SetViewSize(pWin->PixelToLogic(rSize));
//STRIP001 
//STRIP001 	SetBorderPixel(SvBorder());
//STRIP001 
//STRIP001 	Rectangle aLogicRect = GetWindow()->PixelToLogic(Rectangle(rOfs, rSize));
//STRIP001 	Size aSize           = GetWindow ()->GetSizePixel ();
//STRIP001 	Size aOutputSize     = GetWindow ()->GetOutputSizePixel ();
//STRIP001 
//STRIP001 	if (aSize.Width () <= 50 && aSize.Height () <= 50 ||
//STRIP001 	aOutputSize.Width () <= 50 && aOutputSize.Height () <= 50) aLogicRect = Rectangle ();
//STRIP001 
//STRIP001 	((SchChartDocShell*)GetViewFrame()->GetObjectShell())->SetVisArea(aLogicRect);
//STRIP001 	GetView()->SetWorkArea(aLogicRect);
//STRIP001 }

/*************************************************************************
|*
|* Nur fuer MAC !?
|*
\************************************************************************/

//STRIP001 Size SchViewShell::GetOptimalSizePixel() const
//STRIP001 {
//STRIP001 	return Size(560, 320);
//STRIP001 }

/*************************************************************************
|*
|* Keyboard event
|*
\************************************************************************/

//STRIP001 FASTBOOL SchViewShell::KeyInput(const KeyEvent& rKEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = SfxViewShell::KeyInput(rKEvt);
//STRIP001 
//STRIP001 
//STRIP001 	if (!bReturn)
//STRIP001 	{
//STRIP001 		if (pFuActual)
//STRIP001 			bReturn = pFuActual->KeyInput(rKEvt);
//STRIP001 
//STRIP001 		if (!bReturn && GetWindow())
//STRIP001 		{
//STRIP001 			KeyCode aKeyCode = rKEvt.GetKeyCode();
//STRIP001 
//STRIP001 			if (aKeyCode.IsMod1() && aKeyCode.IsShift()
//STRIP001 				&& aKeyCode.GetCode() == KEY_R)
//STRIP001 			{
//STRIP001 				 // 3D-Kontext wieder zerstoeren
//STRIP001 				Base3D* pBase3D = (Base3D*) GetWindow()->Get3DContext();
//STRIP001 
//STRIP001 				if (pBase3D)
//STRIP001 				{
//STRIP001 					pBase3D->Destroy(GetWindow());
//STRIP001 				}
//STRIP001 				GetWindow()->Invalidate();
//STRIP001 				bReturn = TRUE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return bReturn;
//STRIP001 }

/*************************************************************************
|*
|* MouseButtonDown event
|*
\************************************************************************/

//STRIP001 FASTBOOL SchViewShell::MouseButtonDown(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	if ( MOUSE_LEFT == rMEvt.GetButtons() )
//STRIP001 		GetWindow()->GrabFocus();
//STRIP001 	if (pFuActual)
//STRIP001 	{
//STRIP001 		pFuActual->SetWindow(GetWindow());
//STRIP001 		return pFuActual->MouseButtonDown(rMEvt);
//STRIP001 	}
//STRIP001 
//STRIP001 	return FALSE;
//STRIP001 }

/*************************************************************************
|*
|* MouseMove event
|*
\************************************************************************/

//STRIP001 FASTBOOL SchViewShell::MouseMove(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	if (pFuActual)
//STRIP001 	{
//STRIP001 		pFuActual->SetWindow(GetWindow());
//STRIP001 		return pFuActual->MouseMove(rMEvt);
//STRIP001 	}
//STRIP001 
//STRIP001 	return FALSE;
//STRIP001 }

/*************************************************************************
|*
|* MouseButtonUp event
|*
\************************************************************************/

//STRIP001 FASTBOOL SchViewShell::MouseButtonUp(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	if (pFuActual)
//STRIP001 	{
//STRIP001 		pFuActual->SetWindow(GetWindow());
//STRIP001 		return pFuActual->MouseButtonUp(rMEvt);
//STRIP001 	}
//STRIP001 
//STRIP001 	return FALSE;
//STRIP001 }

/*************************************************************************
|*
|* Den Zoomfaktor setzen
|*
\************************************************************************/

/*N*/ void SchViewShell::SetZoom(long nZoom)
/*N*/ {
/*N*/ 	GetWindow()->SetZoom(nZoom);
/*N*/ }

/*************************************************************************
|*
|* ObjectBar umschalten, ResourceID der alten ObjectBar-ID zurueckgeben
|*
\************************************************************************/

/*N*/ USHORT SchViewShell::SwitchObjectBar(USHORT nResId)
/*N*/ {
/*N*/ 	USHORT nReturn = nCurrentObjectBar;
/*N*/ 
/*N*/ 	// muss Object Bar gewechselt werden?
/*N*/ 	if (nCurrentObjectBar != nResId && bObjectBarSwitchEnabled)
/*N*/ 	{
/*?*/ 		// SfxDispatcher* pDispatcher = GetViewFrame()->GetDispatcher();
/*?*/ 
/*?*/ 		if (nCurrentObjectBar)
/*?*/ 		{
/*?*/ 			// pDispatcher->Pop(*(SfxShell*)aShellTable.Get(nCurrentObjectBar));
/*?*/			DBG_BF_ASSERT(0, "STRIP"); //STRIP001 			SetSubShell( NULL );
/*?*/ 		}
/*?*/ 
/*?*/ 		nCurrentObjectBar = nResId;
/*?*/ 
/*?*/ 		if (nCurrentObjectBar)
/*?*/ 		{
/*?*/ 			// pDispatcher->Push(*(SfxShell*)aShellTable.Get(nCurrentObjectBar));
/*?*/ 			DBG_BF_ASSERT(0, "STRIP"); //STRIP001 	SetSubShell( (SfxShell*) aShellTable.Get( nCurrentObjectBar ) );
/*?*/ 		}
/*N*/ 	}
/*N*/ 	return nReturn;
/*N*/ }

/*************************************************************************
|*
|* Auf allen Split-Windows ein Markierungsrechteck zeichnen
|*
\************************************************************************/

#ifndef NOOLDSV

//STRIP001 void SchViewShell::DrawMarkRect(const Rectangle& rRect, const Pen& rPen)
//STRIP001 {
//STRIP001 	SchWindow* pWin = GetWindow();
//STRIP001 
//STRIP001 	RasterOp aROp = pWin->GetRasterOp();
//STRIP001 	pWin->SetRasterOp(ROP_INVERT);
//STRIP001 	Pen aPen	  = pWin->GetPen();
//STRIP001 	pWin->SetPen(rPen);
//STRIP001 	Brush aBrush  = pWin->GetFillInBrush();
//STRIP001 	pWin->SetFillInBrush(BRUSH_NULL);
//STRIP001 	pWin->DrawRect(rRect);
//STRIP001 	pWin->SetRasterOp(aROp);
//STRIP001 	pWin->SetPen(aPen);
//STRIP001 	pWin->SetFillInBrush(aBrush);
//STRIP001 }

#endif

//STRIP001 void SchViewShell::DrawMarkRect(const Rectangle& rRect, const Color& rColor )
//STRIP001 {
//STRIP001 	SchWindow* pWin = GetWindow();
//STRIP001 
//STRIP001 	RasterOp aROp = pWin->GetRasterOp();
//STRIP001 	pWin->SetRasterOp(ROP_INVERT);
//STRIP001 
//STRIP001 	Color aOldLineColor( pWin->GetLineColor() );
//STRIP001 	pWin->SetLineColor( rColor );
//STRIP001 	Color aOldFillColor( pWin->GetFillColor() );
//STRIP001 	pWin->SetFillColor();
//STRIP001 	pWin->DrawRect(rRect);
//STRIP001 	pWin->SetRasterOp(aROp);
//STRIP001 	pWin->SetLineColor( aOldLineColor );
//STRIP001 	pWin->SetFillColor( aOldFillColor );
//STRIP001 }

/*************************************************************************
|*
|* Auf allen Split-Windows ein Rechteck zeichnen.
|*
\************************************************************************/

#ifndef NOOLDSV

//STRIP001 void SchViewShell::DrawFilledRect(const Rectangle& rRect, const Pen& rPen,
//STRIP001 								 const Brush& rFillInBrush) const
//STRIP001 {
//STRIP001 	SchWindow* pWin = GetWindow();
//STRIP001 
//STRIP001 	Pen aPen	 = pWin->GetPen();
//STRIP001 	pWin->SetPen(rPen);
//STRIP001 	Brush aBrush = pWin->GetFillInBrush();
//STRIP001 	pWin->SetFillInBrush(rFillInBrush);
//STRIP001 	pWin->DrawRect(rRect);
//STRIP001 	pWin->SetPen(aPen);
//STRIP001 	pWin->SetFillInBrush(aBrush);
//STRIP001 }

#endif

//STRIP001 void SchViewShell::DrawFilledRect(const Rectangle& rRect, const Color& rColor,
//STRIP001 								 const Color& rFillColor ) const
//STRIP001 {
//STRIP001 	SchWindow* pWin = GetWindow();
//STRIP001 
//STRIP001 	Color aOldLineColor( pWin->GetLineColor() );
//STRIP001 	Color aOldFillColor( pWin->GetFillColor() );
//STRIP001 	pWin->SetLineColor( rColor );
//STRIP001 	pWin->SetFillColor( rFillColor );
//STRIP001 
//STRIP001 	pWin->DrawRect(rRect);
//STRIP001 	
//STRIP001 	pWin->SetLineColor( aOldLineColor );
//STRIP001 	pWin->SetFillColor( aOldFillColor );
//STRIP001 }

/*************************************************************************
|*
|* Zoom-Faktor fuer InPlace einstellen
|*
\************************************************************************/

//STRIP001 void SchViewShell::SetZoomFactor(const Fraction& rZoomX,
//STRIP001 								 const Fraction& rZoomY)
//STRIP001 {
//STRIP001 	long nZoom = (long)((double) rZoomX * 100);
//STRIP001 	SetZoom(nZoom);
//STRIP001 }


// ========================================
// DropTargetHelper for drag and drop
// ========================================

//STRIP001 sal_Int8 SchViewShell::AcceptDrop( const AcceptDropEvent& rEvt, SchWindow* pWin )
//STRIP001 {
//STRIP001 	if( pChView )
//STRIP001 		return pChView->AcceptDrop( rEvt, pWin );
//STRIP001 
//STRIP001 	return DND_ACTION_NONE;
//STRIP001 }

//STRIP001 sal_Int8 SchViewShell::ExecuteDrop( const ExecuteDropEvent& rEvt, SchWindow* pWin )
//STRIP001 {
//STRIP001 	if( pChView )
//STRIP001 		return pChView->ExecuteDrop( rEvt, pWin );
//STRIP001 
//STRIP001 	return DND_ACTION_NONE;
//STRIP001 }
}
