/*************************************************************************
 *
 *  $RCSfile: sd_tbxww.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:34:29 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

// auto strip #include <bf_sfx2/bindings.hxx>
#include <bf_svx/svxids.hrc>
#include <bf_svx/grafctrl.hxx>
// auto strip #ifndef _SVTOOLS_CJKOPTIONS_HXX
// auto strip #include <svtools/cjkoptions.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWSH_HXX
// auto strip #include <bf_sfx2/viewsh.hxx>
// auto strip #endif

// auto strip #include "sddll.hxx"
// auto strip #include "grdocsh.hxx"

// auto strip #include "app.hxx"
#include "app.hrc"
#include "res_bmp.hrc"
// auto strip #include "sdresid.hxx"

#ifndef _SVTOOLS_IMGDEF_HXX
#include <svtools/imgdef.hxx>
#endif

#include "tbx_ww.hxx"
#include "tbx_ww.hrc"
namespace binfilter {

/*N*/ SFX_IMPL_TOOLBOX_CONTROL( SdTbxControl, TbxImageItem )

/*************************************************************************
|*
|* PopUp-Window
|*
\************************************************************************/

//STRIP001 SdPopupWindowTbx::SdPopupWindowTbx( USHORT nId, WindowAlign eAlign,
//STRIP001                                     SdResId aRIdWin, SdResId aRIdTbx,
//STRIP001 									SfxBindings& rBindings ) :
//STRIP001 				SfxPopupWindow	( nId, aRIdWin, rBindings ),
//STRIP001                 aTbx            ( this, GetBindings(), aRIdTbx ),
//STRIP001                 aSdResIdWin       ( aRIdWin ),
//STRIP001                 aSdResIdTbx       ( aRIdTbx ),
//STRIP001 				eTbxAlign		( eAlign )
//STRIP001 {
//STRIP001 	aTbx.UseDefault();
//STRIP001 	aSelectLink = aTbx.GetToolBox().GetSelectHdl();
//STRIP001 	aTbx.GetToolBox().SetSelectHdl( LINK( this, SdPopupWindowTbx, TbxSelectHdl ) );
//STRIP001 
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	if( ( eAlign == WINDOWALIGN_TOP ) || ( eAlign == WINDOWALIGN_BOTTOM ) )
//STRIP001 	{
//STRIP001         if ( aSdResIdWin.GetId() != RID_TEXT )
//STRIP001 	        aTbx.GetToolBox().SetAlign( WINDOWALIGN_LEFT );
//STRIP001 	    
//STRIP001         SetText( String() );
//STRIP001 	}
//STRIP001 
//STRIP001     AdaptToCTL();
//STRIP001 }


//STRIP001 void SdPopupWindowTbx::AdaptToCTL (void)
//STRIP001 {
//STRIP001 	Size aSize = aTbx.CalcWindowSizePixel();
//STRIP001 	if (aSdResIdWin.GetId() == RID_TEXT)
//STRIP001 	{
//STRIP001         SvtCJKOptions aCJKOptions;
//STRIP001         if ( ! aCJKOptions.IsVerticalTextEnabled())
//STRIP001         {
//STRIP001             ToolBox& aToolBox = aTbx.GetToolBox();
//STRIP001 
//STRIP001             // Iterate over all tool box items and remove those that are
//STRIP001             // specific to complex text layout.
//STRIP001             USHORT i=0;
//STRIP001             while (i < aToolBox.GetItemCount())
//STRIP001             {
//STRIP001                 USHORT nIndex = aToolBox.GetItemId(i);
//STRIP001                 switch (nIndex)
//STRIP001                 {
//STRIP001                     case 0: // Line break.
//STRIP001                     case SID_ATTR_CHAR_VERTICAL:
//STRIP001                     case SID_TEXT_FITTOSIZE_VERTICAL:
//STRIP001                     case SID_DRAW_CAPTION_VERTICAL:
//STRIP001                         aToolBox.RemoveItem (i);
//STRIP001                         break;
//STRIP001 
//STRIP001                     default:
//STRIP001                         // Leave the item unmodified.  Advance to the next one.
//STRIP001                         i+=1;
//STRIP001                 }
//STRIP001             }
//STRIP001             aToolBox.RecalcItems();
//STRIP001             // Why is this necessary?
//STRIP001             aToolBox.SetLineCount(1);
//STRIP001             USHORT nLineCount = aToolBox.GetLineCount();
//STRIP001             aSize = aToolBox.CalcWindowSizePixel(nLineCount);
//STRIP001         }
//STRIP001     }
//STRIP001 	aTbx.SetPosSizePixel( Point(), aSize );
//STRIP001 	SetOutputSizePixel( aSize );
//STRIP001 }


/*-------------------------------------------------------------------------*/

//STRIP001 SdPopupWindowTbx::~SdPopupWindowTbx()
//STRIP001 {
//STRIP001 }

/*-------------------------------------------------------------------------*/

//STRIP001 SfxPopupWindow* SdPopupWindowTbx::Clone() const
//STRIP001 {
//STRIP001 	SfxBindings& rBindings = (SfxBindings&)GetBindings();
//STRIP001 
//STRIP001 	return( new SdPopupWindowTbx( GetId(), eTbxAlign,
//STRIP001                     aSdResIdWin, aSdResIdTbx, rBindings ) );
//STRIP001 
//STRIP001 	//return( SfxPopupWindow::Clone() );
//STRIP001 }

/*-------------------------------------------------------------------------*/

//STRIP001 void SdPopupWindowTbx::Update()
//STRIP001 {
//STRIP001     AdaptToCTL();
//STRIP001 
//STRIP001 	ToolBox *pBox = &aTbx.GetToolBox();
//STRIP001 	aTbx.Activate( pBox );
//STRIP001 	aTbx.Deactivate( pBox );
//STRIP001 }
//STRIP001 
/*-------------------------------------------------------------------------*/
//STRIP001 void SdPopupWindowTbx::PopupModeEnd()
//STRIP001 {
//STRIP001 	aTbx.GetToolBox().EndSelection();
//STRIP001 
//STRIP001 	SfxPopupWindow::PopupModeEnd();
//STRIP001 }

/*-------------------------------------------------------------------------*/
//STRIP001 IMPL_LINK( SdPopupWindowTbx, TbxSelectHdl, ToolBox*, pBox)
//STRIP001 {
//STRIP001 	if( IsInPopupMode() )
//STRIP001 		EndPopupMode();
//STRIP001 
//STRIP001 	aSelectLink.Call( &aTbx.GetToolBox() );
//STRIP001 
//STRIP001 	if ( pBox->GetModifier() & KEY_MOD1 )
//STRIP001 	{
//STRIP001 		//	#99013# if selected with control key, return focus to current view
//STRIP001 		Window* pShellWnd = SfxViewShell::Current()->GetWindow();
//STRIP001 		if ( pShellWnd )
//STRIP001 			pShellWnd->GrabFocus();
//STRIP001 	}
//STRIP001 
//STRIP001 	return( 0L );
//STRIP001 }

/*************************************************************************
|*
|* Klasse fuer Toolbox
|*
\************************************************************************/

//STRIP001 SdTbxControl::SdTbxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind ) :
//STRIP001 		SfxToolBoxControl( nId, rTbx, rBind )
//STRIP001 {
//STRIP001 }

/*-------------------------------------------------------------------------*/

//STRIP001 SfxPopupWindowType SdTbxControl::GetPopupWindowType() const
//STRIP001 {
//STRIP001 	return( SFX_POPUPWINDOW_ONTIMEOUT );
//STRIP001 }

/*************************************************************************
|*
|* Hier wird das Fenster erzeugt
|* Lage der Toolbox mit GetToolBox() abfragbar
|* rItemRect sind die Screen-Koordinaten
|*
\************************************************************************/

//STRIP001 SfxPopupWindow*	SdTbxControl::CreatePopupWindow()
//STRIP001 {
//STRIP001 	SdPopupWindowTbx *pWin = NULL;
//STRIP001 
//STRIP001 	switch( GetId() )
//STRIP001 	{
//STRIP001 		case SID_OBJECT_ALIGN:
//STRIP001 		{
//STRIP001 			pWin = new SdPopupWindowTbx( GetId(), this->GetToolBox().GetAlign(),
//STRIP001                     SdResId( RID_ALIGNMENT ),
//STRIP001                     SdResId( RID_ALIGNMENT_TBX ), GetBindings() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_ZOOM_TOOLBOX:
//STRIP001 		{
//STRIP001 			pWin = new SdPopupWindowTbx( GetId(), this->GetToolBox().GetAlign(),
//STRIP001                     SdResId( RID_ZOOM ),
//STRIP001                     SdResId( RID_ZOOM_TBX ), GetBindings() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_OBJECT_CHOOSE_MODE:
//STRIP001 		{
//STRIP001 			pWin = new SdPopupWindowTbx(  GetId(), this->GetToolBox().GetAlign(),
//STRIP001                     SdResId( RID_CHOOSE_MODE ),
//STRIP001                     SdResId( RID_CHOOSE_MODE_TBX ), GetBindings() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_POSITION:
//STRIP001 		{
//STRIP001 			pWin = new SdPopupWindowTbx(  GetId(), this->GetToolBox().GetAlign(),
//STRIP001                     SdResId( RID_POSITION ),
//STRIP001                     SdResId( RID_POSITION_TBX ), GetBindings() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DRAWTBX_TEXT:
//STRIP001 		{
//STRIP001 			pWin = new SdPopupWindowTbx( GetId(), this->GetToolBox().GetAlign(),
//STRIP001                     SdResId( RID_TEXT ),
//STRIP001                     SdResId( RID_TEXT_TBX ), GetBindings() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DRAWTBX_RECTANGLES:
//STRIP001 		{
//STRIP001 			pWin = new SdPopupWindowTbx( GetId(), this->GetToolBox().GetAlign(),
//STRIP001                     SdResId( RID_RECTANGLES ),
//STRIP001                     SdResId( RID_RECTANGLES_TBX ), GetBindings() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DRAWTBX_ELLIPSES:
//STRIP001 		{
//STRIP001 			pWin = new SdPopupWindowTbx( GetId(), this->GetToolBox().GetAlign(),
//STRIP001                     SdResId( RID_ELLIPSES ),
//STRIP001                     SdResId( RID_ELLIPSES_TBX ), GetBindings() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DRAWTBX_LINES:
//STRIP001 		{
//STRIP001 			pWin = new SdPopupWindowTbx( GetId(), this->GetToolBox().GetAlign(),
//STRIP001                     SdResId( RID_LINES ),
//STRIP001                     SdResId( RID_LINES_TBX ), GetBindings() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DRAWTBX_ARROWS:
//STRIP001 		{
//STRIP001 			pWin = new SdPopupWindowTbx( GetId(), this->GetToolBox().GetAlign(),
//STRIP001                     SdResId( RID_ARROWS ),
//STRIP001                     SdResId( RID_ARROWS_TBX ), GetBindings() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DRAWTBX_3D_OBJECTS:
//STRIP001 		{
//STRIP001 			pWin = new SdPopupWindowTbx( GetId(), this->GetToolBox().GetAlign(),
//STRIP001                     SdResId( RID_3D_OBJECTS ),
//STRIP001                     SdResId( RID_3D_OBJECTS_TBX ), GetBindings() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001         case SID_DRAWTBX_CONNECTORS:
//STRIP001 		{
//STRIP001 			pWin = new SdPopupWindowTbx( GetId(), this->GetToolBox().GetAlign(),
//STRIP001                     SdResId( RID_CONNECTORS ),
//STRIP001                     SdResId( RID_CONNECTORS_TBX ), GetBindings() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001         case SID_DRAWTBX_INSERT:
//STRIP001 		{
//STRIP001 			pWin = new SdPopupWindowTbx( GetId(), this->GetToolBox().GetAlign(),
//STRIP001                     SdResId( RID_INSERT ),
//STRIP001                     SdResId( RID_INSERT_TBX ), GetBindings() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 	}
//STRIP001 	if( pWin )
//STRIP001 	{
//STRIP001 		pWin->StartPopupMode( &GetToolBox(), TRUE );
//STRIP001 		pWin->Update();
//STRIP001 		pWin->StartSelection();
//STRIP001 		pWin->Show();
//STRIP001 	}
//STRIP001 	return( pWin );
//STRIP001 }

/*-------------------------------------------------------------------------*/

//STRIP001 void SdTbxControl::StateChanged( USHORT nSId,
//STRIP001 						SfxItemState eState, const SfxPoolItem* pState )
//STRIP001 {
//STRIP001 	SfxToolBoxControl::StateChanged( nSId, eState, pState );
//STRIP001 
//STRIP001 	if( eState == SFX_ITEM_AVAILABLE )
//STRIP001 	{
//STRIP001 		TbxImageItem* pItem = PTR_CAST( TbxImageItem, pState );
//STRIP001 		//DBG_ASSERT( pItem, "TbxImageItem erwartet!" );
//STRIP001 		// Im StarDesktop kann jetzt auch ein anderes Item ankommen,
//STRIP001 		// das nicht ausgewertet werden darf (#33802# und #33838#)
//STRIP001 		if( pItem )
//STRIP001 		{
//STRIP001 			ToolBox& rTbx = GetToolBox();
//STRIP001 			USHORT nImage = pItem->GetValue();
//STRIP001 			if( nImage == 0 )
//STRIP001 			{
//STRIP001 				if( rTbx.IsItemChecked( nSId ) )
//STRIP001 					rTbx.CheckItem( nSId, FALSE );
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				Image  aImage = GetBindings().GetImageManager()->GetImage( nImage, rTbx.GetDisplayBackground().GetColor().IsDark(), SD_MOD() );
//STRIP001 				// Es kann u.U. ein Default-Image zurueckgegeben werden,
//STRIP001 				// welches eine Breite von 0 haben soll
//STRIP001 				// if( aImage.GetSizePixel().Width() > 0 )
//STRIP001 				// !-Operator prueft, ob Image nicht vorhanden ist
//STRIP001 				if( !!aImage )
//STRIP001 				{
//STRIP001 					rTbx.SetItemImage( nSId, aImage );
//STRIP001 					rTbx.CheckItem( nSId, IsCheckable( nImage ) );
//STRIP001 
//STRIP001 					if( nSId != SID_ZOOM_TOOLBOX &&
//STRIP001 						nSId != SID_DRAWTBX_INSERT &&
//STRIP001 						nSId != SID_POSITION &&
//STRIP001 						nSId != SID_OBJECT_ALIGN )
//STRIP001 					{
//STRIP001 						if( nSId != SID_OBJECT_CHOOSE_MODE &&
//STRIP001 							rTbx.IsItemChecked( SID_OBJECT_CHOOSE_MODE ) )
//STRIP001 							rTbx.CheckItem( SID_OBJECT_CHOOSE_MODE, FALSE );
//STRIP001 						if( nSId != SID_DRAWTBX_TEXT &&
//STRIP001 							rTbx.IsItemChecked( SID_DRAWTBX_TEXT ) )
//STRIP001 			 				rTbx.CheckItem( SID_DRAWTBX_TEXT, FALSE );
//STRIP001 						if( nSId != SID_DRAWTBX_RECTANGLES &&
//STRIP001 							rTbx.IsItemChecked( SID_DRAWTBX_RECTANGLES ) )
//STRIP001 			   				rTbx.CheckItem( SID_DRAWTBX_RECTANGLES, FALSE );
//STRIP001 						if( nSId != SID_DRAWTBX_ELLIPSES &&
//STRIP001 							rTbx.IsItemChecked( SID_DRAWTBX_ELLIPSES ) )
//STRIP001 			   				rTbx.CheckItem( SID_DRAWTBX_ELLIPSES, FALSE );
//STRIP001 						if( nSId != SID_DRAWTBX_LINES &&
//STRIP001 							rTbx.IsItemChecked( SID_DRAWTBX_LINES ) )
//STRIP001 							rTbx.CheckItem( SID_DRAWTBX_LINES, FALSE );
//STRIP001 						if( nSId != SID_DRAWTBX_ARROWS &&
//STRIP001 							rTbx.IsItemChecked( SID_DRAWTBX_ARROWS ) )
//STRIP001 							rTbx.CheckItem( SID_DRAWTBX_ARROWS, FALSE );
//STRIP001 						if( nSId != SID_DRAWTBX_3D_OBJECTS &&
//STRIP001 							rTbx.IsItemChecked( SID_DRAWTBX_3D_OBJECTS ) )
//STRIP001 							rTbx.CheckItem( SID_DRAWTBX_3D_OBJECTS, FALSE );
//STRIP001                         if( nSId != SID_DRAWTBX_CONNECTORS &&
//STRIP001                             rTbx.IsItemChecked( SID_DRAWTBX_CONNECTORS ) )
//STRIP001                             rTbx.CheckItem( SID_DRAWTBX_CONNECTORS, FALSE );
//STRIP001                     }
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }

/*-------------------------------------------------------------------------*/

//STRIP001 BOOL SdTbxControl::IsCheckable( USHORT nSId )
//STRIP001 {
//STRIP001 	switch( nSId )
//STRIP001 	{
//STRIP001 		case SID_OBJECT_ROTATE:
//STRIP001 		case SID_OBJECT_MIRROR:
//STRIP001 		case SID_OBJECT_TRANSPARENCE:
//STRIP001 		case SID_OBJECT_GRADIENT:
//STRIP001 		case SID_OBJECT_SHEAR:
//STRIP001 		case SID_OBJECT_CROOK_ROTATE:
//STRIP001 		case SID_OBJECT_CROOK_SLANT:
//STRIP001 		case SID_OBJECT_CROOK_STRETCH:
//STRIP001         case SID_CONVERT_TO_3D_LATHE:
//STRIP001 
//STRIP001 		case SID_ATTR_CHAR:
//STRIP001 		case SID_ATTR_CHAR_VERTICAL:
//STRIP001 		case SID_TEXT_FITTOSIZE:
//STRIP001 		case SID_TEXT_FITTOSIZE_VERTICAL:
//STRIP001 		case SID_DRAW_CAPTION:
//STRIP001 		case SID_DRAW_CAPTION_VERTICAL:
//STRIP001 
//STRIP001 		case SID_DRAW_RECT:
//STRIP001 		case SID_DRAW_SQUARE:
//STRIP001 		case SID_DRAW_RECT_ROUND:
//STRIP001 		case SID_DRAW_SQUARE_ROUND:
//STRIP001 		case SID_DRAW_RECT_NOFILL:
//STRIP001 		case SID_DRAW_SQUARE_NOFILL:
//STRIP001 		case SID_DRAW_RECT_ROUND_NOFILL:
//STRIP001 		case SID_DRAW_SQUARE_ROUND_NOFILL:
//STRIP001 
//STRIP001 		case SID_DRAW_ELLIPSE:
//STRIP001 		case SID_DRAW_CIRCLE:
//STRIP001 		case SID_DRAW_PIE:
//STRIP001 		case SID_DRAW_CIRCLEPIE:
//STRIP001 		case SID_DRAW_ELLIPSECUT:
//STRIP001 		case SID_DRAW_CIRCLECUT:
//STRIP001 		case SID_DRAW_ARC:
//STRIP001 		case SID_DRAW_CIRCLEARC:
//STRIP001 		case SID_DRAW_ELLIPSE_NOFILL:
//STRIP001 		case SID_DRAW_CIRCLE_NOFILL:
//STRIP001 		case SID_DRAW_PIE_NOFILL:
//STRIP001 		case SID_DRAW_CIRCLEPIE_NOFILL:
//STRIP001 		case SID_DRAW_ELLIPSECUT_NOFILL:
//STRIP001 		case SID_DRAW_CIRCLECUT_NOFILL:
//STRIP001 
//STRIP001         case SID_DRAW_BEZIER_NOFILL:
//STRIP001 		case SID_DRAW_POLYGON_NOFILL:
//STRIP001 		case SID_DRAW_XPOLYGON_NOFILL:
//STRIP001         case SID_DRAW_BEZIER_FILL:
//STRIP001 		case SID_DRAW_POLYGON:
//STRIP001 		case SID_DRAW_XPOLYGON:
//STRIP001         case SID_DRAW_FREELINE:
//STRIP001         case SID_DRAW_FREELINE_NOFILL:
//STRIP001 
//STRIP001 		case SID_DRAW_LINE:
//STRIP001 		case SID_DRAW_XLINE:
//STRIP001 		case SID_DRAW_MEASURELINE:
//STRIP001 		case SID_LINE_ARROW_START:
//STRIP001 		case SID_LINE_ARROW_END:
//STRIP001 		case SID_LINE_ARROWS:
//STRIP001 		case SID_LINE_ARROW_CIRCLE:
//STRIP001 		case SID_LINE_CIRCLE_ARROW:
//STRIP001 		case SID_LINE_ARROW_SQUARE:
//STRIP001 		case SID_LINE_SQUARE_ARROW:
//STRIP001 
//STRIP001 		case SID_3D_CUBE:
//STRIP001 		case SID_3D_SPHERE:
//STRIP001 		case SID_3D_CYLINDER:
//STRIP001 		case SID_3D_CONE:
//STRIP001 		case SID_3D_PYRAMID:
//STRIP001 		case SID_3D_TORUS:
//STRIP001 		case SID_3D_SHELL:
//STRIP001 		case SID_3D_HALF_SPHERE:
//STRIP001 
//STRIP001         case SID_TOOL_CONNECTOR:
//STRIP001         case SID_CONNECTOR_ARROW_START:
//STRIP001         case SID_CONNECTOR_ARROW_END:
//STRIP001         case SID_CONNECTOR_ARROWS:
//STRIP001         case SID_CONNECTOR_CIRCLE_START:
//STRIP001         case SID_CONNECTOR_CIRCLE_END:
//STRIP001         case SID_CONNECTOR_CIRCLES:
//STRIP001         case SID_CONNECTOR_LINE:
//STRIP001         case SID_CONNECTOR_LINE_ARROW_START:
//STRIP001         case SID_CONNECTOR_LINE_ARROW_END:
//STRIP001         case SID_CONNECTOR_LINE_ARROWS:
//STRIP001         case SID_CONNECTOR_LINE_CIRCLE_START:
//STRIP001         case SID_CONNECTOR_LINE_CIRCLE_END:
//STRIP001         case SID_CONNECTOR_LINE_CIRCLES:
//STRIP001         case SID_CONNECTOR_CURVE:
//STRIP001         case SID_CONNECTOR_CURVE_ARROW_START:
//STRIP001         case SID_CONNECTOR_CURVE_ARROW_END:
//STRIP001         case SID_CONNECTOR_CURVE_ARROWS:
//STRIP001         case SID_CONNECTOR_CURVE_CIRCLE_START:
//STRIP001         case SID_CONNECTOR_CURVE_CIRCLE_END:
//STRIP001         case SID_CONNECTOR_CURVE_CIRCLES:
//STRIP001         case SID_CONNECTOR_LINES:
//STRIP001         case SID_CONNECTOR_LINES_ARROW_START:
//STRIP001         case SID_CONNECTOR_LINES_ARROW_END:
//STRIP001         case SID_CONNECTOR_LINES_ARROWS:
//STRIP001         case SID_CONNECTOR_LINES_CIRCLE_START:
//STRIP001         case SID_CONNECTOR_LINES_CIRCLE_END:
//STRIP001         case SID_CONNECTOR_LINES_CIRCLES:
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 		//case SID_ZOOM_OUT:
//STRIP001 			return( TRUE );
//STRIP001 	}
//STRIP001 	return( FALSE );
//STRIP001 }



}
