/*************************************************************************
 *
 *  $RCSfile: sd_tpaction.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/01/11 11:32:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


// auto strip #ifndef _COM_SUN_STAR_PRESENTATION_ANIMATIONEFFECT_HPP_
// auto strip #include <com/sun/star/presentation/AnimationEffect.hpp>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_PRESENTATION_CLICKACTION_HPP_
// auto strip #include <com/sun/star/presentation/ClickAction.hpp>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_PRESENTATION_ANIMATIONSPEED_HPP_
// auto strip #include <com/sun/star/presentation/AnimationSpeed.hpp>
// auto strip #endif

#include "sdattr.hxx"

#define ITEMID_COLOR			ATTR_ANIMATION_COLOR
#define ITEMID_COLOR_TABLE		SID_COLOR_TABLE

// auto strip #ifndef _SV_WAITOBJ_HXX
// auto strip #include <vcl/waitobj.hxx>
// auto strip #endif

// auto strip #ifndef _OSL_FILE_HXX_
// auto strip #include <osl/file.hxx>
// auto strip #endif
// auto strip #include <bf_sfx2/app.hxx>
// auto strip #include <tools/urlobj.hxx>
// auto strip #ifndef INCLUDED_SVTOOLS_PATHOPTIONS_HXX
// auto strip #include <svtools/pathoptions.hxx>
// auto strip #endif
// auto strip #ifndef _SVDPAGV_HXX //autogen
// auto strip #include <bf_svx/svdpagv.hxx>
// auto strip #endif
// auto strip #ifndef _URLOBJ_HXX
// auto strip #include <tools/urlobj.hxx>
// auto strip #endif
// auto strip #ifndef _UNOTOOLS_LOCALFILEHELPER_HXX
// auto strip #include <unotools/localfilehelper.hxx>
// auto strip #endif
// auto strip #ifndef _AEITEM_HXX //autogen
// auto strip #include <svtools/aeitem.hxx>
// auto strip #endif
#ifndef _SVX_COLRITEM_HXX //autogen
#include <bf_svx/colritem.hxx>
#endif
// auto strip #ifndef _SVDOOLE2_HXX //autogen
// auto strip #include <bf_svx/svdoole2.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDOCFILE_HXX //autogen
// auto strip #include <bf_sfx2/docfile.hxx>
// auto strip #endif
// auto strip #ifndef _SVSTOR_HXX //autogen
// auto strip #include <so3/svstor.hxx>
// auto strip #endif
// auto strip #ifndef _SB_SBMETH_HXX //autogen
// auto strip #include <basic/sbmeth.hxx>
// auto strip #endif
// auto strip #ifndef _SB_SBMOD_HXX //autogen
// auto strip #include <basic/sbmod.hxx>
// auto strip #endif
// auto strip #ifndef _SB_SBSTAR_HXX //autogen
// auto strip #include <basic/sbstar.hxx>
// auto strip #endif
// auto strip #ifndef _XTABLE_HXX
// auto strip #include <bf_svx/xtable.hxx>
// auto strip #endif

// auto strip #ifndef _SV_SVAPP_HXX //autogen
// auto strip #include <vcl/svapp.hxx>
// auto strip #endif

// auto strip #ifndef SVTOOLS_URIHELPER_HXX
// auto strip #include <svtools/urihelper.hxx>
// auto strip #endif

// auto strip #ifndef _FILEDLGHELPER_HXX
// auto strip #include <bf_sfx2/filedlghelper.hxx>
// auto strip #endif

// auto strip #ifndef _SVX_DRAWITEM_HXX
// auto strip #include <bf_svx/drawitem.hxx>
// auto strip #endif

// auto strip #ifndef _OFF_APP_HXX //autogen
// auto strip #include <bf_offmgr/app.hxx>
// auto strip #endif

// auto strip #include "sdview.hxx"
// auto strip #include "sdresid.hxx"
// auto strip #include "tpaction.hxx"
#include "tpaction.hrc"
#include "strmname.h"
// auto strip #include "viewshel.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "docshell.hxx"
#include "strings.hrc"
#include "res_bmp.hrc"
// auto strip #include "filedlg.hxx"

#include <algorithm>
#include "so3/staticbaseurl.hxx"
namespace binfilter {

using namespace ::com::sun::star;

//STRIP001 static USHORT pActionRanges[] =
//STRIP001 {
//STRIP001 	ATTR_ANIMATION_TRANSPCOLOR,
//STRIP001 	ATTR_ANIMATION_TRANSPCOLOR,
//STRIP001 	ATTR_ACTION_START,
//STRIP001 	ATTR_ACTION_END,
//STRIP001 	0
//STRIP001 };
//STRIP001 
//STRIP001 static USHORT pEffectRanges[] =
//STRIP001 {
//STRIP001 	ATTR_ANIMATION_START,
//STRIP001 	ATTR_ANIMATION_END,
//STRIP001 	0
//STRIP001 };
//STRIP001 
//STRIP001 
//STRIP001 #define DOCUMENT_TOKEN (sal_Unicode('#'))
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor des Tab-Dialogs: Fuegt die Seiten zum Dialog hinzu
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdActionDlg::SdActionDlg( Window* pParent, const SfxItemSet* pAttr, SdView* pView ) :
//STRIP001 		SfxSingleTabDialog	( pParent, *pAttr, TP_ANIMATION_ACTION ),
//STRIP001 		rOutAttrs			( *pAttr )
//STRIP001 {
//STRIP001 	// FreeResource();
//STRIP001 	SfxTabPage* pPage = SdTPAction::Create( this, rOutAttrs );
//STRIP001 	DBG_ASSERT( pPage, "Seite konnte nicht erzeugt werden");
//STRIP001 
//STRIP001 	// Ehemals in PageCreated
//STRIP001 	( (SdTPAction*) pPage )->SetView( pView );
//STRIP001 	( (SdTPAction*) pPage )->Construct();
//STRIP001 
//STRIP001 	SetTabPage( pPage );
//STRIP001 
//STRIP001 	String aStr( pPage->GetText() );
//STRIP001 	if( aStr.Len() )
//STRIP001 		SetText( aStr );
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	Action-TabPage
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdTPAction::SdTPAction( Window* pWindow, const SfxItemSet& rInAttrs ) :
//STRIP001 		SfxTabPage  	( pWindow, SdResId( TP_ANIMATION ), rInAttrs ),
//STRIP001 
//STRIP001 		aFtAction   	( this, SdResId( FT_ACTION ) ),
//STRIP001 		aLbAction   	( this, SdResId( LB_ACTION ) ),
//STRIP001 		aFlEffect   	( this, SdResId( FL_EFFECT ) ),
//STRIP001 		aFtAnimation	( this, SdResId( FT_ANIMATION ) ),
//STRIP001 		aLbEffect   	( this, SdResId( LB_EFFECT ) ),
//STRIP001 		aFtSpeed    	( this, SdResId( FT_SPEED ) ),
//STRIP001 		aRbtSlow   	 	( this, SdResId( RBT_SLOW ) ),
//STRIP001 		aRbtMedium	  	( this, SdResId( RBT_MEDIUM ) ),
//STRIP001 		aRbtFast    	( this, SdResId( RBT_FAST ) ),
//STRIP001 		aTsbSound   	( this, SdResId( TSB_SOUND ) ),
//STRIP001 		aEdtSound   	( this, SdResId( EDT_SOUND ) ),
//STRIP001 		aBtnSearch		( this, SdResId( BTN_SEARCH ) ),
//STRIP001 		aTsbPlayFull	( this, SdResId( TSB_PLAY_FULL ) ),
//STRIP001 		aFtTree     	( this, SdResId( FT_TREE ) ),
//STRIP001 		aLbTree     	( this, SdResId( LB_TREE ) ),
//STRIP001 		aLbTreeDocument	( this, SdResId( LB_TREE_DOCUMENT ) ),
//STRIP001 		aLbOLEAction	( this, SdResId( LB_OLE_ACTION ) ),
//STRIP001 		aFlSeparator	( this, SdResId( FL_SEPARATOR ) ),
//STRIP001 		aEdtBookmark  	( this, SdResId( EDT_BOOKMARK ) ),
//STRIP001 		aEdtDocument	( this, SdResId( EDT_DOCUMENT ) ),
//STRIP001 		aEdtProgram     ( this, SdResId( EDT_PROGRAM ) ),
//STRIP001 		aEdtMacro       ( this, SdResId( EDT_MACRO ) ),
//STRIP001 		aBtnSeek    	( this, SdResId( BTN_SEEK ) ),
//STRIP001 
//STRIP001 		pView			( NULL ),
//STRIP001 		pDoc			( NULL ),
//STRIP001 		rOutAttrs		( rInAttrs ),
//STRIP001 		bTreeUpdated	( FALSE )
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aTsbSound.SetClickHdl( LINK( this, SdTPAction, ClickSoundHdl ) );
//STRIP001 	aLbEffect.SetSelectHdl( LINK( this, SdTPAction, ChangeEffectHdl ) );
//STRIP001 	aBtnSearch.SetClickHdl( LINK( this, SdTPAction, ClickSearchHdl ) );
//STRIP001 	aBtnSeek.SetClickHdl( LINK( this, SdTPAction, ClickSearchHdl ) );
//STRIP001 
//STRIP001 	// diese Page braucht ExchangeSupport
//STRIP001 	SetExchangeSupport();
//STRIP001 
//STRIP001 	pCurrentEffects = new List;
//STRIP001 	pCurrentActions = new List;
//STRIP001 
//STRIP001 	aLbAction.SetSelectHdl( LINK( this, SdTPAction, ClickActionHdl ) );
//STRIP001 	aLbTree.SetSelectHdl( LINK( this, SdTPAction, SelectTreeHdl ) );
//STRIP001 	aEdtDocument.SetLoseFocusHdl( LINK( this, SdTPAction, CheckFileHdl ) );
//STRIP001 	aEdtMacro.SetLoseFocusHdl( LINK( this, SdTPAction, CheckFileHdl ) );
//STRIP001 
//STRIP001 	// Controls enablen
//STRIP001 	aFtAction.Show();
//STRIP001 	aLbAction.Show();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SdTPAction::~SdTPAction()
//STRIP001 {
//STRIP001 	delete pCurrentEffects;
//STRIP001 	delete pCurrentActions;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SdTPAction::SetView( const SdView* pSdView )
//STRIP001 {
//STRIP001 	pView = pSdView;
//STRIP001 
//STRIP001 	// Holen der ColorTable und Fuellen der ListBox
//STRIP001 	SdDrawDocShell* pDocSh = ( (SdView*) pView )->GetDocSh();
//STRIP001 	pDoc = pDocSh->GetDoc();
//STRIP001 	SfxViewFrame* pFrame = pDocSh->GetViewShell()->GetViewFrame();
//STRIP001 	aLbTree.SetViewFrame( pFrame );
//STRIP001 	aLbTreeDocument.SetViewFrame( pFrame );
//STRIP001 
//STRIP001 	SvxColorTableItem aItem( *(const SvxColorTableItem*)( pDocSh->GetItem( SID_COLOR_TABLE ) ) );
//STRIP001 	pColTab = aItem.GetColorTable();
//STRIP001 	DBG_ASSERT( pColTab, "Keine Farbtabelle vorhanden!" );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SdTPAction::Construct()
//STRIP001 {
//STRIP001 	// OLE-Actionlistbox auffuellen
//STRIP001 	SdrOle2Obj* pOleObj = NULL;
//STRIP001 	SdrGrafObj* pGrafObj = NULL;
//STRIP001 	BOOL		bDisableAll = FALSE;
//STRIP001 	BOOL        bOLEAction = FALSE;
//STRIP001 
//STRIP001 	if ( pView->HasMarkedObj() )
//STRIP001 	{
//STRIP001 		const SdrMarkList& rMarkList = pView->GetMarkList();
//STRIP001 		SdrObject* pObj;
//STRIP001 
//STRIP001 		if (rMarkList.GetMarkCount() == 1)
//STRIP001 		{
//STRIP001 			SdrMark* pMark = rMarkList.GetMark(0);
//STRIP001 			pObj = pMark->GetObj();
//STRIP001 
//STRIP001 			UINT32 nInv = pObj->GetObjInventor();
//STRIP001 			UINT16 nSdrObjKind = pObj->GetObjIdentifier();
//STRIP001 
//STRIP001 			if (nInv == SdrInventor && nSdrObjKind == OBJ_OLE2)
//STRIP001 			{
//STRIP001 				pOleObj = (SdrOle2Obj*) pObj;
//STRIP001 			}
//STRIP001 			else if (nInv == SdrInventor && nSdrObjKind == OBJ_GRAF)
//STRIP001 			{
//STRIP001 				pGrafObj = (SdrGrafObj*) pObj;
//STRIP001 			}
//STRIP001 //			// VCXControl ?
//STRIP001 //			else if( pObj->IsA( TYPE( VCSbxDrawObject ) ) )
//STRIP001 //			{
//STRIP001 //				bDisableAll = TRUE;
//STRIP001 //			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	if( pGrafObj )
//STRIP001 	{
//STRIP001 		bOLEAction = TRUE;
//STRIP001         
//STRIP001         aVerbVector.push_back( 0 );
//STRIP001 		aLbOLEAction.InsertEntry( String( SdResId( STR_EDIT_OBJ ) ).EraseAllChars('~') );
//STRIP001 	}
//STRIP001 	else if( pOleObj )
//STRIP001 	{
//STRIP001 		SvInPlaceObjectRef aIPObj = pOleObj->GetObjRef();
//STRIP001 
//STRIP001 		if ( aIPObj.Is() )
//STRIP001 		{
//STRIP001 			bOLEAction = TRUE;
//STRIP001 			const SvVerbList* pList = &aIPObj->GetVerbList();
//STRIP001 			for( USHORT i = 0; i < pList->Count() ; i++ )
//STRIP001 			{
//STRIP001 				const SvVerb& rVerb = pList->GetObject( i );
//STRIP001 				if( rVerb.IsOnMenu() )
//STRIP001 				{
//STRIP001 					String aTmp( rVerb.GetName() );
//STRIP001                     aVerbVector.push_back( rVerb.GetId() );
//STRIP001                     aLbOLEAction.InsertEntry( aTmp.EraseAllChars('~') );
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	// auf einer Masterpage ?
//STRIP001 	BOOL bOnMaster = FALSE;
//STRIP001 	if (pView->GetPageViewPvNum(0)->GetPage()->IsMasterPage())
//STRIP001 	{
//STRIP001 		bOnMaster = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_NONE, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_FADE_FROM_LEFT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_FADE_FROM_UPPERLEFT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_FADE_FROM_TOP, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_FADE_FROM_UPPERRIGHT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_FADE_FROM_RIGHT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_FADE_FROM_LOWERRIGHT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_FADE_FROM_BOTTOM, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_FADE_FROM_LOWERLEFT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_FADE_TO_CENTER, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_FADE_FROM_CENTER, LIST_APPEND);
//STRIP001 	//pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_FROM_LEFT, LIST_APPEND);
//STRIP001 	//pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_FROM_TOP, LIST_APPEND);
//STRIP001 	//pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_FROM_RIGHT, LIST_APPEND);
//STRIP001 	//pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_FROM_BOTTOM, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_VERTICAL_STRIPES, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_HORIZONTAL_STRIPES, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_VERTICAL_LINES, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_HORIZONTAL_LINES, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_VERTICAL_CHECKERBOARD, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_HORIZONTAL_CHECKERBOARD, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_CLOCKWISE, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_COUNTERCLOCKWISE, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_CLOSE_VERTICAL, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_CLOSE_HORIZONTAL, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_OPEN_VERTICAL, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_OPEN_HORIZONTAL, LIST_APPEND);
//STRIP001 	//pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_PATH
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_SPIRALIN_LEFT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_SPIRALIN_RIGHT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_SPIRALOUT_LEFT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_SPIRALOUT_RIGHT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_DISSOLVE, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_WAVYLINE_FROM_LEFT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_WAVYLINE_FROM_TOP, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_WAVYLINE_FROM_RIGHT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_WAVYLINE_FROM_BOTTOM, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_TO_LEFT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_TO_UPPERLEFT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_TO_TOP, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_TO_UPPERRIGHT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_TO_RIGHT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_TO_LOWERRIGHT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_TO_BOTTOM, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_TO_LOWERLEFT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_SHORT_TO_LEFT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_SHORT_TO_UPPERLEFT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_SHORT_TO_TOP, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_SHORT_TO_UPPERRIGHT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_SHORT_TO_RIGHT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_SHORT_TO_LOWERRIGHT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_SHORT_TO_BOTTOM, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_MOVE_SHORT_TO_LOWERLEFT, LIST_APPEND);
//STRIP001 	pCurrentEffects->Insert((void*)(ULONG)presentation::AnimationEffect_RANDOM, LIST_APPEND);
//STRIP001 
//STRIP001 	pCurrentActions->Insert((void*)(ULONG)presentation::ClickAction_NONE, LIST_APPEND);
//STRIP001 	pCurrentActions->Insert((void*)(ULONG)presentation::ClickAction_PREVPAGE, LIST_APPEND);
//STRIP001 	pCurrentActions->Insert((void*)(ULONG)presentation::ClickAction_NEXTPAGE, LIST_APPEND);
//STRIP001 	pCurrentActions->Insert((void*)(ULONG)presentation::ClickAction_FIRSTPAGE, LIST_APPEND);
//STRIP001 	pCurrentActions->Insert((void*)(ULONG)presentation::ClickAction_LASTPAGE, LIST_APPEND);
//STRIP001 	pCurrentActions->Insert((void*)(ULONG)presentation::ClickAction_BOOKMARK, LIST_APPEND);
//STRIP001 	pCurrentActions->Insert((void*)(ULONG)presentation::ClickAction_DOCUMENT, LIST_APPEND);
//STRIP001 	if (!bOnMaster)
//STRIP001 		pCurrentActions->Insert((void*)(ULONG)presentation::ClickAction_INVISIBLE, LIST_APPEND);
//STRIP001 	pCurrentActions->Insert((void*)(ULONG)presentation::ClickAction_SOUND, LIST_APPEND);
//STRIP001 	if (bOLEAction && aLbOLEAction.GetEntryCount())
//STRIP001 		pCurrentActions->Insert((void*)(ULONG)presentation::ClickAction_VERB, LIST_APPEND);
//STRIP001 	if (!bOnMaster)
//STRIP001 		pCurrentActions->Insert((void*)(ULONG)presentation::ClickAction_VANISH, LIST_APPEND);
//STRIP001 	pCurrentActions->Insert((void*)(ULONG)presentation::ClickAction_PROGRAM, LIST_APPEND);
//STRIP001 	pCurrentActions->Insert((void*)(ULONG)presentation::ClickAction_MACRO, LIST_APPEND);
//STRIP001 	pCurrentActions->Insert((void*)(ULONG)presentation::ClickAction_STOPPRESENTATION, LIST_APPEND);
//STRIP001 
//STRIP001 	// Action-Listbox fuellen
//STRIP001 	for (ULONG nAction = 0; nAction < pCurrentActions->Count(); nAction++)
//STRIP001 	{
//STRIP001 		USHORT nRId = GetClickActionSdResId((presentation::ClickAction)(ULONG)pCurrentActions->
//STRIP001 												GetObject(nAction));
//STRIP001 		aLbAction.InsertEntry( String( SdResId( nRId ) ) );
//STRIP001 	}
//STRIP001 
//STRIP001 
//STRIP001 	// Effekte-Listbox fuellen
//STRIP001 	for (ULONG nEffect = 0; nEffect < pCurrentEffects->Count(); nEffect++)
//STRIP001 	{
//STRIP001 		presentation::AnimationEffect eEffect = (presentation::AnimationEffect)(ULONG)pCurrentEffects->
//STRIP001 											GetObject(nEffect);
//STRIP001 		USHORT nRId = GetAnimationEffectSdResId(eEffect);
//STRIP001 		aLbEffect.InsertEntry( String( SdResId( nRId ) ) );
//STRIP001 	}
//STRIP001 
//STRIP001 
//STRIP001 	if( bDisableAll )
//STRIP001 	{
//STRIP001 		aFtAction.Disable();
//STRIP001 		aLbAction.Disable();
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		ChangeEffectHdl( this );
//STRIP001 		ClickActionHdl( this );
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL SdTPAction::FillItemSet( SfxItemSet& rAttrs )
//STRIP001 {
//STRIP001 	BOOL bModified = FALSE;
//STRIP001 	presentation::ClickAction eCA = presentation::ClickAction_NONE;
//STRIP001 
//STRIP001 	if( aLbAction.GetSelectEntryCount() )
//STRIP001 		eCA = GetActualClickAction();
//STRIP001 
//STRIP001 	if( aLbAction.GetSavedValue() != aLbAction.GetSelectEntryPos() )
//STRIP001 	{
//STRIP001 		rAttrs.Put( SfxAllEnumItem( ATTR_ACTION, eCA ) );
//STRIP001 		bModified = TRUE;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		rAttrs.InvalidateItem( ATTR_ACTION );
//STRIP001 
//STRIP001 	String aFileName = GetEditText( TRUE );
//STRIP001 	if( aFileName.Len() == 0 )
//STRIP001 		rAttrs.InvalidateItem( ATTR_ACTION_FILENAME );
//STRIP001 	else
//STRIP001 	{
//STRIP001 		if( eCA == presentation::ClickAction_SOUND ||
//STRIP001 			eCA == presentation::ClickAction_VANISH ||
//STRIP001 			eCA == presentation::ClickAction_DOCUMENT ||
//STRIP001 			eCA == presentation::ClickAction_PROGRAM )
//STRIP001 			aFileName = so3::StaticBaseUrl::SmartRelToAbs( aFileName, FALSE,
//STRIP001 													INetURLObject::WAS_ENCODED,
//STRIP001 													INetURLObject::DECODE_UNAMBIGUOUS );
//STRIP001 
//STRIP001 		rAttrs.Put( SfxStringItem( ATTR_ACTION_FILENAME, aFileName ) );
//STRIP001 		bModified = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if( eCA == presentation::ClickAction_VANISH )
//STRIP001 	{
//STRIP001 		// Effekt
//STRIP001 		if( aLbEffect.GetSelectEntryCount() &&
//STRIP001 			aLbEffect.GetSavedValue() != aLbEffect.GetSelectEntryPos() )
//STRIP001 		{
//STRIP001 			rAttrs.Put( SfxAllEnumItem( ATTR_ACTION_EFFECT, GetActualAnimationEffect() ) );
//STRIP001 			bModified = TRUE;
//STRIP001 		}
//STRIP001 		else
//STRIP001 			rAttrs.InvalidateItem( ATTR_ACTION_EFFECT );
//STRIP001 
//STRIP001 		// Speed
//STRIP001 		if( aRbtSlow.IsChecked() && aRbtSlow.GetSavedValue() != TRUE )
//STRIP001 		{
//STRIP001 			rAttrs.Put( SfxAllEnumItem( ATTR_ACTION_EFFECTSPEED, (presentation::AnimationSpeed) presentation::AnimationSpeed_SLOW ) );
//STRIP001 			bModified = TRUE;
//STRIP001 		}
//STRIP001 		else if( aRbtMedium.IsChecked() && aRbtMedium.GetSavedValue() != TRUE )
//STRIP001 		{
//STRIP001 			rAttrs.Put( SfxAllEnumItem( ATTR_ACTION_EFFECTSPEED, (presentation::AnimationSpeed) presentation::AnimationSpeed_MEDIUM ) );
//STRIP001 			bModified = TRUE;
//STRIP001 		}
//STRIP001 		else if( aRbtFast.IsChecked() && aRbtFast.GetSavedValue() != TRUE )
//STRIP001 		{
//STRIP001 			rAttrs.Put( SfxAllEnumItem( ATTR_ACTION_EFFECTSPEED, (presentation::AnimationSpeed) presentation::AnimationSpeed_FAST ) );
//STRIP001 			bModified = TRUE;
//STRIP001 		}
//STRIP001 		else
//STRIP001 			rAttrs.InvalidateItem( ATTR_ACTION_EFFECTSPEED );
//STRIP001 
//STRIP001 		// Sound On
//STRIP001 		TriState eState = aTsbSound.GetState();
//STRIP001 		if( eState != aTsbSound.GetSavedValue() )
//STRIP001 		{
//STRIP001 			if( eState == STATE_DONTKNOW )
//STRIP001 				rAttrs.InvalidateItem( ATTR_ACTION_SOUNDON );
//STRIP001 			else if( eState == STATE_CHECK )
//STRIP001 			{
//STRIP001 				rAttrs.Put( SfxBoolItem( ATTR_ACTION_SOUNDON, TRUE ) );
//STRIP001 				bModified = TRUE;
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				rAttrs.Put( SfxBoolItem( ATTR_ACTION_SOUNDON, FALSE ) );
//STRIP001 				bModified = TRUE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		// vollstaendig abspielen
//STRIP001 		eState = aTsbPlayFull.GetState();
//STRIP001 		if( eState != aTsbPlayFull.GetSavedValue() )
//STRIP001 		{
//STRIP001 			if( eState == STATE_DONTKNOW )
//STRIP001 				rAttrs.InvalidateItem( ATTR_ACTION_PLAYFULL );
//STRIP001 			else if( eState == STATE_CHECK )
//STRIP001 			{
//STRIP001 				rAttrs.Put( SfxBoolItem( ATTR_ACTION_PLAYFULL, TRUE ) );
//STRIP001 				bModified = TRUE;
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				rAttrs.Put( SfxBoolItem( ATTR_ACTION_PLAYFULL, FALSE ) );
//STRIP001 				bModified = TRUE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return( bModified );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 void SdTPAction::Reset( const SfxItemSet& rAttrs )
//STRIP001 {
//STRIP001 	presentation::ClickAction eCA = presentation::ClickAction_NONE;
//STRIP001 	String		aFileName;
//STRIP001 
//STRIP001 	// aLbAction
//STRIP001 	if( rAttrs.GetItemState( ATTR_ACTION ) != SFX_ITEM_DONTCARE )
//STRIP001 	{
//STRIP001 		eCA = (presentation::ClickAction) ( ( const SfxAllEnumItem& ) rAttrs.
//STRIP001 					Get( ATTR_ACTION ) ).GetValue();
//STRIP001 		SetActualClickAction( eCA );
//STRIP001 	}
//STRIP001 	else
//STRIP001 		aLbAction.SetNoSelection();
//STRIP001 
//STRIP001 	// aEdtSound
//STRIP001 	if( rAttrs.GetItemState( ATTR_ACTION_FILENAME ) != SFX_ITEM_DONTCARE )
//STRIP001 	{
//STRIP001 		aFileName = ( ( const SfxStringItem& ) rAttrs.
//STRIP001 					Get( ATTR_ACTION_FILENAME ) ).GetValue();
//STRIP001 		if( eCA == presentation::ClickAction_MACRO )
//STRIP001 		{
//STRIP001 			sal_Unicode cToken = '.';
//STRIP001 			String aStr( aFileName.GetToken( 2, cToken ) );
//STRIP001 			aStr.Append( cToken );
//STRIP001 			aStr.Append( aFileName.GetToken( 1, cToken ) );
//STRIP001 			aStr.Append( cToken );
//STRIP001 			aStr.Append( aFileName.GetToken( 0, cToken ) );
//STRIP001 			aFileName = aStr;
//STRIP001 		}
//STRIP001 		SetEditText( aFileName );
//STRIP001 	}
//STRIP001 
//STRIP001 	// Effekt
//STRIP001 	if( rAttrs.GetItemState( ATTR_ACTION_EFFECT ) != SFX_ITEM_DONTCARE )
//STRIP001 	{
//STRIP001 		presentation::AnimationEffect eAE = (presentation::AnimationEffect) ( ( const SfxAllEnumItem& ) rAttrs.
//STRIP001 					Get( ATTR_ACTION_EFFECT ) ).GetValue();
//STRIP001 		SetActualAnimationEffect( eAE );
//STRIP001 	}
//STRIP001 	else
//STRIP001 		aLbEffect.SetNoSelection();
//STRIP001 
//STRIP001 	// Speed
//STRIP001 	if( rAttrs.GetItemState( ATTR_ACTION_EFFECTSPEED ) != SFX_ITEM_DONTCARE )
//STRIP001 	{
//STRIP001 		presentation::AnimationSpeed eAS = (presentation::AnimationSpeed) ( ( const SfxAllEnumItem& ) rAttrs.
//STRIP001 					Get( ATTR_ACTION_EFFECTSPEED ) ).GetValue();
//STRIP001 
//STRIP001 		if( eAS == presentation::AnimationSpeed_SLOW )
//STRIP001 			aRbtSlow.Check();
//STRIP001 		else if( eAS == presentation::AnimationSpeed_MEDIUM )
//STRIP001 			aRbtMedium.Check();
//STRIP001 		else if( eAS == presentation::AnimationSpeed_FAST )
//STRIP001 			aRbtFast.Check();
//STRIP001 	}
//STRIP001 
//STRIP001 	// Sound on
//STRIP001 	if( rAttrs.GetItemState( ATTR_ACTION_SOUNDON ) != SFX_ITEM_DONTCARE )
//STRIP001 	{
//STRIP001 		aTsbSound.EnableTriState( FALSE );
//STRIP001 		if( ( ( const SfxBoolItem& ) rAttrs.Get( ATTR_ACTION_SOUNDON ) ).GetValue() )
//STRIP001 			aTsbSound.SetState( STATE_CHECK );
//STRIP001 		else
//STRIP001 			aTsbSound.SetState( STATE_NOCHECK );
//STRIP001 	}
//STRIP001 	else
//STRIP001 		aTsbSound.SetState( STATE_DONTKNOW );
//STRIP001 
//STRIP001 	// vollstaendig abspielen
//STRIP001 	if( SFX_ITEM_DONTCARE != rAttrs.GetItemState( ATTR_ACTION_PLAYFULL ) )
//STRIP001 	{
//STRIP001 		aTsbPlayFull.EnableTriState( FALSE );
//STRIP001 		if( ( ( const SfxBoolItem& ) rAttrs.Get( ATTR_ACTION_PLAYFULL ) ).GetValue() )
//STRIP001 			aTsbPlayFull.SetState( STATE_CHECK );
//STRIP001 		else
//STRIP001 			aTsbPlayFull.SetState( STATE_NOCHECK );
//STRIP001 	}
//STRIP001 	else
//STRIP001 		aTsbPlayFull.SetState( STATE_DONTKNOW );
//STRIP001 
//STRIP001 	switch( eCA )
//STRIP001 	{
//STRIP001 		case presentation::ClickAction_VANISH:
//STRIP001 		{
//STRIP001 			ChangeEffectHdl( this );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case presentation::ClickAction_BOOKMARK:
//STRIP001 		{
//STRIP001 			if( !aLbTree.SelectEntry( aFileName ) )
//STRIP001 				aLbTree.SelectAll( FALSE );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case presentation::ClickAction_DOCUMENT:
//STRIP001 		{
//STRIP001 			if( aFileName.GetTokenCount( DOCUMENT_TOKEN ) == 2 )
//STRIP001 				aLbTreeDocument.SelectEntry( aFileName.GetToken( 1, DOCUMENT_TOKEN ) );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		default:
//STRIP001 		break;
//STRIP001 	}
//STRIP001 	ClickActionHdl( this );
//STRIP001 
//STRIP001 	aLbAction.SaveValue();
//STRIP001 	aLbEffect.SaveValue();
//STRIP001 	aRbtSlow.SaveValue();
//STRIP001 	aRbtMedium.SaveValue();
//STRIP001 	aRbtFast.SaveValue();
//STRIP001 	aEdtSound.SaveValue();
//STRIP001 	aTsbSound.SaveValue();
//STRIP001 	aTsbPlayFull.SaveValue();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SdTPAction::ActivatePage( const SfxItemSet& rSet )
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 int SdTPAction::DeactivatePage( SfxItemSet* pSet )
//STRIP001 {
//STRIP001 	if( pSet )
//STRIP001 		FillItemSet( *pSet );
//STRIP001 
//STRIP001 	return( LEAVE_PAGE );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxTabPage* SdTPAction::Create( Window* pWindow,
//STRIP001 				const SfxItemSet& rAttrs )
//STRIP001 {
//STRIP001 	return( new SdTPAction( pWindow, rAttrs ) );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 USHORT* SdTPAction::GetRanges()
//STRIP001 {
//STRIP001 	return( pActionRanges );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 void SdTPAction::UpdateTree()
//STRIP001 {
//STRIP001 	if( !bTreeUpdated )
//STRIP001 	{
//STRIP001 		//aLbTree.Clear();
//STRIP001 		aLbTree.Fill( pDoc, TRUE, pDoc->GetDocSh()->GetMedium()->GetName() );
//STRIP001 		bTreeUpdated = TRUE;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 void SdTPAction::OpenFileDialog()
//STRIP001 {
//STRIP001 	// Soundpreview nur fuer Interaktionen mit Sound
//STRIP001 	presentation::ClickAction eCA = GetActualClickAction();
//STRIP001 	BOOL bSound = ( eCA == presentation::ClickAction_SOUND ||
//STRIP001 					eCA == presentation::ClickAction_VANISH );
//STRIP001 	BOOL bPage = ( eCA == presentation::ClickAction_BOOKMARK );
//STRIP001 	BOOL bDocument = ( eCA == presentation::ClickAction_DOCUMENT ||
//STRIP001 					   eCA == presentation::ClickAction_PROGRAM );
//STRIP001 	BOOL bMacro = ( eCA == presentation::ClickAction_MACRO );
//STRIP001 	//BOOL bObject = ( eCA == presentation::ClickAction_VERB );
//STRIP001 
//STRIP001 	if( bPage )
//STRIP001 	{
//STRIP001 		// Es wird in der TreeLB nach dem eingegebenen Objekt gesucht
//STRIP001 		aLbTree.SelectEntry( GetEditText() );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		String aFile( GetEditText() );
//STRIP001 
//STRIP001 		if( bSound )
//STRIP001 		{
//STRIP001 			SdOpenSoundFileDialog	aFileDialog;
//STRIP001 
//STRIP001 			if( !aFile.Len() )
//STRIP001 				aFile = SvtPathOptions().GetGraphicPath();
//STRIP001 
//STRIP001 			aFileDialog.SetPath( aFile );
//STRIP001 
//STRIP001 			if( aFileDialog.Execute() == ERRCODE_NONE )
//STRIP001 			{
//STRIP001 				aFile = aFileDialog.GetPath();
//STRIP001 				SetEditText( aFile );
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else if (bMacro)
//STRIP001 		{
//STRIP001 			Window* pOldWin = Application::GetDefDialogParent();
//STRIP001 			Application::SetDefDialogParent( this );
//STRIP001 
//STRIP001             // choose macro dialog    
//STRIP001             String aScriptURL = OfficeApplication::ChooseMacro(FALSE, TRUE);
//STRIP001 
//STRIP001 	        // aScriptURL has the following format:
//STRIP001             // vnd.sun.star.script:language=[language],macro=[macro],location=[location]
//STRIP001             // [language] = StarBasic
//STRIP001             // [macro] = libname.modulename.macroname
//STRIP001             // [location] = application|document
//STRIP001             // e.g. 'vnd.sun.star.script:language=StarBasic,macro=Standard.Module1.Main,location=document'
//STRIP001             //
//STRIP001 	        // but for the UI we need this format:
//STRIP001 	        // 'libname.modulename.macroname'
//STRIP001 
//STRIP001 	        if ( aScriptURL.Len() != 0 )
//STRIP001 	        {
//STRIP001 		        // parse script URL
//STRIP001                 BOOL bFound;
//STRIP001                 String aValue;
//STRIP001                 INetURLObject aINetScriptURL( aScriptURL );
//STRIP001 
//STRIP001                 // get language
//STRIP001                 String aLanguage;
//STRIP001                 bFound = aINetScriptURL.getParameter( String( RTL_CONSTASCII_USTRINGPARAM("language") ), &aValue );
//STRIP001                 if ( bFound )
//STRIP001                     aLanguage = aValue;
//STRIP001 
//STRIP001                 // get macro
//STRIP001                 String aMacro;
//STRIP001                 String aLibName;
//STRIP001                 String aModuleName;
//STRIP001                 String aMacroName;
//STRIP001                 bFound = aINetScriptURL.getParameter( String( RTL_CONSTASCII_USTRINGPARAM("macro") ), &aValue );
//STRIP001                 if ( bFound )
//STRIP001                 {
//STRIP001                     aMacro = aValue;
//STRIP001                     aLibName    = aMacro.GetToken(0, sal_Unicode('.'));
//STRIP001 		            aModuleName = aMacro.GetToken(1, sal_Unicode('.'));
//STRIP001 		            aMacroName  = aMacro.GetToken(2, sal_Unicode('.'));
//STRIP001                 }
//STRIP001 
//STRIP001                 // get location
//STRIP001                 String aLocation;
//STRIP001                 bFound = aINetScriptURL.getParameter( String( RTL_CONSTASCII_USTRINGPARAM("location") ), &aValue );
//STRIP001                 if ( bFound )
//STRIP001                     aLocation = aValue;
//STRIP001 
//STRIP001                 SetEditText( aMacro );
//STRIP001             }
//STRIP001 
//STRIP001 			Application::SetDefDialogParent( pOldWin );
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			sfx2::FileDialogHelper aFileDialog(WB_OPEN | WB_3DLOOK | WB_STDMODAL );
//STRIP001 
//STRIP001 			if (bDocument && !aFile.Len())
//STRIP001 				aFile = SvtPathOptions().GetWorkPath();
//STRIP001 
//STRIP001 			aFileDialog.SetDisplayDirectory( aFile );
//STRIP001 
//STRIP001             // The following is a fix for #1008001# and a workarround for
//STRIP001             // #i4306#: The addition of the implicitely existing "all files"
//STRIP001             // filter makes the (Windows system) open file dialog follow
//STRIP001             // links on the desktop to directories.
//STRIP001             aFileDialog.AddFilter (
//STRIP001                 String (SdResId (STR_FILTERNAME_ALL)),
//STRIP001                 String (RTL_CONSTASCII_USTRINGPARAM("*.*")));
//STRIP001 
//STRIP001 
//STRIP001 			if( aFileDialog.Execute() == ERRCODE_NONE )
//STRIP001 			{
//STRIP001 				aFile = aFileDialog.GetPath();
//STRIP001 				SetEditText( aFile );
//STRIP001 			}
//STRIP001 			if( bDocument )
//STRIP001 				CheckFileHdl( NULL );
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SdTPAction, ChangeEffectHdl, void *, EMPTYARG )
//STRIP001 {
//STRIP001 	USHORT nPos = GetActualAnimationEffect();
//STRIP001 	if( nPos == presentation::AnimationEffect_NONE &&
//STRIP001 		aLbEffect.GetSelectEntryCount() > 0 )
//STRIP001 	{
//STRIP001 		aRbtSlow.Disable();
//STRIP001 		aRbtMedium.Disable();
//STRIP001 		aRbtFast.Disable();
//STRIP001 	}
//STRIP001 	else 
//STRIP001 	{
//STRIP001 		aRbtSlow.Enable();
//STRIP001 		aRbtMedium.Enable();
//STRIP001 		aRbtFast.Enable();
//STRIP001 
//STRIP001 		// Damit wenigstens ein Radiobutton gechecked wird:
//STRIP001 		if( !aRbtSlow.IsChecked() &&
//STRIP001 			!aRbtMedium.IsChecked() &&
//STRIP001 			!aRbtFast.IsChecked() )
//STRIP001 		{
//STRIP001 			aRbtSlow.Check();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	
//STRIP001 	return( 0L );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SdTPAction, ClickSoundHdl, void *, EMPTYARG )
//STRIP001 {
//STRIP001 	if( aTsbSound.GetState() == STATE_NOCHECK)
//STRIP001 	{
//STRIP001 		aEdtSound.Disable();
//STRIP001 		aBtnSearch.Disable();
//STRIP001 		aTsbPlayFull.Disable();
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aEdtSound.Enable();
//STRIP001 		aBtnSearch.Enable();
//STRIP001 		aTsbPlayFull.Enable();
//STRIP001 	}
//STRIP001 
//STRIP001 	return( 0L );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SdTPAction, ClickSearchHdl, void *, EMPTYARG )
//STRIP001 {
//STRIP001 	OpenFileDialog();
//STRIP001 
//STRIP001 	return( 0L );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SdTPAction, ClickActionHdl, void *, EMPTYARG )
//STRIP001 {
//STRIP001 	presentation::ClickAction eCA = GetActualClickAction();
//STRIP001 
//STRIP001 	// hide controls we don't need 
//STRIP001 	switch( eCA )
//STRIP001 	{
//STRIP001 		case presentation::ClickAction_NONE:
//STRIP001 		case presentation::ClickAction_INVISIBLE:
//STRIP001 		case presentation::ClickAction_PREVPAGE:
//STRIP001 		case presentation::ClickAction_NEXTPAGE:
//STRIP001 		case presentation::ClickAction_FIRSTPAGE:
//STRIP001 		case presentation::ClickAction_LASTPAGE:
//STRIP001 		case presentation::ClickAction_STOPPRESENTATION:
//STRIP001 			aFtTree.Hide();
//STRIP001 			aLbTree.Hide();
//STRIP001 			aLbTreeDocument.Hide();
//STRIP001 			aLbOLEAction.Hide();
//STRIP001 
//STRIP001 			aFlEffect.Hide();
//STRIP001 			aFtAnimation.Hide();
//STRIP001 			aLbEffect.Hide();
//STRIP001 			aFtSpeed.Hide();
//STRIP001 			aRbtSlow.Hide();
//STRIP001 			aRbtMedium.Hide();
//STRIP001 			aRbtFast.Hide();
//STRIP001 			aTsbPlayFull.Hide();
//STRIP001 			aTsbSound.Hide();
//STRIP001 
//STRIP001 			aFlSeparator.Hide();
//STRIP001 			aEdtSound.Hide();
//STRIP001 			aEdtBookmark.Hide();
//STRIP001 			aEdtDocument.Hide();
//STRIP001 			aEdtProgram.Hide();
//STRIP001 			aEdtMacro.Hide();
//STRIP001 			aBtnSearch.Hide();
//STRIP001 			aBtnSeek.Hide();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case presentation::ClickAction_SOUND:
//STRIP001 		case presentation::ClickAction_PROGRAM:
//STRIP001 		case presentation::ClickAction_MACRO:
//STRIP001 			aFtTree.Hide();
//STRIP001 			aLbTree.Hide();
//STRIP001 			aLbTreeDocument.Hide();
//STRIP001 			aLbOLEAction.Hide();
//STRIP001 
//STRIP001 			aFlEffect.Hide();
//STRIP001 			aFtAnimation.Hide();
//STRIP001 			aLbEffect.Hide();
//STRIP001 			aFtSpeed.Hide();
//STRIP001 			aRbtSlow.Hide();
//STRIP001 			aRbtMedium.Hide();
//STRIP001 			aRbtFast.Hide();
//STRIP001 			aTsbPlayFull.Hide();
//STRIP001 			aTsbSound.Hide();
//STRIP001 
//STRIP001 			aEdtDocument.Hide();
//STRIP001 
//STRIP001 			if( eCA == presentation::ClickAction_MACRO )
//STRIP001 			{
//STRIP001 				aEdtSound.Hide();
//STRIP001 				aEdtProgram.Hide();
//STRIP001 			}
//STRIP001 			else if( eCA == presentation::ClickAction_PROGRAM )
//STRIP001 			{
//STRIP001 				aEdtSound.Hide();
//STRIP001 				aEdtMacro.Hide();
//STRIP001 			}
//STRIP001 			else if( eCA == presentation::ClickAction_SOUND )
//STRIP001 			{
//STRIP001 				aEdtProgram.Hide();
//STRIP001 				aEdtMacro.Hide();
//STRIP001 			}
//STRIP001 
//STRIP001 			aBtnSeek.Hide();
//STRIP001 			break;
//STRIP001 
//STRIP001 
//STRIP001 		case presentation::ClickAction_DOCUMENT:
//STRIP001 			aLbTree.Hide();
//STRIP001 			aLbOLEAction.Hide();
//STRIP001 
//STRIP001 			aFlEffect.Hide();
//STRIP001 			aFtAnimation.Hide();
//STRIP001 			aLbEffect.Hide();
//STRIP001 			aFtSpeed.Hide();
//STRIP001 			aRbtSlow.Hide();
//STRIP001 			aRbtMedium.Hide();
//STRIP001 			aRbtFast.Hide();
//STRIP001 			aTsbPlayFull.Hide();
//STRIP001 			aEdtSound.Hide();
//STRIP001 			aTsbSound.Hide();
//STRIP001 			
//STRIP001 			aEdtProgram.Hide();
//STRIP001 			aEdtMacro.Hide();
//STRIP001 			aEdtBookmark.Hide();
//STRIP001 			aBtnSeek.Hide();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case presentation::ClickAction_VERB:
//STRIP001 			aLbTree.Hide();
//STRIP001 			aLbTreeDocument.Hide();
//STRIP001 
//STRIP001 			aFlEffect.Hide();
//STRIP001 			aFtAnimation.Hide();
//STRIP001 			aLbEffect.Hide();
//STRIP001 			aFtSpeed.Hide();
//STRIP001 			aRbtSlow.Hide();
//STRIP001 			aRbtMedium.Hide();
//STRIP001 			aRbtFast.Hide();
//STRIP001 			aTsbPlayFull.Hide();
//STRIP001 			aEdtSound.Hide();
//STRIP001 			aTsbSound.Hide();
//STRIP001 
//STRIP001 			aFlSeparator.Hide();
//STRIP001 			aEdtBookmark.Hide();
//STRIP001 			aEdtDocument.Hide();
//STRIP001 			aEdtProgram.Hide();
//STRIP001 			aEdtMacro.Hide();
//STRIP001 			aBtnSearch.Hide();
//STRIP001 			aBtnSeek.Hide();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case presentation::ClickAction_BOOKMARK:
//STRIP001 			aLbTreeDocument.Hide();
//STRIP001 			aLbOLEAction.Hide();
//STRIP001 
//STRIP001 			aFlEffect.Hide();
//STRIP001 			aFtAnimation.Hide();
//STRIP001 			aLbEffect.Hide();
//STRIP001 			aFtSpeed.Hide();
//STRIP001 			aRbtSlow.Hide();
//STRIP001 			aRbtMedium.Hide();
//STRIP001 			aRbtFast.Hide();
//STRIP001 			aTsbPlayFull.Hide();
//STRIP001 			aEdtSound.Hide();
//STRIP001 			aTsbSound.Hide();
//STRIP001 
//STRIP001 			aEdtDocument.Hide();
//STRIP001 			aEdtProgram.Hide();
//STRIP001 			aEdtMacro.Hide();
//STRIP001 			aBtnSearch.Hide();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case presentation::ClickAction_VANISH:
//STRIP001 			aFtTree.Hide();
//STRIP001 			aLbTree.Hide();
//STRIP001 			aLbTreeDocument.Hide();
//STRIP001 			aLbOLEAction.Hide();
//STRIP001 
//STRIP001 			aFlSeparator.Hide();
//STRIP001 			aEdtBookmark.Hide();
//STRIP001 			aEdtDocument.Hide();
//STRIP001 			aEdtProgram.Hide();
//STRIP001 			aEdtMacro.Hide();
//STRIP001 			aBtnSeek.Hide();
//STRIP001 			break;
//STRIP001 	}
//STRIP001 
//STRIP001 	// show controls we do need 
//STRIP001 	switch( eCA )
//STRIP001 	{
//STRIP001 		case presentation::ClickAction_NONE:
//STRIP001 		case presentation::ClickAction_INVISIBLE:
//STRIP001 		case presentation::ClickAction_PREVPAGE:
//STRIP001 		case presentation::ClickAction_NEXTPAGE:
//STRIP001 		case presentation::ClickAction_FIRSTPAGE:
//STRIP001 		case presentation::ClickAction_LASTPAGE:
//STRIP001 		case presentation::ClickAction_STOPPRESENTATION:
//STRIP001 			// none 
//STRIP001 			break;
//STRIP001 
//STRIP001 		case presentation::ClickAction_SOUND:
//STRIP001 			aFlSeparator.Show();
//STRIP001 			aEdtSound.Show();
//STRIP001 			aEdtSound.Enable();
//STRIP001 			aBtnSearch.Show();
//STRIP001 			aBtnSearch.Enable();
//STRIP001 			aFlSeparator.SetText( String( SdResId( STR_EFFECTDLG_SOUND ) ) );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case presentation::ClickAction_PROGRAM:
//STRIP001 		case presentation::ClickAction_MACRO:
//STRIP001 			aFlSeparator.Show();
//STRIP001 			aBtnSearch.Show();
//STRIP001 			aBtnSearch.Enable();
//STRIP001 			if( eCA == presentation::ClickAction_MACRO )
//STRIP001 			{
//STRIP001 				aEdtMacro.Show();
//STRIP001 				aFlSeparator.SetText( String( SdResId( STR_EFFECTDLG_MACRO ) ) );
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				aEdtProgram.Show();
//STRIP001 				aFlSeparator.SetText( String( SdResId( STR_EFFECTDLG_PROGRAM ) ) );
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case presentation::ClickAction_DOCUMENT:
//STRIP001 			aFtTree.Show();
//STRIP001 			aLbTreeDocument.Show();
//STRIP001 
//STRIP001 			aFlSeparator.Show();
//STRIP001 			aEdtDocument.Show();
//STRIP001 			aBtnSearch.Show();
//STRIP001 			aBtnSearch.Enable();
//STRIP001 
//STRIP001 			aFtTree.SetText( String( SdResId( STR_EFFECTDLG_JUMP ) ) );
//STRIP001 			aFlSeparator.SetText( String( SdResId( STR_EFFECTDLG_DOCUMENT ) ) );
//STRIP001 
//STRIP001 			CheckFileHdl( NULL );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case presentation::ClickAction_VERB:
//STRIP001 			aFtTree.Show();
//STRIP001 			aLbOLEAction.Show();
//STRIP001 
//STRIP001 			aFtTree.SetText( String( SdResId( STR_EFFECTDLG_ACTION ) ) );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case presentation::ClickAction_BOOKMARK:
//STRIP001 			UpdateTree();
//STRIP001 
//STRIP001 			aFtTree.Show();
//STRIP001 			aLbTree.Show();
//STRIP001 
//STRIP001 			aFlSeparator.Show();
//STRIP001 			aEdtBookmark.Show();
//STRIP001 			aBtnSeek.Show();
//STRIP001 
//STRIP001 			aFtTree.SetText( String( SdResId( STR_EFFECTDLG_JUMP ) ) );
//STRIP001 			aFlSeparator.SetText( String( SdResId( STR_EFFECTDLG_PAGE_OBJECT ) ) );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case presentation::ClickAction_VANISH:
//STRIP001 			aFlEffect.Show();
//STRIP001 			aFtAnimation.Show();
//STRIP001 			aLbEffect.Show();
//STRIP001 			aFtSpeed.Show();
//STRIP001 			aRbtSlow.Show();
//STRIP001 			aRbtMedium.Show();
//STRIP001 			aRbtFast.Show();
//STRIP001 			aTsbPlayFull.Show();
//STRIP001 			aEdtSound.Show();
//STRIP001 			aTsbSound.Show();
//STRIP001 
//STRIP001 			aBtnSearch.Show();
//STRIP001 
//STRIP001 			ClickSoundHdl( NULL );
//STRIP001 			ChangeEffectHdl( NULL );
//STRIP001 			break;
//STRIP001 	}
//STRIP001 
//STRIP001 	return( 0L );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SdTPAction, SelectTreeHdl, void *, EMPTYARG )
//STRIP001 {
//STRIP001 	aEdtBookmark.SetText( aLbTree.GetSelectEntry() );
//STRIP001 	return( 0L );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SdTPAction, CheckFileHdl, void *, EMPTYARG )
//STRIP001 {
//STRIP001 	String aFile( GetEditText() );
//STRIP001 	String aStrTmp = aFile.ToLowerAscii();
//STRIP001 
//STRIP001 	if( aFile != aLastFile )
//STRIP001 	{
//STRIP001 		// Ueberpruefen, ob es eine gueltige Draw-Datei ist
//STRIP001 		SfxMedium aMedium( aFile,
//STRIP001 					STREAM_READ | STREAM_NOCREATE,
//STRIP001 					TRUE ); 			  // Download
//STRIP001 
//STRIP001 		if( aMedium.IsStorage() )
//STRIP001 		{
//STRIP001 			WaitObject aWait( GetParent()->GetParent() );
//STRIP001 
//STRIP001 			// ist es eine Draw-Datei?
//STRIP001 			// mit READ oeffnen, sonst schreiben die Storages evtl. in die Datei!
//STRIP001 
//STRIP001 			SvStorage* pStorage = aMedium.GetStorage();
//STRIP001 			DBG_ASSERT( pStorage, "Kein Storage!" );
//STRIP001 
//STRIP001 			if( pStorage->IsStream( pStarDrawDoc ) ||
//STRIP001 				pStorage->IsStream( pStarDrawDoc3 ) || 
//STRIP001 				pStorage->IsStream( pStarDrawXMLContent ) ||
//STRIP001 				pStorage->IsStream( pStarDrawOldXMLContent ) )
//STRIP001 			{
//STRIP001 				SdDrawDocument* pBookmarkDoc = pDoc->OpenBookmarkDoc( aFile );
//STRIP001 
//STRIP001 				if( pBookmarkDoc )
//STRIP001 				{
//STRIP001 					aLastFile = aFile;
//STRIP001 
//STRIP001 					aLbTreeDocument.Clear();
//STRIP001 					aLbTreeDocument.Fill( pBookmarkDoc, TRUE, aFile );
//STRIP001 					pDoc->CloseBookmarkDoc();
//STRIP001 					aLbTreeDocument.Show();
//STRIP001 				}
//STRIP001 				else
//STRIP001 					aLbTreeDocument.Hide();
//STRIP001 			}
//STRIP001 			else
//STRIP001 				aLbTreeDocument.Hide();
//STRIP001 
//STRIP001 		}
//STRIP001 		else
//STRIP001 			aLbTreeDocument.Hide();
//STRIP001 	}
//STRIP001 
//STRIP001 	return( 0L );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 presentation::ClickAction SdTPAction::GetActualClickAction()
//STRIP001 {
//STRIP001 	presentation::ClickAction eCA = presentation::ClickAction_NONE;
//STRIP001 	USHORT nPos = aLbAction.GetSelectEntryPos();
//STRIP001 
//STRIP001 	if (nPos != LISTBOX_ENTRY_NOTFOUND)
//STRIP001 		eCA = (presentation::ClickAction)(ULONG)pCurrentActions->GetObject((ULONG)nPos);
//STRIP001 	return( eCA );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 void SdTPAction::SetActualClickAction( presentation::ClickAction eCA )
//STRIP001 {
//STRIP001 	USHORT nPos = (USHORT)pCurrentActions->GetPos((void*)(ULONG)eCA);
//STRIP001 	DBG_ASSERT(nPos != LIST_ENTRY_NOTFOUND, "unbekannte Interaktion");
//STRIP001 	aLbAction.SelectEntryPos(nPos);
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 presentation::AnimationEffect SdTPAction::GetActualAnimationEffect()
//STRIP001 {
//STRIP001 	presentation::AnimationEffect eAE = presentation::AnimationEffect_NONE;
//STRIP001 
//STRIP001 	USHORT nPos = aLbEffect.GetSelectEntryPos();
//STRIP001 	if (nPos != LISTBOX_ENTRY_NOTFOUND)
//STRIP001 		eAE = (presentation::AnimationEffect)(ULONG)pCurrentEffects->GetObject((ULONG)nPos);
//STRIP001 	return( eAE );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 void SdTPAction::SetActualAnimationEffect( presentation::AnimationEffect eAE )
//STRIP001 {
//STRIP001 	USHORT nPos = (USHORT)pCurrentEffects->GetPos((void*)(ULONG)eAE);
//STRIP001 	DBG_ASSERT(nPos != LIST_ENTRY_NOTFOUND, "unbekannter Effekt");
//STRIP001 	aLbEffect.SelectEntryPos(nPos);
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 void SdTPAction::SetEditText( String& rStr )
//STRIP001 {
//STRIP001 	presentation::ClickAction 	eCA = GetActualClickAction();
//STRIP001 	String						aText(rStr);
//STRIP001 
//STRIP001 	// possibly convert URI back to system path
//STRIP001 	switch( eCA )
//STRIP001 	{
//STRIP001 		case presentation::ClickAction_DOCUMENT:
//STRIP001 			if( rStr.GetTokenCount( DOCUMENT_TOKEN ) == 2 )
//STRIP001 				aText = rStr.GetToken( 0, DOCUMENT_TOKEN );
//STRIP001 
//STRIP001 			// fallthrough intended			
//STRIP001 		case presentation::ClickAction_SOUND:
//STRIP001 		case presentation::ClickAction_VANISH:
//STRIP001 		case presentation::ClickAction_PROGRAM:
//STRIP001 			INetURLObject aURL( aText );
//STRIP001 	
//STRIP001 			// try to convert to system path
//STRIP001 			String aTmpStr(aURL.getFSysPath(INetURLObject::FSYS_DETECT));
//STRIP001 
//STRIP001 			if( aTmpStr.Len() )
//STRIP001 				aText = aTmpStr;	// was a system path
//STRIP001 			break;
//STRIP001 	}
//STRIP001 
//STRIP001 	// set the string to the corresponding control
//STRIP001 	switch( eCA )
//STRIP001 	{
//STRIP001 		case presentation::ClickAction_SOUND:
//STRIP001 		case presentation::ClickAction_VANISH:
//STRIP001 			aEdtSound.SetText( aText );
//STRIP001 			break;
//STRIP001 		case presentation::ClickAction_VERB:
//STRIP001         {
//STRIP001             ::std::vector< long >::iterator aFound( ::std::find( aVerbVector.begin(), aVerbVector.end(), rStr.ToInt32() ) );
//STRIP001 
//STRIP001             if( aFound != aVerbVector.end() )
//STRIP001                 aLbOLEAction.SelectEntryPos( static_cast< short >( aFound - aVerbVector.begin() ) );
//STRIP001         }
//STRIP001         break;
//STRIP001 		case presentation::ClickAction_PROGRAM:
//STRIP001 			aEdtProgram.SetText( aText );
//STRIP001 			break;
//STRIP001 		case presentation::ClickAction_MACRO:
//STRIP001 		{
//STRIP001 			if( rStr.GetTokenCount( DOCUMENT_TOKEN ) == 2 )
//STRIP001 				aEdtMacro.SetText( aText.GetToken( 0, DOCUMENT_TOKEN ) );
//STRIP001 			else
//STRIP001 				aEdtMacro.SetText( aText );
//STRIP001 		}
//STRIP001 			break;
//STRIP001 		case presentation::ClickAction_DOCUMENT:
//STRIP001 			aEdtDocument.SetText( aText );
//STRIP001 			break;
//STRIP001 		case presentation::ClickAction_BOOKMARK:
//STRIP001 			aEdtBookmark.SetText( aText );
//STRIP001 			break;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 String SdTPAction::GetEditText( BOOL bFullDocDestination )
//STRIP001 {
//STRIP001 	String aStr;
//STRIP001 	presentation::ClickAction eCA = GetActualClickAction();
//STRIP001 
//STRIP001 	switch( eCA )
//STRIP001 	{
//STRIP001 		case presentation::ClickAction_SOUND:
//STRIP001 		case presentation::ClickAction_VANISH:
//STRIP001 			aStr =  aEdtSound.GetText();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case presentation::ClickAction_VERB:
//STRIP001         {
//STRIP001             const USHORT nPos = aLbOLEAction.GetSelectEntryPos();
//STRIP001 
//STRIP001             if( nPos < aVerbVector.size() )
//STRIP001                 aStr = UniString::CreateFromInt32( aVerbVector[ nPos ] );
//STRIP001 
//STRIP001 			return( aStr );
//STRIP001         }
//STRIP001 
//STRIP001 		case presentation::ClickAction_DOCUMENT:
//STRIP001 			aStr = aEdtDocument.GetText();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case presentation::ClickAction_PROGRAM:
//STRIP001 			aStr = aEdtProgram.GetText();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case presentation::ClickAction_MACRO:
//STRIP001 		{
//STRIP001 			String aTmpStr = aEdtMacro.GetText();
//STRIP001 			// Currently, the macro has got following format:
//STRIP001 			// "Libname.Modulname.Macroname"
//STRIP001 			// But "aMacro" Have to be following format (because of file-format )
//STRIP001 			// "Macroname.Modulname.Libname.BASIC"
//STRIP001 			sal_Unicode cToken = '.';
//STRIP001 			aStr = aTmpStr.GetToken( 2, cToken );
//STRIP001 			aStr.Append( cToken );
//STRIP001 			aStr.Append( aTmpStr.GetToken( 1, cToken ) );
//STRIP001 			aStr.Append( cToken );
//STRIP001 			aStr.Append( aTmpStr.GetToken( 0, cToken ) );
//STRIP001 			aStr.Append( cToken );
//STRIP001 			aStr.AppendAscii( RTL_CONSTASCII_STRINGPARAM( "BASIC" ) );    // Name ist egal, wird nur wegen synt. Reihenfolge gebraucht
//STRIP001 
//STRIP001 			return aStr;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case presentation::ClickAction_BOOKMARK:
//STRIP001 			return( aEdtBookmark.GetText() );
//STRIP001 	}
//STRIP001 
//STRIP001 	// validate file URI
//STRIP001 	INetURLObject aURL( aStr );
//STRIP001 	
//STRIP001 	if( aStr.Len() && aURL.GetProtocol() == INET_PROT_NOT_VALID )
//STRIP001 		aURL = INetURLObject( so3::StaticBaseUrl::SmartRelToAbs( aStr ) );
//STRIP001 	
//STRIP001 	// get adjusted file name
//STRIP001 	aStr = aURL.GetMainURL( INetURLObject::NO_DECODE );
//STRIP001 	
//STRIP001 	if( bFullDocDestination && 
//STRIP001 		eCA == presentation::ClickAction_DOCUMENT &&
//STRIP001 		aLbTreeDocument.Control::IsVisible() &&
//STRIP001 		aLbTreeDocument.GetSelectionCount() > 0 )
//STRIP001 	{
//STRIP001 		String aTmpStr( aLbTreeDocument.GetSelectEntry() );
//STRIP001 		if( aTmpStr.Len() )
//STRIP001 		{
//STRIP001 			aStr.Append( DOCUMENT_TOKEN );
//STRIP001 			aStr.Append( aTmpStr );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return( aStr );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 USHORT SdTPAction::GetClickActionSdResId( presentation::ClickAction eCA )
//STRIP001 {
//STRIP001 	switch( eCA )
//STRIP001 	{
//STRIP001 		case presentation::ClickAction_NONE:             return STR_CLICK_ACTION_NONE;
//STRIP001 		case presentation::ClickAction_PREVPAGE:         return STR_CLICK_ACTION_PREVPAGE;
//STRIP001 		case presentation::ClickAction_NEXTPAGE:         return STR_CLICK_ACTION_NEXTPAGE;
//STRIP001 		case presentation::ClickAction_FIRSTPAGE:        return STR_CLICK_ACTION_FIRSTPAGE;
//STRIP001 		case presentation::ClickAction_LASTPAGE:         return STR_CLICK_ACTION_LASTPAGE;
//STRIP001 		case presentation::ClickAction_BOOKMARK:         return STR_CLICK_ACTION_BOOKMARK;
//STRIP001 		case presentation::ClickAction_DOCUMENT:         return STR_CLICK_ACTION_DOCUMENT;
//STRIP001 		case presentation::ClickAction_PROGRAM:          return STR_CLICK_ACTION_PROGRAM;
//STRIP001 		case presentation::ClickAction_MACRO:            return STR_CLICK_ACTION_MACRO;
//STRIP001 		case presentation::ClickAction_INVISIBLE:        return STR_CLICK_ACTION_INVISIBLE;
//STRIP001 		case presentation::ClickAction_SOUND:            return STR_CLICK_ACTION_SOUND;
//STRIP001 		case presentation::ClickAction_VERB:             return STR_CLICK_ACTION_VERB;
//STRIP001 		case presentation::ClickAction_VANISH:           return STR_CLICK_ACTION_VANISH;
//STRIP001 		case presentation::ClickAction_STOPPRESENTATION: return STR_CLICK_ACTION_STOPPRESENTATION;
//STRIP001 		default: DBG_ERROR( "Keine StringResource fuer ClickAction vorhanden!" );
//STRIP001 	}
//STRIP001 	return( 0 );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 USHORT SdTPAction::GetAnimationEffectSdResId( presentation::AnimationEffect eAE )
//STRIP001 {
//STRIP001 	switch( eAE )
//STRIP001 	{
//STRIP001 		case presentation::AnimationEffect_NONE: 					return STR_EFFECT_NONE;
//STRIP001 		case presentation::AnimationEffect_FADE_FROM_LEFT:			return STR_EFFECT_FADE_FROM_L;
//STRIP001 		case presentation::AnimationEffect_FADE_FROM_UPPERLEFT:		return STR_EFFECT_FADE_FROM_UL;
//STRIP001 		case presentation::AnimationEffect_FADE_FROM_TOP:			return STR_EFFECT_FADE_FROM_T;
//STRIP001 		case presentation::AnimationEffect_FADE_FROM_UPPERRIGHT:	return STR_EFFECT_FADE_FROM_UR;
//STRIP001 		case presentation::AnimationEffect_FADE_FROM_RIGHT:			return STR_EFFECT_FADE_FROM_R;
//STRIP001 		case presentation::AnimationEffect_FADE_FROM_LOWERRIGHT:	return STR_EFFECT_FADE_FROM_LR;
//STRIP001 		case presentation::AnimationEffect_FADE_FROM_BOTTOM:		return STR_EFFECT_FADE_FROM_B;
//STRIP001 		case presentation::AnimationEffect_FADE_FROM_LOWERLEFT:		return STR_EFFECT_FADE_FROM_LL;
//STRIP001 		case presentation::AnimationEffect_MOVE_FROM_LEFT:			return 0;
//STRIP001 		case presentation::AnimationEffect_MOVE_FROM_UPPERLEFT:		return 0;
//STRIP001 		case presentation::AnimationEffect_MOVE_FROM_TOP:			return 0;
//STRIP001 		case presentation::AnimationEffect_MOVE_FROM_UPPERRIGHT:	return 0;
//STRIP001 		case presentation::AnimationEffect_MOVE_FROM_RIGHT:			return 0;
//STRIP001 		case presentation::AnimationEffect_MOVE_FROM_LOWERRIGHT:	return 0;
//STRIP001 		case presentation::AnimationEffect_MOVE_FROM_BOTTOM:		return 0;
//STRIP001 		case presentation::AnimationEffect_MOVE_FROM_LOWERLEFT:		return 0;
//STRIP001 		case presentation::AnimationEffect_FADE_TO_CENTER:			return STR_EFFECT_FADE_TO_CENTER;
//STRIP001 		case presentation::AnimationEffect_FADE_FROM_CENTER:		return STR_EFFECT_FADE_FROM_CENTER;
//STRIP001 		case presentation::AnimationEffect_VERTICAL_STRIPES: 		return STR_EFFECT_VERTICAL_STRIPES;
//STRIP001 		case presentation::AnimationEffect_HORIZONTAL_STRIPES:		return STR_EFFECT_HORIZONTAL_STRIPES;
//STRIP001 		case presentation::AnimationEffect_VERTICAL_LINES:			return STR_EFFECT_VERTICAL_LINES;
//STRIP001 		case presentation::AnimationEffect_HORIZONTAL_LINES: 		return STR_EFFECT_HORIZONTAL_LINES;
//STRIP001 		case presentation::AnimationEffect_VERTICAL_CHECKERBOARD:	return STR_EFFECT_VERTICAL_CHECKERBOARD;
//STRIP001 		case presentation::AnimationEffect_HORIZONTAL_CHECKERBOARD:	return STR_EFFECT_HORIZONTAL_CHECKERBOARD;
//STRIP001 		case presentation::AnimationEffect_CLOCKWISE:				return STR_EFFECT_CLOCKWISE;
//STRIP001 		case presentation::AnimationEffect_COUNTERCLOCKWISE: 		return STR_EFFECT_COUNTERCLOCKWISE;
//STRIP001 		case presentation::AnimationEffect_CLOSE_VERTICAL:			return STR_EFFECT_CLOSE_VERTICAL;
//STRIP001 		case presentation::AnimationEffect_CLOSE_HORIZONTAL: 		return STR_EFFECT_CLOSE_HORIZONTAL;
//STRIP001 		case presentation::AnimationEffect_OPEN_VERTICAL:			return STR_EFFECT_OPEN_VERTICAL;
//STRIP001 		case presentation::AnimationEffect_OPEN_HORIZONTAL:			return STR_EFFECT_OPEN_HORIZONTAL;
//STRIP001 		case presentation::AnimationEffect_PATH: 					return 0;
//STRIP001 		case presentation::AnimationEffect_MOVE_TO_LEFT: 			return STR_EFFECT_MOVE_TO_L;
//STRIP001 		case presentation::AnimationEffect_MOVE_TO_UPPERLEFT: 		return STR_EFFECT_MOVE_TO_UL;
//STRIP001 		case presentation::AnimationEffect_MOVE_TO_TOP:				return STR_EFFECT_MOVE_TO_T;
//STRIP001 		case presentation::AnimationEffect_MOVE_TO_UPPERRIGHT:		return STR_EFFECT_MOVE_TO_UR;
//STRIP001 		case presentation::AnimationEffect_MOVE_TO_RIGHT:			return STR_EFFECT_MOVE_TO_R;
//STRIP001 		case presentation::AnimationEffect_MOVE_TO_LOWERRIGHT:		return STR_EFFECT_MOVE_TO_LR;
//STRIP001 		case presentation::AnimationEffect_MOVE_TO_BOTTOM:			return STR_EFFECT_MOVE_TO_B;
//STRIP001 		case presentation::AnimationEffect_MOVE_TO_LOWERLEFT:		return STR_EFFECT_MOVE_TO_LL;
//STRIP001 		case presentation::AnimationEffect_MOVE_SHORT_TO_LEFT: 		return STR_EFFECT_MOVE_S_TO_L;
//STRIP001 		case presentation::AnimationEffect_MOVE_SHORT_TO_UPPERLEFT: return STR_EFFECT_MOVE_S_TO_UL;
//STRIP001 		case presentation::AnimationEffect_MOVE_SHORT_TO_TOP:		return STR_EFFECT_MOVE_S_TO_T;
//STRIP001 		case presentation::AnimationEffect_MOVE_SHORT_TO_UPPERRIGHT:return STR_EFFECT_MOVE_S_TO_UR;
//STRIP001 		case presentation::AnimationEffect_MOVE_SHORT_TO_RIGHT:		return STR_EFFECT_MOVE_S_TO_R;
//STRIP001 		case presentation::AnimationEffect_MOVE_SHORT_TO_LOWERRIGHT:return STR_EFFECT_MOVE_S_TO_LR;
//STRIP001 		case presentation::AnimationEffect_MOVE_SHORT_TO_BOTTOM:	return STR_EFFECT_MOVE_S_TO_B;
//STRIP001 		case presentation::AnimationEffect_MOVE_SHORT_TO_LOWERLEFT:	return STR_EFFECT_MOVE_S_TO_LL;
//STRIP001 		case presentation::AnimationEffect_SPIRALIN_LEFT:			return STR_EFFECT_SPIRALIN_L;
//STRIP001 		case presentation::AnimationEffect_SPIRALIN_RIGHT:			return STR_EFFECT_SPIRALIN_R;
//STRIP001 		case presentation::AnimationEffect_SPIRALOUT_LEFT:			return STR_EFFECT_SPIRALOUT_L;
//STRIP001 		case presentation::AnimationEffect_SPIRALOUT_RIGHT:			return STR_EFFECT_SPIRALOUT_R;
//STRIP001 		case presentation::AnimationEffect_DISSOLVE: 				return STR_EFFECT_DISSOLVE;
//STRIP001 		case presentation::AnimationEffect_WAVYLINE_FROM_LEFT:		return STR_EFFECT_WAVYLINE_FROM_L;
//STRIP001 		case presentation::AnimationEffect_WAVYLINE_FROM_RIGHT:		return STR_EFFECT_WAVYLINE_FROM_R;
//STRIP001 		case presentation::AnimationEffect_WAVYLINE_FROM_TOP:		return STR_EFFECT_WAVYLINE_FROM_T;
//STRIP001 		case presentation::AnimationEffect_WAVYLINE_FROM_BOTTOM:	return STR_EFFECT_WAVYLINE_FROM_B;
//STRIP001 		case presentation::AnimationEffect_RANDOM:					return STR_EFFECT_RANDOM;
//STRIP001 		case presentation::AnimationEffect_LASER_FROM_LEFT:			return 0;
//STRIP001 		case presentation::AnimationEffect_LASER_FROM_TOP:			return 0;
//STRIP001 		case presentation::AnimationEffect_LASER_FROM_RIGHT: 		return 0;
//STRIP001 		case presentation::AnimationEffect_LASER_FROM_BOTTOM:		return 0;
//STRIP001 		case presentation::AnimationEffect_LASER_FROM_UPPERLEFT:	return 0;
//STRIP001 		case presentation::AnimationEffect_LASER_FROM_UPPERRIGHT:	return 0;
//STRIP001 		case presentation::AnimationEffect_LASER_FROM_LOWERLEFT:	return 0;
//STRIP001 		case presentation::AnimationEffect_LASER_FROM_LOWERRIGHT:	return 0;
//STRIP001 
//STRIP001 		default:
//STRIP001 			DBG_ERROR( "Keine StringResource fuer AnimationEffect vorhanden!" );
//STRIP001 	}
//STRIP001 	return( 0 );
//STRIP001 }


}
