/*************************************************************************
 *
 *  $RCSfile: sd_fucopy.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:47:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

// auto strip #ifndef _SFX_PROGRESS_HXX
// auto strip #include <bf_sfx2/progress.hxx>
// auto strip #endif
#include <bf_svx/svxids.hrc>

// auto strip #include "sdresid.hxx"
// auto strip #include "sdattr.hxx"
#include "strings.hrc"
// auto strip #include "viewshel.hxx"
// auto strip #include "sdview.hxx"
// auto strip #include "fucopy.hxx"
// auto strip #include "copydlg.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "docshell.hxx"

// auto strip #ifndef _SV_WRKWIN_HXX
// auto strip #include <vcl/wrkwin.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOBJ_HXX //autogen
// auto strip #include <bf_svx/svdobj.hxx>
// auto strip #endif
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _SFXAPP_HXX //autogen
// auto strip #include <bf_sfx2/app.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XCOLORITEM_HXX //autogen
// auto strip #include <bf_svx/xcolit.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XFLCLIT_HXX //autogen
// auto strip #include <bf_svx/xflclit.hxx>
// auto strip #endif
// auto strip #ifndef _XDEF_HXX //autogen
// auto strip #include <bf_svx/xdef.hxx>
// auto strip #endif
// auto strip #ifndef SVX_XFILLIT0_HXX //autogen
// auto strip #include <bf_svx/xfillit0.hxx>
// auto strip #endif
// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif
namespace binfilter {

//STRIP001 TYPEINIT1( FuCopy, FuPoor );
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuCopy::FuCopy(SdViewShell* pViewSh, SdWindow* pWin, SdView* pView,
//STRIP001 						 SdDrawDocument* pDoc, SfxRequest& rReq)
//STRIP001 	: FuPoor(pViewSh, pWin, pView, pDoc, rReq)
//STRIP001 {
//STRIP001 	if( pView->HasMarkedObj() )
//STRIP001 	{
//STRIP001 		// Undo
//STRIP001 		String aString( pView->GetMarkDescription() );
//STRIP001 		aString.Append( sal_Unicode(' ') );
//STRIP001 		aString.Append( String( SdResId( STR_UNDO_COPYOBJECTS ) ) );
//STRIP001 		pView->BegUndo( aString );
//STRIP001 
//STRIP001 		const SfxItemSet* pArgs = rReq.GetArgs();
//STRIP001 
//STRIP001 		if( !pArgs )
//STRIP001 		{
//STRIP001 			SfxItemSet aSet( pViewSh->GetPool(),
//STRIP001 								ATTR_COPY_START, ATTR_COPY_END, 0 );
//STRIP001 
//STRIP001 			// Farb-Attribut angeben
//STRIP001 			SfxItemSet aAttr( pDoc->GetPool() );
//STRIP001 			pView->GetAttributes( aAttr );
//STRIP001 			const SfxPoolItem*	pPoolItem = NULL;
//STRIP001 
//STRIP001 			if( SFX_ITEM_SET == aAttr.GetItemState( XATTR_FILLSTYLE, TRUE, &pPoolItem ) )
//STRIP001 			{
//STRIP001 				XFillStyle eStyle = ( ( const XFillStyleItem* ) pPoolItem )->GetValue();
//STRIP001 
//STRIP001 				if( eStyle == XFILL_SOLID &&
//STRIP001 					SFX_ITEM_SET == aAttr.GetItemState( XATTR_FILLCOLOR, TRUE, &pPoolItem ) )
//STRIP001 				{
//STRIP001 					const XFillColorItem* pItem = ( const XFillColorItem* ) pPoolItem;
//STRIP001 					XColorItem aXColorItem( ATTR_COPY_START_COLOR, pItem->GetName(),
//STRIP001 														pItem->GetValue() );
//STRIP001 					aSet.Put( aXColorItem );
//STRIP001 
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			SdCopyDlg*  pDlg = new SdCopyDlg( NULL, aSet, pDoc->GetColorTable(), pView );
//STRIP001 			USHORT      nResult = pDlg->Execute();
//STRIP001 
//STRIP001 			switch( nResult )
//STRIP001 			{
//STRIP001 				case RET_OK:
//STRIP001 					pDlg->GetAttr( aSet );
//STRIP001 					rReq.Done( aSet );
//STRIP001 					pArgs = rReq.GetArgs();
//STRIP001 				break;
//STRIP001 
//STRIP001 				default:
//STRIP001 				{
//STRIP001 					delete pDlg;
//STRIP001 					pView->EndUndo();
//STRIP001 				}
//STRIP001 				return; // Abbruch
//STRIP001 			}
//STRIP001 			delete( pDlg );
//STRIP001 		}
//STRIP001 
//STRIP001 		Rectangle	        aRect;
//STRIP001 		INT32		        lWidth, lHeight, lSizeX = 0L, lSizeY = 0L, lAngle = 0L;
//STRIP001 		UINT16		        nNumber = 0;
//STRIP001 		Color		        aStartColor, aEndColor;
//STRIP001 		BOOL		        bColor = FALSE;
//STRIP001 		const SfxPoolItem*  pPoolItem = NULL;
//STRIP001 
//STRIP001 		// Anzahl
//STRIP001 		if( SFX_ITEM_SET == pArgs->GetItemState( ATTR_COPY_NUMBER, TRUE, &pPoolItem ) )
//STRIP001 			nNumber = ( ( const SfxUInt16Item* ) pPoolItem )->GetValue();
//STRIP001 
//STRIP001 		// Verschiebung
//STRIP001 		if( SFX_ITEM_SET == pArgs->GetItemState( ATTR_COPY_MOVE_X, TRUE, &pPoolItem ) )
//STRIP001 			lSizeX = ( ( const SfxInt32Item* ) pPoolItem )->GetValue();
//STRIP001 		if( SFX_ITEM_SET == pArgs->GetItemState( ATTR_COPY_MOVE_Y, TRUE, &pPoolItem ) )
//STRIP001 			lSizeY = ( ( const SfxInt32Item* ) pPoolItem )->GetValue();
//STRIP001 		if( SFX_ITEM_SET == pArgs->GetItemState( ATTR_COPY_ANGLE, TRUE, &pPoolItem ) )
//STRIP001 			lAngle = ( ( const SfxInt32Item* )pPoolItem )->GetValue();
//STRIP001 
//STRIP001 		// Verrgroesserung / Verkleinerung
//STRIP001 		if( SFX_ITEM_SET == pArgs->GetItemState( ATTR_COPY_WIDTH, TRUE, &pPoolItem ) )
//STRIP001 			lWidth = ( ( const SfxInt32Item* ) pPoolItem )->GetValue();
//STRIP001 		if( SFX_ITEM_SET == pArgs->GetItemState( ATTR_COPY_HEIGHT, TRUE, &pPoolItem ) )
//STRIP001 			lHeight = ( ( const SfxInt32Item* ) pPoolItem )->GetValue();
//STRIP001 
//STRIP001 		// Startfarbe / Endfarbe
//STRIP001 		if( SFX_ITEM_SET == pArgs->GetItemState( ATTR_COPY_START_COLOR, TRUE, &pPoolItem ) )
//STRIP001 		{
//STRIP001 			aStartColor = ( ( const XColorItem* ) pPoolItem )->GetValue();
//STRIP001 			bColor = TRUE;
//STRIP001 		}
//STRIP001 		if( SFX_ITEM_SET == pArgs->GetItemState( ATTR_COPY_END_COLOR, TRUE, &pPoolItem ) )
//STRIP001 		{
//STRIP001 			aEndColor = ( ( const XColorItem* ) pPoolItem )->GetValue();
//STRIP001 			if( aStartColor == aEndColor )
//STRIP001 				bColor = FALSE;
//STRIP001 		}
//STRIP001 		else
//STRIP001 			bColor = FALSE;
//STRIP001 
//STRIP001 		// Handles wegnehmen
//STRIP001 		pView->HideMarkHdl( NULL );
//STRIP001 
//STRIP001 		SfxProgress*    pProgress = NULL;
//STRIP001 		BOOL            bWaiting = FALSE;
//STRIP001 
//STRIP001 		if( nNumber > 1 )
//STRIP001 		{
//STRIP001 			String aStr( SdResId( STR_OBJECTS ) );
//STRIP001 			aStr.Append( sal_Unicode(' ') );
//STRIP001 			aStr.Append( String( SdResId( STR_UNDO_COPYOBJECTS ) ) );
//STRIP001 
//STRIP001 			pProgress = new SfxProgress( pDocSh, aStr, nNumber );
//STRIP001 			pDocSh->SetWaitCursor( TRUE );
//STRIP001 			bWaiting = TRUE;
//STRIP001 		}
//STRIP001 
//STRIP001 		const SdrMarkList 	aMarkList( pView->GetMarkList() );
//STRIP001 		const ULONG			nMarkCount = aMarkList.GetMarkCount();
//STRIP001 		SdrPageView*	    pPageView = pView->GetPageViewPvNum( 0 );
//STRIP001 		SdrObject*		    pObj = NULL;
//STRIP001 
//STRIP001 		// Anzahl moeglicher Kopien berechnen
//STRIP001 		aRect = pView->GetAllMarkedRect();
//STRIP001 		
//STRIP001 		if( lWidth < 0L )
//STRIP001 		{
//STRIP001 			long nTmp = ( aRect.Right() - aRect.Left() ) / -lWidth;
//STRIP001 			nNumber = (UINT16) Min( nTmp, (long)nNumber );
//STRIP001 		}
//STRIP001 		
//STRIP001 		if( lHeight < 0L )
//STRIP001 		{
//STRIP001 			long nTmp = ( aRect.Bottom() - aRect.Top() ) / -lHeight;
//STRIP001 			nNumber = (UINT16) Min( nTmp, (long)nNumber );
//STRIP001 		}
//STRIP001 
//STRIP001 		for( USHORT i = 1; i <= nNumber; i++ )
//STRIP001 		{
//STRIP001 			if( pProgress )
//STRIP001 				pProgress->SetState( i );
//STRIP001 
//STRIP001 			aRect = pView->GetAllMarkedRect();
//STRIP001 
//STRIP001 			if( ( 1 == i ) && bColor )
//STRIP001 			{
//STRIP001 				SfxItemSet aNewSet( pViewSh->GetPool(), XATTR_FILLSTYLE, XATTR_FILLCOLOR, 0L );
//STRIP001 				aNewSet.Put( XFillStyleItem( XFILL_SOLID ) );
//STRIP001 				aNewSet.Put( XFillColorItem( String(), aStartColor ) );
//STRIP001 				pView->SetAttributes( aNewSet );
//STRIP001 			}
//STRIP001 
//STRIP001 			// make a copy of selected objects
//STRIP001 			pView->CopyMarked();
//STRIP001 			
//STRIP001     		// get newly selected objects 
//STRIP001     		SdrMarkList aCopyMarkList( pView->GetMarkList() );
//STRIP001 	    	ULONG		j, nCopyMarkCount = aMarkList.GetMarkCount();
//STRIP001 				
//STRIP001 			// set protection flags at marked copies to null
//STRIP001 			for( j = 0; j < nCopyMarkCount; j++ )
//STRIP001 			{
//STRIP001 				pObj = aCopyMarkList.GetMark( j )->GetObj();
//STRIP001 				
//STRIP001 				if( pObj )
//STRIP001 				{
//STRIP001 					pObj->SetMoveProtect( FALSE );
//STRIP001 					pObj->SetResizeProtect( FALSE );
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			Fraction aWidth( aRect.Right() - aRect.Left() + lWidth, aRect.Right() - aRect.Left() );
//STRIP001 			Fraction aHeight( aRect.Bottom() - aRect.Top() + lHeight, aRect.Bottom() - aRect.Top() );
//STRIP001 
//STRIP001 			if( pView->IsResizeAllowed() )
//STRIP001 				pView->ResizeAllMarked( aRect.TopLeft(), aWidth, aHeight );
//STRIP001 
//STRIP001 			if( pView->IsRotateAllowed() )
//STRIP001 				pView->RotateAllMarked( aRect.Center(), lAngle * 100 );
//STRIP001 
//STRIP001 			if( pView->IsMoveAllowed() )
//STRIP001 				pView->MoveAllMarked( Size( lSizeX, lSizeY ) );
//STRIP001 			
//STRIP001 			// set protection flags at marked copies to original values
//STRIP001 			if( nMarkCount == nCopyMarkCount )
//STRIP001 			{
//STRIP001 			    for( j = 0; j < nMarkCount; j++ )
//STRIP001 			    {
//STRIP001 			        SdrObject* pSrcObj = aMarkList.GetMark( j )->GetObj();
//STRIP001 			        SdrObject* pDstObj = aCopyMarkList.GetMark( j )->GetObj();
//STRIP001 			    
//STRIP001 				    if( pSrcObj && pDstObj && 
//STRIP001 				        ( pSrcObj->GetObjInventor() == pDstObj->GetObjInventor() ) &&
//STRIP001 				        ( pSrcObj->GetObjIdentifier() == pDstObj->GetObjIdentifier() ) )
//STRIP001 				    {
//STRIP001 					    pDstObj->SetMoveProtect( pSrcObj->IsMoveProtect() );
//STRIP001 					    pDstObj->SetResizeProtect( pSrcObj->IsResizeProtect() );
//STRIP001 				    }
//STRIP001 			    }
//STRIP001 			}
//STRIP001 
//STRIP001 			if( bColor )
//STRIP001 			{
//STRIP001 				// Koennte man sicher noch optimieren, wuerde aber u.U.
//STRIP001 				// zu Rundungsfehlern fuehren
//STRIP001 				BYTE nRed = aStartColor.GetRed() + (BYTE) ( ( (long) aEndColor.GetRed() - (long) aStartColor.GetRed() ) * (long) i / (long) nNumber  );
//STRIP001 				BYTE nGreen = aStartColor.GetGreen() + (BYTE) ( ( (long) aEndColor.GetGreen() - (long) aStartColor.GetGreen() ) *  (long) i / (long) nNumber );
//STRIP001 				BYTE nBlue = aStartColor.GetBlue() + (BYTE) ( ( (long) aEndColor.GetBlue() - (long) aStartColor.GetBlue() ) * (long) i / (long) nNumber );
//STRIP001 				Color aNewColor( nRed, nGreen, nBlue );
//STRIP001 				SfxItemSet aNewSet( pViewSh->GetPool(), XATTR_FILLSTYLE, XATTR_FILLCOLOR, 0L );
//STRIP001 				aNewSet.Put( XFillStyleItem( XFILL_SOLID ) );
//STRIP001 				aNewSet.Put( XFillColorItem( String(), aNewColor ) );
//STRIP001 				pView->SetAttributes( aNewSet );
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		if ( pProgress )
//STRIP001 			delete pProgress;
//STRIP001 
//STRIP001 		if ( bWaiting )
//STRIP001 			pDocSh->SetWaitCursor( FALSE );
//STRIP001 
//STRIP001 		// Handles zeigen
//STRIP001 		pView->AdjustMarkHdl( TRUE );
//STRIP001 		pView->ShowMarkHdl( NULL );
//STRIP001 
//STRIP001 		pView->EndUndo();
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Dtor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuCopy::~FuCopy()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function aktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuCopy::Activate()
//STRIP001 {
//STRIP001 	FuPoor::Activate();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function deaktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuCopy::Deactivate()
//STRIP001 {
//STRIP001 	FuPoor::Deactivate();
//STRIP001 }


}
