/*************************************************************************
 *
 *  $RCSfile: sd_fuoaprms.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:50:13 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop



#include "sdattr.hxx"
#define ITEMID_COLOR			ATTR_ANIMATION_COLOR
// auto strip #ifndef _SVDPAGV_HXX //autogen
// auto strip #include <bf_svx/svdpagv.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_COLRITEM_HXX //autogen
// auto strip #include <bf_svx/colritem.hxx>
// auto strip #endif
// auto strip #ifndef _SVDUNDO_HXX //autogen
// auto strip #include <bf_svx/svdundo.hxx>
// auto strip #endif
// auto strip #ifndef _SV_GROUP_HXX //autogen
// auto strip #include <vcl/group.hxx>
// auto strip #endif
// auto strip #ifndef _SV_FIXED_HXX //autogen
// auto strip #include <vcl/fixed.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_OBJSH_HXX //autogen
// auto strip #include <bf_sfx2/objsh.hxx>
// auto strip #endif
// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif
// auto strip #ifndef _MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _AEITEM_HXX //autogen
// auto strip #include <svtools/aeitem.hxx>
// auto strip #endif
// auto strip #include "bf_svx/xtable.hxx"

#include "strings.hrc"
// auto strip #include "fuoaprms.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "viewshel.hxx"
// auto strip #include "anminfo.hxx"
// auto strip #include "unoaprms.hxx"                 // Undo-Action
// auto strip #include "sdundogr.hxx"                 // Undo Gruppe
// auto strip #include "sdview.hxx"
// auto strip #include "tpaction.hxx"
// auto strip #include "preview.hxx"
// auto strip #include "prevchld.hxx"
namespace binfilter {

using namespace ::com::sun::star;

//STRIP001 TYPEINIT1( FuObjectAnimationParameters, FuPoor );
//STRIP001 
//STRIP001 #define ATTR_MISSING    0       // Attribut nicht verfuegbar
//STRIP001 #define ATTR_MIXED      1       // Attribut uneindeutig (bei Mehrfachselektion)
//STRIP001 #define ATTR_SET        2       // Attribut eindeutig
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuObjectAnimationParameters::FuObjectAnimationParameters
//STRIP001 									(SdViewShell*	 pViewSh,
//STRIP001 									 SdWindow*		 pWin,
//STRIP001 									 SdView*		 pView,
//STRIP001 									 SdDrawDocument* pDoc,
//STRIP001 									 SfxRequest&	 rReq)
//STRIP001 	: FuPoor(pViewSh, pWin, pView, pDoc, rReq)
//STRIP001 {
//STRIP001 	BOOL bOnMaster = pView->GetPageViewPvNum(0)->GetPage()->IsMasterPage();
//STRIP001 	SfxUndoManager* pUndoMgr = pViewSh->GetViewFrame()->GetObjectShell()->
//STRIP001 								GetUndoManager();
//STRIP001 
//STRIP001 	const SdrMarkList& rMarkList  = pView->GetMarkList();
//STRIP001 	ULONG		 nCount 	= rMarkList.GetMarkCount();
//STRIP001 	ULONG		 nObject	= 0;
//STRIP001 
//STRIP001 	short nAnimationSet     = ATTR_MISSING;
//STRIP001 	short nEffectSet        = ATTR_MISSING;
//STRIP001 	short nTextEffectSet    = ATTR_MISSING;
//STRIP001 	short nSpeedSet         = ATTR_MISSING;
//STRIP001 	short nFadeColorSet     = ATTR_MISSING;
//STRIP001 	short nFadeOutSet       = ATTR_MISSING;
//STRIP001 	short nInvisibleSet     = ATTR_MISSING;
//STRIP001 	short nSoundOnSet       = ATTR_MISSING;
//STRIP001 	short nSoundFileSet     = ATTR_MISSING;
//STRIP001 	short nPlayFullSet      = ATTR_MISSING;
//STRIP001 	short nClickActionSet   = ATTR_MISSING;
//STRIP001 	short nBookmarkSet      = ATTR_MISSING;
//STRIP001 
//STRIP001 	short nSecondEffectSet      = ATTR_MISSING;
//STRIP001 	short nSecondSpeedSet       = ATTR_MISSING;
//STRIP001 	short nSecondSoundOnSet     = ATTR_MISSING;
//STRIP001 	short nSecondPlayFullSet    = ATTR_MISSING;
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 //    BOOL bDontKnow   = FALSE;
//STRIP001 
//STRIP001 									// defaulten (fuer Undo-Aktion)
//STRIP001 	presentation::AnimationEffect eEffect         = presentation::AnimationEffect_NONE;
//STRIP001 	presentation::AnimationEffect eTextEffect     = presentation::AnimationEffect_NONE;
//STRIP001 	presentation::AnimationSpeed  eSpeed          = presentation::AnimationSpeed_MEDIUM;
//STRIP001 	BOOL            bActive         = FALSE;
//STRIP001 	BOOL            bFadeOut        = FALSE;
//STRIP001 	Color           aFadeColor      = COL_LIGHTGRAY;
//STRIP001 	BOOL            bInvisible      = FALSE;
//STRIP001 	BOOL            bSoundOn        = FALSE;
//STRIP001 	String          aSound;
//STRIP001 	BOOL            bPlayFull       = FALSE;
//STRIP001 	presentation::ClickAction     eClickAction    = presentation::ClickAction_NONE;
//STRIP001 	String          aBookmark;
//STRIP001 
//STRIP001 	presentation::AnimationEffect eSecondEffect   = presentation::AnimationEffect_NONE;
//STRIP001 	presentation::AnimationSpeed  eSecondSpeed    = presentation::AnimationSpeed_MEDIUM;
//STRIP001 	BOOL            bSecondSoundOn  = FALSE;
//STRIP001 	BOOL            bSecondPlayFull = FALSE;
//STRIP001 
//STRIP001 
//STRIP001 	SdAnimationInfo* pInfo;
//STRIP001 	SdrMark* pMark;
//STRIP001 
//STRIP001 	// das erste Objekt untersuchen
//STRIP001 	pMark = rMarkList.GetMark(0);
//STRIP001 	SdrObject* pObject = pMark->GetObj();
//STRIP001 	pInfo = pDoc->GetAnimationInfo(pObject);
//STRIP001 	if( pInfo )
//STRIP001 	{
//STRIP001 		bActive             = pInfo->bActive;
//STRIP001 		nAnimationSet       = ATTR_SET;
//STRIP001 
//STRIP001 		eEffect             = pInfo->eEffect;
//STRIP001 		nEffectSet          = ATTR_SET;
//STRIP001 
//STRIP001 		eTextEffect         = pInfo->eTextEffect;
//STRIP001 		nTextEffectSet      = ATTR_SET;
//STRIP001 
//STRIP001 		eSpeed              = pInfo->eSpeed;
//STRIP001 		nSpeedSet           = ATTR_SET;
//STRIP001 
//STRIP001 		bFadeOut            = pInfo->bDimPrevious;
//STRIP001 		nFadeOutSet         = ATTR_SET;
//STRIP001 
//STRIP001 		aFadeColor          = pInfo->aDimColor;
//STRIP001 		nFadeColorSet       = ATTR_SET;
//STRIP001 
//STRIP001 		bInvisible          = pInfo->bDimHide;
//STRIP001 		nInvisibleSet       = ATTR_SET;
//STRIP001 
//STRIP001 		bSoundOn            = pInfo->bSoundOn;
//STRIP001 		nSoundOnSet         = ATTR_SET;
//STRIP001 
//STRIP001 		aSound              = pInfo->aSoundFile;
//STRIP001 		nSoundFileSet       = ATTR_SET;
//STRIP001 
//STRIP001 		bPlayFull           = pInfo->bPlayFull;
//STRIP001 		nPlayFullSet        = ATTR_SET;
//STRIP001 
//STRIP001 		eClickAction        = pInfo->eClickAction;
//STRIP001 		nClickActionSet     = ATTR_SET;
//STRIP001 
//STRIP001 		aBookmark           = pInfo->aBookmark;
//STRIP001 		nBookmarkSet        = ATTR_SET;
//STRIP001 
//STRIP001 		eSecondEffect       = pInfo->eSecondEffect;
//STRIP001 		nSecondEffectSet    = ATTR_SET;
//STRIP001 
//STRIP001 		eSecondSpeed        = pInfo->eSecondSpeed;
//STRIP001 		nSecondSpeedSet     = ATTR_SET;
//STRIP001 
//STRIP001 		bSecondSoundOn      = pInfo->bSecondSoundOn;
//STRIP001 		nSecondSoundOnSet   = ATTR_SET;
//STRIP001 
//STRIP001 		bSecondPlayFull     = pInfo->bSecondPlayFull;
//STRIP001 		nSecondPlayFullSet  = ATTR_SET;
//STRIP001 	}
//STRIP001 
//STRIP001 	// ggfs. weitere Objekte untersuchen
//STRIP001 	for( nObject = 1; nObject < nCount; nObject++ )
//STRIP001 	{
//STRIP001 		pMark = rMarkList.GetMark( nObject );
//STRIP001 		SdrObject* pObject = pMark->GetObj();
//STRIP001 		pInfo = pDoc->GetAnimationInfo(pObject);
//STRIP001 		if( pInfo )
//STRIP001 		{
//STRIP001 			if( bActive != pInfo->bActive )
//STRIP001 				nAnimationSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if( eEffect != pInfo->eEffect )
//STRIP001 				nEffectSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if( eTextEffect != pInfo->eTextEffect )
//STRIP001 				nTextEffectSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if( eSpeed != pInfo->eSpeed )
//STRIP001 				nSpeedSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if( bFadeOut != pInfo->bDimPrevious )
//STRIP001 				nFadeOutSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if( aFadeColor != pInfo->aDimColor )
//STRIP001 				nFadeColorSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if( bInvisible != pInfo->bDimHide )
//STRIP001 				nInvisibleSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if( bSoundOn != pInfo->bSoundOn )
//STRIP001 				nSoundOnSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if( aSound != pInfo->aSoundFile )
//STRIP001 				nSoundFileSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if( bPlayFull != pInfo->bPlayFull )
//STRIP001 				nPlayFullSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if( eClickAction != pInfo->eClickAction )
//STRIP001 				nClickActionSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if( aBookmark != pInfo->aBookmark )
//STRIP001 				nBookmarkSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if( eSecondEffect != pInfo->eSecondEffect )
//STRIP001 				nSecondEffectSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if( eSecondSpeed != pInfo->eSecondSpeed )
//STRIP001 				nSecondSpeedSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if( bSecondSoundOn != pInfo->bSecondSoundOn )
//STRIP001 				nSecondSoundOnSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if( bSecondPlayFull != pInfo->bSecondPlayFull )
//STRIP001 				nSecondPlayFullSet = ATTR_MIXED;
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			if (nAnimationSet == ATTR_SET && bActive == TRUE)
//STRIP001 				nAnimationSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if (nEffectSet == ATTR_SET && eEffect != presentation::AnimationEffect_NONE)
//STRIP001 				nEffectSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if (nTextEffectSet == ATTR_SET && eTextEffect != presentation::AnimationEffect_NONE)
//STRIP001 				nTextEffectSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if (nSpeedSet == ATTR_SET)
//STRIP001 				nSpeedSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if (nFadeOutSet == ATTR_SET && bFadeOut == TRUE)
//STRIP001 				nFadeOutSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if (nFadeColorSet == ATTR_SET)
//STRIP001 				nFadeColorSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if (nInvisibleSet == ATTR_SET && bInvisible == TRUE)
//STRIP001 				nInvisibleSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if (nSoundOnSet == ATTR_SET && bSoundOn == TRUE)
//STRIP001 				nSoundOnSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if (nSoundFileSet == ATTR_SET)
//STRIP001 				nSoundFileSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if (nPlayFullSet == ATTR_SET && bPlayFull == TRUE)
//STRIP001 				nPlayFullSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if (nClickActionSet == ATTR_SET && eClickAction != presentation::ClickAction_NONE)
//STRIP001 				nClickActionSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if (nBookmarkSet == ATTR_SET)
//STRIP001 				nBookmarkSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if (nSecondEffectSet == ATTR_SET && eSecondEffect != presentation::AnimationEffect_NONE)
//STRIP001 				nSecondEffectSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if (nSecondSpeedSet == ATTR_SET)
//STRIP001 				nSecondSpeedSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if (nSecondSoundOnSet == ATTR_SET && bSecondSoundOn == TRUE)
//STRIP001 				nSecondSoundOnSet = ATTR_MIXED;
//STRIP001 
//STRIP001 			if (nSecondPlayFullSet == ATTR_SET && bSecondPlayFull == TRUE)
//STRIP001 				nSecondPlayFullSet = ATTR_MIXED;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	// Genau zwei Objekte mit Pfadeffekt? Dann gilt nur die Animationsinfo
//STRIP001 	// am bewegten Objekt.
//STRIP001 	if (nCount == 2)
//STRIP001 	{
//STRIP001 		SdrObject* pObject1 = rMarkList.GetMark(0)->GetObj();
//STRIP001 		SdrObject* pObject2 = rMarkList.GetMark(1)->GetObj();
//STRIP001 		SdrObjKind eKind1   = (SdrObjKind)pObject1->GetObjIdentifier();
//STRIP001 		SdrObjKind eKind2   = (SdrObjKind)pObject2->GetObjIdentifier();
//STRIP001 		SdAnimationInfo* pInfo1 = pDoc->GetAnimationInfo(pObject1);
//STRIP001 		SdAnimationInfo* pInfo2 = pDoc->GetAnimationInfo(pObject2);
//STRIP001 		SdAnimationInfo* pInfo  = NULL;
//STRIP001 
//STRIP001 		if (pObject1->GetObjInventor() == SdrInventor &&
//STRIP001 			((eKind1 == OBJ_LINE) ||                        // 2-Punkt-Linie
//STRIP001 			 (eKind1 == OBJ_PLIN) ||                        // Polygon
//STRIP001 			 (eKind1 == OBJ_PATHLINE))                &&    // Bezier-Kurve
//STRIP001 			 (pInfo2 && pInfo2->eEffect == presentation::AnimationEffect_PATH))
//STRIP001 		{
//STRIP001 			pInfo = pInfo2;
//STRIP001 		}
//STRIP001 
//STRIP001 		if (pObject2->GetObjInventor() == SdrInventor &&
//STRIP001 			((eKind2 == OBJ_LINE) ||                        // 2-Punkt-Linie
//STRIP001 			 (eKind2 == OBJ_PLIN) ||                        // Polygon
//STRIP001 			 (eKind2 == OBJ_PATHLINE))                &&    // Bezier-Kurve
//STRIP001 			(pInfo1 && pInfo1->eEffect == presentation::AnimationEffect_PATH))
//STRIP001 		{
//STRIP001 			pInfo = pInfo1;
//STRIP001 		}
//STRIP001 
//STRIP001 		if (pInfo)
//STRIP001 		{
//STRIP001 			bActive         = pInfo->bActive;          nAnimationSet       = ATTR_SET;
//STRIP001 			eEffect         = pInfo->eEffect;          nEffectSet          = ATTR_SET;
//STRIP001 			eTextEffect     = pInfo->eTextEffect;      nTextEffectSet      = ATTR_SET;
//STRIP001 			eSpeed          = pInfo->eSpeed;           nSpeedSet           = ATTR_SET;
//STRIP001 			bFadeOut        = pInfo->bDimPrevious;     nFadeOutSet         = ATTR_SET;
//STRIP001 			aFadeColor      = pInfo->aDimColor;        nFadeColorSet       = ATTR_SET;
//STRIP001 			bInvisible      = pInfo->bDimHide;         nInvisibleSet       = ATTR_SET;
//STRIP001 			bSoundOn        = pInfo->bSoundOn;         nSoundOnSet         = ATTR_SET;
//STRIP001 			aSound          = pInfo->aSoundFile;       nSoundFileSet       = ATTR_SET;
//STRIP001 			bPlayFull       = pInfo->bPlayFull;        nPlayFullSet        = ATTR_SET;
//STRIP001 			eClickAction    = pInfo->eClickAction;     nClickActionSet     = ATTR_SET;
//STRIP001 			aBookmark       = pInfo->aBookmark;        nBookmarkSet        = ATTR_SET;
//STRIP001 			eSecondEffect   = pInfo->eSecondEffect;    nSecondEffectSet    = ATTR_SET;
//STRIP001 			eSecondSpeed    = pInfo->eSecondSpeed;     nSecondSpeedSet     = ATTR_SET;
//STRIP001 			bSecondSoundOn  = pInfo->bSecondSoundOn;   nSecondSoundOnSet   = ATTR_SET;
//STRIP001 			bSecondPlayFull = pInfo->bSecondPlayFull;  nSecondPlayFullSet  = ATTR_SET;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	const SfxItemSet* pArgs = rReq.GetArgs();
//STRIP001 
//STRIP001 	if(!pArgs)
//STRIP001 	{
//STRIP001 		// ItemSet fuer Dialog fuellen
//STRIP001 		SfxItemSet aSet(pDoc->GetPool(), ATTR_ANIMATION_START, ATTR_ACTION_END);
//STRIP001 
//STRIP001 		// das Set besetzen
//STRIP001 		if (nAnimationSet == ATTR_SET)
//STRIP001 			aSet.Put( SfxBoolItem( ATTR_ANIMATION_ACTIVE, bActive));
//STRIP001 		else if (nAnimationSet == ATTR_MIXED)
//STRIP001 			aSet.InvalidateItem(ATTR_ANIMATION_ACTIVE);
//STRIP001 		else
//STRIP001 			aSet.Put(SfxBoolItem(ATTR_ANIMATION_ACTIVE, FALSE));
//STRIP001 
//STRIP001 		if (nEffectSet == ATTR_SET)
//STRIP001 			aSet.Put(SfxAllEnumItem(ATTR_ANIMATION_EFFECT, eEffect));
//STRIP001 		else if (nEffectSet == ATTR_MIXED)
//STRIP001 			aSet.InvalidateItem( ATTR_ANIMATION_EFFECT );
//STRIP001 		else
//STRIP001 			aSet.Put(SfxAllEnumItem(ATTR_ANIMATION_EFFECT, presentation::AnimationEffect_NONE));
//STRIP001 
//STRIP001 		if (nTextEffectSet == ATTR_SET)
//STRIP001 			aSet.Put(SfxAllEnumItem(ATTR_ANIMATION_TEXTEFFECT, eTextEffect));
//STRIP001 		else if (nTextEffectSet == ATTR_MIXED)
//STRIP001 			aSet.InvalidateItem( ATTR_ANIMATION_TEXTEFFECT );
//STRIP001 		else
//STRIP001 			aSet.Put(SfxAllEnumItem(ATTR_ANIMATION_TEXTEFFECT, presentation::AnimationEffect_NONE));
//STRIP001 
//STRIP001 		if (nSpeedSet == ATTR_SET)
//STRIP001 			aSet.Put(SfxAllEnumItem(ATTR_ANIMATION_SPEED, eSpeed));
//STRIP001 		else
//STRIP001 			aSet.InvalidateItem(ATTR_ANIMATION_SPEED);
//STRIP001 
//STRIP001 		if (nFadeOutSet == ATTR_SET)
//STRIP001 			aSet.Put(SfxBoolItem(ATTR_ANIMATION_FADEOUT, bFadeOut));
//STRIP001 		else if (nFadeOutSet == ATTR_MIXED)
//STRIP001 			aSet.InvalidateItem(ATTR_ANIMATION_FADEOUT);
//STRIP001 		else
//STRIP001 			aSet.Put(SfxBoolItem(ATTR_ANIMATION_FADEOUT, FALSE));
//STRIP001 
//STRIP001 		if (nFadeColorSet == ATTR_SET)
//STRIP001 			aSet.Put(SvxColorItem(aFadeColor, ATTR_ANIMATION_COLOR));
//STRIP001 		else if (nFadeColorSet == ATTR_MIXED)
//STRIP001 			aSet.InvalidateItem(ATTR_ANIMATION_COLOR);
//STRIP001 		else
//STRIP001 			aSet.Put(SvxColorItem(RGB_Color(COL_LIGHTGRAY), ATTR_ANIMATION_COLOR));
//STRIP001 
//STRIP001 		if (nInvisibleSet == ATTR_SET)
//STRIP001 			aSet.Put(SfxBoolItem(ATTR_ANIMATION_INVISIBLE, bInvisible));
//STRIP001 		else if (nInvisibleSet == ATTR_MIXED)
//STRIP001 			aSet.InvalidateItem(ATTR_ANIMATION_INVISIBLE);
//STRIP001 		else
//STRIP001 			aSet.Put(SfxBoolItem(ATTR_ANIMATION_INVISIBLE, FALSE));
//STRIP001 
//STRIP001 		if (nSoundOnSet == ATTR_SET)
//STRIP001 			aSet.Put(SfxBoolItem(ATTR_ANIMATION_SOUNDON, bSoundOn));
//STRIP001 		else if (nSoundOnSet == ATTR_MIXED)
//STRIP001 			aSet.InvalidateItem(ATTR_ANIMATION_SOUNDON);
//STRIP001 		else
//STRIP001 			aSet.Put(SfxBoolItem(ATTR_ANIMATION_SOUNDON, FALSE));
//STRIP001 
//STRIP001 		if (nSoundFileSet == ATTR_SET)
//STRIP001 			aSet.Put(SfxStringItem(ATTR_ANIMATION_SOUNDFILE, aSound));
//STRIP001 		else
//STRIP001 			aSet.InvalidateItem(ATTR_ANIMATION_SOUNDFILE);
//STRIP001 
//STRIP001 		if (nPlayFullSet == ATTR_SET)
//STRIP001 			aSet.Put(SfxBoolItem(ATTR_ANIMATION_PLAYFULL, bPlayFull));
//STRIP001 		else if (nPlayFullSet == ATTR_MIXED)
//STRIP001 			aSet.InvalidateItem(ATTR_ANIMATION_PLAYFULL);
//STRIP001 		else
//STRIP001 			aSet.Put(SfxBoolItem(ATTR_ANIMATION_PLAYFULL, FALSE));
//STRIP001 
//STRIP001 		if (nClickActionSet == ATTR_SET)
//STRIP001 			aSet.Put(SfxAllEnumItem(ATTR_ACTION, eClickAction));
//STRIP001 		else if (nClickActionSet == ATTR_MIXED)
//STRIP001 			aSet.InvalidateItem(ATTR_ACTION);
//STRIP001 		else
//STRIP001 			aSet.Put(SfxAllEnumItem(ATTR_ACTION, presentation::ClickAction_NONE));
//STRIP001 
//STRIP001 		if (nBookmarkSet == ATTR_SET)
//STRIP001 			aSet.Put(SfxStringItem(ATTR_ACTION_FILENAME, aBookmark));
//STRIP001 		else
//STRIP001 			aSet.InvalidateItem(ATTR_ACTION_FILENAME);
//STRIP001 
//STRIP001 		if (nSecondEffectSet == ATTR_SET)
//STRIP001 			aSet.Put(SfxAllEnumItem(ATTR_ACTION_EFFECT, eSecondEffect));
//STRIP001 		else if (nSecondEffectSet == ATTR_MIXED)
//STRIP001 			aSet.InvalidateItem( ATTR_ACTION_EFFECT );
//STRIP001 		else
//STRIP001 			aSet.Put(SfxAllEnumItem(ATTR_ACTION_EFFECT, presentation::AnimationEffect_NONE));
//STRIP001 
//STRIP001 		if (nSecondSpeedSet == ATTR_SET)
//STRIP001 			aSet.Put(SfxAllEnumItem(ATTR_ACTION_EFFECTSPEED, eSecondSpeed));
//STRIP001 		else
//STRIP001 			aSet.InvalidateItem(ATTR_ACTION_EFFECTSPEED);
//STRIP001 
//STRIP001 		if (nSecondSoundOnSet == ATTR_SET)
//STRIP001 			aSet.Put(SfxBoolItem(ATTR_ACTION_SOUNDON, bSecondSoundOn));
//STRIP001 		else if (nSecondSoundOnSet == ATTR_MIXED)
//STRIP001 			aSet.InvalidateItem(ATTR_ACTION_SOUNDON);
//STRIP001 		else
//STRIP001 			aSet.Put(SfxBoolItem(ATTR_ACTION_SOUNDON, FALSE));
//STRIP001 
//STRIP001 		if (nSecondPlayFullSet == ATTR_SET)
//STRIP001 			aSet.Put(SfxBoolItem(ATTR_ACTION_PLAYFULL, bSecondPlayFull));
//STRIP001 		else if (nPlayFullSet == ATTR_MIXED)
//STRIP001 			aSet.InvalidateItem(ATTR_ACTION_PLAYFULL);
//STRIP001 		else
//STRIP001 			aSet.Put(SfxBoolItem(ATTR_ACTION_PLAYFULL, FALSE));
//STRIP001 
//STRIP001 		SdActionDlg* pDlg = new SdActionDlg(NULL, &aSet, pView);
//STRIP001 
//STRIP001 		USHORT nResult = pDlg->Execute();
//STRIP001 
//STRIP001 		switch( nResult )
//STRIP001 		{
//STRIP001 			case RET_OK:
//STRIP001 			{
//STRIP001 				rReq.Done( *( pDlg->GetOutputItemSet() ) );
//STRIP001 				pArgs = rReq.GetArgs();
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			default:
//STRIP001 			{
//STRIP001 				delete( pDlg );
//STRIP001 			}
//STRIP001 			return; // Abbruch
//STRIP001 		}
//STRIP001 		delete pDlg;
//STRIP001 	}
//STRIP001 
//STRIP001 	// Auswertung des ItemSets
//STRIP001 	if (pArgs->GetItemState(ATTR_ANIMATION_ACTIVE) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		bActive = ((SfxBoolItem&)pArgs->Get(ATTR_ANIMATION_ACTIVE)).GetValue();
//STRIP001 		nAnimationSet = ATTR_SET;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		nAnimationSet = ATTR_MISSING;
//STRIP001 
//STRIP001 	if (pArgs->GetItemState(ATTR_ANIMATION_EFFECT) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		eEffect = (presentation::AnimationEffect)((SfxAllEnumItem&) pArgs->
//STRIP001 					Get(ATTR_ANIMATION_EFFECT)).GetValue();
//STRIP001 		nEffectSet = ATTR_SET;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		nEffectSet = ATTR_MISSING;
//STRIP001 
//STRIP001 	if (pArgs->GetItemState(ATTR_ANIMATION_TEXTEFFECT) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		eTextEffect = (presentation::AnimationEffect)((SfxAllEnumItem&) pArgs->
//STRIP001 						Get(ATTR_ANIMATION_TEXTEFFECT)).GetValue();
//STRIP001 		nTextEffectSet = ATTR_SET;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		nTextEffectSet = ATTR_MISSING;
//STRIP001 
//STRIP001 	if (pArgs->GetItemState(ATTR_ANIMATION_SPEED) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		eSpeed  = (presentation::AnimationSpeed)((SfxAllEnumItem&) pArgs->
//STRIP001 					Get(ATTR_ANIMATION_SPEED)).GetValue();
//STRIP001 		nSpeedSet = ATTR_SET;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		nSpeedSet = ATTR_MISSING;
//STRIP001 
//STRIP001 	if (pArgs->GetItemState(ATTR_ANIMATION_FADEOUT) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		bFadeOut = ((SfxBoolItem&)pArgs->Get(ATTR_ANIMATION_FADEOUT)).GetValue();
//STRIP001 		nFadeOutSet = ATTR_SET;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		nFadeOutSet = ATTR_MISSING;
//STRIP001 
//STRIP001 	if (pArgs->GetItemState(ATTR_ANIMATION_INVISIBLE) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		bInvisible = ((SfxBoolItem&)pArgs->Get(ATTR_ANIMATION_INVISIBLE)).GetValue();
//STRIP001 		nInvisibleSet = ATTR_SET;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		nInvisibleSet = ATTR_MISSING;
//STRIP001 
//STRIP001 	if (pArgs->GetItemState(ATTR_ANIMATION_SOUNDON) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		bSoundOn = ((SfxBoolItem&)pArgs->Get(ATTR_ANIMATION_SOUNDON)).GetValue();
//STRIP001 		nSoundOnSet = ATTR_SET;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		nSoundOnSet = ATTR_MISSING;
//STRIP001 
//STRIP001 	if (pArgs->GetItemState(ATTR_ANIMATION_SOUNDFILE) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		aSound =  ((SfxStringItem&)pArgs->Get(ATTR_ANIMATION_SOUNDFILE)).GetValue();
//STRIP001 		nSoundFileSet = ATTR_SET;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		nSoundFileSet = ATTR_MISSING;
//STRIP001 
//STRIP001 	if (pArgs->GetItemState(ATTR_ANIMATION_COLOR) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		aFadeColor = ((SvxColorItem&)pArgs->Get(ATTR_ANIMATION_COLOR)).GetValue();
//STRIP001 		nFadeColorSet = ATTR_SET;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		nFadeColorSet = ATTR_MISSING;
//STRIP001 
//STRIP001 	if (pArgs->GetItemState(ATTR_ANIMATION_PLAYFULL) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		bPlayFull = ((SfxBoolItem&)pArgs->Get(ATTR_ANIMATION_PLAYFULL)).GetValue();
//STRIP001 		nPlayFullSet = ATTR_SET;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		nPlayFullSet = ATTR_MISSING;
//STRIP001 
//STRIP001 	if (pArgs->GetItemState(ATTR_ACTION) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		eClickAction = (presentation::ClickAction)((SfxAllEnumItem&)pArgs->
//STRIP001 					Get(ATTR_ACTION)).GetValue();
//STRIP001 		nClickActionSet = ATTR_SET;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		nClickActionSet = ATTR_MISSING;
//STRIP001 
//STRIP001 	if (pArgs->GetItemState(ATTR_ACTION_FILENAME) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		aBookmark = ((SfxStringItem&)pArgs->
//STRIP001 						Get(ATTR_ACTION_FILENAME)).GetValue();
//STRIP001 		nBookmarkSet = ATTR_SET;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		nBookmarkSet = ATTR_MISSING;
//STRIP001 
//STRIP001 	if (pArgs->GetItemState(ATTR_ACTION_EFFECT) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		eSecondEffect = (presentation::AnimationEffect)((SfxAllEnumItem&) pArgs->
//STRIP001 					Get(ATTR_ACTION_EFFECT)).GetValue();
//STRIP001 		nSecondEffectSet = ATTR_SET;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		nSecondEffectSet = ATTR_MISSING;
//STRIP001 
//STRIP001 	if (pArgs->GetItemState(ATTR_ACTION_EFFECTSPEED) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		eSecondSpeed  = (presentation::AnimationSpeed)((SfxAllEnumItem&) pArgs->
//STRIP001 					Get(ATTR_ACTION_EFFECTSPEED)).GetValue();
//STRIP001 		nSecondSpeedSet = ATTR_SET;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		nSecondSpeedSet = ATTR_MISSING;
//STRIP001 
//STRIP001 	if (pArgs->GetItemState(ATTR_ACTION_SOUNDON) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		bSecondSoundOn = ((SfxBoolItem&)pArgs->Get(ATTR_ACTION_SOUNDON)).GetValue();
//STRIP001 		nSecondSoundOnSet = ATTR_SET;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		nSecondSoundOnSet = ATTR_MISSING;
//STRIP001 
//STRIP001 	if (pArgs->GetItemState(ATTR_ACTION_PLAYFULL) == SFX_ITEM_SET)
//STRIP001 	{
//STRIP001 		bSecondPlayFull = ((SfxBoolItem&)pArgs->Get(ATTR_ACTION_PLAYFULL)).GetValue();
//STRIP001 		nSecondPlayFullSet = ATTR_SET;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		nSecondPlayFullSet = ATTR_MISSING;
//STRIP001 
//STRIP001 	// Wenn irgendwelche Attribute ausgewaehlt wurden
//STRIP001 	if (nEffectSet         == ATTR_SET  ||
//STRIP001 		nTextEffectSet     == ATTR_SET  ||
//STRIP001 		nSpeedSet          == ATTR_SET  ||
//STRIP001 		nAnimationSet      == ATTR_SET  ||
//STRIP001 		nFadeOutSet        == ATTR_SET  ||
//STRIP001 		nFadeColorSet      == ATTR_SET  ||
//STRIP001 		nInvisibleSet      == ATTR_SET  ||
//STRIP001 		nSoundOnSet        == ATTR_SET  ||
//STRIP001 		nSoundFileSet      == ATTR_SET  ||
//STRIP001 		nPlayFullSet       == ATTR_SET  ||
//STRIP001 		nClickActionSet    == ATTR_SET  ||
//STRIP001 		nBookmarkSet       == ATTR_SET  ||
//STRIP001 		nSecondEffectSet   == ATTR_SET  ||
//STRIP001 		nSecondSpeedSet    == ATTR_SET  ||
//STRIP001 		nSecondSoundOnSet  == ATTR_SET  ||
//STRIP001 		nSecondPlayFullSet == ATTR_SET)
//STRIP001 	{
//STRIP001 		// String fuer Undo-Group und List-Action
//STRIP001 		String aComment(SdResId(STR_UNDO_ANIMATION));
//STRIP001 
//STRIP001 		// bei 'an Kurve entlang' gibt's noch eine extra UndoAction, darum
//STRIP001 		// hier klammern
//STRIP001 		pUndoMgr->EnterListAction(aComment, aComment);
//STRIP001 
//STRIP001 		// Undo Gruppe erzeugen
//STRIP001 		SdUndoGroup* pUndoGroup = new SdUndoGroup(pDoc);
//STRIP001 		pUndoGroup->SetComment(aComment);
//STRIP001 
//STRIP001 
//STRIP001 		// fuer den Pfad-Effekt einige Dinge merken
//STRIP001 		SdrObject*  pRunningObj = NULL;
//STRIP001 		SdrPathObj* pPath       = NULL;
//STRIP001 		if (eEffect == presentation::AnimationEffect_PATH && nEffectSet == ATTR_SET)
//STRIP001 		{
//STRIP001 			DBG_ASSERT(nCount == 2, "dieser Effekt braucht genau 2 selektierte Objekte");
//STRIP001 			SdrObject* pObject1 = rMarkList.GetMark(0)->GetObj();
//STRIP001 			SdrObject* pObject2 = rMarkList.GetMark(1)->GetObj();
//STRIP001 			SdrObjKind eKind1   = (SdrObjKind)pObject1->GetObjIdentifier();
//STRIP001 			SdrObjKind eKind2   = (SdrObjKind)pObject2->GetObjIdentifier();
//STRIP001 
//STRIP001 			if (pObject1->GetObjInventor() == SdrInventor &&
//STRIP001 				((eKind1 == OBJ_LINE) ||        // 2-Punkt-Linie
//STRIP001 				 (eKind1 == OBJ_PLIN) ||        // Polygon
//STRIP001 				 (eKind1 == OBJ_PATHLINE)))     // Bezier-Kurve
//STRIP001 			{
//STRIP001 				pPath = (SdrPathObj*)pObject1;
//STRIP001 				pRunningObj = pObject2;
//STRIP001 			}
//STRIP001 
//STRIP001 			if (pObject2->GetObjInventor() == SdrInventor &&
//STRIP001 				((eKind2 == OBJ_LINE) ||        // 2-Punkt-Linie
//STRIP001 				 (eKind2 == OBJ_PLIN) ||        // Polygon
//STRIP001 				 (eKind2 == OBJ_PATHLINE)))     // Bezier-Kurve
//STRIP001 			{
//STRIP001 				pPath = (SdrPathObj*)pObject2;
//STRIP001 				pRunningObj = pObject1;
//STRIP001 			}
//STRIP001 
//STRIP001 			DBG_ASSERT(pPath, "keine Kurve gefunden");
//STRIP001 
//STRIP001 
//STRIP001 			// das laufende Objekt auf das Kurvenende schieben
//STRIP001 			Rectangle aCurRect(pRunningObj->GetLogicRect());
//STRIP001 			Point     aCurCenter(aCurRect.Center());
//STRIP001 			const XPolyPolygon& rXPP = pPath->GetPathPoly();
//STRIP001 			USHORT nNoOfXPoly = rXPP.Count();
//STRIP001 			const XPolygon& rXPoly = rXPP.GetObject(nNoOfXPoly - 1);
//STRIP001 			USHORT nPoints = rXPoly.GetPointCount();
//STRIP001 			Point aNewCenter(rXPoly[nPoints - 1]);
//STRIP001 			Size aDistance(aNewCenter.X() - aCurCenter.X(),
//STRIP001 						   aNewCenter.Y() - aCurCenter.Y());
//STRIP001 			pRunningObj->Move(aDistance);
//STRIP001 
//STRIP001 			SdrUndoMoveObj* pUndoAction = new SdrUndoMoveObj(*pRunningObj,
//STRIP001 															 aDistance);
//STRIP001 			pUndoMgr->AddUndoAction(pUndoAction);
//STRIP001 		}
//STRIP001 
//STRIP001 		for (nObject = 0; nObject < nCount; nObject++)
//STRIP001 		{
//STRIP001 			SdrObject* pObject = rMarkList.GetMark(nObject)->GetObj();
//STRIP001 
//STRIP001 			pInfo = pDoc->GetAnimationInfo(pObject);
//STRIP001 
//STRIP001 			BOOL bCreated = FALSE;
//STRIP001 			if( !pInfo )
//STRIP001 			{
//STRIP001 				pInfo = new SdAnimationInfo(pDoc);
//STRIP001 				pObject->InsertUserData( pInfo );
//STRIP001 				bCreated = TRUE;
//STRIP001 			}
//STRIP001 
//STRIP001 			// das Pfadobjekt fuer 'an Kurve entlang'?
//STRIP001 			if (eEffect == presentation::AnimationEffect_PATH && pObject == pPath)
//STRIP001 			{
//STRIP001 				SdAnimationPrmsUndoAction* pAction = new SdAnimationPrmsUndoAction
//STRIP001 												(pDoc, pObject, bCreated);
//STRIP001 				pAction->SetActive(pInfo->bActive, pInfo->bActive);
//STRIP001 				pAction->SetEffect(pInfo->eEffect, pInfo->eEffect);
//STRIP001 				pAction->SetTextEffect(pInfo->eTextEffect, pInfo->eTextEffect);
//STRIP001 				pAction->SetSpeed(pInfo->eSpeed, pInfo->eSpeed);
//STRIP001 				pAction->SetDim(pInfo->bDimPrevious, pInfo->bDimPrevious);
//STRIP001 				pAction->SetDimColor(pInfo->aDimColor, pInfo->aDimColor);
//STRIP001 				pAction->SetDimHide(pInfo->bDimHide, pInfo->bDimHide);
//STRIP001 				pAction->SetSoundOn(pInfo->bSoundOn, pInfo->bSoundOn);
//STRIP001 				pAction->SetSound(pInfo->aSoundFile, pInfo->aSoundFile);
//STRIP001 				pAction->SetPlayFull(pInfo->bPlayFull, pInfo->bPlayFull);
//STRIP001 				pAction->SetPathObj(pInfo->pPathObj, pInfo->pPathObj);
//STRIP001 				pAction->SetClickAction(pInfo->eClickAction, pInfo->eClickAction);
//STRIP001 				pAction->SetBookmark(pInfo->aBookmark, pInfo->aBookmark);
//STRIP001 				pAction->SetInvisibleInPres(pInfo->bInvisibleInPresentation, TRUE);
//STRIP001 				pAction->SetVerb(pInfo->nVerb, pInfo->nVerb);
//STRIP001 				pAction->SetSecondEffect(pInfo->eSecondEffect, pInfo->eSecondEffect);
//STRIP001 				pAction->SetSecondSpeed(pInfo->eSecondSpeed, pInfo->eSecondSpeed);
//STRIP001 				pAction->SetSecondSoundOn(pInfo->bSecondSoundOn, pInfo->bSecondSoundOn);
//STRIP001 				pAction->SetSecondPlayFull(pInfo->bSecondPlayFull, pInfo->bSecondPlayFull);
//STRIP001 				pUndoGroup->AddAction(pAction);
//STRIP001 
//STRIP001 				pInfo->bInvisibleInPresentation = TRUE;
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 
//STRIP001 				// Undo-Action mit alten und neuen Groessen erzeugen
//STRIP001 				SdAnimationPrmsUndoAction* pAction = new SdAnimationPrmsUndoAction
//STRIP001 												(pDoc, pObject, bCreated);
//STRIP001 				pAction->SetActive(pInfo->bActive, bActive);
//STRIP001 				pAction->SetEffect(pInfo->eEffect, eEffect);
//STRIP001 				pAction->SetTextEffect(pInfo->eTextEffect, eTextEffect);
//STRIP001 				pAction->SetSpeed(pInfo->eSpeed, eSpeed);
//STRIP001 				pAction->SetDim(pInfo->bDimPrevious, bFadeOut);
//STRIP001 				pAction->SetDimColor(pInfo->aDimColor, aFadeColor);
//STRIP001 				pAction->SetDimHide(pInfo->bDimHide, bInvisible);
//STRIP001 				pAction->SetSoundOn(pInfo->bSoundOn, bSoundOn);
//STRIP001 				pAction->SetSound(pInfo->aSoundFile, aSound);
//STRIP001 				pAction->SetPlayFull(pInfo->bPlayFull, bPlayFull);
//STRIP001 				pAction->SetPathObj(pInfo->pPathObj, pPath);
//STRIP001 				pAction->SetClickAction(pInfo->eClickAction, eClickAction);
//STRIP001 				pAction->SetBookmark(pInfo->aBookmark, aBookmark);
//STRIP001 				pAction->SetInvisibleInPres(pInfo->bInvisibleInPresentation,
//STRIP001 											pInfo->bInvisibleInPresentation);
//STRIP001 				pAction->SetVerb(pInfo->nVerb, (USHORT)pInfo->aBookmark.ToInt32() );
//STRIP001 				pAction->SetSecondEffect(pInfo->eSecondEffect, eSecondEffect);
//STRIP001 				pAction->SetSecondSpeed(pInfo->eSecondSpeed, eSecondSpeed);
//STRIP001 				pAction->SetSecondSoundOn(pInfo->bSecondSoundOn, bSecondSoundOn);
//STRIP001 				pAction->SetSecondPlayFull(pInfo->bSecondPlayFull,bSecondPlayFull);
//STRIP001 				pUndoGroup->AddAction(pAction);
//STRIP001 
//STRIP001 				// neue Werte am Infoblock des Objekts eintragen
//STRIP001 				if (nAnimationSet == ATTR_SET)
//STRIP001 					pInfo->bActive = bActive;
//STRIP001 
//STRIP001 				if (nEffectSet == ATTR_SET)
//STRIP001 					pInfo->eEffect = eEffect;
//STRIP001 
//STRIP001 				if (nTextEffectSet == ATTR_SET)
//STRIP001 					pInfo->eTextEffect = eTextEffect;
//STRIP001 
//STRIP001 				if (nSpeedSet == ATTR_SET)
//STRIP001 					pInfo->eSpeed = eSpeed;
//STRIP001 
//STRIP001 				if (nFadeOutSet == ATTR_SET)
//STRIP001 					pInfo->bDimPrevious = bFadeOut;
//STRIP001 
//STRIP001 				if (nFadeColorSet == ATTR_SET)
//STRIP001 					pInfo->aDimColor = aFadeColor;
//STRIP001 
//STRIP001 				if (nInvisibleSet == ATTR_SET)
//STRIP001 					pInfo->bDimHide = bInvisible;
//STRIP001 
//STRIP001 				if (nSoundOnSet == ATTR_SET)
//STRIP001 					pInfo->bSoundOn = bSoundOn;
//STRIP001 
//STRIP001 				if (nSoundFileSet == ATTR_SET)
//STRIP001 					pInfo->aSoundFile = aSound;
//STRIP001 
//STRIP001 				if (nPlayFullSet == ATTR_SET)
//STRIP001 					pInfo->bPlayFull = bPlayFull;
//STRIP001 
//STRIP001 				if (nClickActionSet == ATTR_SET)
//STRIP001 					pInfo->eClickAction = eClickAction;
//STRIP001 
//STRIP001 				if (nBookmarkSet == ATTR_SET)
//STRIP001 					pInfo->aBookmark = aBookmark;
//STRIP001 
//STRIP001 				if (nSecondEffectSet == ATTR_SET)
//STRIP001 					pInfo->eSecondEffect = eSecondEffect;
//STRIP001 
//STRIP001 				if (nSecondSpeedSet == ATTR_SET)
//STRIP001 					pInfo->eSecondSpeed = eSecondSpeed;
//STRIP001 
//STRIP001 				if (nSecondSoundOnSet == ATTR_SET)
//STRIP001 					pInfo->bSecondSoundOn = bSecondSoundOn;
//STRIP001 
//STRIP001 				if (nSecondPlayFullSet == ATTR_SET)
//STRIP001 					pInfo->bSecondPlayFull = bSecondPlayFull;
//STRIP001 
//STRIP001 				// noch ein paar Spezialitaeten
//STRIP001 				if (eEffect == presentation::AnimationEffect_PATH && nEffectSet == ATTR_SET)
//STRIP001 					pInfo->SetPath(pPath);
//STRIP001 
//STRIP001 				if (eClickAction == presentation::ClickAction_VERB)
//STRIP001 					pInfo->nVerb = (USHORT)aBookmark.ToInt32();
//STRIP001 			}
//STRIP001 		}
//STRIP001 		// Undo Gruppe dem Undo Manager uebergeben
//STRIP001 		pUndoMgr->AddUndoAction(pUndoGroup);
//STRIP001 		pUndoMgr->LeaveListAction();
//STRIP001 
//STRIP001 		// Model geaendert
//STRIP001 		pDoc->SetChanged();
//STRIP001 
//STRIP001 		/***************************************************************
//STRIP001 		|* ggfs. in Preview anzeigen
//STRIP001 		\**************************************************************/
//STRIP001 		SfxChildWindow* pPreviewChildWindow =
//STRIP001 			pViewShell->GetViewFrame()->GetChildWindow(SdPreviewChildWindow::GetChildWindowId());
//STRIP001 		if (pPreviewChildWindow)
//STRIP001 		{
//STRIP001 			SdPreviewWin* pPreviewWin =
//STRIP001 				(SdPreviewWin*)pPreviewChildWindow->GetWindow();
//STRIP001 			if (pPreviewWin && pPreviewWin->GetDoc() == pDoc)
//STRIP001 			{
//STRIP001 				for (nObject = 0; nObject < nCount; nObject++)
//STRIP001 				{
//STRIP001 					SdrObject* pObject = rMarkList.GetMark(nObject)->GetObj();
//STRIP001 
//STRIP001 					pInfo = pDoc->GetAnimationInfo(pObject);
//STRIP001 					if (pInfo)
//STRIP001 					{
//STRIP001 						// das Pfadobjekt fuer 'an Kurve entlang'?
//STRIP001 						if (!(eEffect == presentation::AnimationEffect_PATH &&
//STRIP001 							 pObject == pPath))
//STRIP001 						{
//STRIP001 							pPreviewWin->HideAndAnimateObject(pObject);
//STRIP001 						}
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	// sieht man nicht, also muss an den Bindings nicht invalidiert werden
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Destruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuObjectAnimationParameters::~FuObjectAnimationParameters()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function aktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuObjectAnimationParameters::Activate()
//STRIP001 {
//STRIP001 	FuPoor::Activate();
//STRIP001 
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function deaktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuObjectAnimationParameters::Deactivate()
//STRIP001 {
//STRIP001 	FuPoor::Deactivate();
//STRIP001 }


}
