/*************************************************************************
 *
 *  $RCSfile: sd_fupage.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:51:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

// Seite einrichten Tab-Page
#define ITEMID_PAGE 		SID_ATTR_PAGE
#define ITEMID_LRSPACE		SID_ATTR_LRSPACE
#define ITEMID_ULSPACE		SID_ATTR_ULSPACE
#define ITEMID_SIZE 		SID_ATTR_PAGE_SIZE
#define ITEMID_PAPERBIN 	SID_ATTR_PAGE_PAPERBIN

#define ITEMID_BOX			SID_ATTR_BORDER_OUTER
#define ITEMID_SHADOW		SID_ATTR_BORDER_SHADOW

#include <bf_svx/svxids.hrc>
#include <bf_svx/dialogs.hrc>

// auto strip #ifndef _SFXITEMPOOL_HXX //autogen
// auto strip #include <svtools/itempool.hxx>
// auto strip #endif
// auto strip #ifndef _MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif
// auto strip #ifndef _SFXSTRITEM_HXX //autogen
// auto strip #include <svtools/stritem.hxx>
// auto strip #endif
// auto strip #ifndef _SV_PRNTYPES_HXX //autogen
// auto strip #include <vcl/prntypes.hxx>
// auto strip #endif
// auto strip #ifndef _SFXSTYLE_HXX
// auto strip #include <svtools/style.hxx>
// auto strip #endif
// auto strip #ifndef _SD_STLSHEET_HXX
// auto strip #include <stlsheet.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_SVDORECT_HXX
// auto strip #include <bf_svx/svdorect.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_SVDUNDO_HXX
// auto strip #include <bf_svx/svdundo.hxx>
// auto strip #endif
#ifndef _EEITEM_HXX 
#include <bf_svx/eeitem.hxx>
#endif
#define ITEMID_FRAMEDIR             EE_PARA_WRITINGDIR
// auto strip #ifndef _SVX_FRMDIRITEM_HXX 
// auto strip #include <bf_svx/frmdiritem.hxx>
// auto strip #endif
#include "glob.hrc"
// auto strip #include <bf_svx/shaditem.hxx>
// auto strip #include <bf_svx/boxitem.hxx>
// auto strip #include <bf_svx/sizeitem.hxx>
// auto strip #include <bf_svx/ulspitem.hxx>
// auto strip #include <bf_svx/lrspitem.hxx>
// auto strip #include <bf_svx/pbinitem.hxx>
// auto strip #include <bf_sfx2/app.hxx>


#include "strings.hrc"
// auto strip #include "dlgpage.hxx"
// auto strip #include "sdpage.hxx"
#include "sdview.hxx"
// auto strip #include "pres.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "docshell.hxx"
// auto strip #include "viewshel.hxx"
// auto strip #include "drviewsh.hxx"
// auto strip #include "fupage.hxx"
#include "app.hrc"
// auto strip #include "preview.hxx"
// auto strip #include "prevchld.hxx"
// auto strip #include "unchss.hxx"
// auto strip #include "undoback.hxx"
namespace binfilter {

// 50 cm 28350
// erstmal vom Writer uebernommen
#define MAXHEIGHT 28350
#define MAXWIDTH  28350

class SdWindow;

//STRIP001 TYPEINIT1( FuPage, FuPoor );
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuPage::FuPage( SdViewShell* pViewSh, SdWindow* pWin, SdView* pView,
//STRIP001 				 SdDrawDocument* pDoc, SfxRequest& rReq )
//STRIP001 	   : FuPoor(pViewSh, pWin, pView, pDoc, rReq)
//STRIP001 {
//STRIP001 	const SfxItemSet*           pArgs = rReq.GetArgs();
//STRIP001 	SdPage* 	                pPage = NULL;
//STRIP001     SdBackgroundObjUndoAction*  pBackgroundObjUndoAction = NULL;
//STRIP001 	Size		                aSize;
//STRIP001 	PageKind	                ePageKind = PK_STANDARD;
//STRIP001 	BOOL                        bMasterPage = TRUE;
//STRIP001 	BOOL                        bPageBckgrdDeleted = FALSE;
//STRIP001 
//STRIP001 	///////////////////////////////////////////////////////////////////////////
//STRIP001 	//
//STRIP001 	// Retrieve current page
//STRIP001 	//
//STRIP001 	if ( pViewSh->ISA(SdDrawViewShell) )
//STRIP001 		ePageKind = ((SdDrawViewShell*) pViewSh)->GetPageKind();
//STRIP001 
//STRIP001 	 // shall we display background area tabpage?
//STRIP001 	bool bDisplayBackgroundTabPage = (ePageKind == PK_STANDARD) ? TRUE : FALSE;
//STRIP001 
//STRIP001 	if( ( (SdDrawViewShell*) pViewSh )->GetEditMode() == EM_MASTERPAGE )
//STRIP001 	{
//STRIP001 		pPage = pDoc->GetSdPage(0, ePageKind);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		bMasterPage = FALSE;
//STRIP001 		pPage = ( (SdDrawViewShell*) pViewSh )->GetActualPage();
//STRIP001 	}
//STRIP001 
//STRIP001 	if( !pArgs )
//STRIP001 	{
//STRIP001 		pView->EndTextEdit();
//STRIP001 
//STRIP001 		SfxItemSet aNewAttr(pDoc->GetPool(),
//STRIP001 							pDoc->GetPool().GetWhich(SID_ATTR_LRSPACE),
//STRIP001 							pDoc->GetPool().GetWhich(SID_ATTR_ULSPACE),
//STRIP001 							SID_ATTR_PAGE, SID_ATTR_PAGE_BSP,
//STRIP001 							SID_ATTR_BORDER_OUTER, SID_ATTR_BORDER_OUTER,
//STRIP001 							SID_ATTR_BORDER_SHADOW, SID_ATTR_BORDER_SHADOW,
//STRIP001 							XATTR_FILL_FIRST, XATTR_FILL_LAST,
//STRIP001 							EE_PARA_WRITINGDIR, EE_PARA_WRITINGDIR,
//STRIP001 							0);
//STRIP001 
//STRIP001 		SfxItemSet *pDialogItems = 0;
//STRIP001 
//STRIP001 		///////////////////////////////////////////////////////////////////////
//STRIP001 		//
//STRIP001 		// Retrieve additional data for dialog
//STRIP001 		//
//STRIP001 		SvxShadowItem aShadowItem;
//STRIP001 		aNewAttr.Put( aShadowItem );
//STRIP001 		SvxBoxItem aBoxItem;
//STRIP001 		aNewAttr.Put( aBoxItem );
//STRIP001 
//STRIP001 		
//STRIP001 		aNewAttr.Put( SvxFrameDirectionItem( pDoc->GetDefaultWritingMode() == ::com::sun::star::text::WritingMode_RL_TB ? FRMDIR_HORI_RIGHT_TOP : FRMDIR_HORI_LEFT_TOP ) );
//STRIP001 
//STRIP001 		///////////////////////////////////////////////////////////////////////
//STRIP001 		//
//STRIP001 		// Retrieve page-data for dialog
//STRIP001 		//
//STRIP001 		SvxPageItem aPageItem;
//STRIP001 		aPageItem.SetDescName( pPage->GetName() );
//STRIP001 		aPageItem.SetPageUsage( (SvxPageUsage) SVX_PAGE_ALL );
//STRIP001 
//STRIP001 		Orientation eOrientation = pPage->GetOrientation();
//STRIP001 
//STRIP001 		if (eOrientation == ORIENTATION_LANDSCAPE)
//STRIP001 		{
//STRIP001 			aPageItem.SetLandscape(TRUE);
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			aPageItem.SetLandscape(FALSE);
//STRIP001 		}
//STRIP001 
//STRIP001 		aPageItem.SetNumType( pDoc->GetPageNumType() );
//STRIP001 		aNewAttr.Put( aPageItem );
//STRIP001 
//STRIP001 		// size
//STRIP001 		aSize = pPage->GetSize();
//STRIP001 		SvxSizeItem aSizeItem( SID_ATTR_PAGE_SIZE, aSize );
//STRIP001 		aNewAttr.Put( aSizeItem );
//STRIP001 
//STRIP001 		// Max size
//STRIP001 		SvxSizeItem aMaxSizeItem( SID_ATTR_PAGE_MAXSIZE, Size( MAXWIDTH, MAXHEIGHT ) );
//STRIP001 		aNewAttr.Put( aMaxSizeItem );
//STRIP001 
//STRIP001 		// get printer
//STRIP001 		SfxPrinter* pPrinter = ( (SdDrawDocShell*) pViewSh->GetViewFrame()->GetObjectShell() )->GetPrinter(TRUE);
//STRIP001 
//STRIP001 		// paperbin
//STRIP001 		SvxPaperBinItem aPaperBinItem( SID_ATTR_PAGE_PAPERBIN, pPage->GetPaperBin() );
//STRIP001 		aNewAttr.Put( aPaperBinItem );
//STRIP001 
//STRIP001 		// Raender, Umrandung und das andere Zeug
//STRIP001 		//
//STRIP001 		SvxLRSpaceItem aLRSpaceItem(
//STRIP001 							(USHORT) pPage->GetLftBorder(),
//STRIP001 							(USHORT) pPage->GetRgtBorder(), 0, 0,
//STRIP001 								pDoc->GetPool().GetWhich(SID_ATTR_LRSPACE));
//STRIP001 		aNewAttr.Put( aLRSpaceItem );
//STRIP001 
//STRIP001 		SvxULSpaceItem aULSpaceItem(
//STRIP001 							(USHORT) pPage->GetUppBorder(),
//STRIP001 							(USHORT) pPage->GetLwrBorder(),
//STRIP001 							pDoc->GetPool().GetWhich(SID_ATTR_ULSPACE));
//STRIP001 		aNewAttr.Put( aULSpaceItem );
//STRIP001 
//STRIP001 
//STRIP001 		// Applikation
//STRIP001 		BOOL bScale = TRUE;
//STRIP001 		if( pDoc->GetDocumentType() == DOCUMENT_TYPE_DRAW )
//STRIP001 			bScale = FALSE;
//STRIP001 		aNewAttr.Put( SfxBoolItem( SID_ATTR_PAGE_EXT1, bScale ) );
//STRIP001 
//STRIP001 		BOOL bFullSize = ( (SdPage*)( pPage->GetMasterPage( 0 ) ) )->IsBackgroundFullSize();
//STRIP001 		aNewAttr.Put( SfxBoolItem( SID_ATTR_PAGE_EXT2, bFullSize ) );
//STRIP001 
//STRIP001 		///////////////////////////////////////////////////////////////////////
//STRIP001 		//
//STRIP001 		// Merge ItemSet for dialog
//STRIP001 		//
//STRIP001 		const USHORT* pPtr = aNewAttr.GetRanges();
//STRIP001 		USHORT p1 = pPtr[0], p2 = pPtr[1];
//STRIP001 		while(pPtr[2] && (pPtr[2] - p2 == 1))
//STRIP001 		{
//STRIP001 			p2 = pPtr[3];
//STRIP001 			pPtr += 2;
//STRIP001 		}
//STRIP001 		pPtr += 2;
//STRIP001 		SfxItemSet aMergedAttr( *aNewAttr.GetPool(), p1, p2 );
//STRIP001 
//STRIP001 		while( *pPtr )
//STRIP001 		{
//STRIP001 			p1 = pPtr[0];
//STRIP001 			p2 = pPtr[1];
//STRIP001 
//STRIP001 			// erstmal das ganze discret machen
//STRIP001 			while(pPtr[2] && (pPtr[2] - p2 == 1))
//STRIP001 			{
//STRIP001 				p2 = pPtr[3];
//STRIP001 				pPtr += 2;
//STRIP001 			}
//STRIP001 			aMergedAttr.MergeRange( p1, p2 );
//STRIP001 			pPtr += 2;
//STRIP001 		}
//STRIP001 
//STRIP001 		SfxStyleSheetBasePool* pSSPool = pDoc->GetDocSh()->GetStyleSheetPool();
//STRIP001 		SfxStyleSheetBase* pStyleSheet = NULL;
//STRIP001 		if(pSSPool)
//STRIP001 		{
//STRIP001 			String aStr(SdResId(STR_PSEUDOSHEET_BACKGROUND));
//STRIP001 			pStyleSheet = pSSPool->Find( aStr, SFX_STYLE_FAMILY_PSEUDO);
//STRIP001 		}
//STRIP001 
//STRIP001 		if( bDisplayBackgroundTabPage )
//STRIP001 		{
//STRIP001 			if( bMasterPage )
//STRIP001 			{
//STRIP001 				if(pStyleSheet)
//STRIP001 				{
//STRIP001 					SfxItemSet aStyleSet( pStyleSheet->GetItemSet());
//STRIP001 
//STRIP001 					pPtr = aStyleSet.GetRanges();
//STRIP001 					while( *pPtr )
//STRIP001 					{
//STRIP001 						p1 = pPtr[0];
//STRIP001 						p2 = pPtr[1];
//STRIP001 
//STRIP001 						// erstmal das ganze discret machen
//STRIP001 						while(pPtr[2] && (pPtr[2] - p2 == 1))
//STRIP001 						{
//STRIP001 							p2 = pPtr[3];
//STRIP001 							pPtr += 2;
//STRIP001 						}
//STRIP001 						aMergedAttr.MergeRange( p1, p2 );
//STRIP001 						pPtr += 2;
//STRIP001 					}
//STRIP001 
//STRIP001 					aMergedAttr.Put(aStyleSet);
//STRIP001 				}
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				// Only this page
//STRIP001 				SdrObject* pObj = pPage->GetBackgroundObj();
//STRIP001 				if( pObj )
//STRIP001 				{
//STRIP001 	//-/				pObj->TakeAttributes( aMergedAttr, TRUE, TRUE );
//STRIP001 					aMergedAttr.Put(pObj->GetItemSet());
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					// if the page hasn't got a background-object, than use
//STRIP001 					// the fillstyle-settings of the masterpage for the dialog
//STRIP001 					if( pStyleSheet->GetItemSet().GetItemState( XATTR_FILLSTYLE ) != SFX_ITEM_DEFAULT )
//STRIP001 						aMergedAttr.Put( pStyleSheet->GetItemSet() );
//STRIP001 					else
//STRIP001 						aMergedAttr.Put( XFillStyleItem( XFILL_NONE ) );
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		aMergedAttr.Put(aNewAttr);
//STRIP001 
//STRIP001 		SdPageDlg* pDlg = new SdPageDlg( pDocSh, NULL, &aMergedAttr, bDisplayBackgroundTabPage );
//STRIP001 
//STRIP001 		USHORT nResult = pDlg->Execute();
//STRIP001 
//STRIP001 		switch( nResult )
//STRIP001 		{
//STRIP001 			case RET_OK:
//STRIP001 			{
//STRIP001 				SfxItemSet aTempSet(*pDlg->GetOutputItemSet());
//STRIP001 				((SdStyleSheet*)pStyleSheet)->AdjustToFontHeight(aTempSet);
//STRIP001 
//STRIP001 				if( bDisplayBackgroundTabPage )
//STRIP001 				{
//STRIP001 					// if some fillstyle-items are not set in the dialog, then
//STRIP001 					// try to use the items before
//STRIP001 					BOOL bChanges = FALSE;
//STRIP001 					for( int i=XATTR_FILL_FIRST; i<XATTR_FILL_LAST; i++ )
//STRIP001 					{
//STRIP001 						if( aMergedAttr.GetItemState( i ) != SFX_ITEM_DEFAULT )
//STRIP001 						{
//STRIP001 							if( aTempSet.GetItemState( i ) == SFX_ITEM_DEFAULT )
//STRIP001 								aTempSet.Put( aMergedAttr.Get( i ) );
//STRIP001 							else
//STRIP001 								if( aMergedAttr.GetItem( i ) != aTempSet.GetItem( i ) )
//STRIP001 									bChanges = TRUE;
//STRIP001 						}
//STRIP001 					}
//STRIP001 
//STRIP001 					// if the background for this page was set to invisible, the background-object has to be deleted, too.
//STRIP001 					if( ( ( (XFillStyleItem*) aTempSet.GetItem( XATTR_FILLSTYLE ) )->GetValue() == XFILL_NONE ) ||
//STRIP001 						( ( aTempSet.GetItemState( XATTR_FILLSTYLE ) == SFX_ITEM_DEFAULT ) &&
//STRIP001 						  ( ( (XFillStyleItem*) aMergedAttr.GetItem( XATTR_FILLSTYLE ) )->GetValue() == XFILL_NONE ) ) )
//STRIP001 						bPageBckgrdDeleted = TRUE;
//STRIP001 
//STRIP001 					// Ask, wether the setting are for the background-page or for the current page
//STRIP001 					if( !bMasterPage && bChanges )
//STRIP001 					{
//STRIP001 						// But don't ask in notice-view, because we can't change the background of
//STRIP001 						// notice-masterpage (at the moment)
//STRIP001 						if( ePageKind != PK_NOTES )
//STRIP001 						{
//STRIP001 							String aTit(SdResId( STR_PAGE_BACKGROUND_TITLE ));
//STRIP001 							String aTxt(SdResId( STR_PAGE_BACKGROUND_TXT ));
//STRIP001 							MessBox aQuestionBox( (Window*)pWin, WB_YES_NO | WB_DEF_YES,
//STRIP001 												  aTit,
//STRIP001 												  aTxt );
//STRIP001 							aQuestionBox.SetImage( QueryBox::GetStandardImage() );
//STRIP001 							bMasterPage = ( RET_YES == aQuestionBox.Execute() );
//STRIP001 						}
//STRIP001 
//STRIP001                         if( bPageBckgrdDeleted )
//STRIP001 						{
//STRIP001                             pBackgroundObjUndoAction = new SdBackgroundObjUndoAction( *pDoc, *pPage, pPage->GetBackgroundObj() );
//STRIP001 							pPage->SetBackgroundObj( NULL );
//STRIP001 						}
//STRIP001 
//STRIP001 					}
//STRIP001 
//STRIP001 					// Sonderbehandlung: die INVALIDS auf NULL-Pointer
//STRIP001 					// zurueckgesetzen (sonst landen INVALIDs oder
//STRIP001 					// Pointer auf die DefaultItems in der Vorlage;
//STRIP001 					// beides wuerde die Attribut-Vererbung unterbinden)
//STRIP001 					aTempSet.ClearInvalidItems();
//STRIP001 
//STRIP001 					if( bMasterPage )
//STRIP001 					{
//STRIP001 						StyleSheetUndoAction* pAction = new StyleSheetUndoAction(pDoc, (SfxStyleSheet*)pStyleSheet, &aTempSet);
//STRIP001 						pDocSh->GetUndoManager()->AddUndoAction(pAction);
//STRIP001 						pStyleSheet->GetItemSet().Put( aTempSet );
//STRIP001 						SdStyleSheet* pRealSheet =((SdStyleSheet*)pStyleSheet)->GetRealStyleSheet();
//STRIP001 						pRealSheet->Broadcast(SfxSimpleHint(SFX_HINT_DATACHANGED));
//STRIP001 					}
//STRIP001 
//STRIP001 					const SfxPoolItem *pItem;
//STRIP001 					if( SFX_ITEM_SET == aTempSet.GetItemState( EE_PARA_WRITINGDIR, sal_False, &pItem ) )
//STRIP001 					{
//STRIP001 					    sal_uInt32 nVal = ((SvxFrameDirectionItem*)pItem)->GetValue();
//STRIP001 						pDoc->SetDefaultWritingMode( nVal == FRMDIR_HORI_RIGHT_TOP ? ::com::sun::star::text::WritingMode_RL_TB : ::com::sun::star::text::WritingMode_LR_TB );
//STRIP001 					}
//STRIP001 
//STRIP001 					pDoc->SetChanged(TRUE);
//STRIP001 
//STRIP001 					SdrObject* pObj = ( (SdPage*)( pPage->GetMasterPage( 0 ) ) )->GetPresObj( PRESOBJ_BACKGROUND );
//STRIP001 					if( pObj )
//STRIP001 					{
//STRIP001 						// BackgroundObj: no hard attributes allowed
//STRIP001 						SfxItemSet aSet( pDoc->GetPool() );
//STRIP001 	//-/					pObj->NbcSetAttributes( aSet, TRUE );
//STRIP001 						pObj->SetItemSet(aSet);
//STRIP001 					}
//STRIP001 				}
//STRIP001 
//STRIP001 				aNewAttr.Put(aTempSet);
//STRIP001 				rReq.Done( aNewAttr );
//STRIP001 
//STRIP001 				pArgs = rReq.GetArgs();
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			default:
//STRIP001 			{
//STRIP001 				delete pDlg;
//STRIP001 			}
//STRIP001 			return; // Abbruch
//STRIP001 		}
//STRIP001 		delete( pDlg );
//STRIP001 	}
//STRIP001 
//STRIP001 	///////////////////////////////////////////////////////////////////////////
//STRIP001 	//
//STRIP001 	// Set new page-attributes
//STRIP001 	//
//STRIP001 	const SfxPoolItem*  pPoolItem;
//STRIP001 	BOOL                bSetPageSizeAndBorder = FALSE;
//STRIP001 	Size                aNewSize(aSize);
//STRIP001 	INT32	            nLeft  = -1, nRight = -1, nUpper = -1, nLower = -1;
//STRIP001 	BOOL	            bScaleAll = TRUE;
//STRIP001 	Orientation         eOrientation = pPage->GetOrientation();
//STRIP001 	BOOL                bFullSize =	( (SdPage*)( pPage->GetMasterPage( 0 ) ) )->IsBackgroundFullSize();
//STRIP001 	USHORT              nPaperBin = pPage->GetPaperBin();
//STRIP001 
//STRIP001 	if( pArgs->GetItemState(SID_ATTR_PAGE, TRUE, &pPoolItem) == SFX_ITEM_SET )
//STRIP001 	{
//STRIP001 		pDoc->SetPageNumType(((const SvxPageItem*) pPoolItem)->GetNumType());
//STRIP001 
//STRIP001 		if (((const SvxPageItem*) pPoolItem)->IsLandscape() == ORIENTATION_LANDSCAPE)
//STRIP001 		{
//STRIP001 			eOrientation = ORIENTATION_LANDSCAPE;
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			eOrientation = ORIENTATION_PORTRAIT;
//STRIP001 		}
//STRIP001 
//STRIP001 		if( pPage->GetOrientation() != eOrientation )
//STRIP001 			bSetPageSizeAndBorder = TRUE;
//STRIP001 
//STRIP001 		if ( pViewSh->ISA(SdDrawViewShell) )
//STRIP001 			((SdDrawViewShell*) pViewSh)->ResetActualPage();
//STRIP001 	}
//STRIP001 
//STRIP001 	if( pArgs->GetItemState(SID_ATTR_PAGE_SIZE, TRUE, &pPoolItem) == SFX_ITEM_SET )
//STRIP001 	{
//STRIP001 		aNewSize = ((const SvxSizeItem*) pPoolItem)->GetSize();
//STRIP001 
//STRIP001 		if( pPage->GetSize() != aNewSize )
//STRIP001 			bSetPageSizeAndBorder = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if( pArgs->GetItemState(pDoc->GetPool().GetWhich(SID_ATTR_LRSPACE),
//STRIP001 							TRUE, &pPoolItem) == SFX_ITEM_SET )
//STRIP001 	{
//STRIP001 		nLeft = ((const SvxLRSpaceItem*) pPoolItem)->GetLeft();
//STRIP001 		nRight = ((const SvxLRSpaceItem*) pPoolItem)->GetRight();
//STRIP001 
//STRIP001 		if( pPage->GetLftBorder() != nLeft || pPage->GetRgtBorder() != nRight )
//STRIP001 			bSetPageSizeAndBorder = TRUE;
//STRIP001 
//STRIP001 	}
//STRIP001 
//STRIP001 	if( pArgs->GetItemState(pDoc->GetPool().GetWhich(SID_ATTR_ULSPACE),
//STRIP001 							TRUE, &pPoolItem) == SFX_ITEM_SET )
//STRIP001 	{
//STRIP001 		nUpper = ((const SvxULSpaceItem*) pPoolItem)->GetUpper();
//STRIP001 		nLower = ((const SvxULSpaceItem*) pPoolItem)->GetLower();
//STRIP001 
//STRIP001 		if( pPage->GetUppBorder() != nUpper || pPage->GetLwrBorder() != nLower )
//STRIP001 			bSetPageSizeAndBorder = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if( pArgs->GetItemState(pDoc->GetPool().GetWhich(SID_ATTR_PAGE_EXT1),
//STRIP001 							TRUE, &pPoolItem) == SFX_ITEM_SET )
//STRIP001 	{
//STRIP001 		bScaleAll = ((const SfxBoolItem*) pPoolItem)->GetValue();
//STRIP001 	}
//STRIP001 
//STRIP001 	if( pArgs->GetItemState(pDoc->GetPool().GetWhich(SID_ATTR_PAGE_EXT2),
//STRIP001 							TRUE, &pPoolItem) == SFX_ITEM_SET )
//STRIP001 	{
//STRIP001 		bFullSize = ((const SfxBoolItem*) pPoolItem)->GetValue();
//STRIP001 
//STRIP001 		if( ( (SdPage*)( pPage->GetMasterPage( 0 ) ) )->IsBackgroundFullSize() != bFullSize )
//STRIP001 			bSetPageSizeAndBorder = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	// Papierschacht (PaperBin)
//STRIP001 	if( pArgs->GetItemState(pDoc->GetPool().GetWhich(SID_ATTR_PAGE_PAPERBIN),
//STRIP001 							TRUE, &pPoolItem) == SFX_ITEM_SET )
//STRIP001 	{
//STRIP001 		nPaperBin = ((const SvxPaperBinItem*) pPoolItem)->GetValue();
//STRIP001 
//STRIP001 		if( pPage->GetPaperBin() != nPaperBin )
//STRIP001 			bSetPageSizeAndBorder = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (nLeft == -1 && nUpper != -1)
//STRIP001 	{
//STRIP001 		bSetPageSizeAndBorder = TRUE;
//STRIP001 		nLeft  = pPage->GetLftBorder();
//STRIP001 		nRight = pPage->GetRgtBorder();
//STRIP001 	}
//STRIP001 	else if (nLeft != -1 && nUpper == -1)
//STRIP001 	{
//STRIP001 		bSetPageSizeAndBorder = TRUE;
//STRIP001 		nUpper = pPage->GetUppBorder();
//STRIP001 		nLower = pPage->GetLwrBorder();
//STRIP001 	}
//STRIP001 
//STRIP001 	if( bSetPageSizeAndBorder || !bMasterPage )
//STRIP001 		pViewSh->SetPageSizeAndBorder(ePageKind, aNewSize, nLeft, nRight, nUpper, 
//STRIP001 		                              nLower, bScaleAll, eOrientation, nPaperBin, bFullSize );
//STRIP001 
//STRIP001 	////////////////////////////////////////////////////////////////////////////////
//STRIP001 	//
//STRIP001 	// if bMasterPage==FALSE then create a background-object for this page with the
//STRIP001 	// properties set in the dialog before, but if bPageBckgrdDeleted==TRUE then
//STRIP001 	// the background of this page was set to invisible, so it would be a mistake
//STRIP001 	// to create a new background-object for this page !
//STRIP001 	//
//STRIP001 
//STRIP001 	if( bDisplayBackgroundTabPage )
//STRIP001 	{
//STRIP001 		if ( !bMasterPage && !bPageBckgrdDeleted )
//STRIP001 		{
//STRIP001 			// Only this page
//STRIP001 			SdrObject* pObj = pPage->GetBackgroundObj();
//STRIP001 
//STRIP001             delete pBackgroundObjUndoAction;
//STRIP001             pBackgroundObjUndoAction = new SdBackgroundObjUndoAction( *pDoc, *pPage, pObj );
//STRIP001 
//STRIP001 			if( !pObj )
//STRIP001 			{
//STRIP001 				pObj = new SdrRectObj();
//STRIP001 				pPage->SetBackgroundObj( pObj );
//STRIP001 			}
//STRIP001 
//STRIP001 			Point aPos ( nLeft, nUpper );
//STRIP001 			Size aSize( pPage->GetSize() );
//STRIP001 			aSize.Width()  -= nLeft  + nRight - 1;
//STRIP001 			aSize.Height() -= nUpper + nLower - 1;
//STRIP001 			Rectangle aRect( aPos, aSize );
//STRIP001 			pObj->SetLogicRect( aRect );
//STRIP001 			pObj->SetItemSet(*pArgs);
//STRIP001 		}
//STRIP001 	}
//STRIP001 	
//STRIP001 	// add undo action for background object
//STRIP001 	if( pBackgroundObjUndoAction )
//STRIP001 	{
//STRIP001         // set merge flag, because a SdUndoGroupAction could have been inserted before
//STRIP001         pDocSh->GetUndoManager()->AddUndoAction( pBackgroundObjUndoAction, TRUE );
//STRIP001     }
//STRIP001 
//STRIP001 	///////////////////////////////////////////////////////////////////////////
//STRIP001 	//
//STRIP001 	// Objekte koennen max. so gross wie die ViewSize werden
//STRIP001 	//
//STRIP001 	Size aPageSize = pDoc->GetSdPage(0, ePageKind)->GetSize();
//STRIP001 	Size aViewSize = Size(aPageSize.Width() * 3, aPageSize.Height() * 2);
//STRIP001 	pDoc->SetMaxObjSize(aViewSize);
//STRIP001 
//STRIP001 	///////////////////////////////////////////////////////////////////////////
//STRIP001 	//
//STRIP001 	// ggfs. Preview den neuen Kontext mitteilen
//STRIP001 	//
//STRIP001 	pViewSh->UpdatePreview( pViewSh->GetActualPage() );
//STRIP001 }


}
