/*************************************************************************
 *
 *  $RCSfile: sd_fuslsel.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:53:49 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #ifndef _SVDPAGV_HXX //autogen
// auto strip #include <bf_svx/svdpagv.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_BINDINGS_HXX //autogen
// auto strip #include <bf_sfx2/bindings.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif
// auto strip #ifndef _SV_SOUND_HXX //autogen
// auto strip #include <vcl/sound.hxx>
// auto strip #endif
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif

// auto strip #include "sdresid.hxx"
// auto strip #include "fuslsel.hxx"
// auto strip #include "slidvish.hxx"
// auto strip #include "slidview.hxx"
// auto strip #include "sdwindow.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "sdpage.hxx"
// auto strip #include "pres.hxx"
// auto strip #include "fader.hxx"
// auto strip #include "showview.hxx"
#include "frmview.hxx"
#include "strings.hrc"
#include "app.hrc"                  
// auto strip #include "AccessibleSlideView.hxx"
namespace binfilter {

using namespace ::com::sun::star;

// --------------------
// - FuSlideSelection -
// --------------------

// -----------------------------------------------------------------------------

//STRIP001 TYPEINIT1( FuSlideSelection, FuSlide );
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 FuSlideSelection::FuSlideSelection(SdSlideViewShell* pViewSh,
//STRIP001 								   SdWindow*		 pWin,
//STRIP001 								   SdSlideView* 	 pView,
//STRIP001 								   SdDrawDocument*	 pDoc,
//STRIP001 								   SfxRequest&		 rReq)
//STRIP001 				: FuSlide(pViewSh, pWin, pView, pDoc, rReq),
//STRIP001 				  bSubstShown(FALSE),
//STRIP001 				  bPageHit(FALSE),
//STRIP001 				  bDragSelection(FALSE)
//STRIP001 {
//STRIP001 	pSound = new Sound;
//STRIP001 
//STRIP001 	pIsShowingEffectInfo = new FSS_IsShowingEffectInfo;
//STRIP001 	pIsShowingEffectInfo->bDisposed = FALSE;
//STRIP001 	pIsShowingEffectInfo->bIsShowingEffect = FALSE;
//STRIP001 
//STRIP001 	aDelayToScrollTimer.SetTimeout(50);
//STRIP001 	aDragTimer.SetTimeoutHdl( LINK( this, FuSlideSelection, DragSlideHdl ) );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 FuSlideSelection::~FuSlideSelection()
//STRIP001 {
//STRIP001     aDragTimer.Stop();
//STRIP001 	delete pSound;
//STRIP001 
//STRIP001 	if( pIsShowingEffectInfo && pIsShowingEffectInfo->bIsShowingEffect )
//STRIP001 	{
//STRIP001 		// we can not delete the info because its
//STRIP001 		// used in ShowFade(), but mark it as
//STRIP001 		// dispose so ShowFade() will clear it
//STRIP001 		pIsShowingEffectInfo->bDisposed = TRUE;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		delete pIsShowingEffectInfo;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL FuSlideSelection::MouseButtonDown(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	// #95491# remember button state for creation of own MouseEvents
//STRIP001 	SetMouseButtonCode(rMEvt.GetButtons());
//STRIP001 
//STRIP001 	BOOL			bReturn = FALSE;
//STRIP001 	Point			aPos( pWindow->PixelToLogic( rMEvt.GetPosPixel() ) );
//STRIP001     SdPage*         pHitPage = pSlView->GetHitPage( aPos );
//STRIP001     SdPage*         pFadePage = pSlView->GetFadePage( aPos );
//STRIP001 	USHORT			nNoOfPages = pDoc->GetSdPageCount(PK_STANDARD);
//STRIP001 	USHORT			nPage;
//STRIP001 
//STRIP001 	pWindow->CaptureMouse();
//STRIP001 
//STRIP001 	if( ( rMEvt.GetButtons() == MOUSE_LEFT ) && ( rMEvt.GetClicks() == 1 )	&& pHitPage )
//STRIP001 	{
//STRIP001 		bPageHit = TRUE;		 // Seite getroffen, merken fuer MouseMove
//STRIP001 
//STRIP001 		if (rMEvt.IsShift())
//STRIP001             pSlView->Select( ( pHitPage->GetPageNum() - 1 ) / 2, !pHitPage->IsSelected() );
//STRIP001 		else if( !pHitPage->IsSelected() )
//STRIP001 		{
//STRIP001     		// einfache Selektion, alle selektierten deselektieren, getroffene Seite selektieren
//STRIP001             pSlView->SelectAll( FALSE );
//STRIP001             pSlView->Select( ( pHitPage->GetPageNum() - 1 ) / 2, TRUE );
//STRIP001 		}
//STRIP001 
//STRIP001 		// Position und Status der Ersatzdarstellung merken
//STRIP001 		aDragPos = aPos;
//STRIP001 		bSubstShown = FALSE;
//STRIP001 		bFirstMouseMove = TRUE;
//STRIP001 		aDragTimer.Start();
//STRIP001 	}
//STRIP001 
//STRIP001 	// bei Doppelklick: einfache Selektion und in Zeichenmodus gehen
//STRIP001 	if( ( rMEvt.GetButtons() == MOUSE_LEFT ) && ( rMEvt.GetClicks() == 2 ) && pHitPage )
//STRIP001 	{
//STRIP001 		for (nPage = 0; nPage < nNoOfPages; nPage++)
//STRIP001 		{
//STRIP001 			SdPage* pTestPage = pDoc->GetSdPage(nPage, PK_STANDARD);
//STRIP001 			pDoc->SetSelected(pTestPage, FALSE);
//STRIP001 		}
//STRIP001 		
//STRIP001         pDoc->SetSelected(pHitPage, TRUE);
//STRIP001 		bReturn = TRUE;
//STRIP001 		pViewShell->GetFrameView()->SetSelectedPage((pHitPage->GetPageNum()-1)/2);
//STRIP001 		pViewShell->GetViewFrame()->GetDispatcher()->Execute(SID_DRAWINGMODE, SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD);
//STRIP001 	}
//STRIP001 
//STRIP001 	// eines der Diawechselsymbole getroffen?
//STRIP001 	if( ( rMEvt.GetButtons() == MOUSE_LEFT ) && ( rMEvt.GetClicks() == 1 ) && pFadePage )
//STRIP001 	{
//STRIP001     	ShowEffect( ( pFadePage->GetPageNum() - 1 ) >> 1 );
//STRIP001         return TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	// Selektionsrechteck aufziehen
//STRIP001 	if( !pHitPage && !bReturn )
//STRIP001 	{
//STRIP001 		// keine erweiterte Selektion: alle Seiten deselektieren
//STRIP001 		if( !rMEvt.IsShift() )
//STRIP001             pSlView->SelectAll( FALSE );
//STRIP001 
//STRIP001 		bDragSelection = TRUE;
//STRIP001 		pSlView->BegEncirclement(aPos);
//STRIP001 	}
//STRIP001 
//STRIP001 	return bReturn;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL FuSlideSelection::MouseMove(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	Point   aPix( rMEvt.GetPosPixel() );
//STRIP001 	Point   aPos( pWindow->PixelToLogic( aPix ) );
//STRIP001     BOOL    bReturn = FALSE;
//STRIP001 
//STRIP001     if( aDragTimer.IsActive() )
//STRIP001 	{
//STRIP001         if( bFirstMouseMove )
//STRIP001 			bFirstMouseMove = FALSE;
//STRIP001 		else
//STRIP001             aDragTimer.Stop();
//STRIP001 	}
//STRIP001 
//STRIP001 	if( rMEvt.GetButtons() == MOUSE_LEFT && bPageHit && !rMEvt.IsShift() || bSubstShown )
//STRIP001 	{										
//STRIP001 		ForceScroll( aPix );
//STRIP001 
//STRIP001 		// wenn DragRect erzeugt, an alter Pos. loeschen, Position aendern
//STRIP001 		if (bSubstShown)
//STRIP001 		{
//STRIP001 			DrawSubst();
//STRIP001 			ChangeSubstPos(aPos- aDragPos);
//STRIP001 			aDragPos = aPos;
//STRIP001 		}
//STRIP001 		// sonst Ersatzdarstellungen erzeugen
//STRIP001 		else
//STRIP001 		{
//STRIP001 			CreateSubst();
//STRIP001 			bSubstShown = TRUE;
//STRIP001 		}
//STRIP001 
//STRIP001 		// Aenderung der Einfuegeposition
//STRIP001 		Point aTemp = CalcPosOfInsertMarker (aPos);
//STRIP001 		if (aTemp != aPosOfInsertMarker)
//STRIP001 		{
//STRIP001 			DrawInsertMarker(FALSE);
//STRIP001 			aPosOfInsertMarker = aTemp;
//STRIP001 			DrawInsertMarker(TRUE);
//STRIP001 		}
//STRIP001 
//STRIP001 		// wenn Ersatzdarstellungen erzeugt, an neuer Pos. zeichnen
//STRIP001 		if (bSubstShown)
//STRIP001 		{
//STRIP001 			DrawSubst();
//STRIP001 		}
//STRIP001 
//STRIP001 		bReturn = TRUE;
//STRIP001 	}
//STRIP001 	else if (bDragSelection)
//STRIP001 	{
//STRIP001 		ForceScroll( aPix );
//STRIP001 		pSlView->MovEncirclement(aPos);
//STRIP001 	}
//STRIP001 
//STRIP001 	return bReturn;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL FuSlideSelection::MouseButtonUp(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	// #95491# remember button state for creation of own MouseEvents
//STRIP001 	SetMouseButtonCode(rMEvt.GetButtons());
//STRIP001 	SdDrawDocument* pDoc = pSlView->GetDoc();
//STRIP001 	BOOL            bReturn = FALSE;
//STRIP001 
//STRIP001 	if( aDragTimer.IsActive() )
//STRIP001 		aDragTimer.Stop();
//STRIP001 
//STRIP001 	if (rMEvt.GetButtons() == MOUSE_LEFT && bSubstShown)
//STRIP001 	{
//STRIP001 		Point aPos = pWindow->PixelToLogic(rMEvt.GetPosPixel());
//STRIP001 
//STRIP001 		// Ersatzdarstellung loeschen
//STRIP001 		DrawSubst();					// vom Bildschirm
//STRIP001 		DeleteSubst();					// und aus dem Speicher
//STRIP001 		bSubstShown = FALSE;
//STRIP001 
//STRIP001 		// Einfuegemarke loeschen
//STRIP001 		DrawInsertMarker(FALSE);
//STRIP001 
//STRIP001 		// Seiten ablegen wenn Ziel gueltig
//STRIP001 		USHORT nTargetPage = GetTargetPage( aPos );
//STRIP001 
//STRIP001 		pSlView->MoveMarked( nTargetPage );
//STRIP001 		pViewShell->GetViewFrame()->GetBindings().Invalidate(SID_STATUS_PAGE);
//STRIP001 		bReturn = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (bDragSelection)
//STRIP001 	{
//STRIP001 		aDragSelRect = pSlView->EndEncirclement();
//STRIP001 		bDragSelection = FALSE;
//STRIP001 		
//STRIP001         USHORT nNoOfPages = pDoc->GetSdPageCount(PK_STANDARD);
//STRIP001 		BOOL   bChanged = FALSE;
//STRIP001 		
//STRIP001         for( USHORT nPage = 0; nPage < nNoOfPages; nPage++ )
//STRIP001 		{
//STRIP001 			SdPage*   pPage = pDoc->GetSdPage(nPage, PK_STANDARD);
//STRIP001 			Rectangle aPageRect(pSlView->CalcPagePos(nPage), pPage->GetSize());
//STRIP001 			
//STRIP001             if( aDragSelRect.IsInside( aPageRect ) )
//STRIP001                 pSlView->Select( ( pPage->GetPageNum() - 1 ) / 2, rMEvt.IsShift() ? !pPage->IsSelected() : TRUE );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	bPageHit = FALSE;				  // ab jetzt keine Seite mehr "am Haken"
//STRIP001     pWindow->ReleaseMouse();
//STRIP001 
//STRIP001 	return bReturn;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL FuSlideSelection::KeyInput(const KeyEvent& rKEvt)
//STRIP001 {
//STRIP001     SdSlideView*	pSlideView = PTR_CAST( SdSlideView, pView );
//STRIP001 	BOOL            bReturn = FALSE;
//STRIP001 
//STRIP001 	switch( rKEvt.GetKeyCode().GetCode() )
//STRIP001 	{
//STRIP001         case( KEY_RETURN ):
//STRIP001         {
//STRIP001             if( pSlideView && pSlideView->HasFocus() )
//STRIP001             {
//STRIP001                 const USHORT nFocusPage = pSlideView->GetFocusPage();
//STRIP001 
//STRIP001 		        for( USHORT nPage = 0, nPageCount = pDoc->GetSdPageCount( PK_STANDARD ); nPage < nPageCount; nPage++ )
//STRIP001 			        pDoc->SetSelected( pDoc->GetSdPage( nPage, PK_STANDARD ), FALSE );
//STRIP001 		        
//STRIP001                 pDoc->SetSelected( pDoc->GetSdPage( nFocusPage, PK_STANDARD ), TRUE );
//STRIP001 		        pViewShell->GetFrameView()->SetSelectedPage( nFocusPage );
//STRIP001 		        pViewShell->GetViewFrame()->GetDispatcher()->Execute( SID_DRAWINGMODE, SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD );
//STRIP001 		        bReturn = TRUE;
//STRIP001             }
//STRIP001         }
//STRIP001 
//STRIP001 		case( KEY_ESCAPE ):
//STRIP001 		{
//STRIP001 			bReturn = cancel();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case( KEY_SPACE ):
//STRIP001 		{
//STRIP001             if( pSlideView && pSlideView->HasFocus() )
//STRIP001             {
//STRIP001                 pSlideView->MoveFocus( SLIDEVIEWFOCUSMOVE_SELECT );
//STRIP001     			bReturn = TRUE;
//STRIP001             }
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case( KEY_LEFT ):
//STRIP001 		{
//STRIP001             if( pSlideView && pSlideView->HasFocus() )
//STRIP001             {
//STRIP001                 pSlideView->MoveFocus( SLIDEVIEWFOCUSMOVE_LEFT );
//STRIP001     			bReturn = TRUE;
//STRIP001             }
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case( KEY_UP ):
//STRIP001 		{
//STRIP001             if( pSlideView && pSlideView->HasFocus() )
//STRIP001             {
//STRIP001                 pSlideView->MoveFocus( SLIDEVIEWFOCUSMOVE_TOP );
//STRIP001     			bReturn = TRUE;
//STRIP001             }
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case( KEY_RIGHT ):
//STRIP001 		{
//STRIP001             if( pSlideView && pSlideView->HasFocus() )
//STRIP001             {
//STRIP001                 pSlideView->MoveFocus( SLIDEVIEWFOCUSMOVE_RIGHT );
//STRIP001     			bReturn = TRUE;
//STRIP001             }
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case( KEY_DOWN ):
//STRIP001 		{
//STRIP001             if( pSlideView && pSlideView->HasFocus() )
//STRIP001             {
//STRIP001                 pSlideView->MoveFocus( SLIDEVIEWFOCUSMOVE_BOTTOM );
//STRIP001     			bReturn = TRUE;
//STRIP001             }
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case( KEY_ADD ):
//STRIP001 		{
//STRIP001 			pViewShell->SetZoom(pWindow->GetZoom() * 3 / 2);
//STRIP001 			bReturn = TRUE;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case( KEY_PAGEUP ):
//STRIP001 		{
//STRIP001             if( pSlideView )
//STRIP001             {
//STRIP001 			    ScrollStart();
//STRIP001 			    pViewShell->ScrollLines( 0, -10 );
//STRIP001 			    ScrollEnd();
//STRIP001 			    bReturn = TRUE;
//STRIP001             }
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case( KEY_PAGEDOWN ):
//STRIP001 		{
//STRIP001             if( pSlideView )
//STRIP001             {
//STRIP001 			    ScrollStart();
//STRIP001 			    pViewShell->ScrollLines( 0, 10 );
//STRIP001 			    ScrollEnd();
//STRIP001 			    bReturn = TRUE;
//STRIP001             }
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case( KEY_SUBTRACT ):
//STRIP001 		{
//STRIP001 			pViewShell->SetZoom(pWindow->GetZoom() * 2 / 3);
//STRIP001 			bReturn = TRUE;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001         case( KEY_DELETE ):
//STRIP001         {
//STRIP001             if( pSlideView )
//STRIP001             {
//STRIP001                 BOOL	bHasObjects = FALSE;
//STRIP001 			    USHORT	nMarkedPages = 0, nCount = pDoc->GetSdPageCount( PK_STANDARD );
//STRIP001 			    
//STRIP001 			    for( USHORT nPgNum = 0; nPgNum < nCount; nPgNum++ )
//STRIP001 			    {
//STRIP001 				    SdPage* pPage = pDoc->GetSdPage(nPgNum, PK_STANDARD);
//STRIP001 				    
//STRIP001 				    if( pPage && pPage->IsSelected() )
//STRIP001 				    {
//STRIP001 					    nMarkedPages++;
//STRIP001 					    
//STRIP001 					    if( pPage->GetObjCount() > 0 ) 
//STRIP001 						    bHasObjects = TRUE;
//STRIP001 				    }
//STRIP001 			    }
//STRIP001 
//STRIP001 			    if( nMarkedPages )
//STRIP001 			    {
//STRIP001 				    String aString( SdResId( nMarkedPages == 1 ? STR_WARN_DEL_SEL_PAGE : STR_WARN_DEL_SEL_PAGES ) );
//STRIP001 				    
//STRIP001 				    if( !bHasObjects || QueryBox( pWindow, WB_YES_NO, aString ).Execute() == RET_YES )
//STRIP001 					    pSlideView->DeleteMarked();
//STRIP001 			    }
//STRIP001 
//STRIP001 			    bReturn = TRUE;
//STRIP001             }
//STRIP001         }
//STRIP001         break;
//STRIP001 
//STRIP001         default:
//STRIP001         break;
//STRIP001 	}
//STRIP001 
//STRIP001 	return( bReturn || FuSlide::KeyInput( rKEvt ) );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void FuSlideSelection::Activate()
//STRIP001 {
//STRIP001 	FuSlide::Activate();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void FuSlideSelection::Deactivate()
//STRIP001 {
//STRIP001 	// Sound nicht mehr blockieren, damit er in der Show gespielt werden kann
//STRIP001 	if (pSound)
//STRIP001 		pSound->Stop();
//STRIP001 
//STRIP001 	FuSlide::Deactivate();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void FuSlideSelection::DrawSubst() const
//STRIP001 {
//STRIP001 	ULONG nNoOfSubst = aSubstList.Count();
//STRIP001 	ULONG nSubst;
//STRIP001 	for (nSubst = 0; nSubst < nNoOfSubst; nSubst++)
//STRIP001 	{
//STRIP001 		pViewShell->DrawMarkRect(*(Rectangle*)aSubstList.GetObject(nSubst));
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void FuSlideSelection::DrawDragSelectionRect() const
//STRIP001 {
//STRIP001 	pViewShell->DrawMarkRect(aDragSelRect);
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void FuSlideSelection::DrawInsertMarker (BOOL bShow)
//STRIP001 {
//STRIP001 	Color aNewColor;
//STRIP001 
//STRIP001 	if (bShow)
//STRIP001 		aNewColor = Color(COL_BLACK);
//STRIP001 	else
//STRIP001 		aNewColor = pWindow->GetBackground().GetColor();
//STRIP001 
//STRIP001 
//STRIP001 	Size  aMarkerSize	= pDoc->GetSdPage(0, PK_STANDARD)->GetSize();
//STRIP001 	aMarkerSize.Width() = pSlView->GetPageGap() / pSlView->GetPagesPerRow();
//STRIP001 
//STRIP001 	Rectangle aMarkerRect(aPosOfInsertMarker, aMarkerSize);
//STRIP001 	pViewShell->DrawFilledRect( aMarkerRect, aNewColor, aNewColor );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 USHORT FuSlideSelection::GetTargetPage(const Point& rPoint) const
//STRIP001 {
//STRIP001 	USHORT			nResult;
//STRIP001 	SdDrawDocument* pDoc		  = pSlView->GetDoc();
//STRIP001 	USHORT			nNumOfPages   = pDoc->GetSdPageCount(PK_STANDARD);
//STRIP001 
//STRIP001 	USHORT			nPagesPerRow  = pSlView->GetPagesPerRow();
//STRIP001 	Size			aPageSize	  = pDoc->GetSdPage(0, PK_STANDARD)->GetSize();
//STRIP001 	ULONG			nGap		  = pSlView->GetPageGap();
//STRIP001 
//STRIP001 	USHORT			nColumn;
//STRIP001 	USHORT			nRow;
//STRIP001 	Point			aWorkPoint;
//STRIP001 
//STRIP001 	if (rPoint.X() < (long)(nGap + aPageSize.Width()))
//STRIP001 	{
//STRIP001 		nColumn = 0;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aWorkPoint = rPoint;
//STRIP001 		aWorkPoint.X() += aPageSize.Width() / 2;
//STRIP001 		nColumn = (USHORT)(aWorkPoint.X() / (aPageSize.Width() + nGap));
//STRIP001 		nColumn = Min(nColumn, (USHORT)(nPagesPerRow - 1));
//STRIP001 	}
//STRIP001 
//STRIP001 	if (rPoint.Y() < (long)(nGap + aPageSize.Height()))
//STRIP001 	{
//STRIP001 		nRow = 0;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aWorkPoint = rPoint;
//STRIP001 		aWorkPoint.Y() -= nGap / 2;
//STRIP001 		nRow = (USHORT)(aWorkPoint.Y() / (aPageSize.Height() + nGap));
//STRIP001 		nRow = Min(nRow, (USHORT)(nNumOfPages / nPagesPerRow));
//STRIP001 	}
//STRIP001 
//STRIP001 	nResult = nRow * nPagesPerRow + nColumn;		// die getroffene Seite
//STRIP001 	nResult = Min(nResult, (USHORT)(nNumOfPages - 1));
//STRIP001 
//STRIP001 	// linke oder rechte Hlfte getroffen?
//STRIP001 	Rectangle	aPageRect(pSlView->GetPageArea(nResult));
//STRIP001 	long		nCenter = aPageRect.TopLeft().X();
//STRIP001 	nCenter += aPageRect.GetWidth() / 2;
//STRIP001 
//STRIP001 	// links getroffen, also hinter Vorgaengerseite einfuegen
//STRIP001 	if (rPoint.X() < nCenter)
//STRIP001 		nResult--;
//STRIP001 
//STRIP001 	return nResult;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 Point FuSlideSelection::CalcPosOfInsertMarker( const Point& rPoint )
//STRIP001 {
//STRIP001 	Point  aResult;
//STRIP001 	USHORT nNoOfPages = pDoc->GetSdPageCount(PK_STANDARD);
//STRIP001 
//STRIP001 	USHORT nTargetPage = GetTargetPage(rPoint);
//STRIP001 
//STRIP001 	if (nTargetPage == (USHORT)-1)
//STRIP001 	{
//STRIP001 		nTargetPage = 0;
//STRIP001 	}
//STRIP001 
//STRIP001 	Size  aPageSize   = pDoc->GetSdPage(0, PK_STANDARD)->GetSize();
//STRIP001 
//STRIP001 	Point aTargetPagePoint	= pSlView->CalcPagePos(nTargetPage);
//STRIP001 	Point aWorkPoint(aTargetPagePoint);
//STRIP001 	aWorkPoint.X()	 += aPageSize.Width() / 2;		// Seitenzentrum
//STRIP001 	aWorkPoint.Y()	 += aPageSize.Height() / 2;
//STRIP001 
//STRIP001 	// wenn es eine Folgeseite gibt: Marke hinter Zielseite oder vor Folgeseite
//STRIP001 	if (nTargetPage < nNoOfPages - 1)
//STRIP001 	{
//STRIP001 		Point aNextPagePoint = pSlView->CalcPagePos(nTargetPage + 1);
//STRIP001 		Point aNextCenter	 = aNextPagePoint;
//STRIP001 		aNextCenter.X() 	+= aPageSize.Width() / 2;
//STRIP001 		aNextCenter.Y() 	+= aPageSize.Height() / 2;
//STRIP001 
//STRIP001 		Point aToTarget = rPoint - aWorkPoint;
//STRIP001 		float fToTarget = aToTarget.X() * (float)aToTarget.X() +
//STRIP001 						  aToTarget.Y() * (float)aToTarget.Y();
//STRIP001 
//STRIP001 		Point aToNext	= rPoint - aNextCenter;
//STRIP001 		float fToNext	= aToNext.X() * (float)aToNext.X() +
//STRIP001 							aToNext.Y() * (float)aToNext.Y();
//STRIP001 
//STRIP001 		if (fToNext < fToTarget)
//STRIP001 		{
//STRIP001 			aWorkPoint = aNextCenter;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if (rPoint.X() < aWorkPoint.X())
//STRIP001 	{
//STRIP001 		aWorkPoint.X() -= aPageSize.Width() / 2;	  // zurueck zum Ursprung
//STRIP001 		aWorkPoint.Y() -= aPageSize.Height() / 2;
//STRIP001 		aResult 		= aWorkPoint;
//STRIP001 		aResult.X()    -= pSlView->GetPageGap() * 5 / 8;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aWorkPoint.X() -= aPageSize.Width() / 2;	  // zurueck zum Ursprung
//STRIP001 		aWorkPoint.Y() -= aPageSize.Height() / 2;
//STRIP001 		aResult 		= aWorkPoint;
//STRIP001 		aResult.X()    += aPageSize.Width() + pSlView->GetPageGap() * 3 / 8;
//STRIP001 	}
//STRIP001 	return aResult;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void FuSlideSelection::CreateSubst()
//STRIP001 {
//STRIP001     for( USHORT nPage = 0, nNoOfPages = pDoc->GetSdPageCount( PK_STANDARD ); nPage < nNoOfPages; nPage++ )
//STRIP001 	{
//STRIP001 		SdPage* pTestPage = pDoc->GetSdPage( nPage, PK_STANDARD );
//STRIP001 
//STRIP001 		if( pTestPage->IsSelected() )
//STRIP001 			aSubstList.Insert( new Rectangle( pSlView->GetPageArea( nPage ) ), LIST_APPEND ); 
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void FuSlideSelection::DeleteSubst()
//STRIP001 {
//STRIP001 	while (aSubstList.Count() > 0)
//STRIP001 	{
//STRIP001 		delete (Rectangle*)aSubstList.Remove((ULONG)0);
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void FuSlideSelection::ChangeSubstPos(const Point& rVector)
//STRIP001 {
//STRIP001 	Rectangle * pRect	   = NULL;
//STRIP001 	ULONG		nNoOfSubst = aSubstList.Count();
//STRIP001 	ULONG		nSubst;
//STRIP001 	for (nSubst = 0; nSubst < nNoOfSubst; nSubst++)
//STRIP001 	{
//STRIP001 		pRect = (Rectangle*)aSubstList.GetObject(nSubst);
//STRIP001 		pRect->SetPos(rVector + pRect->TopLeft());
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void FuSlideSelection::ShowEffect(USHORT nPageNo)
//STRIP001 {
//STRIP001 	FSS_IsShowingEffectInfo* pInfo = pIsShowingEffectInfo;
//STRIP001 
//STRIP001 	if( pInfo )
//STRIP001 		pInfo->bIsShowingEffect = TRUE;
//STRIP001 
//STRIP001 	SdPage* 	 pPage	   = pDoc->GetSdPage(nPageNo, PK_STANDARD);
//STRIP001 	Size		 aPageSize = pPage->GetSize();
//STRIP001 
//STRIP001 	// korrigierte Seitengroesse, sonst kommt die letzte Pixelreihe(spalte)
//STRIP001 	// nicht mit
//STRIP001 	Size aCPageSize(aPageSize);
//STRIP001 	Size aPixelSize = pWindow->PixelToLogic(Size(1,1));
//STRIP001 	aCPageSize.Width()	+= aPixelSize.Width();
//STRIP001 	aCPageSize.Height() += aPixelSize.Height();
//STRIP001 
//STRIP001 	Point aPagePos = pSlView->CalcPagePos(nPageNo);
//STRIP001 
//STRIP001 	// virtuelle Devices anlegen
//STRIP001 	MapMode aMapMode = pWindow->GetMapMode();
//STRIP001 	aMapMode.SetOrigin(Point(0,0));
//STRIP001 
//STRIP001 	VirtualDevice* pVDev = new VirtualDevice(*pWindow);
//STRIP001 	pVDev->SetMapMode(aMapMode);
//STRIP001 	pVDev->SetOutputSize(aCPageSize);
//STRIP001 
//STRIP001 	VirtualDevice* pVDevOld = new VirtualDevice(*pWindow);
//STRIP001 	pVDevOld->SetMapMode(aMapMode);
//STRIP001 	pVDevOld->SetOutputSize(aCPageSize);
//STRIP001 
//STRIP001 	// Views fuer die virtuellen Devices
//STRIP001 	ShowView aShowView(pDoc, pVDev, pViewShell);
//STRIP001 	aShowView.SetAllowMasterPageCaching(FALSE);
//STRIP001 	aShowView.SetLineDraft(pView->IsLineDraft());
//STRIP001 	aShowView.SetFillDraft(pView->IsFillDraft());
//STRIP001 	aShowView.SetTextDraft(pView->IsTextDraft());
//STRIP001 	aShowView.SetGrafDraft(pView->IsGrafDraft());
//STRIP001 
//STRIP001 	ShowView aShowViewOld(pDoc, pVDevOld, pViewShell);
//STRIP001 	aShowViewOld.SetAllowMasterPageCaching(FALSE);
//STRIP001 	aShowViewOld.SetLineDraft(pView->IsLineDraft());
//STRIP001 	aShowViewOld.SetFillDraft(pView->IsFillDraft());
//STRIP001 	aShowViewOld.SetTextDraft(pView->IsTextDraft());
//STRIP001 	aShowViewOld.SetGrafDraft(pView->IsGrafDraft());
//STRIP001 
//STRIP001 	// ein Fader zum Ueberblenden
//STRIP001 	Fader* pFader = new Fader(pWindow);
//STRIP001 	pFader->SetEffect(pPage->GetFadeEffect());
//STRIP001 	pFader->SetSpeed(pPage->GetFadeSpeed());
//STRIP001 	pFader->SetSource(Rectangle(Point(), aPageSize));
//STRIP001 	pFader->SetTarget(Rectangle(aPagePos, aPageSize));
//STRIP001 
//STRIP001 	// Bitmaps in virtuellen Devices bereitstellen
//STRIP001 	long nWinZoom = pWindow->GetZoom();
//STRIP001 	long nZoom;
//STRIP001 
//STRIP001     if (nPageNo == 0)
//STRIP001 	{
//STRIP001 		Rectangle aRect(Point(0,0), aCPageSize);
//STRIP001 		pVDevOld->SetFillColor( Color( COL_BLACK ) );
//STRIP001 		pVDevOld->DrawRect(aRect);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		// Vorgaengerdia bestimmen
//STRIP001 		short nPrevPage = nPageNo - 1;
//STRIP001 
//STRIP001 		nZoom = nWinZoom;
//STRIP001 		GraphicObject* pOld = const_cast< GraphicObject* >( pSlView->GetFromCache( pDoc->GetSdPage(nPrevPage, PK_STANDARD), nZoom, -10 ) );
//STRIP001 		
//STRIP001         if( !pOld )
//STRIP001 		{
//STRIP001 			SdPage* pPrevPage = pDoc->GetSdPage(nPrevPage, PK_STANDARD);
//STRIP001 			aShowViewOld.ShowPage(pPrevPage, Point(0,0));
//STRIP001 
//STRIP001 			SdrPageView* pPageView = aShowViewOld.GetPageView(pPrevPage);
//STRIP001 			FrameView* pFrameView = pViewShell->GetFrameView();
//STRIP001 			pPageView->SetVisibleLayers( pFrameView->GetVisibleLayers() );
//STRIP001 			pPageView->SetLockedLayers( pFrameView->GetLockedLayers() );
//STRIP001 			pPageView->SetPrintableLayers( pFrameView->GetPrintableLayers() );
//STRIP001 			aShowViewOld.InitRedraw(pVDevOld, Region(Rectangle(Point(), aCPageSize)));
//STRIP001     		while (!aShowViewOld.IsRedrawReady()){}
//STRIP001 		}
//STRIP001         else
//STRIP001             pOld->Draw( pVDevOld, Point(), aCPageSize );
//STRIP001 	}
//STRIP001 
//STRIP001 	nZoom = nWinZoom;
//STRIP001 	GraphicObject* pNew = const_cast< GraphicObject* >( pSlView->GetFromCache( pDoc->GetSdPage(nPageNo, PK_STANDARD), nZoom, -10 ) );
//STRIP001 	
//STRIP001     if( !pNew )
//STRIP001 	{
//STRIP001 		SdPage* pPage = pDoc->GetSdPage(nPageNo, PK_STANDARD);
//STRIP001 		aShowView.ShowPage(pPage, Point(0,0));
//STRIP001 
//STRIP001 		SdrPageView* pPageView = aShowView.GetPageView(pPage);
//STRIP001 		FrameView* pFrameView = pViewShell->GetFrameView();
//STRIP001 		pPageView->SetVisibleLayers( pFrameView->GetVisibleLayers() );
//STRIP001 		pPageView->SetLockedLayers( pFrameView->GetLockedLayers() );
//STRIP001 		pPageView->SetPrintableLayers( pFrameView->GetPrintableLayers() );
//STRIP001 
//STRIP001 		aShowView.InitRedraw(pVDev, Region(Rectangle(Point(0,0), aCPageSize)));
//STRIP001 		while (!aShowView.IsRedrawReady()){}
//STRIP001 	}
//STRIP001     else
//STRIP001 		pNew->Draw( pVDev, Point(), aCPageSize );
//STRIP001 
//STRIP001 	// virtuelle Devices an Fader uebergeben
//STRIP001 	pFader->SetOldVirtualDevice(pVDevOld);
//STRIP001 	pFader->SetNewVirtualDevice(pVDev);
//STRIP001 
//STRIP001 	// Sound beim Ueberblenden
//STRIP001 	if (pPage->IsSoundOn())
//STRIP001 	{
//STRIP001 		String aSoundFile(pPage->GetSoundFile());
//STRIP001 		if (aSoundFile.Len() > 0)
//STRIP001 		{
//STRIP001 			pSound->Stop();
//STRIP001 			pSound->SetSoundName(aSoundFile);
//STRIP001 			pSound->Play();
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	// ueberblenden
//STRIP001 	pFader->Fade();
//STRIP001 
//STRIP001 	delete pFader;
//STRIP001 	delete pVDev;
//STRIP001 	delete pVDevOld;
//STRIP001 
//STRIP001 	// check IsShowingEffectInfo if we were disposed
//STRIP001 	// inside pFader->Fade()
//STRIP001 	if( pInfo && !pInfo->bDisposed )
//STRIP001 	{
//STRIP001 		pInfo->bIsShowingEffect = FALSE;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		// were already dead, so kill the info and quit silently
//STRIP001 		delete pInfo;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void FuSlideSelection::ScrollStart()
//STRIP001 {
//STRIP001 	if ( pView->IsShownXorVisible(pWindow) )
//STRIP001 		pView->HideShownXor(pWindow);
//STRIP001 
//STRIP001 	DrawInsertMarker( FALSE );
//STRIP001 
//STRIP001 	if( bSubstShown )
//STRIP001 		DrawSubst();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void FuSlideSelection::ScrollEnd()
//STRIP001 {
//STRIP001 	if( bSubstShown )
//STRIP001 		DrawSubst();
//STRIP001 
//STRIP001 	if ( !pView->IsShownXorVisible(pWindow) )
//STRIP001 		pView->ShowShownXor(pWindow);
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void FuSlideSelection::Paint(const Rectangle& rRect, SdWindow* pWin)
//STRIP001 {
//STRIP001 	if (bSubstShown && pView->IsShownXorVisible(pWindow))
//STRIP001 	{
//STRIP001 		DrawSubst();
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( FuSlideSelection, DragSlideHdl, Timer*, pTimer )
//STRIP001 {
//STRIP001 	if( bPageHit )
//STRIP001 	{
//STRIP001 		DrawSubst();
//STRIP001 		DeleteSubst();
//STRIP001 		DrawInsertMarker( FALSE );
//STRIP001 		bPageHit = bSubstShown = FALSE;
//STRIP001 		pWindow->ReleaseMouse();
//STRIP001 		pView->StartDrag( aDragPos, pWindow );
//STRIP001 	}
//STRIP001 	
//STRIP001     return 0;
//STRIP001 }

/** is called when the currenct function should be aborted. <p>
	This is used when a function gets a KEY_ESCAPE but can also
	be called directly.

	@returns true if a active function was aborted
*/
//STRIP001 bool FuSlideSelection::cancel()
//STRIP001 {
//STRIP001     SdSlideView*	pSlideView = PTR_CAST( SdSlideView, pView );
//STRIP001 	if( pSlideView )
//STRIP001 	{
//STRIP001 		pSlideView->MoveFocus( SLIDEVIEWFOCUSMOVE_TOGGLE );
//STRIP001 		return true;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		return false;
//STRIP001 	}
//STRIP001 }
}
