/*************************************************************************
 *
 *  $RCSfile: sd_futhes.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:56:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

// auto strip #include <tools/pstm.hxx>
// auto strip #include <bf_svx/outliner.hxx>
// auto strip #include <bf_offmgr/osplcfg.hxx>
// auto strip #ifndef _OFF_APP_HXX //autogen
// auto strip #include <bf_offmgr/app.hxx>
// auto strip #endif
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOBJ_HXX //autogen
// auto strip #include <bf_svx/svdobj.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOTEXT_HXX //autogen
// auto strip #include <bf_svx/svdotext.hxx>
// auto strip #endif

// auto strip #ifndef _EEITEM_HXX
// auto strip #include <bf_svx/eeitem.hxx>
// auto strip #endif

#define ITEMID_LANGUAGE 		SID_ATTR_CHAR_LANGUAGE
#include <bf_svx/dialogs.hrc>
// auto strip #include <bf_svx/svxerr.hxx>
// auto strip #include <bf_svx/dialmgr.hxx>

// auto strip #ifndef _UNO_LINGU_HXX
// auto strip #include <bf_svx/unolingu.hxx>
// auto strip #endif
// auto strip #ifndef _COMPHELPER_PROCESSFACTORY_HXX_
// auto strip #include <comphelper/processfactory.hxx>
// auto strip #endif
#include "app.hrc"
#include "strings.hrc"
// auto strip #include "drawdoc.hxx"
// auto strip #include "app.hxx"
// auto strip #include "futhes.hxx"
// auto strip #include "sdview.hxx"
#include "sdoutl.hxx"
// auto strip #include "drviewsh.hxx"
// auto strip #include "outlnvsh.hxx"
#include "sdwindow.hxx"
// auto strip #include "sdresid.hxx"
namespace binfilter {

using namespace ::rtl;
using namespace ::com::sun::star;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::linguistic2;

class SfxRequest;

//STRIP001 TYPEINIT1( FuThesaurus, FuPoor );
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuThesaurus::FuThesaurus( SdViewShell* pViewSh, SdWindow* pWin, SdView* pView,
//STRIP001 				  SdDrawDocument* pDoc, SfxRequest& rReq )
//STRIP001 	   : FuPoor(pViewSh, pWin, pView, pDoc, rReq)
//STRIP001 {
//STRIP001 	SfxErrorContext aContext(ERRCTX_SVX_LINGU_THESAURUS, String(),
//STRIP001 							 pWin, RID_SVXERRCTX, DIALOG_MGR() );
//STRIP001 
//STRIP001 	if ( pViewShell->ISA(SdDrawViewShell) )
//STRIP001 	{
//STRIP001 		SdrTextObj* pTextObj = NULL;
//STRIP001 
//STRIP001 		if ( pView->HasMarkedObj() )
//STRIP001 		{
//STRIP001 			const SdrMarkList& rMarkList = pView->GetMarkList();
//STRIP001 
//STRIP001 			if ( rMarkList.GetMarkCount() == 1 )
//STRIP001 			{
//STRIP001 				SdrMark* pMark = rMarkList.GetMark(0);
//STRIP001 				SdrObject* pObj = pMark->GetObj();
//STRIP001 
//STRIP001 				if ( pObj->ISA(SdrTextObj) )
//STRIP001 				{
//STRIP001 					pTextObj = (SdrTextObj*) pObj;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		Outliner* pOutliner = pView->GetTextEditOutliner();
//STRIP001 		const OutlinerView* pOutlView = pView->GetTextEditOutlinerView();
//STRIP001 
//STRIP001 		if ( pTextObj && pOutliner && pOutlView )
//STRIP001 		{
//STRIP001 			if ( !pOutliner->GetSpeller().is() )
//STRIP001 			{
//STRIP001 	            Reference< XSpellChecker1 > xSpellChecker( LinguMgr::GetSpellChecker() );
//STRIP001 	            if ( xSpellChecker.is() )
//STRIP001 		            pOutliner->SetSpeller( xSpellChecker );
//STRIP001 
//STRIP001 	            Reference< XHyphenator > xHyphenator( LinguMgr::GetHyphenator() );
//STRIP001 	            if( xHyphenator.is() )
//STRIP001 		            pOutliner->SetHyphenator( xHyphenator );
//STRIP001 
//STRIP001 				pOutliner->SetDefaultLanguage( pDoc->GetLanguage( EE_CHAR_LANGUAGE ) );
//STRIP001 			}
//STRIP001 
//STRIP001 			EESpellState eState = ( (OutlinerView*) pOutlView)->StartThesaurus();
//STRIP001 			DBG_ASSERT(eState != EE_SPELL_NOSPELLER, "No SpellChecker");
//STRIP001 
//STRIP001 			if (eState == EE_SPELL_NOLANGUAGE)
//STRIP001 			{
//STRIP001 				ErrorBox(pWindow, WB_OK, String(SdResId(STR_NOLANGUAGE))).Execute();
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if ( pViewShell->ISA(SdOutlineViewShell) )
//STRIP001 	{
//STRIP001 		Outliner* pOutliner = pDoc->GetOutliner();
//STRIP001 		OutlinerView* pOutlView = pOutliner->GetView(0);
//STRIP001 
//STRIP001 		if ( !pOutliner->GetSpeller().is() )
//STRIP001 		{
//STRIP001 	        Reference< XSpellChecker1 > xSpellChecker( LinguMgr::GetSpellChecker() );
//STRIP001 	        if ( xSpellChecker.is() )
//STRIP001 		        pOutliner->SetSpeller( xSpellChecker );
//STRIP001 
//STRIP001 	        Reference< XHyphenator > xHyphenator( LinguMgr::GetHyphenator() );
//STRIP001 	        if( xHyphenator.is() )
//STRIP001 		        pOutliner->SetHyphenator( xHyphenator );
//STRIP001 
//STRIP001 			pOutliner->SetDefaultLanguage( pDoc->GetLanguage( EE_CHAR_LANGUAGE ) );
//STRIP001 		}
//STRIP001 
//STRIP001 		EESpellState eState = pOutlView->StartThesaurus();
//STRIP001 		DBG_ASSERT(eState != EE_SPELL_NOSPELLER, "No SpellChecker");
//STRIP001 
//STRIP001 		if (eState == EE_SPELL_NOLANGUAGE)
//STRIP001 		{
//STRIP001 			ErrorBox(pWindow, WB_OK, String(SdResId(STR_NOLANGUAGE))).Execute();
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Destruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 FuThesaurus::~FuThesaurus()
//STRIP001 {
//STRIP001 }


}
