/*************************************************************************
 *
 *  $RCSfile: sd_sdmtf.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:58:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #ifndef _SVDOATTR_HXX //autogen
// auto strip #include <bf_svx/svdoattr.hxx>
// auto strip #endif
// auto strip #ifndef _SVDPAGE_HXX //autogen
// auto strip #include <bf_svx/svdpage.hxx>
// auto strip #endif
// auto strip #ifndef _SV_VIRDEV_HXX //autogen
// auto strip #include <vcl/virdev.hxx>
// auto strip #endif
// auto strip #ifndef _SV_IMAGE_HXX //autogen
// auto strip #include <vcl/image.hxx>
// auto strip #endif

#define FUSLIDESHOW_INTERN

// auto strip #include "sdmtf.hxx"
#include "fuslshow.hxx"
// auto strip #include "anminfo.hxx"
// auto strip #include "drawdoc.hxx"
namespace binfilter {


#define MARKEROBJ( nMarker )	( (Marker*) pMarkerList->GetObject( nMarker ) )
#define FIRSTMARKER()			( (Marker*) pMarkerList->First() )
#define NEXTMARKER()			( (Marker*) pMarkerList->Next() )


/******************************************************************************
|*
|*
|*
\******************************************************************************/

//STRIP001 SdMetaFile::SdMetaFile( FuSlideShow* pShow ) :
//STRIP001 			pFuSlideShow( pShow )
//STRIP001 {
//STRIP001 	pMarkerList = new List;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /******************************************************************************
//STRIP001 |*
//STRIP001 |*
//STRIP001 |*
//STRIP001 \******************************************************************************/
//STRIP001 
//STRIP001 SdMetaFile::~SdMetaFile()
//STRIP001 {
//STRIP001 	Clear();
//STRIP001 	delete pMarkerList;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /******************************************************************************
//STRIP001 |*
//STRIP001 |*
//STRIP001 |*
//STRIP001 \******************************************************************************/
//STRIP001 
//STRIP001 void SdMetaFile::Clear()
//STRIP001 {
//STRIP001 	GDIMetaFile::Clear();
//STRIP001 
//STRIP001 	Marker*	pMarker = FIRSTMARKER();
//STRIP001 
//STRIP001 	while( pMarker )
//STRIP001 	{
//STRIP001 		delete pMarker;
//STRIP001 		pMarker = NEXTMARKER();
//STRIP001 	}
//STRIP001 
//STRIP001 	pMarkerList->Clear();
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /******************************************************************************
//STRIP001 |*
//STRIP001 |*
//STRIP001 |*
//STRIP001 \******************************************************************************/
//STRIP001 
//STRIP001 void SdMetaFile::InsertMarker( const Marker& rMarker )
//STRIP001 {
//STRIP001 	Marker* pMarker = new Marker( rMarker );
//STRIP001 
//STRIP001 	pMarker->nMtfPos = GetActionCount();
//STRIP001 	pMarkerList->Insert( pMarker, LIST_APPEND );
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /******************************************************************************
//STRIP001 |*
//STRIP001 |*
//STRIP001 |*
//STRIP001 \******************************************************************************/
//STRIP001 
//STRIP001 BOOL SdMetaFile::ReplaceMarker( const Marker& rMarker, const Marker& rNewMarker )
//STRIP001 {
//STRIP001 	const ULONG	nMarkerPos = ImpGetMarkerPos( rMarker );
//STRIP001 
//STRIP001 	if ( nMarkerPos != METAFILE_END )
//STRIP001 	{
//STRIP001 		Marker* pNewMarker = new Marker( rNewMarker );
//STRIP001 		Marker* pOldMarker = (Marker*) pMarkerList->Replace( pNewMarker, nMarkerPos );
//STRIP001 
//STRIP001 		pNewMarker->nMtfPos = pOldMarker->nMtfPos;
//STRIP001 		delete pOldMarker;
//STRIP001 
//STRIP001 		return TRUE;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		return FALSE;
//STRIP001 }
//STRIP001 
//STRIP001 /******************************************************************************
//STRIP001 |*
//STRIP001 |*
//STRIP001 |*
//STRIP001 \******************************************************************************/
//STRIP001 
//STRIP001 BOOL SdMetaFile::HasMarker( const Marker& rMarker ) const
//STRIP001 {
//STRIP001 	BOOL bRet = FALSE;
//STRIP001 
//STRIP001 	for( ULONG i = 0, nCount = pMarkerList->Count(); i < nCount; i++ )
//STRIP001 	{
//STRIP001 		if( rMarker == *MARKEROBJ( i ) )
//STRIP001 		{
//STRIP001 			bRet = TRUE;
//STRIP001 			break;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 /******************************************************************************
//STRIP001 |*
//STRIP001 |*
//STRIP001 |*
//STRIP001 \******************************************************************************/
//STRIP001 
//STRIP001 ULONG SdMetaFile::ImpGetMarkerPos( const Marker& rMarker )
//STRIP001 {
//STRIP001 	ULONG nMarkerPos = METAFILE_END;
//STRIP001 
//STRIP001 	for( ULONG i = 0, nCount = pMarkerList->Count(); i < nCount; i++ )
//STRIP001 	{
//STRIP001 		if( rMarker == *MARKEROBJ( i ) )
//STRIP001 		{
//STRIP001 			nMarkerPos = i;
//STRIP001 			break;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return nMarkerPos;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /******************************************************************************
//STRIP001 |*
//STRIP001 |*
//STRIP001 |*
//STRIP001 \******************************************************************************/
//STRIP001 
//STRIP001 void SdMetaFile::ImpPlayToNextStart( ULONG& rMarker, OutputDevice* pOut )
//STRIP001 {
//STRIP001 	const ULONG nCount = pMarkerList->Count();
//STRIP001 	ULONG		nMtfPos;
//STRIP001 	BOOL		bFound = FALSE;
//STRIP001 
//STRIP001 	while( TRUE )
//STRIP001 	{
//STRIP001 		if ( ++rMarker < nCount )
//STRIP001 		{
//STRIP001 			const Marker* pMarker = MARKEROBJ( rMarker );
//STRIP001 
//STRIP001 			if ( pMarker->IsObjStart() )
//STRIP001 			{
//STRIP001 				nMtfPos = pMarker->nMtfPos;
//STRIP001 				break;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			nMtfPos = rMarker = METAFILE_END;
//STRIP001 			break;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	GDIMetaFile::Play( pOut, nMtfPos );
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /******************************************************************************
//STRIP001 |*
//STRIP001 |*
//STRIP001 |*
//STRIP001 \******************************************************************************/
//STRIP001 
//STRIP001 void SdMetaFile::ImpPlayToNextMarker( ULONG& rMarker, OutputDevice* pOut )
//STRIP001 {
//STRIP001 	ULONG nMtfPos;
//STRIP001 
//STRIP001 	if ( ++rMarker < pMarkerList->Count() )
//STRIP001 		nMtfPos = MARKEROBJ( rMarker )->nMtfPos;
//STRIP001 	else
//STRIP001 		nMtfPos = rMarker = METAFILE_END;
//STRIP001 
//STRIP001 	GDIMetaFile::Play( pOut, nMtfPos );
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /******************************************************************************
//STRIP001 |*
//STRIP001 |*
//STRIP001 |*
//STRIP001 \******************************************************************************/
//STRIP001 
//STRIP001 void SdMetaFile::ImpSkipActualObject( ULONG& rMarker, OutputDevice* pOut )
//STRIP001 {
//STRIP001 	const void*	pObject = MARKEROBJ( rMarker )->pObj;
//STRIP001 	ULONG		nMtfPos = METAFILE_END;
//STRIP001 	const ULONG	nCount = pMarkerList->Count();
//STRIP001 	BOOL		bEndFound = FALSE;
//STRIP001 
//STRIP001 	// wir ueberspringen bis zum naechsten Marker, der
//STRIP001 	// das gleiche Objekt kennzeichnet und ein Ende-Marker ist
//STRIP001 	while ( ++rMarker < nCount )
//STRIP001 	{
//STRIP001 		const Marker* pMarker = MARKEROBJ( rMarker );
//STRIP001 
//STRIP001 		if ( ( pMarker->pObj == pObject ) && pMarker->IsObjEnd() )
//STRIP001 		{
//STRIP001 			// der letzte Marker ist der letzte Marker fuer das Object
//STRIP001 			nMtfPos = pMarker->nMtfPos;
//STRIP001 			break;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	Wind( nMtfPos );
//STRIP001 	ImpPlayToNextMarker( rMarker, pOut );
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /******************************************************************************
//STRIP001 |*
//STRIP001 |*
//STRIP001 |*
//STRIP001 \******************************************************************************/
//STRIP001 
//STRIP001 void SdMetaFile::ImpPlaySlowObj( ULONG& rMarker, OutputDevice* pOut )
//STRIP001 {
//STRIP001 	const SdSlowObjRecord* pRec = pFuSlideShow->GetSlowObjRecord( (SdrAttrObj*) MARKEROBJ( rMarker )->pObj );
//STRIP001 
//STRIP001 	if( pRec  )
//STRIP001 	{
//STRIP001 		if( pRec->pImage )
//STRIP001 			pOut->DrawImage( pRec->aPos, *pRec->pImage );
//STRIP001 		else if( pRec->pBmpEx )
//STRIP001 			pOut->DrawBitmapEx( pRec->aPos, *pRec->pBmpEx );
//STRIP001 
//STRIP001 		// dieses Objekt im Mtf ueberspringen
//STRIP001 		ImpSkipActualObject( rMarker, pOut );
//STRIP001 	}
//STRIP001 	else
//STRIP001 		ImpPlayToNextStart( rMarker, pOut );
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /******************************************************************************
//STRIP001 |*
//STRIP001 |*
//STRIP001 |*
//STRIP001 \******************************************************************************/
//STRIP001 
//STRIP001 void SdMetaFile::Play( OutputDevice* pOut,
//STRIP001 					   const Marker& rStartMarker, const Marker& rEndMarker,
//STRIP001 					   BOOL bUseOutDevDrawMode )
//STRIP001 {
//STRIP001 	const ULONG nOldDrawMode = pOut->GetDrawMode();
//STRIP001 
//STRIP001 	if( !bUseOutDevDrawMode )
//STRIP001 		pOut->SetDrawMode( DRAWMODE_DEFAULT );
//STRIP001 
//STRIP001 	// keine Marker im Metafile => alles abspielen
//STRIP001 	if ( !pMarkerList->Count() )
//STRIP001 	{
//STRIP001 		WindStart();
//STRIP001 		GDIMetaFile::Play( pOut );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		ULONG		nCurMarker = ImpGetMarkerPos( rStartMarker );
//STRIP001 		const ULONG nEndMarker = ImpGetMarkerPos( rEndMarker );
//STRIP001 		Marker		aActMarker;
//STRIP001 
//STRIP001 		// auf Startposition
//STRIP001 		if ( nCurMarker != METAFILE_END )
//STRIP001 		{
//STRIP001 			aActMarker = *MARKEROBJ( nCurMarker );
//STRIP001 			Wind( aActMarker.nMtfPos );
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			// bis zum ersten Marker abspielen
//STRIP001 			WindStart();
//STRIP001 			GDIMetaFile::Play( pOut, FIRSTMARKER()->nMtfPos );
//STRIP001 		}
//STRIP001 
//STRIP001 		while ( nCurMarker < nEndMarker )
//STRIP001 		{
//STRIP001 			SdrObject*			pObject = (SdrObject*) aActMarker.pObj;
//STRIP001 			SdAnimationInfo*	pInfo;
//STRIP001 			BOOL				bGrouped;
//STRIP001 
//STRIP001 			if ( pObject )
//STRIP001 			{
//STRIP001 				bGrouped = pObject->IsGrouped();
//STRIP001 				pInfo = ( (SdDrawDocument*) pObject->GetModel() )->GetAnimationInfo( pObject );
//STRIP001 			}
//STRIP001 			else
//STRIP001 				pInfo = NULL;
//STRIP001 
//STRIP001 			// Start eines Animationsobjekts?
//STRIP001 			if ( pInfo && aActMarker.IsObjStart() )
//STRIP001 			{
//STRIP001 				// wenn das Objekt gezeichnet werden soll, gleich bis zum
//STRIP001 				// naechsten Startlabel bzw. Metafileende abspielen
//STRIP001 				if ( !pInfo->bInvisibleInPresentation && pInfo->bShow )
//STRIP001 				{
//STRIP001 					// langsame Objekte
//STRIP001 					if ( aActMarker.IsSlowObj() && !pInfo->bDimmed )
//STRIP001 						ImpPlaySlowObj( nCurMarker, pOut );
//STRIP001 					else if ( pInfo->bDimmed )
//STRIP001 					{
//STRIP001 						// abgeblendete Objekte koennen nicht aus dem Metafile
//STRIP001 						// gezeichnet werden, die muessen wir selbst zeichnen
//STRIP001 						if ( pObject == (SdrObject*) pFuSlideShow->GetLayoutText() )
//STRIP001 							pFuSlideShow->PaintLayoutClone( pOut );
//STRIP001 						else
//STRIP001 							pFuSlideShow->PaintDimmedObject( (SdrAttrObj*) pObject, pOut, pInfo->aDimColor, TRUE );
//STRIP001 
//STRIP001 						// dieses Objekt im Mtf ueberspringen
//STRIP001 						ImpSkipActualObject( nCurMarker, pOut );
//STRIP001 					}
//STRIP001 					else if ( pObject == (SdrObject*) pFuSlideShow->GetLayoutText() )
//STRIP001 					{
//STRIP001 						// animierte Gliederung, kann TEILWEISE sichtbar sein
//STRIP001 						pFuSlideShow->PaintLayoutClone( pOut );
//STRIP001 						ImpSkipActualObject( nCurMarker, pOut );
//STRIP001 					}
//STRIP001 					else
//STRIP001 						ImpPlayToNextStart( nCurMarker, pOut );
//STRIP001 				}
//STRIP001 				else
//STRIP001 					ImpSkipActualObject( nCurMarker, pOut );
//STRIP001 			}
//STRIP001 			else if ( aActMarker.IsStart() && aActMarker.IsSlowObj() )
//STRIP001 				ImpPlaySlowObj( nCurMarker, pOut );
//STRIP001 			else
//STRIP001 				ImpPlayToNextMarker( nCurMarker, pOut );
//STRIP001 
//STRIP001 			if ( nCurMarker != METAFILE_END )
//STRIP001 				aActMarker = *MARKEROBJ( nCurMarker );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	pOut->SetDrawMode( nOldDrawMode );
//STRIP001 }



}
