/*************************************************************************
 *
 *  $RCSfile: animobjs.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:36:04 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef _SD_ANIMOBJS_HXX
#define _SD_ANIMOBJS_HXX

#ifndef _SFXDOCKWIN_HXX //autogen
#include <bf_sfx2/dockwin.hxx>
#endif
#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _STDCTRL_HXX //autogen
#include <svtools/stdctrl.hxx>
#endif
#ifndef _SV_GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif
#ifndef _SFXCTRLITEM_HXX //autogen
#include <bf_sfx2/ctrlitem.hxx>
#endif

#ifndef _SV_BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif

#ifndef _SV_FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif

#ifndef _SVX_DLG_CTRL_HXX //autogen
#include <bf_svx/dlgctrl.hxx>
#endif


#ifndef _SV_LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif

#ifndef _SD_SDRESID_HXX
#include "sdresid.hxx"
#endif
class BitmapEx;
namespace binfilter {

class SdDrawDocument;
class SdView;

//------------------------------------------------------------------------

//STRIP001 enum BitmapAdjustment
//STRIP001 {
//STRIP001 	BA_LEFT_UP,
//STRIP001 	BA_LEFT,
//STRIP001 	BA_LEFT_DOWN,
//STRIP001 	BA_UP,
//STRIP001 	BA_CENTER,
//STRIP001 	BA_DOWN,
//STRIP001 	BA_RIGHT_UP,
//STRIP001 	BA_RIGHT,
//STRIP001 	BA_RIGHT_DOWN
//STRIP001 };
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 class SdDisplay : public Control
//STRIP001 {
//STRIP001 private:
//STRIP001 	BitmapEx 	aBitmapEx;
//STRIP001 	Fraction	aScale;
//STRIP001 
//STRIP001 public:
//STRIP001 	SdDisplay( Window* pWin, SdResId Id );
//STRIP001 	~SdDisplay();
//STRIP001 
//STRIP001 	virtual void Paint( const Rectangle& rRect );
//STRIP001 
//STRIP001 	void	SetBitmapEx( BitmapEx* pBmpEx );
//STRIP001 	void	SetScale( const Fraction& rFrac );
//STRIP001 
//STRIP001 	virtual void DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 };
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 class SdAnimationWin : public SfxDockingWindow
//STRIP001 {
//STRIP001  friend class SdAnimationChildWindow;
//STRIP001  friend class SdAnimationControllerItem;
//STRIP001 
//STRIP001 private:
//STRIP001 	SdDisplay		aCtlDisplay;
//STRIP001 	ImageButton 	aBtnFirst;
//STRIP001 	ImageButton 	aBtnReverse;
//STRIP001 	ImageButton 	aBtnStop;
//STRIP001 	ImageButton 	aBtnPlay;
//STRIP001 	ImageButton 	aBtnLast;
//STRIP001 	NumericField	aNumFldBitmap;
//STRIP001 	TimeField		aTimeField;
//STRIP001 	ListBox 		aLbLoopCount;
//STRIP001 
//STRIP001 	ImageButton		aBtnGetOneObject;
//STRIP001 	ImageButton		aBtnGetAllObjects;
//STRIP001 	ImageButton		aBtnRemoveBitmap;
//STRIP001 	ImageButton		aBtnRemoveAll;
//STRIP001 	FixedText		aFtCount;
//STRIP001 	FixedInfo		aFiCount;
//STRIP001 	FixedLine		aGrpBitmap;
//STRIP001 
//STRIP001 	RadioButton		aRbtGroup;
//STRIP001 	RadioButton		aRbtBitmap;
//STRIP001 	FixedText		aFtAdjustment;
//STRIP001 	ListBox 		aLbAdjustment;
//STRIP001 	PushButton		aBtnCreateGroup;
//STRIP001 	FixedLine		aGrpAnimation;
//STRIP001 
//STRIP001 	Window* 		pWin;
//STRIP001 	List			aBmpExList;
//STRIP001 	List			aTimeList;
//STRIP001 	SdDrawDocument* pMyDoc;
//STRIP001 	BitmapEx* 		pBitmapEx;
//STRIP001 
//STRIP001 	Size			aSize;
//STRIP001 	Size			aFltWinSize;
//STRIP001 	Size			aDisplaySize;
//STRIP001 	Size			aBmpSize;
//STRIP001 	BOOL			bMovie;
//STRIP001 	BOOL			bAllObjects;
//STRIP001 
//STRIP001 	SfxBindings*				pBindings;
//STRIP001 	SdAnimationControllerItem*	pControllerItem;
//STRIP001 
//STRIP001 	//------------------------------------
//STRIP001 
//STRIP001 	DECL_LINK( ClickFirstHdl, void * );
//STRIP001 	DECL_LINK( ClickStopHdl, void * );
//STRIP001 	DECL_LINK( ClickPlayHdl, void * );
//STRIP001 	DECL_LINK( ClickLastHdl, void * );
//STRIP001 	DECL_LINK( ClickGetObjectHdl, void * );
//STRIP001 	DECL_LINK( ClickRemoveBitmapHdl, void * );
//STRIP001 	DECL_LINK( ClickRbtHdl, void * );
//STRIP001 	DECL_LINK( ClickCreateGroupHdl, void * );
//STRIP001 	DECL_LINK( ModifyBitmapHdl, void * );
//STRIP001 	DECL_LINK( ModifyTimeHdl, void * );
//STRIP001 
//STRIP001 	void			UpdateControl( ULONG nPos, BOOL bDisableCtrls = FALSE );
//STRIP001 	void			ResetAttrs();
//STRIP001 	void			WaitInEffect( ULONG nMilliSeconds ) const;
//STRIP001 	void			WaitInEffect( ULONG nMilliSeconds, ULONG nTime,
//STRIP001 										SfxProgress* pStbMgr ) const;
//STRIP001 	Fraction		GetScale();
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual BOOL	Close();
//STRIP001 	virtual void	Resize();
//STRIP001 	virtual void	FillInfo( SfxChildWinInfo& ) const;
//STRIP001 
//STRIP001 public:
//STRIP001 			SdAnimationWin( SfxBindings* pBindings, SfxChildWindow *pCW,
//STRIP001 						Window* pParent, const SdResId& rSdResId );
//STRIP001 			~SdAnimationWin();
//STRIP001 
//STRIP001 	void	AddObj( SdView& rView );
//STRIP001 	void	CreateAnimObj( SdView& rView );
//STRIP001 
//STRIP001 	virtual void DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 };

/*************************************************************************
|*
|* Ableitung vom SfxChildWindow als "Behaelter" fuer Animator
|*
\************************************************************************/

class SdAnimationChildWindow : public SfxChildWindow
{
 public:
	SdAnimationChildWindow( Window*, USHORT, SfxBindings*,
		SfxChildWinInfo*);

	SFX_DECL_CHILDWINDOW(SdAnimationChildWindow);
};

//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* ControllerItem fuer Animator
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 class SdAnimationControllerItem : public SfxControllerItem
//STRIP001 {
//STRIP001 	SdAnimationWin* pAnimationWin;
//STRIP001 
//STRIP001  protected:
//STRIP001 	virtual void StateChanged( USHORT nSId, SfxItemState eState,
//STRIP001 								const SfxPoolItem* pState );
//STRIP001 
//STRIP001  public:
//STRIP001 	SdAnimationControllerItem( USHORT, SdAnimationWin*, SfxBindings* );
//STRIP001 };

} //namespace binfilter
#endif		// _SD_ANIMOBJS_HXX

