/*************************************************************************
 *
 *  $RCSfile: sd_drtxtob1.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:11:36 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#define ITEMID_FRAMEDIR EE_PARA_WRITINGDIR

// auto strip #ifndef _OUTLINER_HXX
// auto strip #include <bf_svx/outliner.hxx>
// auto strip #endif
#ifndef _EEITEMID_HXX
#include <bf_svx/eeitemid.hxx>
#endif

#ifndef _EEITEM_HXX //autogen
#include <bf_svx/eeitem.hxx>
#endif

// auto strip #ifndef _ULSPITEM_HXX
// auto strip #include <bf_svx/ulspitem.hxx>
// auto strip #endif
// auto strip #ifndef _LSPCITEM_HXX
// auto strip #include <bf_svx/lspcitem.hxx>
// auto strip #endif
// auto strip #ifndef _ADJITEM_HXX
// auto strip #include <bf_svx/adjitem.hxx>
// auto strip #endif
// auto strip #ifndef _VCL_VCLENUM_HXX
// auto strip #include <vcl/vclenum.hxx>
// auto strip #endif
// auto strip #ifndef _SFXAPP_HXX //autogen
// auto strip #include <bf_sfx2/app.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_WHITER_HXX //autogen
// auto strip #include <svtools/whiter.hxx>
// auto strip #endif
// auto strip #ifndef _SFXITEMPOOL_HXX //autogen
// auto strip #include <svtools/itempool.hxx>
// auto strip #endif
// auto strip #ifndef _SFXSTYLE_HXX //autogen
// auto strip #include <svtools/style.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_TPLPITEM_HXX //autogen
// auto strip #include <bf_sfx2/tplpitem.hxx>
// auto strip #endif
// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_ESCPITEM_HXX //autogen
// auto strip #include <bf_svx/escpitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_WGHTITEM_HXX //autogen
// auto strip #include <bf_svx/wghtitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_POSTITEM_HXX //autogen
// auto strip #include <bf_svx/postitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_UDLNITEM_HXX //autogen
// auto strip #include <bf_svx/udlnitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_CRSDITEM_HXX //autogen
// auto strip #include <bf_svx/crsditem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_ITEM_HXX //autogen
// auto strip #include <bf_svx/cntritem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_SHDDITEM_HXX //autogen
// auto strip #include <bf_svx/shdditem.hxx>
// auto strip #endif
// auto strip #include <bf_svx/xtable.hxx>
// auto strip #ifndef _SVDOBJ_HXX //autogen
// auto strip #include <bf_svx/svdobj.hxx>
// auto strip #endif
// auto strip #ifndef _OUTLOBJ_HXX //autogen
// auto strip #include <bf_svx/outlobj.hxx>
// auto strip #endif
// auto strip #ifndef _SFXINTITEM_HXX //autogen
// auto strip #include <svtools/intitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_SRIPTTYPEITEM_HXX //autogen
// auto strip #include <bf_svx/scripttypeitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOUTL_HXX
// auto strip #include <bf_svx/svdoutl.hxx>
// auto strip #endif

#ifndef _XDEF_HXX
#include <bf_svx/xdef.hxx>
#endif

// auto strip #ifndef _SVX_WRITINGMODEITEM_HXX
// auto strip #include <bf_svx/writingmodeitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_FRMDIRITEM_HXX
// auto strip #include <bf_svx/frmdiritem.hxx>
// auto strip #endif
// auto strip #ifndef _SFXITEMITER_HXX
// auto strip #include <svtools/itemiter.hxx>
// auto strip #endif

#pragma hdrstop

#include "app.hrc"

// auto strip #include "eetext.hxx"
// auto strip #include "viewshel.hxx"
// auto strip #include "drtxtob.hxx"
// auto strip #include "drawview.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "outlview.hxx"
// auto strip #include "sdwindow.hxx"
// auto strip #include "futempl.hxx"
namespace binfilter {

/*************************************************************************
|*
|* Bearbeitung der SfxRequests
|*
\************************************************************************/

//STRIP001 void SdDrawTextObjectBar::Execute( SfxRequest &rReq )
//STRIP001 {
//STRIP001 	const SfxItemSet* pArgs = rReq.GetArgs();
//STRIP001 	const SfxPoolItem* pPoolItem = NULL;
//STRIP001 	USHORT nSlot = rReq.GetSlot();
//STRIP001 	BOOL bOutlineMode = FALSE;
//STRIP001 	OutlinerView* pOLV = pView->GetTextEditOutlinerView();
//STRIP001 
//STRIP001 	if (pView->ISA(SdOutlineView))
//STRIP001 	{
//STRIP001 		bOutlineMode = TRUE;
//STRIP001 		pOLV = ((SdOutlineView*) pView)->GetViewByWindow(pViewShell->GetActiveWindow());
//STRIP001 	}
//STRIP001 
//STRIP001 	switch (nSlot)
//STRIP001 	{
//STRIP001 		case SID_STYLE_APPLY:
//STRIP001 		{
//STRIP001 			if( pArgs )
//STRIP001 			{
//STRIP001 				SdDrawDocument* pDoc = pView->GetDoc();
//STRIP001 				FuPoor* pFuActual = new FuTemplate( pViewShell,
//STRIP001 									(SdWindow*) pViewShell->GetWindow(),
//STRIP001 									pView, pDoc, rReq );
//STRIP001 
//STRIP001 				if (pFuActual)
//STRIP001 				{
//STRIP001 					pFuActual->Activate();
//STRIP001 					pFuActual->Deactivate();
//STRIP001 					delete pFuActual;
//STRIP001 
//STRIP001 					if( rReq.GetSlot() == SID_STYLE_APPLY )
//STRIP001 						pViewShell->GetViewFrame()->GetBindings().Invalidate( SID_STYLE_APPLY );
//STRIP001 				}
//STRIP001 			}
//STRIP001 			else
//STRIP001 				pViewShell->GetViewFrame()->GetDispatcher()->
//STRIP001 				Execute( SID_STYLE_DESIGNER, SFX_CALLMODE_ASYNCHRON );
//STRIP001 
//STRIP001 			rReq.Done();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_PARASPACE_INCREASE:
//STRIP001 		case SID_PARASPACE_DECREASE:
//STRIP001 		{
//STRIP001 			if( pOLV )
//STRIP001 			{
//STRIP001 				ESelection aSel = pOLV->GetSelection();
//STRIP001 				aSel.Adjust();
//STRIP001 				ULONG nStartPara = aSel.nStartPara;
//STRIP001 				ULONG nEndPara = aSel.nEndPara;
//STRIP001 				if( !aSel.HasRange() )
//STRIP001 				{
//STRIP001 					nStartPara = 0;
//STRIP001 					nEndPara = pOLV->GetOutliner()->GetParagraphCount() - 1;
//STRIP001 				}
//STRIP001 				for( ULONG nPara = nStartPara; nPara <= nEndPara; nPara++ )
//STRIP001 				{
//STRIP001 					SfxItemSet aAttr( pOLV->GetOutliner()->GetStyleSheet( nPara )->GetItemSet() );
//STRIP001 					SfxItemSet aTmpSet( pOLV->GetOutliner()->GetParaAttribs( nPara ) );
//STRIP001 					aAttr.Put( aTmpSet, FALSE ); // FALSE= InvalidItems nicht als Default, sondern als "Loecher" betrachten
//STRIP001 					const SvxULSpaceItem& rItem = (const SvxULSpaceItem&) aAttr.Get( ITEMID_ULSPACE );
//STRIP001 					SvxULSpaceItem* pNewItem = (SvxULSpaceItem*) rItem.Clone();
//STRIP001 
//STRIP001 					long nUpper = pNewItem->GetUpper();
//STRIP001 					if( nSlot == SID_PARASPACE_INCREASE )
//STRIP001 						nUpper += 100;
//STRIP001 					else
//STRIP001 					{
//STRIP001 						nUpper -= 100;
//STRIP001 						nUpper = Max( (long) nUpper, 0L );
//STRIP001 					}
//STRIP001 					pNewItem->SetUpper( (USHORT) nUpper );
//STRIP001 
//STRIP001 					long nLower = pNewItem->GetLower();
//STRIP001 					if( nSlot == SID_PARASPACE_INCREASE )
//STRIP001 						nLower += 100;
//STRIP001 					else
//STRIP001 					{
//STRIP001 						nLower -= 100;
//STRIP001 						nLower = Max( (long) nLower, 0L );
//STRIP001 					}
//STRIP001 					pNewItem->SetLower( (USHORT) nLower );
//STRIP001 
//STRIP001 					SfxItemSet aNewAttrs( aAttr );
//STRIP001 					aNewAttrs.Put( *pNewItem );
//STRIP001 					delete pNewItem;
//STRIP001 					pOLV->GetOutliner()->SetParaAttribs( nPara, aNewAttrs );
//STRIP001 				}
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				// Der folgende Code kann enabled werden, wenn ich von
//STRIP001 				// JOE einen richtigen Status (DontCare) bekomme;
//STRIP001 
//STRIP001 				// Wird enabled, obwohl es nicht richtig funktioniert (s.o.)
//STRIP001 				SfxItemSet aEditAttr( pView->GetDoc()->GetPool() );
//STRIP001 				pView->GetAttributes( aEditAttr );
//STRIP001 				if( aEditAttr.GetItemState( ITEMID_ULSPACE ) >= SFX_ITEM_AVAILABLE )
//STRIP001 				{
//STRIP001 					SfxItemSet aNewAttrs(*(aEditAttr.GetPool()), aEditAttr.GetRanges());
//STRIP001 					const SvxULSpaceItem& rItem = (const SvxULSpaceItem&) aEditAttr.Get( ITEMID_ULSPACE );
//STRIP001 					SvxULSpaceItem* pNewItem = (SvxULSpaceItem*) rItem.Clone();
//STRIP001 					long nUpper = pNewItem->GetUpper();
//STRIP001 
//STRIP001 					if( nSlot == SID_PARASPACE_INCREASE )
//STRIP001 						nUpper += 100;
//STRIP001 					else
//STRIP001 					{
//STRIP001 						nUpper -= 100;
//STRIP001 						nUpper = Max( (long) nUpper, 0L );
//STRIP001 					}
//STRIP001 					pNewItem->SetUpper( (USHORT) nUpper );
//STRIP001 
//STRIP001 					long nLower = pNewItem->GetLower();
//STRIP001 					if( nSlot == SID_PARASPACE_INCREASE )
//STRIP001 						nLower += 100;
//STRIP001 					else
//STRIP001 					{
//STRIP001 						nLower -= 100;
//STRIP001 						nLower = Max( (long) nLower, 0L );
//STRIP001 					}
//STRIP001 					pNewItem->SetLower( (USHORT) nLower );
//STRIP001 
//STRIP001 					aNewAttrs.Put( *pNewItem );
//STRIP001 					delete pNewItem;
//STRIP001 
//STRIP001 					pView->SetAttributes( aNewAttrs );
//STRIP001 				}
//STRIP001 			}
//STRIP001 			rReq.Done();
//STRIP001 
//STRIP001 			Invalidate();
//STRIP001 			// Um die Preview (im Gliederungsmodus) zu aktualisieren muss
//STRIP001 			// der Slot invalidiert werden:
//STRIP001 			pViewShell->GetViewFrame()->GetBindings().Invalidate( SID_PREVIEW_STATE, TRUE, FALSE );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_OUTLINE_LEFT:
//STRIP001 		{
//STRIP001 			if (pOLV)
//STRIP001 			{
//STRIP001 				pOLV->AdjustDepth( -1 );
//STRIP001 
//STRIP001 				// #96551# trigger preview refresh
//STRIP001 				pViewShell->GetViewFrame()->GetBindings().Invalidate( SID_PREVIEW_STATE, TRUE, FALSE );
//STRIP001 			}
//STRIP001 			rReq.Done();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_OUTLINE_RIGHT:
//STRIP001 		{
//STRIP001 			if (pOLV)
//STRIP001 			{
//STRIP001 				pOLV->AdjustDepth( 1 );
//STRIP001 
//STRIP001 				// #96551# trigger preview refresh
//STRIP001 				pViewShell->GetViewFrame()->GetBindings().Invalidate( SID_PREVIEW_STATE, TRUE, FALSE );
//STRIP001 			}
//STRIP001 			rReq.Done();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_OUTLINE_UP:
//STRIP001 		{
//STRIP001 			if (pOLV)
//STRIP001 			{
//STRIP001 				pOLV->AdjustHeight( -1 );
//STRIP001 
//STRIP001 				// #96551# trigger preview refresh
//STRIP001 				pViewShell->GetViewFrame()->GetBindings().Invalidate( SID_PREVIEW_STATE, TRUE, FALSE );
//STRIP001 			}
//STRIP001 			rReq.Done();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_OUTLINE_DOWN:
//STRIP001 		{
//STRIP001 			if (pOLV)
//STRIP001 			{
//STRIP001 				pOLV->AdjustHeight( 1 );
//STRIP001 				
//STRIP001 				// #96551# trigger preview refresh
//STRIP001 				pViewShell->GetViewFrame()->GetBindings().Invalidate( SID_PREVIEW_STATE, TRUE, FALSE );
//STRIP001 			}
//STRIP001 			rReq.Done();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_TEXTDIRECTION_LEFT_TO_RIGHT:
//STRIP001 		case SID_TEXTDIRECTION_TOP_TO_BOTTOM:
//STRIP001 		{
//STRIP001 			pView->EndTextEdit();
//STRIP001 			SfxItemSet aAttr( pView->GetDoc()->GetPool(), SDRATTR_TEXTDIRECTION, SDRATTR_TEXTDIRECTION, 0 );
//STRIP001 			aAttr.Put( SvxWritingModeItem( nSlot == SID_TEXTDIRECTION_LEFT_TO_RIGHT ? ::com::sun::star::text::WritingMode_LR_TB : ::com::sun::star::text::WritingMode_TB_RL ) );
//STRIP001 			rReq.Done( aAttr );
//STRIP001 			pView->SetAttributes( aAttr );
//STRIP001 			Invalidate();
//STRIP001 			pViewShell->GetViewFrame()->GetBindings().Invalidate( SID_PREVIEW_STATE, TRUE, FALSE );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 
//STRIP001 		default:
//STRIP001 		{
//STRIP001 			SfxItemSet aEditAttr( pView->GetDoc()->GetPool() );
//STRIP001 			pView->GetAttributes( aEditAttr );
//STRIP001 			SfxItemSet aNewAttr(*(aEditAttr.GetPool()), aEditAttr.GetRanges());
//STRIP001 
//STRIP001 			if( !pArgs )
//STRIP001 			{
//STRIP001 				//aNewAttr.InvalidateAllItems(); <- Macht Probleme (#35465#)
//STRIP001 
//STRIP001 				switch ( nSlot )
//STRIP001 				{
//STRIP001 					case SID_ATTR_CHAR_WEIGHT:
//STRIP001 					{
//STRIP001 						FontWeight eFW = ( (const SvxWeightItem&) aEditAttr.
//STRIP001 										Get( ITEMID_WEIGHT ) ).GetWeight();
//STRIP001 						aNewAttr.Put( SvxWeightItem( eFW == WEIGHT_NORMAL ?
//STRIP001 											WEIGHT_BOLD : WEIGHT_NORMAL ) );
//STRIP001 					}
//STRIP001 					break;
//STRIP001 					case SID_ATTR_CHAR_POSTURE:
//STRIP001 					{
//STRIP001 						FontItalic eFI = ( (const SvxPostureItem&) aEditAttr.
//STRIP001 										Get( ITEMID_POSTURE ) ).GetPosture();
//STRIP001 						aNewAttr.Put( SvxPostureItem( eFI == ITALIC_NORMAL ?
//STRIP001 											ITALIC_NONE : ITALIC_NORMAL ) );
//STRIP001 					}
//STRIP001 					break;
//STRIP001 					case SID_ATTR_CHAR_UNDERLINE:
//STRIP001 					{
//STRIP001 						FontUnderline eFU = ( (const SvxUnderlineItem&) aEditAttr.
//STRIP001 										Get( ITEMID_UNDERLINE ) ).GetUnderline();
//STRIP001 						aNewAttr.Put( SvxUnderlineItem( eFU == UNDERLINE_SINGLE ?
//STRIP001 											UNDERLINE_NONE : UNDERLINE_SINGLE ) );
//STRIP001 					}
//STRIP001 					break;
//STRIP001 					case SID_ATTR_CHAR_CONTOUR:
//STRIP001 					{
//STRIP001 						aNewAttr.Put( SvxContourItem( !( (const SvxContourItem&) aEditAttr.
//STRIP001 										Get( ITEMID_CONTOUR ) ).GetValue() ) );
//STRIP001 					}
//STRIP001 					break;
//STRIP001 					case SID_ATTR_CHAR_SHADOWED:
//STRIP001 					{
//STRIP001 						aNewAttr.Put( SvxShadowedItem( !( (const SvxShadowedItem&) aEditAttr.
//STRIP001 										Get( ITEMID_SHADOWED ) ).GetValue() ) );
//STRIP001 					}
//STRIP001 					break;
//STRIP001 					case SID_ATTR_CHAR_STRIKEOUT:
//STRIP001 					{
//STRIP001 						FontStrikeout eFSO = ( ( (const SvxCrossedOutItem&) aEditAttr.
//STRIP001 										Get( ITEMID_CROSSEDOUT ) ).GetStrikeout() );
//STRIP001 						aNewAttr.Put( SvxCrossedOutItem( eFSO == STRIKEOUT_SINGLE ?
//STRIP001 											STRIKEOUT_NONE : STRIKEOUT_SINGLE ) );
//STRIP001 					}
//STRIP001 					break;
//STRIP001 
//STRIP001 					case SID_ATTR_PARA_ADJUST_LEFT:
//STRIP001 					{
//STRIP001 						aNewAttr.Put( SvxAdjustItem( SVX_ADJUST_LEFT ) );
//STRIP001 					}
//STRIP001 					break;
//STRIP001 					case SID_ATTR_PARA_ADJUST_CENTER:
//STRIP001 					{
//STRIP001 						aNewAttr.Put( SvxAdjustItem( SVX_ADJUST_CENTER ) );
//STRIP001 					}
//STRIP001 					break;
//STRIP001 					case SID_ATTR_PARA_ADJUST_RIGHT:
//STRIP001 					{
//STRIP001 						aNewAttr.Put( SvxAdjustItem( SVX_ADJUST_RIGHT ) );
//STRIP001 					}
//STRIP001 					break;
//STRIP001 					case SID_ATTR_PARA_ADJUST_BLOCK:
//STRIP001 					{
//STRIP001 						aNewAttr.Put( SvxAdjustItem( SVX_ADJUST_BLOCK ) );
//STRIP001 					}
//STRIP001 					break;
//STRIP001 					case SID_ATTR_PARA_LINESPACE_10:
//STRIP001 					{
//STRIP001 						SvxLineSpacingItem aItem( SVX_LINESPACE_ONE_LINE );
//STRIP001 						aItem.SetPropLineSpace( 100 );
//STRIP001 						aNewAttr.Put( aItem );
//STRIP001 					}
//STRIP001 					break;
//STRIP001 					case SID_ATTR_PARA_LINESPACE_15:
//STRIP001 					{
//STRIP001 						SvxLineSpacingItem aItem( SVX_LINESPACE_ONE_POINT_FIVE_LINES );
//STRIP001 						aItem.SetPropLineSpace( 150 );
//STRIP001 						aNewAttr.Put( aItem );
//STRIP001 					}
//STRIP001 					break;
//STRIP001 					case SID_ATTR_PARA_LINESPACE_20:
//STRIP001 					{
//STRIP001 						SvxLineSpacingItem aItem( SVX_LINESPACE_TWO_LINES );
//STRIP001 						aItem.SetPropLineSpace( 200 );
//STRIP001 						aNewAttr.Put( aItem );
//STRIP001 					}
//STRIP001     				break;
//STRIP001 					case SID_SET_SUPER_SCRIPT:
//STRIP001 					{
//STRIP001 						SvxEscapementItem aItem;
//STRIP001 						SvxEscapement eEsc = (SvxEscapement ) ( (const SvxEscapementItem&)
//STRIP001 										aEditAttr.Get( ITEMID_ESCAPEMENT ) ).GetEnumValue();
//STRIP001 
//STRIP001 						if( eEsc == SVX_ESCAPEMENT_SUPERSCRIPT )
//STRIP001 							aItem.SetEscapement( SVX_ESCAPEMENT_OFF );
//STRIP001 						else
//STRIP001 							aItem.SetEscapement( SVX_ESCAPEMENT_SUPERSCRIPT );
//STRIP001 						aNewAttr.Put( aItem );
//STRIP001 					}
//STRIP001 					break;
//STRIP001 					case SID_SET_SUB_SCRIPT:
//STRIP001 					{
//STRIP001 						SvxEscapementItem aItem;
//STRIP001 						SvxEscapement eEsc = (SvxEscapement ) ( (const SvxEscapementItem&)
//STRIP001 										aEditAttr.Get( ITEMID_ESCAPEMENT ) ).GetEnumValue();
//STRIP001 
//STRIP001 						if( eEsc == SVX_ESCAPEMENT_SUBSCRIPT )
//STRIP001 							aItem.SetEscapement( SVX_ESCAPEMENT_OFF );
//STRIP001 						else
//STRIP001 							aItem.SetEscapement( SVX_ESCAPEMENT_SUBSCRIPT );
//STRIP001 						aNewAttr.Put( aItem );
//STRIP001 					}
//STRIP001 					break;
//STRIP001 
//STRIP001 					// Attribute fuer die TextObjectBar
//STRIP001 					case SID_ATTR_CHAR_FONT:
//STRIP001 					{
//STRIP001 						if( pArgs )
//STRIP001 						{
//STRIP001 							if( SFX_ITEM_SET == pArgs->GetItemState( ITEMID_FONT, TRUE, &pPoolItem ) )
//STRIP001 								aNewAttr.Put( *pPoolItem );
//STRIP001 						}
//STRIP001 						else
//STRIP001 							pViewShell->GetViewFrame()->GetDispatcher()->
//STRIP001 							Execute( SID_CHAR_DLG, SFX_CALLMODE_ASYNCHRON );
//STRIP001 					}
//STRIP001 					break;
//STRIP001 					case SID_ATTR_CHAR_FONTHEIGHT:
//STRIP001 					{
//STRIP001 						if( pArgs )
//STRIP001 						{
//STRIP001 							if( SFX_ITEM_SET == pArgs->GetItemState( ITEMID_FONTHEIGHT, TRUE, &pPoolItem ) )
//STRIP001 								aNewAttr.Put( *pPoolItem );
//STRIP001 						}
//STRIP001 						else
//STRIP001 							pViewShell->GetViewFrame()->GetDispatcher()->
//STRIP001 							Execute( SID_CHAR_DLG, SFX_CALLMODE_ASYNCHRON );
//STRIP001 					}
//STRIP001 					break;
//STRIP001 					case SID_ATTR_CHAR_COLOR:
//STRIP001 					{
//STRIP001 						if( pArgs && SFX_ITEM_SET == pArgs->GetItemState( ITEMID_COLOR, TRUE, &pPoolItem ) )
//STRIP001 							aNewAttr.Put( *pPoolItem );
//STRIP001 					}
//STRIP001 					break;
//STRIP001 
//STRIP001 					case FN_NUM_BULLET_ON:
//STRIP001 					{
//STRIP001 						if (aEditAttr.GetItemState(EE_PARA_BULLETSTATE) == SFX_ITEM_ON)
//STRIP001 						{
//STRIP001 							SfxUInt16Item aBulletState((const SfxUInt16Item&) aEditAttr.Get(EE_PARA_BULLETSTATE));
//STRIP001 
//STRIP001 							if (aBulletState.GetValue() != 0)
//STRIP001 							{
//STRIP001 								// Ausschalten
//STRIP001 								aNewAttr.Put(SfxUInt16Item(EE_PARA_BULLETSTATE, 0));
//STRIP001 							}
//STRIP001 							else
//STRIP001 							{
//STRIP001 								// Einschalten
//STRIP001 								aNewAttr.Put(SfxUInt16Item(EE_PARA_BULLETSTATE, 1));
//STRIP001 							}
//STRIP001 						}
//STRIP001 						else
//STRIP001 						{
//STRIP001 							// Einschalten
//STRIP001 							aNewAttr.Put(SfxUInt16Item(EE_PARA_BULLETSTATE, 1));
//STRIP001 						}
//STRIP001 					}
//STRIP001 					break;
//STRIP001 				}
//STRIP001 
//STRIP001 				rReq.Done( aNewAttr );
//STRIP001 				pArgs = rReq.GetArgs();
//STRIP001 			}
//STRIP001 			else if ( nSlot == SID_ATTR_PARA_LEFT_TO_RIGHT ||
//STRIP001 					  nSlot == SID_ATTR_PARA_RIGHT_TO_LEFT )
//STRIP001 			{
//STRIP001 				sal_Bool bLeftToRight = nSlot == SID_ATTR_PARA_LEFT_TO_RIGHT;
//STRIP001 
//STRIP001 				USHORT nAdjust = SVX_ADJUST_LEFT;
//STRIP001 				if( SFX_ITEM_ON == aEditAttr.GetItemState(ITEMID_ADJUST, TRUE, &pPoolItem ) )
//STRIP001 					nAdjust = ( (SvxAdjustItem*)pPoolItem)->GetEnumValue();
//STRIP001 
//STRIP001 				if( bLeftToRight )
//STRIP001 				{
//STRIP001 					aNewAttr.Put( SvxFrameDirectionItem( FRMDIR_HORI_LEFT_TOP, EE_PARA_WRITINGDIR ) );
//STRIP001 					if( nAdjust == SVX_ADJUST_RIGHT )
//STRIP001 						aNewAttr.Put( SvxAdjustItem( SVX_ADJUST_LEFT ) );
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					aNewAttr.Put( SvxFrameDirectionItem( FRMDIR_HORI_RIGHT_TOP, EE_PARA_WRITINGDIR ) );
//STRIP001 					if( nAdjust == SVX_ADJUST_LEFT )
//STRIP001 						aNewAttr.Put( SvxAdjustItem( SVX_ADJUST_RIGHT ) );
//STRIP001 				}
//STRIP001 
//STRIP001 				rReq.Done( aNewAttr );
//STRIP001 				pArgs = rReq.GetArgs();
//STRIP001 
//STRIP001 				Invalidate( SID_RULER_TEXT_RIGHT_TO_LEFT );
//STRIP001 			}
//STRIP001 			else if ( nSlot == SID_ATTR_CHAR_FONT       ||
//STRIP001                 	  nSlot == SID_ATTR_CHAR_FONTHEIGHT ||
//STRIP001                 	  nSlot == SID_ATTR_CHAR_POSTURE    ||
//STRIP001                 	  nSlot == SID_ATTR_CHAR_WEIGHT )
//STRIP001             {
//STRIP001 				USHORT nScriptType = pView->GetScriptType();
//STRIP001                 SfxItemPool& rPool = pView->GetDoc()->GetPool();
//STRIP001                 SvxScriptSetItem aSvxScriptSetItem( nSlot, rPool );
//STRIP001                 aSvxScriptSetItem.PutItemForScriptType( nScriptType, pArgs->Get( rPool.GetWhich( nSlot ) ) );
//STRIP001 				aNewAttr.Put( aSvxScriptSetItem.GetItemSet() );
//STRIP001 				rReq.Done( aNewAttr );
//STRIP001 				pArgs = rReq.GetArgs();
//STRIP001 			}
//STRIP001 
//STRIP001 			pView->SetAttributes(*pArgs);
//STRIP001 
//STRIP001 			// Aus Performance- und Erweiterungsgruenden wird
//STRIP001 			// jetzt die komplette Shell invalidiert
//STRIP001 			Invalidate();
//STRIP001 
//STRIP001 			// Um die Preview (im Gliederungsmodus) zu aktualisieren muss
//STRIP001 			// der Slot invalidiert werden:
//STRIP001 			pViewShell->GetViewFrame()->GetBindings().Invalidate( SID_PREVIEW_STATE, TRUE, FALSE );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 	}
//STRIP001 
//STRIP001 	Invalidate( SID_OUTLINE_LEFT );
//STRIP001 	Invalidate( SID_OUTLINE_RIGHT );
//STRIP001 	Invalidate( SID_OUTLINE_UP );
//STRIP001 	Invalidate( SID_OUTLINE_DOWN );
//STRIP001 }

}
