/*************************************************************************
 *
 *  $RCSfile: sd_sdview3.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:19:30 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop
// auto strip #ifndef _COM_SUN_STAR_LANG_XCOMPONENT_HPP_ 
// auto strip #include <com/sun/star/lang/XComponent.hpp>
// auto strip #endif
// auto strip #ifndef _FILELIST_HXX
// auto strip #include <sot/filelist.hxx>
// auto strip #endif
// auto strip #ifndef INCLUDED_SVTOOLS_PATHOPTIONS_HXX
// auto strip #include <svtools/pathoptions.hxx>
// auto strip #endif
// auto strip #ifndef _EDITDATA_HXX
// auto strip #include <bf_svx/editdata.hxx>
// auto strip #endif
// auto strip #ifndef _URLBMK_HXX
// auto strip #include <svtools/urlbmk.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XEXCH_HXX
// auto strip #include <bf_svx/xexch.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XFLCLIT_HXX
// auto strip #include <bf_svx/xflclit.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XLNCLIT_HXX
// auto strip #include <bf_svx/xlnclit.hxx>
// auto strip #endif
// auto strip #ifndef _SVDPAGV_HXX //autogen
// auto strip #include <bf_svx/svdpagv.hxx>
// auto strip #endif
#ifndef _EEITEM_HXX
#include <bf_svx/eeitem.hxx>
#endif
#define ITEMID_COLOR                    EE_CHAR_COLOR
// auto strip #ifndef _SVX_COLRITEM_HXX
// auto strip #include <bf_svx/colritem.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDOCFILE_HXX //autogen
// auto strip #include <bf_sfx2/docfile.hxx>
// auto strip #endif
// auto strip #ifndef _SVDITER_HXX //autogen
// auto strip #include <bf_svx/svditer.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOGRP_HXX //autogen
// auto strip #include <bf_svx/svdogrp.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOOLE2_HXX //autogen
// auto strip #include <bf_svx/svdoole2.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOGRAF_HXX //autogen
// auto strip #include <bf_svx/svdograf.hxx>
// auto strip #endif
// auto strip #ifndef _SVDETC_HXX //autogen
// auto strip #include <bf_svx/svdetc.hxx>
// auto strip #endif
// auto strip #ifndef _SVDUNDO_HXX //autogen
// auto strip #include <bf_svx/svdundo.hxx>
// auto strip #endif
// auto strip #ifndef _SFXAPP_HXX //autogen
// auto strip #include <bf_sfx2/app.hxx>
// auto strip #endif
// auto strip #ifndef _SFXITEMPOOL_HXX //autogen
// auto strip #include <svtools/itempool.hxx>
// auto strip #endif
// auto strip #ifndef _SO_CLSIDS_HXX
// auto strip #include <so3/clsids.hxx>
// auto strip #endif
// auto strip #ifndef _FM_FMMODEL_HXX
// auto strip #include <bf_svx/fmmodel.hxx>
// auto strip #endif
// auto strip #ifndef _SOT_FORMATS_HXX //autogen
// auto strip #include <sot/formats.hxx>
// auto strip #endif
// auto strip #ifndef _OUTLINER_HXX //autogen
// auto strip #include <bf_svx/outliner.hxx>
// auto strip #endif
// auto strip #ifndef _EDITENG_HXX //autogen
// auto strip #include <bf_svx/editeng.hxx>
// auto strip #endif
// auto strip #ifndef _TRANSBND_HXX
// auto strip #include <so3/transbnd.hxx>
// auto strip #endif
// auto strip #ifndef _E3D_OBJ3D_HXX
// auto strip #include <bf_svx/obj3d.hxx>
// auto strip #endif
// auto strip #ifndef _E3D_UNDO_HXX
// auto strip #include <bf_svx/e3dundo.hxx>
// auto strip #endif
#include <bf_svx/dbexch.hrc>
// auto strip #ifndef SVX_UNOMODEL_HXX
// auto strip #include <bf_svx/unomodel.hxx>
// auto strip #endif
// auto strip #ifndef _UTL_STREAM_WRAPPER_HXX_ 
// auto strip #include <unotools/streamwrap.hxx>
// auto strip #endif

// auto strip #include "docshell.hxx"
// auto strip #include "fupoor.hxx"
// auto strip #include "sdwindow.hxx"
#include "sdview.hxx"
// auto strip #include "sdxfer.hxx"
// auto strip #include "sdpage.hxx"
// auto strip #include "drviewsh.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "sdresid.hxx"
#include "strings.hrc"
// auto strip #include "imapinfo.hxx"
// auto strip #include "slidvish.hxx"
#include "strmname.h"
// auto strip #include "unomodel.hxx"
namespace binfilter {

// --------------
// - Namespaces -
// --------------

using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::io;
using namespace ::com::sun::star::datatransfer;
using namespace ::com::sun::star::datatransfer::clipboard;

#define CHECK_FORMAT_TRANS( _def_Type ) ( ( nFormat == (_def_Type) || !nFormat ) && aDataHelper.HasFormat( _def_Type ) )

/*************************************************************************
|*
|* Paste
|*
\************************************************************************/

// #83525#
//STRIP001 struct ImpRememberOrigAndClone
//STRIP001 {
//STRIP001 	SdrObject*		pOrig;
//STRIP001 	SdrObject*		pClone;
//STRIP001 };
//STRIP001 
//STRIP001 SdrObject* ImpGetClone(Container& aConnectorContainer, SdrObject* pConnObj)
//STRIP001 {
//STRIP001 	for(sal_uInt32 a(0); a < aConnectorContainer.Count(); a++)
//STRIP001 	{
//STRIP001 		if(pConnObj == ((ImpRememberOrigAndClone*)aConnectorContainer.GetObject(a))->pOrig)
//STRIP001 			return ((ImpRememberOrigAndClone*)aConnectorContainer.GetObject(a))->pClone;
//STRIP001 	}
//STRIP001 	return 0L;
//STRIP001 }
//STRIP001 
//STRIP001 // #90129# restrict movement to WorkArea
//STRIP001 void ImpCheckInsertPos(Point& rPos, const Size& rSize, const Rectangle& rWorkArea)
//STRIP001 {
//STRIP001 	if(!rWorkArea.IsEmpty())
//STRIP001 	{
//STRIP001 		Rectangle aMarkRect(Point(rPos.X() - (rSize.Width() / 2), rPos.Y() - (rSize.Height() / 2)), rSize);
//STRIP001 
//STRIP001 		if(!aMarkRect.IsInside(rWorkArea))
//STRIP001 		{
//STRIP001 			if(aMarkRect.Left() < rWorkArea.Left())
//STRIP001 			{
//STRIP001 				rPos.X() += rWorkArea.Left() - aMarkRect.Left();
//STRIP001 			}
//STRIP001 
//STRIP001 			if(aMarkRect.Right() > rWorkArea.Right())
//STRIP001 			{
//STRIP001 				rPos.X() -= aMarkRect.Right() - rWorkArea.Right();
//STRIP001 			}
//STRIP001 
//STRIP001 			if(aMarkRect.Top() < rWorkArea.Top())
//STRIP001 			{
//STRIP001 				rPos.Y() += rWorkArea.Top() - aMarkRect.Top();
//STRIP001 			}
//STRIP001 
//STRIP001 			if(aMarkRect.Bottom() > rWorkArea.Bottom())
//STRIP001 			{
//STRIP001 				rPos.Y() -= aMarkRect.Bottom() - rWorkArea.Bottom();
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 BOOL SdView::InsertData( const TransferableDataHelper& rDataHelper, 
//STRIP001 						 const Point& rPos, sal_Int8& rDnDAction, BOOL bDrag, 
//STRIP001 						 ULONG nFormat, USHORT nPage, USHORT nLayer )
//STRIP001 {
//STRIP001 	aDropPos = rPos;
//STRIP001 	nAction = rDnDAction;
//STRIP001 	bIsDropAllowed = FALSE;
//STRIP001 
//STRIP001 	TransferableDataHelper	aDataHelper( rDataHelper );
//STRIP001 	SdrObject*				pPickObj = NULL;
//STRIP001 	SdPage*					pPage = NULL;
//STRIP001 	SdWindow*				pWin = pViewSh->GetActiveWindow();
//STRIP001 	ImageMap*				pImageMap = NULL;
//STRIP001 	BOOL					bMtf = FALSE;
//STRIP001 	BOOL					bReturn = FALSE;
//STRIP001 	BOOL					bLink = ( ( nAction & DND_ACTION_LINK ) != 0 );
//STRIP001 	BOOL					bCopy = ( ( ( nAction & DND_ACTION_COPY ) != 0 ) || bLink );
//STRIP001 	ULONG					nPasteOptions = SDRINSERT_SETDEFLAYER;
//STRIP001 
//STRIP001 	if( pViewSh->ISA( SdSlideViewShell ) || ( pViewSh && pViewSh->GetIPClient() && pViewSh->GetIPClient()->IsInPlaceActive() ) )
//STRIP001 		nPasteOptions |= SDRINSERT_DONTMARK;
//STRIP001 
//STRIP001 	if( bDrag )
//STRIP001 	{
//STRIP001 		SdrPageView* pPV = NULL;
//STRIP001 		PickObj( rPos, pPickObj, pPV );
//STRIP001 	}
//STRIP001 
//STRIP001 	if( nPage != SDRPAGE_NOTFOUND )
//STRIP001 		pPage = (SdPage*) pDoc->GetPage( nPage );
//STRIP001 
//STRIP001 	SdTransferable* pOwnData = NULL;
//STRIP001     SdTransferable* pImplementation = SdTransferable::getImplementation( aDataHelper.GetTransferable() );
//STRIP001 
//STRIP001 	// try to get own transfer data
//STRIP001 	if( pImplementation )
//STRIP001 	{
//STRIP001 		if( SD_MOD()->pTransferClip == (SdTransferable*) pImplementation )
//STRIP001 			pOwnData = SD_MOD()->pTransferClip;
//STRIP001 		else if( SD_MOD()->pTransferDrag == (SdTransferable*) pImplementation )
//STRIP001 			pOwnData = SD_MOD()->pTransferDrag;
//STRIP001 		else if( SD_MOD()->pTransferSelection == (SdTransferable*) pImplementation )
//STRIP001 			pOwnData = SD_MOD()->pTransferSelection;
//STRIP001 	}
//STRIP001         
//STRIP001 	// ImageMap?
//STRIP001 	if( !pOwnData && aDataHelper.HasFormat( SOT_FORMATSTR_ID_SVIM ) )
//STRIP001 	{
//STRIP001 		SotStorageStreamRef xStm;
//STRIP001 
//STRIP001 		if( aDataHelper.GetSotStorageStream( SOT_FORMATSTR_ID_SVIM, xStm ) )
//STRIP001 		{
//STRIP001 			pImageMap = new ImageMap;
//STRIP001 			*xStm >> *pImageMap;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if( pOwnData && !nFormat )
//STRIP001 	{
//STRIP001 		const SdView* pSourceView = pOwnData->GetView();
//STRIP001 
//STRIP001 
//STRIP001         if( pOwnData->GetDocShell() && pOwnData->IsPageTransferable() && ISA( SdView ) )
//STRIP001 		{
//STRIP001 			USHORT	nInsertPgCnt, nInsertPos = pDoc->GetSdPageCount( PK_STANDARD ) * 2 + 1;
//STRIP001 			USHORT	nPgCnt = pDoc->GetSdPageCount( PK_STANDARD );
//STRIP001 			BOOL	bMergeMasterPages = !pOwnData->HasSourceDoc( pDoc );
//STRIP001 
//STRIP001 			for( USHORT nPage = 0; nPage < nPgCnt; nPage++ )
//STRIP001 			{
//STRIP001 				SdPage* pPage = pDoc->GetSdPage( nPage, PK_STANDARD );
//STRIP001 
//STRIP001 				if( pPage->IsSelected() )
//STRIP001 					nInsertPos = nPage * 2 + 3;
//STRIP001 			}
//STRIP001 
//STRIP001             if( pOwnData->HasPageBookmarks() )
//STRIP001             {
//STRIP001                 const List&         rBookmarkList = pOwnData->GetPageBookmarks();
//STRIP001                 const ::vos::OGuard aGuard( Application::GetSolarMutex() );
//STRIP001                 const BOOL          bWait = pWin && pWin->IsWait();
//STRIP001 
//STRIP001                 if( bWait )
//STRIP001                     pWin->LeaveWait();
//STRIP001 		        
//STRIP001                 nInsertPgCnt = (USHORT) rBookmarkList.Count();
//STRIP001 		        pDoc->InsertBookmarkAsPage( const_cast< List* >( &rBookmarkList ), NULL, FALSE, FALSE, nInsertPos, 
//STRIP001                                             pOwnData == SD_MOD()->pTransferDrag,
//STRIP001                                             pOwnData->GetPageDocShell(), TRUE, bMergeMasterPages, FALSE );
//STRIP001 
//STRIP001                 if( bWait )
//STRIP001                     pWin->EnterWait();
//STRIP001             }
//STRIP001             else
//STRIP001             {
//STRIP001 			    SvEmbeddedObject*	pObj = pOwnData->GetDocShell();
//STRIP001 			    SdDrawDocShell*		pDataDocSh = (SdDrawDocShell*) pObj;
//STRIP001 			    SdDrawDocument*		pDataDoc = pDataDocSh->GetDoc();
//STRIP001 
//STRIP001 			    if( pDataDoc && pDataDoc->GetSdPageCount( PK_STANDARD ) )
//STRIP001 			    {
//STRIP001                     const ::vos::OGuard aGuard( Application::GetSolarMutex() );
//STRIP001                     const BOOL          bWait = pWin && pWin->IsWait();
//STRIP001 
//STRIP001                     if( bWait )
//STRIP001                         pWin->LeaveWait();
//STRIP001 				    
//STRIP001                     nInsertPgCnt = pDataDoc->GetSdPageCount( PK_STANDARD );
//STRIP001 				    pDoc->InsertBookmarkAsPage( NULL, NULL, FALSE, FALSE, nInsertPos, 
//STRIP001                                                 pOwnData == SD_MOD()->pTransferDrag,
//STRIP001                                                 pDataDocSh, TRUE, bMergeMasterPages, FALSE );
//STRIP001 
//STRIP001                     if( bWait )
//STRIP001                         pWin->EnterWait();
//STRIP001 			    }
//STRIP001             }
//STRIP001 		}
//STRIP001         else if( pSourceView )
//STRIP001 		{
//STRIP001 			if( pSourceView == this )
//STRIP001 			{
//STRIP001 				// same view
//STRIP001 				if( nLayer != SDRLAYER_NOTFOUND )
//STRIP001 				{
//STRIP001 					// drop on layer tab bar
//STRIP001 					SdrLayerAdmin&	rLayerAdmin = pDoc->GetLayerAdmin();
//STRIP001 					SdrLayer*		pLayer = rLayerAdmin.GetLayerPerID( nLayer );
//STRIP001 					SdrPageView*	pPV = GetPageViewPvNum( 0 );
//STRIP001 					String			aLayer( pLayer->GetName() );
//STRIP001 
//STRIP001 					if( !pPV->IsLayerLocked( aLayer ) )
//STRIP001 					{
//STRIP001 						pOwnData->SetInternalMove( TRUE );
//STRIP001 						aMark.ForceSort();
//STRIP001 
//STRIP001 						for( ULONG nM = 0; nM < aMark.GetMarkCount(); nM++ )
//STRIP001 						{
//STRIP001 							SdrMark*	pM = aMark.GetMark( nM );
//STRIP001 							SdrObject*	pO = pM->GetObj();
//STRIP001 
//STRIP001 							if( pO )
//STRIP001 							{
//STRIP001 								// #i11702#
//STRIP001 								BegUndo(String(SdResId(STR_MODIFYLAYER)));
//STRIP001 								AddUndo(new SdrUndoObjectLayerChange(*pO, pO->GetLayer(), (SdrLayerID)nLayer));
//STRIP001 								EndUndo();
//STRIP001 
//STRIP001 								pO->SetLayer( (SdrLayerID) nLayer );
//STRIP001 							}
//STRIP001 						}
//STRIP001 
//STRIP001 						bReturn = TRUE;
//STRIP001 					}
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					SdrPageView*	pPV = GetPageViewPvNum( 0 );
//STRIP001 					BOOL			bDropOnTabBar = TRUE;
//STRIP001 
//STRIP001 					if( !pPage && pPV->GetPage()->GetPageNum() != nDragSrcPgNum )
//STRIP001 					{
//STRIP001 						pPage = (SdPage*) pPV->GetPage();
//STRIP001 						bDropOnTabBar = FALSE;
//STRIP001 					}
//STRIP001 
//STRIP001 					if( pPage )
//STRIP001 					{
//STRIP001 						// drop on other page
//STRIP001 						String aActiveLayer( GetActiveLayer() );
//STRIP001 
//STRIP001 						if( !pPV->IsLayerLocked( aActiveLayer ) )
//STRIP001 						{
//STRIP001 							if( !IsPresObjSelected() )
//STRIP001 							{
//STRIP001 								SdrMarkList* pMarkList;
//STRIP001 
//STRIP001 								if( nDragSrcPgNum != SDRPAGE_NOTFOUND && nDragSrcPgNum != pPV->GetPage()->GetPageNum() )
//STRIP001 								{
//STRIP001 									// source != destination => saved mark list is used
//STRIP001 									pMarkList = pDragSrcMarkList;
//STRIP001 								}
//STRIP001 								else
//STRIP001 									// actual mark list is used
//STRIP001 									pMarkList = new SdrMarkList( aMark );
//STRIP001 
//STRIP001 								pMarkList->ForceSort();
//STRIP001 
//STRIP001 								// #83525# stuff to remember originals and clones
//STRIP001 								Container	aConnectorContainer(0);
//STRIP001 								sal_uInt32	a, nConnectorCount(0L);
//STRIP001 								Point		aCurPos;
//STRIP001 
//STRIP001 								// calculate real position of current 
//STRIP001 								// source objects, if necessary (#103207)
//STRIP001 								if( pOwnData == SD_MOD()->pTransferSelection )
//STRIP001 								{
//STRIP001 									Rectangle aCurBoundRect;
//STRIP001 
//STRIP001 									if( pMarkList->TakeBoundRect( pPV, aCurBoundRect ) )
//STRIP001 										aCurPos = aCurBoundRect.TopLeft();
//STRIP001 									else	
//STRIP001 										aCurPos = pOwnData->GetStartPos();
//STRIP001 								}
//STRIP001 								else
//STRIP001 									aCurPos = pOwnData->GetStartPos();
//STRIP001 
//STRIP001 								const Size aVector( aDropPos.X() - aCurPos.X(), aDropPos.Y() - aCurPos.Y() );
//STRIP001 
//STRIP001 								for(a = 0; a < pMarkList->GetMarkCount(); a++)
//STRIP001 								{
//STRIP001 									SdrMark* pM = pMarkList->GetMark(a);
//STRIP001 									SdrObject* pObj = pM->GetObj()->Clone();
//STRIP001 
//STRIP001 									if(pObj)
//STRIP001 									{
//STRIP001 										if(!bDropOnTabBar)
//STRIP001 										{
//STRIP001 											// #83525# do a NbcMove(...) instead of setting SnapRects here
//STRIP001 											pObj->NbcMove(aVector);
//STRIP001 										}
//STRIP001 
//STRIP001 										pPage->InsertObject(pObj);
//STRIP001 
//STRIP001 										BegUndo(String(SdResId(STR_UNDO_DRAGDROP)));
//STRIP001 										AddUndo(new SdrUndoNewObj(*pObj));
//STRIP001 										EndUndo();
//STRIP001 
//STRIP001 										// #83525#
//STRIP001 										ImpRememberOrigAndClone* pRem = new ImpRememberOrigAndClone;
//STRIP001 										pRem->pOrig = pM->GetObj();
//STRIP001 										pRem->pClone = pObj;
//STRIP001 										aConnectorContainer.Insert(pRem, CONTAINER_APPEND);
//STRIP001 
//STRIP001 										if(pObj->ISA(SdrEdgeObj))
//STRIP001 											nConnectorCount++;
//STRIP001 									}
//STRIP001 								}
//STRIP001 
//STRIP001 								// #83525# try to re-establish connections at clones
//STRIP001 								if(nConnectorCount)
//STRIP001 								{
//STRIP001 									for(a = 0; a < aConnectorContainer.Count(); a++)
//STRIP001 									{
//STRIP001 										ImpRememberOrigAndClone* pRem = (ImpRememberOrigAndClone*)aConnectorContainer.GetObject(a);
//STRIP001 										
//STRIP001 										if(pRem->pClone->ISA(SdrEdgeObj))
//STRIP001 										{
//STRIP001 											SdrEdgeObj* pOrigEdge = (SdrEdgeObj*)pRem->pOrig;
//STRIP001 											SdrEdgeObj* pCloneEdge = (SdrEdgeObj*)pRem->pClone;
//STRIP001 
//STRIP001 											// test first connection
//STRIP001 											SdrObjConnection& rConn0 = pOrigEdge->GetConnection(FALSE);
//STRIP001 											SdrObject* pConnObj = rConn0.GetObject();
//STRIP001 											if(pConnObj)
//STRIP001 											{
//STRIP001 												SdrObject* pConnClone = ImpGetClone(aConnectorContainer, pConnObj);
//STRIP001 												if(pConnClone)
//STRIP001 												{
//STRIP001 													// if dest obj was cloned, too, re-establish connection
//STRIP001 													pCloneEdge->ConnectToNode(FALSE, pConnClone);
//STRIP001 													pCloneEdge->GetConnection(FALSE).SetConnectorId(rConn0.GetConnectorId());
//STRIP001 												}
//STRIP001 												else
//STRIP001 												{
//STRIP001 													// set position of connection point of original connected object
//STRIP001 													const SdrGluePointList* pGlueList = pConnObj->GetGluePointList();
//STRIP001 													if(pGlueList)
//STRIP001 													{
//STRIP001 														sal_uInt16 nInd = pGlueList->FindGluePoint(rConn0.GetConnectorId());
//STRIP001 														
//STRIP001 														if(SDRGLUEPOINT_NOTFOUND != nInd)
//STRIP001 														{
//STRIP001 															const SdrGluePoint& rGluePoint = (*pGlueList)[nInd];
//STRIP001 															Point aPosition = rGluePoint.GetAbsolutePos(*pConnObj);
//STRIP001 															aPosition.X() += aVector.A();
//STRIP001 															aPosition.Y() += aVector.B();
//STRIP001 															pCloneEdge->SetTailPoint(FALSE, aPosition);
//STRIP001 														}
//STRIP001 													}
//STRIP001 												}
//STRIP001 											}
//STRIP001 
//STRIP001 											// test second connection
//STRIP001 											SdrObjConnection& rConn1 = pOrigEdge->GetConnection(TRUE);
//STRIP001 											pConnObj = rConn1.GetObject();
//STRIP001 											if(pConnObj)
//STRIP001 											{
//STRIP001 												SdrObject* pConnClone = ImpGetClone(aConnectorContainer, pConnObj);
//STRIP001 												if(pConnClone)
//STRIP001 												{
//STRIP001 													// if dest obj was cloned, too, re-establish connection
//STRIP001 													pCloneEdge->ConnectToNode(TRUE, pConnClone);
//STRIP001 													pCloneEdge->GetConnection(TRUE).SetConnectorId(rConn1.GetConnectorId());
//STRIP001 												}
//STRIP001 												else
//STRIP001 												{
//STRIP001 													// set position of connection point of original connected object
//STRIP001 													const SdrGluePointList* pGlueList = pConnObj->GetGluePointList();
//STRIP001 													if(pGlueList)
//STRIP001 													{
//STRIP001 														sal_uInt16 nInd = pGlueList->FindGluePoint(rConn1.GetConnectorId());
//STRIP001 														
//STRIP001 														if(SDRGLUEPOINT_NOTFOUND != nInd)
//STRIP001 														{
//STRIP001 															const SdrGluePoint& rGluePoint = (*pGlueList)[nInd];
//STRIP001 															Point aPosition = rGluePoint.GetAbsolutePos(*pConnObj);
//STRIP001 															aPosition.X() += aVector.A();
//STRIP001 															aPosition.Y() += aVector.B();
//STRIP001 															pCloneEdge->SetTailPoint(TRUE, aPosition);
//STRIP001 														}
//STRIP001 													}
//STRIP001 												}
//STRIP001 											}
//STRIP001 										}
//STRIP001 									}
//STRIP001 								}
//STRIP001 
//STRIP001 								// #83525# cleanup remember classes
//STRIP001 								for(a = 0; a < aConnectorContainer.Count(); a++)
//STRIP001 									delete (ImpRememberOrigAndClone*)aConnectorContainer.GetObject(a);
//STRIP001 
//STRIP001 								if( pMarkList != pDragSrcMarkList )
//STRIP001 									delete pMarkList;
//STRIP001 
//STRIP001 								bReturn = TRUE;
//STRIP001 							}
//STRIP001 							else
//STRIP001 							{
//STRIP001 								aDropErrorTimer.Start();
//STRIP001 								bReturn = FALSE;
//STRIP001 							}
//STRIP001 						}
//STRIP001 					}
//STRIP001 					else
//STRIP001 					{
//STRIP001 						pOwnData->SetInternalMove( TRUE );
//STRIP001 						MoveAllMarked( Size( aDropPos.X() - pOwnData->GetStartPos().X(),
//STRIP001 											 aDropPos.Y() - pOwnData->GetStartPos().Y() ), bCopy );
//STRIP001 						bReturn = TRUE;
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				// different views
//STRIP001 				if( !pSourceView->IsPresObjSelected() )
//STRIP001 				{
//STRIP001 					// model is owned by from AllocModel() created DocShell
//STRIP001 					SdDrawDocument* pSourceDoc = (SdDrawDocument*) pSourceView->GetModel();
//STRIP001 					pSourceDoc->CreatingDataObj( pOwnData );
//STRIP001 					SdDrawDocument* pModel = (SdDrawDocument*) pSourceView->GetAllMarkedModel();
//STRIP001 					bReturn = Paste( *pModel, aDropPos, pPage, nPasteOptions );
//STRIP001 
//STRIP001 					if( bLink )
//STRIP001 					{
//STRIP001 						SdrObject*		pObj = NULL;
//STRIP001 						SdPage*			pWorkPage = pModel->GetSdPage( 0, PK_STANDARD );
//STRIP001 						SdrObjListIter	aIter( *pWorkPage, IM_DEEPWITHGROUPS );
//STRIP001 						String			aDocName( pSourceDoc->GetDocSh()->GetMedium()->GetName() );
//STRIP001 
//STRIP001 						while( aIter.IsMore() )
//STRIP001 						{
//STRIP001 							pObj = aIter.Next();
//STRIP001 							
//STRIP001 							String aName( pObj->GetName() );
//STRIP001 
//STRIP001 							if( aName.Len() )
//STRIP001 							{
//STRIP001 								SdrObject* pNewObj = pDoc->GetObj( aName );
//STRIP001 
//STRIP001 								if( pNewObj )
//STRIP001 								{
//STRIP001 									if( pNewObj->ISA( SdrObjGroup ) )
//STRIP001 										( (SdrObjGroup*) pNewObj )->SetGroupLink( aDocName, aName );
//STRIP001 								}
//STRIP001 							}
//STRIP001 						}
//STRIP001 					}
//STRIP001 
//STRIP001 					if( !pPage )
//STRIP001 						pPage = (SdPage*) GetPageViewPvNum( 0 )->GetPage();
//STRIP001 
//STRIP001 					String aLayout( pPage->GetLayoutName() );
//STRIP001 					aLayout.Erase( aLayout.SearchAscii( SD_LT_SEPARATOR ) );
//STRIP001 					pPage->SetPresentationLayout( aLayout, FALSE, FALSE );
//STRIP001 					pSourceDoc->CreatingDataObj( NULL );
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					aDropErrorTimer.Start();
//STRIP001 					bReturn = FALSE;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 		    SdDrawDocument*	pWorkModel = (SdDrawDocument*) pOwnData->GetWorkDocument();
//STRIP001 		    SdPage*			pWorkPage = (SdPage*) pWorkModel->GetSdPage( 0, PK_STANDARD ); 
//STRIP001 		    
//STRIP001 		    pWorkPage->SetRectsDirty();
//STRIP001 
//STRIP001 			// #104148# Use SnapRect, not BoundRect
//STRIP001 		    Size aSize( pWorkPage->GetAllObjSnapRect().GetSize() );
//STRIP001 
//STRIP001 		    aDropPos.X() = pOwnData->GetStartPos().X() + ( aSize.Width() >> 1 );
//STRIP001 		    aDropPos.Y() = pOwnData->GetStartPos().Y() + ( aSize.Height() >> 1 );
//STRIP001 		    
//STRIP001 		    // delete pages, that are not of any interest for us
//STRIP001 		    for( long i = ( pWorkModel->GetPageCount() - 1 ); i >= 0; i-- )
//STRIP001 		    {
//STRIP001 			    SdPage* pPage = (SdPage*) pWorkModel->GetPage( (USHORT) i );
//STRIP001 
//STRIP001 			    if( pPage->GetPageKind() != PK_STANDARD )
//STRIP001 				    pWorkModel->DeletePage( (USHORT) i );
//STRIP001 		    }
//STRIP001 			    
//STRIP001 		    bReturn = Paste( *pWorkModel, aDropPos, pPage, nPasteOptions );
//STRIP001 
//STRIP001 		    if( !pPage )
//STRIP001 			    pPage = (SdPage*) GetPageViewPvNum( 0 )->GetPage();
//STRIP001 
//STRIP001 		    String aLayout(pPage->GetLayoutName());
//STRIP001 		    aLayout.Erase(aLayout.SearchAscii(SD_LT_SEPARATOR));
//STRIP001 		    pPage->SetPresentationLayout( aLayout, FALSE, FALSE );
//STRIP001 	   }
//STRIP001 	}
//STRIP001 	else if( CHECK_FORMAT_TRANS( SOT_FORMATSTR_ID_DRAWING ) )
//STRIP001 	{
//STRIP001 		SotStorageStreamRef xStm;
//STRIP001 
//STRIP001 		if( aDataHelper.GetSotStorageStream( SOT_FORMATSTR_ID_DRAWING, xStm ) )
//STRIP001 		{
//STRIP001 			BOOL bChanged = FALSE;
//STRIP001 
//STRIP001 			SdDrawDocument* pModel = new SdDrawDocument( DOCUMENT_TYPE_IMPRESS, pDocSh );
//STRIP001 			pModel->GetItemPool().SetDefaultMetric(SFX_MAPUNIT_100TH_MM);
//STRIP001 //			pModel->GetItemPool().FreezeIdRanges();
//STRIP001 
//STRIP001 			pModel->SetStreamingSdrModel( TRUE );
//STRIP001 
//STRIP001 			Reference< XComponent > xComponent( new SdXImpressDocument( pModel, sal_True ) );
//STRIP001 			pModel->setUnoModel( Reference< XInterface >::query( xComponent ) );
//STRIP001 
//STRIP001 			xStm->Seek( 0 );
//STRIP001 
//STRIP001 			::com::sun::star::uno::Reference< ::com::sun::star::io::XInputStream > xInputStream( new utl::OInputStreamWrapper( *xStm ) );
//STRIP001 			bReturn = SvxDrawingLayerImport( pModel, xInputStream, xComponent, "com.sun.star.comp.Impress.XMLImporter" );
//STRIP001 
//STRIP001 			pModel->SetStreamingSdrModel( FALSE );
//STRIP001 
//STRIP001 			if( bReturn )
//STRIP001 			{
//STRIP001 				if( pModel->GetPage( 0 )->GetObjCount() == 1 )
//STRIP001 				{
//STRIP001 					// only one object
//STRIP001 					SdrObject*		pObj = pModel->GetPage( 0 )->GetObj( 0 );
//STRIP001 					SdrObject*		pPickObj = NULL;
//STRIP001 					SdrPageView*	pPV = NULL;
//STRIP001 					BOOL			bPickObj = PickObj( rPos, pPickObj, pPV );
//STRIP001 
//STRIP001 					if( ( nAction & DND_ACTION_MOVE ) && pPickObj && pObj )
//STRIP001 					{
//STRIP001 						// replace object
//STRIP001 						SdrObject*	pNewObj = pObj->Clone();
//STRIP001 						Rectangle	aPickObjRect( pPickObj->GetBoundRect() );
//STRIP001 						Size		aPickObjSize( aPickObjRect.GetSize() );
//STRIP001 						Point		aVec( aPickObjRect.TopLeft() );
//STRIP001 						Rectangle	aObjRect( pNewObj->GetBoundRect() );
//STRIP001 						Size		aObjSize( aObjRect.GetSize() );
//STRIP001 
//STRIP001 						Fraction aScaleWidth( aPickObjSize.Width(), aObjSize.Width() );
//STRIP001 						Fraction aScaleHeight( aPickObjSize.Height(), aObjSize.Height() );
//STRIP001 						pNewObj->NbcResize( aObjRect.TopLeft(), aScaleWidth, aScaleHeight );
//STRIP001 
//STRIP001 						aVec -= aObjRect.TopLeft();
//STRIP001 						pNewObj->NbcMove( Size( aVec.X(), aVec.Y() ) );
//STRIP001 
//STRIP001 						BegUndo( String( SdResId(STR_UNDO_DRAGDROP ) ) );
//STRIP001 						pNewObj->NbcSetLayer( pPickObj->GetLayer() );
//STRIP001 						SdrPage* pWorkPage = GetPageViewPvNum( 0 )->GetPage();
//STRIP001 						pWorkPage->InsertObject( pNewObj );
//STRIP001 						AddUndo( new SdrUndoNewObj( *pNewObj ) );
//STRIP001 						AddUndo( new SdrUndoDelObj( *pPickObj ) );
//STRIP001 						pWorkPage->RemoveObject( pPickObj->GetOrdNum() );
//STRIP001 						EndUndo();
//STRIP001 						bChanged = TRUE;
//STRIP001 						nAction = DND_ACTION_COPY;
//STRIP001 					}
//STRIP001 					else if( ( nAction & DND_ACTION_LINK ) && pPickObj && pObj && !pPickObj->ISA( SdrGrafObj ) && !pPickObj->ISA( SdrOle2Obj ) )
//STRIP001 					{
//STRIP001 						SfxItemSet aSet( pDoc->GetPool() );
//STRIP001 
//STRIP001 						// set new attributes to object
//STRIP001 						BegUndo( String( SdResId( STR_UNDO_DRAGDROP ) ) );
//STRIP001 						AddUndo( new SdrUndoAttrObj( *pPickObj ) );
//STRIP001 						aSet.Put( pObj->GetItemSet() );
//STRIP001 
//STRIP001 						// Eckenradius soll nicht uebernommen werden.
//STRIP001 						// In der Gallery stehen Farbverlauefe (Rechtecke)
//STRIP001 						// welche den Eckenradius == 0 haben. Dieser soll
//STRIP001 						// nicht auf das Objekt uebertragen werden.
//STRIP001 						aSet.ClearItem( SDRATTR_ECKENRADIUS );
//STRIP001 
//STRIP001 						pPickObj->SetItemSetAndBroadcast( aSet );
//STRIP001 
//STRIP001 						if( pPickObj->ISA( E3dObject ) && pObj->ISA( E3dObject ) )
//STRIP001 						{
//STRIP001 							// Zusaetzlich 3D Attribute handeln
//STRIP001 							SfxItemSet aNewSet( pDoc->GetPool(), SID_ATTR_3D_START, SID_ATTR_3D_END, 0 );
//STRIP001 							SfxItemSet aOldSet( pDoc->GetPool(), SID_ATTR_3D_START, SID_ATTR_3D_END, 0 );
//STRIP001 							
//STRIP001 							aOldSet.Put(pPickObj->GetItemSet());
//STRIP001 							aNewSet.Put( pObj->GetItemSet() );
//STRIP001 
//STRIP001 							AddUndo( new E3dAttributesUndoAction( *pDoc, this, (E3dObject*) pPickObj, aNewSet, aOldSet, FALSE ) );
//STRIP001 							pPickObj->SetItemSetAndBroadcast( aNewSet );
//STRIP001 						}
//STRIP001 
//STRIP001 						EndUndo();
//STRIP001 						bChanged = TRUE;
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			if( !bChanged )
//STRIP001 			{
//STRIP001 				SdrPage* pWorkPage = pModel->GetPage( 0 );
//STRIP001 				
//STRIP001 				pWorkPage->SetRectsDirty();
//STRIP001 
//STRIP001 				if( pOwnData )
//STRIP001 				{
//STRIP001 					// #104148# Use SnapRect, not BoundRect
//STRIP001 					Size aSize( pWorkPage->GetAllObjSnapRect().GetSize() );
//STRIP001 					
//STRIP001 					aDropPos.X() = pOwnData->GetStartPos().X() + ( aSize.Width() >> 1 );
//STRIP001 					aDropPos.Y() = pOwnData->GetStartPos().Y() + ( aSize.Height() >> 1 );
//STRIP001 				}
//STRIP001 
//STRIP001 				bReturn = Paste( *pModel, aDropPos, pPage, nPasteOptions );
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if( CHECK_FORMAT_TRANS( SOT_FORMATSTR_ID_SBA_FIELDDATAEXCHANGE ) )
//STRIP001 	{
//STRIP001 		::rtl::OUString aOUString;
//STRIP001 
//STRIP001 		if( aDataHelper.GetString( SOT_FORMATSTR_ID_SBA_FIELDDATAEXCHANGE, aOUString ) )
//STRIP001 		{
//STRIP001 			SdrObject* pObj = CreateFieldControl( aOUString );
//STRIP001 
//STRIP001 			if( pObj )
//STRIP001 			{
//STRIP001 				Rectangle	aRect( pObj->GetLogicRect() );
//STRIP001 				Size		aSize( aRect.GetSize() );
//STRIP001 
//STRIP001 				aDropPos.X() -= ( aSize.Width() >> 1 );
//STRIP001 				aDropPos.Y() -= ( aSize.Height() >> 1 );
//STRIP001 
//STRIP001 				aRect.SetPos( aDropPos );
//STRIP001 				pObj->SetLogicRect( aRect );
//STRIP001 				InsertObject( pObj, *GetPageViewPvNum( 0 ), SDRINSERT_SETDEFLAYER );
//STRIP001 				bReturn = TRUE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if( !bLink &&
//STRIP001 			 ( CHECK_FORMAT_TRANS( SOT_FORMATSTR_ID_EMBED_SOURCE ) || 
//STRIP001 			   CHECK_FORMAT_TRANS( SOT_FORMATSTR_ID_EMBEDDED_OBJ ) )  &&
//STRIP001 			   aDataHelper.HasFormat( SOT_FORMATSTR_ID_OBJECTDESCRIPTOR ) )
//STRIP001 	{
//STRIP001 		SotStorageStreamRef				xStm;
//STRIP001 		TransferableObjectDescriptor	aObjDesc;
//STRIP001 
//STRIP001 		if( aDataHelper.GetTransferableObjectDescriptor( SOT_FORMATSTR_ID_OBJECTDESCRIPTOR, aObjDesc ) &&
//STRIP001 			( aDataHelper.GetSotStorageStream( nFormat ? nFormat : SOT_FORMATSTR_ID_EMBED_SOURCE, xStm ) ||
//STRIP001 			  aDataHelper.GetSotStorageStream( SOT_FORMATSTR_ID_EMBEDDED_OBJ, xStm ) ) )
//STRIP001 		{
//STRIP001 			SvStorageRef xStore( new SvStorage( *xStm ) );
//STRIP001 
//STRIP001 			if( pDoc->GetDocSh() && ( pDoc->GetDocSh()->GetClassName() == aObjDesc.maClassName ) )
//STRIP001 			{
//STRIP001 				SdDrawDocShellRef xDocShRef( new SdDrawDocShell( SFX_CREATE_MODE_EMBEDDED, TRUE, pDoc->GetDocumentType() ) );
//STRIP001 
//STRIP001 				if( xDocShRef->DoLoad( xStore ) )
//STRIP001 				{
//STRIP001 					SdDrawDocument*	pModel = (SdDrawDocument*) xDocShRef->GetDoc();
//STRIP001 					SdPage*			pWorkPage = (SdPage*) pModel->GetSdPage( 0, PK_STANDARD ); 
//STRIP001 					
//STRIP001 					pWorkPage->SetRectsDirty();
//STRIP001 
//STRIP001 					if( pOwnData )
//STRIP001 					{
//STRIP001 						// #104148# Use SnapRect, not BoundRect
//STRIP001 						Size aSize( pWorkPage->GetAllObjSnapRect().GetSize() );
//STRIP001 						
//STRIP001 						aDropPos.X() = pOwnData->GetStartPos().X() + ( aSize.Width() >> 1 );
//STRIP001 						aDropPos.Y() = pOwnData->GetStartPos().Y() + ( aSize.Height() >> 1 );
//STRIP001 					}
//STRIP001 					
//STRIP001 					// delete pages, that are not of any interest for us
//STRIP001 					for( long i = ( pModel->GetPageCount() - 1 ); i >= 0; i-- )
//STRIP001 					{
//STRIP001 						SdPage* pPage = (SdPage*) pModel->GetPage( (USHORT) i );
//STRIP001 
//STRIP001 						if( pPage->GetPageKind() != PK_STANDARD )
//STRIP001 							pModel->DeletePage( (USHORT) i );
//STRIP001 					}
//STRIP001 						
//STRIP001 					bReturn = Paste( *pModel, aDropPos, pPage, nPasteOptions );
//STRIP001 
//STRIP001 					if( !pPage )
//STRIP001 						pPage = (SdPage*) GetPageViewPvNum( 0 )->GetPage();
//STRIP001 
//STRIP001 					String aLayout(pPage->GetLayoutName());
//STRIP001 					aLayout.Erase(aLayout.SearchAscii(SD_LT_SEPARATOR));
//STRIP001 					pPage->SetPresentationLayout( aLayout, FALSE, FALSE );
//STRIP001 				}
//STRIP001 
//STRIP001 				xDocShRef->DoClose();
//STRIP001 				xDocShRef.Clear();
//STRIP001 
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				SvInPlaceObjectRef	xIPObj( &( (SvFactory*) SvInPlaceObject::ClassFactory() )->CreateAndLoad( xStore ) );
//STRIP001 				
//STRIP001 				if( xIPObj.Is() )
//STRIP001 				{
//STRIP001 					String aName( pDocSh->InsertObject( xIPObj, String() )->GetObjName() );
//STRIP001 
//STRIP001 					if( aObjDesc.maSize.Width() && aObjDesc.maSize.Height() )
//STRIP001 						xIPObj->SetVisAreaSize( OutputDevice::LogicToLogic( aObjDesc.maSize, MAP_100TH_MM, xIPObj->GetMapUnit() ) );
//STRIP001 
//STRIP001 					Size aSize( xIPObj->GetVisArea().GetSize() );
//STRIP001 
//STRIP001 					if( !aSize.Width() || !aSize.Height() )
//STRIP001 					{
//STRIP001 						aSize.Width()  = 14100;
//STRIP001 						aSize.Height() = 10000;
//STRIP001 						xIPObj->SetVisAreaSize( OutputDevice::LogicToLogic( aSize, MAP_100TH_MM, xIPObj->GetMapUnit() ) );
//STRIP001 						aSize = xIPObj->GetVisArea().GetSize();
//STRIP001 					}
//STRIP001 
//STRIP001 					aSize = OutputDevice::LogicToLogic( aSize, xIPObj->GetMapUnit(), MAP_100TH_MM );
//STRIP001 					Size aMaxSize( pDoc->GetMaxObjSize() );
//STRIP001 					
//STRIP001 					aDropPos.X() -= Min( aSize.Width(), aMaxSize.Width() ) >> 1;
//STRIP001 					aDropPos.Y() -= Min( aSize.Height(), aMaxSize.Height() ) >> 1;
//STRIP001 					
//STRIP001 					Rectangle		aRect( aDropPos, aSize );
//STRIP001 					SdrOle2Obj*		pObj = new SdrOle2Obj( xIPObj, aName, aRect );
//STRIP001 					SdrPageView*	pPV = GetPageViewPvNum( 0 );
//STRIP001 					ULONG			nOptions = SDRINSERT_SETDEFLAYER;
//STRIP001 
//STRIP001 					if( pViewSh && pViewSh->GetIPClient() && pViewSh->GetIPClient()->IsInPlaceActive() )
//STRIP001 						nOptions |= SDRINSERT_DONTMARK;
//STRIP001 
//STRIP001 					InsertObject( pObj, *pPV, nOptions );
//STRIP001 
//STRIP001 					if( pImageMap )
//STRIP001 						pObj->InsertUserData( new SdIMapInfo( *pImageMap ) );
//STRIP001 
//STRIP001 					bReturn = TRUE;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if( !bLink &&
//STRIP001 			 ( CHECK_FORMAT_TRANS( SOT_FORMATSTR_ID_EMBEDDED_OBJ_OLE ) ||
//STRIP001 			   CHECK_FORMAT_TRANS( SOT_FORMATSTR_ID_EMBED_SOURCE_OLE ) ) &&
//STRIP001 			   aDataHelper.HasFormat( SOT_FORMATSTR_ID_OBJECTDESCRIPTOR_OLE ) )
//STRIP001 	{
//STRIP001 		SotStorageStreamRef				xStm;
//STRIP001 		TransferableObjectDescriptor	aObjDesc;
//STRIP001 
//STRIP001 		if( aDataHelper.GetTransferableObjectDescriptor(
//STRIP001 			SOT_FORMATSTR_ID_OBJECTDESCRIPTOR_OLE, aObjDesc ))
//STRIP001 		{
//STRIP001 			UniString aEmptyStr;
//STRIP001 			SvStorage* xStore = new SvStorage( aEmptyStr, STREAM_STD_READWRITE );
//STRIP001 			SvInPlaceObjectRef xIPObj= &((SvFactory*)SvInPlaceObject::ClassFactory())
//STRIP001 				->CreateAndInit( aDataHelper.GetTransferable(), xStore);
//STRIP001 				
//STRIP001 			if( xIPObj.Is() )
//STRIP001 			{
//STRIP001 				String aName( pDocSh->InsertObject( xIPObj, String() )->GetObjName() );
//STRIP001 				
//STRIP001 				if( aObjDesc.maSize.Width() && aObjDesc.maSize.Height() )
//STRIP001 					xIPObj->SetVisAreaSize( OutputDevice::LogicToLogic( aObjDesc.maSize, MAP_100TH_MM, xIPObj->GetMapUnit() ) );
//STRIP001 				
//STRIP001 				Size aSize( xIPObj->GetVisArea().GetSize() );
//STRIP001 				
//STRIP001 				if( !aSize.Width() || !aSize.Height() )
//STRIP001 				{
//STRIP001 					aSize.Width()  = 14100;
//STRIP001 					aSize.Height() = 10000;
//STRIP001 					xIPObj->SetVisAreaSize( OutputDevice::LogicToLogic( aSize, MAP_100TH_MM, xIPObj->GetMapUnit() ) );
//STRIP001 					aSize = xIPObj->GetVisArea().GetSize();
//STRIP001 				}
//STRIP001 				
//STRIP001 				aSize = OutputDevice::LogicToLogic( aSize, xIPObj->GetMapUnit(), MAP_100TH_MM );
//STRIP001 				Size aMaxSize( pDoc->GetMaxObjSize() );
//STRIP001 				
//STRIP001 				aDropPos.X() -= Min( aSize.Width(), aMaxSize.Width() ) >> 1;
//STRIP001 				aDropPos.Y() -= Min( aSize.Height(), aMaxSize.Height() ) >> 1;
//STRIP001 				
//STRIP001 				Rectangle		aRect( aDropPos, aSize );
//STRIP001 				SdrOle2Obj*		pObj = new SdrOle2Obj( xIPObj, aName, aRect );
//STRIP001 				SdrPageView*	pPV = GetPageViewPvNum( 0 );
//STRIP001 				ULONG			nOptions = SDRINSERT_SETDEFLAYER;
//STRIP001 				
//STRIP001 				if( pViewSh && pViewSh->GetIPClient() && pViewSh->GetIPClient()->IsInPlaceActive() )
//STRIP001 					nOptions |= SDRINSERT_DONTMARK;
//STRIP001 				
//STRIP001 				InsertObject( pObj, *pPV, nOptions );
//STRIP001 				
//STRIP001 				if( pImageMap )
//STRIP001 					pObj->InsertUserData( new SdIMapInfo( *pImageMap ) );
//STRIP001 				
//STRIP001 				bReturn = TRUE;
//STRIP001 				
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if( ( !bLink || pPickObj ) && CHECK_FORMAT_TRANS( SOT_FORMATSTR_ID_SVXB ) )
//STRIP001 	{
//STRIP001 		SotStorageStreamRef xStm;
//STRIP001 
//STRIP001 		if( aDataHelper.GetSotStorageStream( SOT_FORMATSTR_ID_SVXB, xStm ) )
//STRIP001 		{
//STRIP001 			Point   aInsertPos( rPos );
//STRIP001 			Graphic aGraphic;
//STRIP001 
//STRIP001 			*xStm >> aGraphic;
//STRIP001 
//STRIP001 			if( pOwnData && pOwnData->GetWorkDocument() )
//STRIP001 			{
//STRIP001 		        const SdDrawDocument*	pWorkModel = pOwnData->GetWorkDocument();
//STRIP001                 SdrPage*	            pWorkPage = (SdrPage*) ( ( pWorkModel->GetPageCount() > 1 ) ?
//STRIP001                                                     pWorkModel->GetSdPage( 0, PK_STANDARD ) :
//STRIP001                                                     pWorkModel->GetPage( 0 ) );
//STRIP001 				
//STRIP001 				pWorkPage->SetRectsDirty();
//STRIP001 				
//STRIP001 				// #104148# Use SnapRect, not BoundRect
//STRIP001 				Size aSize( pWorkPage->GetAllObjSnapRect().GetSize() );
//STRIP001 				
//STRIP001 				aInsertPos.X() = pOwnData->GetStartPos().X() + ( aSize.Width() >> 1 );
//STRIP001 				aInsertPos.Y() = pOwnData->GetStartPos().Y() + ( aSize.Height() >> 1 );
//STRIP001 			}
//STRIP001 
//STRIP001 			// #90129# restrict movement to WorkArea
//STRIP001 			Size aImageMapSize = OutputDevice::LogicToLogic(aGraphic.GetPrefSize(),
//STRIP001 				aGraphic.GetPrefMapMode(), MapMode(MAP_100TH_MM));
//STRIP001 			
//STRIP001 			ImpCheckInsertPos(aInsertPos, aImageMapSize, GetWorkArea());
//STRIP001 
//STRIP001 			InsertGraphic( aGraphic, nAction, aInsertPos, NULL, pImageMap );
//STRIP001 			bReturn = TRUE;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if( ( !bLink || pPickObj ) && CHECK_FORMAT_TRANS( FORMAT_GDIMETAFILE ) )
//STRIP001 	{
//STRIP001 		GDIMetaFile aMtf;
//STRIP001 
//STRIP001 		if( aDataHelper.GetGDIMetaFile( FORMAT_GDIMETAFILE, aMtf ) )
//STRIP001 		{
//STRIP001 			Point aInsertPos( rPos );
//STRIP001 
//STRIP001 			if( pOwnData && pOwnData->GetWorkDocument() )
//STRIP001 
//STRIP001 			{
//STRIP001 			    const SdDrawDocument*	pWorkModel = pOwnData->GetWorkDocument();
//STRIP001                 SdrPage*	            pWorkPage = (SdrPage*) ( ( pWorkModel->GetPageCount() > 1 ) ?
//STRIP001                                                     pWorkModel->GetSdPage( 0, PK_STANDARD ) :
//STRIP001                                                     pWorkModel->GetPage( 0 ) );
//STRIP001 				
//STRIP001 				pWorkPage->SetRectsDirty();
//STRIP001 				
//STRIP001 				// #104148# Use SnapRect, not BoundRect
//STRIP001 				Size aSize( pWorkPage->GetAllObjSnapRect().GetSize() );
//STRIP001 				
//STRIP001 				aInsertPos.X() = pOwnData->GetStartPos().X() + ( aSize.Width() >> 1 );
//STRIP001 				aInsertPos.Y() = pOwnData->GetStartPos().Y() + ( aSize.Height() >> 1 );
//STRIP001 			}
//STRIP001 
//STRIP001 			// #90129# restrict movement to WorkArea
//STRIP001 			Size aImageMapSize(aMtf.GetPrefSize());
//STRIP001 			ImpCheckInsertPos(aInsertPos, aImageMapSize, GetWorkArea());
//STRIP001 
//STRIP001 			InsertGraphic( aMtf, nAction, aInsertPos, NULL, pImageMap );
//STRIP001 			bReturn = TRUE;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if( ( !bLink || pPickObj ) && CHECK_FORMAT_TRANS( FORMAT_BITMAP ) )
//STRIP001 	{
//STRIP001 		Bitmap aBmp;
//STRIP001 
//STRIP001 		if( aDataHelper.GetBitmap( FORMAT_BITMAP, aBmp ) )
//STRIP001 		{
//STRIP001 			Point aInsertPos( rPos );
//STRIP001 
//STRIP001 			if( pOwnData && pOwnData->GetWorkDocument() )
//STRIP001 			{
//STRIP001 			    const SdDrawDocument*	pWorkModel = pOwnData->GetWorkDocument();
//STRIP001                 SdrPage*	            pWorkPage = (SdrPage*) ( ( pWorkModel->GetPageCount() > 1 ) ?
//STRIP001                                                     pWorkModel->GetSdPage( 0, PK_STANDARD ) :
//STRIP001                                                     pWorkModel->GetPage( 0 ) );
//STRIP001 				
//STRIP001 				pWorkPage->SetRectsDirty();
//STRIP001 				
//STRIP001 				// #104148# Use SnapRect, not BoundRect
//STRIP001 				Size aSize( pWorkPage->GetAllObjSnapRect().GetSize() );
//STRIP001 				
//STRIP001 				aInsertPos.X() = pOwnData->GetStartPos().X() + ( aSize.Width() >> 1 );
//STRIP001 				aInsertPos.Y() = pOwnData->GetStartPos().Y() + ( aSize.Height() >> 1 );
//STRIP001 			}
//STRIP001 
//STRIP001 			// #90129# restrict movement to WorkArea
//STRIP001 			Size aImageMapSize(aBmp.GetPrefSize());
//STRIP001 			ImpCheckInsertPos(aInsertPos, aImageMapSize, GetWorkArea());
//STRIP001 
//STRIP001 			InsertGraphic( aBmp, nAction, aInsertPos, NULL, pImageMap );
//STRIP001 			bReturn = TRUE;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if( pPickObj && CHECK_FORMAT_TRANS( SOT_FORMATSTR_ID_XFA ) )
//STRIP001 	{
//STRIP001 		SotStorageStreamRef xStm;
//STRIP001 
//STRIP001 		if( aDataHelper.GetSotStorageStream( SOT_FORMATSTR_ID_XFA, xStm ) )
//STRIP001 		{
//STRIP001 			XFillExchangeData aFillData( XFillAttrSetItem( &pDoc->GetPool() ) );
//STRIP001 
//STRIP001 			*xStm >> aFillData;
//STRIP001 			
//STRIP001 			BegUndo( String( SdResId( STR_UNDO_DRAGDROP ) ) );
//STRIP001 			AddUndo( new SdrUndoAttrObj( *pPickObj ) );
//STRIP001 			EndUndo();
//STRIP001 
//STRIP001 			XFillAttrSetItem*	pSetItem = aFillData.GetXFillAttrSetItem();
//STRIP001 			SfxItemSet			rSet = pSetItem->GetItemSet();
//STRIP001 			XFillStyle			eFill= ( (XFillStyleItem&) rSet.Get( XATTR_FILLSTYLE ) ).GetValue();
//STRIP001 
//STRIP001 			if( eFill == XFILL_SOLID || eFill == XFILL_NONE )
//STRIP001 			{
//STRIP001 				const XFillColorItem&	rColItem = (XFillColorItem&) rSet.Get( XATTR_FILLCOLOR );
//STRIP001 				Color					aColor( rColItem.GetValue() );
//STRIP001 				String					aName( rColItem.GetName() );
//STRIP001 				SfxItemSet				aSet( pDoc->GetPool() );
//STRIP001 				BOOL					bClosed = pPickObj->IsClosedObj();
//STRIP001 				SdWindow*				pWin = pViewSh->GetActiveWindow();
//STRIP001 				USHORT					nHitLog = (USHORT) pWin->PixelToLogic( Size( HITPIX, 0 ) ).Width();
//STRIP001 				const long				n2HitLog = nHitLog << 1;
//STRIP001 				Point					aHitPosR( rPos );
//STRIP001 				Point					aHitPosL( rPos );
//STRIP001 				Point					aHitPosT( rPos );
//STRIP001 				Point					aHitPosB( rPos );
//STRIP001 				const SetOfByte*		pVisiLayer = &GetPageViewPvNum(0)->GetVisibleLayers();
//STRIP001 
//STRIP001 				aHitPosR.X() += n2HitLog;
//STRIP001 				aHitPosL.X() -= n2HitLog;
//STRIP001 				aHitPosT.Y() += n2HitLog;
//STRIP001 				aHitPosB.Y() -= n2HitLog;
//STRIP001 
//STRIP001 				if( bClosed                                          &&
//STRIP001 					pPickObj->IsHit( aHitPosR, nHitLog, pVisiLayer ) &&
//STRIP001 					pPickObj->IsHit( aHitPosL, nHitLog, pVisiLayer ) &&
//STRIP001 					pPickObj->IsHit( aHitPosT, nHitLog, pVisiLayer ) &&
//STRIP001 					pPickObj->IsHit( aHitPosB, nHitLog, pVisiLayer ) )
//STRIP001 				{
//STRIP001 					// area fill
//STRIP001 					if(eFill == XFILL_SOLID ) 
//STRIP001 						aSet.Put(XFillColorItem(aName, aColor));
//STRIP001 
//STRIP001 					aSet.Put( XFillStyleItem( eFill ) ); 
//STRIP001 				}
//STRIP001 				else
//STRIP001 					aSet.Put( XLineColorItem( aName, aColor ) );
//STRIP001 
//STRIP001 				// Textfarbe hinzufuegen
//STRIP001 				pPickObj->SetItemSetAndBroadcast( aSet );
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if( !bLink && CHECK_FORMAT_TRANS( SOT_FORMATSTR_ID_HTML ) )
//STRIP001 	{
//STRIP001 		SotStorageStreamRef xStm;
//STRIP001 
//STRIP001 		if( aDataHelper.GetSotStorageStream( SOT_FORMATSTR_ID_HTML, xStm ) )
//STRIP001 		{
//STRIP001 			xStm->Seek( 0 );
//STRIP001 			bReturn = SdrView::Paste( *xStm, EE_FORMAT_HTML, aDropPos, pPage, nPasteOptions );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if( !bLink && CHECK_FORMAT_TRANS( SOT_FORMATSTR_ID_EDITENGINE ) )
//STRIP001 	{
//STRIP001 		SotStorageStreamRef xStm;
//STRIP001 
//STRIP001 		if( aDataHelper.GetSotStorageStream( SOT_FORMATSTR_ID_EDITENGINE, xStm ) )
//STRIP001 		{
//STRIP001 			OutlinerView* pOLV = GetTextEditOutlinerView();
//STRIP001 
//STRIP001             xStm->Seek( 0 );
//STRIP001 
//STRIP001 			if( pOLV )
//STRIP001 			{
//STRIP001 				Rectangle   aRect( pOLV->GetOutputArea() );
//STRIP001    				Point       aPos( pOLV->GetWindow()->PixelToLogic( aDropPos ) );
//STRIP001 
//STRIP001 				if( aRect.IsInside( aPos ) || ( !bDrag && IsTextEdit() ) )
//STRIP001 				{
//STRIP001 					pOLV->Read( *xStm, EE_FORMAT_BIN, FALSE, pDocSh->GetHeaderAttributes() );
//STRIP001 					bReturn = TRUE;
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			if( !bReturn )
//STRIP001 				bReturn = SdrView::Paste( *xStm, EE_FORMAT_BIN, aDropPos, pPage, nPasteOptions );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if( !bLink && CHECK_FORMAT_TRANS( FORMAT_RTF ) )
//STRIP001 	{
//STRIP001 		SotStorageStreamRef xStm;
//STRIP001 
//STRIP001 		if( aDataHelper.GetSotStorageStream( FORMAT_RTF, xStm ) )
//STRIP001 		{
//STRIP001 			OutlinerView* pOLV = GetTextEditOutlinerView();
//STRIP001 
//STRIP001             xStm->Seek( 0 );
//STRIP001 
//STRIP001 			if( pOLV )
//STRIP001 			{
//STRIP001 				Rectangle   aRect( pOLV->GetOutputArea() );
//STRIP001    				Point       aPos( pOLV->GetWindow()->PixelToLogic( aDropPos ) );
//STRIP001 
//STRIP001 				if( aRect.IsInside( aPos ) || ( !bDrag && IsTextEdit() ) )
//STRIP001 				{
//STRIP001 					pOLV->Read( *xStm, EE_FORMAT_RTF, FALSE, pDocSh->GetHeaderAttributes() );
//STRIP001 					bReturn = TRUE;
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			if( !bReturn )
//STRIP001 				bReturn = SdrView::Paste( *xStm, EE_FORMAT_RTF, aDropPos, pPage, nPasteOptions );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if( CHECK_FORMAT_TRANS( FORMAT_FILE_LIST ) )
//STRIP001 	{
//STRIP001         FileList aDropFileList;
//STRIP001 
//STRIP001         if( aDataHelper.GetFileList( FORMAT_FILE_LIST, aDropFileList ) )
//STRIP001         {
//STRIP001             aDropFileVector.clear();
//STRIP001 
//STRIP001             for( ULONG i = 0, nCount = aDropFileList.Count(); i < nCount; i++ )
//STRIP001                 aDropFileVector.push_back( aDropFileList.GetFile( i ) );
//STRIP001 			
//STRIP001             aDropInsertFileTimer.Start();
//STRIP001         }
//STRIP001 
//STRIP001 		bReturn = TRUE;
//STRIP001 	}
//STRIP001 	else if( CHECK_FORMAT_TRANS( FORMAT_FILE ) )
//STRIP001 	{
//STRIP001         String aDropFile;
//STRIP001 
//STRIP001         if( aDataHelper.GetString( FORMAT_FILE, aDropFile ) )
//STRIP001         {
//STRIP001             aDropFileVector.clear();
//STRIP001             aDropFileVector.push_back( aDropFile );
//STRIP001 			aDropInsertFileTimer.Start();
//STRIP001         }
//STRIP001 
//STRIP001 		bReturn = TRUE;
//STRIP001 	}
//STRIP001 	else if( !bLink && CHECK_FORMAT_TRANS( FORMAT_STRING ) )
//STRIP001 	{
//STRIP001 		if( ( FORMAT_STRING == nFormat ) || 
//STRIP001             ( !aDataHelper.HasFormat( SOT_FORMATSTR_ID_SOLK ) &&
//STRIP001 			  !aDataHelper.HasFormat( SOT_FORMATSTR_ID_NETSCAPE_BOOKMARK ) &&
//STRIP001 			  !aDataHelper.HasFormat( SOT_FORMATSTR_ID_FILENAME ) ) )
//STRIP001 		{
//STRIP001 			::rtl::OUString aOUString;
//STRIP001 
//STRIP001 			if( aDataHelper.GetString( FORMAT_STRING, aOUString ) )
//STRIP001 			{
//STRIP001 				OutlinerView* pOLV = GetTextEditOutlinerView();
//STRIP001 
//STRIP001 				if( pOLV )
//STRIP001 				{
//STRIP001 					pOLV->InsertText( aOUString );
//STRIP001 					bReturn = TRUE;
//STRIP001 				}
//STRIP001 				
//STRIP001                 if( !bReturn )
//STRIP001                     bReturn = SdrView::Paste( aOUString, aDropPos, pPage, nPasteOptions );
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	MarkListHasChanged();
//STRIP001 	bIsDropAllowed = TRUE;
//STRIP001 	rDnDAction = nAction;
//STRIP001 	delete pImageMap;
//STRIP001 
//STRIP001 	return bReturn;
//STRIP001 }
} //namespace binfilter
