/*************************************************************************
 *
 *  $RCSfile: sfx2_passwd.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:45:30 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// Include ---------------------------------------------------------------

// auto strip #ifndef _SV_MSGBOX_HXX
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
#pragma hdrstop

// auto strip #include "passwd.hxx"
// auto strip #include "sfxtypes.hxx"
// auto strip #include "sfxresid.hxx"

#include "dialog.hrc"
#include "passwd.hrc"
namespace binfilter {

#define MAX_PASSWORD_LEN	((USHORT)16)

// -----------------------------------------------------------------------

//STRIP001 #if (SUPD < 555)
//STRIP001 void SfxPasswordDialog::SetConfirm()
//STRIP001 {
//STRIP001 	SetText( maConfirmStr );
//STRIP001 	maPasswordED.SetText( String() );
//STRIP001 	maPasswordED.GrabFocus();
//STRIP001 }
//STRIP001 #endif
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK_INLINE_START( SfxPasswordDialog, EditModifyHdl, Edit *, EMPTYARG )
//STRIP001 {
//STRIP001 	maOKBtn.Enable( maPasswordED.GetText().Len() >= mnMinLen );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 IMPL_LINK_INLINE_END( SfxPasswordDialog, EditModifyHdl, Edit *, EMPTYARG )
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SfxPasswordDialog, OKHdl, OKButton *, EMPTYARG )
//STRIP001 {
//STRIP001 	if ( ( ( mnExtras & SHOWEXTRAS_CONFIRM ) == SHOWEXTRAS_CONFIRM ) &&
//STRIP001 		 ( GetConfirm() != GetPassword() ) )
//STRIP001 	{
//STRIP001 		ErrorBox aBox( this, SfxResId( MSG_ERROR_WRONG_CONFIRM ) );
//STRIP001 		aBox.Execute();
//STRIP001 		maConfirmED.SetText( String() );
//STRIP001 		maConfirmED.GrabFocus();
//STRIP001 	}
//STRIP001 	else
//STRIP001 		EndDialog( RET_OK );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 // CTOR / DTOR -----------------------------------------------------------
//STRIP001 
//STRIP001 SfxPasswordDialog::SfxPasswordDialog( Window* pParent, const String* pGroupText ) :
//STRIP001 
//STRIP001 	ModalDialog( pParent, SfxResId ( DLG_PASSWD ) ),
//STRIP001 
//STRIP001 	maUserFT		( this, ResId( FT_PASSWD_USER ) ),
//STRIP001 	maUserED		( this, ResId( ED_PASSWD_USER ) ),
//STRIP001 	maPasswordFT	( this, ResId( FT_PASSWD_PASSWORD ) ),
//STRIP001 	maPasswordED	( this, ResId( ED_PASSWD_PASSWORD ) ),
//STRIP001 	maConfirmFT		( this, ResId( FT_PASSWD_CONFIRM ) ),
//STRIP001 	maConfirmED		( this, ResId( ED_PASSWD_CONFIRM ) ),
//STRIP001 	maPasswordBox	( this, ResId( GB_PASSWD_PASSWORD ) ),
//STRIP001 	maOKBtn			( this, ResId( BTN_PASSWD_OK ) ),
//STRIP001 	maCancelBtn		( this, ResId( BTN_PASSWD_CANCEL ) ),
//STRIP001 	maHelpBtn		( this, ResId( BTN_PASSWD_HELP ) ),
//STRIP001 	maConfirmStr	( 		ResId( STR_PASSWD_CONFIRM ) ),
//STRIP001 
//STRIP001 	mnMinLen		( 5 ),
//STRIP001 	mnExtras		( 0 )
//STRIP001 
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	Link aLink = LINK( this, SfxPasswordDialog, EditModifyHdl );
//STRIP001 	maPasswordED.SetModifyHdl( aLink );
//STRIP001 	aLink = LINK( this, SfxPasswordDialog, OKHdl );
//STRIP001 	maOKBtn.SetClickHdl( aLink );
//STRIP001 
//STRIP001 	maPasswordED.SetMaxTextLen( MAX_PASSWORD_LEN );
//STRIP001 	maConfirmED.SetMaxTextLen( MAX_PASSWORD_LEN );
//STRIP001 
//STRIP001 	if ( pGroupText )
//STRIP001 		  maPasswordBox.SetText( *pGroupText );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SfxPasswordDialog::SetMinLen( USHORT nLen )
//STRIP001 {
//STRIP001 	mnMinLen = Min( nLen, MAX_PASSWORD_LEN );
//STRIP001 	EditModifyHdl( NULL );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 short SfxPasswordDialog::Execute()
//STRIP001 {
//STRIP001 	if ( mnExtras < SHOWEXTRAS_ALL )
//STRIP001 	{
//STRIP001 		Size a3Size = LogicToPixel( Size( 3, 3 ), MAP_APPFONT );
//STRIP001 		Size a6Size = LogicToPixel( Size( 6, 6 ), MAP_APPFONT );
//STRIP001 		long nMinHeight = maHelpBtn.GetPosPixel().Y() +
//STRIP001 						  maHelpBtn.GetSizePixel().Height() + a6Size.Height();
//STRIP001 		USHORT nRowHided = 1;
//STRIP001 
//STRIP001 		if ( SHOWEXTRAS_NONE == mnExtras )
//STRIP001 		{
//STRIP001 			maUserFT.Hide();
//STRIP001 			maUserED.Hide();
//STRIP001 			maConfirmFT.Hide();
//STRIP001 			maConfirmED.Hide();
//STRIP001 			maPasswordFT.Hide();
//STRIP001 
//STRIP001 			Point aPos = maUserFT.GetPosPixel();
//STRIP001 			long nEnd = maUserED.GetPosPixel().X() + maUserED.GetSizePixel().Width();
//STRIP001 			maPasswordED.SetPosPixel( aPos );
//STRIP001 			Size aSize = maPasswordED.GetSizePixel();
//STRIP001 			aSize.Width() = nEnd - aPos.X();
//STRIP001 			maPasswordED.SetSizePixel( aSize );
//STRIP001 
//STRIP001 			nRowHided = 2;
//STRIP001 		}
//STRIP001 		else if ( SHOWEXTRAS_USER == mnExtras )
//STRIP001 		{
//STRIP001 			maConfirmFT.Hide();
//STRIP001 			maConfirmED.Hide();
//STRIP001 		}
//STRIP001 		else if ( SHOWEXTRAS_CONFIRM == mnExtras )
//STRIP001 		{
//STRIP001 			maUserFT.Hide();
//STRIP001 			maUserED.Hide();
//STRIP001 
//STRIP001 			Point aPwdPos1 = maPasswordFT.GetPosPixel();
//STRIP001 			Point aPwdPos2 = maPasswordED.GetPosPixel();
//STRIP001 
//STRIP001 			Point aPos = maUserFT.GetPosPixel();
//STRIP001 			maPasswordFT.SetPosPixel( aPos );
//STRIP001 			aPos = maUserED.GetPosPixel();
//STRIP001 			maPasswordED.SetPosPixel( aPos );
//STRIP001 
//STRIP001 			maConfirmFT.SetPosPixel( aPwdPos1 );
//STRIP001 			maConfirmED.SetPosPixel( aPwdPos2 );
//STRIP001 		}
//STRIP001 
//STRIP001 		Size aBoxSize = maPasswordBox.GetSizePixel();
//STRIP001 		aBoxSize.Height() -= ( nRowHided * maUserED.GetSizePixel().Height() );
//STRIP001 		aBoxSize.Height() -= ( nRowHided * a3Size.Height() );
//STRIP001 		maPasswordBox.SetSizePixel( aBoxSize );
//STRIP001 
//STRIP001 		long nDlgHeight = maPasswordBox.GetPosPixel().Y() + aBoxSize.Height() + a6Size.Height();
//STRIP001 		if ( nDlgHeight < nMinHeight )
//STRIP001 			nDlgHeight = nMinHeight;
//STRIP001 		Size aDlgSize = GetOutputSizePixel();
//STRIP001 		aDlgSize.Height() = nDlgHeight;
//STRIP001 		SetOutputSizePixel( aDlgSize );
//STRIP001 	}
//STRIP001 
//STRIP001 	return ModalDialog::Execute();
//STRIP001 }


}
