/*************************************************************************
 *
 *  $RCSfile: sfx2_recfloat.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:46:24 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// includes *******************************************************************

#pragma hdrstop

// auto strip #ifndef _COM_SUN_STAR_FRAME_XDISPATCHRECORDERSUPPLIER_HPP_
// auto strip #include <com/sun/star/frame/XDispatchRecorderSupplier.hpp>
// auto strip #endif

// auto strip #include <svtools/eitem.hxx>
// auto strip #include <vcl/msgbox.hxx>

#ifndef _SVTOOLS_IMGDEF_HXX
#include <svtools/imgdef.hxx>
#endif

#include "recfloat.hxx"
#include "dialog.hrc"
// auto strip #include "sfxresid.hxx"
// auto strip #include "app.hxx"
// auto strip #include "bindings.hxx"
// auto strip #include "dispatch.hxx"
// auto strip #include "viewfrm.hxx"
// auto strip #include "viewsh.hxx"
namespace binfilter {

/*N*/ SFX_IMPL_FLOATINGWINDOW( SfxRecordingFloatWrapper_Impl, SID_RECORDING_FLOATWINDOW );

/*?*/ SfxRecordingFloatWrapper_Impl::SfxRecordingFloatWrapper_Impl( Window* pParent ,
/*?*/ 												USHORT nId ,
/*?*/ 												SfxBindings* pBind ,
/*?*/ 												SfxChildWinInfo* pInfo )
/*?*/ 					: SfxChildWindow( pParent , nId )
/*?*/ 					, pBindings( pBind )
/*?*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
//STRIP001     pWindow = new SfxRecordingFloat_Impl( pBindings, this, pParent );
//STRIP001 	SetWantsFocus( FALSE );
//STRIP001 	eChildAlignment = SFX_ALIGN_NOALIGNMENT;
//STRIP001     ( ( SfxFloatingWindow* ) pWindow )->Initialize( pInfo );
/*?*/ }

//STRIP001 SfxRecordingFloatWrapper_Impl::~SfxRecordingFloatWrapper_Impl()
//STRIP001 {
//STRIP001 	SfxBoolItem aItem( FN_PARAM_1, TRUE );
//STRIP001 	::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatchRecorder > xRecorder = pBindings->GetRecorder();
//STRIP001 	if ( xRecorder.is() )
//STRIP001 	    pBindings->GetDispatcher()->Execute( SID_STOP_RECORDING, SFX_CALLMODE_SYNCHRON, &aItem, 0L );
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool SfxRecordingFloatWrapper_Impl::QueryClose()
//STRIP001 {
//STRIP001     // asking for recorded macro should be replaced if index access is available!
//STRIP001 	BOOL bRet = TRUE;
//STRIP001     ::com::sun::star::uno::Reference< ::com::sun::star::frame::XDispatchRecorder > xRecorder = pBindings->GetRecorder();
//STRIP001     if ( xRecorder.is() && xRecorder->getRecordedMacro().getLength() )
//STRIP001     {
//STRIP001         QueryBox aBox( GetWindow(), WB_YES_NO | WB_DEF_NO , String( SfxResId( STR_MACRO_LOSS ) ) );
//STRIP001         aBox.SetText( String( SfxResId(STR_CANCEL_RECORDING) ) );
//STRIP001         bRet = ( aBox.Execute() == RET_YES );
//STRIP001     }
//STRIP001 
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 SfxRecordingFloat_Impl::SfxRecordingFloat_Impl( SfxBindings* pBindings ,
//STRIP001 										SfxChildWindow* pChildWin ,
//STRIP001                                         Window* pParent )
//STRIP001                         : SfxFloatingWindow( pBindings ,
//STRIP001 										pChildWin ,
//STRIP001 										pParent ,
//STRIP001                                         SfxResId( SID_RECORDING_FLOATWINDOW ) )
//STRIP001                         , pWrapper( pChildWin )
//STRIP001                         , aTbx( this, GetBindings(), SfxResId(SID_RECORDING_FLOATWINDOW) )
//STRIP001 {
//STRIP001     aTbx.Initialize();
//STRIP001     Size aSize = aTbx.GetToolBox().CalcWindowSizePixel();
//STRIP001     aTbx.GetToolBox().SetPosSizePixel( Point(), aSize );
//STRIP001 	SetOutputSizePixel( aSize );
//STRIP001     SfxBoolItem aItem( SID_RECORDMACRO, TRUE );
//STRIP001     GetBindings().GetDispatcher()->Execute( SID_RECORDMACRO, SFX_CALLMODE_SYNCHRON, &aItem, 0L );
//STRIP001 }
//STRIP001 
//STRIP001 BOOL SfxRecordingFloat_Impl::Close()
//STRIP001 {
//STRIP001     BOOL bRet = SfxFloatingWindow::Close();
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 void SfxRecordingFloat_Impl::FillInfo( SfxChildWinInfo& rInfo ) const
//STRIP001 {
//STRIP001     SfxFloatingWindow::FillInfo( rInfo );
//STRIP001 	rInfo.bVisible = sal_False;
//STRIP001 }
//STRIP001 
//STRIP001 void SfxRecordingFloat_Impl::StateChanged( StateChangedType nStateChange )
//STRIP001 {
//STRIP001 	if ( nStateChange == STATE_CHANGE_INITSHOW )
//STRIP001 	{
//STRIP001 		SfxViewFrame *pFrame = GetBindings().GetDispatcher_Impl()->GetFrame();
//STRIP001 		Window* pEditWin = pFrame->GetViewShell()->GetWindow();
//STRIP001 
//STRIP001 		Point aPoint = pEditWin->OutputToScreenPixel( pEditWin->GetPosPixel() );
//STRIP001 		aPoint = GetParent()->ScreenToOutputPixel( aPoint );
//STRIP001 		aPoint.X() += 20;
//STRIP001 		aPoint.Y() += 10;
//STRIP001 		SetPosPixel( aPoint );
//STRIP001 	}
//STRIP001 
//STRIP001 	SfxFloatingWindow::StateChanged( nStateChange );
//STRIP001 }
}
