/*************************************************************************
 *
 *  $RCSfile: sfx2_contenv.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 15:05:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #ifndef _SV_MENU_HXX
// auto strip #include <vcl/menu.hxx>
// auto strip #endif
// auto strip #ifndef _PSEUDO_HXX //autogen
// auto strip #include <so3/pseudo.hxx>
// auto strip #endif
// auto strip #ifndef _SFXENUMITEM_HXX //autogen
// auto strip #include <svtools/eitem.hxx>
// auto strip #endif
// auto strip #ifndef _IPMENU_HXX //autogen
// auto strip #include <so3/ipmenu.hxx>
// auto strip #endif
// auto strip #ifndef _SFXRECTITEM_HXX //autogen
// auto strip #include <svtools/rectitem.hxx>
// auto strip #endif
// auto strip #ifndef _SFXSTRITEM_HXX //autogen
// auto strip #include <svtools/stritem.hxx>
// auto strip #endif
// auto strip #ifndef _URLOBJ_HXX //autogen
// auto strip #include <tools/urlobj.hxx>
// auto strip #endif
// auto strip #include <svtools/menuoptions.hxx>
#pragma hdrstop

#include "app.hxx"
// auto strip #include "virtmenu.hxx"
// auto strip #include "mnumgr.hxx"
// auto strip #include "stbmgr.hxx"
#include "viewsh.hxx"
// auto strip #include "dispatch.hxx"
#include "contenv.hxx"
// auto strip #include "workwin.hxx"
// auto strip #include "viewfrm.hxx"
// auto strip #include "appdata.hxx"
// auto strip #include "docfile.hxx"
#include "topfrm.hxx"
// auto strip #include "objsh.hxx"

// SFX_INIMANAGER()
#if SUPD<613//MUSTINI
// auto strip #include "inimgr.hxx"
#endif
namespace binfilter {

//=========================================================================

//STRIP001 MenuBar * SfxContainerEnv_Impl::QueryMenu
//STRIP001 (
//STRIP001 	USHORT * pCount0,
//STRIP001 	USHORT * pCount1,
//STRIP001 	USHORT * pCount2
//STRIP001 )
//STRIP001 {
//STRIP001 	if( !pMenuBar )
//STRIP001 	{
//STRIP001         SfxMenuBarManager *pMMgr = pFrame->GetViewShell()->GetMenuBar_Impl();
//STRIP001         SfxVirtualMenu *pAppMenu = pMMgr->GetMenu();
//STRIP001 		MenuBar *pAppBar;
//STRIP001 
//STRIP001 #ifdef OS2
//STRIP001 		pAppBar = new MenuBar( *(MenuBar*) pAppMenu->GetSVMenu() );
//STRIP001 #else
//STRIP001 		pAppBar = (MenuBar*) pAppMenu->GetSVMenu();
//STRIP001 #endif
//STRIP001 
//STRIP001 		// Bereich 1: das Datei-Menue
//STRIP001 		USHORT nStart0 = 0, nCount0 = 1;
//STRIP001 
//STRIP001 		// Bereich 2: haben wir nicht
//STRIP001 		USHORT nStart1 = 0, nCount1 = 0;
//STRIP001 
//STRIP001 		// Bereich 3: das Fenstermenue
//STRIP001 		USHORT nPos = pAppBar->GetItemPos( SID_MDIWINDOWLIST );
//STRIP001 
//STRIP001 		// Die Menue-Konfiguration mu\s sicherstellen, da\s vor dem Dateimenue
//STRIP001 		// nichts steht und da\s Datei - und Fenstermenue nicht wegkonfiguriert
//STRIP001 		// werden k"onnen !
//STRIP001 		// OLE im PlugIn geht davon aus, da\s vom Container genau zwei Menues,
//STRIP001 		// Datei und Fenster, an der 1. und einer beliebigen anderen Position
//STRIP001 		// im InPlaceMenu stammen.
//STRIP001 		DBG_ASSERT( nPos != MENU_ITEM_NOTFOUND, "Wer hat das MDI-Menue geklaut ?!");
//STRIP001 		USHORT nStart2 = nPos, nCount2 = 1;
//STRIP001 
//STRIP001 		pAppMenu->InitPopup(0);
//STRIP001 		pAppMenu->InitPopup(nStart2);
//STRIP001 
//STRIP001 		pMenuBar = new SvInPlaceMenuBar( pAppBar, nStart0, nCount0, nStart1, nCount1, nStart2, nCount2 );
//STRIP001 
//STRIP001 		if ( pMMgr->GetMenu() )
//STRIP001 			pMenuBar->SetSelectHdl( LINK( pMMgr->GetMenu(), SfxVirtualMenu, Select ) );
//STRIP001 		else
//STRIP001         		pMenuBar->SetSelectHdl( LINK( pMMgr, SfxMenuManager, Select ) );
//STRIP001 
//STRIP001 		if( SvtMenuOptions().IsEntryHidingEnabled() == sal_False )
//STRIP001 			pMenuBar->SetMenuFlags( pMenuBar->GetMenuFlags() | MENU_FLAG_HIDEDISABLEDENTRIES );
//STRIP001 	}
//STRIP001 
//STRIP001 	return pMenuBar->GetBlocks( pCount0, pCount1, pCount2 );
//STRIP001 }

//-------------------------------------------------------------------------
//STRIP001 void SfxContainerEnv_Impl::SetInPlaceMenu( MenuBar * pMenu, BOOL bSet )
//STRIP001 {
//STRIP001 //  DV the rvp office now is started with -appserver -bean
//STRIP001 //	if ( SFX_APP()->Get_Impl()->bBean )
//STRIP001 //		return;
//STRIP001 
//STRIP001 	SfxApplication *pSfxApp = SFX_APP();
//STRIP001 	if( !bSet)
//STRIP001 		// AppMenue wieder zur"ucksetzen
//STRIP001         pMenu = (MenuBar*) pFrame->GetViewShell()->GetMenuBar_Impl()->GetMenu()->GetSVMenu();
//STRIP001 
//STRIP001     SfxTopViewFrame *pTop= PTR_CAST( SfxTopViewFrame, pFrame->GetTopViewFrame() );
//STRIP001     if ( pTop )
//STRIP001         pTop->GetTopFrame_Impl()->SetMenuBar_Impl( pMenu );
//STRIP001 }

//-------------------------------------------------------------------------

//STRIP001 void SfxContainerEnv_Impl::MenuReleased()
//STRIP001 {
//STRIP001 	DELETEZ( pMenuBar );
//STRIP001 }

//-------------------------------------------------------------------------

/*N*/ SfxContainerEnv_Impl::~SfxContainerEnv_Impl()
/*N*/ {
/*N*/ }

//-------------------------------------------------------------------------

/*N*/ SfxContainerEnv_Impl::SfxContainerEnv_Impl
/*N*/ (
/*N*/ 	SfxInPlaceClient* 	pClient,
/*N*/ 	SfxViewFrame*		pViewFrame,
/*N*/ 	WorkWindow*			pTopWin,
/*N*/ 	Window* 			pEditWin
/*N*/ )
/*N*/ :	SvContainerEnvironment( pClient, pTopWin,
/*N*/ //			(WorkWindow*) &( pViewFrame->GetParentViewFrame_Impl() ?
/*N*/ //			pViewFrame->GetParentViewFrame_Impl() :
/*N*/ //			pViewFrame->GetTopViewFrame() )->GetWindow(),
/*N*/ 			(WorkWindow*) &pViewFrame->GetWindow(),
/*N*/ 			pEditWin ? pEditWin : pViewFrame->GetViewShell()->GetWindow() ),
/*N*/ 	pFrame( pViewFrame ),
/*N*/ 	pMenuBar( 0 )
/*N*/ {
/*N*/ }

//-------------------------------------------------------------------------

//STRIP001 BOOL SfxContainerEnv_Impl::SetStatusText( const String & rText )
//STRIP001 {
//STRIP001 	if( GetParent() )
//STRIP001 		return SvContainerEnvironment::SetStatusText( rText );
//STRIP001 	else
//STRIP001 	{
//STRIP001 		if ( rText.Len() )
//STRIP001 			pFrame->ShowStatusText( rText );
//STRIP001 		else
//STRIP001 			pFrame->HideStatusText();
//STRIP001 	}
//STRIP001 	return TRUE;
//STRIP001 }

//-------------------------------------------------------------------------
//STRIP001 void SfxContainerEnv_Impl::ShowDocument
//STRIP001 (
//STRIP001 	const INetURLObject & rURL,
//STRIP001 	const XubString & rFrame
//STRIP001 )
//STRIP001 {
//STRIP001 	SfxStringItem aReferer( SID_REFERER, pFrame->GetObjectShell()->GetMedium()->GetName() );
//STRIP001 	SfxStringItem aName( SID_FILE_NAME, rURL.GetMainURL( INetURLObject::NO_DECODE ) );
//STRIP001 	SfxStringItem aTarget( SID_TARGETNAME, rFrame );
//STRIP001 	SfxBoolItem aCreateView( SID_OPEN_NEW_VIEW, TRUE );
//STRIP001 	SfxFrameItem aFrame( SID_DOCFRAME, pFrame );
//STRIP001 
//STRIP001     SFX_APP()->GetAppDispatcher_Impl()->Execute( SID_OPENDOC,
//STRIP001 			SFX_CALLMODE_ASYNCHRON, &aFrame, &aReferer,
//STRIP001 			&aName, &aCreateView, &aTarget, 0L );
//STRIP001 }

//-------------------------------------------------------------------------

//STRIP001 BOOL SfxContainerEnv_Impl::DispatchAccel( const KeyCode &rKeyCode )
//STRIP001 {
//STRIP001 	// zum Glueck wird das char (1. Parameter) nicht benoetigt
//STRIP001     return pFrame->GetViewShell()->KeyInput( KeyEvent( 0, rKeyCode ) );
//STRIP001 }

//-------------------------------------------------------------------------

//STRIP001 void SfxContainerEnv_Impl::RequestObjAreaPixel( const Rectangle & rObjRect )
//STRIP001 {
//STRIP001 	SfxRectangleItem *pRet, aReq( SID_OBJECTRESIZE, rObjRect );
//STRIP001 
//STRIP001 	// gewuenschte Groesse erfragen
//STRIP001 	SfxDispatcher * pDispat = pFrame->GetDispatcher();
//STRIP001 	const SfxPoolItem *pBaseRet = pDispat->Execute( SID_OBJECTRESIZE,
//STRIP001 			SFX_CALLMODE_SYNCHRON, &aReq, 0L, 0L );
//STRIP001 	pRet = PTR_CAST( SfxRectangleItem, pBaseRet );
//STRIP001 	if( pRet )
//STRIP001 		((SfxInPlaceClient *)GetIPClient())->RequestObjAreaPixel( pRet->GetValue() );
//STRIP001 	else
//STRIP001 		((SfxInPlaceClient *)GetIPClient())->RequestObjAreaPixel( rObjRect );
//STRIP001 }

//-------------------------------------------------------------------------

//STRIP001 void SfxContainerEnv_Impl::UIToolsShown( BOOL bShow )
//STRIP001 {
//STRIP001 	SfxWorkWindow *pWorkWin =
//STRIP001 		SFX_APP()->GetWorkWindow_Impl( pFrame );
//STRIP001 	if ( bShow )
//STRIP001 	{
//STRIP001 		// Gleich zeigt ein Objekt seine UITools an; jetzt mu\s ich meine
//STRIP001 		// Tools wegnehmen
//STRIP001 		BOOL bObjIsStarApp = GetIPClient()->Owner();
//STRIP001 /*
//STRIP001 		// Erkennung "uber Verben haut initial im Writer nicht hin
//STRIP001 		const SvVerbList *pList = pFrame->GetViewShell()->GetVerbs();
//STRIP001 		if ( pList )
//STRIP001 		{
//STRIP001 			for (USHORT n=0; n<pList->Count(); n++)
//STRIP001 			{
//STRIP001 				if ((*pList)[n].GetName() == STARAPP_VERB)
//STRIP001 				{
//STRIP001 					bObjIsStarApp = TRUE;
//STRIP001 					break;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 */
//STRIP001 		pFrame->GetBindings().HidePopups(TRUE);
//STRIP001 
//STRIP001 		// Bei StarApp als Server bleibt die Funktionsleiste des Clients
//STRIP001 		// sichtbar
//STRIP001 		// Wenn das OLE-Object in einem PlugIn aktiviert wird, mu\s das UI
//STRIP001 		// des OLE-Clients = PluginServers deaktiviert und das des PlugIn-Clients
//STRIP001 		// in den ToolSpace einbezogen werden
//STRIP001 		USHORT nVis = SFX_VISIBILITY_CLIENT;
//STRIP001 		if ( !bObjIsStarApp )
//STRIP001 			nVis = SFX_VISIBILITY_UNVISIBLE;
//STRIP001 		pWorkWin->SetObjectBarVisibility_Impl( nVis );
//STRIP001         pFrame->GetDispatcher()->Update_Impl( TRUE );
//STRIP001 //		pWorkWin->UpdateObjectBars_Impl();
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		// Das Objekt hat seine UITools weggenommen, jetzt kommen meine wieder.
//STRIP001 		// Dabei setzt die Applikation den App-Border, da es kein UI-aktives
//STRIP001 		// Objekt im aktiven Dokument gibt.
//STRIP001 		//	(->SfxAppWindow::ArrangeChilds_Impl())
//STRIP001         pWorkWin->SetObjectBarVisibility_Impl( SFX_VISIBILITY_STANDARD );
//STRIP001 
//STRIP001 		// Wenn ich gerade am sterben bin und mein ViewFrame noch der aktive ist,
//STRIP001 		// brauche ich kein Update zu machen, da das dann beim Austragen oder
//STRIP001 		// Wechseln des ViewFrames ohnehin geschieht (weniger Zappeln)
//STRIP001 		if ( !pFrame->GetFrame()->IsClosing_Impl() ||
//STRIP001 			SFX_APP()->GetViewFrame() != pFrame )
//STRIP001 				pFrame->GetDispatcher()->Update_Impl( TRUE );
//STRIP001 //				pWorkWin->UpdateObjectBars_Impl();
//STRIP001 
//STRIP001 		pFrame->GetBindings().HidePopups(FALSE);
//STRIP001 	}
//STRIP001 }

//STRIP001 BOOL SfxContainerEnv_Impl::SetTopToolSpacePixel( const SvBorder & rInner )
//STRIP001 {
//STRIP001 	if( !GetIPClient() || GetIPClient()->Owner() )
//STRIP001 	{
//STRIP001 		if( RequestTopToolSpacePixel( rInner ) )
//STRIP001 		{
//STRIP001             if ( pFrame->GetFrame()->OwnsBindings_Impl() )
//STRIP001 			{
//STRIP001 				SvBorder aBorder( GetTopBorder() );
//STRIP001 				aBorder += rInner;
//STRIP001 				pFrame->GetFrame()->SetToolSpaceBorderPixel_Impl( aBorder );
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				return FALSE;
//STRIP001 			}
//STRIP001 
//STRIP001 			return TRUE;
//STRIP001 
//STRIP001 			// Sind Top- und EditWin unterschiedlich, dann muss das EditWin
//STRIP001 			// neu angeordnet werden. Dies muss von dem abgeleiteten
//STRIP001 			// Environment geleistet werden.
//STRIP001 			// Sind sie gleich, kann die Anordnung automatisch geschehen
//STRIP001 			return GetEditWin() == GetTopWin();
//STRIP001 		}
//STRIP001 		return FALSE;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		return SvContainerEnvironment::SetTopToolSpacePixel( rInner );
//STRIP001 	}
//STRIP001 
//STRIP001 	return FALSE;
//STRIP001 }


}
