/*************************************************************************
 *
 *  $RCSfile: svx_worient.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:42:43 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop
#include "worient.hxx"
namespace binfilter {

//STRIP001 struct SvxWinOrientation_Impl
//STRIP001 {
//STRIP001     Link                maTxtStackedClickHdl;
//STRIP001 	ImageButton			aBtnTxtStacked;
//STRIP001 	SvxCtrDial			aCtrDial;
//STRIP001 	FixedText			aOrientFieldLabel;
//STRIP001 	SvxOrientationField	aOrientField;
//STRIP001 	FixedText			aVSLockModeLabel;
//STRIP001 	ValueSet			aVSLockMode;
//STRIP001     FixedLine           aFlAlign;
//STRIP001 	Color				aLast_BtnTxtStacked_Color;
//STRIP001 	Window&				rParent;
//STRIP001 	BOOL				bFlagEnabled;
//STRIP001 
//STRIP001 	SvxWinOrientation_Impl(
//STRIP001 					Window* pParent,
//STRIP001 					const ResId& rResIdForCtrDial,
//STRIP001 					const ResId& rResIdForBtnStackedText,
//STRIP001 					const ResId& rResIdForOrientLabel,
//STRIP001 					const ResId& rResIdForOrientField,
//STRIP001 					const ResId& rResIdForVSLockModeLabel,
//STRIP001 					const ResId& rResIdForVSLockMode,
//STRIP001                     const ResId& rResIdForFixedLine);
//STRIP001 
//STRIP001 	DECL_LINK( OrientModifyHdl, void * );
//STRIP001 	DECL_LINK( LostActiveHdl, void * );
//STRIP001 
//STRIP001 	void			Enable();
//STRIP001 	void			Disable();
//STRIP001 	void			SetStackedTxt(BOOL bOnOff);
//STRIP001 	void			SetDegrees(short alpha);
//STRIP001     void            SetNoDegrees();
//STRIP001 
//STRIP001 	void			Update_BtnTxtStacked_Colors( void );
//STRIP001 };
//STRIP001 
//STRIP001 SvxWinOrientation_Impl::SvxWinOrientation_Impl( Window * pParent,
//STRIP001 					const ResId & rResIdForCtrDial,
//STRIP001 					const ResId & rResIdForImageButton,
//STRIP001 					const ResId & rResIdForFixedText,
//STRIP001 					const ResId & rResIdForOrientField,
//STRIP001 					const ResId & rResIdForVSLockModeLabel,
//STRIP001 					const ResId & rResIdForVSLockMode,
//STRIP001                     const ResId & rResIdForFixedLine) :
//STRIP001 	aCtrDial( pParent,rResIdForCtrDial),
//STRIP001 	aOrientFieldLabel( pParent, rResIdForFixedText),
//STRIP001 	aOrientField(pParent, rResIdForOrientField),
//STRIP001 	aBtnTxtStacked	( pParent, rResIdForImageButton),
//STRIP001 	aVSLockModeLabel( pParent, rResIdForVSLockModeLabel),
//STRIP001 	aVSLockMode( pParent, rResIdForVSLockMode),
//STRIP001     aFlAlign( pParent, rResIdForFixedLine),
//STRIP001 	aLast_BtnTxtStacked_Color( COL_BLACK ),
//STRIP001 	rParent( *pParent )
//STRIP001 {
//STRIP001 	bFlagEnabled = TRUE;
//STRIP001 
//STRIP001 	Link			aLink = LINK( this, SvxWinOrientation_Impl, OrientModifyHdl );
//STRIP001 	Link			a2Link = LINK( this, SvxWinOrientation_Impl, LostActiveHdl );
//STRIP001 
//STRIP001 	// Mit Handler verbinden
//STRIP001 	aCtrDial.SetCtrModifiedHdl( aLink );
//STRIP001 	aCtrDial.SetMouseUpHdl( a2Link );
//STRIP001 	aOrientField.SetPrivatModifyHdl( aLink );
//STRIP001 	aOrientField.SetLoseFocusHdl(a2Link);
//STRIP001 	aBtnTxtStacked.SetClickHdl( aLink);
//STRIP001 
//STRIP001 	// change black text color to actual text color for Button for Stacked Text option
//STRIP001 	// aLast_BtnTxtStacked_Color was set to COL_BLACK initially
//STRIP001 	Update_BtnTxtStacked_Colors();
//STRIP001 
//STRIP001 	OrientModifyHdl( NULL );
//STRIP001 }
//STRIP001 
//STRIP001 void SvxWinOrientation_Impl::Enable()
//STRIP001 {
//STRIP001 	if( !bFlagEnabled  )
//STRIP001 	{
//STRIP001 		bFlagEnabled = TRUE;
//STRIP001 		aCtrDial.Enable();
//STRIP001 		aCtrDial.Invalidate();
//STRIP001 		aBtnTxtStacked.Enable();
//STRIP001 		aOrientFieldLabel.Enable();
//STRIP001 		aOrientField.Enable();
//STRIP001 		aVSLockModeLabel.Enable();
//STRIP001 		aVSLockMode.Enable();
//STRIP001         aFlAlign.Enable();
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void SvxWinOrientation_Impl::Disable()
//STRIP001 {
//STRIP001 	if( bFlagEnabled )
//STRIP001 	{
//STRIP001 		bFlagEnabled = FALSE;
//STRIP001 		aCtrDial.Disable();
//STRIP001 		aCtrDial.Invalidate();
//STRIP001 		aBtnTxtStacked.Disable();
//STRIP001 		aOrientFieldLabel.Disable();
//STRIP001 		aOrientField.Disable();
//STRIP001 		aVSLockModeLabel.Disable();
//STRIP001 		aVSLockMode.Disable();
//STRIP001         aFlAlign.Disable();
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void SvxWinOrientation_Impl::SetStackedTxt( BOOL bOnOff )
//STRIP001 {
//STRIP001 	aBtnTxtStacked.Check( bOnOff );
//STRIP001     aCtrDial.SetOrientation( aCtrDial.GetOrientation() );
//STRIP001 
//STRIP001 	if( bOnOff || !aBtnTxtStacked.IsEnabled() )
//STRIP001 	{
//STRIP001 		aCtrDial.Disable();
//STRIP001 		aCtrDial.Invalidate();
//STRIP001 		aOrientFieldLabel.Disable();
//STRIP001 		aOrientField.Disable();
//STRIP001 		aVSLockModeLabel.Disable();
//STRIP001 		aVSLockMode.Disable();
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aCtrDial.Enable();
//STRIP001 		aCtrDial.Invalidate();
//STRIP001 		aOrientFieldLabel.Enable();
//STRIP001 		aOrientField.Enable();
//STRIP001 		aVSLockModeLabel.Enable();
//STRIP001 		aVSLockMode.Enable();
//STRIP001 	}
//STRIP001 
//STRIP001     maTxtStackedClickHdl.Call( this );
//STRIP001 }
//STRIP001 
//STRIP001 void SvxWinOrientation_Impl::SetDegrees( short alpha )
//STRIP001 {
//STRIP001 	aCtrDial.SetOrientation( alpha );
//STRIP001 	aOrientField.SetText( UniString::CreateFromInt32( alpha ) );
//STRIP001 }
//STRIP001 
//STRIP001 void SvxWinOrientation_Impl::SetNoDegrees()
//STRIP001 {
//STRIP001     aCtrDial.SetNoOrientation();
//STRIP001     aOrientField.SetText( UniString() );
//STRIP001     aBtnTxtStacked.Check( FALSE );
//STRIP001     maTxtStackedClickHdl.Call( this );
//STRIP001 }
//STRIP001 
//STRIP001 IMPL_LINK( SvxWinOrientation_Impl, OrientModifyHdl, void*, ctrPtr )
//STRIP001 {
//STRIP001 	if( ctrPtr != NULL )
//STRIP001 	{
//STRIP001 		if(	&aCtrDial == ctrPtr)
//STRIP001 			aOrientField.SetOrientation( aCtrDial.GetOrientation() );
//STRIP001 		else
//STRIP001 		{
//STRIP001 			if(	&aOrientField == ctrPtr)
//STRIP001 			{
//STRIP001 				aCtrDial.SetOrientation( aOrientField.GetOrientation() );
//STRIP001 				aCtrDial.Invalidate();
//STRIP001 				aCtrDial.Update();
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				if( ctrPtr == &aBtnTxtStacked )
//STRIP001 				{
//STRIP001                     aCtrDial.SetOrientation( aCtrDial.GetOrientation() );
//STRIP001 					if( aBtnTxtStacked.IsChecked() )
//STRIP001 					{
//STRIP001 						aBtnTxtStacked.Check( FALSE );
//STRIP001 						aCtrDial.Enable();
//STRIP001 						aCtrDial.Invalidate();
//STRIP001 						aOrientFieldLabel.Enable();
//STRIP001 						aOrientField.Enable();
//STRIP001 						aVSLockModeLabel.Enable();
//STRIP001 						aVSLockMode.Enable();
//STRIP001 					}
//STRIP001 					else
//STRIP001 					{
//STRIP001 						aBtnTxtStacked.Check();
//STRIP001 						aCtrDial.Disable();
//STRIP001 						aCtrDial.Invalidate();
//STRIP001 						aOrientFieldLabel.Disable();
//STRIP001 						aOrientField.Disable();
//STRIP001 						aVSLockModeLabel.Disable();
//STRIP001 						aVSLockMode.Disable();
//STRIP001 					}
//STRIP001                     maTxtStackedClickHdl.Call( this );
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return 0L;
//STRIP001 }
//STRIP001 
//STRIP001 IMPL_LINK( SvxWinOrientation_Impl, LostActiveHdl, void *, ctrPtr )
//STRIP001 {
//STRIP001 	if( ( SvxCtrDial* ) ctrPtr == &aCtrDial )
//STRIP001 		aOrientField.GrabFocus();
//STRIP001 	else if( ( SvxOrientationField* ) ctrPtr == &aOrientField )
//STRIP001 		aOrientField.SetOrientation( aCtrDial.GetOrientation() );
//STRIP001 
//STRIP001 	return 0L ;
//STRIP001 }
//STRIP001 
//STRIP001 void SvxWinOrientation_Impl::Update_BtnTxtStacked_Colors( void )
//STRIP001 {
//STRIP001 	const Image&	rTmpImg = aBtnTxtStacked.GetImage();
//STRIP001 	Bitmap			aTmpBmp( rTmpImg.GetBitmap() );
//STRIP001 
//STRIP001 	Color			aNewColor = rParent.GetSettings().GetStyleSettings().GetButtonTextColor();
//STRIP001 
//STRIP001 	aTmpBmp.Replace( aLast_BtnTxtStacked_Color, aNewColor );
//STRIP001 	aBtnTxtStacked.SetImage( Image( aTmpBmp, rTmpImg.GetMaskColor() ) );
//STRIP001 
//STRIP001 	aLast_BtnTxtStacked_Color = aNewColor;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 SvxWinOrientation::SvxWinOrientation(
//STRIP001 					Window* pParent,
//STRIP001 					const ResId& rResIdForCtrDial,
//STRIP001 					const ResId& rResIdForImageButton,
//STRIP001 					const ResId& rResIdForFixedText,
//STRIP001 					const ResId& rResIdForOrientField,
//STRIP001 					const ResId& rResIdForVSLockModeLabel,
//STRIP001 					const ResId& rResIdForVSLockMode,
//STRIP001                     const ResId& rResIdForFixedLine)
//STRIP001 	: Link(),
//STRIP001 	pImpl( new SvxWinOrientation_Impl( pParent, rResIdForCtrDial, rResIdForImageButton, rResIdForFixedText, rResIdForOrientField, rResIdForVSLockModeLabel, rResIdForVSLockMode, rResIdForFixedLine ) )
//STRIP001 
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 SvxWinOrientation::~SvxWinOrientation()
//STRIP001 {
//STRIP001 	delete pImpl;
//STRIP001 }
//STRIP001 
//STRIP001 void SvxWinOrientation::Enable()
//STRIP001 {
//STRIP001 	pImpl->Enable();
//STRIP001 }
//STRIP001 
//STRIP001 void SvxWinOrientation::Disable()
//STRIP001 {
//STRIP001 	pImpl->Disable();
//STRIP001 }
//STRIP001 
//STRIP001 BOOL SvxWinOrientation::IsEnabled()
//STRIP001 {
//STRIP001 	return pImpl->bFlagEnabled;
//STRIP001 }
//STRIP001 
//STRIP001 BOOL SvxWinOrientation::IsStackedTxt()
//STRIP001 {
//STRIP001 	return pImpl->aBtnTxtStacked.IsChecked();
//STRIP001 }
//STRIP001 
//STRIP001 void SvxWinOrientation::SetStackedTxt( BOOL bOnOff )
//STRIP001 {
//STRIP001 	pImpl->SetStackedTxt( bOnOff );
//STRIP001 }
//STRIP001 
//STRIP001 BOOL SvxWinOrientation::HasDegrees()
//STRIP001 {
//STRIP001     return pImpl->aCtrDial.HasOrientation();
//STRIP001 }
//STRIP001 
//STRIP001 void SvxWinOrientation::SetDegrees( short alpha )
//STRIP001 {
//STRIP001 	pImpl->SetDegrees( alpha );
//STRIP001 }
//STRIP001 
//STRIP001 void SvxWinOrientation::SetNoDegrees()
//STRIP001 {
//STRIP001     pImpl->SetNoDegrees();
//STRIP001 }
//STRIP001 
//STRIP001 short SvxWinOrientation::GetDegrees()
//STRIP001 {
//STRIP001 	return pImpl->aCtrDial.GetOrientation();
//STRIP001 }
//STRIP001 
//STRIP001 SvxRotateMode SvxWinOrientation::GetRotateMode()
//STRIP001 {
//STRIP001 	SvxRotateMode	nRetVal;
//STRIP001 	USHORT			nSelId = pImpl->aVSLockMode.GetSelectItemId();
//STRIP001 
//STRIP001 	switch( nSelId )
//STRIP001 	{
//STRIP001 		case 1:		nRetVal = SVX_ROTATE_MODE_BOTTOM;	break;
//STRIP001 		case 2:		nRetVal = SVX_ROTATE_MODE_TOP;		break;
//STRIP001 		default:	nRetVal = SVX_ROTATE_MODE_STANDARD;	break;
//STRIP001 	}
//STRIP001 
//STRIP001 	return nRetVal;
//STRIP001 }
//STRIP001 
//STRIP001 void SvxWinOrientation::SetRotateMode( SvxRotateMode nVal )
//STRIP001 {
//STRIP001 	short nItem;
//STRIP001 
//STRIP001 	switch( nVal )
//STRIP001 	{
//STRIP001 		case SVX_ROTATE_MODE_BOTTOM:	nItem = 1; break;
//STRIP001 		case SVX_ROTATE_MODE_TOP:		nItem = 2; break;
//STRIP001 		default:						nItem = 3; break;
//STRIP001 	}
//STRIP001 	pImpl->aVSLockMode.SelectItem( nItem );
//STRIP001 }
//STRIP001 
//STRIP001 ValueSet& SvxWinOrientation::GetVSLockMode()
//STRIP001 {
//STRIP001 	return pImpl->aVSLockMode;
//STRIP001 }
//STRIP001 
//STRIP001 BOOL SvxWinOrientation::IsSelRotateMode()
//STRIP001 {
//STRIP001 	return !pImpl->aVSLockMode.IsNoSelection();
//STRIP001 }
//STRIP001 
//STRIP001 void SvxWinOrientation::SetNoSelRotateMode()
//STRIP001 {
//STRIP001     pImpl->aVSLockMode.SetNoSelection();
//STRIP001 }
//STRIP001 
//STRIP001 void SvxWinOrientation::SetTxtStackedClickHdl( const Link& rLink )
//STRIP001 {
//STRIP001     pImpl->maTxtStackedClickHdl = rLink;
//STRIP001 }
//STRIP001 
//STRIP001 const Link& SvxWinOrientation::GetTxtStackedClickHdl() const
//STRIP001 {
//STRIP001     return pImpl->maTxtStackedClickHdl;
//STRIP001 }
//STRIP001 
//STRIP001 void SvxWinOrientation::HandleUpdatedSystemsettings( void )
//STRIP001 {
//STRIP001 	pImpl->Update_BtnTxtStacked_Colors();
//STRIP001 }
}
