/*************************************************************************
 *
 *  $RCSfile: isbxobj.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:45:03 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_ISBXOBJ_HXX
#define _SVX_ISBXOBJ_HXX

// include ---------------------------------------------------------------

#ifndef _AUTO_HXX //autogen
#include <so3/auto.hxx>
#endif

//#include "svxids.hrc"
#include "tstpitem.hxx"
namespace binfilter {

//-------------------------------------------------------------------------

//STRIP001 class SvxTabStopObject_Impl: public SvDispatch
//STRIP001 
//STRIP001 /*	[Beschreibung]
//STRIP001 
//STRIP001 	Diese SbxObject-Subklasse kann Instanzen der Klasse <SvxTabStopsItem>
//STRIP001 	im SBX-System recorden und wieder abspielen. Ein Item mit einem Dezimal-
//STRIP001 	und einem Links-Tab wird wie folgt recorded (das WITH-Statement kommt
//STRIP001 	dabei vom Sfx-Makro-Recorder, nur die Insert-Statements werden hier
//STRIP001 	generiert):
//STRIP001 
//STRIP001 		DIM aTabStops1 AS NEW TabStops
//STRIP001 		WITH aTabStops1
//STRIP001 			Insert( 2343, "D", ",", " " )
//STRIP001 			Insert( 5343, "L", " ", "." )
//STRIP001 		END WITH
//STRIP001 
//STRIP001 	 Die Positionsangaben sind noch in Core-Ma\seinheiten, da ich diese
//STRIP001 	 noch nicht kenne (also nicht umrechnen kann).
//STRIP001 
//STRIP001 	 Desweiteren gibt es die folgenden Sbx-Methoden an diesem Objekt:
//STRIP001 
//STRIP001 		int 	GetCount()
//STRIP001 		long	GetPosition()
//STRIP001 		String	GetAdjust()
//STRIP001 		String	GetDecimalChar()
//STRIP001 		String	GetFillChar()
//STRIP001 
//STRIP001 
//STRIP001 	[Anmerkung]
//STRIP001 
//STRIP001 	SbxObjects, die nur aus einfachen (keine Arrays) Properties bestehen,
//STRIP001 	brauchen nur den Konstruktor implementieren, da die Basisklasse
//STRIP001 	<SbxObject> Properties bereits selbst recorden kann. Notify() ist
//STRIP001 	dann i.d.R. auch automatisch korrekt implemementiert.
//STRIP001 */
//STRIP001 
//STRIP001 {
//STRIP001 	SvxTabStopItem* 		pTabs;	// Container f"ur die TabStops
//STRIP001 	SbxVariableRef			xVar;	// zum Benachrichtigen
//STRIP001 
//STRIP001 private:
//STRIP001 	char					GetAdjustChar( SvxTabAdjust eAdj );
//STRIP001 
//STRIP001 protected:
//STRIP001 	void					SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType,
//STRIP001 									const SfxHint& rHint, const TypeId& rHintType );
//STRIP001 
//STRIP001 public:
//STRIP001 							TYPEINFO();
//STRIP001 							SvxTabStopObject_Impl();
//STRIP001 							SvxTabStopObject_Impl( SbxVariable *pVar,
//STRIP001 												   const SvxTabStopItem &rTabs );
//STRIP001 							~SvxTabStopObject_Impl();
//STRIP001 
//STRIP001 	const SvxTabStopItem&	GetTabStops() const { return *pTabs; }
//STRIP001 
//STRIP001 	virtual String 			GenerateSource( const String &rLinePrefix,
//STRIP001 											const SbxObject *pRelativeTo );
//STRIP001 };


}//end of namespace binfilter
#endif

