/*************************************************************************
 *
 *  $RCSfile: svx_msocximex.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:45:36 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil -*- */

#ifndef _COM_SUN_STAR_UNO_ANY_H_
#include <com/sun/star/uno/Any.h>
#endif
#ifndef _COM_SUN_STAR_TEXT_VERTORIENTATION_HPP_
#include <com/sun/star/text/VertOrientation.hpp>
#endif
#ifndef _COM_SUN_STAR_TEXT_XTEXT_HPP_
#include <com/sun/star/text/XText.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XSERVICEINFO_HDL_
#include <com/sun/star/lang/XServiceInfo.hpp>
#endif
#ifndef _COM_SUN_STAR_TEXT_TEXTCONTENTANCHORTYPE_HPP_
#include <com/sun/star/text/TextContentAnchorType.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_XSHAPE_HPP_
#include <com/sun/star/drawing/XShape.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_XDRAWPAGE_HPP_
#include <com/sun/star/drawing/XDrawPage.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_XSHAPES_HPP_
#include <com/sun/star/drawing/XShapes.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_XCONTROLSHAPE_HPP_
#include <com/sun/star/drawing/XControlShape.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XINDEXCONTAINER_HPP_
#include <com/sun/star/container/XIndexContainer.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_XDRAWPAGESUPPLIER_HPP_
#include <com/sun/star/drawing/XDrawPageSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_FORM_XFORMSSUPPLIER_HPP_
#include <com/sun/star/form/XFormsSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_FORM_XFORM_HPP_
#include <com/sun/star/form/XForm.hpp>
#endif
#ifndef _COM_SUN_STAR_FORM_FORMCOMPONENTTYPE_HPP_
#include <com/sun/star/form/FormComponentType.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_FONTWEIGHT_HPP_
#include <com/sun/star/awt/FontWeight.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_FONTSLANT_HPP_
#include <com/sun/star/awt/FontSlant.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_FONTUNDERLINE_HPP_
#include <com/sun/star/awt/FontUnderline.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_FONTSTRIKEOUT_HPP_
#include <com/sun/star/awt/FontStrikeout.hpp>
#endif
#ifndef _COMPHELPER_EXTRACT_HXX_
#include <comphelper/extract.hxx>
#endif
#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif
#ifndef _SFX_OBJSH_HXX
#include <bf_sfx2/objsh.hxx>
#endif
#ifndef _MSOCXIMEX_HXX
#include "msocximex.hxx"
#endif
namespace binfilter {

#ifndef C2S
#define C2S(cChar)	String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(cChar))
#endif

using namespace ::com::sun::star;
#if 0
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::beans;
using namespace ::com::sun::star::drawing;
using namespace ::com::sun::star::form;
using namespace ::com::sun::star::text;
using namespace ::com::sun::star::container;
#endif
using namespace ::rtl;
using namespace cppu;


#define WW8_ASCII2STR(s) String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(s))


//STRIP001 static char sWW8_form[] = "WW-Standard";
//STRIP001 
//STRIP001 
//STRIP001 sal_uInt8 __READONLY_DATA OCX_Control::aObjInfo[4] = {
//STRIP001 0x00, 0x12, 0x03, 0x00, };
//STRIP001 
//STRIP001 
//STRIP001 void Align(SvStorageStream *pS,int nAmount,BOOL bFill=FALSE)
//STRIP001 {
//STRIP001 	if (pS->Tell()%nAmount)
//STRIP001 	{
//STRIP001 		if (bFill == FALSE)
//STRIP001 			pS->SeekRel(nAmount-(pS->Tell()%nAmount));
//STRIP001 		else
//STRIP001 		{
//STRIP001 		int nLen = nAmount-(pS->Tell()%nAmount);
//STRIP001 		for(int i=0;i<nLen;i++)
//STRIP001 			*pS << sal_uInt8(0x00);
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 sal_uInt16 OCX_Control::nStandardId(0x0200);
//STRIP001 sal_uInt16 OCX_FontData::nStandardId(0x0200);
//STRIP001 
//STRIP001 sal_uInt32 OCX_Control::pColor[25] = {
//STRIP001 0xC0C0C0, 0x008080, 0x000080, 0x808080, 0xC0C0C0, 0xFFFFFF, 0x000000,
//STRIP001 0x000000, 0x000000, 0xFFFFFF, 0xC0C0C0, 0xC0C0C0, 0x808080, 0x000080,
//STRIP001 0xFFFFFF, 0xC0C0C0, 0x808080, 0x808080, 0x000000, 0xC0C0C0, 0xFFFFFF,
//STRIP001 0x000000, 0xC0C0C0, 0x000000, 0xFFFFC0 };
//STRIP001 
//STRIP001 void OCX_Control::FillSystemColors()
//STRIP001 {
//STRIP001     // overwrite the predefined colors with available system colors
//STRIP001     const StyleSettings& rSett = Application::GetSettings().GetStyleSettings();
//STRIP001 
//STRIP001     pColor[ 0x00 ] = rSett.GetFaceColor().GetColor();
//STRIP001     pColor[ 0x01 ] = rSett.GetWorkspaceColor().GetColor();
//STRIP001     pColor[ 0x02 ] = rSett.GetActiveColor().GetColor();
//STRIP001     pColor[ 0x03 ] = rSett.GetDeactiveColor().GetColor();
//STRIP001     pColor[ 0x04 ] = rSett.GetMenuBarColor().GetColor();
//STRIP001     pColor[ 0x05 ] = rSett.GetWindowColor().GetColor();
//STRIP001     pColor[ 0x07 ] = rSett.GetMenuTextColor().GetColor();
//STRIP001     pColor[ 0x08 ] = rSett.GetWindowTextColor().GetColor();
//STRIP001     pColor[ 0x09 ] = rSett.GetActiveTextColor().GetColor();
//STRIP001     pColor[ 0x0A ] = rSett.GetActiveBorderColor().GetColor();
//STRIP001     pColor[ 0x0B ] = rSett.GetDeactiveBorderColor().GetColor();
//STRIP001     pColor[ 0x0C ] = rSett.GetWorkspaceColor().GetColor();
//STRIP001     pColor[ 0x0D ] = rSett.GetHighlightColor().GetColor();
//STRIP001     pColor[ 0x0E ] = rSett.GetHighlightTextColor().GetColor();
//STRIP001     pColor[ 0x0F ] = rSett.GetFaceColor().GetColor();
//STRIP001     pColor[ 0x10 ] = rSett.GetShadowColor().GetColor();
//STRIP001     pColor[ 0x12 ] = rSett.GetButtonTextColor().GetColor();
//STRIP001     pColor[ 0x13 ] = rSett.GetDeactiveTextColor().GetColor();
//STRIP001     pColor[ 0x14 ] = rSett.GetHighlightColor().GetColor();
//STRIP001     pColor[ 0x15 ] = rSett.GetDarkShadowColor().GetColor();
//STRIP001     pColor[ 0x16 ] = rSett.GetShadowColor().GetColor();
//STRIP001     pColor[ 0x17 ] = rSett.GetHelpTextColor().GetColor();
//STRIP001     pColor[ 0x18 ] = rSett.GetHelpColor().GetColor();
//STRIP001 }
//STRIP001 
//STRIP001 sal_uInt32 OCX_Control::ImportColor(sal_uInt32 nColor) const
//STRIP001 {
//STRIP001 	sal_uInt8 nUpper = (sal_uInt8)( nColor >> 24 );
//STRIP001 	if (nUpper & 0x80) //Palette color, should be switch on bottom 24 bits
//STRIP001 	{
//STRIP001 		/*Might as well use my systems ones in the absence of any other ideas*/
//STRIP001 		nColor = nColor&0x00FFFFFF;
//STRIP001 		DBG_ASSERT (nColor <= 24,"Unknown Palette Index");
//STRIP001 		if (nColor > 24)
//STRIP001 			nColor = 0xFFFFFF;
//STRIP001 		else
//STRIP001 			nColor = pColor[nColor];
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		//Stored in bgr! rather than rgb
//STRIP001 		nColor = SwapColor(nColor);
//STRIP001 	}
//STRIP001 	return nColor;
//STRIP001 }
//STRIP001 
//STRIP001 sal_Int16 OCX_FontData::ImportAlign(sal_uInt8 nJustification) const
//STRIP001 {
//STRIP001 	sal_Int16 nRet;
//STRIP001 	switch (nJustification)
//STRIP001 	{
//STRIP001 	default:
//STRIP001 	case 1:
//STRIP001 		nRet = 0;
//STRIP001 		break;
//STRIP001 	case 2:
//STRIP001 		nRet = 2;
//STRIP001 		break;
//STRIP001 	case 3:
//STRIP001 		nRet = 1;
//STRIP001 		break;
//STRIP001 	}
//STRIP001 	return nRet;
//STRIP001 }
//STRIP001 
//STRIP001 sal_uInt8 OCX_FontData::ExportAlign(sal_Int16 nAlign) const
//STRIP001 {
//STRIP001 	sal_Int8 nRet;
//STRIP001 	switch (nAlign)
//STRIP001 	{
//STRIP001 	default:
//STRIP001 	case 0:
//STRIP001 		nRet = 1;
//STRIP001 		break;
//STRIP001 	case 2:
//STRIP001 		nRet = 2;
//STRIP001 		break;
//STRIP001 	case 1:
//STRIP001 		nRet = 3;
//STRIP001 		break;
//STRIP001 	}
//STRIP001 	return nRet;
//STRIP001 }
//STRIP001 
//STRIP001 sal_uInt32 OCX_Control::SwapColor(sal_uInt32 nColor) const
//STRIP001 {
//STRIP001 	sal_uInt8
//STRIP001 		r(static_cast<sal_uInt8>(nColor&0xFF)),
//STRIP001 		g(static_cast<sal_uInt8>(((nColor)>>8)&0xFF)),
//STRIP001 		b(static_cast<sal_uInt8>((nColor>>16)&0xFF));
//STRIP001 	nColor = (r<<16) + (g<<8) + b;
//STRIP001 	return nColor;
//STRIP001 }
//STRIP001 
//STRIP001 sal_uInt32 OCX_Control::ExportColor(sal_uInt32 nColor) const
//STRIP001 {
//STRIP001 	sal_uInt8 nUpper = (sal_uInt8)( nColor >> 24 );
//STRIP001 	if (nUpper & 0x80) //Palette color, should be switch on bottom 24 bits
//STRIP001 	{
//STRIP001 		/*Might as well use my systems ones in the absence of any other ideas*/
//STRIP001 		nColor = nColor&0x00FFFFFF;
//STRIP001 		DBG_ASSERT (nColor <= 24,"Unknown Palette Index");
//STRIP001 		if (nColor > 24)
//STRIP001 			nColor = 0xFFFFFF;
//STRIP001 		else
//STRIP001 			nColor = pColor[nColor];
//STRIP001 	}
//STRIP001 	
//STRIP001 	//Stored in bgr! rather than rgb
//STRIP001 	nColor = SwapColor(nColor);
//STRIP001 	return nColor;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 sal_Int16 OCX_Control::ImportBorder(sal_uInt16 nSpecialEffect,
//STRIP001 	sal_uInt16 nBorderStyle) const
//STRIP001 {
//STRIP001 	if ((nSpecialEffect == 0) && (nBorderStyle == 0))
//STRIP001 		return 0;	//No Border
//STRIP001 	else if ((nSpecialEffect == 0) && (nBorderStyle == 1))
//STRIP001 		return 2;	//Flat Border
//STRIP001 	return 1;	//3D Border
//STRIP001 }
//STRIP001 
//STRIP001 sal_uInt8 OCX_Control::ExportBorder(sal_uInt16 nBorder,sal_uInt8 &rBorderStyle)
//STRIP001 	const
//STRIP001 {
//STRIP001 	sal_uInt8 nRet;
//STRIP001 	switch(nBorder)
//STRIP001 	{
//STRIP001 		case 0:
//STRIP001 			nRet = rBorderStyle = 0;
//STRIP001 			break;
//STRIP001 		default:
//STRIP001 		case 1:
//STRIP001 			nRet = 2;
//STRIP001 			rBorderStyle = 1;
//STRIP001 			break;
//STRIP001 		case 2:
//STRIP001 			nRet = 3;
//STRIP001 			rBorderStyle = 1;
//STRIP001 			break;
//STRIP001 	}
//STRIP001 	return nRet;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 const uno::Reference< drawing::XDrawPage >&
//STRIP001 	SvxMSConvertOCXControls::GetDrawPage()
//STRIP001 {
//STRIP001 	if( !xDrawPage.is() && pDocSh )
//STRIP001 	{
//STRIP001 		uno::Reference< drawing::XDrawPageSupplier > xTxtDoc(pDocSh->GetModel(),
//STRIP001 			uno::UNO_QUERY);
//STRIP001 		DBG_ASSERT(xTxtDoc.is(),"XDrawPageSupplier nicht vom XModel erhalten");
//STRIP001 		xDrawPage = xTxtDoc->getDrawPage();
//STRIP001 		DBG_ASSERT( xDrawPage.is(), "XDrawPage nicht erhalten" );
//STRIP001 	}
//STRIP001 
//STRIP001 	return xDrawPage;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 const uno::Reference< lang::XMultiServiceFactory >&
//STRIP001 	SvxMSConvertOCXControls::GetServiceFactory()
//STRIP001 {
//STRIP001 	if( !xServiceFactory.is() && pDocSh )
//STRIP001 	{
//STRIP001 		xServiceFactory = uno::Reference< lang::XMultiServiceFactory >
//STRIP001 			(pDocSh->GetBaseModel(), uno::UNO_QUERY);
//STRIP001 		DBG_ASSERT( xServiceFactory.is(),
//STRIP001 				"XMultiServiceFactory nicht vom Model erhalten" );
//STRIP001 	}
//STRIP001 
//STRIP001 	return xServiceFactory;
//STRIP001 }
//STRIP001 
//STRIP001 const uno::Reference< drawing::XShapes >& SvxMSConvertOCXControls::GetShapes()
//STRIP001 {
//STRIP001 	if( !xShapes.is() )
//STRIP001 	{
//STRIP001 		GetDrawPage();
//STRIP001 		if( xDrawPage.is() )
//STRIP001 		{
//STRIP001 
//STRIP001 			xShapes = uno::Reference< drawing::XShapes >(xDrawPage,
//STRIP001 				uno::UNO_QUERY);
//STRIP001 			DBG_ASSERT( xShapes.is(), "XShapes nicht vom XDrawPage erhalten" );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return xShapes;
//STRIP001 }
//STRIP001 
//STRIP001 const uno::Reference< container::XIndexContainer >&
//STRIP001 	SvxMSConvertOCXControls::GetFormComps()
//STRIP001 {
//STRIP001 	if( !xFormComps.is() )
//STRIP001 	{
//STRIP001 		GetDrawPage();
//STRIP001 		if( xDrawPage.is() )
//STRIP001 		{
//STRIP001 			uno::Reference< form::XFormsSupplier > xFormsSupplier( xDrawPage,
//STRIP001 				uno::UNO_QUERY );
//STRIP001 			DBG_ASSERT( xFormsSupplier.is(),
//STRIP001 					"XFormsSupplier nicht vom XDrawPage erhalten" );
//STRIP001 
//STRIP001 			uno::Reference< container::XNameContainer >  xNameCont =
//STRIP001 				xFormsSupplier->getForms();
//STRIP001 
//STRIP001 			// Das Formular bekommt einen Namen wie "WW-Standard[n]" und
//STRIP001 			// wird in jedem Fall neu angelegt.
//STRIP001 			UniString sName( sWW8_form, RTL_TEXTENCODING_MS_1252 );
//STRIP001 			sal_uInt16 n = 0;
//STRIP001 
//STRIP001 			while( xNameCont->hasByName( sName ) )
//STRIP001 			{
//STRIP001 				sName.AssignAscii( sWW8_form );
//STRIP001 				sName += String::CreateFromInt32( ++n );
//STRIP001 			}
//STRIP001 
//STRIP001 			const uno::Reference< lang::XMultiServiceFactory > &rServiceFactory
//STRIP001 				= GetServiceFactory();
//STRIP001 			if( !rServiceFactory.is() )
//STRIP001 				return xFormComps;
//STRIP001 
//STRIP001 			uno::Reference< uno::XInterface >  xCreate =
//STRIP001 				rServiceFactory->createInstance(WW8_ASCII2STR(
//STRIP001 					"com.sun.star.form.component.Form"));
//STRIP001 			if( xCreate.is() )
//STRIP001 			{
//STRIP001 				uno::Reference< beans::XPropertySet > xFormPropSet( xCreate,
//STRIP001 					uno::UNO_QUERY );
//STRIP001 
//STRIP001 				uno::Any aTmp(&sName,getCppuType((OUString *)0));
//STRIP001 				xFormPropSet->setPropertyValue( WW8_ASCII2STR("Name"), aTmp );
//STRIP001 
//STRIP001 				uno::Reference< form::XForm > xForm( xCreate, uno::UNO_QUERY );
//STRIP001 				DBG_ASSERT(xForm.is(), "keine Form?")
//STRIP001 
//STRIP001 				uno::Reference< container::XIndexContainer > xForms( xNameCont,
//STRIP001 					uno::UNO_QUERY );
//STRIP001 				DBG_ASSERT( xForms.is(), "XForms nicht erhalten" );
//STRIP001 
//STRIP001 				aTmp.setValue( &xForm,
//STRIP001 					::getCppuType((uno::Reference < form::XForm >*)0));
//STRIP001 				xForms->insertByIndex( xForms->getCount(), aTmp );
//STRIP001 
//STRIP001 				xFormComps = uno::Reference< container::XIndexContainer >
//STRIP001 					(xCreate, uno::UNO_QUERY);
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return xFormComps;
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool OCX_CommandButton::Import(
//STRIP001 	const uno::Reference< lang::XMultiServiceFactory > &rServiceFactory,
//STRIP001 	uno::Reference< form::XFormComponent >  &rFComp,
//STRIP001 	awt::Size &rSz)
//STRIP001 {
//STRIP001 	OUString sServiceName =
//STRIP001 		WW8_ASCII2STR("com.sun.star.form.component.CommandButton");
//STRIP001 	uno::Reference< uno::XInterface > xCreate =
//STRIP001 		rServiceFactory->createInstance( sServiceName );
//STRIP001 	if( !xCreate.is() )
//STRIP001 		return sal_False;
//STRIP001 
//STRIP001 	rFComp = uno::Reference< form::XFormComponent > (xCreate,uno::UNO_QUERY);
//STRIP001 	if( !rFComp.is() )
//STRIP001 		return sal_False;
//STRIP001 
//STRIP001 	uno::Reference< beans::XPropertySet >  xPropSet( xCreate, uno::UNO_QUERY );
//STRIP001 
//STRIP001 	rSz.Width = nWidth;
//STRIP001 	rSz.Height = nHeight;
//STRIP001 
//STRIP001 	uno::Any aTmp(&sName,getCppuType((OUString *)0));
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("Name"), aTmp );
//STRIP001 
//STRIP001 	aTmp <<= ImportColor(nForeColor);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("TextColor"), aTmp);
//STRIP001 
//STRIP001 	aTmp <<= ImportColor(nBackColor);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("BackgroundColor"), aTmp);
//STRIP001 
//STRIP001 	sal_Bool bTemp;
//STRIP001 	if ((!(fEnabled)) || (fLocked))
//STRIP001 		bTemp = sal_False;
//STRIP001 	else
//STRIP001 		bTemp = sal_True;
//STRIP001 	aTmp = bool2any(bTemp);
//STRIP001 
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("Enabled"), aTmp);
//STRIP001 
//STRIP001 	if (pCaption)
//STRIP001 	{
//STRIP001 		UniString sTmp(pCaption,RTL_TEXTENCODING_MS_1252);
//STRIP001 		OUString sStr = sTmp;
//STRIP001 		aTmp.setValue(&sStr,getCppuType((OUString *)0));
//STRIP001 		xPropSet->setPropertyValue( WW8_ASCII2STR("Label"), aTmp);
//STRIP001 	}
//STRIP001 
//STRIP001 	aFontData.Import(xPropSet);
//STRIP001 	return sal_True;
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool OCX_GroupBox::Export(SvStorageRef &rObj,
//STRIP001 	const uno::Reference< beans::XPropertySet > &rPropSet,
//STRIP001 	const awt::Size &rSize)
//STRIP001 {
//STRIP001 	sal_Bool bRet=sal_True;
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool OCX_GroupBox::WriteContents(SvStorageStreamRef &rObj,
//STRIP001 	const uno::Reference< beans::XPropertySet > &rPropSet,
//STRIP001 	const awt::Size &rSize)
//STRIP001 {
//STRIP001 	sal_Bool bRet=sal_True;
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool OCX_CommandButton::WriteContents(SvStorageStreamRef &rContents,
//STRIP001 	const uno::Reference< beans::XPropertySet > &rPropSet,
//STRIP001 	const awt::Size &rSize)
//STRIP001 {
//STRIP001 	sal_Bool bRet=sal_True;
//STRIP001 
//STRIP001     sal_uInt32 nOldPos = rContents->Tell();
//STRIP001 	rContents->SeekRel(8);
//STRIP001 
//STRIP001 	uno::Any aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("TextColor"));
//STRIP001     if (aTmp.hasValue())
//STRIP001 	    aTmp >>= nForeColor;
//STRIP001 	*rContents << ExportColor(nForeColor);
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("BackgroundColor"));
//STRIP001     if (aTmp.hasValue())
//STRIP001 	    aTmp >>= nBackColor;
//STRIP001 	*rContents << ExportColor(nBackColor);
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("Enabled"));
//STRIP001 	fEnabled = any2bool(aTmp);
//STRIP001 	sal_uInt8 nTemp=0;//fEnabled;
//STRIP001 	if (fEnabled)
//STRIP001 		nTemp |= 0x02;
//STRIP001 	*rContents << nTemp;
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("Label"));
//STRIP001 	OUString *pStr = (OUString *)aTmp.getValue();
//STRIP001 
//STRIP001 	nCaptionLen = pStr->getLength();
//STRIP001 	if (nCaptionLen)
//STRIP001 	{
//STRIP001 		nCaptionLen |= 0x80000000;
//STRIP001 		*rContents << nCaptionLen;
//STRIP001 		Align(rContents,4,TRUE);
//STRIP001 		String aTmpStr(*pStr);
//STRIP001 		ByteString sByte(aTmpStr,RTL_TEXTENCODING_MS_1252);
//STRIP001 		rContents->Write(sByte.GetBuffer(),sByte.Len());
//STRIP001 	}
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 
//STRIP001 	*rContents << rSize.Width;
//STRIP001 	*rContents << rSize.Height;
//STRIP001 
//STRIP001     nFixedAreaLen = static_cast<sal_uInt16>(rContents->Tell()-nOldPos-4);
//STRIP001 
//STRIP001 	bRet = aFontData.Export(rContents,rPropSet);
//STRIP001 
//STRIP001     rContents->Seek(nOldPos);
//STRIP001 	*rContents << nStandardId;
//STRIP001 	*rContents << nFixedAreaLen;
//STRIP001 
//STRIP001 	sal_uInt8 nTmp = 0x27;
//STRIP001 	if (nCaptionLen)
//STRIP001 		nTmp |= 0x08;
//STRIP001 	*rContents << nTmp;
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 
//STRIP001 	DBG_ASSERT((rContents.Is() && (SVSTREAM_OK==rContents->GetError())),"damn");
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 sal_Bool OCX_CommandButton::Export(SvStorageRef &rObj,
//STRIP001 	const uno::Reference< beans::XPropertySet > &rPropSet,
//STRIP001 	const awt::Size &rSize)
//STRIP001 {
//STRIP001 	static sal_uInt8 __READONLY_DATA aCompObj[] = {
//STRIP001 			0x01, 0x00, 0xFE, 0xFF, 0x03, 0x0A, 0x00, 0x00,
//STRIP001 			0xFF, 0xFF, 0xFF, 0xFF, 0x40, 0x32, 0x05, 0xD7,
//STRIP001 			0x69, 0xCE, 0xCD, 0x11, 0xA7, 0x77, 0x00, 0xDD,
//STRIP001 			0x01, 0x14, 0x3C, 0x57, 0x22, 0x00, 0x00, 0x00,
//STRIP001 			0x4D, 0x69, 0x63, 0x72, 0x6F, 0x73, 0x6F, 0x66,
//STRIP001 			0x74, 0x20, 0x46, 0x6F, 0x72, 0x6d, 0x73, 0x20,
//STRIP001 			0x32, 0x2e, 0x30, 0x20, 0x43, 0x6F, 0x6D, 0x6D,
//STRIP001 			0x61, 0x6E, 0x64, 0x42, 0x75, 0x74, 0x74, 0x6F,
//STRIP001 			0x6E, 0x00, 0x10, 0x00, 0x00, 0x00, 0x45, 0x6D,
//STRIP001 			0x62, 0x65, 0x64, 0x64, 0x65, 0x64, 0x20, 0x4F,
//STRIP001 			0x62, 0x6A, 0x65, 0x63, 0x74, 0x00, 0x16, 0x00,
//STRIP001 			0x00, 0x00, 0x46, 0x6F, 0x72, 0x6D, 0x73, 0x2E,
//STRIP001 			0x43, 0x6F, 0x6D, 0x6D, 0x61, 0x6E, 0x64, 0x42,
//STRIP001 			0x75, 0x74, 0x74, 0x6F, 0x6E, 0x2E, 0x31, 0x00,
//STRIP001 			0xF4, 0x39, 0xB2, 0x71, 0x00, 0x00, 0x00, 0x00,
//STRIP001 			0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
//STRIP001 		};
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor( rObj->OpenStream( C2S("\1CompObj")));
//STRIP001 	xStor->Write(aCompObj,sizeof(aCompObj));
//STRIP001 	DBG_ASSERT((xStor.Is() && (SVSTREAM_OK == xStor->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor3( rObj->OpenStream( C2S("\3ObjInfo")));
//STRIP001 	xStor3->Write(aObjInfo,sizeof(aObjInfo));
//STRIP001 	DBG_ASSERT((xStor3.Is() && (SVSTREAM_OK == xStor3->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	static sal_uInt8 __READONLY_DATA aOCXNAME[] = {
//STRIP001 		0x43, 0x00, 0x6F, 0x00, 0x6D, 0x00, 0x6D, 0x00,
//STRIP001 		0x61, 0x00, 0x6E, 0x00, 0x64, 0x00, 0x42, 0x00,
//STRIP001 		0x75, 0x00, 0x74, 0x00, 0x74, 0x00, 0x6F, 0x00,
//STRIP001 		0x6E, 0x00, 0x31, 0x00, 0x00, 0x00, 0x00, 0x00
//STRIP001 	};
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor2( rObj->OpenStream( C2S("\3OCXNAME")));
//STRIP001 	xStor2->Write(aOCXNAME,sizeof(aOCXNAME));
//STRIP001 	DBG_ASSERT((xStor2.Is() && (SVSTREAM_OK == xStor2->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	SvStorageStreamRef xContents( rObj->OpenStream( C2S("contents")));
//STRIP001 
//STRIP001 	return WriteContents(xContents,rPropSet,rSize);
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool OCX_ImageButton::WriteContents(SvStorageStreamRef &rContents,
//STRIP001 	const uno::Reference< beans::XPropertySet > &rPropSet,
//STRIP001 	const awt::Size &rSize)
//STRIP001 {
//STRIP001 	sal_Bool bRet=sal_True;
//STRIP001 
//STRIP001     sal_uInt32 nOldPos = rContents->Tell();
//STRIP001 	rContents->SeekRel(8);
//STRIP001 
//STRIP001 	uno::Any aTmp=rPropSet->getPropertyValue(WW8_ASCII2STR("BackgroundColor"));
//STRIP001     if (aTmp.hasValue())
//STRIP001 	    aTmp >>= nBackColor;
//STRIP001 	*rContents << ExportColor(nBackColor);
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("Enabled"));
//STRIP001 	fEnabled = any2bool(aTmp);
//STRIP001 	sal_uInt8 nTemp=0;//fEnabled;
//STRIP001 	if (fEnabled)
//STRIP001 		nTemp |= 0x02;
//STRIP001 	*rContents << nTemp;
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 
//STRIP001 	*rContents << rSize.Width;
//STRIP001 	*rContents << rSize.Height;
//STRIP001 
//STRIP001     nFixedAreaLen = static_cast<sal_uInt16>(rContents->Tell()-nOldPos-4);
//STRIP001 
//STRIP001 	bRet = aFontData.Export(rContents,rPropSet);
//STRIP001 
//STRIP001     rContents->Seek(nOldPos);
//STRIP001 	*rContents << nStandardId;
//STRIP001 	*rContents << nFixedAreaLen;
//STRIP001 
//STRIP001 	sal_uInt8 nTmp = 0x26;
//STRIP001 	*rContents << nTmp;
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 
//STRIP001 	DBG_ASSERT((rContents.Is() && (SVSTREAM_OK==rContents->GetError())),"damn");
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 sal_Bool OCX_ImageButton::Export(SvStorageRef &rObj,
//STRIP001 	const uno::Reference< beans::XPropertySet > &rPropSet,
//STRIP001 	const awt::Size &rSize)
//STRIP001 {
//STRIP001 	static sal_uInt8 __READONLY_DATA aCompObj[] = {
//STRIP001 			0x01, 0x00, 0xFE, 0xFF, 0x03, 0x0A, 0x00, 0x00,
//STRIP001 			0xFF, 0xFF, 0xFF, 0xFF, 0x40, 0x32, 0x05, 0xD7,
//STRIP001 			0x69, 0xCE, 0xCD, 0x11, 0xA7, 0x77, 0x00, 0xDD,
//STRIP001 			0x01, 0x14, 0x3C, 0x57, 0x22, 0x00, 0x00, 0x00,
//STRIP001 			0x4D, 0x69, 0x63, 0x72, 0x6F, 0x73, 0x6F, 0x66,
//STRIP001 			0x74, 0x20, 0x46, 0x6F, 0x72, 0x6d, 0x73, 0x20,
//STRIP001 			0x32, 0x2e, 0x30, 0x20, 0x43, 0x6F, 0x6D, 0x6D,
//STRIP001 			0x61, 0x6E, 0x64, 0x42, 0x75, 0x74, 0x74, 0x6F,
//STRIP001 			0x6E, 0x00, 0x10, 0x00, 0x00, 0x00, 0x45, 0x6D,
//STRIP001 			0x62, 0x65, 0x64, 0x64, 0x65, 0x64, 0x20, 0x4F,
//STRIP001 			0x62, 0x6A, 0x65, 0x63, 0x74, 0x00, 0x16, 0x00,
//STRIP001 			0x00, 0x00, 0x46, 0x6F, 0x72, 0x6D, 0x73, 0x2E,
//STRIP001 			0x43, 0x6F, 0x6D, 0x6D, 0x61, 0x6E, 0x64, 0x42,
//STRIP001 			0x75, 0x74, 0x74, 0x6F, 0x6E, 0x2E, 0x31, 0x00,
//STRIP001 			0xF4, 0x39, 0xB2, 0x71, 0x00, 0x00, 0x00, 0x00,
//STRIP001 			0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
//STRIP001 		};
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor( rObj->OpenStream( C2S("\1CompObj")));
//STRIP001 	xStor->Write(aCompObj,sizeof(aCompObj));
//STRIP001 	DBG_ASSERT((xStor.Is() && (SVSTREAM_OK == xStor->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor3( rObj->OpenStream( C2S("\3ObjInfo")));
//STRIP001 	xStor3->Write(aObjInfo,sizeof(aObjInfo));
//STRIP001 	DBG_ASSERT((xStor3.Is() && (SVSTREAM_OK == xStor3->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	static sal_uInt8 __READONLY_DATA aOCXNAME[] = {
//STRIP001 		0x43, 0x00, 0x6F, 0x00, 0x6D, 0x00, 0x6D, 0x00,
//STRIP001 		0x61, 0x00, 0x6E, 0x00, 0x64, 0x00, 0x42, 0x00,
//STRIP001 		0x75, 0x00, 0x74, 0x00, 0x74, 0x00, 0x6F, 0x00,
//STRIP001 		0x6E, 0x00, 0x31, 0x00, 0x00, 0x00, 0x00, 0x00
//STRIP001 	};
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor2( rObj->OpenStream( C2S("\3OCXNAME")));
//STRIP001 	xStor2->Write(aOCXNAME,sizeof(aOCXNAME));
//STRIP001 	DBG_ASSERT((xStor2.Is() && (SVSTREAM_OK == xStor2->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	SvStorageStreamRef xContents( rObj->OpenStream( C2S("contents")));
//STRIP001 	return WriteContents(xContents,rPropSet,rSize);
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 sal_Bool OCX_OptionButton::Import(
//STRIP001 	const uno::Reference< lang::XMultiServiceFactory > &rServiceFactory,
//STRIP001 	uno::Reference< form::XFormComponent > &rFComp, awt::Size &rSz)
//STRIP001 {
//STRIP001 	OUString sServiceName =
//STRIP001 		WW8_ASCII2STR("com.sun.star.form.component.RadioButton");
//STRIP001 	uno::Reference< uno::XInterface >  xCreate =
//STRIP001 		rServiceFactory->createInstance( sServiceName );
//STRIP001 	if( !xCreate.is() )
//STRIP001 		return sal_False;
//STRIP001 
//STRIP001 	rFComp = uno::Reference< form::XFormComponent > (xCreate,uno::UNO_QUERY);
//STRIP001 	if( !rFComp.is() )
//STRIP001 		return sal_False;
//STRIP001 
//STRIP001 	uno::Reference< beans::XPropertySet >  xPropSet(xCreate,uno::UNO_QUERY);
//STRIP001 
//STRIP001 	rSz.Width = nWidth;
//STRIP001 	rSz.Height = nHeight;
//STRIP001 
//STRIP001 	uno::Any aTmp(&sName,getCppuType((OUString *)0));
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("Name"), aTmp );
//STRIP001 
//STRIP001 	sal_Bool bTemp;
//STRIP001 	if ((!(fEnabled)) || (fLocked))
//STRIP001 		bTemp = sal_False;
//STRIP001 	else
//STRIP001 		bTemp = sal_True;
//STRIP001 	aTmp = bool2any(bTemp);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("Enabled"), aTmp);
//STRIP001 
//STRIP001 	aTmp <<= ImportColor(nForeColor);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("TextColor"), aTmp);
//STRIP001 
//STRIP001 	if (pValue)
//STRIP001 	{
//STRIP001 		INT16 nTmp = pValue[0]-0x30;
//STRIP001 		aTmp <<= nTmp;
//STRIP001 		xPropSet->setPropertyValue( WW8_ASCII2STR("DefaultState"), aTmp);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pCaption)
//STRIP001 	{
//STRIP001 		UniString sTmp(pCaption,RTL_TEXTENCODING_MS_1252);
//STRIP001 		OUString sStr = sTmp;
//STRIP001 		aTmp.setValue(&sStr,getCppuType((OUString *)0));
//STRIP001 		xPropSet->setPropertyValue( WW8_ASCII2STR("Label"), aTmp);
//STRIP001 	}
//STRIP001 
//STRIP001 	aFontData.Import(xPropSet);
//STRIP001 	return sal_True;
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool OCX_OptionButton::WriteContents(SvStorageStreamRef &rContents,
//STRIP001 	const uno::Reference< beans::XPropertySet > &rPropSet,
//STRIP001 	const awt::Size &rSize)
//STRIP001 {
//STRIP001 	sal_Bool bRet=sal_True;
//STRIP001 
//STRIP001     sal_uInt32 nOldPos = rContents->Tell();
//STRIP001 	rContents->SeekRel(12);
//STRIP001 
//STRIP001 	pBlockFlags[0] = 0;
//STRIP001 	pBlockFlags[1] = 0x01;
//STRIP001 	pBlockFlags[2] = 0;
//STRIP001 	pBlockFlags[3] = 0x80;
//STRIP001 	pBlockFlags[4] = 0;
//STRIP001 	pBlockFlags[5] = 0;
//STRIP001 	pBlockFlags[6] = 0;
//STRIP001 	pBlockFlags[7] = 0;
//STRIP001 
//STRIP001 	uno::Any aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("Enabled"));
//STRIP001 	fEnabled = any2bool(aTmp);
//STRIP001 	sal_uInt8 nTemp=0;//=fEnabled;
//STRIP001 	if (fEnabled)
//STRIP001 		nTemp |= 0x02;
//STRIP001 	*rContents << nTemp;
//STRIP001 	pBlockFlags[0] |= 0x01;
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("TextColor"));
//STRIP001     if (aTmp.hasValue())
//STRIP001 	    aTmp >>= nForeColor;
//STRIP001 	*rContents << ExportColor(nForeColor);
//STRIP001 	pBlockFlags[0] |= 0x04;
//STRIP001 
//STRIP001 	nStyle = 5;
//STRIP001 	*rContents << nStyle;
//STRIP001 	pBlockFlags[0] |= 0x40;
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 	nValueLen = 1|0x80000000;
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("DefaultState"));
//STRIP001 	INT16 nDefault;
//STRIP001 	aTmp >>= nDefault;
//STRIP001 	*rContents << nValueLen;
//STRIP001 	pBlockFlags[2] |= 0x40;
//STRIP001 
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("Label"));
//STRIP001 	OUString *pStr = (OUString *)aTmp.getValue();
//STRIP001 	nCaptionLen = pStr->getLength();
//STRIP001 	ByteString sByte;
//STRIP001 	if (nCaptionLen)
//STRIP001 	{
//STRIP001 		Align(rContents,4,TRUE);
//STRIP001 		nCaptionLen |= 0x80000000;
//STRIP001 		*rContents << nCaptionLen;
//STRIP001 		pBlockFlags[2] |= 0x80;
//STRIP001 		sByte = ByteString(String(*pStr),RTL_TEXTENCODING_MS_1252);
//STRIP001 	}
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 	*rContents << rSize.Width;
//STRIP001 	*rContents << rSize.Height;
//STRIP001 
//STRIP001 	nDefault += 0x30;
//STRIP001 	*rContents << sal_uInt8(nDefault);
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 	if (nCaptionLen)
//STRIP001 		rContents->Write(sByte.GetBuffer(),sByte.Len());
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001     nFixedAreaLen = static_cast<sal_uInt16>(rContents->Tell()-nOldPos-4);
//STRIP001 	bRet = aFontData.Export(rContents,rPropSet);
//STRIP001 
//STRIP001     rContents->Seek(nOldPos);
//STRIP001 	*rContents << nStandardId;
//STRIP001 	*rContents << nFixedAreaLen;
//STRIP001 
//STRIP001 	*rContents << pBlockFlags[0];
//STRIP001 	*rContents << pBlockFlags[1];
//STRIP001 	*rContents << pBlockFlags[2];
//STRIP001 	*rContents << pBlockFlags[3];
//STRIP001 	*rContents << pBlockFlags[4];
//STRIP001 	*rContents << pBlockFlags[5];
//STRIP001 	*rContents << pBlockFlags[6];
//STRIP001 	*rContents << pBlockFlags[7];
//STRIP001 
//STRIP001 	DBG_ASSERT((rContents.Is() &&
//STRIP001 		(SVSTREAM_OK==rContents->GetError())),"damn");
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 sal_Bool OCX_OptionButton::Export(SvStorageRef &rObj,
//STRIP001 	const uno::Reference< beans::XPropertySet > &rPropSet,
//STRIP001 	const awt::Size &rSize)
//STRIP001 {
//STRIP001 	static sal_uInt8 __READONLY_DATA aCompObj[] = {
//STRIP001 		0x01, 0x00, 0xFE, 0xFF, 0x03, 0x0A, 0x00, 0x00,
//STRIP001 		0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0x1D, 0xD2, 0x8B,
//STRIP001 		0x42, 0xEC, 0xCE, 0x11, 0x9E, 0x0D, 0x00, 0xAA,
//STRIP001 		0x00, 0x60, 0x02, 0xF3, 0x21, 0x00, 0x00, 0x00,
//STRIP001 		0x4D, 0x69, 0x63, 0x72, 0x6F, 0x73, 0x6F, 0x66,
//STRIP001 		0x74, 0x20, 0x46, 0x6F, 0x72, 0x6D, 0x73, 0x20,
//STRIP001 		0x32, 0x2E, 0x30, 0x20, 0x4F, 0x70, 0x74, 0x69,
//STRIP001 		0x6F, 0x6E, 0x42, 0x75, 0x74, 0x74, 0x6F, 0x6E,
//STRIP001 		0x00, 0x10, 0x00, 0x00, 0x00, 0x45, 0x6D, 0x62,
//STRIP001 		0x65, 0x64, 0x64, 0x65, 0x64, 0x20, 0x4F, 0x62,
//STRIP001 		0x6A, 0x65, 0x63, 0x74, 0x00, 0x15, 0x00, 0x00,
//STRIP001 		0x00, 0x46, 0x6F, 0x72, 0x6D, 0x73, 0x2E, 0x4F,
//STRIP001 		0x70, 0x74, 0x69, 0x6F, 0x6E, 0x42, 0x75, 0x74,
//STRIP001 		0x74, 0x6F, 0x6E, 0x2E, 0x31, 0x00, 0xF4, 0x39,
//STRIP001 		0xB2, 0x71, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
//STRIP001 		0x00, 0x00, 0x00, 0x00, 0x00, 0x00
//STRIP001 		};
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor( rObj->OpenStream( C2S("\1CompObj")));
//STRIP001 	xStor->Write(aCompObj,sizeof(aCompObj));
//STRIP001 	DBG_ASSERT((xStor.Is() && (SVSTREAM_OK == xStor->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor3( rObj->OpenStream( C2S("\3ObjInfo")));
//STRIP001 	xStor3->Write(aObjInfo,sizeof(aObjInfo));
//STRIP001 	DBG_ASSERT((xStor3.Is() && (SVSTREAM_OK == xStor3->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	static sal_uInt8 __READONLY_DATA aOCXNAME[] = {
//STRIP001 			0x4F, 0x00, 0x70, 0x00, 0x74, 0x00, 0x69, 0x00,
//STRIP001 			0x6F, 0x00, 0x6E, 0x00, 0x42, 0x00, 0x75, 0x00,
//STRIP001 			0x74, 0x00, 0x74, 0x00, 0x6F, 0x00, 0x6E, 0x00,
//STRIP001 			0x31, 0x00, 0x00, 0x00, 0x00, 0x00
//STRIP001 			};
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor2( rObj->OpenStream( C2S("\3OCXNAME")));
//STRIP001 	xStor2->Write(aOCXNAME,sizeof(aOCXNAME));
//STRIP001 	DBG_ASSERT((xStor2.Is() && (SVSTREAM_OK == xStor2->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	SvStorageStreamRef xContents( rObj->OpenStream( C2S("contents")));
//STRIP001 	return WriteContents(xContents, rPropSet, rSize);
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 sal_Bool OCX_TextBox::Import(
//STRIP001 	const uno::Reference< lang::XMultiServiceFactory > &rServiceFactory,
//STRIP001 	uno::Reference< form::XFormComponent >  &rFComp, awt::Size &rSz)
//STRIP001 {
//STRIP001 	OUString sServiceName =
//STRIP001 		WW8_ASCII2STR("com.sun.star.form.component.TextField");
//STRIP001 	uno::Reference< uno::XInterface >  xCreate =
//STRIP001 		rServiceFactory->createInstance( sServiceName );
//STRIP001 	if( !xCreate.is() )
//STRIP001 		return sal_False;
//STRIP001 
//STRIP001 	rFComp = uno::Reference< form::XFormComponent > (xCreate,uno::UNO_QUERY);
//STRIP001 	if( !rFComp.is() )
//STRIP001 		return sal_False;
//STRIP001 
//STRIP001 	uno::Reference< beans::XPropertySet >  xPropSet( xCreate, uno::UNO_QUERY );
//STRIP001 
//STRIP001 	rSz.Width = nWidth;
//STRIP001 	rSz.Height = nHeight;
//STRIP001 
//STRIP001 	uno::Any aTmp(&sName,getCppuType((OUString *)0));
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("Name"), aTmp );
//STRIP001 
//STRIP001 	sal_Bool bTemp;
//STRIP001 	if (fEnabled)
//STRIP001 		bTemp = sal_True;
//STRIP001 	else
//STRIP001 		bTemp = sal_False;
//STRIP001 	aTmp = bool2any(bTemp);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("Enabled"), aTmp);
//STRIP001 
//STRIP001 	if (fLocked)
//STRIP001 		bTemp = sal_True;
//STRIP001 	else
//STRIP001 		bTemp = sal_False;
//STRIP001 	aTmp = bool2any(bTemp);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("ReadOnly"), aTmp);
//STRIP001 
//STRIP001 
//STRIP001 	aTmp <<= ImportColor(nForeColor);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("TextColor"), aTmp);
//STRIP001 
//STRIP001 	aTmp <<= ImportColor(nBackColor);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("BackgroundColor"), aTmp);
//STRIP001 
//STRIP001 	sal_Bool bTmp=fMultiLine;
//STRIP001 	aTmp = bool2any(bTmp);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("MultiLine"), aTmp);
//STRIP001 
//STRIP001 	sal_uInt16 nTmp = static_cast<sal_uInt16>(nMaxLength);
//STRIP001 	aTmp <<= nTmp;
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("MaxTextLen"), aTmp);
//STRIP001 
//STRIP001 
//STRIP001 	sal_Bool bTemp1,bTemp2;
//STRIP001 	uno::Any aBarsH,aBarsV;
//STRIP001 	switch(nScrollBars)
//STRIP001 	{
//STRIP001 		case 1:
//STRIP001 			bTemp1 = sal_True;
//STRIP001 			bTemp2 = sal_False;
//STRIP001 			break;
//STRIP001 		case 2:
//STRIP001 			bTemp1 = sal_False;
//STRIP001 			bTemp2 = sal_True;
//STRIP001 			break;
//STRIP001 		case 3:
//STRIP001 			bTemp1 = sal_True;
//STRIP001 			bTemp2 = sal_True;
//STRIP001 			break;
//STRIP001 		case 0:
//STRIP001 		default:
//STRIP001 			bTemp1 = sal_False;
//STRIP001 			bTemp2 = sal_False;
//STRIP001 			break;
//STRIP001 	}
//STRIP001 
//STRIP001 	aBarsH = bool2any(bTemp1);
//STRIP001 	aBarsV = bool2any(bTemp2);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("HScroll"), aBarsH);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("VScroll"), aBarsV);
//STRIP001 
//STRIP001 	nTmp = nPasswordChar;
//STRIP001 	aTmp <<= nTmp;
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("EchoChar"), aTmp);
//STRIP001 
//STRIP001 
//STRIP001 	aTmp <<= ImportBorder(nSpecialEffect,nBorderStyle);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("Border"), aTmp);
//STRIP001 
//STRIP001 
//STRIP001 	if (pValue)
//STRIP001 	{
//STRIP001 		UniString sTmp(pValue,RTL_TEXTENCODING_MS_1252);
//STRIP001 		OUString sStr = sTmp;
//STRIP001 		aTmp.setValue(&sStr,getCppuType((OUString *)0));
//STRIP001 		xPropSet->setPropertyValue( WW8_ASCII2STR("DefaultText"), aTmp);
//STRIP001 	}
//STRIP001 
//STRIP001 	aFontData.Import(xPropSet);
//STRIP001 	return sal_True;
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool OCX_TextBox::WriteContents(SvStorageStreamRef &rContents,
//STRIP001 	const uno::Reference< beans::XPropertySet > &rPropSet,
//STRIP001 	const awt::Size &rSize)
//STRIP001 {
//STRIP001 	sal_Bool bRet=sal_True;
//STRIP001     sal_uInt32 nOldPos = rContents->Tell();
//STRIP001 	rContents->SeekRel(12);
//STRIP001 
//STRIP001 	pBlockFlags[0] = 0;
//STRIP001 	pBlockFlags[1] = 0x01;
//STRIP001 	pBlockFlags[2] = 0x00;
//STRIP001 	pBlockFlags[3] = 0x80;
//STRIP001 	pBlockFlags[4] = 0;
//STRIP001 	pBlockFlags[5] = 0;
//STRIP001 	pBlockFlags[6] = 0;
//STRIP001 	pBlockFlags[7] = 0;
//STRIP001 
//STRIP001 
//STRIP001 	sal_uInt8 nTemp=0x19;
//STRIP001 	uno::Any aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("Enabled"));
//STRIP001 	fEnabled = any2bool(aTmp);
//STRIP001 	if (fEnabled)
//STRIP001 		nTemp |= 0x02;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("ReadOnly"));
//STRIP001 	fLocked = any2bool(aTmp);
//STRIP001 	if (fLocked)
//STRIP001 		nTemp |= 0x04;
//STRIP001 
//STRIP001 	*rContents << nTemp;
//STRIP001 	pBlockFlags[0] |= 0x01;
//STRIP001 	*rContents << sal_uInt8(0x48);
//STRIP001 	*rContents << sal_uInt8(0x80);
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("MultiLine"));
//STRIP001 	fMultiLine = any2bool(aTmp);
//STRIP001 	nTemp = 0x2C;
//STRIP001 	if (fMultiLine)
//STRIP001 		nTemp |= 0x80;
//STRIP001 	*rContents << nTemp;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("BackgroundColor"));
//STRIP001     if (aTmp.hasValue())
//STRIP001 	    aTmp >>= nBackColor;
//STRIP001 	*rContents << ExportColor(nBackColor);
//STRIP001 	pBlockFlags[0] |= 0x02;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("TextColor"));
//STRIP001     if (aTmp.hasValue())
//STRIP001 	    aTmp >>= nForeColor;
//STRIP001 	*rContents << ExportColor(nForeColor);
//STRIP001 	pBlockFlags[0] |= 0x04;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue( WW8_ASCII2STR("MaxTextLen"));
//STRIP001 	aTmp >>= nMaxLength;
//STRIP001 	*rContents << nMaxLength;
//STRIP001 	pBlockFlags[0] |= 0x08;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("Border"));
//STRIP001 	sal_Int16 nBorder;
//STRIP001 	aTmp >>= nBorder;
//STRIP001 	nSpecialEffect = ExportBorder(nBorder,nBorderStyle);
//STRIP001 	*rContents << nBorderStyle;
//STRIP001 	pBlockFlags[0] |= 0x10;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue( WW8_ASCII2STR("HScroll"));
//STRIP001 	sal_Bool bTemp1 = any2bool(aTmp);
//STRIP001 	aTmp = rPropSet->getPropertyValue( WW8_ASCII2STR("VScroll"));
//STRIP001 	sal_Bool bTemp2 = any2bool(aTmp);
//STRIP001 	if (!bTemp1 && !bTemp2)
//STRIP001 		nScrollBars =0;
//STRIP001 	else if (bTemp1 && bTemp2)
//STRIP001 		nScrollBars = 3;
//STRIP001 	else if (!bTemp1 && bTemp2)
//STRIP001 		nScrollBars = 2;
//STRIP001 	else
//STRIP001 		nScrollBars = 1;
//STRIP001 	*rContents << nScrollBars;
//STRIP001 	pBlockFlags[0] |= 0x20;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("EchoChar"));
//STRIP001 	sal_uInt16 nTmp;
//STRIP001 	aTmp >>= nTmp;
//STRIP001 	nPasswordChar = static_cast<sal_uInt8>(nTmp);
//STRIP001 	*rContents << nPasswordChar;
//STRIP001 	pBlockFlags[1] |= 0x02;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("DefaultText"));
//STRIP001 	OUString *pStr = (OUString *)aTmp.getValue();
//STRIP001 	nValueLen = pStr->getLength();
//STRIP001 	ByteString sByte;
//STRIP001 	if (nValueLen)
//STRIP001 	{
//STRIP001 		Align(rContents,4,TRUE);
//STRIP001 		nValueLen |= 0x80000000;
//STRIP001 		*rContents << nValueLen;
//STRIP001 		pBlockFlags[2] |= 0x40;
//STRIP001 		sByte = ByteString(String(*pStr),RTL_TEXTENCODING_MS_1252);
//STRIP001 	}
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 	*rContents << nSpecialEffect;
//STRIP001 	pBlockFlags[3] |= 0x04;
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 	*rContents << rSize.Width;
//STRIP001 	*rContents << rSize.Height;
//STRIP001 
//STRIP001 	if (nValueLen)
//STRIP001 		rContents->Write(sByte.GetBuffer(),sByte.Len());
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 
//STRIP001     nFixedAreaLen = static_cast<sal_uInt16>(rContents->Tell()-nOldPos-4);
//STRIP001 
//STRIP001 	bRet = aFontData.Export(rContents,rPropSet);
//STRIP001 
//STRIP001     rContents->Seek(nOldPos);
//STRIP001 	*rContents << nStandardId;
//STRIP001 	*rContents << nFixedAreaLen;
//STRIP001 
//STRIP001 	*rContents << pBlockFlags[0];
//STRIP001 	*rContents << pBlockFlags[1];
//STRIP001 	*rContents << pBlockFlags[2];
//STRIP001 	*rContents << pBlockFlags[3];
//STRIP001 	*rContents << pBlockFlags[4];
//STRIP001 	*rContents << pBlockFlags[5];
//STRIP001 	*rContents << pBlockFlags[6];
//STRIP001 	*rContents << pBlockFlags[7];
//STRIP001 
//STRIP001 	DBG_ASSERT((rContents.Is() &&
//STRIP001 		(SVSTREAM_OK == rContents->GetError())),"damn");
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 sal_Bool OCX_TextBox::Export(SvStorageRef &rObj,
//STRIP001 	const uno::Reference< beans::XPropertySet > &rPropSet,
//STRIP001 	const awt::Size &rSize)
//STRIP001 {
//STRIP001 	static sal_uInt8 __READONLY_DATA aCompObj[] = {
//STRIP001 		0x01, 0x00, 0xFE, 0xFF, 0x03, 0x0A, 0x00, 0x00,
//STRIP001 		0xFF, 0xFF, 0xFF, 0xFF, 0x10, 0x1D, 0xD2, 0x8B,
//STRIP001 		0x42, 0xEC, 0xCE, 0x11, 0x9E, 0x0D, 0x00, 0xAA,
//STRIP001 		0x00, 0x60, 0x02, 0xF3, 0x1C, 0x00, 0x00, 0x00,
//STRIP001 		0x4D, 0x69, 0x63, 0x72, 0x6F, 0x73, 0x6F, 0x66,
//STRIP001 		0x74, 0x20, 0x46, 0x6F, 0x72, 0x6D, 0x73, 0x20,
//STRIP001 		0x32, 0x2E, 0x30, 0x20, 0x54, 0x65, 0x78, 0x74,
//STRIP001 		0x42, 0x6F, 0x78, 0x00, 0x10, 0x00, 0x00, 0x00,
//STRIP001 		0x45, 0x6D, 0x62, 0x65, 0x64, 0x64, 0x65, 0x64,
//STRIP001 		0x20, 0x4F, 0x62, 0x6A, 0x65, 0x63, 0x74, 0x00,
//STRIP001 		0x10, 0x00, 0x00, 0x00, 0x46, 0x6F, 0x72, 0x6D,
//STRIP001 		0x73, 0x2E, 0x54, 0x65, 0x78, 0x74, 0x42, 0x6F,
//STRIP001 		0x78, 0x2E, 0x31, 0x00, 0xF4, 0x39, 0xB2, 0x71,
//STRIP001 		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
//STRIP001 		0x00, 0x00, 0x00, 0x00
//STRIP001 		};
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor( rObj->OpenStream( C2S("\1CompObj")));
//STRIP001 	xStor->Write(aCompObj,sizeof(aCompObj));
//STRIP001 	DBG_ASSERT((xStor.Is() && (SVSTREAM_OK == xStor->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor3( rObj->OpenStream( C2S("\3ObjInfo")));
//STRIP001 	xStor3->Write(aObjInfo,sizeof(aObjInfo));
//STRIP001 	DBG_ASSERT((xStor3.Is() && (SVSTREAM_OK == xStor3->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	static sal_uInt8 __READONLY_DATA aOCXNAME[] = {
//STRIP001 		0x54, 0x00, 0x65, 0x00, 0x78, 0x00, 0x74, 0x00,
//STRIP001 		0x42, 0x00, 0x6F, 0x00, 0x78, 0x00, 0x31, 0x00,
//STRIP001 		0x00, 0x00, 0x00, 0x00
//STRIP001 		};
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor2( rObj->OpenStream( C2S("\3OCXNAME")));
//STRIP001 	xStor2->Write(aOCXNAME,sizeof(aOCXNAME));
//STRIP001 	DBG_ASSERT((xStor2.Is() && (SVSTREAM_OK == xStor2->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	SvStorageStreamRef xContents( rObj->OpenStream( C2S("contents")));
//STRIP001 	return WriteContents(xContents, rPropSet, rSize);
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool OCX_FieldControl::WriteContents(SvStorageStreamRef &rContents,
//STRIP001 	const uno::Reference< beans::XPropertySet > &rPropSet,
//STRIP001 	const awt::Size &rSize)
//STRIP001 {
//STRIP001 	sal_Bool bRet=sal_True;
//STRIP001     sal_uInt32 nOldPos = rContents->Tell();
//STRIP001 	rContents->SeekRel(12);
//STRIP001 
//STRIP001 	pBlockFlags[0] = 0;
//STRIP001 	pBlockFlags[1] = 0x01;
//STRIP001 	pBlockFlags[2] = 0x00;
//STRIP001 	pBlockFlags[3] = 0x80;
//STRIP001 	pBlockFlags[4] = 0;
//STRIP001 	pBlockFlags[5] = 0;
//STRIP001 	pBlockFlags[6] = 0;
//STRIP001 	pBlockFlags[7] = 0;
//STRIP001 
//STRIP001 
//STRIP001 	sal_uInt8 nTemp=0x19;
//STRIP001 	uno::Any aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("Enabled"));
//STRIP001 	fEnabled = any2bool(aTmp);
//STRIP001 	if (fEnabled)
//STRIP001 		nTemp |= 0x02;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("ReadOnly"));
//STRIP001 	fLocked = any2bool(aTmp);
//STRIP001 	if (fLocked)
//STRIP001 		nTemp |= 0x04;
//STRIP001 
//STRIP001 	*rContents << nTemp;
//STRIP001 	pBlockFlags[0] |= 0x01;
//STRIP001 	*rContents << sal_uInt8(0x48);
//STRIP001 	*rContents << sal_uInt8(0x80);
//STRIP001 
//STRIP001 	nTemp = 0x2C;
//STRIP001 	*rContents << nTemp;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("BackgroundColor"));
//STRIP001     if (aTmp.hasValue())
//STRIP001 	    aTmp >>= nBackColor;
//STRIP001 	*rContents << ExportColor(nBackColor);
//STRIP001 	pBlockFlags[0] |= 0x02;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("TextColor"));
//STRIP001     if (aTmp.hasValue())
//STRIP001 	    aTmp >>= nForeColor;
//STRIP001 	*rContents << ExportColor(nForeColor);
//STRIP001 	pBlockFlags[0] |= 0x04;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("Border"));
//STRIP001 	sal_Int16 nBorder;
//STRIP001 	aTmp >>= nBorder;
//STRIP001 	nSpecialEffect = ExportBorder(nBorder,nBorderStyle);
//STRIP001 	*rContents << nBorderStyle;
//STRIP001 	pBlockFlags[0] |= 0x10;
//STRIP001 
//STRIP001 #if 0 //Each control has a different Value format, and how to convert each to text has to be found out
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("DefaultText"));
//STRIP001 	OUString *pStr = (OUString *)aTmp.getValue();
//STRIP001 	nValueLen = pStr->getLength();
//STRIP001 	ByteString sByte;
//STRIP001 	if (nValueLen)
//STRIP001 	{
//STRIP001 		Align(rContents,4,TRUE);
//STRIP001 		nValueLen |= 0x80000000;
//STRIP001 		*rContents << nValueLen;
//STRIP001 		pBlockFlags[2] |= 0x40;
//STRIP001 		sByte = ByteString(String(*pStr),RTL_TEXTENCODING_MS_1252);
//STRIP001 	}
//STRIP001 #endif
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 	*rContents << nSpecialEffect;
//STRIP001 	pBlockFlags[3] |= 0x04;
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 	*rContents << rSize.Width;
//STRIP001 	*rContents << rSize.Height;
//STRIP001 
//STRIP001 #if 0
//STRIP001 	if (nValueLen)
//STRIP001 		rContents->Write(sByte.GetBuffer(),sByte.Len());
//STRIP001 #endif
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 
//STRIP001     nFixedAreaLen = static_cast<sal_uInt16>(rContents->Tell()-nOldPos-4);
//STRIP001 
//STRIP001 	bRet = aFontData.Export(rContents,rPropSet);
//STRIP001 
//STRIP001     rContents->Seek(nOldPos);
//STRIP001 	*rContents << nStandardId;
//STRIP001 	*rContents << nFixedAreaLen;
//STRIP001 
//STRIP001 	*rContents << pBlockFlags[0];
//STRIP001 	*rContents << pBlockFlags[1];
//STRIP001 	*rContents << pBlockFlags[2];
//STRIP001 	*rContents << pBlockFlags[3];
//STRIP001 	*rContents << pBlockFlags[4];
//STRIP001 	*rContents << pBlockFlags[5];
//STRIP001 	*rContents << pBlockFlags[6];
//STRIP001 	*rContents << pBlockFlags[7];
//STRIP001 
//STRIP001 	DBG_ASSERT((rContents.Is() &&
//STRIP001 		(SVSTREAM_OK==rContents->GetError())),"damn");
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool OCX_FieldControl::Export(SvStorageRef &rObj,
//STRIP001 	const uno::Reference< beans::XPropertySet > &rPropSet,
//STRIP001 	const awt::Size &rSize)
//STRIP001 {
//STRIP001 	static sal_uInt8 __READONLY_DATA aCompObj[] = {
//STRIP001 		0x01, 0x00, 0xFE, 0xFF, 0x03, 0x0A, 0x00, 0x00,
//STRIP001 		0xFF, 0xFF, 0xFF, 0xFF, 0x10, 0x1D, 0xD2, 0x8B,
//STRIP001 		0x42, 0xEC, 0xCE, 0x11, 0x9E, 0x0D, 0x00, 0xAA,
//STRIP001 		0x00, 0x60, 0x02, 0xF3, 0x1C, 0x00, 0x00, 0x00,
//STRIP001 		0x4D, 0x69, 0x63, 0x72, 0x6F, 0x73, 0x6F, 0x66,
//STRIP001 		0x74, 0x20, 0x46, 0x6F, 0x72, 0x6D, 0x73, 0x20,
//STRIP001 		0x32, 0x2E, 0x30, 0x20, 0x54, 0x65, 0x78, 0x74,
//STRIP001 		0x42, 0x6F, 0x78, 0x00, 0x10, 0x00, 0x00, 0x00,
//STRIP001 		0x45, 0x6D, 0x62, 0x65, 0x64, 0x64, 0x65, 0x64,
//STRIP001 		0x20, 0x4F, 0x62, 0x6A, 0x65, 0x63, 0x74, 0x00,
//STRIP001 		0x10, 0x00, 0x00, 0x00, 0x46, 0x6F, 0x72, 0x6D,
//STRIP001 		0x73, 0x2E, 0x54, 0x65, 0x78, 0x74, 0x42, 0x6F,
//STRIP001 		0x78, 0x2E, 0x31, 0x00, 0xF4, 0x39, 0xB2, 0x71,
//STRIP001 		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
//STRIP001 		0x00, 0x00, 0x00, 0x00
//STRIP001 		};
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor( rObj->OpenStream( C2S("\1CompObj")));
//STRIP001 	xStor->Write(aCompObj,sizeof(aCompObj));
//STRIP001 	DBG_ASSERT((xStor.Is() && (SVSTREAM_OK == xStor->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor3( rObj->OpenStream( C2S("\3ObjInfo")));
//STRIP001 	xStor3->Write(aObjInfo,sizeof(aObjInfo));
//STRIP001 	DBG_ASSERT((xStor3.Is() && (SVSTREAM_OK == xStor3->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	static sal_uInt8 __READONLY_DATA aOCXNAME[] = {
//STRIP001 		0x54, 0x00, 0x65, 0x00, 0x78, 0x00, 0x74, 0x00,
//STRIP001 		0x42, 0x00, 0x6F, 0x00, 0x78, 0x00, 0x31, 0x00,
//STRIP001 		0x00, 0x00, 0x00, 0x00
//STRIP001 		};
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor2( rObj->OpenStream( C2S("\3OCXNAME")));
//STRIP001 	xStor2->Write(aOCXNAME,sizeof(aOCXNAME));
//STRIP001 	DBG_ASSERT((xStor2.Is() && (SVSTREAM_OK == xStor2->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	SvStorageStreamRef xContents( rObj->OpenStream( C2S("contents")));
//STRIP001 	return WriteContents(xContents, rPropSet, rSize);
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 sal_Bool OCX_ToggleButton::Import(
//STRIP001 	const uno::Reference< lang::XMultiServiceFactory > &rServiceFactory,
//STRIP001 	uno::Reference< form::XFormComponent > &rFComp, awt::Size &rSz)
//STRIP001 {
//STRIP001 
//STRIP001 	OUString sServiceName =
//STRIP001 		WW8_ASCII2STR("com.sun.star.form.component.CheckBox");
//STRIP001 	uno::Reference< uno::XInterface >  xCreate =
//STRIP001 		rServiceFactory->createInstance( sServiceName );
//STRIP001 	if( !xCreate.is() )
//STRIP001 		return sal_False;
//STRIP001 
//STRIP001 	rFComp = uno::Reference< form::XFormComponent > (xCreate,uno::UNO_QUERY);
//STRIP001 	if( !rFComp.is() )
//STRIP001 		return sal_False;
//STRIP001 
//STRIP001 	uno::Reference< beans::XPropertySet >  xPropSet(xCreate,uno::UNO_QUERY);
//STRIP001 
//STRIP001 	rSz.Width = nWidth;
//STRIP001 	rSz.Height = nHeight;
//STRIP001 
//STRIP001 	uno::Any aTmp(&sName,getCppuType((OUString *)0));
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("Name"), aTmp );
//STRIP001 
//STRIP001 	sal_Bool bTemp;
//STRIP001 	if ((!(fEnabled)) || (fLocked))
//STRIP001 		bTemp = sal_False;
//STRIP001 	else
//STRIP001 		bTemp = sal_True;
//STRIP001 	aTmp = bool2any(bTemp);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("Enabled"), aTmp);
//STRIP001 
//STRIP001     bTemp = nMultiState;
//STRIP001     aTmp = bool2any(bTemp);
//STRIP001     xPropSet->setPropertyValue( WW8_ASCII2STR("TriState"), aTmp);
//STRIP001 
//STRIP001 	aTmp <<= ImportColor(nForeColor);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("TextColor"), aTmp);
//STRIP001 
//STRIP001 	if (pValue)
//STRIP001 	{
//STRIP001 		INT16 nTmp=pValue[0]-0x30;
//STRIP001 		aTmp <<= nTmp;
//STRIP001 		xPropSet->setPropertyValue( WW8_ASCII2STR("DefaultState"), aTmp);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pCaption)
//STRIP001 	{
//STRIP001 		UniString sTmp(pCaption,RTL_TEXTENCODING_MS_1252);
//STRIP001 		OUString sStr = sTmp;
//STRIP001 		aTmp.setValue(&sStr,getCppuType((OUString *)0));
//STRIP001 		xPropSet->setPropertyValue( WW8_ASCII2STR("Label"), aTmp);
//STRIP001 	}
//STRIP001 
//STRIP001 	aFontData.Import(xPropSet);
//STRIP001 	return sal_True;
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool OCX_Label::Import(
//STRIP001 	const uno::Reference< lang::XMultiServiceFactory > &rServiceFactory,
//STRIP001 	uno::Reference< form::XFormComponent >  &rFComp,awt::Size &rSz)
//STRIP001 {
//STRIP001 	OUString sServiceName = WW8_ASCII2STR(
//STRIP001 		"com.sun.star.form.component.FixedText");
//STRIP001 	uno::Reference< uno::XInterface >  xCreate =
//STRIP001 		rServiceFactory->createInstance( sServiceName );
//STRIP001 	if( !xCreate.is() )
//STRIP001 		return sal_False;
//STRIP001 
//STRIP001 	rFComp = uno::Reference< form::XFormComponent > (xCreate,uno::UNO_QUERY);
//STRIP001 	if( !rFComp.is() )
//STRIP001 		return sal_False;
//STRIP001 
//STRIP001 	uno::Reference< beans::XPropertySet >  xPropSet(xCreate,uno::UNO_QUERY);
//STRIP001 
//STRIP001 	rSz.Width = nWidth;
//STRIP001 	rSz.Height = nHeight;
//STRIP001 
//STRIP001 	uno::Any aTmp(&sName,getCppuType((OUString *)0));
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("Name"), aTmp );
//STRIP001 
//STRIP001 	sal_Bool bTemp;
//STRIP001 	if ((!(fEnabled)) || (fLocked))
//STRIP001 		bTemp = sal_False;
//STRIP001 	else
//STRIP001 		bTemp = sal_True;
//STRIP001 	aTmp = bool2any(bTemp);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("Enabled"), aTmp);
//STRIP001 
//STRIP001 	aTmp <<= ImportColor(nForeColor);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("TextColor"), aTmp);
//STRIP001 
//STRIP001 	aTmp <<= ImportColor(nBackColor);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("BackgroundColor"), aTmp);
//STRIP001 
//STRIP001 	aTmp <<= ImportBorder(nSpecialEffect,nBorderStyle);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("Border"), aTmp);
//STRIP001 
//STRIP001 	bTemp=fWordWrap;
//STRIP001 	aTmp = bool2any(bTemp);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("MultiLine"), aTmp);
//STRIP001 
//STRIP001 	if (pCaption)
//STRIP001 	{
//STRIP001 		UniString sTmp(pCaption,RTL_TEXTENCODING_MS_1252);
//STRIP001 		OUString sStr = sTmp;
//STRIP001 		aTmp.setValue(&sStr,getCppuType((OUString *)0));
//STRIP001 		xPropSet->setPropertyValue( WW8_ASCII2STR("Label"), aTmp);
//STRIP001 	}
//STRIP001 
//STRIP001 	aFontData.Import(xPropSet);
//STRIP001 	return sal_True;
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool OCX_ComboBox::Import(
//STRIP001 	const uno::Reference< lang::XMultiServiceFactory >  &rServiceFactory,
//STRIP001 	uno::Reference< form::XFormComponent > &rFComp, awt::Size &rSz)
//STRIP001 {
//STRIP001 
//STRIP001 	OUString sServiceName = WW8_ASCII2STR(
//STRIP001 		"com.sun.star.form.component.ComboBox");
//STRIP001 	uno::Reference< uno::XInterface > xCreate =
//STRIP001 		rServiceFactory->createInstance( sServiceName );
//STRIP001 	if( !xCreate.is() )
//STRIP001 		return sal_False;
//STRIP001 
//STRIP001 	rFComp = uno::Reference< form::XFormComponent > (xCreate,uno::UNO_QUERY);
//STRIP001 	if( !rFComp.is() )
//STRIP001 		return sal_False;
//STRIP001 
//STRIP001 	uno::Reference< beans::XPropertySet >  xPropSet( xCreate, uno::UNO_QUERY );
//STRIP001 
//STRIP001 	rSz.Width = nWidth;
//STRIP001 	rSz.Height = nHeight;
//STRIP001 
//STRIP001 	uno::Any aTmp(&sName,getCppuType((OUString *)0));
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("Name"), aTmp );
//STRIP001 
//STRIP001 	sal_Bool bTmp=fEnabled;
//STRIP001 	aTmp = bool2any(bTmp);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("Enabled"), aTmp);
//STRIP001 
//STRIP001 	bTmp=fLocked;
//STRIP001 	aTmp = bool2any(bTmp);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("ReadOnly"), aTmp);
//STRIP001 
//STRIP001 	if (nDropButtonStyle)
//STRIP001 		bTmp=sal_True;
//STRIP001 	else
//STRIP001 		bTmp=sal_False;
//STRIP001 	aTmp = bool2any(bTmp);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("Dropdown"), aTmp);
//STRIP001 
//STRIP001 	aTmp <<= ImportColor(nForeColor);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("TextColor"), aTmp);
//STRIP001 
//STRIP001 	if (pValue)
//STRIP001 		{
//STRIP001 			UniString sTmp(pValue,RTL_TEXTENCODING_MS_1252);
//STRIP001 			OUString sStr = sTmp;
//STRIP001 			aTmp.setValue(&sStr,getCppuType((OUString *)0));
//STRIP001 			xPropSet->setPropertyValue( WW8_ASCII2STR("DefaultText"), aTmp);
//STRIP001 		}
//STRIP001 
//STRIP001 	aTmp <<= ImportColor(nBackColor);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("BackgroundColor"), aTmp);
//STRIP001 
//STRIP001 	aTmp <<= ImportBorder(nSpecialEffect,nBorderStyle);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("Border"), aTmp);
//STRIP001 
//STRIP001 	sal_Int16 nTmp=static_cast<sal_Int16>(nMaxLength);
//STRIP001 	aTmp <<= nTmp;
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("MaxTextLen"), aTmp);
//STRIP001 
//STRIP001 	aFontData.Import(xPropSet);
//STRIP001 	return sal_True;
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool OCX_ComboBox::WriteContents(SvStorageStreamRef &rContents,
//STRIP001 	const uno::Reference< beans::XPropertySet > &rPropSet,
//STRIP001 	const awt::Size &rSize)
//STRIP001 {
//STRIP001 	sal_Bool bRet=sal_True;
//STRIP001     sal_uInt32 nOldPos = rContents->Tell();
//STRIP001 	rContents->SeekRel(12);
//STRIP001 
//STRIP001 	pBlockFlags[0] = 0;
//STRIP001 	pBlockFlags[1] = 0x01;
//STRIP001 	pBlockFlags[2] = 0x00;
//STRIP001 	pBlockFlags[3] = 0x80;
//STRIP001 	pBlockFlags[4] = 0;
//STRIP001 	pBlockFlags[5] = 0;
//STRIP001 	pBlockFlags[6] = 0;
//STRIP001 	pBlockFlags[7] = 0;
//STRIP001 
//STRIP001 
//STRIP001 	sal_uInt8 nTemp=0x19;//fEnabled;
//STRIP001 	uno::Any aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("Enabled"));
//STRIP001 	fEnabled = any2bool(aTmp);
//STRIP001 	if (fEnabled)
//STRIP001 		nTemp |= 0x02;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("ReadOnly"));
//STRIP001 	fLocked = any2bool(aTmp);
//STRIP001 	if (fLocked)
//STRIP001 		nTemp |= 0x04;
//STRIP001 
//STRIP001 	*rContents << nTemp;
//STRIP001 	pBlockFlags[0] |= 0x01;
//STRIP001 	*rContents << sal_uInt8(0x48);
//STRIP001 	*rContents << sal_uInt8(0x80);
//STRIP001 	*rContents << sal_uInt8(0x2C);
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("BackgroundColor"));
//STRIP001     if (aTmp.hasValue())
//STRIP001 	    aTmp >>= nBackColor;
//STRIP001 	*rContents << ExportColor(nBackColor);
//STRIP001 	pBlockFlags[0] |= 0x02;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("TextColor"));
//STRIP001     if (aTmp.hasValue())
//STRIP001 	    aTmp >>= nForeColor;
//STRIP001 	*rContents << ExportColor(nForeColor);
//STRIP001 	pBlockFlags[0] |= 0x04;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("Border"));
//STRIP001 	sal_Int16 nBorder;
//STRIP001 	aTmp >>= nBorder;
//STRIP001 	nSpecialEffect = ExportBorder(nBorder,nBorderStyle);
//STRIP001 	*rContents << nBorderStyle;
//STRIP001 	pBlockFlags[0] |= 0x10;
//STRIP001 
//STRIP001 	nStyle = 3;
//STRIP001 	*rContents << nStyle;
//STRIP001 	pBlockFlags[0] |= 0x40;
//STRIP001 
//STRIP001 	Align(rContents,2,TRUE);
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("LineCount"));
//STRIP001 	aTmp >>= nListRows;
//STRIP001 	*rContents << nListRows;
//STRIP001 	pBlockFlags[1] |= 0x40;
//STRIP001 
//STRIP001 	*rContents << sal_uInt8(1); //DefaultSelected One
//STRIP001 	pBlockFlags[2] |= 0x01;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("Dropdown"));
//STRIP001 	nDropButtonStyle = any2bool(aTmp);
//STRIP001 	if (nDropButtonStyle)
//STRIP001 		nDropButtonStyle=0x02;
//STRIP001 	*rContents << nDropButtonStyle;
//STRIP001 	pBlockFlags[2] |= 0x04;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("Text"));
//STRIP001 	OUString *pStr = (OUString *)aTmp.getValue();
//STRIP001 	nValueLen = pStr->getLength();
//STRIP001 	ByteString sByte;
//STRIP001 	if (nValueLen)
//STRIP001 	{
//STRIP001 		Align(rContents,4,TRUE);
//STRIP001 		sByte = ByteString(String(*pStr),RTL_TEXTENCODING_MS_1252);
//STRIP001 		nValueLen |= 0x80000000;
//STRIP001 		*rContents << nValueLen;
//STRIP001 		pBlockFlags[2] |= 0x40;
//STRIP001 	}
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 	*rContents << nSpecialEffect;
//STRIP001 	pBlockFlags[3] |= 0x04;
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 	*rContents << rSize.Width;
//STRIP001 	*rContents << rSize.Height;
//STRIP001 
//STRIP001 	if (nValueLen)
//STRIP001 		rContents->Write(sByte.GetBuffer(),sByte.Len());
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 
//STRIP001     nFixedAreaLen = static_cast<sal_uInt16>(rContents->Tell()-nOldPos-4);
//STRIP001 
//STRIP001 	bRet = aFontData.Export(rContents,rPropSet);
//STRIP001 
//STRIP001     rContents->Seek(nOldPos);
//STRIP001 	*rContents << nStandardId;
//STRIP001 	*rContents << nFixedAreaLen;
//STRIP001 
//STRIP001 	*rContents << pBlockFlags[0];
//STRIP001 	*rContents << pBlockFlags[1];
//STRIP001 	*rContents << pBlockFlags[2];
//STRIP001 	*rContents << pBlockFlags[3];
//STRIP001 	*rContents << pBlockFlags[4];
//STRIP001 	*rContents << pBlockFlags[5];
//STRIP001 	*rContents << pBlockFlags[6];
//STRIP001 	*rContents << pBlockFlags[7];
//STRIP001 
//STRIP001 	DBG_ASSERT((rContents.Is() &&
//STRIP001 		(SVSTREAM_OK==rContents->GetError())),"damn");
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 sal_Bool OCX_ComboBox::Export(SvStorageRef &rObj,
//STRIP001 	const uno::Reference< beans::XPropertySet > &rPropSet,
//STRIP001 	const awt::Size &rSize)
//STRIP001 {
//STRIP001 	static sal_uInt8 __READONLY_DATA aCompObj[] = {
//STRIP001 		0x01, 0x00, 0xFE, 0xFF, 0x03, 0x0A, 0x00, 0x00,
//STRIP001 		0xFF, 0xFF, 0xFF, 0xFF, 0x30, 0x1D, 0xD2, 0x8B,
//STRIP001 		0x42, 0xEC, 0xCE, 0x11, 0x9E, 0x0D, 0x00, 0xAA,
//STRIP001 		0x00, 0x60, 0x02, 0xF3, 0x1D, 0x00, 0x00, 0x00,
//STRIP001 		0x4D, 0x69, 0x63, 0x72, 0x6F, 0x73, 0x6F, 0x66,
//STRIP001 		0x74, 0x20, 0x46, 0x6F, 0x72, 0x6D, 0x73, 0x20,
//STRIP001 		0x32, 0x2E, 0x30, 0x20, 0x43, 0x6F, 0x6D, 0x62,
//STRIP001 		0x6F, 0x42, 0x6F, 0x78, 0x00, 0x10, 0x00, 0x00,
//STRIP001 		0x00, 0x45, 0x6D, 0x62, 0x65, 0x64, 0x64, 0x65,
//STRIP001 		0x64, 0x20, 0x4F, 0x62, 0x6A, 0x65, 0x63, 0x74,
//STRIP001 		0x00, 0x11, 0x00, 0x00, 0x00, 0x46, 0x6F, 0x72,
//STRIP001 		0x6D, 0x73, 0x2E, 0x43, 0x6F, 0x6D, 0x62, 0x6F,
//STRIP001 		0x42, 0x6F, 0x78, 0x2E, 0x31, 0x00, 0xF4, 0x39,
//STRIP001 		0xB2, 0x71, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
//STRIP001 		0x00, 0x00, 0x00, 0x00, 0x00, 0x00
//STRIP001 		};
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor( rObj->OpenStream( C2S("\1CompObj")));
//STRIP001 	xStor->Write(aCompObj,sizeof(aCompObj));
//STRIP001 	DBG_ASSERT((xStor.Is() && (SVSTREAM_OK == xStor->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor3( rObj->OpenStream( C2S("\3ObjInfo")));
//STRIP001 	xStor3->Write(aObjInfo,sizeof(aObjInfo));
//STRIP001 	DBG_ASSERT((xStor3.Is() && (SVSTREAM_OK == xStor3->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	static sal_uInt8 __READONLY_DATA aOCXNAME[] = {
//STRIP001 		0x43, 0x00, 0x6F, 0x00, 0x6D, 0x00, 0x62, 0x00,
//STRIP001 		0x6F, 0x00, 0x42, 0x00, 0x6F, 0x00, 0x78, 0x00,
//STRIP001 		0x31, 0x00, 0x00, 0x00, 0x00, 0x00
//STRIP001 	};
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor2( rObj->OpenStream( C2S("\3OCXNAME")));
//STRIP001 	xStor2->Write(aOCXNAME,sizeof(aOCXNAME));
//STRIP001 	DBG_ASSERT((xStor2.Is() && (SVSTREAM_OK == xStor2->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	SvStorageStreamRef xContents( rObj->OpenStream( C2S("contents")));
//STRIP001 	return WriteContents(xContents, rPropSet, rSize);
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 sal_Bool OCX_ListBox::Import(
//STRIP001 	const uno::Reference< lang::XMultiServiceFactory > &rServiceFactory,
//STRIP001 	uno::Reference< form::XFormComponent > &rFComp, awt::Size &rSz)
//STRIP001 {
//STRIP001 	OUString sServiceName = WW8_ASCII2STR("com.sun.star.form.component.ListBox");
//STRIP001 	uno::Reference< uno::XInterface > xCreate =
//STRIP001 		rServiceFactory->createInstance( sServiceName );
//STRIP001 	if( !xCreate.is() )
//STRIP001 		return sal_False;
//STRIP001 
//STRIP001 	rFComp = uno::Reference< form::XFormComponent > (xCreate,uno::UNO_QUERY);
//STRIP001 	if( !rFComp.is() )
//STRIP001 		return sal_False;
//STRIP001 
//STRIP001 	uno::Reference< beans::XPropertySet >  xPropSet(xCreate,uno::UNO_QUERY);
//STRIP001 
//STRIP001 	rSz.Width = nWidth;
//STRIP001 	rSz.Height = nHeight;
//STRIP001 
//STRIP001 	uno::Any aTmp(&sName,getCppuType((OUString *)0));
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("Name"), aTmp );
//STRIP001 
//STRIP001 	sal_Bool bTmp=fEnabled;
//STRIP001 	aTmp = bool2any(bTmp);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("Enabled"), aTmp);
//STRIP001 
//STRIP001 	bTmp=fLocked;
//STRIP001 	aTmp = bool2any(bTmp);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("ReadOnly"), aTmp);
//STRIP001 
//STRIP001 	aTmp <<= ImportColor(nForeColor);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("TextColor"), aTmp);
//STRIP001 
//STRIP001 	sal_Bool bTemp = nMultiState;
//STRIP001 	aTmp = bool2any(bTemp);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("MultiSelection"), aTmp);
//STRIP001 
//STRIP001 #if 0		//Don't delete this for now until I figure out if I can make this
//STRIP001 	if (pValue)
//STRIP001 		{
//STRIP001 			UniString sTmp(pValue,RTL_TEXTENCODING_MS_1252);
//STRIP001 			OUString sStr = sTmp;
//STRIP001 			aTmp.setValue(&sStr,getCppuType((OUString *)0));
//STRIP001 			xPropSet->setPropertyValue( WW8_ASCII2STR("DefaultText"), aTmp);
//STRIP001 		}
//STRIP001 #endif
//STRIP001 
//STRIP001 	aTmp <<= ImportColor(nBackColor);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("BackgroundColor"), aTmp);
//STRIP001 
//STRIP001 	aTmp <<= ImportBorder(nSpecialEffect,nBorderStyle);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("Border"), aTmp);
//STRIP001 
//STRIP001 	aFontData.Import(xPropSet);
//STRIP001 	return sal_True;
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool OCX_ListBox::WriteContents(SvStorageStreamRef &rContents,
//STRIP001 	const uno::Reference< beans::XPropertySet > &rPropSet,
//STRIP001 	const awt::Size &rSize)
//STRIP001 {
//STRIP001 	sal_Bool bRet=sal_True;
//STRIP001     sal_uInt32 nOldPos = rContents->Tell();
//STRIP001 	rContents->SeekRel(12);
//STRIP001 
//STRIP001 	pBlockFlags[0] = 0;
//STRIP001 	pBlockFlags[1] = 0x01;
//STRIP001 	pBlockFlags[2] = 0x01;
//STRIP001 	pBlockFlags[3] = 0x80;
//STRIP001 	pBlockFlags[4] = 0;
//STRIP001 	pBlockFlags[5] = 0;
//STRIP001 	pBlockFlags[6] = 0;
//STRIP001 	pBlockFlags[7] = 0;
//STRIP001 
//STRIP001 	uno::Any aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("Enabled"));
//STRIP001 	fEnabled = any2bool(aTmp);
//STRIP001 	sal_uInt8 nTemp=fEnabled;
//STRIP001 	if (fEnabled)
//STRIP001 		nTemp = nTemp << 1;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("ReadOnly"));
//STRIP001 	fLocked = any2bool(aTmp);
//STRIP001 	if (fLocked)
//STRIP001 		nTemp |= 0x04;
//STRIP001 
//STRIP001 	*rContents << nTemp;
//STRIP001 	pBlockFlags[0] |= 0x01;
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("BackgroundColor"));
//STRIP001     if (aTmp.hasValue())
//STRIP001 	    aTmp >>= nBackColor;
//STRIP001 	*rContents << ExportColor(nBackColor);
//STRIP001 	pBlockFlags[0] |= 0x02;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("TextColor"));
//STRIP001     if (aTmp.hasValue())
//STRIP001 	    aTmp >>= nForeColor;
//STRIP001 	*rContents << ExportColor(nForeColor);
//STRIP001 	pBlockFlags[0] |= 0x04;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("MultiSelection"));
//STRIP001 	nMultiState = any2bool(aTmp);
//STRIP001 
//STRIP001 	if (nMultiState)
//STRIP001 	{
//STRIP001 		*rContents << nMultiState;
//STRIP001 		pBlockFlags[0] |= 0x20;
//STRIP001 	}
//STRIP001 
//STRIP001 	nStyle = 2;
//STRIP001 	*rContents << nStyle;
//STRIP001 	pBlockFlags[0] |= 0x40;
//STRIP001 
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 
//STRIP001 #if 0
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("DefaultText"));
//STRIP001 	OUString *pStr = (OUString *)aTmp.getValue();
//STRIP001 	nValueLen = pStr->getLength();
//STRIP001 	ByteString sByte;
//STRIP001 	if (nValueLen)
//STRIP001 	{
//STRIP001 		sByte = ByteString(String(*pStr),RTL_TEXTENCODING_MS_1252);
//STRIP001 		nValueLen |= 0x80000000;
//STRIP001 		*rContents << nValueLen;
//STRIP001 		pBlockFlags[2] |= 0x40;
//STRIP001 	}
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 #endif
//STRIP001 
//STRIP001 	*rContents << rSize.Width;
//STRIP001 	*rContents << rSize.Height;
//STRIP001 
//STRIP001 #if 0
//STRIP001 	if (nValueLen)
//STRIP001 	{
//STRIP001 		rContents->Write(sByte.GetBuffer(),sByte.Len());
//STRIP001 		Align(rContents,4,TRUE);
//STRIP001 	}
//STRIP001 #endif
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 
//STRIP001     nFixedAreaLen = static_cast<sal_uInt16>(rContents->Tell()-nOldPos-4);
//STRIP001 
//STRIP001 	bRet = aFontData.Export(rContents,rPropSet);
//STRIP001 
//STRIP001     rContents->Seek(nOldPos);
//STRIP001 	*rContents << nStandardId;
//STRIP001 	*rContents << nFixedAreaLen;
//STRIP001 
//STRIP001 	*rContents << pBlockFlags[0];
//STRIP001 	*rContents << pBlockFlags[1];
//STRIP001 	*rContents << pBlockFlags[2];
//STRIP001 	*rContents << pBlockFlags[3];
//STRIP001 	*rContents << pBlockFlags[4];
//STRIP001 	*rContents << pBlockFlags[5];
//STRIP001 	*rContents << pBlockFlags[6];
//STRIP001 	*rContents << pBlockFlags[7];
//STRIP001 
//STRIP001 	DBG_ASSERT((rContents.Is() &&
//STRIP001 		(SVSTREAM_OK==rContents->GetError())),"damn");
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool OCX_ListBox::Export(SvStorageRef &rObj,
//STRIP001 	const uno::Reference< beans::XPropertySet > &rPropSet,
//STRIP001 	const awt::Size &rSize)
//STRIP001 {
//STRIP001 	static sal_uInt8 __READONLY_DATA aCompObj[] = {
//STRIP001 		0x01, 0x00, 0xFE, 0xFF, 0x03, 0x0A, 0x00, 0x00,
//STRIP001 		0xFF, 0xFF, 0xFF, 0xFF, 0x20, 0x1D, 0xD2, 0x8B,
//STRIP001 		0x42, 0xEC, 0xCE, 0x11, 0x9E, 0x0D, 0x00, 0xAA,
//STRIP001 		0x00, 0x60, 0x02, 0xF3, 0x1C, 0x00, 0x00, 0x00,
//STRIP001 		0x4D, 0x69, 0x63, 0x72, 0x6F, 0x73, 0x6F, 0x66,
//STRIP001 		0x74, 0x20, 0x46, 0x6F, 0x72, 0x6D, 0x73, 0x20,
//STRIP001 		0x32, 0x2E, 0x30, 0x20, 0x4C, 0x69, 0x73, 0x74,
//STRIP001 		0x42, 0x6F, 0x78, 0x00, 0x10, 0x00, 0x00, 0x00,
//STRIP001 		0x45, 0x6D, 0x62, 0x65, 0x64, 0x64, 0x65, 0x64,
//STRIP001 		0x20, 0x4F, 0x62, 0x6A, 0x65, 0x63, 0x74, 0x00,
//STRIP001 		0x10, 0x00, 0x00, 0x00, 0x46, 0x6F, 0x72, 0x6D,
//STRIP001 		0x73, 0x2E, 0x4C, 0x69, 0x73, 0x74, 0x42, 0x6F,
//STRIP001 		0x78, 0x2E, 0x31, 0x00, 0xF4, 0x39, 0xB2, 0x71,
//STRIP001 		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
//STRIP001 		0x00, 0x00, 0x00, 0x00
//STRIP001 		};
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor( rObj->OpenStream( C2S("\1CompObj")));
//STRIP001 	xStor->Write(aCompObj,sizeof(aCompObj));
//STRIP001 	DBG_ASSERT((xStor.Is() && (SVSTREAM_OK == xStor->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor3( rObj->OpenStream( C2S("\3ObjInfo")));
//STRIP001 	xStor3->Write(aObjInfo,sizeof(aObjInfo));
//STRIP001 	DBG_ASSERT((xStor3.Is() && (SVSTREAM_OK == xStor3->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	static sal_uInt8 __READONLY_DATA aOCXNAME[] = {
//STRIP001 		0x4C, 0x00, 0x69, 0x00, 0x73, 0x00, 0x74, 0x00,
//STRIP001 		0x42, 0x00, 0x6F, 0x00, 0x78, 0x00, 0x31, 0x00,
//STRIP001 		0x00, 0x00, 0x00, 0x00
//STRIP001 		};
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor2( rObj->OpenStream( C2S("\3OCXNAME")));
//STRIP001 	xStor2->Write(aOCXNAME,sizeof(aOCXNAME));
//STRIP001 	DBG_ASSERT((xStor2.Is() && (SVSTREAM_OK == xStor2->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	SvStorageStreamRef xContents( rObj->OpenStream( C2S("contents")));
//STRIP001 	return WriteContents(xContents, rPropSet, rSize);
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool OCX_ModernControl::Read(SvStorageStream *pS)
//STRIP001 {
//STRIP001 	*pS >> nIdentifier;
//STRIP001 	DBG_ASSERT(nIdentifier==nStandardId,
//STRIP001 			"A control that has a different identifier");
//STRIP001 	*pS >> nFixedAreaLen;
//STRIP001 	pS->Read(pBlockFlags,8);
//STRIP001 
//STRIP001 	if (pBlockFlags[0] & 0x01)
//STRIP001 	{
//STRIP001 		sal_uInt8 nTemp;
//STRIP001 		*pS >> nTemp;
//STRIP001 
//STRIP001 		fEnabled = (nTemp & 0x02) >> 1;
//STRIP001 		fLocked = (nTemp & 0x04) >> 2;
//STRIP001         fBackStyle = (nTemp & 0x08) >> 3;
//STRIP001 
//STRIP001 		*pS >> nTemp;
//STRIP001 
//STRIP001 		fColumnHeads = (nTemp & 0x04) >> 2;
//STRIP001 		fIntegralHeight = (nTemp & 0x08) >> 3;
//STRIP001 		fMatchRequired = (nTemp & 0x10) >> 4;
//STRIP001 		fAlignment = (nTemp & 0x20) >> 5;
//STRIP001 
//STRIP001 		*pS >> nTemp;
//STRIP001 
//STRIP001 		fDragBehaviour = (nTemp & 0x08) >> 3;
//STRIP001 		fEnterKeyBehaviour = (nTemp & 0x10) >> 4;
//STRIP001 		fEnterFieldBehaviour = (nTemp & 0x20) >> 5;
//STRIP001 		fTabKeyBehaviour = (nTemp & 0x40) >> 6;
//STRIP001 		fWordWrap = (nTemp & 0x80) >> 7;
//STRIP001 
//STRIP001 		*pS >> nTemp;
//STRIP001 		fSelectionMargin = (nTemp & 0x04) >> 2;
//STRIP001 		fAutoWordSelect = (nTemp & 0x08) >> 3;
//STRIP001 		fAutoSize = (nTemp & 0x10) >> 4;
//STRIP001 		fHideSelection = (nTemp & 0x20) >> 5;
//STRIP001 		fAutoTab = (nTemp & 0x40) >> 6;
//STRIP001 		fMultiLine = (nTemp & 0x80) >> 7;
//STRIP001 
//STRIP001 	}
//STRIP001 
//STRIP001 	/*If any of these are set they follow eachother in this order one after
//STRIP001 	another padded out to the next U32 boundary with 0's
//STRIP001 	U8 can abut each other U16 must start on a U16 boundary and are padded to
//STRIP001 	that with 0's. A standardish word alignment structure*/
//STRIP001 
//STRIP001 	if (pBlockFlags[0] & 0x02)
//STRIP001 		*pS >> nBackColor;
//STRIP001 	if (pBlockFlags[0] & 0x04)
//STRIP001 		*pS >> nForeColor;
//STRIP001 	if (pBlockFlags[0] & 0x08)
//STRIP001 		*pS >> nMaxLength;
//STRIP001 
//STRIP001 	if (pBlockFlags[0] & 0x10)
//STRIP001 		*pS >> nBorderStyle;
//STRIP001 	if (pBlockFlags[0] & 0x20)
//STRIP001 		*pS >> nScrollBars;
//STRIP001 	if (pBlockFlags[0] & 0x40)
//STRIP001 		*pS >> nStyle;// (UI 0 == Data 3, UI 2 = Data 7)
//STRIP001 	if (pBlockFlags[0] & 0x80)
//STRIP001 		*pS >> nMousePointer;
//STRIP001 
//STRIP001 	if (pBlockFlags[1] & 0x02)
//STRIP001 		*pS >> nPasswordChar; //HUH ??? always 0 ??? not sure maybe just padding
//STRIP001 
//STRIP001 	if (pBlockFlags[1] & 0x04)
//STRIP001 	{
//STRIP001 		Align(pS,4);
//STRIP001 		*pS >> nListWidth;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pBlockFlags[1] & 0x08)
//STRIP001 	{
//STRIP001 		Align(pS,2);
//STRIP001 		*pS >> nBoundColumn;
//STRIP001 	}
//STRIP001 	if (pBlockFlags[1] & 0x10)
//STRIP001 	{
//STRIP001 		Align(pS,2);
//STRIP001 		*pS >> nTextColumn;
//STRIP001 	}
//STRIP001 	if (pBlockFlags[1] & 0x20)
//STRIP001 	{
//STRIP001 		Align(pS,2);
//STRIP001 		*pS >> nColumnCount;
//STRIP001 	}
//STRIP001 	if (pBlockFlags[1] & 0x40)
//STRIP001 	{
//STRIP001 		Align(pS,2);
//STRIP001 		*pS >> nListRows;
//STRIP001 	}
//STRIP001 	if (pBlockFlags[1] & 0x80)
//STRIP001 	{
//STRIP001 		Align(pS,2);
//STRIP001 		*pS >> nUnknown8; //something to do with ColumnWidths
//STRIP001 	}
//STRIP001 	if (pBlockFlags[2] & 0x01)
//STRIP001 		*pS >> nMatchEntry;
//STRIP001 	if (pBlockFlags[2] & 0x02)
//STRIP001 		*pS >> nListStyle;
//STRIP001 	if (pBlockFlags[2] & 0x04)
//STRIP001 		*pS >> nShowDropButtonWhen;
//STRIP001 	if (pBlockFlags[2] & 0x10)
//STRIP001 		*pS >> nDropButtonStyle;
//STRIP001 	if (pBlockFlags[2] & 0x20)
//STRIP001 		*pS >> nMultiState;
//STRIP001 
//STRIP001 	if (pBlockFlags[2] & 0x40)
//STRIP001 	{
//STRIP001 		Align(pS,4);
//STRIP001 		*pS >> nValueLen; //bit 0x80000000L set
//STRIP001 	}
//STRIP001 	if (pBlockFlags[2] & 0x80)
//STRIP001 	{
//STRIP001 		Align(pS,4);
//STRIP001 		*pS >> nCaptionLen; //bit 0x80000000L set
//STRIP001 	}
//STRIP001 	if (pBlockFlags[3] & 0x01)
//STRIP001 	{
//STRIP001 		Align(pS,4);
//STRIP001 		*pS >> nHorzPos;
//STRIP001 		*pS >> nVertPos;
//STRIP001 	}
//STRIP001 	if (pBlockFlags[3] & 0x02)
//STRIP001 	{
//STRIP001 		Align(pS,4);
//STRIP001 		*pS >> nBorderColor;
//STRIP001 	}
//STRIP001 	if (pBlockFlags[3] & 0x04)
//STRIP001 	{
//STRIP001 		Align(pS,4); // NEW
//STRIP001 		*pS >> nSpecialEffect;
//STRIP001 	}
//STRIP001 	if (pBlockFlags[3] & 0x08)
//STRIP001 	{
//STRIP001 		Align(pS,2);
//STRIP001 		*pS >> nIcon;
//STRIP001 		DBG_ASSERT(nIcon == 0xFFFF, "Unexpected nIcon");
//STRIP001 	}
//STRIP001 	if (pBlockFlags[3] & 0x10)
//STRIP001 	{
//STRIP001 		Align(pS,2);
//STRIP001 		*pS >> nPicture;
//STRIP001 		DBG_ASSERT(nPicture == 0xFFFF, "Unexpected nIcon");
//STRIP001 	}
//STRIP001 	if (pBlockFlags[3] & 0x20)
//STRIP001 		*pS >> nAccelerator;
//STRIP001 	/*
//STRIP001 	if (pBlockFlags[3] & 0x80)
//STRIP001 		*pS >> nUnknown9;
//STRIP001 	*/
//STRIP001 	if (pBlockFlags[4] & 0x01)
//STRIP001 	{
//STRIP001 		Align(pS,4);
//STRIP001 		*pS >> nGroupNameLen; // bit 0x80000000L set
//STRIP001 	}
//STRIP001 
//STRIP001 	//End
//STRIP001 
//STRIP001 	Align(pS,4);
//STRIP001 	*pS >> nWidth;
//STRIP001 	*pS >> nHeight;
//STRIP001 
//STRIP001 	if (nValueLen)
//STRIP001 	{
//STRIP001 		nValueLen &= 0x7FFFFFFF;
//STRIP001 		pValue= new char[nValueLen+1];
//STRIP001 		pS->Read(pValue,nValueLen);
//STRIP001 		pValue[nValueLen]=0;
//STRIP001 		Align(pS,4);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (nCaptionLen)
//STRIP001 	{
//STRIP001 		nCaptionLen &= 0x7FFFFFFF;
//STRIP001 		pCaption = new char[nCaptionLen+1];
//STRIP001 		pS->Read(pCaption,nCaptionLen);
//STRIP001 		pCaption[nCaptionLen]=0;
//STRIP001 		Align(pS,4);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (nGroupNameLen)
//STRIP001 	{
//STRIP001 		nGroupNameLen &= 0x7FFFFFFF;
//STRIP001 		pGroupName = new char[nGroupNameLen+1];
//STRIP001 		pS->Read(pGroupName,nGroupNameLen);
//STRIP001 		pGroupName[nGroupNameLen]=0;
//STRIP001 		Align(pS,4);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (nIcon)
//STRIP001 	{
//STRIP001 		pS->Read(pIconHeader,20);
//STRIP001 		*pS >> nIconLen;
//STRIP001 		pIcon = new sal_uInt8[nIconLen];
//STRIP001 		pS->Read(pIcon,nIconLen);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (nPicture)
//STRIP001 	{
//STRIP001 		pS->Read(pPictureHeader,20);
//STRIP001 		*pS >> nPictureLen;
//STRIP001 		pPicture = new sal_uInt8[nPictureLen];
//STRIP001 		pS->Read(pPicture,nPictureLen);
//STRIP001 	}
//STRIP001 
//STRIP001 	return sal_True;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 sal_Bool OCX_CommandButton::Read(SvStorageStream *pS)
//STRIP001 {
//STRIP001 	*pS >> nIdentifier;
//STRIP001 	DBG_ASSERT(nStandardId==nIdentifier,
//STRIP001 		"A control that has a different identifier");
//STRIP001 	*pS >> nFixedAreaLen;
//STRIP001 	pS->Read(pBlockFlags,4);
//STRIP001 
//STRIP001 
//STRIP001 	if (pBlockFlags[0] & 0x01)
//STRIP001 		*pS >> nForeColor;
//STRIP001 	if (pBlockFlags[0] & 0x02)
//STRIP001 		*pS >> nBackColor;
//STRIP001 
//STRIP001 	if (pBlockFlags[0] & 0x04)
//STRIP001 	{
//STRIP001 		sal_uInt8 nTemp;
//STRIP001 		*pS >> nTemp;
//STRIP001 		fEnabled = (nTemp&0x02)>>1;
//STRIP001 		fLocked = (nTemp&0x04)>>2;
//STRIP001 		fBackStyle = (nTemp&0x08)>>3;
//STRIP001 		*pS >> nTemp;
//STRIP001 		*pS >> nTemp;
//STRIP001 		fWordWrap = (nTemp&0x80)>>7;
//STRIP001 		*pS >> nTemp;
//STRIP001 		fAutoSize = (nTemp&0x10)>>4;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pBlockFlags[0] & 0x08)
//STRIP001 		*pS >> nCaptionLen;
//STRIP001 
//STRIP001 	if (pBlockFlags[0] & 0x10) /*Picture Position, a strange mechanism here*/
//STRIP001 	{
//STRIP001 		*pS >> nVertPos;
//STRIP001 		*pS >> nHorzPos;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pBlockFlags[0] & 0x40) /*MousePointer*/
//STRIP001 		*pS >> nMousePointer;
//STRIP001 
//STRIP001 	if (pBlockFlags[0] & 0x80)
//STRIP001 	{
//STRIP001 		Align(pS,2);
//STRIP001 		*pS >> nPicture;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pBlockFlags[1] & 0x01)
//STRIP001 	{
//STRIP001 		Align(pS,2);
//STRIP001 		*pS >> nAccelerator;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pBlockFlags[1] & 0x04)
//STRIP001 	{
//STRIP001 		Align(pS,2);
//STRIP001 		*pS >> nIcon;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (nCaptionLen)
//STRIP001 	{
//STRIP001 		Align(pS,4);
//STRIP001 		nCaptionLen &= 0x7FFFFFFF;
//STRIP001 		pCaption = new char[nCaptionLen+1];
//STRIP001 		pS->Read(pCaption,nCaptionLen);
//STRIP001 		pCaption[nCaptionLen]=0;
//STRIP001 	}
//STRIP001 
//STRIP001 	Align(pS,4);
//STRIP001 	*pS >> nWidth;
//STRIP001 	*pS >> nHeight;
//STRIP001 
//STRIP001 	if (nIcon)
//STRIP001 	{
//STRIP001 		pS->Read(pIconHeader,20);
//STRIP001 		*pS >> nIconLen;
//STRIP001 		pIcon = new sal_uInt8[nIconLen];
//STRIP001 		pS->Read(pIcon,nIconLen);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (nPicture)
//STRIP001 	{
//STRIP001 		pS->Read(pPictureHeader,20);
//STRIP001 		*pS >> nPictureLen;
//STRIP001 		pPicture = new sal_uInt8[nPictureLen];
//STRIP001 		pS->Read(pPicture,nPictureLen);
//STRIP001 	}
//STRIP001 
//STRIP001 	return sal_True;
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool OCX_Label::Read(SvStorageStream *pS)
//STRIP001 {
//STRIP001 	*pS >> nIdentifier;
//STRIP001 	DBG_ASSERT(nStandardId==nIdentifier,
//STRIP001 			"A control that has a different identifier");
//STRIP001 	*pS >> nFixedAreaLen;
//STRIP001 	pS->Read(pBlockFlags,4);
//STRIP001 
//STRIP001 
//STRIP001 	if (pBlockFlags[0] & 0x01)
//STRIP001 		*pS >> nForeColor;
//STRIP001 	if (pBlockFlags[0] & 0x02)
//STRIP001 		*pS >> nBackColor;
//STRIP001 
//STRIP001 
//STRIP001 	if (pBlockFlags[0] & 0x04)
//STRIP001 	{
//STRIP001 		sal_uInt8 nTemp;
//STRIP001 		*pS >> nTemp;
//STRIP001 		fEnabled = (nTemp&0x02)>>1;
//STRIP001 		fLocked = (nTemp&0x04)>>2;
//STRIP001 		fBackStyle = (nTemp&0x08)>>3;
//STRIP001 		*pS >> nTemp;
//STRIP001 		*pS >> nTemp;
//STRIP001 		fWordWrap = (nTemp&0x80)>>7;
//STRIP001 		*pS >> nTemp;
//STRIP001 		fAutoSize = (nTemp&0x10)>>4;
//STRIP001 	}
//STRIP001 	if (pBlockFlags[0] & 0x08)
//STRIP001 		*pS >> nCaptionLen;
//STRIP001 
//STRIP001 	if (pBlockFlags[0] & 0x10)
//STRIP001 	{
//STRIP001 		*pS >> nVertPos;
//STRIP001 		*pS >> nHorzPos;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pBlockFlags[0] & 0x40)
//STRIP001 		*pS >> nMousePointer;
//STRIP001 
//STRIP001 	if (pBlockFlags[0] & 0x80)
//STRIP001 	{
//STRIP001 		Align(pS,4);
//STRIP001 		*pS >> nBorderColor;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pBlockFlags[1] & 0x01)
//STRIP001 	{
//STRIP001 		Align(pS,2);
//STRIP001 		*pS >> nBorderStyle;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pBlockFlags[1] & 0x02)
//STRIP001 	{
//STRIP001 		Align(pS,2);
//STRIP001 		*pS >> nSpecialEffect;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pBlockFlags[1] & 0x04)
//STRIP001 	{
//STRIP001 		Align(pS,2);
//STRIP001 		*pS >> nPicture;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pBlockFlags[1] & 0x08)
//STRIP001 	{
//STRIP001 		Align(pS,2);
//STRIP001 		*pS >> nAccelerator;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pBlockFlags[1] & 0x10)
//STRIP001 	{
//STRIP001 		Align(pS,2);
//STRIP001 		*pS >> nIcon;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (nCaptionLen)
//STRIP001 	{
//STRIP001 		Align(pS,4);
//STRIP001 		nCaptionLen &= 0x7FFFFFFF;
//STRIP001 		pCaption = new char[nCaptionLen+1];
//STRIP001 		pS->Read(pCaption,nCaptionLen);
//STRIP001 		pCaption[nCaptionLen]=0;
//STRIP001 		Align(pS,4);
//STRIP001 	}
//STRIP001 
//STRIP001 	*pS >> nWidth;
//STRIP001 	*pS >> nHeight;
//STRIP001 
//STRIP001 	if (nIcon)
//STRIP001 	{
//STRIP001 		pS->Read(pIconHeader,20);
//STRIP001 		*pS >> nIconLen;
//STRIP001 		pIcon = new sal_uInt8[nIconLen];
//STRIP001 		pS->Read(pIcon,nIconLen);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (nPicture)
//STRIP001 	{
//STRIP001 		pS->Read(pPictureHeader,20);
//STRIP001 		*pS >> nPictureLen;
//STRIP001 		pPicture = new sal_uInt8[nPictureLen];
//STRIP001 		pS->Read(pPicture,nPictureLen);
//STRIP001 	}
//STRIP001 
//STRIP001 	return sal_True;
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool OCX_Label::WriteContents(SvStorageStreamRef &rContents,
//STRIP001 	const uno::Reference< beans::XPropertySet > &rPropSet,
//STRIP001 	const awt::Size &rSize)
//STRIP001 {
//STRIP001 	sal_Bool bRet = sal_True;
//STRIP001     sal_uInt32 nOldPos = rContents->Tell();
//STRIP001 	rContents->SeekRel(8);
//STRIP001 	pBlockFlags[0] = 0x20;
//STRIP001 	pBlockFlags[1] = 0;
//STRIP001 	pBlockFlags[2] = 0;
//STRIP001 	pBlockFlags[3] = 0;
//STRIP001 
//STRIP001 	uno::Any aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("TextColor"));
//STRIP001     if (aTmp.hasValue())
//STRIP001 	    aTmp >>= nForeColor;
//STRIP001 	*rContents << ExportColor(nForeColor);
//STRIP001 	pBlockFlags[0] |= 0x01;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("BackgroundColor"));
//STRIP001     if (aTmp.hasValue())
//STRIP001 	    aTmp >>= nBackColor;
//STRIP001 	*rContents << ExportColor(nBackColor);
//STRIP001 	pBlockFlags[0] |= 0x02;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("Enabled"));
//STRIP001 	fEnabled = any2bool(aTmp);
//STRIP001 	sal_uInt8 nTemp=fEnabled;
//STRIP001 	if (fEnabled)
//STRIP001 		nTemp = nTemp << 1;
//STRIP001 	*rContents << nTemp;
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("MultiLine"));
//STRIP001 	fWordWrap = any2bool(aTmp);
//STRIP001 	nTemp=fWordWrap;
//STRIP001 	nTemp = nTemp << 7;
//STRIP001 	*rContents << nTemp;
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 	pBlockFlags[0] |= 0x04;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("Label"));
//STRIP001 	OUString *pStr = (OUString *)aTmp.getValue();
//STRIP001 	nCaptionLen = pStr->getLength();
//STRIP001 	ByteString sByte;
//STRIP001 	if (nCaptionLen)
//STRIP001 	{
//STRIP001 		nCaptionLen |= 0x80000000;
//STRIP001 		*rContents << nCaptionLen;
//STRIP001 		pBlockFlags[0] |= 0x08;
//STRIP001 		sByte = ByteString(String(*pStr),RTL_TEXTENCODING_MS_1252);
//STRIP001 	}
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("Border"));
//STRIP001 	sal_Int16 nBorder;
//STRIP001 	aTmp >>= nBorder;
//STRIP001 	sal_uInt8 nNewBorder;
//STRIP001 	nSpecialEffect = ExportBorder(nBorder,nNewBorder);
//STRIP001 	nBorderStyle = nNewBorder;
//STRIP001 	*rContents << nBorderStyle;
//STRIP001 	pBlockFlags[1] |= 0x01;
//STRIP001 	*rContents << nSpecialEffect;
//STRIP001 	pBlockFlags[1] |= 0x02;
//STRIP001 
//STRIP001 	if (nCaptionLen)
//STRIP001 		rContents->Write(sByte.GetBuffer(),sByte.Len());
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 	*rContents << rSize.Width;
//STRIP001 	*rContents << rSize.Height;
//STRIP001     nFixedAreaLen = static_cast<sal_uInt16>(rContents->Tell()-nOldPos-4);
//STRIP001 
//STRIP001 	bRet = aFontData.Export(rContents,rPropSet);
//STRIP001 
//STRIP001     rContents->Seek(nOldPos);
//STRIP001 	*rContents << nStandardId;
//STRIP001 	*rContents << nFixedAreaLen;
//STRIP001 
//STRIP001 	*rContents << pBlockFlags[0];
//STRIP001 	*rContents << pBlockFlags[1];
//STRIP001 	*rContents << pBlockFlags[2];
//STRIP001 	*rContents << pBlockFlags[3];
//STRIP001 
//STRIP001 	DBG_ASSERT((rContents.Is() &&
//STRIP001 		(SVSTREAM_OK==rContents->GetError())),"damn");
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 sal_Bool OCX_Label::Export(SvStorageRef &rObj,
//STRIP001 	const uno::Reference< beans::XPropertySet > &rPropSet,
//STRIP001 	const awt::Size &rSize)
//STRIP001 {
//STRIP001 	static sal_uInt8 __READONLY_DATA aCompObj[] = {
//STRIP001 		0x01, 0x00, 0xFE, 0xFF, 0x03, 0x0A, 0x00, 0x00,
//STRIP001 		0xFF, 0xFF, 0xFF, 0xFF, 0x23, 0x9E, 0x8C, 0x97,
//STRIP001 		0xB0, 0xD4, 0xCE, 0x11, 0xBF, 0x2D, 0x00, 0xAA,
//STRIP001 		0x00, 0x3F, 0x40, 0xD0, 0x1A, 0x00, 0x00, 0x00,
//STRIP001 		0x4D, 0x69, 0x63, 0x72, 0x6F, 0x73, 0x6F, 0x66,
//STRIP001 		0x74, 0x20, 0x46, 0x6F, 0x72, 0x6D, 0x73, 0x20,
//STRIP001 		0x32, 0x2E, 0x30, 0x20, 0x4C, 0x61, 0x62, 0x65,
//STRIP001 		0x6C, 0x00, 0x10, 0x00, 0x00, 0x00, 0x45, 0x6D,
//STRIP001 		0x62, 0x65, 0x64, 0x64, 0x65, 0x64, 0x20, 0x4F,
//STRIP001 		0x62, 0x6A, 0x65, 0x63, 0x74, 0x00, 0x0E, 0x00,
//STRIP001 		0x00, 0x00, 0x46, 0x6F, 0x72, 0x6D, 0x73, 0x2E,
//STRIP001 		0x4C, 0x61, 0x62, 0x65, 0x6C, 0x2E, 0x31, 0x00,
//STRIP001 		0xF4, 0x39, 0xB2, 0x71, 0x00, 0x00, 0x00, 0x00,
//STRIP001 		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
//STRIP001 		};
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor( rObj->OpenStream( C2S("\1CompObj")));
//STRIP001 	xStor->Write(aCompObj,sizeof(aCompObj));
//STRIP001 	DBG_ASSERT((xStor.Is() && (SVSTREAM_OK == xStor->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor3( rObj->OpenStream( C2S("\3ObjInfo")));
//STRIP001 	xStor3->Write(aObjInfo,sizeof(aObjInfo));
//STRIP001 	DBG_ASSERT((xStor3.Is() && (SVSTREAM_OK == xStor3->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	static sal_uInt8 __READONLY_DATA aOCXNAME[] = {
//STRIP001 		0x4C, 0x00, 0x61, 0x00, 0x62, 0x00, 0x65, 0x00,
//STRIP001 		0x6C, 0x00, 0x31, 0x00, 0x00, 0x00, 0x00, 0x00
//STRIP001 		};
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor2( rObj->OpenStream( C2S("\3OCXNAME")));
//STRIP001 	xStor2->Write(aOCXNAME,sizeof(aOCXNAME));
//STRIP001 	DBG_ASSERT((xStor2.Is() && (SVSTREAM_OK == xStor2->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	static sal_uInt8 __READONLY_DATA aTest[] = {
//STRIP001 		0x00, 0x02, 0x20, 0x00, 0x2B, 0x00, 0x00, 0x00,
//STRIP001 		0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0x00,
//STRIP001 		0x06, 0x00, 0x00, 0x80, 0x4C, 0x61, 0x62, 0x65,
//STRIP001 		0x6C, 0x31, 0x18, 0x00, 0xEC, 0x09, 0x00, 0x00,
//STRIP001 		0x7B, 0x02, 0x00, 0x00, 0x00, 0x02, 0x20, 0x00,
//STRIP001 		0x35, 0x00, 0x00, 0x00, 0x0F, 0x00, 0x00, 0x80,
//STRIP001 		0xC3, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00,
//STRIP001 		0x54, 0x69, 0x6D, 0x65, 0x73, 0x20, 0x4E, 0x65,
//STRIP001 		0x77, 0x20, 0x52, 0x6F, 0x6D, 0x61, 0x6E, 0x00,
//STRIP001 		};
//STRIP001 
//STRIP001 	SvStorageStreamRef xContents( rObj->OpenStream( C2S("contents")));
//STRIP001 	return WriteContents(xContents, rPropSet, rSize);
//STRIP001 }
//STRIP001 
//STRIP001 typedef OCX_Control *(*FNCreate)();
//STRIP001 
//STRIP001 
//STRIP001 struct OCX_map
//STRIP001 {
//STRIP001 	FNCreate pCreate;
//STRIP001 	const char *sId;
//STRIP001 	sal_Int16 nId;
//STRIP001 	const char *sName;
//STRIP001 };
//STRIP001 
//STRIP001 static const int NO_OCX=16;
//STRIP001 
//STRIP001 OCX_map aOCXTab[NO_OCX] =
//STRIP001 {
//STRIP001 	{&OCX_CommandButton::Create,"D7053240-CE69-11CD-a777-00dd01143c57",
//STRIP001 		form::FormComponentType::COMMANDBUTTON,"CommandButton"},
//STRIP001 	{&OCX_Label::Create, "978C9E23-D4B0-11CE-bf2d-00aa003f40d0",
//STRIP001 		form::FormComponentType::FIXEDTEXT,"Label"},
//STRIP001 	{&OCX_TextBox::Create,"8BD21D10-EC42-11CE-9e0d-00aa006002f3",
//STRIP001 		form::FormComponentType::TEXTFIELD,"TextBox"},
//STRIP001 	{&OCX_ListBox::Create,"8BD21D20-EC42-11CE-9e0d-00aa006002f3",
//STRIP001 		form::FormComponentType::LISTBOX,"ListBox"},
//STRIP001 	{&OCX_ComboBox::Create,"8BD21D30-EC42-11CE-9e0d-00aa006002f3",
//STRIP001 		form::FormComponentType::COMBOBOX,"ComboBox"},
//STRIP001 	{&OCX_CheckBox::Create,"8BD21D40-EC42-11CE-9e0d-00aa006002f3",
//STRIP001 		form::FormComponentType::CHECKBOX,"CheckBox"},
//STRIP001 	{&OCX_OptionButton::Create,"8BD21D50-EC42-11CE-9e0d-00aa006002f3",
//STRIP001 		form::FormComponentType::RADIOBUTTON,"OptionButton"},
//STRIP001 	{&OCX_ToggleButton::Create,"8BD21D60-EC42-11CE-9e0d-00aa006002f3",
//STRIP001 		-1,"ToggleButton"},
//STRIP001 	{&OCX_Image::Create,"4C599241-6926-101B-9992-00000b65c6f9",
//STRIP001 		form::FormComponentType::IMAGECONTROL,"Image"},
//STRIP001 	{&OCX_FieldControl::Create,"8BD21D10-EC42-11CE-9e0d-00aa006002f3",
//STRIP001 		form::FormComponentType::DATEFIELD,"TextBox"},
//STRIP001 	{&OCX_FieldControl::Create,"8BD21D10-EC42-11CE-9e0d-00aa006002f3",
//STRIP001 		form::FormComponentType::TIMEFIELD,"TextBox"},
//STRIP001 	{&OCX_FieldControl::Create,"8BD21D10-EC42-11CE-9e0d-00aa006002f3",
//STRIP001 		form::FormComponentType::NUMERICFIELD,"TextBox"},
//STRIP001 	{&OCX_FieldControl::Create,"8BD21D10-EC42-11CE-9e0d-00aa006002f3",
//STRIP001 		form::FormComponentType::CURRENCYFIELD,"TextBox"},
//STRIP001 	{&OCX_FieldControl::Create,"8BD21D10-EC42-11CE-9e0d-00aa006002f3",
//STRIP001 		form::FormComponentType::PATTERNFIELD,"TextBox"},
//STRIP001 #if 0
//STRIP001 	{&OCX_FieldControl::Create,"8BD21D10-EC42-11CE-9e0d-00aa006002f3",
//STRIP001 		form::FormComponentType::FORMULAFIELD,"TextBox"},
//STRIP001 #endif
//STRIP001 	{&OCX_ImageButton::Create,"D7053240-CE69-11CD-a777-00dd01143c57",
//STRIP001 		form::FormComponentType::IMAGEBUTTON,"CommandButton"},
//STRIP001 	{&OCX_GroupBox::Create,"",
//STRIP001 		form::FormComponentType::GROUPBOX,""}
//STRIP001 };
//STRIP001 
//STRIP001 SvxMSConvertOCXControls::SvxMSConvertOCXControls( SfxObjectShell *pDSh,SwPaM *pP ) :
//STRIP001     pDocSh( pDSh ), pPaM(pP),nEdit( 0 ), nCheckbox( 0 )
//STRIP001 {
//STRIP001     DBG_ASSERT( pDocSh, "No DocShell, Cannot do Controls" );
//STRIP001     OCX_Control::FillSystemColors();
//STRIP001 }
//STRIP001 
//STRIP001 OCX_Control * SvxMSConvertOCXControls::OCX_Factory(const String &sName)
//STRIP001 {
//STRIP001 	for (int i=0;i<NO_OCX;i++)
//STRIP001 	{
//STRIP001 		if ( sName.EqualsAscii( aOCXTab[i].sId ))
//STRIP001 			return(aOCXTab[i].pCreate());
//STRIP001 	}
//STRIP001 	return(NULL);
//STRIP001 }
//STRIP001 
//STRIP001 OCX_Control * SvxMSConvertOCXControls::OCX_Factory(
//STRIP001 	const uno::Reference< awt::XControlModel > &rControlModel,
//STRIP001 	String &rId, String &rName)
//STRIP001 {
//STRIP001 	rName.Erase();
//STRIP001 	rId.Erase();
//STRIP001 
//STRIP001 	uno::Reference< beans::XPropertySet > xPropSet(
//STRIP001 		rControlModel,uno::UNO_QUERY);
//STRIP001 
//STRIP001 	uno::Any aTmp = xPropSet->getPropertyValue(
//STRIP001 		OUString::createFromAscii("ClassId"));
//STRIP001 	sal_Int16 nClassId = *(sal_Int16*) aTmp.getValue();
//STRIP001 
//STRIP001 //Begin nasty hack
//STRIP001 	/*
//STRIP001 	There is a truly horrible thing with EditControls and FormattedField
//STRIP001 	Controls, they both pretend to have an EDITBOX ClassId for compability
//STRIP001 	reasons, at some stage in the future hopefully there will be a proper
//STRIP001 	FormulaField ClassId rather than this piggybacking two controls onto the
//STRIP001 	same ClassId, when this happens uncomment the FORMULAFIELD in the OCX_Tab
//STRIP001 	and delete this block, cmc.
//STRIP001 
//STRIP001 	And also the nClassId for ImageControls is being reported as "CONTROL"
//STRIP001 	rather than IMAGECONTROL
//STRIP001 	*/
//STRIP001 	if (nClassId == form::FormComponentType::TEXTFIELD)
//STRIP001 	{
//STRIP001 		uno::Reference< lang::XServiceInfo > xInfo(rControlModel,
//STRIP001 			uno::UNO_QUERY);
//STRIP001 		if (xInfo->
//STRIP001 			supportsService(OUString::createFromAscii(
//STRIP001 				"com.sun.star.form.component.FormattedField")))
//STRIP001 		{
//STRIP001 			rId.AppendAscii("8BD21D10-EC42-11CE-9e0d-00aa006002f3");
//STRIP001 			rName.AppendAscii("TextBox");
//STRIP001 			return new OCX_FieldControl;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if (nClassId == form::FormComponentType::CONTROL)
//STRIP001 	{
//STRIP001 		uno::Reference< lang::XServiceInfo > xInfo(rControlModel,
//STRIP001 			uno::UNO_QUERY);
//STRIP001 		if (xInfo->
//STRIP001 			supportsService(OUString::createFromAscii(
//STRIP001 				"com.sun.star.form.component.ImageControl")))
//STRIP001 		nClassId = form::FormComponentType::IMAGECONTROL;
//STRIP001 	}
//STRIP001 //End nasty hack
//STRIP001 
//STRIP001 	//sal_Int16  nClassId = FormComponentType::COMMANDBUTTON;
//STRIP001 
//STRIP001 	for (int i=0;i<NO_OCX;i++)
//STRIP001 	{
//STRIP001 		if ( nClassId == aOCXTab[i].nId )
//STRIP001 		{
//STRIP001 			rId.AppendAscii(aOCXTab[i].sId);
//STRIP001 			rName.AppendAscii(aOCXTab[i].sName);
//STRIP001 			return(aOCXTab[i].pCreate());
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return(NULL);
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 sal_Bool SvxMSConvertOCXControls::ReadOCXStream( SvStorageRef& rSrc1,
//STRIP001 		uno::Reference < drawing::XShape > *pShapeRef,BOOL bFloatingCtrl)
//STRIP001 {
//STRIP001 	sal_Bool bRet=sal_False;
//STRIP001 
//STRIP001 	SvStorageStreamRef xSrc2 = rSrc1->OpenStream( WW8_ASCII2STR("\3OCXNAME") );
//STRIP001 	SvStorageStream* pSt = xSrc2;
//STRIP001 	pSt->SetNumberFormatInt( NUMBERFORMAT_INT_LITTLEENDIAN );
//STRIP001 	xSrc2 = rSrc1->OpenStream( WW8_ASCII2STR("contents") );
//STRIP001 	pSt = xSrc2;
//STRIP001 	pSt->SetNumberFormatInt( NUMBERFORMAT_INT_LITTLEENDIAN );
//STRIP001 	/*Get Class Id of this object, see if it is one of the types
//STRIP001 	 *that this importer can handle, call the appropiate handler
//STRIP001 	 to read that control, and call the appropiate handler to
//STRIP001 	 insert that control
//STRIP001 	 */
//STRIP001 
//STRIP001 	OCX_Control *pObj=NULL;
//STRIP001 	SvGlobalName aTest = rSrc1->GetClassName();
//STRIP001 	if (pObj = OCX_Factory(aTest.GetHexName()))
//STRIP001 	{
//STRIP001 
//STRIP001 		::com::sun::star::awt::Size aSz;
//STRIP001 		uno::Reference< form::XFormComponent >  xFComp;
//STRIP001 		const uno::Reference< lang::XMultiServiceFactory > & rServiceFactory =
//STRIP001 			GetServiceFactory();
//STRIP001 		if(!rServiceFactory.is())
//STRIP001 			return(sal_False);
//STRIP001 		if(bRet = pObj->FullRead(pSt))
//STRIP001 			if (pObj->Import(rServiceFactory,xFComp,aSz))
//STRIP001 				bRet = InsertControl( xFComp, aSz,pShapeRef,bFloatingCtrl);
//STRIP001 		delete pObj;
//STRIP001 	}
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 sal_Bool SvxMSConvertOCXControls::ReadOCXExcelKludgeStream(
//STRIP001 	SvStorageStreamRef& rSrc1, uno::Reference < drawing::XShape > *
//STRIP001 	pShapeRef,BOOL bFloatingCtrl)
//STRIP001 {
//STRIP001 	sal_Bool bRet=sal_False;
//STRIP001 	/*Get Class Id of this object, see if it is one of the types
//STRIP001 	 *that this importer can handle, call the appropiate handler
//STRIP001 	 to read that control, and call the appropiate handler to
//STRIP001 	 insert that control
//STRIP001 	 */
//STRIP001 	/*The Excel Kludge is to concatenate a class id with a contents
//STRIP001 	 * stream, and then concatenate all the controls together,
//STRIP001 	 * This means that you should have the cnts stream wound to the
//STRIP001 	 * correct location before passing the control stream in here*/
//STRIP001 	OCX_Control *pObj=NULL;
//STRIP001 	SvStream *pSt = rSrc1;
//STRIP001 	pSt->SetNumberFormatInt( NUMBERFORMAT_INT_LITTLEENDIAN );
//STRIP001 	SvGlobalName aTest;
//STRIP001 	*pSt >> aTest;
//STRIP001 	if (pObj = OCX_Factory(aTest.GetHexName()))
//STRIP001 	{
//STRIP001 
//STRIP001 		::com::sun::star::awt::Size aSz;
//STRIP001 		uno::Reference< form::XFormComponent >  xFComp;
//STRIP001 		const uno::Reference< lang::XMultiServiceFactory > & rServiceFactory =
//STRIP001 			GetServiceFactory();
//STRIP001 		if(!rServiceFactory.is())
//STRIP001 			return(sal_False);
//STRIP001 		if(bRet = pObj->FullRead(rSrc1))
//STRIP001 			if (pObj->Import(rServiceFactory,xFComp,aSz))
//STRIP001 				bRet = InsertControl( xFComp, aSz,pShapeRef,bFloatingCtrl);
//STRIP001 		delete pObj;
//STRIP001 	}
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 sal_Bool SvxMSConvertOCXControls::WriteOCXStream( SvStorageRef& rSrc1,
//STRIP001 	const uno::Reference< awt::XControlModel > &rControlModel,
//STRIP001 	const awt::Size &rSize, String &rName)
//STRIP001 {
//STRIP001 	sal_Bool bRet=sal_False;
//STRIP001 
//STRIP001 	DBG_ASSERT( rControlModel.is(), "UNO-Control missing Model, panic!" );
//STRIP001 	if( !rControlModel.is() )
//STRIP001 		return sal_False;
//STRIP001 
//STRIP001 #if 0
//STRIP001 	uno::Any aTmp = xPropSet->getPropertyValue(
//STRIP001 		OUString::createFromAscii("ClassId"));
//STRIP001 	sal_Int16 nClassId = *(sal_Int16*) aTmp.getValue();
//STRIP001 #endif
//STRIP001 
//STRIP001 	OCX_Control *pObj=NULL;
//STRIP001 	String sId;
//STRIP001 	if (pObj = OCX_Factory(rControlModel,sId,rName))
//STRIP001 	{
//STRIP001 		uno::Reference<beans::XPropertySet> xPropSet(rControlModel,
//STRIP001 			uno::UNO_QUERY);
//STRIP001 
//STRIP001 		SvGlobalName aName;
//STRIP001 		aName.MakeId(sId);
//STRIP001 		String sFullName(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(
//STRIP001 			"Microsoft Forms 2.0 ")));
//STRIP001 		sFullName.Append(rName);
//STRIP001 		rSrc1->SetClass(aName,0x5C,sFullName);
//STRIP001 		//                    ^^^^, this pathetic 0x5c is the magic number
//STRIP001 		// which the lack of originally blocked the implementation of
//STRIP001 		// the controls export
//STRIP001 		// cmc
//STRIP001 
//STRIP001 		bRet = pObj->Export(rSrc1,xPropSet,rSize);
//STRIP001 		delete pObj;
//STRIP001 	}
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 //I think this should work for excel documents, create the "Ctls" stream
//STRIP001 //and give it here as rContents, we'll append out streams ole id and
//STRIP001 //contents here and that appears to be what Excel is doing
//STRIP001 sal_Bool SvxMSConvertOCXControls::WriteOCXExcelKludgeStream(
//STRIP001 	SvStorageStreamRef& rContents,
//STRIP001 	const uno::Reference< awt::XControlModel > &rControlModel,
//STRIP001 	const awt::Size &rSize, String &rName)
//STRIP001 {
//STRIP001 	sal_Bool bRet=sal_False;
//STRIP001 
//STRIP001 	DBG_ASSERT( rControlModel.is(), "UNO-Control missing Model, panic!" );
//STRIP001 	if( !rControlModel.is() )
//STRIP001 		return sal_False;
//STRIP001 
//STRIP001 	OCX_Control *pObj=NULL;
//STRIP001 	String sId;
//STRIP001 	if (pObj = OCX_Factory(rControlModel,sId,rName))
//STRIP001 	{
//STRIP001 		uno::Reference<beans::XPropertySet> xPropSet(rControlModel,
//STRIP001 			uno::UNO_QUERY);
//STRIP001 
//STRIP001 		SvGlobalName aName;
//STRIP001 		aName.MakeId(sId);
//STRIP001 		String sFullName(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(
//STRIP001 			"Microsoft Forms 2.0 ")));
//STRIP001 		sFullName.Append(rName);
//STRIP001 		SvStream *pS=rContents;
//STRIP001 		*pS << aName;
//STRIP001 		bRet = pObj->WriteContents(rContents,xPropSet,rSize);
//STRIP001 		delete pObj;
//STRIP001         // export needs correct stream position
//STRIP001         rContents->Seek( STREAM_SEEK_TO_END );
//STRIP001 	}
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 sal_Bool OCX_CheckBox::Import(
//STRIP001 	const uno::Reference< lang::XMultiServiceFactory >  &rServiceFactory,
//STRIP001 	uno::Reference< form::XFormComponent > &rFComp, awt::Size &rSz)
//STRIP001 {
//STRIP001 	OUString sServiceName = WW8_ASCII2STR("com.sun.star.form.component.CheckBox");
//STRIP001 	uno::Reference< uno::XInterface > xCreate =
//STRIP001 		rServiceFactory->createInstance( sServiceName );
//STRIP001 	if( !xCreate.is() )
//STRIP001 		return(sal_False);
//STRIP001 
//STRIP001 	rFComp = uno::Reference< form::XFormComponent > (xCreate,uno::UNO_QUERY);
//STRIP001 	if( !rFComp.is() )
//STRIP001 		return(sal_False);
//STRIP001 
//STRIP001 	uno::Reference< beans::XPropertySet >  xPropSet( xCreate,uno::UNO_QUERY );
//STRIP001 
//STRIP001 	rSz.Width = nWidth;
//STRIP001 	rSz.Height = nHeight;
//STRIP001 
//STRIP001 	uno::Any aTmp(&sName,getCppuType((OUString *)0));
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("Name"), aTmp );
//STRIP001 
//STRIP001 	sal_Bool bTemp;
//STRIP001 	if ((!(fEnabled)) || (fLocked))
//STRIP001 		bTemp = sal_False;
//STRIP001 	else
//STRIP001 		bTemp = sal_True;
//STRIP001 	aTmp = bool2any(bTemp);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("Enabled"), aTmp);
//STRIP001 
//STRIP001 	aTmp <<= ImportColor(nForeColor);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("TextColor"), aTmp);
//STRIP001 #if 0
//STRIP001     aTmp <<= ImportColor(nBackColor);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("BackgroundColor"), aTmp);
//STRIP001 #endif
//STRIP001 
//STRIP001 	bTemp = nMultiState;
//STRIP001 	aTmp = bool2any(bTemp);
//STRIP001 	xPropSet->setPropertyValue( WW8_ASCII2STR("TriState"), aTmp);
//STRIP001 
//STRIP001 	if (pValue)
//STRIP001 	{
//STRIP001 		INT16 nTmp=pValue[0]-0x30;
//STRIP001 		aTmp <<= nTmp;
//STRIP001 		xPropSet->setPropertyValue( WW8_ASCII2STR("DefaultState"), aTmp);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pCaption)
//STRIP001 	{
//STRIP001 		UniString sTmp(pCaption,RTL_TEXTENCODING_MS_1252);
//STRIP001 		OUString sStr = sTmp;
//STRIP001 		aTmp.setValue(&sStr,getCppuType((OUString *)0));
//STRIP001 		xPropSet->setPropertyValue( WW8_ASCII2STR("Label"), aTmp);
//STRIP001 	}
//STRIP001 
//STRIP001 	aFontData.Import(xPropSet);
//STRIP001 	return(sal_True);
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool OCX_CheckBox::WriteContents(SvStorageStreamRef &rContents,
//STRIP001     const uno::Reference< beans::XPropertySet > &rPropSet,
//STRIP001 	const awt::Size &rSize)
//STRIP001 
//STRIP001 {
//STRIP001 	sal_Bool bRet=sal_True;
//STRIP001     sal_uInt32 nOldPos = rContents->Tell();
//STRIP001 	rContents->SeekRel(12);
//STRIP001 
//STRIP001 	pBlockFlags[0] = 0;
//STRIP001 	pBlockFlags[1] = 0x01;
//STRIP001 	pBlockFlags[2] = 0;
//STRIP001 	pBlockFlags[3] = 0x80;
//STRIP001 	pBlockFlags[4] = 0;
//STRIP001 	pBlockFlags[5] = 0;
//STRIP001 	pBlockFlags[6] = 0;
//STRIP001 	pBlockFlags[7] = 0;
//STRIP001 
//STRIP001 	uno::Any aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("Enabled"));
//STRIP001 	fEnabled = any2bool(aTmp);
//STRIP001 	sal_uInt8 nTemp=fEnabled;
//STRIP001 	if (fEnabled)
//STRIP001 		nTemp = nTemp << 1;
//STRIP001 	*rContents << nTemp;
//STRIP001 	pBlockFlags[0] |= 0x01;
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("TextColor"));
//STRIP001     if (aTmp.hasValue())
//STRIP001 	    aTmp >>= nForeColor;
//STRIP001 	*rContents << ExportColor(nForeColor);
//STRIP001 	pBlockFlags[0] |= 0x04;
//STRIP001 
//STRIP001 	nStyle = 4;
//STRIP001 	*rContents << nStyle;
//STRIP001 	pBlockFlags[0] |= 0x40;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("TriState"));
//STRIP001 	nMultiState = any2bool(aTmp);
//STRIP001 	*rContents << nMultiState;
//STRIP001 	pBlockFlags[2] |= 0x20;
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 	nValueLen = 1|0x80000000;
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("DefaultState"));
//STRIP001 	INT16 nDefault;
//STRIP001 	aTmp >>= nDefault;
//STRIP001 	*rContents << nValueLen;
//STRIP001 	pBlockFlags[2] |= 0x40;
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("Label"));
//STRIP001 	OUString *pStr = (OUString *)aTmp.getValue();
//STRIP001 	nCaptionLen = pStr->getLength();
//STRIP001 	ByteString sByte;
//STRIP001 	if (nCaptionLen)
//STRIP001 	{
//STRIP001 		Align(rContents,4,TRUE);
//STRIP001 		nCaptionLen |= 0x80000000;
//STRIP001 		*rContents << nCaptionLen;
//STRIP001 		pBlockFlags[2] |= 0x80;
//STRIP001 		sByte = ByteString(String(*pStr),RTL_TEXTENCODING_MS_1252);
//STRIP001 	}
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 	*rContents << rSize.Width;
//STRIP001 	*rContents << rSize.Height;
//STRIP001 
//STRIP001 	nDefault += 0x30;
//STRIP001 	*rContents << sal_uInt8(nDefault);
//STRIP001 	*rContents << sal_uInt8(0x00);
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 	if (nCaptionLen)
//STRIP001 		rContents->Write(sByte.GetBuffer(),sByte.Len());
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001     nFixedAreaLen = static_cast<sal_uInt16>(rContents->Tell()-nOldPos-4);
//STRIP001 	bRet = aFontData.Export(rContents,rPropSet);
//STRIP001     rContents->Seek(nOldPos);
//STRIP001 	*rContents << nStandardId;
//STRIP001 	*rContents << nFixedAreaLen;
//STRIP001 
//STRIP001 	*rContents << pBlockFlags[0];
//STRIP001 	*rContents << pBlockFlags[1];
//STRIP001 	*rContents << pBlockFlags[2];
//STRIP001 	*rContents << pBlockFlags[3];
//STRIP001 	*rContents << pBlockFlags[4];
//STRIP001 	*rContents << pBlockFlags[5];
//STRIP001 	*rContents << pBlockFlags[6];
//STRIP001 	*rContents << pBlockFlags[7];
//STRIP001 
//STRIP001 	DBG_ASSERT((rContents.Is() &&
//STRIP001 		(SVSTREAM_OK==rContents->GetError())),"damn");
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 sal_Bool OCX_CheckBox::Export(SvStorageRef &rObj,
//STRIP001     const uno::Reference< beans::XPropertySet > &rPropSet,
//STRIP001 	const awt::Size &rSize)
//STRIP001 
//STRIP001 {
//STRIP001 	static sal_uInt8 __READONLY_DATA aCompObj[] = {
//STRIP001 		0x01, 0x00, 0xFE, 0xFF, 0x03, 0x0A, 0x00, 0x00,
//STRIP001 		0xFF, 0xFF, 0xFF, 0xFF, 0x40, 0x1D, 0xD2, 0x8B,
//STRIP001 		0x42, 0xEC, 0xCE, 0x11, 0x9E, 0x0D, 0x00, 0xAA,
//STRIP001 		0x00, 0x60, 0x02, 0xF3, 0x1D, 0x00, 0x00, 0x00,
//STRIP001 		0x4D, 0x69, 0x63, 0x72, 0x6F, 0x73, 0x6F, 0x66,
//STRIP001 		0x74, 0x20, 0x46, 0x6F, 0x72, 0x6D, 0x73, 0x20,
//STRIP001 		0x32, 0x2E, 0x30, 0x20, 0x43, 0x68, 0x65, 0x63,
//STRIP001 		0x6B, 0x42, 0x6F, 0x78, 0x00, 0x10, 0x00, 0x00,
//STRIP001 		0x00, 0x45, 0x6D, 0x62, 0x65, 0x64, 0x64, 0x65,
//STRIP001 		0x64, 0x20, 0x4F, 0x62, 0x6A, 0x65, 0x63, 0x74,
//STRIP001 		0x00, 0x11, 0x00, 0x00, 0x00, 0x46, 0x6F, 0x72,
//STRIP001 		0x6D, 0x73, 0x2E, 0x43, 0x68, 0x65, 0x63, 0x6B,
//STRIP001 		0x42, 0x6F, 0x78, 0x2E, 0x31, 0x00, 0xF4, 0x39,
//STRIP001 		0xB2, 0x71, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
//STRIP001 		0x00, 0x00, 0x00, 0x00, 0x00, 0x00
//STRIP001 	};
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor( rObj->OpenStream( C2S("\1CompObj")));
//STRIP001 	xStor->Write(aCompObj,sizeof(aCompObj));
//STRIP001 	DBG_ASSERT((xStor.Is() && (SVSTREAM_OK == xStor->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor3( rObj->OpenStream( C2S("\3ObjInfo")));
//STRIP001 	xStor3->Write(aObjInfo,sizeof(aObjInfo));
//STRIP001 	DBG_ASSERT((xStor3.Is() && (SVSTREAM_OK == xStor3->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	static sal_uInt8 __READONLY_DATA aOCXNAME[] = {
//STRIP001 		0x43, 0x00, 0x68, 0x00, 0x65, 0x00, 0x63, 0x00,
//STRIP001 		0x6B, 0x00, 0x42, 0x00, 0x6F, 0x00, 0x78, 0x00,
//STRIP001 		0x31, 0x00, 0x00, 0x00, 0x00, 0x00
//STRIP001 		};
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor2( rObj->OpenStream( C2S("\3OCXNAME")));
//STRIP001 	xStor2->Write(aOCXNAME,sizeof(aOCXNAME));
//STRIP001 	DBG_ASSERT((xStor2.Is() && (SVSTREAM_OK == xStor2->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	static sal_uInt8 __READONLY_DATA aTest[] = {
//STRIP001 		0x00, 0x02, 0x34, 0x00, 0x46, 0x01, 0xC0, 0x80,
//STRIP001 		0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0x00,
//STRIP001 		0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00,
//STRIP001 		0x01, 0x00, 0x00, 0x80, 0x09, 0x00, 0x00, 0x80,
//STRIP001 		0xE2, 0x0E, 0x00, 0x00, 0x95, 0x02, 0x00, 0x00,
//STRIP001 		0x30, 0x69, 0x1D, 0x00, 0x43, 0x68, 0x65, 0x63,
//STRIP001 		0x6B, 0x42, 0x6F, 0x78, 0x31, 0x20, 0x52, 0x6F,
//STRIP001 		0x00, 0x02, 0x20, 0x00, 0x35, 0x00, 0x00, 0x00,
//STRIP001 		0x0F, 0x00, 0x00, 0x80, 0xC3, 0x00, 0x00, 0x00,
//STRIP001 		0x00, 0x02, 0x00, 0x00, 0x54, 0x69, 0x6D, 0x65,
//STRIP001 		0x73, 0x20, 0x4E, 0x65, 0x77, 0x20, 0x52, 0x6F,
//STRIP001 		0x6D, 0x61, 0x6E, 0x00,
//STRIP001 	};
//STRIP001 	SvStorageStreamRef xContents( rObj->OpenStream( C2S("contents")));
//STRIP001 	return WriteContents(xContents, rPropSet, rSize);
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 sal_Bool OCX_FontData::Read(SvStorageStream *pS)
//STRIP001 {
//STRIP001 	*pS >> nIdentifier;
//STRIP001 	*pS >> nFixedAreaLen;
//STRIP001 	pS->Read(pBlockFlags,4);
//STRIP001 
//STRIP001 	if (pBlockFlags[0] & 0x01)
//STRIP001 		*pS >> nFontNameLen;
//STRIP001 	if (pBlockFlags[0] & 0x02)
//STRIP001 	{
//STRIP001 		sal_uInt8 nTmp;
//STRIP001 		*pS >> nTmp;
//STRIP001 		fBold = nTmp & 0x01;
//STRIP001 		fItalic = (nTmp & 0x02) >> 1;
//STRIP001 		fUnderline = (nTmp & 0x04) >> 2;
//STRIP001 		fStrike = (nTmp & 0x08) >> 3;
//STRIP001 		fUnknown1 = (nTmp & 0xF0) >> 4;
//STRIP001 		*pS >> nUnknown2;
//STRIP001 		*pS >> nUnknown3;
//STRIP001 		*pS >> nUnknown4;
//STRIP001 	}
//STRIP001 	if (pBlockFlags[0] & 0x04)
//STRIP001 	{
//STRIP001 		Align(pS,4);
//STRIP001 		*pS >> nFontSize;
//STRIP001 	}
//STRIP001 	if (pBlockFlags[0] & 0x10)
//STRIP001 	{
//STRIP001 		Align(pS,2);
//STRIP001 		*pS >> nLanguageID;
//STRIP001 	}
//STRIP001 	if (pBlockFlags[0] & 0x40)
//STRIP001     {
//STRIP001 		*pS >> nJustification;
//STRIP001     }
//STRIP001     if (pBlockFlags[0] & 0x80)  // font weight before font name
//STRIP001     {
//STRIP001         Align(pS,2);
//STRIP001         *pS >> nFontWeight;
//STRIP001     }
//STRIP001 
//STRIP001 	if (nFontNameLen)
//STRIP001 	{
//STRIP001 		Align(pS,4);
//STRIP001 		nFontNameLen &= 0x7FFFFFFF;
//STRIP001 		pFontName = new char[nFontNameLen+1];
//STRIP001 		pS->Read(pFontName,nFontNameLen);
//STRIP001 		pFontName[nFontNameLen]=0;
//STRIP001 	}
//STRIP001 
//STRIP001 	Align(pS,4);
//STRIP001 	return(TRUE);
//STRIP001 }
//STRIP001 
//STRIP001 void OCX_FontData::Import(uno::Reference< beans::XPropertySet > &rPropSet)
//STRIP001 {
//STRIP001 	uno::Any aTmp;
//STRIP001 	if (pFontName)
//STRIP001 	{
//STRIP001 		UniString sTmp(pFontName,RTL_TEXTENCODING_MS_1252);
//STRIP001 		OUString sStr = sTmp;
//STRIP001 		aTmp.setValue(&sStr,getCppuType((OUString *)0));
//STRIP001 		rPropSet->setPropertyValue( WW8_ASCII2STR("FontName"), aTmp);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (bHasAlign)
//STRIP001 	{
//STRIP001 		sal_Int16 nAlign = ImportAlign(nJustification);
//STRIP001 		aTmp <<= nAlign;
//STRIP001 		rPropSet->setPropertyValue( WW8_ASCII2STR("Align"), aTmp);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (fBold)
//STRIP001 	{
//STRIP001         aTmp <<= awt::FontWeight::BOLD;
//STRIP001 		rPropSet->setPropertyValue( WW8_ASCII2STR("FontWeight"), aTmp);
//STRIP001 	}
//STRIP001 
//STRIP001     if (fItalic)
//STRIP001     {
//STRIP001         aTmp <<= (sal_Int16)awt::FontSlant_ITALIC;
//STRIP001         rPropSet->setPropertyValue( WW8_ASCII2STR("FontSlant"), aTmp);
//STRIP001     }
//STRIP001 
//STRIP001     if (fUnderline)
//STRIP001     {
//STRIP001         aTmp <<= awt::FontUnderline::SINGLE;
//STRIP001         rPropSet->setPropertyValue( WW8_ASCII2STR("FontUnderline"), aTmp);
//STRIP001     }
//STRIP001 
//STRIP001     if (fStrike)
//STRIP001     {
//STRIP001         aTmp <<= awt::FontStrikeout::SINGLE;
//STRIP001         rPropSet->setPropertyValue( WW8_ASCII2STR("FontStrikeout"), aTmp);
//STRIP001     }
//STRIP001 
//STRIP001     aTmp <<= sal_Int16(nFontSize/20);
//STRIP001     rPropSet->setPropertyValue( WW8_ASCII2STR("FontHeight"), aTmp);
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool OCX_FontData::Export(SvStorageStreamRef &rContent,
//STRIP001 	const uno::Reference< beans::XPropertySet > &rPropSet)
//STRIP001 {
//STRIP001 	sal_uInt8 nFlags=0x00;
//STRIP001     sal_uInt32 nOldPos = rContent->Tell();
//STRIP001 	rContent->SeekRel(8);
//STRIP001 	ByteString sByte;
//STRIP001 	uno::Any aTmp;
//STRIP001 
//STRIP001 	if (bHasFont)
//STRIP001 	{
//STRIP001 		aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("FontName"));
//STRIP001 		OUString *pStr = (OUString *)aTmp.getValue();
//STRIP001 		nFontNameLen = pStr->getLength();
//STRIP001 		if (nFontNameLen)
//STRIP001 			sByte = ByteString(String(*pStr),RTL_TEXTENCODING_MS_1252);
//STRIP001 	}
//STRIP001 	if (!nFontNameLen)
//STRIP001 	{
//STRIP001 		sByte = ByteString("Times New Roman");
//STRIP001 		nFontNameLen = sByte.Len();
//STRIP001 	}
//STRIP001 	nFontNameLen |= 0x80000000;
//STRIP001 	*rContent << nFontNameLen;
//STRIP001 	nFlags |= 0x01;
//STRIP001 
//STRIP001 	if (bHasFont)
//STRIP001 	{
//STRIP001 		aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("FontWeight"));
//STRIP001 		float nBold;
//STRIP001 		aTmp >>= nBold;
//STRIP001 
//STRIP001 		if (nBold >= 150)
//STRIP001 		{
//STRIP001 			nFlags |= 0x02;
//STRIP001 			sal_uInt8 nTmp=0x01;
//STRIP001 			*rContent << nTmp;
//STRIP001 			nTmp=0x00;
//STRIP001 			*rContent << nTmp;
//STRIP001 			*rContent << nTmp;
//STRIP001 			*rContent << nTmp;
//STRIP001 		}
//STRIP001 
//STRIP001         aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("FontHeight"));
//STRIP001         float nFontHeight;
//STRIP001         aTmp >>= nFontHeight;
//STRIP001         if (nFontHeight)
//STRIP001         {
//STRIP001             nFlags |= 0x04;
//STRIP001             nFontSize = static_cast<sal_uInt32>(nFontHeight*20);
//STRIP001             *rContent << nFontSize;
//STRIP001         }
//STRIP001 
//STRIP001 		if (bHasAlign)
//STRIP001 		{
//STRIP001 			*rContent << sal_uInt16(0x0200);
//STRIP001 			nFlags |= 0x10;
//STRIP001 
//STRIP001 			nFlags |= 0x20; // ?
//STRIP001 
//STRIP001 			aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("Align"));
//STRIP001 			nFlags |= 0x40;
//STRIP001 			sal_Int16 nAlign(0);
//STRIP001             if (aTmp.hasValue())
//STRIP001 			    aTmp >>= nAlign;
//STRIP001 			nJustification = ExportAlign(nAlign);
//STRIP001 			*rContent << nJustification;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	Align(rContent,4,TRUE);
//STRIP001 	rContent->Write(sByte.GetBuffer(),sByte.Len());
//STRIP001 	Align(rContent,4,TRUE);
//STRIP001 
//STRIP001     sal_uInt16 nFixedAreaLen = static_cast<sal_uInt16>(rContent->Tell()-nOldPos-4);
//STRIP001 	rContent->Seek(nOldPos);
//STRIP001 	*rContent << nStandardId;
//STRIP001 	*rContent << nFixedAreaLen;
//STRIP001 	*rContent << nFlags;
//STRIP001 	*rContent << sal_uInt8(0x00);
//STRIP001 	*rContent << sal_uInt8(0x00);
//STRIP001 	*rContent << sal_uInt8(0x00);
//STRIP001 
//STRIP001 	Align(rContent,4,TRUE);
//STRIP001 	return sal_True;
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool OCX_Image::WriteContents(SvStorageStreamRef &rContents,
//STRIP001 	const uno::Reference< beans::XPropertySet > &rPropSet,
//STRIP001 	const awt::Size &rSize)
//STRIP001 {
//STRIP001 	sal_Bool bRet=sal_True;
//STRIP001     sal_uInt32 nOldPos = rContents->Tell();
//STRIP001 	rContents->SeekRel(8);
//STRIP001 
//STRIP001 	pBlockFlags[0] = 0;
//STRIP001 	pBlockFlags[1] = 0x02;
//STRIP001 	pBlockFlags[2] = 0;
//STRIP001 	pBlockFlags[3] = 0;
//STRIP001 
//STRIP001 	uno::Any aTmp = rPropSet->getPropertyValue(
//STRIP001 		WW8_ASCII2STR("BackgroundColor"));
//STRIP001     if (aTmp.hasValue())
//STRIP001 	    aTmp >>= nBackColor;
//STRIP001 	*rContents << ExportColor(nBackColor);
//STRIP001 	pBlockFlags[0] |= 0x10;
//STRIP001 
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("Border"));
//STRIP001 	sal_Int16 nBorder;
//STRIP001 	aTmp >>= nBorder;
//STRIP001 	nSpecialEffect = ExportBorder(nBorder,nBorderStyle);
//STRIP001 	*rContents << nBorderStyle;
//STRIP001 	pBlockFlags[0] |= 0x20;
//STRIP001 
//STRIP001 	*rContents << nSpecialEffect;
//STRIP001 	pBlockFlags[1] |= 0x01;
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("Enabled"));
//STRIP001 	fEnabled = any2bool(aTmp);
//STRIP001 	if (fEnabled)
//STRIP001 	{
//STRIP001 		sal_uInt8 nTemp = 0x19;
//STRIP001 		*rContents << nTemp;
//STRIP001 		pBlockFlags[1] |= 0x20;
//STRIP001 		*rContents << sal_uInt8(0x00);
//STRIP001 		*rContents << sal_uInt8(0x00);
//STRIP001 		*rContents << sal_uInt8(0x00);
//STRIP001 	}
//STRIP001 
//STRIP001 	aTmp = rPropSet->getPropertyValue(WW8_ASCII2STR("ImageURL"));
//STRIP001 	OUString *pStr = (OUString *)aTmp.getValue();
//STRIP001 	/*Magically fetch that image and turn it into something that
//STRIP001 	 *we can store in ms controls, wmf,png,jpg are almost certainly
//STRIP001 	 *the options we have for export...*/
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001 	*rContents << rSize.Width;
//STRIP001 	*rContents << rSize.Height;
//STRIP001 
//STRIP001 	Align(rContents,4,TRUE);
//STRIP001     nFixedAreaLen = static_cast<sal_uInt16>(rContents->Tell()-nOldPos-4);
//STRIP001 
//STRIP001     rContents->Seek(nOldPos);
//STRIP001 	*rContents << nStandardId;
//STRIP001 	*rContents << nFixedAreaLen;
//STRIP001 
//STRIP001 	*rContents << pBlockFlags[0];
//STRIP001 	*rContents << pBlockFlags[1];
//STRIP001 	*rContents << pBlockFlags[2];
//STRIP001 	*rContents << pBlockFlags[3];
//STRIP001 	DBG_ASSERT((rContents.Is() &&
//STRIP001 		(SVSTREAM_OK==rContents->GetError())),"damn");
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 sal_Bool OCX_Image::Export(SvStorageRef &rObj,
//STRIP001 	const uno::Reference< beans::XPropertySet > &rPropSet,
//STRIP001 	const awt::Size &rSize)
//STRIP001 {
//STRIP001 	sal_Bool bRet=sal_True;
//STRIP001 
//STRIP001 	static sal_uInt8 __READONLY_DATA aCompObj[] = {
//STRIP001 		0x01, 0x00, 0xFE, 0xFF, 0x03, 0x0A, 0x00, 0x00,
//STRIP001 		0xFF, 0xFF, 0xFF, 0xFF, 0x41, 0x92, 0x59, 0x4C,
//STRIP001 		0x26, 0x69, 0x1B, 0x10, 0x99, 0x92, 0x00, 0x00,
//STRIP001 		0x0B, 0x65, 0xC6, 0xF9, 0x1A, 0x00, 0x00, 0x00,
//STRIP001 		0x4D, 0x69, 0x63, 0x72, 0x6F, 0x73, 0x6F, 0x66,
//STRIP001 		0x74, 0x20, 0x46, 0x6F, 0x72, 0x6D, 0x73, 0x20,
//STRIP001 		0x32, 0x2E, 0x30, 0x20, 0x49, 0x6D, 0x61, 0x67,
//STRIP001 		0x65, 0x00, 0x10, 0x00, 0x00, 0x00, 0x45, 0x6D,
//STRIP001 		0x62, 0x65, 0x64, 0x64, 0x65, 0x64, 0x20, 0x4F,
//STRIP001 		0x62, 0x6A, 0x65, 0x63, 0x74, 0x00, 0x0E, 0x00,
//STRIP001 		0x00, 0x00, 0x46, 0x6F, 0x72, 0x6D, 0x73, 0x2E,
//STRIP001 		0x49, 0x6D, 0x61, 0x67, 0x65, 0x2E, 0x31, 0x00,
//STRIP001 		0xF4, 0x39, 0xB2, 0x71, 0x00, 0x00, 0x00, 0x00,
//STRIP001 		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
//STRIP001 		};
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor( rObj->OpenStream( C2S("\1CompObj")));
//STRIP001 	xStor->Write(aCompObj,sizeof(aCompObj));
//STRIP001 	DBG_ASSERT((xStor.Is() && (SVSTREAM_OK == xStor->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor3( rObj->OpenStream( C2S("\3ObjInfo")));
//STRIP001 	xStor3->Write(aObjInfo,sizeof(aObjInfo));
//STRIP001 	DBG_ASSERT((xStor3.Is() && (SVSTREAM_OK == xStor3->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	static sal_uInt8 __READONLY_DATA aOCXNAME[] = {
//STRIP001 		0x49, 0x00, 0x6D, 0x00, 0x61, 0x00, 0x67, 0x00,
//STRIP001 		0x65, 0x00, 0x31, 0x00, 0x00, 0x00, 0x00, 0x00
//STRIP001 		};
//STRIP001 
//STRIP001 	{
//STRIP001 	SvStorageStreamRef xStor2( rObj->OpenStream( C2S("\3OCXNAME")));
//STRIP001 	xStor2->Write(aOCXNAME,sizeof(aOCXNAME));
//STRIP001 	DBG_ASSERT((xStor2.Is() && (SVSTREAM_OK == xStor2->GetError())),"damn");
//STRIP001 	}
//STRIP001 
//STRIP001 	SvStorageStreamRef xContents( rObj->OpenStream( C2S("contents")));
//STRIP001 	return WriteContents(xContents, rPropSet, rSize);
//STRIP001 }

/* vi:set tabstop=4 shiftwidth=4 expandtab: */
}
