/*************************************************************************
 *
 *  $RCSfile: svx_modctrl.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 16:15:47 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#ifndef _STATUS_HXX //autogen
#include <vcl/status.hxx>
#endif
#ifndef _SFXENUMITEM_HXX
#include <svtools/eitem.hxx>
#endif
#ifndef _SFXAPP_HXX //autogen
#include <bf_sfx2/app.hxx>
#endif
#pragma hdrstop

#define _SVX_MODCTRL_CXX

#include "dialogs.hrc"

#include "modctrl.hxx"
// auto strip #include "dialmgr.hxx"
namespace binfilter {

/*N*/ SFX_IMPL_STATUSBAR_CONTROL(SvxModifyControl, SfxBoolItem);

// class SvxModifyControl ------------------------------------------------

/*?*/ SvxModifyControl::SvxModifyControl( USHORT nId,
/*?*/ 									StatusBar& rStb, SfxBindings& rBind ) :
/*?*/ 
/*?*/ 	SfxStatusBarControl( nId, rStb, rBind ),
/*?*/ 
/*?*/ 	bState( TRUE )
/*?*/ {
/*?*/ }

// -----------------------------------------------------------------------

//STRIP001 void SvxModifyControl::StateChanged( USHORT nSID, SfxItemState eState,
//STRIP001 									 const SfxPoolItem* pState )
//STRIP001 {
//STRIP001 	if ( SFX_ITEM_AVAILABLE != eState )
//STRIP001 		GetStatusBar().SetItemText( GetId(), String() );
//STRIP001 	else
//STRIP001 	{
//STRIP001 		DBG_ASSERT( pState->ISA( SfxBoolItem ), "invalid item type" );
//STRIP001 		SfxBoolItem* pItem = (SfxBoolItem*)pState;
//STRIP001 		bState = pItem->GetValue();
//STRIP001 		DrawItemText_Impl();
//STRIP001 	}
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void SvxModifyControl::Paint( const UserDrawEvent& rUsrEvt )
//STRIP001 {
//STRIP001 	DrawItemText_Impl();
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void SvxModifyControl::DrawItemText_Impl()
//STRIP001 {
//STRIP001 	String sMode;
//STRIP001 
//STRIP001 	if ( bState )
//STRIP001 		sMode = '*';
//STRIP001 	GetStatusBar().SetItemText( GetId(), sMode );
//STRIP001 }

/*N*/ ULONG SvxModifyControl::GetDefItemWidth(const StatusBar& rStb)
/*N*/ {
/*N*/ 	return rStb.GetTextWidth(String::CreateFromAscii("XX"));
/*N*/ }


}
