/*************************************************************************
 *
 *  $RCSfile: svx_lboxctrl.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 16:37:00 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef   _TOOLS_DEBUG_HXX
// auto strip #include <tools/debug.hxx>
#endif
// auto strip #ifndef _SV_LSTBOX_HXX
// auto strip #include <vcl/lstbox.hxx>
// auto strip #endif
#ifndef _SV_TOOLBOX_HXX
#include <vcl/toolbox.hxx>
#endif
// auto strip #ifndef _SV_EVENT_HXX
// auto strip #include <vcl/event.hxx>
// auto strip #endif
// auto strip #ifndef _SFXAPP_HXX
// auto strip #include <bf_sfx2/app.hxx>
// auto strip #endif
// auto strip #ifndef _SFXTBXCTRL_HXX
// auto strip #include <bf_sfx2/tbxctrl.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_BINDINGS_HXX
// auto strip #include <bf_sfx2/bindings.hxx>
// auto strip #endif
#ifndef _SFXDISPATCH_HXX
#include <bf_sfx2/dispatch.hxx>
#endif
// auto strip #ifndef _SFXVIEWSH_HXX
// auto strip #include <bf_sfx2/viewsh.hxx>
// auto strip #endif
// auto strip #ifndef _SV_GEN_HXX
// auto strip #include <tools/gen.hxx>
// auto strip #endif
// auto strip #ifndef _SFXINTITEM_HXX
// auto strip #include <svtools/intitem.hxx>
// auto strip #endif
// auto strip #ifndef _SFXENUMITEM_HXX
// auto strip #include <svtools/eitem.hxx>
// auto strip #endif
// auto strip #ifndef _STDCTRL_HXX
// auto strip #include <svtools/stdctrl.hxx>
// auto strip #endif
// auto strip #ifndef _SFXSLSTITM_HXX
// auto strip #include <svtools/slstitm.hxx>
// auto strip #endif
#ifndef _SFXSTRITEM_HXX
#include <svtools/stritem.hxx>
#endif

// auto strip #ifndef _SVX_DIALMGR_HXX
// auto strip #include <dialmgr.hxx>
// auto strip #endif
#ifndef _SVX_LBOXCTRL_HXX_
#include <lboxctrl.hxx>
#endif

#include <svxids.hrc>
#include <dialogs.hrc>

#include "lboxctrl.hrc"
namespace binfilter {

class SvxPopupWindowListBox;

/////////////////////////////////////////////////////////////////

//STRIP001 class SvxPopupWindowListBox : public SfxPopupWindow
//STRIP001 {
//STRIP001 	FixedInfo		aInfo;
//STRIP001 	ListBox	*		pListBox;
//STRIP001 	ToolBox &		rToolBox;
//STRIP001 	BOOL			bUserSel;
//STRIP001 	// disallow copy-constructor and assignment-operator
//STRIP001 
//STRIP001 	SvxPopupWindowListBox(const& );
//STRIP001 	SvxPopupWindowListBox & operator = (const& );
//STRIP001 
//STRIP001 	SvxPopupWindowListBox( USHORT nSlotId,
//STRIP001 						   ToolBox& rTbx, USHORT nTbxItemId );
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxPopupWindowListBox( USHORT nSlotId,
//STRIP001                            ToolBox& rTbx,
//STRIP001 						   SfxBindings &rBindings );
//STRIP001 	virtual ~SvxPopupWindowListBox();
//STRIP001 
//STRIP001 	// SfxPopupWindow
//STRIP001 	virtual SfxPopupWindow * 	Clone() const;
//STRIP001 	virtual void 				PopupModeEnd();
//STRIP001 	virtual void 				StateChanged( USHORT nSID, SfxItemState eState,
//STRIP001 											  const SfxPoolItem* pState );
//STRIP001 
//STRIP001 	void 						StartSelection();
//STRIP001 	inline ListBox &			GetListBox()	{ return *pListBox; }
//STRIP001 	inline FixedInfo &			GetInfo()		{ return aInfo; }
//STRIP001 
//STRIP001 	BOOL						IsUserSelected() const			{ return bUserSel; }
//STRIP001 	void						SetUserSelected( BOOL bVal )	{ bUserSel = bVal; }
//STRIP001     /*virtual*/Window*                     GetPreferredKeyInputWindow();
//STRIP001 };

/////////////////////////////////////////////////////////////////

//STRIP001 SvxPopupWindowListBox::SvxPopupWindowListBox(
//STRIP001 			USHORT nSlotId,
//STRIP001             ToolBox& rTbx,
//STRIP001 			SfxBindings &rBindings ) :
//STRIP001 
//STRIP001 	SfxPopupWindow( nSlotId, SVX_RES( RID_SVXTBX_UNDO_REDO_CTRL ), rBindings ),
//STRIP001 	aInfo		( this, ResId( FT_NUM_OPERATIONS ) ),
//STRIP001 	rToolBox	( rTbx ),
//STRIP001 	bUserSel	( FALSE )
//STRIP001 {
//STRIP001 	DBG_ASSERT( nSlotId == GetId(), "id mismatch" );
//STRIP001     pListBox = new ListBox( this, SVX_RES( LB_SVXTBX_UNDO_REDO_CTRL ) );
//STRIP001 	FreeResource();
//STRIP001     pListBox->EnableMultiSelection( TRUE, TRUE );
//STRIP001 	SetBackground( GetSettings().GetStyleSettings().GetDialogColor() );
//STRIP001 }


//STRIP001 SvxPopupWindowListBox::~SvxPopupWindowListBox()
//STRIP001 {
//STRIP001 	delete pListBox;
//STRIP001 }


//STRIP001 SfxPopupWindow* SvxPopupWindowListBox::Clone() const
//STRIP001 {
//STRIP001     return new SvxPopupWindowListBox( GetId(), rToolBox,
//STRIP001                                       (SfxBindings &) GetBindings() );
//STRIP001 }


//STRIP001 void SvxPopupWindowListBox::PopupModeEnd()
//STRIP001 {
//STRIP001 	rToolBox.EndSelection();
//STRIP001 	SfxPopupWindow::PopupModeEnd();
//STRIP001 	//FloatingWindow::PopupModeEnd();
//STRIP001 
//STRIP001     Window* pShellWnd = SfxViewShell::Current()->GetWindow();
//STRIP001     if (pShellWnd)
//STRIP001 		pShellWnd->GrabFocus();
//STRIP001 }


//STRIP001 void SvxPopupWindowListBox::StateChanged(
//STRIP001 		USHORT nSID, SfxItemState eState, const SfxPoolItem* pState )
//STRIP001 {
//STRIP001 	rToolBox.EnableItem( GetId(), (GetItemState(pState) != SFX_ITEM_DISABLED) );
//STRIP001 	SfxPopupWindow::StateChanged( nSID, eState, pState );
//STRIP001 }


//STRIP001 void SvxPopupWindowListBox::StartSelection()
//STRIP001 {
//STRIP001 	rToolBox.StartSelection();
//STRIP001 }

//STRIP001 Window* SvxPopupWindowListBox::GetPreferredKeyInputWindow()
//STRIP001 {
//STRIP001     // allows forwarding key events in the correct window
//STRIP001     // without setting the focus
//STRIP001     return pListBox->GetPreferredKeyInputWindow();
//STRIP001 }

/////////////////////////////////////////////////////////////////

//STRIP001 SFX_IMPL_TOOLBOX_CONTROL( SvxListBoxControl, SfxStringItem );


/*N*/ SvxListBoxControl::SvxListBoxControl(
/*N*/ 							USHORT nId, ToolBox& rTbx, SfxBindings& rBind )
/*N*/ 	:SfxToolBoxControl( nId, rTbx, rBind ),
/*N*/ 	pPopupWin	( 0 )
/*N*/ {
/*N*/ 	rTbx.SetItemBits( nId, TIB_DROPDOWN | rTbx.GetItemBits( nId ) );
/*N*/ 	rTbx.Invalidate();
/*N*/ }


/*N*/ SvxListBoxControl::~SvxListBoxControl()
/*N*/ {
/*N*/ }


//STRIP001 SfxPopupWindow* SvxListBoxControl::CreatePopupWindow()
//STRIP001 {
//STRIP001 	DBG_ERROR( "not implemented" );
//STRIP001 	return 0;
//STRIP001 }


//STRIP001 SfxPopupWindowType SvxListBoxControl::GetPopupWindowType() const
//STRIP001 {
//STRIP001 	return SFX_POPUPWINDOW_ONTIMEOUT;
//STRIP001 }


/*N*/ void SvxListBoxControl::StateChanged(
/*N*/ 		USHORT nSID, SfxItemState eState, const SfxPoolItem* pState )
/*N*/ {
/*N*/ 	GetToolBox().EnableItem( GetId(),
/*N*/ 							SFX_ITEM_DISABLED != GetItemState(pState) );
/*N*/ }


//STRIP001 IMPL_LINK( SvxListBoxControl, PopupModeEndHdl, void *, EMPTYARG )
//STRIP001 {
//STRIP001 	if( pPopupWin && 0 == pPopupWin->GetPopupModeFlags()  &&
//STRIP001 		pPopupWin->IsUserSelected() )
//STRIP001 	{
//STRIP001         USHORT nCount = pPopupWin->GetListBox().GetSelectEntryCount();
//STRIP001         SfxUInt16Item aItem( GetId(), nCount );
//STRIP001 		GetBindings().GetDispatcher()->Execute( GetId(),
//STRIP001 										SFX_CALLMODE_SYNCHRON, &aItem, 0L );
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }


//STRIP001 void SvxListBoxControl::Impl_SetInfo( USHORT nCount )
//STRIP001 {
//STRIP001     DBG_ASSERT( pPopupWin, "NULL pointer, PopupWindow missing" );
//STRIP001     String aText( aActionStr );
//STRIP001     aText.SearchAndReplaceAllAscii( "$(ARG1)", String::CreateFromInt32( nCount ) );
//STRIP001     pPopupWin->GetInfo().SetText( aText );
//STRIP001 }


//STRIP001 IMPL_LINK( SvxListBoxControl, SelectHdl, void *, EMPTYARG )
//STRIP001 {
//STRIP001     if (pPopupWin)
//STRIP001     {
//STRIP001         //pPopupWin->SetUserSelected( FALSE );
//STRIP001 
//STRIP001         ListBox &rListBox = pPopupWin->GetListBox();
//STRIP001         if (rListBox.IsTravelSelect())
//STRIP001             Impl_SetInfo( rListBox.GetSelectEntryCount() );
//STRIP001         else
//STRIP001         {
//STRIP001             pPopupWin->SetUserSelected( TRUE );
//STRIP001             pPopupWin->EndPopupMode( 0 );
//STRIP001         }
//STRIP001     }
//STRIP001 	return 0;
//STRIP001 }

/////////////////////////////////////////////////////////////////

/*N*/ SFX_IMPL_TOOLBOX_CONTROL( SvxUndoRedoControl, SfxStringItem );

/*N*/ SvxUndoRedoControl::~SvxUndoRedoControl()
/*N*/ {
/*N*/ }


//STRIP001 SfxPopupWindow* SvxUndoRedoControl::CreatePopupWindow()
//STRIP001 {
//STRIP001 	const USHORT nId = GetId();
//STRIP001 	DBG_ASSERT( SID_UNDO == nId || SID_REDO == nId, "mismatching ids" );
//STRIP001 
//STRIP001 	const SfxPoolItem* pState = 0;
//STRIP001 	SfxBindings &rBindings = GetBindings();
//STRIP001 	SfxDispatcher &rDispatch = *rBindings.GetDispatcher();
//STRIP001 	SfxItemState eState = rDispatch.QueryState( SID_UNDO == nId
//STRIP001 												? SID_GETUNDOSTRINGS
//STRIP001 												: SID_GETREDOSTRINGS, pState );
//STRIP001 
//STRIP001 	if( eState >= SFX_ITEM_AVAILABLE  &&  pState)
//STRIP001 	{
//STRIP001 		ToolBox& rBox = GetToolBox();
//STRIP001 
//STRIP001         pPopupWin = new SvxPopupWindowListBox( nId, rBox, rBindings );
//STRIP001 		pPopupWin->SetPopupModeEndHdl( LINK( this, SvxUndoRedoControl,
//STRIP001 												PopupModeEndHdl ) );
//STRIP001 		ListBox &rListBox = pPopupWin->GetListBox();
//STRIP001         rListBox.SetSelectHdl( LINK( this, SvxUndoRedoControl, SelectHdl ) );
//STRIP001 
//STRIP001 		SfxStringListItem &rItem = *(SfxStringListItem *) pState;
//STRIP001 		const List* pLst = rItem.GetList();
//STRIP001 		DBG_ASSERT( pLst, "no undo actions available" );
//STRIP001 		if( pLst )
//STRIP001 			for( long nI = 0, nEnd = pLst->Count(); nI < nEnd; ++nI )
//STRIP001 				rListBox.InsertEntry( *((String*)pLst->GetObject( nI )) );
//STRIP001 		rListBox.SelectEntryPos( 0 );
//STRIP001 
//STRIP001     	aActionStr = String( SVX_RES( SID_UNDO == nId
//STRIP001 										? RID_SVXSTR_NUM_UNDO_ACTIONS
//STRIP001 					   					: RID_SVXSTR_NUM_REDO_ACTIONS ) );
//STRIP001         Impl_SetInfo( rListBox.GetSelectEntryCount() );
//STRIP001 
//STRIP001 
//STRIP001         // move focus in floating window without
//STRIP001         // closing it (GrabFocus() would close it!)
//STRIP001         pPopupWin->StartPopupMode( &rBox, FLOATWIN_POPUPMODE_GRABFOCUS );
//STRIP001         //pPopupWin->GetListBox().GrabFocus();
//STRIP001 	}
//STRIP001 	return pPopupWin;
//STRIP001 }



}
