/*************************************************************************
 *
 *  $RCSfile: sw_unmove.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 18:05:31 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif
// auto strip #ifndef _DOC_HXX
// auto strip #include <doc.hxx>
// auto strip #endif
#ifndef _ERRHDL_HXX
#include <errhdl.hxx>
#endif
// auto strip #ifndef _PAM_HXX
// auto strip #include <pam.hxx>
// auto strip #endif
// auto strip #ifndef _SWUNDO_HXX
// auto strip #include <swundo.hxx>			// fuer die UndoIds
// auto strip #endif
// auto strip #ifndef _NDTXT_HXX
// auto strip #include <ndtxt.hxx>
// auto strip #endif
// auto strip #ifndef _UNDOBJ_HXX
// auto strip #include <undobj.hxx>
// auto strip #endif
// auto strip #ifndef _ROLBCK_HXX
// auto strip #include <rolbck.hxx>
// auto strip #endif
namespace binfilter {


//STRIP001 inline SwDoc& SwUndoIter::GetDoc() const { return *pAktPam->GetDoc(); }

// MOVE

//STRIP001 SwUndoMove::SwUndoMove( const SwPaM& rRange, const SwPosition& rMvPos )
//STRIP001 	: SwUndo( UNDO_MOVE ), SwUndRng( rRange ),
//STRIP001 	nMvDestNode( rMvPos.nNode.GetIndex() ),
//STRIP001 	nMvDestCntnt( rMvPos.nContent.GetIndex() )
//STRIP001 {
//STRIP001 	bMoveRange = bJoinNext = bJoinPrev = FALSE;
//STRIP001 
//STRIP001 	// StartNode vorm loeschen von Fussnoten besorgen!
//STRIP001 	SwDoc* pDoc = rRange.GetDoc();
//STRIP001 	SwTxtNode* pTxtNd = pDoc->GetNodes()[ nSttNode ]->GetTxtNode();
//STRIP001 	SwTxtNode* pEndTxtNd = pDoc->GetNodes()[ nEndNode ]->GetTxtNode();
//STRIP001 
//STRIP001 	pHistory = new SwHistory;
//STRIP001 
//STRIP001 	if( pTxtNd )
//STRIP001 	{
//STRIP001 		pHistory->Add( pTxtNd->GetTxtColl(), nSttNode, ND_TEXTNODE );
//STRIP001 		if( pTxtNd->GetpSwpHints() )
//STRIP001 			pHistory->CopyAttr( pTxtNd->GetpSwpHints(), nSttNode,
//STRIP001 								0, pTxtNd->GetTxt().Len(), FALSE );
//STRIP001 		if( pTxtNd->GetpSwAttrSet() )
//STRIP001 			pHistory->CopyFmtAttr( *pTxtNd->GetpSwAttrSet(), nSttNode );
//STRIP001 	}
//STRIP001 	if( pEndTxtNd && pEndTxtNd != pTxtNd )
//STRIP001 	{
//STRIP001 		pHistory->Add( pEndTxtNd->GetTxtColl(), nEndNode, ND_TEXTNODE );
//STRIP001 		if( pEndTxtNd->GetpSwpHints() )
//STRIP001 			pHistory->CopyAttr( pEndTxtNd->GetpSwpHints(), nEndNode,
//STRIP001 								0, pEndTxtNd->GetTxt().Len(), FALSE );
//STRIP001 		if( pEndTxtNd->GetpSwAttrSet() )
//STRIP001 			pHistory->CopyFmtAttr( *pEndTxtNd->GetpSwAttrSet(), nEndNode );
//STRIP001 	}
//STRIP001 
//STRIP001 	if( 0 != (pTxtNd = rRange.GetDoc()->GetNodes()[ rMvPos.nNode ]->GetTxtNode() ))
//STRIP001 	{
//STRIP001 		pHistory->Add( pTxtNd->GetTxtColl(), nMvDestNode, ND_TEXTNODE );
//STRIP001 		if( pTxtNd->GetpSwpHints() )
//STRIP001 			pHistory->CopyAttr( pTxtNd->GetpSwpHints(), nMvDestNode,
//STRIP001 								0, pTxtNd->GetTxt().Len(), FALSE );
//STRIP001 		if( pTxtNd->GetpSwAttrSet() )
//STRIP001 			pHistory->CopyFmtAttr( *pTxtNd->GetpSwAttrSet(), nMvDestNode );
//STRIP001 	}
//STRIP001 
//STRIP001 
//STRIP001 	nFtnStt = pHistory->Count();
//STRIP001 	DelFtn( rRange );
//STRIP001 
//STRIP001 	if( pHistory && !pHistory->Count() )
//STRIP001 		DELETEZ( pHistory );
//STRIP001 }


//STRIP001 SwUndoMove::SwUndoMove( SwDoc* pDoc, const SwNodeRange& rRg,
//STRIP001 						const SwNodeIndex& rMvPos )
//STRIP001 	: SwUndo( UNDO_MOVE ),
//STRIP001 	nMvDestNode( rMvPos.GetIndex() )
//STRIP001 {
//STRIP001 	bMoveRange = TRUE;
//STRIP001 	bJoinNext = bJoinPrev = FALSE;
//STRIP001 
//STRIP001 	nSttCntnt = nEndCntnt = nMvDestCntnt = STRING_MAXLEN;
//STRIP001 
//STRIP001 	nSttNode = rRg.aStart.GetIndex();
//STRIP001 	nEndNode = rRg.aEnd.GetIndex();
//STRIP001 
//STRIP001 //	DelFtn( rRange );
//STRIP001 
//STRIP001 	// wird aus dem CntntBereich in den Sonderbereich verschoben ?
//STRIP001 	ULONG nCntntStt = pDoc->GetNodes().GetEndOfAutotext().GetIndex();
//STRIP001 	if( nMvDestNode < nCntntStt && rRg.aStart.GetIndex() > nCntntStt )
//STRIP001 	{
//STRIP001 		// loesche alle Fussnoten. Diese sind dort nicht erwuenscht.
//STRIP001 		SwPosition aPtPos( rRg.aEnd );
//STRIP001 		SwCntntNode* pCNd = rRg.aEnd.GetNode().GetCntntNode();
//STRIP001 		if( pCNd )
//STRIP001 			aPtPos.nContent.Assign( pCNd, pCNd->Len() );
//STRIP001 		SwPosition aMkPos( rRg.aStart );
//STRIP001 		if( 0 != ( pCNd = aMkPos.nNode.GetNode().GetCntntNode() ))
//STRIP001 			aMkPos.nContent.Assign( pCNd, 0 );
//STRIP001 
//STRIP001 		DelCntntIndex( aMkPos, aPtPos, SwUndoSaveCntnt::DELCNT_FTN );
//STRIP001 
//STRIP001 		if( pHistory && !pHistory->Count() )
//STRIP001 			DELETEZ( pHistory );
//STRIP001 	}
//STRIP001 
//STRIP001 	nFtnStt = 0;
//STRIP001 }



//STRIP001 void SwUndoMove::SetDestRange( const SwPaM& rRange,
//STRIP001 								const SwPosition& rInsPos,
//STRIP001 								BOOL bJoin, BOOL bCorrPam )
//STRIP001 {
//STRIP001 	const SwPosition *pStt = rRange.Start(),
//STRIP001 					*pEnd = rRange.GetPoint() == pStt
//STRIP001 						? rRange.GetMark()
//STRIP001 						: rRange.GetPoint();
//STRIP001 
//STRIP001 	nDestSttNode	= pStt->nNode.GetIndex();
//STRIP001 	nDestSttCntnt	= pStt->nContent.GetIndex();
//STRIP001 	nDestEndNode	= pEnd->nNode.GetIndex();
//STRIP001 	nDestEndCntnt	= pEnd->nContent.GetIndex();
//STRIP001 
//STRIP001 	nInsPosNode     = rInsPos.nNode.GetIndex();
//STRIP001 	nInsPosCntnt	= rInsPos.nContent.GetIndex();
//STRIP001 
//STRIP001 	if( bCorrPam )
//STRIP001 	{
//STRIP001 		nDestSttNode--;
//STRIP001 		nDestEndNode--;
//STRIP001 	}
//STRIP001 
//STRIP001 	bJoinNext = nDestSttNode != nDestEndNode &&
//STRIP001 				pStt->nNode.GetNode().GetTxtNode() &&
//STRIP001 				pEnd->nNode.GetNode().GetTxtNode();
//STRIP001 	bJoinPrev = bJoin;
//STRIP001 }


//STRIP001 void SwUndoMove::SetDestRange( const SwNodeIndex& rStt,
//STRIP001 								const SwNodeIndex& rEnd,
//STRIP001 								const SwNodeIndex& rInsPos )
//STRIP001 {
//STRIP001 	nDestSttNode = rStt.GetIndex();
//STRIP001 	nDestEndNode = rEnd.GetIndex();
//STRIP001 	if( nDestSttNode > nDestEndNode )
//STRIP001 	{
//STRIP001 		nDestSttNode = nDestEndNode;
//STRIP001 		nDestEndNode = rStt.GetIndex();
//STRIP001 	}
//STRIP001 	nInsPosNode  = rInsPos.GetIndex();
//STRIP001 
//STRIP001 	nDestSttCntnt = nDestEndCntnt = nInsPosCntnt = STRING_MAXLEN;
//STRIP001 }


//STRIP001 void SwUndoMove::Undo( SwUndoIter& rUndoIter )
//STRIP001 {
//STRIP001 	SwDoc* pDoc = &rUndoIter.GetDoc();
//STRIP001 	BOOL bUndo = pDoc->DoesUndo();
//STRIP001 	pDoc->DoUndo( FALSE );
//STRIP001 
//STRIP001 	// Block, damit aus diesem gesprungen werden kann
//STRIP001 	do {
//STRIP001 		// erzeuge aus den Werten die Insert-Position und den Bereich
//STRIP001 		SwNodeIndex aIdx( pDoc->GetNodes(), nDestSttNode );
//STRIP001 
//STRIP001 		if( bMoveRange )
//STRIP001 		{
//STRIP001 			// nur ein Move mit SwRange
//STRIP001 			SwNodeRange aRg( aIdx, aIdx );
//STRIP001 			aRg.aEnd = nDestEndNode;
//STRIP001 			aIdx = nInsPosNode;
//STRIP001 			if( !pDoc->Move( aRg, aIdx ) )
//STRIP001 				break;
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			SwPaM aPam( aIdx.GetNode(), nDestSttCntnt,
//STRIP001 						*pDoc->GetNodes()[ nDestEndNode ], nDestEndCntnt );
//STRIP001 
//STRIP001 			RemoveIdxFromRange( aPam, FALSE );
//STRIP001 
//STRIP001 			SwPosition aPos( *pDoc->GetNodes()[ nInsPosNode] );
//STRIP001 			SwCntntNode* pCNd = aPos.nNode.GetNode().GetCntntNode();
//STRIP001 			aPos.nContent.Assign( pCNd, nInsPosCntnt );
//STRIP001 
//STRIP001 			if( pCNd->GetpSwAttrSet() )
//STRIP001 				pCNd->ResetAllAttr();
//STRIP001 
//STRIP001 			if( pCNd->IsTxtNode() && ((SwTxtNode*)pCNd)->GetpSwpHints() )
//STRIP001 				((SwTxtNode*)pCNd)->ClearSwpHintsArr( FALSE, FALSE );
//STRIP001 
//STRIP001 			// an der InsertPos erstmal alle Attribute entfernen,
//STRIP001 			if( !pDoc->Move( aPam, aPos ) )
//STRIP001 				break;
//STRIP001 
//STRIP001 			aPam.Exchange();
//STRIP001 			aPam.DeleteMark();
//STRIP001 //			pDoc->ResetAttr( aPam, FALSE );
//STRIP001 			if( aPam.GetNode()->IsCntntNode() )
//STRIP001 				aPam.GetNode()->GetCntntNode()->ResetAllAttr();
//STRIP001 			// der Pam wird jetzt aufgegeben.
//STRIP001 		}
//STRIP001 
//STRIP001 		SwTxtNode* pTxtNd = aIdx.GetNode().GetTxtNode();
//STRIP001 		if( bJoinNext )
//STRIP001 		{
//STRIP001 			{
//STRIP001 				RemoveIdxRel( aIdx.GetIndex() + 1, SwPosition( aIdx,
//STRIP001 						SwIndex( pTxtNd, pTxtNd->GetTxt().Len() ) ) );
//STRIP001 			}
//STRIP001 			// sind keine Pams mehr im naechsten TextNode
//STRIP001 			pTxtNd->JoinNext();
//STRIP001 		}
//STRIP001 
//STRIP001 		if( bJoinPrev && pTxtNd->CanJoinPrev( &aIdx ) )
//STRIP001 		{
//STRIP001 			// ?? sind keine Pams mehr im naechsten TextNode ??
//STRIP001 			pTxtNd = aIdx.GetNode().GetTxtNode();
//STRIP001 			{
//STRIP001 				RemoveIdxRel( aIdx.GetIndex() + 1, SwPosition( aIdx,
//STRIP001 						SwIndex( pTxtNd, pTxtNd->GetTxt().Len() ) ) );
//STRIP001 			}
//STRIP001 			pTxtNd->JoinNext();
//STRIP001 		}
//STRIP001 
//STRIP001 	} while( FALSE );
//STRIP001 
//STRIP001 	if( pHistory )
//STRIP001 	{
//STRIP001 		if( nFtnStt != pHistory->Count() )
//STRIP001 			pHistory->Rollback( pDoc, nFtnStt );
//STRIP001 		pHistory->TmpRollback( pDoc, 0 );
//STRIP001 		pHistory->SetTmpEnd( pHistory->Count() );
//STRIP001 	}
//STRIP001 
//STRIP001 	pDoc->DoUndo( bUndo );
//STRIP001 
//STRIP001 	// setze noch den Cursor auf den Undo-Bereich
//STRIP001 	if( !bMoveRange )
//STRIP001 		SetPaM( rUndoIter );
//STRIP001 }


//STRIP001 void SwUndoMove::Redo( SwUndoIter& rUndoIter )
//STRIP001 {
//STRIP001 	SwPaM* pPam = rUndoIter.pAktPam;
//STRIP001 	SwDoc& rDoc = *pPam->GetDoc();
//STRIP001 
//STRIP001 	SwNodes& rNds = rDoc.GetNodes();
//STRIP001 	SwNodeIndex aIdx( rNds, nMvDestNode );
//STRIP001 
//STRIP001 	if( bMoveRange )
//STRIP001 	{
//STRIP001 		// nur ein Move mit SwRange
//STRIP001 		SwNodeRange aRg( rNds, nSttNode, rNds, nEndNode );
//STRIP001 		rDoc.Move( aRg, aIdx );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		SwPaM aPam( *pPam->GetPoint() );
//STRIP001 		SetPaM( aPam );
//STRIP001 		SwPosition aMvPos( aIdx, SwIndex( aIdx.GetNode().GetCntntNode(),
//STRIP001 										nMvDestCntnt ));
//STRIP001 
//STRIP001 		DelFtn( aPam );
//STRIP001 		RemoveIdxFromRange( aPam, FALSE );
//STRIP001 
//STRIP001 		aIdx = aPam.Start()->nNode;
//STRIP001 		BOOL bJoinTxt = aIdx.GetNode().IsTxtNode();
//STRIP001 
//STRIP001 		aIdx--;
//STRIP001 		rDoc.Move( aPam, aMvPos );
//STRIP001 
//STRIP001 		if( nSttNode != nEndNode && bJoinTxt )
//STRIP001 		{
//STRIP001 			aIdx++;
//STRIP001 			SwTxtNode * pTxtNd = aIdx.GetNode().GetTxtNode();
//STRIP001 			if( pTxtNd && pTxtNd->CanJoinNext() )
//STRIP001 			{
//STRIP001 				{
//STRIP001 					RemoveIdxRel( aIdx.GetIndex() + 1, SwPosition( aIdx,
//STRIP001 							SwIndex( pTxtNd, pTxtNd->GetTxt().Len() ) ) );
//STRIP001 				}
//STRIP001 				pTxtNd->JoinNext();
//STRIP001 			}
//STRIP001 		}
//STRIP001 		*pPam->GetPoint() = *aPam.GetPoint();
//STRIP001 		pPam->SetMark();
//STRIP001 		*pPam->GetMark() = *aPam.GetMark();
//STRIP001 	}
//STRIP001 }


//STRIP001 void SwUndoMove::DelFtn( const SwPaM& rRange )
//STRIP001 {
//STRIP001 	// wird aus dem CntntBereich in den Sonderbereich verschoben ?
//STRIP001 	SwDoc* pDoc = rRange.GetDoc();
//STRIP001 	ULONG nCntntStt = pDoc->GetNodes().GetEndOfAutotext().GetIndex();
//STRIP001 	if( nMvDestNode < nCntntStt &&
//STRIP001 		rRange.GetPoint()->nNode.GetIndex() >= nCntntStt )
//STRIP001 	{
//STRIP001 		// loesche alle Fussnoten. Diese sind dort nicht erwuenscht.
//STRIP001 		DelCntntIndex( *rRange.GetMark(), *rRange.GetPoint(),
//STRIP001 							SwUndoSaveCntnt::DELCNT_FTN );
//STRIP001 
//STRIP001 		if( pHistory && !pHistory->Count() )
//STRIP001 			delete pHistory, pHistory = 0;
//STRIP001 	}
//STRIP001 }

//STRIP001 void SwUndoMove::AddTblMrgFlyHstry( SwHistory& rHstr )
//STRIP001 {
//STRIP001 	if( !pHistory )
//STRIP001 		pHistory = new SwHistory;
//STRIP001 
//STRIP001 	USHORT nInsPos = nFtnStt;
//STRIP001 	nFtnStt += rHstr.Count();
//STRIP001 	pHistory->Move( nInsPos, &rHstr );
//STRIP001 }

}
