/*************************************************************************
 *
 *  $RCSfile: sw_applab.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 18:29:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#if STLPORT_VERSION>=321
#include <cstdarg>
#endif

#define ITEMID_BOXINFO      SID_ATTR_BORDER_INNER
#include <hintids.hxx>

// auto strip #ifndef _APP_HXX //autogen
// auto strip #include <vcl/svapp.hxx>
// auto strip #endif
// auto strip #ifndef _WRKWIN_HXX //autogen
// auto strip #include <vcl/wrkwin.hxx>
// auto strip #endif
// auto strip #ifndef _MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _SFXAPP_HXX //autogen
// auto strip #include <bf_sfx2/app.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_PRINTER_HXX //autogen
// auto strip #include <bf_sfx2/printer.hxx>
// auto strip #endif
// auto strip #ifndef _SFXREQUEST_HXX
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif
// auto strip #ifndef _LINKMGR_HXX
// auto strip #include <so3/linkmgr.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_PBINITEM_HXX //autogen
// auto strip #include <bf_svx/pbinitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_ULSPITEM_HXX //autogen
// auto strip #include <bf_svx/ulspitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_LRSPITEM_HXX //autogen
// auto strip #include <bf_svx/lrspitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_BOXITEM_HXX //autogen
// auto strip #include <bf_svx/boxitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_PAPERINF_HXX
// auto strip #include <bf_svx/paperinf.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_PROTITEM_HXX //autogen
// auto strip #include <bf_svx/protitem.hxx>
// auto strip #endif
#ifndef _SBASLTID_HRC //autogen
#include <bf_offmgr/sbasltid.hrc>
#endif
// auto strip #ifndef _COM_SUN_STAR_FRAME_XSTORABLE_HPP_
// auto strip #include <com/sun/star/frame/XStorable.hpp>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_FRAME_XMODEL_HPP_
// auto strip #include <com/sun/star/frame/XModel.hpp>
// auto strip #endif

// auto strip #ifndef _FMTHDFT_HXX //autogen
// auto strip #include <fmthdft.hxx>
// auto strip #endif
// auto strip #ifndef _FMTANCHR_HXX //autogen
// auto strip #include <fmtanchr.hxx>
// auto strip #endif
// auto strip #ifndef _FMTFSIZE_HXX //autogen
// auto strip #include <fmtfsize.hxx>
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

// auto strip #ifndef _FMTORNT_HXX //autogen
// auto strip #include <fmtornt.hxx>
// auto strip #endif
// auto strip #ifndef _SWWAIT_HXX
// auto strip #include <swwait.hxx>
// auto strip #endif
// auto strip #ifndef _GLOSHDL_HXX
// auto strip #include <gloshdl.hxx>
// auto strip #endif
// auto strip #ifndef _GLOSSARY_HXX
// auto strip #include <glossary.hxx>
// auto strip #endif
// auto strip #ifndef _MDIEXP_HXX
// auto strip #include <mdiexp.hxx>
// auto strip #endif
// auto strip #ifndef _FRMATR_HXX
// auto strip #include <frmatr.hxx>
// auto strip #endif
// auto strip #ifndef _PARATR_HXX
// auto strip #include <paratr.hxx>
// auto strip #endif
// auto strip #ifndef _SWMODULE_HXX
// auto strip #include <swmodule.hxx>
// auto strip #endif
// auto strip #ifndef _VIEW_HXX
// auto strip #include <view.hxx>
// auto strip #endif
// auto strip #ifndef _DOCSH_HXX
// auto strip #include <docsh.hxx>
// auto strip #endif
// auto strip #ifndef _FLDBAS_HXX
// auto strip #include <fldbas.hxx>
// auto strip #endif
// auto strip #ifndef _SWUNDO_HXX
// auto strip #include <swundo.hxx>
// auto strip #endif
#ifndef _WRTSH_HXX
#include <wrtsh.hxx>
#endif
#ifndef _CMDID_H
#include <cmdid.h>
#endif
// auto strip #ifndef _DBMGR_HXX
// auto strip #include <dbmgr.hxx>
// auto strip #endif
// auto strip #ifndef _DOC_HXX
// auto strip #include <doc.hxx>
// auto strip #endif
// auto strip #ifndef _FMTCOL_HXX
// auto strip #include <fmtcol.hxx>
// auto strip #endif
// auto strip #ifndef _EXPFLD_HXX
// auto strip #include <expfld.hxx>
// auto strip #endif
// auto strip #ifndef _FLDMGR_HXX
// auto strip #include <fldmgr.hxx>
// auto strip #endif
// auto strip #ifndef _LABEL_HXX
// auto strip #include <label.hxx>
// auto strip #endif
// auto strip #ifndef _LABIMG_HXX
// auto strip #include <labimg.hxx>
// auto strip #endif
// auto strip #ifndef _SECTION_HXX
// auto strip #include <section.hxx>
// auto strip #endif
// auto strip #ifndef _PAGEDESC_HXX
// auto strip #include <pagedesc.hxx>
// auto strip #endif
// auto strip #ifndef _POOLFMT_HXX
// auto strip #include <poolfmt.hxx>
// auto strip #endif

#ifndef _APP_HRC
#include <app.hrc>
#endif
#ifndef _POOLFMT_HRC
#include <poolfmt.hrc>
#endif
namespace binfilter {

using namespace ::com::sun::star;
using namespace ::rtl;

// steht im appenv.cxx
//STRIP001 extern String InsertLabEnvText( SwWrtShell& , SwFldMgr& , const String& );

//STRIP001 const char __FAR_DATA MASTER_LABEL[] = "MasterLabel";

// --------------------------------------------------------------------------

//STRIP001 const SwFrmFmt *lcl_InsertBCText( SwWrtShell& rSh, const SwLabItem& rItem,
//STRIP001 						SwFrmFmt &rFmt,
//STRIP001 						sal_uInt16 nCol, sal_uInt16 nRow, sal_Bool bPage)
//STRIP001 {
//STRIP001 	SfxItemSet aSet(rSh.GetAttrPool(), RES_ANCHOR, RES_ANCHOR,
//STRIP001 						RES_VERT_ORIENT, RES_VERT_ORIENT, RES_HORI_ORIENT, RES_HORI_ORIENT, 0 );
//STRIP001 	sal_uInt16 nPhyPageNum, nVirtPageNum;
//STRIP001 	rSh.GetPageNum( nPhyPageNum, nVirtPageNum );
//STRIP001 
//STRIP001 	aSet.Put(SwFmtAnchor(bPage ? FLY_IN_CNTNT : FLY_PAGE, nPhyPageNum));
//STRIP001 	if (!bPage)
//STRIP001 	{
//STRIP001 		aSet.Put(SwFmtHoriOrient(rItem.lLeft + nCol * rItem.lHDist,
//STRIP001 													HORI_NONE, REL_PG_FRAME ));
//STRIP001 		aSet.Put(SwFmtVertOrient(rItem.lUpper + nRow * rItem.lVDist,
//STRIP001 													VERT_NONE, REL_PG_FRAME ));
//STRIP001 	}
//STRIP001 	const SwFrmFmt *pFmt = rSh.NewFlyFrm(aSet, sal_True,  &rFmt );	// Fly einfuegen
//STRIP001 	ASSERT( pFmt, "Fly not inserted" );
//STRIP001 
//STRIP001 	rSh.UnSelectFrm();	//Rahmen wurde automatisch selektiert
//STRIP001 
//STRIP001 	rSh.SetTxtFmtColl( rSh.GetTxtCollFromPool( RES_POOLCOLL_STANDARD ) );
//STRIP001 
//STRIP001 	//
//STRIP001 	if(!rItem.bSynchron || !(nCol|nRow))
//STRIP001 	{
//STRIP001 		SwGlossaryDlg::SetActGroup(rItem.sGlossaryGroup);
//STRIP001 		SwGlossaryHdl* pGlosHdl = rSh.GetView().GetGlosHdl();
//STRIP001 		pGlosHdl->SetCurGroup(rItem.sGlossaryGroup, sal_True);
//STRIP001 		pGlosHdl->InsertGlossary( rItem.sGlossaryBlockName );
//STRIP001 	}
//STRIP001 
//STRIP001 	return pFmt;
//STRIP001 }

//STRIP001 const SwFrmFmt *lcl_InsertLabText( SwWrtShell& rSh, const SwLabItem& rItem,
//STRIP001 						SwFrmFmt &rFmt, SwFldMgr& rFldMgr,
//STRIP001 						sal_uInt16 nCol, sal_uInt16 nRow, sal_Bool bLast, sal_Bool bPage)
//STRIP001 {
//STRIP001 	SfxItemSet aSet(rSh.GetAttrPool(), RES_ANCHOR, RES_ANCHOR,
//STRIP001 						RES_VERT_ORIENT, RES_VERT_ORIENT, RES_HORI_ORIENT, RES_HORI_ORIENT, 0 );
//STRIP001 	sal_uInt16 nPhyPageNum, nVirtPageNum;
//STRIP001 	rSh.GetPageNum( nPhyPageNum, nVirtPageNum );
//STRIP001 
//STRIP001 	aSet.Put(SwFmtAnchor(bPage ? FLY_IN_CNTNT : FLY_PAGE, nPhyPageNum));
//STRIP001 	if (!bPage)
//STRIP001 	{
//STRIP001 		aSet.Put(SwFmtHoriOrient(rItem.lLeft + nCol * rItem.lHDist,
//STRIP001 													HORI_NONE, REL_PG_FRAME ));
//STRIP001 		aSet.Put(SwFmtVertOrient(rItem.lUpper + nRow * rItem.lVDist,
//STRIP001 													VERT_NONE, REL_PG_FRAME ));
//STRIP001 	}
//STRIP001 	const SwFrmFmt *pFmt = rSh.NewFlyFrm(aSet, sal_True,  &rFmt );	// Fly einfuegen
//STRIP001 	ASSERT( pFmt, "Fly not inserted" );
//STRIP001 
//STRIP001 	rSh.UnSelectFrm();	//Rahmen wurde automatisch selektiert
//STRIP001 
//STRIP001 	rSh.SetTxtFmtColl( rSh.GetTxtCollFromPool( RES_POOLCOLL_STANDARD ) );
//STRIP001 
//STRIP001 	// Ggf. "Naechster Datensatz"
//STRIP001 	String sDBName;
//STRIP001 	if( (!rItem.bSynchron || !(nCol|nRow)) && (sDBName = InsertLabEnvText( rSh, rFldMgr, rItem.aWriting )).Len() && !bLast )
//STRIP001 	{
//STRIP001         sDBName.SetToken( 3, DB_DELIM, String::CreateFromAscii("True"));
//STRIP001         SwInsertFld_Data aData(TYP_DBNEXTSETFLD, 0, sDBName, aEmptyStr, 0, &rSh );
//STRIP001         rFldMgr.InsertFld( aData );
//STRIP001 	}
//STRIP001 
//STRIP001 	return pFmt;
//STRIP001 }

// ----------------------------------------------------------------------------


//STRIP001 void SwModule::InsertLab(SfxRequest& rReq, sal_Bool bLabel)
//STRIP001 {
//STRIP001 static sal_uInt16 nLabelTitleNo = 0;
//STRIP001 static sal_uInt16 nBCTitleNo = 0;
//STRIP001 
//STRIP001 	// DB-Manager anlegen
//STRIP001 	SwNewDBMgr* pNewDBMgr = new SwNewDBMgr;
//STRIP001 
//STRIP001 	// SwLabItem aus Config lesen
//STRIP001 	SwLabCfgItem aLabCfg(bLabel);
//STRIP001 
//STRIP001 	// Dialog hochfahren
//STRIP001 	SfxItemSet aSet( GetPool(), FN_LABEL, FN_LABEL, 0 );
//STRIP001 	aSet.Put( aLabCfg.GetItem() );
//STRIP001 
//STRIP001 	SwLabDlg* pDlg = new SwLabDlg(0, aSet, pNewDBMgr, bLabel);
//STRIP001 
//STRIP001 	if ( RET_OK == pDlg->Execute() )
//STRIP001 	{
//STRIP001 		// Dialog auslesen, Item in Config speichern
//STRIP001 		const SwLabItem& rItem = (const SwLabItem&) pDlg->
//STRIP001 											GetOutputItemSet()->Get(FN_LABEL);
//STRIP001 		aLabCfg.GetItem() = rItem;
//STRIP001 		pDlg->MakeConfigItem( aLabCfg.GetItem());
//STRIP001 		aLabCfg.Commit();
//STRIP001 
//STRIP001 		// Neues Dokument erzeugen.
//STRIP001 		SfxObjectShellRef xDocSh( new SwDocShell( SFX_CREATE_MODE_STANDARD));
//STRIP001 		xDocSh->DoInitNew( 0 );
//STRIP001 
//STRIP001         /*TODO #111050# call public made method of sfx (which was protected before!)
//STRIP001           to force missing event OnNew ... */
//STRIP001         xDocSh->Stamp_SetActivateEvent(SFX_EVENT_CREATEDOC);
//STRIP001 
//STRIP001 		// Drucker
//STRIP001 		Printer *pPrt = pDlg->GetPrt();
//STRIP001 		if (pPrt)
//STRIP001 		{
//STRIP001 			SwDocShell *pDocSh = (SwDocShell*)(&*xDocSh);
//STRIP001 			pDocSh->GetDoc()->SetJobsetup(pPrt->GetJobSetup());
//STRIP001 		}
//STRIP001 
//STRIP001 		const SfxItemSet *pArgs = rReq.GetArgs();
//STRIP001 		DBG_ASSERT( pArgs, "no arguments in SfxRequest")
//STRIP001 		const SfxPoolItem* pFrameItem = 0;
//STRIP001 		if(pArgs)
//STRIP001 			pArgs->GetItemState(SID_DOCFRAME, FALSE, &pFrameItem);
//STRIP001 		if(!pFrameItem)
//STRIP001 			return ;
//STRIP001 		SfxFrame* pFr = ((const SfxFrameItem*)pFrameItem)->GetFrame();
//STRIP001 		xDocSh->PutItem(SfxBoolItem(SID_HIDDEN, TRUE));
//STRIP001 		pFr->InsertDocument(xDocSh);
//STRIP001 		SfxViewFrame *pFrame = pFr->GetCurrentViewFrame();
//STRIP001 		SwView 		*pView = (SwView*) pFrame->GetViewShell();
//STRIP001 		pView->AttrChangedNotify( &pView->GetWrtShell() );//Damit SelectShell gerufen wird.
//STRIP001 
//STRIP001 		// Dokumenttitel setzen
//STRIP001 		String aTmp;
//STRIP001 		if(bLabel)
//STRIP001 		{
//STRIP001 			aTmp = String(SW_RES( STR_LAB_TITLE));
//STRIP001 			aTmp += String::CreateFromInt32(++nLabelTitleNo );
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			aTmp = pDlg->GetBusinessCardStr();
//STRIP001 			aTmp += String::CreateFromInt32( ++nBCTitleNo );
//STRIP001 		}
//STRIP001 		xDocSh->SetTitle( aTmp );
//STRIP001 
//STRIP001 		pFrame->GetFrame()->Appear();
//STRIP001 
//STRIP001 		// Shell ermitteln
//STRIP001 		SwWrtShell *pSh = pView->GetWrtShellPtr();
//STRIP001 		ASSERT( pSh, "missing WrtShell" );
//STRIP001 
//STRIP001 		{	// block for locks the dispatcher!!
//STRIP001 
//STRIP001 			SwWait aWait( (SwDocShell&)*xDocSh, sal_True );
//STRIP001 
//STRIP001 			SET_CURR_SHELL(pSh);
//STRIP001             pSh->SetLabelDoc(rItem.bSynchron);
//STRIP001             pSh->DoUndo( sal_False );
//STRIP001 			pSh->StartAllAction();
//STRIP001 
//STRIP001 			pSh->SetNewDoc();		// Performanceprobleme vermeiden
//STRIP001 
//STRIP001 			SwPageDesc aDesc = pSh->GetPageDesc( 0 );
//STRIP001 			SwFrmFmt&  rFmt  = aDesc.GetMaster();
//STRIP001 
//STRIP001 			// Raender
//STRIP001 			SvxLRSpaceItem aLRMargin;
//STRIP001 			SvxULSpaceItem aULMargin;
//STRIP001 			aLRMargin.SetLeft ((sal_uInt16) rItem.lLeft );
//STRIP001 			aULMargin.SetUpper((sal_uInt16) rItem.lUpper);
//STRIP001             aLRMargin.SetRight(MINLAY/2);
//STRIP001             aULMargin.SetLower(MINLAY/2);
//STRIP001 			rFmt.SetAttr(aLRMargin);
//STRIP001 			rFmt.SetAttr(aULMargin);
//STRIP001 
//STRIP001 			// Kopf- und Fusszeilen
//STRIP001 			rFmt.SetAttr(SwFmtHeader(sal_Bool(sal_False)));
//STRIP001 			aDesc.ChgHeaderShare(sal_False);
//STRIP001 			rFmt.SetAttr(SwFmtFooter(sal_Bool(sal_False)));
//STRIP001 			aDesc.ChgFooterShare(sal_False);
//STRIP001 
//STRIP001 
//STRIP001 			aDesc.SetUseOn(PD_ALL);				// Seitennumerierung
//STRIP001 
//STRIP001 			// Einstellen der Seitengroesse
//STRIP001 			rFmt.SetAttr(SwFmtFrmSize(ATT_FIX_SIZE,
//STRIP001                                         rItem.lLeft  + rItem.nCols * rItem.lHDist + MINLAY,
//STRIP001                                         rItem.lUpper + rItem.nRows * rItem.lVDist + MINLAY));
//STRIP001 
//STRIP001 			// Numerierungsart
//STRIP001 			SvxNumberType aType;
//STRIP001 			aType.SetNumberingType(SVX_NUM_NUMBER_NONE);
//STRIP001 			aDesc.SetNumType( aType );
//STRIP001 
//STRIP001 			// Folgevorlage
//STRIP001 			const SwPageDesc &rFollow = pSh->GetPageDesc( pSh->GetCurPageDesc() );
//STRIP001 			aDesc.SetFollow( &rFollow );
//STRIP001 
//STRIP001 			pPrt = pSh->GetPrt( sal_True );
//STRIP001 			SvxPaperBinItem aItem;
//STRIP001 			aItem.SetValue((sal_Int8)pPrt->GetPaperBin());
//STRIP001 			rFmt.SetAttr(aItem);
//STRIP001 
//STRIP001 			//determine orientation by calculating the width and height of the resulting page
//STRIP001 			const int nResultWidth = rItem.lHDist * (rItem.nCols - 1) + rItem.lWidth + rItem.lLeft;
//STRIP001 			const int nResultHeight = rItem.lVDist * (rItem.nRows - 1) + rItem.lHeight + rItem.lUpper;
//STRIP001 			aDesc.SetLandscape(nResultWidth > nResultHeight);
//STRIP001 
//STRIP001 			pSh->ChgPageDesc( 0, aDesc );
//STRIP001 
//STRIP001 			// Rahmen einfuegen
//STRIP001 			SwFldMgr*		 pFldMgr = new SwFldMgr;
//STRIP001 			pFldMgr->SetEvalExpFlds(sal_False);
//STRIP001 
//STRIP001 			//fix(24446): Damit der Text der Ettiketten nicht im unbedruckbaren
//STRIP001 			//Bereich landet stellen wir entsprechende Raender ein. Um das Handling
//STRIP001 			//so Optimal wie moeglich zu halten stellen wir zunaechst an der
//STRIP001 			//aktuellen Absatzvorlage keinen Rand als hartes Attribut ein (Damit die
//STRIP001 			//Formatierung wg. der Zeichengeb. Rahmen passt. Dann stellen wir die
//STRIP001 			//Standarabsatzvorlage anhand des unbedruckbaren Bereiches ein.
//STRIP001 			const long nMin = pPrt->GetPageOffset().X() - rItem.lLeft;
//STRIP001 			if ( nMin > 0 )
//STRIP001 			{
//STRIP001 				SvxLRSpaceItem aLR;
//STRIP001 				pSh->SetAttr( aLR );
//STRIP001 				SwFmt *pStandard = pSh->GetTxtCollFromPool( RES_POOLCOLL_STANDARD );
//STRIP001 				aLR.SetLeft ( sal_uInt16(nMin) );
//STRIP001 				aLR.SetRight( sal_uInt16(nMin) );
//STRIP001 				pStandard->SetAttr( aLR );
//STRIP001 			}
//STRIP001 
//STRIP001 			// Rahmenvorlage vorbereiten
//STRIP001 			SwFrmFmt* pFmt = pSh->GetFrmFmtFromPool( RES_POOLFRM_LABEL );
//STRIP001 			SwFmtFrmSize aFrmSize(	ATT_FIX_SIZE,
//STRIP001 									rItem.lHDist - (rItem.lHDist-rItem.lWidth),
//STRIP001 									rItem.lVDist - (rItem.lVDist-rItem.lHeight));
//STRIP001 			pFmt->SetAttr(aFrmSize);
//STRIP001 
//STRIP001 			SvxLRSpaceItem aFrmLRSpace(	0, (sal_uInt16)(rItem.lHDist - rItem.lWidth),
//STRIP001 										0, 0,
//STRIP001 										RES_LR_SPACE);
//STRIP001 			pFmt->SetAttr(aFrmLRSpace);
//STRIP001 
//STRIP001 			SvxULSpaceItem aFrmULSpace(	0, (sal_uInt16)(rItem.lVDist - rItem.lHeight),
//STRIP001 										RES_UL_SPACE);
//STRIP001 			pFmt->SetAttr(aFrmULSpace);
//STRIP001 
//STRIP001 			const SwFrmFmt *pFirstFlyFmt = 0;
//STRIP001 			if ( rItem.bPage )
//STRIP001 			{
//STRIP001 				SwFmtVertOrient aFrmVertOrient( pFmt->GetVertOrient() );
//STRIP001 				aFrmVertOrient.SetVertOrient( VERT_TOP );
//STRIP001 				pFmt->SetAttr(aFrmVertOrient);
//STRIP001 
//STRIP001 				for ( sal_uInt16 i = 0; i < rItem.nRows; ++i )
//STRIP001 				{
//STRIP001 					for ( sal_uInt16 j = 0; j < rItem.nCols; ++j )
//STRIP001 					{
//STRIP001 						pSh->Push();
//STRIP001 						const SwFrmFmt *pTmp =
//STRIP001 								bLabel ?
//STRIP001 								lcl_InsertLabText( *pSh, rItem, *pFmt, *pFldMgr, j, i,
//STRIP001 									i == rItem.nRows - 1 && j == rItem.nCols - 1,
//STRIP001 									sal_True ) :
//STRIP001 								lcl_InsertBCText(*pSh, rItem, *pFmt, j, i, sal_True);
//STRIP001 						if (!(i|j))
//STRIP001 						{
//STRIP001 							pFirstFlyFmt = pTmp;
//STRIP001 
//STRIP001 							if (rItem.bSynchron)
//STRIP001 							{
//STRIP001 								// if there is no content in the fly then
//STRIP001 								// dont leave the fly!!!
//STRIP001 								pSh->Push();
//STRIP001 								pSh->SttDoc();
//STRIP001 								sal_Bool bInFly = 0 != pSh->WizzardGetFly();
//STRIP001 								pSh->Pop( bInFly );
//STRIP001 
//STRIP001 								if( bInFly )
//STRIP001 									pSh->EndDoc(sal_True);	// select all content
//STRIP001 														// in the fly
//STRIP001 								else
//STRIP001 									pSh->SetMark();		// set only the mark
//STRIP001 
//STRIP001 								SwSection aSect( CONTENT_SECTION,
//STRIP001 												String::CreateFromAscii(MASTER_LABEL));
//STRIP001 								pSh->InsertSection(aSect);
//STRIP001 							}
//STRIP001 						}
//STRIP001 						else if (rItem.bSynchron)
//STRIP001 						{
//STRIP001 							SwSection aSect(FILE_LINK_SECTION, pSh->GetUniqueSectionName());
//STRIP001                             String sLinkName(so3::cTokenSeperator);
//STRIP001                             sLinkName += ::so3::cTokenSeperator;
//STRIP001 							sLinkName += String::CreateFromAscii(MASTER_LABEL);
//STRIP001 							aSect.SetLinkFileName(sLinkName);
//STRIP001 							aSect.SetProtect();
//STRIP001 							pSh->Insert(aDotStr);	// Dummytext zum Zuweisen der Section
//STRIP001 							pSh->SttDoc();
//STRIP001 							pSh->EndDoc(sal_True);	// Alles im Rahmen selektieren
//STRIP001 							pSh->InsertSection(aSect);
//STRIP001 						}
//STRIP001 						pSh->Pop( sal_False );
//STRIP001 					}
//STRIP001 					if ( i + 1 != rItem.nRows )
//STRIP001 						pSh->SplitNode(); // Kleine Optimierung
//STRIP001 				}
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				pFirstFlyFmt = bLabel ?
//STRIP001 					lcl_InsertLabText( *pSh, rItem, *pFmt, *pFldMgr,
//STRIP001 							rItem.nCol - 1, rItem.nRow - 1, sal_True, sal_False ) :
//STRIP001 					lcl_InsertBCText(*pSh, rItem, *pFmt, rItem.nCol - 1, rItem.nRow - 1, sal_False);
//STRIP001 			}
//STRIP001 
//STRIP001 			//fill the user fields
//STRIP001 			if(!bLabel)
//STRIP001 			{
//STRIP001 				uno::Reference< frame::XModel >  xModel = pSh->GetView().GetDocShell()->GetBaseModel();
//STRIP001 				SwLabDlg::UpdateFieldInformation(xModel, rItem);
//STRIP001 			}
//STRIP001 
//STRIP001 			pFldMgr->SetEvalExpFlds(sal_True);
//STRIP001 			pFldMgr->EvalExpFlds(pSh);
//STRIP001 
//STRIP001 			delete pFldMgr;
//STRIP001 
//STRIP001 			pSh->GotoFly(pFirstFlyFmt->GetName(), FLYCNTTYPE_ALL, sal_False);
//STRIP001 
//STRIP001 			pSh->EndAllAction();
//STRIP001 			pSh->DoUndo( sal_True );
//STRIP001         }
//STRIP001 
//STRIP001 		if( rItem.aWriting.indexOf( '<' ) >= 0 )
//STRIP001 		{
//STRIP001 			// Datenbankbrowser mit zuletzt verwendeter Datenbank oeffnen
//STRIP001             ShowDBObj( *pView, pSh->GetDBData() );
//STRIP001 		}
//STRIP001 
//STRIP001 		if( rItem.bSynchron )
//STRIP001 		{
//STRIP001 			SfxDispatcher* pDisp = pFrame->GetDispatcher();
//STRIP001 			ASSERT(pDisp, "Heute kein Dispatcher am Frame?");
//STRIP001 			pDisp->Execute(FN_SYNC_LABELS, SFX_CALLMODE_ASYNCHRON);
//STRIP001 		}
//STRIP001         rReq.SetReturnValue(SfxVoidItem(bLabel ? FN_LABEL : FN_BUSINESS_CARD));
//STRIP001 	}
//STRIP001 	delete pDlg;
//STRIP001 
//STRIP001 	if( pNewDBMgr )
//STRIP001 		delete pNewDBMgr;
//STRIP001 }


}
