/*************************************************************************
 *
 *  $RCSfile: optload.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:55:31 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _OPTLOAD_HXX
#define _OPTLOAD_HXX

#ifndef _SFXTABDLG_HXX //autogen
#include <bf_sfx2/tabdlg.hxx>
#endif

#ifndef _GROUP_HXX
#include <vcl/group.hxx>
#endif
#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_LSTBOX_HXX
#include <vcl/lstbox.hxx>
#endif
#ifndef _SV_FIELD_HXX
#include <vcl/field.hxx>
#endif
#ifndef _SVX_STRARRAY_HXX
#include <bf_svx/strarray.hxx>
#endif
#ifndef _BASEDLGS_HXX //autogen
#include <bf_sfx2/basedlgs.hxx>
#endif
#ifndef _SVX_CHECKLBX_HXX //autogen
#include <bf_svx/checklbx.hxx>
#endif
#ifndef _SWLBOX_HXX
#include <swlbox.hxx>
#endif
#ifndef _CAPTION_HXX
#include <caption.hxx>
#endif
namespace binfilter {

//STRIP001 class SwFldMgr;
class SvLBoxEntry;
class SwWrtShell;

/*-----------------31.08.96 10.09-------------------

--------------------------------------------------*/

//STRIP001 class SwLoadOptPage : public SfxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001     FixedLine   aUpdateFL;
//STRIP001     FixedText   aLinkFT;
//STRIP001     RadioButton aAlwaysRB;
//STRIP001 	RadioButton	aRequestRB;
//STRIP001 	RadioButton	aNeverRB;
//STRIP001 
//STRIP001     FixedText   aFieldFT;
//STRIP001     CheckBox    aAutoUpdateFields;
//STRIP001 	CheckBox	aAutoUpdateCharts;
//STRIP001 
//STRIP001     FixedLine   aCaptionFL;
//STRIP001 	CheckBox	aCaptionCB;
//STRIP001 	FixedText	aCaptionFT;
//STRIP001 	PushButton	aCaptionPB;
//STRIP001 
//STRIP001     FixedLine   aSettingsFL;
//STRIP001     FixedText   aMetricFT;
//STRIP001     ListBox     aMetricLB;
//STRIP001     FixedText   aTabFT;
//STRIP001 	MetricField aTabMF;
//STRIP001 
//STRIP001     FixedLine   aCompatFL;
//STRIP001     CheckBox    aPrinterMetricsCB;
//STRIP001     CheckBox    aMergeDistCB;
//STRIP001 	CheckBox 	aMergeDistPageStartCB;
//STRIP001     CheckBox    aTabAlignment;
//STRIP001 
//STRIP001 	SwWrtShell*	pWrtShell;
//STRIP001     sal_Bool    bHTMLMode;
//STRIP001     UINT16      nLastTab;
//STRIP001     sal_Int32   nOldLinkMode;
//STRIP001 
//STRIP001     DECL_LINK(CaptionHdl, PushButton*);
//STRIP001     DECL_LINK(MetricHdl, ListBox*);
//STRIP001     DECL_LINK(UpdateHdl, CheckBox* );
//STRIP001 
//STRIP001 public:
//STRIP001 						SwLoadOptPage( Window* pParent,
//STRIP001 										 const SfxItemSet& rSet );
//STRIP001 						~SwLoadOptPage();
//STRIP001 
//STRIP001 	static SfxTabPage*	Create( Window* pParent,
//STRIP001 								const SfxItemSet& rAttrSet);
//STRIP001 
//STRIP001 	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual	void 		Reset( const SfxItemSet& rSet );
//STRIP001 };
/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 class SwCaptionOptDlg : public SfxSingleTabDialog
//STRIP001 {
//STRIP001 public:
//STRIP001 	 SwCaptionOptDlg(Window* pParent, const SfxItemSet& rSet);
//STRIP001 	~SwCaptionOptDlg();
//STRIP001 };
/* -----------------23.10.98 13:19-------------------
 *
 * --------------------------------------------------*/

//STRIP001 class CaptionComboBox : public SwComboBox
//STRIP001 {
//STRIP001 protected:
//STRIP001 	virtual void KeyInput( const KeyEvent& );
//STRIP001 
//STRIP001 public:
//STRIP001 	CaptionComboBox( Window* pParent, const ResId& rResId)
//STRIP001 		: SwComboBox(pParent, rResId)
//STRIP001 	{}
//STRIP001 };

/*-----------------31.08.96 10.09-------------------

--------------------------------------------------*/
//STRIP001 class SwCaptionOptPage : public SfxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 	SvxCheckListBox	aCheckLB;
//STRIP001 
//STRIP001 	FixedText		aSampleText;
//STRIP001 	FixedText		aCategoryText;
//STRIP001 	CaptionComboBox	aCategoryBox;
//STRIP001 	FixedText		aFormatText;
//STRIP001 	ListBox			aFormatBox;
//STRIP001 	FixedText		aTextText;
//STRIP001 	Edit			aTextEdit;
//STRIP001 	FixedText		aPosText;
//STRIP001 	ListBox			aPosBox;
//STRIP001 	FixedText 		aFtLevel;
//STRIP001 	ListBox 		aLbLevel;
//STRIP001 	FixedText 		aFtDelim;
//STRIP001 	Edit 			aEdDelim;
//STRIP001     FixedLine       aSettingsGroupFL;
//STRIP001 
//STRIP001 	String			sSWTable;
//STRIP001 	String			sSWFrame;
//STRIP001 	String			sSWGraphic;
//STRIP001 	String			sOLE;
//STRIP001 
//STRIP001 	String			sIllustration;
//STRIP001 	String			sTable;
//STRIP001 	String			sText;
//STRIP001     String          sDrawing;
//STRIP001 
//STRIP001 	String			sBegin;
//STRIP001 	String			sEnd;
//STRIP001 	String			sAbove;
//STRIP001 	String			sBelow;
//STRIP001 
//STRIP001 	SwFldMgr		*pMgr;
//STRIP001 	USHORT			eType;
//STRIP001 	BOOL 			bHTMLMode;
//STRIP001 
//STRIP001 	DECL_LINK( SelectHdl, ListBox *pLB = 0 );
//STRIP001 	DECL_LINK( ModifyHdl, Edit *pEdt = 0 );
//STRIP001 	DECL_LINK( ShowEntryHdl, SvxCheckListBox *pLB = 0 );
//STRIP001 	DECL_LINK( SaveEntryHdl, SvxCheckListBox *pLB = 0 );
//STRIP001 
//STRIP001 	void				DelUserData();
//STRIP001 	void				SetOptions(	const USHORT nPos,
//STRIP001 									const SwCapObjType eType,
//STRIP001 									const SvGlobalName *pOleId = 0);
//STRIP001 	void				SaveEntry( SvLBoxEntry* pEntry );
//STRIP001 	void				DrawSample();
//STRIP001 
//STRIP001 public:
//STRIP001 						SwCaptionOptPage( Window* pParent,
//STRIP001 										 const SfxItemSet& rSet );
//STRIP001 						~SwCaptionOptPage();
//STRIP001 
//STRIP001 	static SfxTabPage*	Create( Window* pParent,
//STRIP001 								const SfxItemSet& rAttrSet);
//STRIP001 
//STRIP001 	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual	void 		Reset( const SfxItemSet& rSet );
//STRIP001 };

} //namespace binfilter
#endif


