/*************************************************************************
 *
 *  $RCSfile: sw_insrule.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/01/11 11:57:15 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include "so3/staticbaseurl.hxx"
namespace binfilter {


//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #include "uiparam.hxx"
//STRIP001 #include "hintids.hxx"
//STRIP001 
//STRIP001 #ifndef _GALLERY_HXX_ //autogen
//STRIP001 #include <bf_svx/gallery.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _MSGBOX_HXX //autogen
//STRIP001 #include <vcl/msgbox.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SVX_BRSHITEM_HXX //autogen
//STRIP001 #include <bf_svx/brshitem.hxx>
//STRIP001 #endif
//STRIP001 #ifndef SVTOOLS_URIHELPER_HXX
//STRIP001 #include <svtools/urihelper.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #include "swtypes.hxx"
//STRIP001 #include "docsh.hxx"
//STRIP001 #include "insrule.hxx"
//STRIP001 #include "swvset.hxx"
//STRIP001 #include "insrule.hrc"
//STRIP001 #include "misc.hrc"
//STRIP001 #include "helpid.h"
//STRIP001 
//STRIP001 /*------------------------------------------------------------------------
//STRIP001  Beschreibung:
//STRIP001 ------------------------------------------------------------------------*/
//STRIP001 
//STRIP001 
//STRIP001 SwInsertGrfRulerDlg::SwInsertGrfRulerDlg( Window* pParent ) :
//STRIP001 	SfxModalDialog(pParent, SW_RES(DLG_INSERT_RULER)),
//STRIP001     aSelectionFL(this, ResId(FL_SEL     )),
//STRIP001     pExampleVS  (new SwRulerValueSet(this, ResId(VS_EXAMPLE ))),
//STRIP001 	aOkPB 		(this, ResId(PB_OK		)),
//STRIP001 	aCancelPB	(this, ResId(PB_CANCEL	)),
//STRIP001 	aHelpPB		(this, ResId(PB_HELP	)),
//STRIP001 	sSimple	(ResId(ST_SIMPLE)),
//STRIP001     nSelPos(USHRT_MAX)
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 	pExampleVS->SetLineCount(6);
//STRIP001 	pExampleVS->SetColCount(1);
//STRIP001 	pExampleVS->SetSelectHdl(LINK(this, SwInsertGrfRulerDlg, SelectHdl));
//STRIP001 	pExampleVS->SetDoubleClickHdl(LINK(this, SwInsertGrfRulerDlg, DoubleClickHdl));
//STRIP001 	pExampleVS->GrabFocus();
//STRIP001 
//STRIP001 	// Grafiknamen ermitteln
//STRIP001     GalleryExplorer::BeginLocking(GALLERY_THEME_RULERS);
//STRIP001     GalleryExplorer::FillObjList( GALLERY_THEME_RULERS, aGrfNames );
//STRIP001 	pExampleVS->SetHelpId(HID_VS_RULER);
//STRIP001 	Color aColor(COL_WHITE);
//STRIP001 	pExampleVS->InsertItem( 1, 1);
//STRIP001 	pExampleVS->SetItemText( 1, sSimple);
//STRIP001 
//STRIP001 	for(USHORT i = 1; i <= aGrfNames.Count(); i++)
//STRIP001 	{
//STRIP001 		pExampleVS->InsertItem( i + 1, i);
//STRIP001 		pExampleVS->SetItemText( i + 1, *((String*)aGrfNames.GetObject(i-1)));
//STRIP001 	}
//STRIP001 	pExampleVS->Show();
//STRIP001 
//STRIP001 }
//STRIP001 /*-----------------14.02.97 13.18-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 
//STRIP001 SwInsertGrfRulerDlg::~SwInsertGrfRulerDlg()
//STRIP001 {
//STRIP001     GalleryExplorer::EndLocking(GALLERY_THEME_RULERS);
//STRIP001     delete pExampleVS;
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------14.02.97 13.17-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 
//STRIP001 String SwInsertGrfRulerDlg::GetGraphicName()
//STRIP001 {
//STRIP001 	String sRet;
//STRIP001     USHORT nSel = nSelPos - 2; //align selection position with ValueSet index
//STRIP001     if(nSel < aGrfNames.Count())
//STRIP001         sRet = so3::StaticBaseUrl::SmartRelToAbs(*(String*) aGrfNames.GetObject(nSel));
//STRIP001 	return sRet;
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------14.02.97 13.20-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK(SwInsertGrfRulerDlg, SelectHdl, ValueSet*, pVS)
//STRIP001 {
//STRIP001     nSelPos = pVS->GetSelectItemId();
//STRIP001 	aOkPB.Enable();
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------14.02.97 14.17-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 SwRulerValueSet::SwRulerValueSet(   Window* pParent, const ResId& rResId ) :
//STRIP001     SvxBmpNumValueSet(pParent, rResId)
//STRIP001 {
//STRIP001     SetStyle(  GetStyle() & ~WB_ITEMBORDER     );
//STRIP001 }
//STRIP001 /*-----------------14.02.97 14.17-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 SwRulerValueSet::~SwRulerValueSet()
//STRIP001 {
//STRIP001 }
//STRIP001 /*-----------------14.02.97 13.42-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 void __EXPORT SwRulerValueSet::UserDraw( const UserDrawEvent& rUDEvt )
//STRIP001 {
//STRIP001 	Rectangle aRect = rUDEvt.GetRect();
//STRIP001 	OutputDevice*  pDev = rUDEvt.GetDevice();
//STRIP001 	USHORT	nItemId = rUDEvt.GetItemId();
//STRIP001 	Point aBLPos = aRect.TopLeft();
//STRIP001 
//STRIP001 	// Itemzaehlung beginnt bei 1, und die 1. ist die einfache Linie
//STRIP001 	if(nItemId > 1)
//STRIP001 	{
//STRIP001         Graphic aGraphic;
//STRIP001         if(GalleryExplorer::GetGraphicObj( GALLERY_THEME_RULERS, nItemId - 2,
//STRIP001                                                             &aGraphic))
//STRIP001         {
//STRIP001             Size aGrfSize = aGraphic.GetPrefSize();
//STRIP001             if(aGrfSize.Width() && aGrfSize.Height())
//STRIP001             {
//STRIP001                 int nRelGrf = aGrfSize.Height() * 100 / aGrfSize.Width();
//STRIP001                 Size aWinSize = aRect.GetSize();
//STRIP001                 Size aPaintSize = aWinSize;
//STRIP001                 int nRelWin = aWinSize.Height() * 100 / aWinSize.Width();
//STRIP001                 if(nRelGrf > nRelWin)
//STRIP001                 {
//STRIP001                     aPaintSize.Width() = aWinSize.Height() * 100 / nRelGrf;
//STRIP001                     aBLPos.X() += (aWinSize.Width() - aPaintSize.Width()) /2;
//STRIP001                 }
//STRIP001                 else
//STRIP001                 {
//STRIP001                     aPaintSize.Height() = aWinSize.Width() * nRelGrf/100;
//STRIP001                     aBLPos.Y() += (aWinSize.Height() - aPaintSize.Height()) /2;
//STRIP001                 }
//STRIP001                 aBLPos.X() -= aPaintSize.Width() /2;
//STRIP001                 aBLPos.Y() -= aPaintSize.Height() /2;
//STRIP001 
//STRIP001                 aPaintSize.Width() *= 2;
//STRIP001                 aPaintSize.Height() *= 2;
//STRIP001                 if(aPaintSize.Height() < 2)
//STRIP001                     aPaintSize.Height() = 2;
//STRIP001                 Region aRegion = pDev->GetClipRegion();
//STRIP001                 pDev->SetClipRegion(aRect);
//STRIP001                 aGraphic.Draw(pDev, aBLPos, aPaintSize);
//STRIP001                 pDev->SetClipRegion(aRegion);
//STRIP001             }
//STRIP001         }
//STRIP001         else
//STRIP001         {
//STRIP001             SetGrfNotFound(TRUE);
//STRIP001         }
//STRIP001     }
//STRIP001 	else
//STRIP001 	{
//STRIP001 		// Text fuer einfache Linie painten
//STRIP001 		Font aOldFont = pDev->GetFont();
//STRIP001 		Font aFont = pDev->GetFont();
//STRIP001 		Size aSize = aFont.GetSize();
//STRIP001 		int nRectHeight = aRect.GetHeight();
//STRIP001 		aSize.Height() = nRectHeight * 2 / 3;
//STRIP001 		aFont.SetSize(aSize);
//STRIP001 		pDev->SetFont(aFont);
//STRIP001 		String aText(GetItemText(nItemId));
//STRIP001 		aSize.Width() = pDev->GetTextWidth(aText);
//STRIP001 		aSize.Height() = pDev->GetTextHeight();
//STRIP001 		Point aPos(aBLPos);
//STRIP001 		aPos.Y() += (nRectHeight - aSize.Height()) / 2;
//STRIP001 		aPos.X() += (aRect.GetWidth() - aSize.Width()) / 2;
//STRIP001 		pDev->DrawText(aPos, aText);
//STRIP001 
//STRIP001 		pDev->SetFont(aOldFont);
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------15.02.97 10.03-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK(SwInsertGrfRulerDlg, DoubleClickHdl, ValueSet*, pVS)
//STRIP001 {
//STRIP001 	EndDialog(RET_OK);
//STRIP001 	return 0;
//STRIP001 }

}
