/*************************************************************************
 *
 *  $RCSfile: sw_tbxanchr.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 19:16:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#include <string> // HACK: prevent conflict between STLPORT and Workshop headers

// auto strip #ifndef _SV_TIMER_HXX //autogen
// auto strip #include <vcl/timer.hxx>
// auto strip #endif

// auto strip #ifndef _SFXAPP_HXX //autogen
// auto strip #include <bf_sfx2/app.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_HTMLMODE_HXX //autogen
// auto strip #include <bf_svx/htmlmode.hxx>
// auto strip #endif
// auto strip #ifndef _SFXINTITEM_HXX //autogen
// auto strip #include <svtools/intitem.hxx>
// auto strip #endif
#ifndef _SFXDISPATCH_HXX //autogen
#include <bf_sfx2/dispatch.hxx>
#endif
// auto strip #ifndef _TOOLBOX_HXX //autogen
// auto strip #include <vcl/toolbox.hxx>
// auto strip #endif
// auto strip #ifndef _SFXMNUMGR_HXX //autogen
// auto strip #include <bf_sfx2/mnumgr.hxx>
// auto strip #endif


#include "cmdid.h"
// auto strip #include "docsh.hxx"
// auto strip #include "swtypes.hxx"
// auto strip #include "swmodule.hxx"

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

// auto strip #include "wrtsh.hxx"
#include "view.hxx"
// auto strip #include "viewopt.hxx"
// auto strip #include "errhdl.hxx"
#include "ribbar.hrc"
#include "tbxanchr.hxx"
namespace binfilter {



/*N*/ SFX_IMPL_TOOLBOX_CONTROL(SwTbxAnchor, SfxUInt16Item);

/******************************************************************************
 *	Beschreibung:
 ******************************************************************************/

/*N*/ SwTbxAnchor::SwTbxAnchor(USHORT nId, ToolBox& rTbx, SfxBindings& rBind) :
/*N*/ 	SfxToolBoxControl(nId, rTbx, rBind),
/*N*/ 	nActAnchorId(0)
/*N*/ {
/*N*/ }

/******************************************************************************
 *	Beschreibung:
 ******************************************************************************/

/*N*/  SwTbxAnchor::~SwTbxAnchor()
/*N*/ {
/*N*/ }

/******************************************************************************
 *	Beschreibung:
 ******************************************************************************/

//STRIP001 void  SwTbxAnchor::StateChanged( USHORT nSID, SfxItemState eState, const SfxPoolItem* pState )
//STRIP001 {
//STRIP001 	GetToolBox().EnableItem( GetId(), (GetItemState(pState) != SFX_ITEM_DISABLED) );
//STRIP001 
//STRIP001 	if( eState == SFX_ITEM_AVAILABLE )
//STRIP001 	{
//STRIP001 		const SfxUInt16Item* pItem = PTR_CAST( SfxUInt16Item, pState );
//STRIP001 		if(pItem)
//STRIP001 			nActAnchorId = pItem->GetValue();
//STRIP001 	}
//STRIP001 
//STRIP001 }

/******************************************************************************
 *	Beschreibung:
 ******************************************************************************/

//STRIP001 void  SwTbxAnchor::Click()
//STRIP001 {
//STRIP001 	PopupMenu aPopMenu(SW_RES(MN_ANCHOR_POPUP));
//STRIP001 
//STRIP001 	SwView* pView = ::GetActiveView();
//STRIP001 	SwWrtShell*	pWrtShell = pView->GetWrtShellPtr();
//STRIP001 	aPopMenu.EnableItem( FN_TOOL_ANKER_FRAME, 0 != pWrtShell->IsFlyInFly() );
//STRIP001 
//STRIP001 	Rectangle aRect(GetToolBox().GetItemRect(FN_TOOL_ANKER));
//STRIP001 	USHORT nHtmlMode = ::binfilter::GetHtmlMode((SwDocShell*)SfxObjectShell::Current());
//STRIP001 	BOOL bHtmlModeNoAnchor = ( nHtmlMode & HTMLMODE_ON) && 0 == (nHtmlMode & HTMLMODE_SOME_ABS_POS);
//STRIP001 
//STRIP001 	if (bHtmlModeNoAnchor || pWrtShell->IsInHeaderFooter())
//STRIP001 		aPopMenu.RemoveItem(aPopMenu.GetItemPos(FN_TOOL_ANKER_PAGE));
//STRIP001 
//STRIP001 	if (!pWrtShell->IsFrmSelected())
//STRIP001 		aPopMenu.RemoveItem(aPopMenu.GetItemPos(FN_TOOL_ANKER_AT_CHAR));
//STRIP001 
//STRIP001 	if (nActAnchorId)
//STRIP001 		aPopMenu.CheckItem(nActAnchorId);
//STRIP001 
//STRIP001 
//STRIP001 	USHORT nSlotId = aPopMenu.Execute(&GetToolBox(), aRect.BottomLeft());
//STRIP001 	GetToolBox().EndSelection();
//STRIP001 
//STRIP001 	if (nSlotId)
//STRIP001 		pView->GetViewFrame()->GetDispatcher()->Execute(nSlotId, SFX_CALLMODE_ASYNCHRON|SFX_CALLMODE_RECORD);
//STRIP001 }



}
