/*************************************************************************
 *
 *  $RCSfile: sw_instable.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:57:24 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {


//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #ifndef _SV_MSGBOX_HXX //autogen
//STRIP001 #include <vcl/msgbox.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #include "wrtsh.hxx"
//STRIP001 #include "view.hxx"
//STRIP001 #include "itabenum.hxx"
//STRIP001 #include "instable.hxx"
//STRIP001 #include "tautofmt.hxx"
//STRIP001 #include "tblafmt.hxx"
//STRIP001 #include "modcfg.hxx"
//STRIP001 #include "swmodule.hxx"
//STRIP001 #ifndef _SVX_HTMLMODE_HXX //autogen
//STRIP001 #include <bf_svx/htmlmode.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _VIEWOPT_HXX
//STRIP001 #include <viewopt.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #include "table.hrc"
//STRIP001 #include "instable.hrc"
//STRIP001 
//STRIP001 #define ROW_COL_PROD 16384
//STRIP001 
//STRIP001 void SwInsTableDlg::GetValues( String& rName, USHORT& rRow, USHORT& rCol,
//STRIP001                                 USHORT& rInsTblFlags, String& rAutoName,
//STRIP001 								SwTableAutoFmt *& prTAFmt )
//STRIP001 {
//STRIP001 	rName = aNameEdit.GetText();
//STRIP001 	rRow = (USHORT)aRowEdit.GetValue();
//STRIP001 	rCol = (USHORT)aColEdit.GetValue();
//STRIP001 
//STRIP001 	rInsTblFlags = 0;
//STRIP001 	if (aBorderCB.IsChecked())
//STRIP001 		rInsTblFlags |= DEFAULT_BORDER;
//STRIP001 	if (aHeaderCB.IsChecked())
//STRIP001 		rInsTblFlags |= HEADLINE;
//STRIP001 	if (aRepeatHeaderCB.IsEnabled() && aRepeatHeaderCB.IsChecked())
//STRIP001 		rInsTblFlags |= REPEAT;
//STRIP001 	if (!aDontSplitCB.IsChecked())
//STRIP001 		rInsTblFlags |= SPLIT_LAYOUT;
//STRIP001 	if( pTAutoFmt )
//STRIP001     {
//STRIP001 		prTAFmt = new SwTableAutoFmt( *pTAutoFmt );
//STRIP001         rAutoName = prTAFmt->GetName();
//STRIP001     }
//STRIP001 }
//STRIP001 
//STRIP001 // CTOR / DTOR -----------------------------------------------------------
//STRIP001 
//STRIP001 
//STRIP001 SwInsTableDlg::SwInsTableDlg( SwView& rView )
//STRIP001 	: SfxModalDialog( rView.GetWindow(), SW_RES(DLG_INSERT_TABLE) ),
//STRIP001 	aNameEdit		(this, SW_RES(ED_NAME)),
//STRIP001     aNameFT         (this, SW_RES(FT_NAME)),
//STRIP001 	aColLbl			(this, SW_RES(FT_COL)),
//STRIP001 	aColEdit		(this, SW_RES(ED_COL)),
//STRIP001 	aRowLbl			(this, SW_RES(FT_ROW)),
//STRIP001 	aRowEdit		(this, SW_RES(ED_ROW)),
//STRIP001     aFL             (this, SW_RES(FL_TABLE)),
//STRIP001 	aHeaderCB		(this, SW_RES(CB_HEADER)),
//STRIP001 	aRepeatHeaderCB	(this, SW_RES(CB_REPEAT_HEADER)),
//STRIP001 	aDontSplitCB	(this, SW_RES(CB_DONT_SPLIT)),
//STRIP001 	aBorderCB		(this, SW_RES(CB_BORDER)),
//STRIP001     aOptionsFL      (this, SW_RES(FL_OPTIONS)),
//STRIP001 	aOkBtn			(this, SW_RES(BT_OK)),
//STRIP001 	aCancelBtn		(this, SW_RES(BT_CANCEL)),
//STRIP001 	aHelpBtn		(this, SW_RES(BT_HELP)),
//STRIP001 	aAutoFmtBtn		(this, SW_RES(BT_AUTOFORMAT)),
//STRIP001 	pTAutoFmt( 0 ),
//STRIP001 	pShell(&rView.GetWrtShell())
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 	aNameEdit.SetText(pShell->GetUniqueTblName());
//STRIP001 	aNameEdit.SetModifyHdl(LINK(this, SwInsTableDlg, ModifyName));
//STRIP001 	aColEdit.SetModifyHdl(LINK(this, SwInsTableDlg, ModifyRowCol));
//STRIP001 	aRowEdit.SetModifyHdl(LINK(this, SwInsTableDlg, ModifyRowCol));
//STRIP001 
//STRIP001 	aRowEdit.SetMax(ROW_COL_PROD/aColEdit.GetValue());
//STRIP001 	aColEdit.SetMax(ROW_COL_PROD/aRowEdit.GetValue());
//STRIP001 	aAutoFmtBtn.SetClickHdl(LINK(this, SwInsTableDlg, AutoFmtHdl));
//STRIP001 
//STRIP001 	BOOL bHTMLMode = 0 != (::binfilter::GetHtmlMode(rView.GetDocShell())&HTMLMODE_ON);
//STRIP001 	const SwModuleOptions* pModOpt = SW_MOD()->GetModuleConfig();
//STRIP001 
//STRIP001 	USHORT nInsTblFlags = pModOpt->GetInsTblFlags(bHTMLMode);
//STRIP001 
//STRIP001 	aHeaderCB.Check(nInsTblFlags & HEADLINE);
//STRIP001 	aRepeatHeaderCB.Check(nInsTblFlags & REPEAT);
//STRIP001 	if(bHTMLMode)
//STRIP001 	{
//STRIP001 		aDontSplitCB.Hide();
//STRIP001 		aBorderCB.SetPosPixel(aDontSplitCB.GetPosPixel());
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aDontSplitCB.Check(!(nInsTblFlags & SPLIT_LAYOUT));
//STRIP001 	}
//STRIP001 	aBorderCB.Check(nInsTblFlags & DEFAULT_BORDER);
//STRIP001 
//STRIP001 	aHeaderCB.SetClickHdl(LINK(this, SwInsTableDlg, CheckBoxHdl));
//STRIP001 	CheckBoxHdl();
//STRIP001 }
//STRIP001 
//STRIP001 SwInsTableDlg::~SwInsTableDlg()
//STRIP001 {
//STRIP001 	delete pTAutoFmt;
//STRIP001 }
//STRIP001 
//STRIP001 IMPL_LINK_INLINE_START( SwInsTableDlg, ModifyName, Edit *, pEdit )
//STRIP001 {
//STRIP001 	String sTblName = pEdit->GetText();
//STRIP001 	if(sTblName.Search(' ') != STRING_NOTFOUND)
//STRIP001 	{
//STRIP001 		sTblName.EraseAllChars( );
//STRIP001 		pEdit->SetText(sTblName);
//STRIP001 	}
//STRIP001 
//STRIP001 	aOkBtn.Enable(pShell->GetTblStyle( sTblName ) == 0);
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 IMPL_LINK_INLINE_END( SwInsTableDlg, ModifyName, Edit *, EMPTYARG )
//STRIP001 
//STRIP001 /*-----------------15.04.98 11:36-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 IMPL_LINK( SwInsTableDlg, ModifyRowCol, NumericField *, pField )
//STRIP001 {
//STRIP001 	if(pField == &aColEdit)
//STRIP001 	{
//STRIP001 		long nCol = aColEdit.GetValue();
//STRIP001         if(!nCol)
//STRIP001             nCol = 1;
//STRIP001 		aRowEdit.SetMax(ROW_COL_PROD/nCol);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		long nRow = aRowEdit.GetValue();
//STRIP001         if(!nRow)
//STRIP001             nRow = 1;
//STRIP001         aColEdit.SetMax(ROW_COL_PROD/nRow);
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 IMPL_LINK( SwInsTableDlg, AutoFmtHdl, PushButton*, pButton )
//STRIP001 {
//STRIP001 	SwAutoFormatDlg aDlg( pButton, pShell, FALSE, pTAutoFmt );
//STRIP001 	if( RET_OK == aDlg.Execute())
//STRIP001 		aDlg.FillAutoFmtOfIndex( pTAutoFmt );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*********************************************************************/
//STRIP001 /*                                                                   */
//STRIP001 /*********************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK(SwInsTableDlg, CheckBoxHdl, CheckBox*, EMPTYARG)
//STRIP001 {
//STRIP001 	aRepeatHeaderCB.Enable(aHeaderCB.IsChecked());
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }




}
