/*************************************************************************
 *
 *  $RCSfile: sw_navicfg.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:58:14 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {


//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #ifndef _SWTYPES_HXX
//STRIP001 #include <swtypes.hxx>	// fuer Pathfinder
//STRIP001 #endif
//STRIP001 #ifndef _NAVICFG_HXX
//STRIP001 #include <navicfg.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SWCONT_HXX
//STRIP001 #include <swcont.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _TOOLS_DEBUG_HXX
//STRIP001 #include <tools/debug.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _COM_SUN_STAR_UNO_ANY_HXX_
//STRIP001 #include <com/sun/star/uno/Any.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
//STRIP001 #include <com/sun/star/uno/Sequence.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 using namespace utl;
//STRIP001 using namespace rtl;
//STRIP001 using namespace ::com::sun::star::uno;
//STRIP001 
//STRIP001 #define C2U(cChar) OUString::createFromAscii(cChar)

/* -----------------------------08.09.00 16:30--------------------------------

 ---------------------------------------------------------------------------*/
//STRIP001 Sequence<OUString> SwNavigationConfig::GetPropertyNames()
//STRIP001 {
//STRIP001 	static const char* aPropNames[] =
//STRIP001 	{
//STRIP001 		"RootType",     		//0
//STRIP001 		"SelectedPosition",     //1
//STRIP001 		"OutlineLevel",         //2
//STRIP001 		"InsertMode",           //3
//STRIP001 		"ActiveBlock",          //4
//STRIP001 		"ShowListBox",          //5
//STRIP001 		"GlobalDocMode"         //6
//STRIP001 	};
//STRIP001 	const int nCount = 7;
//STRIP001 	Sequence<OUString> aNames(nCount);
//STRIP001 	OUString* pNames = aNames.getArray();
//STRIP001 	for(int i = 0; i < nCount; i++)
//STRIP001 	{
//STRIP001 		pNames[i] = OUString::createFromAscii(aPropNames[i]);
//STRIP001 	}
//STRIP001 	return aNames;
//STRIP001 }
/*-----------------13.11.96 11.03-------------------

--------------------------------------------------*/

//STRIP001 SwNavigationConfig::SwNavigationConfig() :
//STRIP001 	utl::ConfigItem(C2U("Office.Writer/Navigator")),
//STRIP001 	bIsGlobalActive(TRUE),
//STRIP001 	bIsSmall(FALSE),
//STRIP001 	nRootType(0xffff),
//STRIP001 	nSelectedPos(0),
//STRIP001 	nOutlineLevel(MAXLEVEL),
//STRIP001 	nRegionMode(REGION_MODE_NONE),
//STRIP001 	nActiveBlock(0)
//STRIP001 {
//STRIP001 	Sequence<OUString> aNames = GetPropertyNames();
//STRIP001 	Sequence<Any> aValues = GetProperties(aNames);
//STRIP001 //	EnableNotification(aNames);
//STRIP001 	const Any* pValues = aValues.getConstArray();
//STRIP001 	DBG_ASSERT(aValues.getLength() == aNames.getLength(), "GetProperties failed")
//STRIP001 	if(aValues.getLength() == aNames.getLength())
//STRIP001 	{
//STRIP001 		for(int nProp = 0; nProp < aNames.getLength(); nProp++)
//STRIP001 		{
//STRIP001 			if(pValues[nProp].hasValue())
//STRIP001 			{
//STRIP001 				switch(nProp)
//STRIP001 				{
//STRIP001 					case 0: pValues[nProp] >>= nRootType;	   break;
//STRIP001 					case 1: pValues[nProp] >>= nSelectedPos;   break;
//STRIP001 					case 2: pValues[nProp] >>= nOutlineLevel;  break;
//STRIP001 					case 3: pValues[nProp] >>= nRegionMode;    break;
//STRIP001 					case 4: pValues[nProp] >>= nActiveBlock;	break;
//STRIP001 					case 5: bIsSmall		= *(sal_Bool*)pValues[nProp].getValue();  break;
//STRIP001 					case 6: bIsGlobalActive = *(sal_Bool*)pValues[nProp].getValue();  break;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
/* -----------------------------08.09.00 16:35--------------------------------

 ---------------------------------------------------------------------------*/
//STRIP001 SwNavigationConfig::~SwNavigationConfig()
//STRIP001 {}
/* -----------------------------08.09.00 16:35--------------------------------

 ---------------------------------------------------------------------------*/
//STRIP001 void SwNavigationConfig::Commit()
//STRIP001 {
//STRIP001 	Sequence<OUString> aNames = GetPropertyNames();
//STRIP001 	OUString* pNames = aNames.getArray();
//STRIP001 	Sequence<Any> aValues(aNames.getLength());
//STRIP001 	Any* pValues = aValues.getArray();
//STRIP001 	const Type& rType = ::getBooleanCppuType();
//STRIP001 
//STRIP001 	for(int nProp = 0; nProp < aNames.getLength(); nProp++)
//STRIP001 	{
//STRIP001 		switch(nProp)
//STRIP001 		{
//STRIP001 			case 0: pValues[nProp] <<= nRootType;	  break;
//STRIP001 			case 1: pValues[nProp] <<= nSelectedPos;  break;
//STRIP001 			case 2: pValues[nProp] <<= nOutlineLevel; break;
//STRIP001 			case 3: pValues[nProp] <<= nRegionMode;   break;
//STRIP001 			case 4: pValues[nProp] <<= nActiveBlock;	break;
//STRIP001 			case 5: pValues[nProp].setValue(&bIsSmall, rType);			break;
//STRIP001 			case 6: pValues[nProp].setValue(&bIsGlobalActive, rType);	break;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	PutProperties(aNames, aValues);
//STRIP001 }

}
