/*************************************************************************
 *
 *  $RCSfile: border.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 08:27:29 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_BORDER_HXX
#define _SVX_BORDER_HXX

// include ---------------------------------------------------------------

#ifndef _CTRLBOX_HXX //autogen
#include <svtools/ctrlbox.hxx>
#endif
#ifndef _GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif
#ifndef _FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif
#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _VALUESET_HXX //autogen
#include <svtools/valueset.hxx>
#endif
#ifndef _SFXTABDLG_HXX //autogen
#include <bf_sfx2/tabdlg.hxx>
#endif
#ifndef _SVX_FRMSEL_HXX
#include <bf_svx/frmsel.hxx>
#endif
namespace binfilter {
// forward ---------------------------------------------------------------

//STRIP001 class SvxBorderLine;
//STRIP001 class XColorTable;
//STRIP001 class SvxFrameLine;

// class SvxBorderTabPage ------------------------------------------------
/*
{k:\svx\prototyp\dialog\border.bmp}
[Beschreibung]
TabPage zur Einstellung der Umrandung (Staerke, Farbe, Schatten, ...)
[Items]
<SvxBoxItem><SID_ATTR_BORDER_OUTER>
<SvxBoxInfoItem><SID_ATTR_BORDER_INNER>
<SvxShadowItem><SID_ATTR_BORDER_SHADOW>
*/

// Border-Modes for paragraphs, textframes and tables
//STRIP001 #define SW_BORDER_MODE_PARA 	0x01
//STRIP001 #define SW_BORDER_MODE_TABLE    0x02
//STRIP001 #define SW_BORDER_MODE_FRAME    0x04

//STRIP001 class SvxBorderTabPage : public SfxTabPage
//STRIP001 {
//STRIP001 public:
//STRIP001 	static SfxTabPage*	Create( Window* pParent,
//STRIP001 								const SfxItemSet& rAttrSet);
//STRIP001 	static USHORT*		GetRanges();
//STRIP001 
//STRIP001 	virtual	BOOL		FillItemSet( SfxItemSet& rCoreAttrs );
//STRIP001 	virtual	void		Reset( const SfxItemSet& );
//STRIP001 
//STRIP001 	void				HideShadowControls();
//STRIP001 	void				SetSWMode(BYTE nSet);
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual int			DeactivatePage( SfxItemSet* pSet = 0 );
//STRIP001     virtual void        DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 
//STRIP001 private:
//STRIP001 	SvxBorderTabPage( Window* pParent, const SfxItemSet& rCoreAttrs );
//STRIP001 	~SvxBorderTabPage();
//STRIP001 
//STRIP001 	// Controls
//STRIP001 	FixedLine			aFlBorder;
//STRIP001     FixedText           aDefaultFT;
//STRIP001     ValueSet            aWndPresets;
//STRIP001     FixedText           aUserDefFT;
//STRIP001     SvxFrameSelector    aFrameSel;
//STRIP001 
//STRIP001     FixedLine           aFlSep1;
//STRIP001 	FixedLine			aFlLine;
//STRIP001     FixedText           aStyleFT;
//STRIP001     LineListBox         aLbLineStyle;
//STRIP001     FixedText           aColorFT;
//STRIP001 	ColorListBox		aLbLineColor;
//STRIP001 
//STRIP001     FixedLine           aFlSep2;
//STRIP001 	FixedLine			aDistanceFL;
//STRIP001 	FixedText 			aLeftFT;
//STRIP001 	MetricField			aLeftMF;
//STRIP001 	FixedText 			aRightFT;
//STRIP001 	MetricField			aRightMF;
//STRIP001 	FixedText 			aTopFT;
//STRIP001 	MetricField			aTopMF;
//STRIP001 	FixedText 			aBottomFT;
//STRIP001 	MetricField			aBottomMF;
//STRIP001 	CheckBox			aSynchronizeCB;
//STRIP001 
//STRIP001 	FixedLine			aFlShadow;
//STRIP001 	FixedText			aFtShadowPos;
//STRIP001 	ValueSet			aWndShadows;
//STRIP001 	FixedText			aFtShadowSize;
//STRIP001 	MetricField			aEdShadowSize;
//STRIP001 	FixedText			aFtShadowColor;
//STRIP001 	ColorListBox		aLbShadowColor;
//STRIP001 
//STRIP001     ImageList           aShadowImgLstH;
//STRIP001     ImageList           aShadowImgLst;
//STRIP001     ImageList           aBorderImgLstH;
//STRIP001     ImageList           aBorderImgLst;
//STRIP001 
//STRIP001 	long				nMinValue;	// minimum distance
//STRIP001 	BYTE				nSWMode;	// table, textframe, paragraph
//STRIP001 	BOOL				bIsTableBorder;
//STRIP001 
//STRIP001 	static BOOL 		bSync;
//STRIP001 
//STRIP001 #ifdef _SVX_BORDER_CXX
//STRIP001 	// Handler
//STRIP001 	DECL_LINK( SelStyleHdl_Impl, ListBox* pLb );
//STRIP001 	DECL_LINK( SelColHdl_Impl, ListBox* pLb );
//STRIP001 	DECL_LINK( SelPreHdl_Impl, void* );
//STRIP001 	DECL_LINK( SelSdwHdl_Impl, void* );
//STRIP001 	DECL_LINK( LinesChanged_Impl, void* );
//STRIP001 	DECL_LINK( ModifyDistanceHdl_Impl, MetricField*);
//STRIP001 	DECL_LINK( SyncHdl_Impl, CheckBox*);
//STRIP001 
//STRIP001 	// Filler
//STRIP001 	void				FillLineListBox_Impl();
//STRIP001 	void 				FillValueSets_Impl();
//STRIP001     void                InitValueSets_Impl();
//STRIP001 
//STRIP001 	// Setzen von einzelnen Frame-/Core-Linien
//STRIP001 	void				ResetFrameLine_Impl( const SvxBorderLine* pCurLine,
//STRIP001 											 SvxFrameLine& rFrameLine );
//STRIP001 	void				SetCoreLine_Impl( const SvxFrameLine* pFrameLine,
//STRIP001 										  SvxBorderLine*& rpCoreLine );
//STRIP001 #endif
//STRIP001 };

}//end of namespace binfilter
#endif

