/*************************************************************************
 *
 *  $RCSfile: offmgr_connpoolsettings.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:25:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc..
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {

//STRIP001 #ifndef _OFFAPP_CONNPOOLSETTINGS_HXX_
//STRIP001 #include "connpoolsettings.hxx"
//STRIP001 #endif
//STRIP001 
//STRIP001 //........................................................................
//STRIP001 namespace offapp
//STRIP001 {
//STRIP001 //........................................................................
//STRIP001 
//STRIP001 	//====================================================================
//STRIP001 	//= DriverPooling
//STRIP001 	//====================================================================
//STRIP001 	//--------------------------------------------------------------------
//STRIP001 	DriverPooling::DriverPooling()
//STRIP001 		:bEnabled(sal_False)
//STRIP001 		,nTimeoutSeconds(0)
//STRIP001 	{
//STRIP001 	}
//STRIP001 
//STRIP001 	//--------------------------------------------------------------------
//STRIP001 	DriverPooling::DriverPooling( const String& _rName, sal_Bool _bEnabled, const sal_Int32 _nTimeout )
//STRIP001 		:sName(_rName)
//STRIP001 		,bEnabled(_bEnabled)
//STRIP001 		,nTimeoutSeconds(_nTimeout)
//STRIP001 	{
//STRIP001 	}
//STRIP001 
//STRIP001 	//--------------------------------------------------------------------
//STRIP001 	sal_Bool DriverPooling::operator == (const DriverPooling& _rR) const
//STRIP001 	{
//STRIP001 		return	(sName == _rR.sName)
//STRIP001 			&&	(bEnabled == _rR.bEnabled)
//STRIP001 			&&	(nTimeoutSeconds == _rR.nTimeoutSeconds);
//STRIP001 	}
//STRIP001 
//STRIP001 	//====================================================================
//STRIP001 	//= DriverPoolingSettings
//STRIP001 	//====================================================================
//STRIP001 	//--------------------------------------------------------------------
//STRIP001 	DriverPoolingSettings::DriverPoolingSettings()
//STRIP001 	{
//STRIP001 	}
//STRIP001 
//STRIP001 	//====================================================================
//STRIP001 	//= DriverPoolingSettingsItem
//STRIP001 	//====================================================================
//STRIP001 	TYPEINIT1( DriverPoolingSettingsItem, SfxPoolItem )
//STRIP001 	//--------------------------------------------------------------------
//STRIP001 	DriverPoolingSettingsItem::DriverPoolingSettingsItem( sal_uInt16 _nId, const DriverPoolingSettings _rSettings )
//STRIP001 		:SfxPoolItem(_nId)
//STRIP001 		,m_aSettings(_rSettings)
//STRIP001 	{
//STRIP001 	}
//STRIP001 
//STRIP001 	//--------------------------------------------------------------------
//STRIP001 	int DriverPoolingSettingsItem::operator==( const SfxPoolItem& _rCompare ) const
//STRIP001 	{
//STRIP001 		const DriverPoolingSettingsItem* pItem = PTR_CAST(DriverPoolingSettingsItem, &_rCompare);
//STRIP001 		if (!pItem)
//STRIP001 			return sal_False;
//STRIP001 
//STRIP001 		if (m_aSettings.size() != pItem->m_aSettings.size())
//STRIP001 			return sal_False;
//STRIP001 
//STRIP001 		DriverPoolingSettings::const_iterator aOwn = m_aSettings.begin();
//STRIP001 		DriverPoolingSettings::const_iterator aOwnEnd = m_aSettings.end();
//STRIP001 		DriverPoolingSettings::const_iterator aForeign = pItem->m_aSettings.begin();
//STRIP001 		while (aOwn < aOwnEnd)
//STRIP001 		{
//STRIP001 			if (*aOwn != *aForeign)
//STRIP001 				return sal_False;
//STRIP001 
//STRIP001 			++aForeign;
//STRIP001 			++aOwn;
//STRIP001 		}
//STRIP001 
//STRIP001 		return sal_True;
//STRIP001 	}
//STRIP001 
//STRIP001 	//--------------------------------------------------------------------
//STRIP001 	SfxPoolItem* DriverPoolingSettingsItem::Clone( SfxItemPool *pPool ) const
//STRIP001 	{
//STRIP001 		return new DriverPoolingSettingsItem(Which(), m_aSettings);
//STRIP001 	}
//STRIP001 
//STRIP001 	//--------------------------------------------------------------------
//STRIP001 
//STRIP001 //........................................................................
//STRIP001 }	// namespace offapp
//STRIP001 //........................................................................



}
