/*************************************************************************
 *
 *  $RCSfile: sdbcdriverenum.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:25:41 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc..
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _OFFMGR_SDBCDRIVERENUMERATION_HXX_
#define _OFFMGR_SDBCDRIVERENUMERATION_HXX_


#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif

namespace rtl
{
	class OUString;
}
namespace binfilter {

//........................................................................
namespace offapp
{
//........................................................................

	//====================================================================
	//= ODriverEnumeration
	//====================================================================
	class ODriverEnumerationImpl;
	/** simple class for accessing SDBC drivers registered within the office
		<p>Rather small, introduced to not contaminate other instances with the
		exception handling (code-size-bloating) implementations here.
		</p>
	*/
//STRIP001 	class ODriverEnumeration
//STRIP001 	{
//STRIP001 	private:
//STRIP001 		ODriverEnumerationImpl*	m_pImpl;
//STRIP001 
//STRIP001 	public:
//STRIP001 		ODriverEnumeration() throw();
//STRIP001 		~ODriverEnumeration() throw();
//STRIP001 
//STRIP001 		typedef const	::rtl::OUString*	const_iterator;
//STRIP001 
//STRIP001 		const_iterator	begin() const throw();
//STRIP001 		const_iterator	end() const throw();
//STRIP001 		sal_Int32		size() const throw();
//STRIP001 	};

//........................................................................
}	// namespace offapp
//........................................................................

} //namespace binfilter
#endif // _OFFMGR_SDBCDRIVERENUMERATION_HXX_

