/*************************************************************************
 *
 *  $RCSfile: connpoolsettings.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 11:00:13 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc..
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _OFFAPP_CONNPOOLSETTINGS_HXX_
#define _OFFAPP_CONNPOOLSETTINGS_HXX_

// auto strip #ifndef _STRING_HXX
// auto strip #include <tools/string.hxx>
// auto strip #endif
// auto strip #ifndef _COMPHELPER_STLTYPES_HXX_
// auto strip #include <comphelper/stl_types.hxx>
// auto strip #endif
// auto strip #ifndef _SFXPOOLITEM_HXX 
// auto strip #include <svtools/poolitem.hxx>
// auto strip #endif
namespace binfilter {

//........................................................................
namespace offapp
{
//........................................................................

	//====================================================================
	//= DriverPooling
	//====================================================================
//STRIP001 	struct DriverPooling
//STRIP001 	{
//STRIP001 		String				sName;
//STRIP001 		sal_Bool			bEnabled;
//STRIP001 		sal_Int32			nTimeoutSeconds;
//STRIP001 
//STRIP001 		DriverPooling();
//STRIP001 		DriverPooling( const String& _rName, sal_Bool _bEnabled, const sal_Int32 _nTimeout );
//STRIP001 
//STRIP001 		sal_Bool operator == (const DriverPooling& _rR) const;
//STRIP001 		sal_Bool operator != (const DriverPooling& _rR) const { return !operator ==(_rR); }
//STRIP001 	};

	//====================================================================
	//= DriverPoolingSettings
	//====================================================================
//STRIP001 	class DriverPoolingSettings
//STRIP001 	{
//STRIP001 	protected:
//STRIP001 		DECLARE_STL_VECTOR( DriverPooling, DriverSettings );
//STRIP001 		DriverSettings		m_aDrivers;
//STRIP001 
//STRIP001 	public:
//STRIP001 		typedef ConstDriverSettingsIterator	const_iterator;
//STRIP001 		typedef DriverSettingsIterator		iterator;
//STRIP001 
//STRIP001 	public:
//STRIP001 		DriverPoolingSettings();
//STRIP001 
//STRIP001 		sal_Int32 size() const { return m_aDrivers.size(); }
//STRIP001 
//STRIP001 		const_iterator	begin() const	{ return m_aDrivers.begin(); }
//STRIP001 		const_iterator	end() const		{ return m_aDrivers.end(); }
//STRIP001 
//STRIP001 		iterator		begin()		{ return m_aDrivers.begin(); }
//STRIP001 		iterator		end()		{ return m_aDrivers.end(); }
//STRIP001 
//STRIP001 		void push_back(const DriverPooling& _rElement) { m_aDrivers.push_back(_rElement); }
//STRIP001 	};

	//====================================================================
	//= DriverPoolingSettingsItem
	//====================================================================
//STRIP001 	class DriverPoolingSettingsItem : public SfxPoolItem
//STRIP001 	{
//STRIP001 	protected:
//STRIP001 		DriverPoolingSettings	m_aSettings;
//STRIP001 
//STRIP001 	public:
//STRIP001 		TYPEINFO();
//STRIP001 
//STRIP001 		DriverPoolingSettingsItem( sal_uInt16 _nId, const DriverPoolingSettings _rSettings );
//STRIP001 
//STRIP001 		virtual int              operator==( const SfxPoolItem& ) const;
//STRIP001 		virtual SfxPoolItem*     Clone( SfxItemPool *pPool = 0 ) const;
//STRIP001 
//STRIP001 		const DriverPoolingSettings& getSettings() const	{ return m_aSettings; }
//STRIP001 	};

//........................................................................
}	// namespace offapp
//........................................................................

} //namespace binfilter
#endif // _OFFAPP_CONNPOOLSETTINGS_HXX_


