/*************************************************************************
 *
 *  $RCSfile: sc_filtopt.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 11:16:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "core_pch.hxx"
#endif

#pragma hdrstop

//------------------------------------------------------------------

// auto strip #include <tools/debug.hxx>

// auto strip #include <com/sun/star/uno/Any.hxx>
// auto strip #include <com/sun/star/uno/Sequence.hxx>

// auto strip #include "filtopt.hxx"
#include "miscuno.hxx"
namespace binfilter {

//using namespace utl;
using namespace rtl;
using namespace ::com::sun::star::uno;

//------------------------------------------------------------------

#define CFGPATH_FILTER			"Office.Calc/Filter/Import"

#define SCFILTOPT_COLSCALE		0
#define SCFILTOPT_ROWSCALE		1
#define SCFILTOPT_WK3			2
#define SCFILTOPT_COUNT			3

//!	expand options for bBreakShared
//!	(former "EXCELBREAKSHAREDFORMULA" in ini file)

//STRIP001 Sequence<OUString> ScFilterOptions::GetPropertyNames()
//STRIP001 {
//STRIP001 	static const char* aPropNames[] =
//STRIP001 	{
//STRIP001 		"MS_Excel/ColScale",			// SCFILTOPT_COLSCALE
//STRIP001 		"MS_Excel/RowScale",			// SCFILTOPT_ROWSCALE
//STRIP001 		"Lotus123/WK3"					// SCFILTOPT_WK3
//STRIP001 	};
//STRIP001 	Sequence<OUString> aNames(SCFILTOPT_COUNT);
//STRIP001 	OUString* pNames = aNames.getArray();
//STRIP001 	for(int i = 0; i < SCFILTOPT_COUNT; i++)
//STRIP001 		pNames[i] = OUString::createFromAscii(aPropNames[i]);
//STRIP001 
//STRIP001 	return aNames;
//STRIP001 }

//STRIP001 ScFilterOptions::ScFilterOptions() :
//STRIP001 	ConfigItem( OUString::createFromAscii( CFGPATH_FILTER ) ),
//STRIP001 	bWK3Flag( FALSE ),
//STRIP001 	bBreakShared( TRUE ),
//STRIP001 	fExcelColScale( 0 ),
//STRIP001 	fExcelRowScale( 0 )
//STRIP001 {
//STRIP001 	Sequence<OUString> aNames = GetPropertyNames();
//STRIP001 	Sequence<Any> aValues = GetProperties(aNames);
//STRIP001 //	EnableNotification(aNames);
//STRIP001 	const Any* pValues = aValues.getConstArray();
//STRIP001 	DBG_ASSERT(aValues.getLength() == aNames.getLength(), "GetProperties failed")
//STRIP001 	if(aValues.getLength() == aNames.getLength())
//STRIP001 	{
//STRIP001 		for(int nProp = 0; nProp < aNames.getLength(); nProp++)
//STRIP001 		{
//STRIP001 			DBG_ASSERT(pValues[nProp].hasValue(), "property value missing")
//STRIP001 			if(pValues[nProp].hasValue())
//STRIP001 			{
//STRIP001 				switch(nProp)
//STRIP001 				{
//STRIP001 					case SCFILTOPT_COLSCALE:
//STRIP001 						pValues[nProp] >>= fExcelColScale;
//STRIP001 						break;
//STRIP001 					case SCFILTOPT_ROWSCALE:
//STRIP001 						pValues[nProp] >>= fExcelRowScale;
//STRIP001 						break;
//STRIP001 					case SCFILTOPT_WK3:
//STRIP001 						bWK3Flag = ScUnoHelpFunctions::GetBoolFromAny( pValues[nProp] );
//STRIP001 						break;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }


//STRIP001 void ScFilterOptions::Commit()
//STRIP001 {
//STRIP001 	// options are never modified from office
//STRIP001 
//STRIP001 	DBG_ERROR("trying to commit changed ScFilterOptions?");
//STRIP001 }

//STRIP001 void ScFilterOptions::Notify( const Sequence<rtl::OUString>& aPropertyNames )
//STRIP001 {
//STRIP001 	DBG_ERROR("properties have been changed")
//STRIP001 }


}
