#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.3 $
#
#   last change: $Author: aw $ $Date: 2003/11/18 19:22:35 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
PRJ=..$/..$/..$/..
BFPRJ=..$/..$/..

PRJNAME=binfilter
TARGET=sc_excel

#GEN_HID=TRUE
#GEN_HID_OTHER=TRUE
NO_HIDS=TRUE

AUTOSEG=true

PROJECTPCH4DLL=TRUE
PROJECTPCH=filt_pch
PROJECTPCHSOURCE=..\pch\sc_filt_pch

# --- Settings -----------------------------------------------------

.INCLUDE :  scpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sc.mk
.INCLUDE :  $(BFPRJ)$/util$/makefile.pmk
INC+= -I$(PRJ)$/inc$/bf_sc
# --- Files --------------------------------------------------------

SLOFILES =	\
		$(SLO)$/sc_xltools.obj					\
		$(SLO)$/sc_xlroot.obj					\
		$(SLO)$/sc_xlstyle.obj					\
		$(SLO)$/sc_xlocx.obj					\
		$(SLO)$/sc_xistream.obj				\
		$(SLO)$/sc_xiroot.obj					\
		$(SLO)$/sc_xihelper.obj				\
		$(SLO)$/sc_xilink.obj					\
		$(SLO)$/sc_xicontent.obj				\
		$(SLO)$/sc_xistyle.obj					\
		$(SLO)$/sc_xiescher.obj				\
		$(SLO)$/sc_xestream.obj				\
		$(SLO)$/sc_xerecord.obj				\
		$(SLO)$/sc_xeroot.obj					\
		$(SLO)$/sc_xehelper.obj				\
		$(SLO)$/sc_xelink.obj					\
		$(SLO)$/sc_xecontent.obj				\
		$(SLO)$/sc_xestyle.obj					\
		$(SLO)$/sc_XclChartsApiHelper.obj		\
		$(SLO)$/sc_XclImpCharts.obj			\
		$(SLO)$/sc_XclImpChartsApi.obj			\
		$(SLO)$/sc_XclExpCharts.obj			\
		$(SLO)$/sc_read.obj					\
		$(SLO)$/sc_impop.obj					\
		$(SLO)$/sc_excimp8.obj					\
		$(SLO)$/sc_excel.obj					\
		$(SLO)$/sc_excform.obj					\
		$(SLO)$/sc_excform8.obj				\
		$(SLO)$/sc_fontbuff.obj				\
		$(SLO)$/sc_tokstack.obj				\
		$(SLO)$/sc_namebuff.obj				\
		$(SLO)$/sc_colrowst.obj				\
		$(SLO)$/sc_expop2.obj					\
		$(SLO)$/sc_excrecds.obj				\
		$(SLO)$/sc_excdoc.obj					\
		$(SLO)$/sc_exctools.obj				\
		$(SLO)$/sc_excobj.obj					\
		$(SLO)$/sc_excchart.obj				\
		$(SLO)$/sc_functab.obj					\
		$(SLO)$/sc_frmbase.obj					\
		$(SLO)$/sc_exccomp.obj					\
		$(SLO)$/sc_biffdump.obj

EXCEPTIONSFILES = \
		$(SLO)$/sc_XclImpChartsApi.obj			\
		$(SLO)$/sc_XclExpCharts.obj

# --- Targets -------------------------------------------------------

.INCLUDE :  target.mk

