/*************************************************************************
 *
 *  $RCSfile: sc_hintwin.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:30:55 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// System - Includes -----------------------------------------------------

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif


// INCLUDE ---------------------------------------------------------------

// auto strip #include "hintwin.hxx"
// auto strip #include "global.hxx"
namespace binfilter {

#define HINT_LINESPACE	2
#define HINT_INDENT		3
#define HINT_MARGIN		4

//==================================================================

//STRIP001 ScHintWindow::ScHintWindow( Window* pParent, const String& rTit, const String& rMsg ) :
//STRIP001 	Window( pParent, WinBits( WB_BORDER ) ),
//STRIP001 	aTitle( rTit ),
//STRIP001 	aMessage( rMsg )
//STRIP001 {
//STRIP001 	aMessage.ConvertLineEnd( LINEEND_CR );
//STRIP001 
//STRIP001 	//	Hellgelb, wie Notizen in detfunc.cxx
//STRIP001 	Color aYellow( 255,255,192 );			// hellgelb
//STRIP001 	SetBackground( aYellow );
//STRIP001 
//STRIP001 	aTextFont = GetFont();
//STRIP001 	aTextFont.SetTransparent( TRUE );
//STRIP001 	aTextFont.SetWeight( WEIGHT_NORMAL );
//STRIP001 	aHeadFont = aTextFont;
//STRIP001 	aHeadFont.SetWeight( WEIGHT_BOLD );
//STRIP001 
//STRIP001 	SetFont( aHeadFont );
//STRIP001 	Size aHeadSize( GetTextWidth( aTitle ), GetTextHeight() );
//STRIP001 	SetFont( aTextFont );
//STRIP001 
//STRIP001 	Size aTextSize;
//STRIP001 	xub_StrLen nIndex = 0;
//STRIP001 	while ( nIndex != STRING_NOTFOUND )
//STRIP001 	{
//STRIP001 		String aLine = aMessage.GetToken( 0, CHAR_CR, nIndex );
//STRIP001 		Size aLineSize( GetTextWidth( aLine ), GetTextHeight() );
//STRIP001 		nTextHeight = aLineSize.Height();
//STRIP001 		aTextSize.Height() += nTextHeight;
//STRIP001 		if ( aLineSize.Width() > aTextSize.Width() )
//STRIP001 			aTextSize.Width() = aLineSize.Width();
//STRIP001 	}
//STRIP001 	aTextSize.Width() += HINT_INDENT;
//STRIP001 
//STRIP001 	aTextStart = Point( HINT_MARGIN + HINT_INDENT,
//STRIP001 						aHeadSize.Height() + HINT_MARGIN + HINT_LINESPACE );
//STRIP001 
//STRIP001 	Size aWinSize( Max( aHeadSize.Width(), aTextSize.Width() ) + 2 * HINT_MARGIN + 1,
//STRIP001 					aHeadSize.Height() + aTextSize.Height() + HINT_LINESPACE + 2 * HINT_MARGIN + 1 );
//STRIP001 	SetOutputSizePixel( aWinSize );
//STRIP001 }


//STRIP001 ScHintWindow::~ScHintWindow()
//STRIP001 {
//STRIP001 }


//STRIP001 void __EXPORT ScHintWindow::Paint( const Rectangle& rRect )
//STRIP001 {
//STRIP001 	SetFont( aHeadFont );
//STRIP001 	DrawText( Point(HINT_MARGIN,HINT_MARGIN), aTitle );
//STRIP001 
//STRIP001 	SetFont( aTextFont );
//STRIP001 	xub_StrLen nIndex = 0;
//STRIP001 	Point aLineStart = aTextStart;
//STRIP001 	while ( nIndex != STRING_NOTFOUND )
//STRIP001 	{
//STRIP001 		String aLine = aMessage.GetToken( 0, CHAR_CR, nIndex );
//STRIP001 		DrawText( aLineStart, aLine );
//STRIP001 		aLineStart.Y() += nTextHeight;
//STRIP001 	}
//STRIP001 }
}
