/*************************************************************************
 *
 *  $RCSfile: sc_viewfun7.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:41:01 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

// INCLUDE ---------------------------------------------------------------

// auto strip #include <so3/ipobj.hxx>
// auto strip #include <bf_svx/svditer.hxx>
// auto strip #include <bf_svx/svdograf.hxx>
// auto strip #include <bf_svx/svdoole2.hxx>
#include <bf_svx/svdouno.hxx>
// auto strip #include <bf_svx/svdpage.hxx>
// auto strip #include <bf_svx/svdpagv.hxx>
// auto strip #include <bf_svx/svdundo.hxx>
// auto strip #include <bf_svx/xbitmap.hxx>
// auto strip #include <bf_svx/xbtmpit.hxx>
// auto strip #include <bf_svx/xoutbmp.hxx>
// auto strip #include <bf_sfx2/objsh.hxx>
// auto strip #include <bf_sfx2/viewfrm.hxx>

// auto strip #include "document.hxx"		// fuer MapMode Initialisierung in PasteDraw
// auto strip #include "viewfunc.hxx"
// auto strip #include "tabvwsh.hxx"
// auto strip #include "drawview.hxx"
// auto strip #include "scmod.hxx"
// auto strip #include "drwlayer.hxx"
// auto strip #include "drwtrans.hxx"
#include "globstr.hrc"
namespace binfilter {

extern Point aDragStartDiff;

// STATIC DATA -----------------------------------------------------------

BOOL bPasteIsMove = FALSE;

//==================================================================

//STRIP001 void lcl_AdjustInsertPos( ScViewData* pData, Point& rPos, Size& rSize )
//STRIP001 {
//STRIP001 //	SdrPage* pPage = pData->GetDocument()->GetDrawLayer()->GetPage( pData->GetTabNo() );
//STRIP001 	SdrPage* pPage = pData->GetScDrawView()->GetModel()->GetPage( pData->GetTabNo() );
//STRIP001 	DBG_ASSERT(pPage,"pPage ???");
//STRIP001 	Size aPgSize( pPage->GetSize() );
//STRIP001 	long x = aPgSize.Width() - rPos.X() - rSize.Width();
//STRIP001 	long y = aPgSize.Height() - rPos.Y() - rSize.Height();
//STRIP001 	// ggf. Ajustments (80/200) fuer Pixel-Rundungsfehler
//STRIP001 	if( x < 0 )
//STRIP001 		rPos.X() += x + 80;
//STRIP001 	if( y < 0 )
//STRIP001 		rPos.Y() += y + 200;
//STRIP001 	rPos.X() += rSize.Width() / 2;			// Position bei Paste gibt Mittelpunkt an
//STRIP001 	rPos.Y() += rSize.Height() / 2;
//STRIP001 }

//STRIP001 void ScViewFunc::PasteDraw( const Point& rLogicPos, SdrModel* pModel,
//STRIP001         BOOL bGroup, BOOL bSameDocClipboard )
//STRIP001 {
//STRIP001 	MakeDrawLayer();
//STRIP001 	Point aPos( rLogicPos );
//STRIP001 
//STRIP001 	//	#64184# MapMode am Outliner-RefDevice muss stimmen (wie in FuText::MakeOutliner)
//STRIP001 	//!	mit FuText::MakeOutliner zusammenfassen?
//STRIP001 	MapMode aOldMapMode;
//STRIP001 	OutputDevice* pRef = GetViewData()->GetDocument()->GetDrawLayer()->GetRefDevice();
//STRIP001 	if (pRef)
//STRIP001 	{
//STRIP001 		aOldMapMode = pRef->GetMapMode();
//STRIP001 		pRef->SetMapMode( MapMode(MAP_100TH_MM) );
//STRIP001 	}
//STRIP001 
//STRIP001 	SdrView* pDragEditView = NULL;
//STRIP001 	ScModule* pScMod = SC_MOD();
//STRIP001 	const ScDragData& rData = pScMod->GetDragData();
//STRIP001 	ScDrawTransferObj* pDrawTrans = rData.pDrawTransfer;
//STRIP001 	if (pDrawTrans)
//STRIP001 	{
//STRIP001 		pDragEditView = pDrawTrans->GetDragSourceView();
//STRIP001 
//STRIP001 		aPos -= aDragStartDiff;
//STRIP001 		if (aPos.X() < 0) aPos.X() = 0;
//STRIP001 		if (aPos.Y() < 0) aPos.Y() = 0;
//STRIP001 	}
//STRIP001 
//STRIP001 	ScDrawView* pDrawView = GetScDrawView();
//STRIP001 	if (bGroup)
//STRIP001 		pDrawView->BegUndo( ScGlobal::GetRscString( STR_UNDO_PASTE ) );
//STRIP001 
//STRIP001 	BOOL bSameDoc = ( pDragEditView && pDragEditView->GetModel() == pDrawView->GetModel() );
//STRIP001 	if (bSameDoc)
//STRIP001 	{
//STRIP001 			// lokal kopieren - incl. Charts
//STRIP001 
//STRIP001 		Point aSourceStart = pDragEditView->GetAllMarkedRect().TopLeft();
//STRIP001 		long nDiffX = aPos.X() - aSourceStart.X();
//STRIP001 		long nDiffY = aPos.Y() - aSourceStart.Y();
//STRIP001 
//STRIP001 			// innerhalb einer Page verschieben?
//STRIP001 
//STRIP001 		if ( bPasteIsMove &&
//STRIP001 				pDrawView->GetPageViewPvNum(0)->GetPage() ==
//STRIP001 				pDragEditView->GetPageViewPvNum(0)->GetPage() )
//STRIP001 		{
//STRIP001 			if ( nDiffX != 0 || nDiffY != 0 )
//STRIP001 				pDragEditView->MoveAllMarked(Size(nDiffX,nDiffY), FALSE);
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			SdrModel* pModel = pDragEditView->GetModel();
//STRIP001 			SdrPage* pDestPage = pModel->GetPage( GetViewData()->GetTabNo() );
//STRIP001 			DBG_ASSERT(pDestPage,"nanu, Page?");
//STRIP001 
//STRIP001 			SdrMarkList aMark = pDragEditView->GetMarkList();
//STRIP001 			aMark.ForceSort();
//STRIP001 			ULONG nMarkAnz=aMark.GetMarkCount();
//STRIP001 			for (ULONG nm=0; nm<nMarkAnz; nm++) {
//STRIP001 				const SdrMark* pM=aMark.GetMark(nm);
//STRIP001 				const SdrObject* pObj=pM->GetObj();
//STRIP001 				SdrObject* pNeuObj=pObj->Clone(pDestPage,pModel);
//STRIP001 				if (pNeuObj!=NULL)
//STRIP001 				{
//STRIP001 					//	#68787# copy graphics within the same model - always needs new name
//STRIP001 					if ( pNeuObj->ISA(SdrGrafObj) && !bPasteIsMove )
//STRIP001 						pNeuObj->SetName(((ScDrawLayer*)pModel)->GetNewGraphicName());
//STRIP001 
//STRIP001 					if (nDiffX!=0 || nDiffY!=0)
//STRIP001 						pNeuObj->NbcMove(Size(nDiffX,nDiffY));
//STRIP001 					pDestPage->InsertObject( pNeuObj );
//STRIP001 					pDrawView->AddUndo(new SdrUndoInsertObj( *pNeuObj ));
//STRIP001 
//STRIP001 					//	Chart braucht nicht mehr getrennt behandelt zu werden,
//STRIP001 					//	weil es seine Daten jetzt selber hat
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			if (bPasteIsMove)
//STRIP001 				pDragEditView->DeleteMarked();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		bPasteIsMove = FALSE;		// kein internes Verschieben passiert
//STRIP001 
//STRIP001 		SdrMarkView aView(pModel);
//STRIP001 		SdrPageView* pPv = aView.ShowPagePgNum(0,Point());
//STRIP001 		aView.MarkAll(pPv);
//STRIP001 		Size aSize = aView.GetAllMarkedRect().GetSize();
//STRIP001 		lcl_AdjustInsertPos( GetViewData(), aPos, aSize );
//STRIP001 
//STRIP001 		//	#41333# Markierung nicht aendern, wenn Ole-Objekt aktiv
//STRIP001 		//	(bei Drop aus Ole-Objekt wuerde sonst mitten im ExecuteDrag deaktiviert!)
//STRIP001 
//STRIP001 		ULONG nOptions = 0;
//STRIP001 		SfxInPlaceClient* pClient = GetViewData()->GetViewShell()->GetIPClient();
//STRIP001 		if ( pClient && pClient->IsInPlaceActive() )
//STRIP001 			nOptions |= SDRINSERT_DONTMARK;
//STRIP001 
//STRIP001         // #89247# Set flag for ScDocument::UpdateChartListeners() which is
//STRIP001         // called during paste.
//STRIP001         if ( !bSameDocClipboard )
//STRIP001             GetViewData()->GetDocument()->SetPastingDrawFromOtherDoc( TRUE );
//STRIP001 
//STRIP001 		pDrawView->Paste( *pModel, aPos, NULL, nOptions );
//STRIP001 
//STRIP001         if ( !bSameDocClipboard )
//STRIP001             GetViewData()->GetDocument()->SetPastingDrawFromOtherDoc( FALSE );
//STRIP001 
//STRIP001 		// #68991# Paste puts all objects on the active (front) layer
//STRIP001 		// controls must be on SC_LAYER_CONTROLS
//STRIP001 
//STRIP001 		USHORT nTab = GetViewData()->GetTabNo();
//STRIP001 		SdrPage* pPage = pDrawView->GetModel()->GetPage(nTab);
//STRIP001 		DBG_ASSERT(pPage,"Page?");
//STRIP001 		if (pPage)
//STRIP001 		{
//STRIP001 			SdrObjListIter aIter( *pPage, IM_DEEPNOGROUPS );
//STRIP001 			SdrObject* pObject = aIter.Next();
//STRIP001 			while (pObject)
//STRIP001 			{
//STRIP001 				if ( pObject->ISA(SdrUnoObj) && pObject->GetLayer() != SC_LAYER_CONTROLS )
//STRIP001 					pObject->NbcSetLayer(SC_LAYER_CONTROLS);
//STRIP001 				pObject = aIter.Next();
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		// #75299# all graphics objects must have names
//STRIP001 		GetViewData()->GetDocument()->EnsureGraphicNames();
//STRIP001 	}
//STRIP001 
//STRIP001 	if (bGroup)
//STRIP001 	{
//STRIP001 		pDrawView->GroupMarked();
//STRIP001 		pDrawView->EndUndo();
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pRef)
//STRIP001 		pRef->SetMapMode( aOldMapMode );
//STRIP001 
//STRIP001     // GetViewData()->GetViewShell()->SetDrawShell( TRUE );
//STRIP001     // #99759# It is not sufficient to just set the DrawShell if we pasted, for
//STRIP001     // example, a chart.  SetDrawShellOrSub() would only work for D&D in the
//STRIP001     // same document but not if inserting from the clipboard, therefore
//STRIP001     // MarkListHasChanged() is what we need.
//STRIP001     pDrawView->MarkListHasChanged();
//STRIP001 
//STRIP001 }

//STRIP001 BOOL ScViewFunc::PasteObject( const Point& rPos, SvInPlaceObject* pObj,
//STRIP001 								const Size* pDescSize )
//STRIP001 {
//STRIP001 	MakeDrawLayer();
//STRIP001 	if ( pObj )
//STRIP001 	{
//STRIP001 		SvEmbeddedInfoObject* pInfoObj = GetViewData()->GetViewShell()->
//STRIP001 											GetViewFrame()->GetObjectShell()->
//STRIP001 											InsertObject(pObj, String());
//STRIP001 		String aName = pInfoObj->GetObjName();
//STRIP001 
//STRIP001 		MapMode aMap100( MAP_100TH_MM );
//STRIP001 		MapMode aMapObj( pObj->GetMapUnit() );
//STRIP001 
//STRIP001 		// use size from object descriptor if given
//STRIP001 		if ( pDescSize && pDescSize->Width() && pDescSize->Height() )
//STRIP001 			pObj->SetVisAreaSize(OutputDevice::LogicToLogic( *pDescSize, aMap100, aMapObj ));
//STRIP001 
//STRIP001 		Size aSize = pObj->GetVisArea().GetSize();
//STRIP001 		aSize = OutputDevice::LogicToLogic( aSize, aMapObj, aMap100 );	// fuer SdrOle2Obj
//STRIP001 
//STRIP001 		if( aSize.Height() == 0 || aSize.Width() == 0 )
//STRIP001 		{
//STRIP001 			DBG_ERROR("SvObjectDescriptor::GetSize == 0");
//STRIP001 			aSize.Width() = 5000;
//STRIP001 			aSize.Height() = 5000;
//STRIP001 			aSize = OutputDevice::LogicToLogic( aSize, aMap100, aMapObj );
//STRIP001 			pObj->SetVisAreaSize(aSize);
//STRIP001 		}
//STRIP001 		// kein AdjustInsertPos
//STRIP001 		Rectangle aRect( rPos, aSize );
//STRIP001 
//STRIP001 		ScDrawView* pDrView = GetScDrawView();
//STRIP001 		SdrOle2Obj* pSdrObj = new SdrOle2Obj( pObj, aName, aRect );
//STRIP001 		SdrPageView* pPV = pDrView->GetPageViewPvNum(0);
//STRIP001 		pDrView->InsertObjectSafe( pSdrObj, *pPV );				// nicht markieren wenn Ole
//STRIP001 		GetViewData()->GetViewShell()->SetDrawShell( TRUE );
//STRIP001 		return TRUE;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		return FALSE;
//STRIP001 }

//STRIP001 BOOL ScViewFunc::PasteBitmap( const Point& rPos, const Bitmap& rBmp )
//STRIP001 {
//STRIP001 	String aEmpty;
//STRIP001 	Graphic aGraphic(rBmp);
//STRIP001 	return PasteGraphic( rPos, aGraphic, aEmpty, aEmpty );
//STRIP001 }

//STRIP001 BOOL ScViewFunc::PasteMetaFile( const Point& rPos, const GDIMetaFile& rMtf )
//STRIP001 {
//STRIP001 	String aEmpty;
//STRIP001 	Graphic aGraphic(rMtf);
//STRIP001 	return PasteGraphic( rPos, aGraphic, aEmpty, aEmpty );
//STRIP001 }

//STRIP001 BOOL ScViewFunc::PasteGraphic( const Point& rPos, const Graphic& rGraphic,
//STRIP001 								const String& rFile, const String& rFilter )
//STRIP001 {
//STRIP001 	MakeDrawLayer();
//STRIP001 	ScDrawView* pDrawView = GetScDrawView();
//STRIP001 
//STRIP001 	Point aPos( rPos );
//STRIP001 	Window* pWin = GetActiveWin();
//STRIP001 	MapMode aSourceMap = rGraphic.GetPrefMapMode();
//STRIP001 	MapMode aDestMap( MAP_100TH_MM );
//STRIP001 
//STRIP001 	if (aSourceMap.GetMapUnit() == MAP_PIXEL)
//STRIP001 	{
//STRIP001 			//	Pixel-Korrektur beruecksichtigen, damit Bitmap auf dem Bildschirm stimmt
//STRIP001 
//STRIP001 		Fraction aScaleX, aScaleY;
//STRIP001 		pDrawView->CalcNormScale( aScaleX, aScaleY );
//STRIP001 		aDestMap.SetScaleX(aScaleX);
//STRIP001 		aDestMap.SetScaleY(aScaleY);
//STRIP001 	}
//STRIP001 
//STRIP001 	Size aSize = pWin->LogicToLogic( rGraphic.GetPrefSize(), &aSourceMap, &aDestMap );
//STRIP001 //	lcl_AdjustInsertPos( GetViewData(), aPos, aSize );
//STRIP001 	GetViewData()->GetViewShell()->SetDrawShell( TRUE );
//STRIP001 
//STRIP001 	Rectangle aRect(aPos, aSize);
//STRIP001 	SdrGrafObj* pGrafObj = new SdrGrafObj(rGraphic, aRect);
//STRIP001 
//STRIP001 	if (rFile.Len())
//STRIP001 		pGrafObj->SetGraphicLink( rFile, rFilter );
//STRIP001 
//STRIP001 	//	#49961# Pfad wird nicht mehr als Name der Grafik gesetzt
//STRIP001 
//STRIP001 	ScDrawLayer* pLayer = (ScDrawLayer*) pDrawView->GetModel();
//STRIP001 	String aName = pLayer->GetNewGraphicName();					// "Grafik x"
//STRIP001 	pGrafObj->SetName(aName);
//STRIP001 
//STRIP001 	// nicht markieren wenn Ole
//STRIP001 	pDrawView->InsertObjectSafe(pGrafObj, *pDrawView->GetPageViewPvNum(0));
//STRIP001 	return TRUE;
//STRIP001 }

//STRIP001 BOOL ScViewFunc::ApplyGraphicToObject( SdrObject* pPickObj, const Graphic& rGraphic )
//STRIP001 {
//STRIP001 	BOOL bRet = FALSE;
//STRIP001 	SdrGrafObj* pNewGrafObj = NULL;
//STRIP001 
//STRIP001 	ScDrawView* pDrawView = GetScDrawView();
//STRIP001 	if ( pDrawView && pPickObj )
//STRIP001 	{
//STRIP001 		/**********************************************************************
//STRIP001 		* Objekt neu attributieren
//STRIP001 		**********************************************************************/
//STRIP001 		SdrPageView* pPV = pDrawView->GetPageViewPvNum(0);
//STRIP001 		if (pPickObj->ISA(SdrGrafObj))
//STRIP001 		{
//STRIP001 			/******************************************************************
//STRIP001 			* Das Graphik-Objekt bekommt eine neue Graphik
//STRIP001 			******************************************************************/
//STRIP001 			pNewGrafObj = (SdrGrafObj*) pPickObj->Clone();
//STRIP001 			pNewGrafObj->SetGraphic(rGraphic);
//STRIP001 
//STRIP001 			pDrawView->BegUndo(ScGlobal::GetRscString(STR_UNDO_DRAGDROP));
//STRIP001 			pDrawView->ReplaceObject(pPickObj, *pPV, pNewGrafObj);
//STRIP001 			pDrawView->EndUndo();
//STRIP001 
//STRIP001 			bRet = TRUE;
//STRIP001 		}
//STRIP001 		else if (pPickObj->IsClosedObj() && !pPickObj->ISA(SdrOle2Obj))
//STRIP001 		{
//STRIP001 			/******************************************************************
//STRIP001 			* Das Objekt wird mit der Graphik gefuellt
//STRIP001 			******************************************************************/
//STRIP001 			//pDrawView->BegUndo(ScGlobal::GetRscString(STR_UNDO_DRAGDROP));
//STRIP001 			pDrawView->AddUndo(new SdrUndoAttrObj(*pPickObj));
//STRIP001 			//pDrawView->EndUndo();
//STRIP001 
//STRIP001 			XOBitmap aXOBitmap( rGraphic.GetBitmap() );
//STRIP001 			SfxItemSet aSet( pDrawView->GetModel()->GetItemPool(),
//STRIP001 								XATTR_FILLSTYLE, XATTR_FILLBITMAP );
//STRIP001 			aSet.Put(XFillStyleItem(XFILL_BITMAP));
//STRIP001 			aSet.Put(XFillBitmapItem(String(), aXOBitmap));
//STRIP001 
//STRIP001 //-/			pPickObj->SetAttributes(aSet, FALSE);
//STRIP001 			pPickObj->SetItemSetAndBroadcast(aSet);
//STRIP001 
//STRIP001 			bRet = TRUE;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return bRet;
//STRIP001 }


}
