/*************************************************************************
 *
 *  $RCSfile: sch_fuchrmap.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:56:02 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#ifndef _EEITEM_HXX //autogen
#include <bf_svx/eeitem.hxx>
#endif
// auto strip #ifndef _SFXPOOLITEM_HXX //autogen
// auto strip #include <svtools/poolitem.hxx>
// auto strip #endif
#define ITEMID_FONT 			EE_CHAR_FONTINFO
// auto strip #include <bf_svx/fontitem.hxx>

// auto strip #include "fuchrmap.hxx"
// auto strip #include "schview.hxx"
#include "strings.hrc"
// auto strip #include "schresid.hxx"

// auto strip #ifndef _OUTLINER_HXX //autogen
// auto strip #include <bf_svx/svdoutl.hxx>
// auto strip #endif
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_CHARMAP_HXX //autogen
// auto strip #include <bf_svx/charmap.hxx>
// auto strip #endif

#ifdef IRIX
// auto strip #ifndef _SBXCLASS_HXX
// auto strip #include <svtools/sbx.hxx>
// auto strip #endif
#endif
namespace binfilter {

//STRIP001 TYPEINIT1( SchFuCharMap, SchFuPoor );

/*************************************************************************
|*
|* constructor
|*
|* creates a dialog for insertion of special characters
|* there ist no font support yet.
|* (for info. see sd/source/ui/func/fubullet.cxx)
|*
\************************************************************************/

//STRIP001 SchFuCharMap::SchFuCharMap( SchViewShell* pViewSh, SchWindow* pWin, SchView* pView,
//STRIP001 							ChartModel* pModel, SfxRequest& rReq)
//STRIP001 	   : SchFuPoor(pViewSh, pWin, pView, pModel, rReq)
//STRIP001 {
//STRIP001 
//STRIP001 	SvxCharacterMap* pDlg = new SvxCharacterMap( NULL, FALSE );
//STRIP001 
//STRIP001 	OutlinerView* pOV = NULL;
//STRIP001 	SdrOutliner*  pOL = NULL;
//STRIP001 	
//STRIP001 	pOV = pView->GetTextEditOutlinerView();
//STRIP001 	
//STRIP001 	if( pOV )
//STRIP001 	{
//STRIP001 		// set the current font
//STRIP001 		pOL = pView->GetTextEditOutliner();
//STRIP001 		OutputDevice *pOut = pOL->GetRefDevice();
//STRIP001 
//STRIP001 		pDlg->SetFont( pOut->GetFont() );
//STRIP001 	}
//STRIP001 
//STRIP001 	// the font mustn't be changed
//STRIP001 	pDlg->DisableFontSelection();
//STRIP001 	USHORT nResult = pDlg->Execute();
//STRIP001 
//STRIP001 	String aString;
//STRIP001 
//STRIP001 	if( nResult == RET_OK )
//STRIP001 	{
//STRIP001 		aString = pDlg->GetCharacters();
//STRIP001 	}
//STRIP001 	delete( pDlg );
//STRIP001 
//STRIP001 	if( nResult == RET_OK && pOV )
//STRIP001 	{
//STRIP001 		// insert string
//STRIP001 
//STRIP001 		// prevent flicker
//STRIP001 		pOV->HideCursor();
//STRIP001 		pOL->SetUpdateMode(FALSE);
//STRIP001 
//STRIP001 		// delete current selection by inserting empty String, so current
//STRIP001 		// attributes become unique (sel. has to be erased anyway)
//STRIP001         pOV->InsertText(String());
//STRIP001 
//STRIP001         SfxUndoManager& rUndoMgr =  pOL->GetUndoManager();
//STRIP001         rUndoMgr.EnterListAction( String( SchResId( STR_UNDO_INSERT_SPECCHAR )), String( SchResId( STR_UNDO_INSERT_SPECCHAR )));
//STRIP001 		pOV->InsertText(aString, TRUE);
//STRIP001 
//STRIP001         ESelection aSel = pOV->GetSelection();
//STRIP001 		aSel.nStartPara = aSel.nEndPara;
//STRIP001 		aSel.nStartPos = aSel.nEndPos;
//STRIP001 		pOV->SetSelection(aSel);
//STRIP001 
//STRIP001         rUndoMgr.LeaveListAction();
//STRIP001 
//STRIP001         // show changes
//STRIP001 		pOL->SetUpdateMode(TRUE);
//STRIP001 		pOV->ShowCursor();
//STRIP001 	}
//STRIP001 }

}
