/*************************************************************************
 *
 *  $RCSfile: sch_fuline.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:33:06 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#ifndef _SVX_TAB_LINE_HXX //autogen
#include <bf_svx/tabline.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _SFX_BINDINGS_HXX //autogen
#include <bf_sfx2/bindings.hxx>
#endif

#include <bf_svx/svxids.hrc>

#include "viewshel.hxx"
#include "schview.hxx"
#include "chwindow.hxx"
#ifndef _CHTMODEL_HXX
#include "chtmodel.hxx"
#endif
#include "fuline.hxx"
namespace binfilter {


/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

//STRIP001 SchFuLine::SchFuLine(SchViewShell* pViewSh, SchWindow* pWin, SchView* pView,
//STRIP001 					 ChartModel* pDoc, SfxRequest& rReq)
//STRIP001 	: SchFuPoor(pViewSh, pWin, pView, pDoc, rReq)
//STRIP001 {
//STRIP001 	BOOL bHasMarked = pView->HasMarkedObj();
//STRIP001 
//STRIP001 	const SfxItemSet* pArgs = rReq.GetArgs();
//STRIP001 	SfxBindings& rBind = pViewSh->GetViewFrame()->GetBindings();
//STRIP001 
//STRIP001 	if (!pArgs)
//STRIP001 	{
//STRIP001 		SfxItemSet aNewAttr(pView->GetDefaultAttr());
//STRIP001 
//STRIP001 		if (bHasMarked)	pView->MergeAttrFromMarked(aNewAttr);
//STRIP001 
//STRIP001 		SvxLineTabDialog* pDlg = new SvxLineTabDialog(&(pViewSh->GetViewFrame()->GetWindow()),
//STRIP001 													  &aNewAttr, pDoc);
//STRIP001 
//STRIP001 		if (pDlg->Execute() == RET_OK)
//STRIP001 		{
//STRIP001 			rReq.Done(*(pDlg->GetOutputItemSet()));
//STRIP001 			pArgs = rReq.GetArgs();
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			delete pDlg;
//STRIP001 
//STRIP001 			// Attribute wurden geaendert, Listboxes in Objectbars muessen aktualisiert werden
//STRIP001 			rBind.Invalidate(SID_ATTR_LINE_STYLE);
//STRIP001 			rBind.Invalidate(SID_ATTR_LINE_DASH);
//STRIP001 			rBind.Invalidate(SID_ATTR_LINE_WIDTH);
//STRIP001 			rBind.Invalidate(SID_ATTR_LINE_COLOR);
//STRIP001 			return; // Abbruch
//STRIP001 		}
//STRIP001 		delete pDlg;
//STRIP001 	}
//STRIP001 	if (bHasMarked)	pView->SetAttrToMarked(*pArgs);
//STRIP001 	else pView->SetDefaultAttr(*pArgs);
//STRIP001 
//STRIP001 	// Attribute wurden geaendert, Listboxes in Objectbars muessen aktualisiert werden
//STRIP001 	rBind.Invalidate(SID_ATTR_LINE_STYLE);
//STRIP001 	rBind.Invalidate(SID_ATTR_LINE_DASH);
//STRIP001 	rBind.Invalidate(SID_ATTR_LINE_WIDTH);
//STRIP001 	rBind.Invalidate(SID_ATTR_LINE_COLOR);
//STRIP001 }

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

//STRIP001 SchFuLine::~SchFuLine()
//STRIP001 {
//STRIP001 }



}
