/*************************************************************************
 *
 *  $RCSfile: databrws.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:07:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SCH_DATABRWS_HXX
#define _SCH_DATABRWS_HXX
//------------------------------------------------------------------
//
// dieses Define dient nur zum Testen und darf auf keinen Fall aktiv bleiben
// Bei Umstellungen alle Files nach SIG_CHARTMODELDEFSCHDOC durchsuchen
// #define ChartModel SchChartDocument
//------------------------------------------------------------------

// #ifndef _SVX_BRWBOX_HXX //autogen
// #include <svtools/brwbox.hxx>
// #endif

#ifndef _SVTOOLS_EDITBROWSEBOX_HXX_
#include <svtools/editbrowsebox.hxx>
#endif
#ifndef _SV_OUTDEV_HXX //autogen
#include <vcl/outdev.hxx>
#endif
#ifndef _SV_EDIT_HXX
#include <vcl/edit.hxx>
#endif

#include <memory>

// auto strip #include "datalog.hxx"
namespace binfilter {

class ChartModel;
class SchMemChart;

/*************************************************************************
|*
|* Browser fuer Chart-Daten
|*
\************************************************************************/

//STRIP001 class ChartDataBrowseBox : public ::svt::EditBrowseBox
//STRIP001 {
//STRIP001 private:
//STRIP001 	const ChartModel*	m_pModel;
//STRIP001 	::std::auto_ptr< SchMemChart > m_apMemChart;

    /** this object is created here but deleted by the ChartModel If no
        ChartModel was set this variable remains 0.
     */
//STRIP001 	SchDataLogBook *    m_pLogBook;
//STRIP001 
//STRIP001     KeyEvent            m_aKeyEvent;
//STRIP001     /// the row that is currently painted
//STRIP001     long                m_nSeekRow;
//STRIP001     bool                m_bIsReadOnly;
//STRIP001     bool                m_bIsDirty;
//STRIP001 
//STRIP001     Edit                m_aEditField;
//STRIP001     /// note: the Edit control must precede this member!
//STRIP001     ::svt::CellControllerRef m_rEditController;
//STRIP001 
//STRIP001     Link				m_aCursorMovedHdlLink;
//STRIP001 	Link				m_aEditFieldHdlLink;
//STRIP001 	Link				m_aClickHdlLink;
//STRIP001     Link                m_aCellModifiedLink;
//STRIP001 
//STRIP001 	void RenewTable();
//STRIP001 
//STRIP001 	String GetColString( USHORT nColumnId ) const;
//STRIP001 	String GetRowString( long nRow ) const;
//STRIP001 
//STRIP001     /// not implemented: inhibit copy construction
//STRIP001     ChartDataBrowseBox( const ChartDataBrowseBox & );
//STRIP001 
//STRIP001 protected:
//STRIP001     // EditBrowseBox overridables
//STRIP001     virtual void PaintCell( OutputDevice& _rDev, const Rectangle& _rRect, sal_uInt16 _nColumnId ) const;
//STRIP001     virtual sal_Bool SeekRow( long nRow );
//STRIP001     virtual sal_Bool IsTabAllowed( sal_Bool bForward ) const;
//STRIP001     virtual ::svt::CellController* GetController( long nRow, sal_uInt16 nCol );
//STRIP001     virtual void InitController( ::svt::CellControllerRef& rController, long nRow, sal_uInt16 nCol );
//STRIP001     virtual sal_Bool SaveModified();
//STRIP001 	virtual void CursorMoved();
//STRIP001     // called whenever the control of the current cell has been modified
//STRIP001     virtual void CellModified();
//STRIP001 
//STRIP001     void SetDirty();
//STRIP001 
//STRIP001 public:
//STRIP001 	ChartDataBrowseBox( Window* pParent, const ResId & rId );
//STRIP001 	virtual ~ChartDataBrowseBox();

	/** GetCellText returns the text at the given position
		@param	_nRow
			the number of the row
		@param	_nColId
			the ID of the column
		@return
			the text out of the cell
	*/
//STRIP001 	virtual String	GetCellText(long _nRow, USHORT _nColId) const;
//STRIP001 
//STRIP001     /// @return old state
//STRIP001     bool SetReadOnly( bool bNewState );
//STRIP001     bool IsReadOnly() const;
//STRIP001 
//STRIP001     /// @return true, if data has been modified
//STRIP001     bool IsDirty() const;
//STRIP001     /// reset the dirty status, if changes have been saved
//STRIP001     void SetClean();
//STRIP001 
//STRIP001     void SetDataFromModel( const ChartModel* pDoc );
//STRIP001 	const SchMemChart* GetData() const;
//STRIP001 
//STRIP001     // predicates to determine what actions are possible at the current cursor
//STRIP001     // position.  This depends on the implementation of the according mutators
//STRIP001     // below.  (They are used for enabling toolbar icons)
//STRIP001     bool MayInsertRow() const;
//STRIP001     bool MayInsertColumn() const;
//STRIP001     bool MayDeleteRow() const;
//STRIP001     bool MayDeleteColumn() const;
//STRIP001 
//STRIP001     bool MaySwapRows() const;
//STRIP001     bool MaySwapColumns() const;
//STRIP001 
//STRIP001     bool MaySortRow() const;
//STRIP001     bool MaySortColumn() const;
//STRIP001 
//STRIP001     // mutators mutating data
//STRIP001 	void InsertRow();
//STRIP001 	void InsertColumn();
//STRIP001 	void RemoveRow();
//STRIP001 	void RemoveColumn();
//STRIP001 
//STRIP001 	void SwapRow();
//STRIP001 	void SwapColumn();
//STRIP001 
//STRIP001 	void QuickSortRow();
//STRIP001 	void QuickSortCol();
//STRIP001 
//STRIP001     // sorting the entire table
//STRIP001 	void QuickSortTableCols ();
//STRIP001 	void QuickSortTableRows ();
//STRIP001 
//STRIP001 	void SetCursorMovedHdl( const Link& rLink );
//STRIP001 	const Link& GetCursorMovedHdl() const;
//STRIP001 
//STRIP001     void SetCellModifiedHdl( const Link& rLink );
//STRIP001 
//STRIP001     /// confirms all pending changes to be ready to be closed
//STRIP001     void EndEditing();
//STRIP001 };

} //namespace binfilter
#endif	// _SCH_DATABRSW_HXX


