/*************************************************************************
 *
 *  $RCSfile: uninsaxi.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:18:19 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SCH_UNINSAXI_HXX
#define _SCH_UNINSAXI_HXX

// auto strip #include "schundo.hxx"
namespace binfilter {

/*************************************************************************
|*
|* Undo fuer Achsen & Gitter einfuegen
|*
\************************************************************************/

//STRIP001 class SchUndoInsertAxis : public SchUndoAction
//STRIP001 {
//STRIP001 private:
//STRIP001 	BOOL bOldShowXAxis;
//STRIP001 	BOOL bOldShowXDescr;
//STRIP001 	BOOL bOldShowYAxis;
//STRIP001 	BOOL bOldShowYDescr;
//STRIP001 	BOOL bOldShowZAxis;
//STRIP001 	BOOL bOldShowZDescr;
//STRIP001 	BOOL bOldShow2YAxis;
//STRIP001 	BOOL bOldShow2YDescr;
//STRIP001 	BOOL bOldShow2XAxis;
//STRIP001 	BOOL bOldShow2XDescr;
//STRIP001 
//STRIP001 	BOOL bNewShowXAxis;
//STRIP001 	BOOL bNewShowXDescr;
//STRIP001 	BOOL bNewShowYAxis;
//STRIP001 	BOOL bNewShowYDescr;
//STRIP001 	BOOL bNewShowZAxis;
//STRIP001 	BOOL bNewShowZDescr;
//STRIP001 	BOOL bNewShow2YAxis;
//STRIP001 	BOOL bNewShow2YDescr;
//STRIP001 	BOOL bNewShow2XAxis;
//STRIP001 	BOOL bNewShow2XDescr;
//STRIP001 
//STRIP001 public:
//STRIP001 	TYPEINFO();
//STRIP001 
//STRIP001 	SchUndoInsertAxis( ChartModel& rChDoc,
//STRIP001 					   BOOL bOldXAxis, BOOL bOldXDescr,
//STRIP001 					   BOOL bOldYAxis, BOOL bOldYDescr,
//STRIP001 					   BOOL bOldZAxis, BOOL bOldZDescr,
//STRIP001 					   BOOL bOld2YAxis,BOOL bOld2YDescr,
//STRIP001 					   BOOL bOld2XAxis,BOOL bOld2XDescr,
//STRIP001 
//STRIP001 					   BOOL bNewXAxis, BOOL bNewXDescr,
//STRIP001 					   BOOL bNewYAxis, BOOL bNewYDescr,
//STRIP001 					   BOOL bNewZAxis, BOOL bNewZDescr,
//STRIP001 					   BOOL bNew2YAxis,BOOL bNew2YDescr,
//STRIP001 					   BOOL bNew2XAxis,BOOL bNew2XDescr ) :
//STRIP001 			SchUndoAction( rChDoc ),
//STRIP001 			bOldShowXAxis(bOldXAxis),
//STRIP001 			bOldShowXDescr(bOldXDescr),
//STRIP001 			bOldShowYAxis(bOldYAxis),
//STRIP001 			bOldShowYDescr(bOldYDescr),
//STRIP001 			bOldShowZAxis(bOldZAxis),
//STRIP001 			bOldShowZDescr(bOldZDescr),
//STRIP001 			bOldShow2YAxis(bOld2YAxis),
//STRIP001 			bOldShow2YDescr(bOld2YDescr),
//STRIP001 			bOldShow2XAxis(bOld2XAxis),
//STRIP001 			bOldShow2XDescr(bOld2XDescr),
//STRIP001 
//STRIP001 			bNewShowXAxis(bNewXAxis),
//STRIP001 			bNewShowXDescr(bNewXDescr),
//STRIP001 			bNewShowYAxis(bNewYAxis),
//STRIP001 			bNewShowYDescr(bNewYDescr),
//STRIP001 			bNewShowZAxis(bNewZAxis),
//STRIP001 			bNewShowZDescr(bNewZDescr),
//STRIP001 			bNewShow2YAxis(bNew2YAxis),
//STRIP001 			bNewShow2YDescr(bNew2YDescr),
//STRIP001 			bNewShow2XAxis(bNew2XAxis),
//STRIP001 			bNewShow2XDescr(bNew2XDescr)
//STRIP001 		{}
//STRIP001 
//STRIP001 	virtual void Undo();
//STRIP001 	virtual void Redo();
//STRIP001 
//STRIP001 	virtual BOOL CanRepeat( SfxRepeatTarget& rView ) const;
//STRIP001 };


// ************************************************************

//STRIP001 class SchUndoInsertGrid : public SchUndoAction
//STRIP001 {
//STRIP001 private:
//STRIP001 	BOOL bOldShowXGridMain;
//STRIP001 	BOOL bOldShowXGridHelp;
//STRIP001 	BOOL bOldShowYGridMain;
//STRIP001 	BOOL bOldShowYGridHelp;
//STRIP001 	BOOL bOldShowZGridMain;
//STRIP001 	BOOL bOldShowZGridHelp;
//STRIP001 
//STRIP001 	BOOL bNewShowXGridMain;
//STRIP001 	BOOL bNewShowXGridHelp;
//STRIP001 	BOOL bNewShowYGridMain;
//STRIP001 	BOOL bNewShowYGridHelp;
//STRIP001 	BOOL bNewShowZGridMain;
//STRIP001 	BOOL bNewShowZGridHelp;
//STRIP001 	
//STRIP001 public:
//STRIP001 	TYPEINFO();
//STRIP001 
//STRIP001 	SchUndoInsertGrid( ChartModel& rChDoc,
//STRIP001 					   BOOL bOldXGridMain, BOOL bOldXGridHelp,
//STRIP001 					   BOOL bOldYGridMain, BOOL bOldYGridHelp,
//STRIP001 					   BOOL bOldZGridMain, BOOL bOldZGridHelp,
//STRIP001 
//STRIP001 					   BOOL bNewXGridMain, BOOL bNewXGridHelp,
//STRIP001 					   BOOL bNewYGridMain, BOOL bNewYGridHelp,
//STRIP001 					   BOOL bNewZGridMain, BOOL bNewZGridHelp ) :
//STRIP001 			SchUndoAction( rChDoc ),
//STRIP001 
//STRIP001 			bOldShowXGridMain( bOldXGridMain ),
//STRIP001 			bOldShowXGridHelp( bOldXGridHelp ),
//STRIP001 			bOldShowYGridMain( bOldYGridMain ),
//STRIP001 			bOldShowYGridHelp( bOldYGridHelp ),
//STRIP001 			bOldShowZGridMain( bOldZGridMain ),
//STRIP001 			bOldShowZGridHelp( bOldZGridHelp ),
//STRIP001 
//STRIP001 			bNewShowXGridMain( bNewXGridMain ),
//STRIP001 			bNewShowXGridHelp( bNewXGridHelp ),
//STRIP001 			bNewShowYGridMain( bNewYGridMain ),
//STRIP001 			bNewShowYGridHelp( bNewYGridHelp ),
//STRIP001 			bNewShowZGridMain( bNewZGridMain ),
//STRIP001 			bNewShowZGridHelp( bNewZGridHelp )
//STRIP001 		{}
//STRIP001 
//STRIP001 	virtual void Undo();
//STRIP001 	virtual void Redo();
//STRIP001 
//STRIP001 	virtual BOOL CanRepeat( SfxRepeatTarget& rView ) const;
//STRIP001 };

} //namespace binfilter
#endif	// _SCH_UNINSAXI_HXX

