/*************************************************************************
 *
 *  $RCSfile: sd_fusnapln.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:55:30 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #ifndef _AEITEM_HXX //autogen
// auto strip #include <svtools/aeitem.hxx>
// auto strip #endif
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif

#pragma hdrstop

#include "strings.hrc"

// auto strip #include "sdattr.hxx"
// auto strip #include "sdview.hxx"
// auto strip #include "viewshel.hxx"
// auto strip #include "drviewsh.hxx"
// auto strip #include "sdwindow.hxx"
// auto strip #include "dlgsnap.hxx"
// auto strip #include "sdresid.hxx"
// auto strip #include "fusnapln.hxx"

// auto strip #ifndef _SVDPAGV_HXX //autogen
// auto strip #include <bf_svx/svdpagv.hxx>
// auto strip #endif
namespace binfilter {


//STRIP001 TYPEINIT1( FuSnapLine, FuPoor );
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuSnapLine::FuSnapLine(SdViewShell* pViewSh, SdWindow* pWin, SdView* pView,
//STRIP001 					   SdDrawDocument* pDoc, SfxRequest& rReq) :
//STRIP001 	FuPoor(pViewSh, pWin, pView, pDoc, rReq)
//STRIP001 {
//STRIP001 	const SfxItemSet* pArgs = rReq.GetArgs();
//STRIP001 	SdrPageView* pPV;
//STRIP001 	USHORT	nHelpLine;
//STRIP001 	BOOL	bCreateNew = TRUE;
//STRIP001 
//STRIP001 	if ( !pArgs )
//STRIP001 	{
//STRIP001 		SfxItemSet aNewAttr(pViewSh->GetPool(), ATTR_SNAPLINE_START,
//STRIP001 												ATTR_SNAPLINE_END);
//STRIP001 		Point aLinePos = ((SdDrawViewShell*) pViewSh)->GetMousePos();
//STRIP001 		((SdDrawViewShell*) pViewSh)->SetMousePosFreezed( FALSE );
//STRIP001 		BOOL bLineExist = FALSE;
//STRIP001 
//STRIP001 		pPV = pView->GetPageViewPvNum(0);
//STRIP001 
//STRIP001 		if ( aLinePos.X() >= 0 )
//STRIP001 		{
//STRIP001 			aLinePos = pWindow->PixelToLogic(aLinePos);
//STRIP001 			USHORT nHitLog = (USHORT) pWindow->PixelToLogic(Size(HITPIX,0)).Width();
//STRIP001 			bLineExist = pView->PickHelpLine(aLinePos, nHitLog, *pWindow,
//STRIP001 											 nHelpLine, pPV);
//STRIP001 			if ( bLineExist )
//STRIP001 				aLinePos = (pPV->GetHelpLines())[nHelpLine].GetPos();
//STRIP001 			else
//STRIP001 				pPV = pView->GetPageViewPvNum(0);
//STRIP001 
//STRIP001 			pPV->LogicToPagePos(aLinePos);
//STRIP001 		}
//STRIP001 		else
//STRIP001 			aLinePos = Point(0,0);
//STRIP001 
//STRIP001 		aNewAttr.Put(SfxUInt32Item(ATTR_SNAPLINE_X, aLinePos.X()));
//STRIP001 		aNewAttr.Put(SfxUInt32Item(ATTR_SNAPLINE_Y, aLinePos.Y()));
//STRIP001 
//STRIP001 		SdSnapLineDlg* pDlg = new SdSnapLineDlg( NULL, aNewAttr, pView );
//STRIP001 		if ( bLineExist )
//STRIP001 		{
//STRIP001 			pDlg->HideRadioGroup();
//STRIP001 
//STRIP001 			const SdrHelpLine& rHelpLine = (pPV->GetHelpLines())[nHelpLine];
//STRIP001 
//STRIP001 			if ( rHelpLine.GetKind() == SDRHELPLINE_POINT )
//STRIP001 			{
//STRIP001 				pDlg->SetText(String(SdResId(STR_SNAPDLG_SETPOINT)));
//STRIP001 				pDlg->SetInputFields(TRUE, TRUE);
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				pDlg->SetText(String(SdResId(STR_SNAPDLG_SETLINE)));
//STRIP001 
//STRIP001 				if ( rHelpLine.GetKind() == SDRHELPLINE_VERTICAL )
//STRIP001 					pDlg->SetInputFields(TRUE, FALSE);
//STRIP001 				else
//STRIP001 					pDlg->SetInputFields(FALSE, TRUE);
//STRIP001 			}
//STRIP001 			bCreateNew = FALSE;
//STRIP001 		}
//STRIP001 		else
//STRIP001 			pDlg->HideDeleteBtn();
//STRIP001 
//STRIP001 		USHORT nResult = pDlg->Execute();
//STRIP001 
//STRIP001 		pDlg->GetAttr(aNewAttr);
//STRIP001 		delete pDlg;
//STRIP001 
//STRIP001 		switch( nResult )
//STRIP001 		{
//STRIP001 			case RET_OK:
//STRIP001 				rReq.Done(aNewAttr);
//STRIP001 				pArgs = rReq.GetArgs();
//STRIP001 				break;
//STRIP001 
//STRIP001 			case RET_SNAP_DELETE:
//STRIP001 				// Fangobjekt loeschen
//STRIP001 				if ( !bCreateNew )
//STRIP001 					pPV->DeleteHelpLine(nHelpLine);
//STRIP001 				// und weiter wie bei default
//STRIP001 			default:
//STRIP001 				return;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	Point aHlpPos;
//STRIP001 
//STRIP001 	aHlpPos.X() = ((const SfxUInt32Item&) pArgs->Get(ATTR_SNAPLINE_X)).GetValue();
//STRIP001 	aHlpPos.Y() = ((const SfxUInt32Item&) pArgs->Get(ATTR_SNAPLINE_Y)).GetValue();
//STRIP001 	pPV->PagePosToLogic(aHlpPos);
//STRIP001 
//STRIP001 	if ( bCreateNew )
//STRIP001 	{
//STRIP001 		SdrHelpLineKind eKind;
//STRIP001 
//STRIP001 		pPV = pView->GetPageViewPvNum(0);
//STRIP001 
//STRIP001 		switch ( (SnapKind) ((const SfxAllEnumItem&)
//STRIP001 				 pArgs->Get(ATTR_SNAPLINE_KIND)).GetValue() )
//STRIP001 		{
//STRIP001 			case SK_HORIZONTAL	: eKind = SDRHELPLINE_HORIZONTAL;	break;
//STRIP001 			case SK_VERTICAL	: eKind = SDRHELPLINE_VERTICAL; 	break;
//STRIP001 			default 			: eKind = SDRHELPLINE_POINT;		break;
//STRIP001 		}
//STRIP001 		pPV->InsertHelpLine(SdrHelpLine(eKind, aHlpPos));
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		const SdrHelpLine& rHelpLine = (pPV->GetHelpLines())[nHelpLine];
//STRIP001 		pPV->SetHelpLine(nHelpLine, SdrHelpLine(rHelpLine.GetKind(), aHlpPos));
//STRIP001 	}
//STRIP001 }



}
