/*************************************************************************
 *
 *  $RCSfile: sd_unmovss.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:00:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

// auto strip #include "unmovss.hxx"
// auto strip #include "docshell.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "stlsheet.hxx"
namespace binfilter {


//STRIP001 TYPEINIT1(SdMoveStyleSheetsUndoAction, SdUndoAction);
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdMoveStyleSheetsUndoAction::SdMoveStyleSheetsUndoAction(
//STRIP001 								SdDrawDocument* pTheDoc,
//STRIP001 								List*           pTheStyles,
//STRIP001 								BOOL            bInserted):
//STRIP001 					  SdUndoAction(pTheDoc)
//STRIP001 {
//STRIP001 	DBG_ASSERT(pTheStyles, "keine Liste gesetzt!");
//STRIP001 	pStyles   = pTheStyles;
//STRIP001 	bMySheets = !bInserted;
//STRIP001 
//STRIP001 	pListOfChildLists = new List;
//STRIP001 
//STRIP001 	// Liste mit den Listen der StyleSheet-Kinder erstellen
//STRIP001 	for (SdStyleSheet* pSheet = (SdStyleSheet*)pStyles->First();
//STRIP001 		 pSheet;
//STRIP001 		 pSheet = (SdStyleSheet*)pStyles->Next())
//STRIP001 	{
//STRIP001 		List* pChildList = pSheet->CreateChildList();
//STRIP001 		pListOfChildLists->Insert(pChildList, LIST_APPEND);
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Undo()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdMoveStyleSheetsUndoAction::Undo()
//STRIP001 {
//STRIP001 	SfxStyleSheetBasePool* pPool  = pDoc->GetStyleSheetPool();
//STRIP001 	SdStyleSheet*          pSheet = NULL;
//STRIP001 
//STRIP001 	/********************************************************************
//STRIP001 	|* die StyleSheets sollen wieder in den Pool eingefuegt werden
//STRIP001 	\*******************************************************************/
//STRIP001 	if (bMySheets)
//STRIP001 	{
//STRIP001 		/****************************************************************
//STRIP001 		|* erst alle StyleSheets wieder in den Pool einfuegen
//STRIP001 		\***************************************************************/
//STRIP001 		for (pSheet = (SdStyleSheet*)pStyles->First();
//STRIP001 			 pSheet;
//STRIP001 			 pSheet = (SdStyleSheet*)pStyles->Next())
//STRIP001 		{
//STRIP001 			pPool->Insert(pSheet);
//STRIP001 		}
//STRIP001 
//STRIP001 		/****************************************************************
//STRIP001 		|* jetzt die ehemaligen Kinder wieder zu Kindern machen
//STRIP001 		\***************************************************************/
//STRIP001 		List* pChildList = (List*)pListOfChildLists->First();
//STRIP001 		for (pSheet = (SdStyleSheet*)pStyles->First();
//STRIP001 			 pSheet;
//STRIP001 			 pSheet = (SdStyleSheet*)pStyles->Next())
//STRIP001 		{
//STRIP001 			String aParent(pSheet->GetName());
//STRIP001 			for (SfxStyleSheet* pChild = (SfxStyleSheet*)pChildList->First();
//STRIP001 				 pChild;
//STRIP001 				 pChild = (SfxStyleSheet*)pChildList->Next())
//STRIP001 			{
//STRIP001 				pChild->SetParent(aParent);
//STRIP001 			}
//STRIP001 			pChildList = (List*)pListOfChildLists->Next();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	/********************************************************************
//STRIP001 	|* die StyleSheets sollen wieder aus dem, Pool entfernt werden
//STRIP001 	\*******************************************************************/
//STRIP001 	else
//STRIP001 	{
//STRIP001 		for (pSheet = (SdStyleSheet*)pStyles->First();
//STRIP001 			 pSheet;
//STRIP001 			 pSheet = (SdStyleSheet*)pStyles->Next())
//STRIP001 		{
//STRIP001 			pPool->Remove(pSheet);
//STRIP001 		}
//STRIP001 	}
//STRIP001 	bMySheets = !bMySheets;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Redo()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdMoveStyleSheetsUndoAction::Redo()
//STRIP001 {
//STRIP001 	Undo();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Repeat()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdMoveStyleSheetsUndoAction::Repeat()
//STRIP001 {
//STRIP001 	DBG_ASSERT(FALSE, "SdMoveStyleSheetsUndoAction::Repeat: nicht implementiert");
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Destruktor, Liste loeschen; ggfs. die enthaltenen StyleSheets loeschen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdMoveStyleSheetsUndoAction::~SdMoveStyleSheetsUndoAction()
//STRIP001 {
//STRIP001 	if (bMySheets)
//STRIP001 	{
//STRIP001 		// die Liste rueckwaerts aufdroeseln; wenn Gliederungsvorlagen ent-
//STRIP001 		// halten sind gewaehrleistet dies den geringsten Broadcasting-Aufwand
//STRIP001 		SfxStyleSheet* pSheet = (SfxStyleSheet*)pStyles->Last();
//STRIP001 		while (pSheet)
//STRIP001 		{
//STRIP001 			delete pSheet;
//STRIP001 			pSheet = (SfxStyleSheet*)pStyles->Prev();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	delete pStyles;
//STRIP001 
//STRIP001 	for (List* pChildList = (List*)pListOfChildLists->First();
//STRIP001 		 pChildList;
//STRIP001 		 pChildList = (List*)pListOfChildLists->Next())
//STRIP001 	{
//STRIP001 		delete pChildList;
//STRIP001 	}
//STRIP001 	delete pListOfChildLists;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Kommentar liefern
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 String SdMoveStyleSheetsUndoAction::GetComment() const
//STRIP001 {
//STRIP001 	return String();
//STRIP001 }


}
