/*************************************************************************
 *
 *  $RCSfile: sd_unoaprms.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:00:22 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#include "drawdoc.hxx"
// auto strip #include "unoaprms.hxx"
// auto strip #include "anminfo.hxx"
namespace binfilter {


//STRIP001 TYPEINIT1(SdAnimationPrmsUndoAction, SdUndoAction);
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* 2. Ctor, der den ersten (inline) nach der Version 4.0 einmal ersetzen
//STRIP001 |* soll (mit 3. Parameter dann)
//STRIP001 |* Hier werden die Member mit den Animations-Informationen vorbelegt,
//STRIP001 |* um nicht immer alle inline-Methoden aufrufen zu muessen, auch im
//STRIP001 |* Hinblick auf zukuenftige Erweiterungen (neue Member etc.)
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdAnimationPrmsUndoAction::SdAnimationPrmsUndoAction(
//STRIP001 								SdDrawDocument* pTheDoc,
//STRIP001 								SdrObject* pObj ) :
//STRIP001 	SdUndoAction	( pTheDoc ),
//STRIP001 	pObject 		( pObj ),
//STRIP001 	bInfoCreated    ( FALSE ) // Fuer Animationsreihenfolge existiert Info
//STRIP001 {
//STRIP001 	SdAnimationInfo* pInfo = pTheDoc->GetAnimationInfo( pObject );
//STRIP001 	if( pInfo )
//STRIP001 	{
//STRIP001 		bNewActive		= bOldActive	 = pInfo->bActive;
//STRIP001 		eNewEffect		= eOldEffect	 = pInfo->eEffect;
//STRIP001 		eNewTextEffect	= eOldTextEffect = pInfo->eTextEffect;
//STRIP001 		eNewSpeed		= eOldSpeed		 = pInfo->eSpeed;
//STRIP001 		bNewDimPrevious = bOldDimPrevious= pInfo->bDimPrevious;
//STRIP001 		aNewDimColor	= aOldDimColor	 = pInfo->aDimColor;
//STRIP001 		bNewDimHide		= bOldDimHide	 = pInfo->bDimHide;
//STRIP001 		bNewSoundOn		= bOldSoundOn	 = pInfo->bSoundOn;
//STRIP001 		aNewSoundFile	= aOldSoundFile	 = pInfo->aSoundFile;
//STRIP001 		bNewPlayFull	= bOldPlayFull 	 = pInfo->bPlayFull;
//STRIP001 
//STRIP001 		pNewPathObj 	= pOldPathObj	 = pInfo->pPathObj;
//STRIP001 
//STRIP001 		eNewClickAction		= eOldClickAction	 = pInfo->eClickAction;
//STRIP001 		aNewBookmark		= aOldBookmark 		 = pInfo->aBookmark;
//STRIP001 		bNewInvisibleInPres	= bOldInvisibleInPres= pInfo->bInvisibleInPresentation;
//STRIP001 		nNewVerb			= nOldVerb			 = pInfo->nVerb;
//STRIP001 		nNewPresOrder		= nOldPresOrder		 = pInfo->nPresOrder;
//STRIP001 
//STRIP001 		eNewSecondEffect	= eOldSecondEffect	 = pInfo->eSecondEffect;
//STRIP001 		eNewSecondSpeed		= eOldSecondSpeed	 = pInfo->eSecondSpeed;
//STRIP001 		bNewSecondSoundOn	= bOldSecondSoundOn	 = pInfo->bSecondSoundOn;
//STRIP001 		bNewSecondPlayFull	= bOldSecondPlayFull = pInfo->bSecondPlayFull;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Undo()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdAnimationPrmsUndoAction::Undo()
//STRIP001 {
//STRIP001 	// keine neu Info erzeugt: Daten restaurieren
//STRIP001 	if (!bInfoCreated)
//STRIP001 	{
//STRIP001 		SdDrawDocument*	pDoc   = (SdDrawDocument*)pObject->GetModel();
//STRIP001 		if( pDoc )
//STRIP001 		{
//STRIP001 			SdAnimationInfo* pInfo = pDoc->GetAnimationInfo( pObject );
//STRIP001 			// So nicht...
//STRIP001 			//SdAnimationInfo* pInfo = (SdAnimationInfo*)pObject->GetUserData(0);
//STRIP001 			pInfo->bActive		= bOldActive;
//STRIP001 			pInfo->eEffect      = eOldEffect;
//STRIP001 			pInfo->eTextEffect  = eOldTextEffect;
//STRIP001 			pInfo->eSpeed		= eOldSpeed;
//STRIP001 			pInfo->bDimPrevious = bOldDimPrevious;
//STRIP001 			pInfo->aDimColor    = aOldDimColor;
//STRIP001 			pInfo->bDimHide     = bOldDimHide;
//STRIP001 			pInfo->bSoundOn     = bOldSoundOn;
//STRIP001 			pInfo->aSoundFile   = aOldSoundFile;
//STRIP001 			pInfo->bPlayFull    = bOldPlayFull;
//STRIP001 			pInfo->SetPath(pOldPathObj);
//STRIP001 			pInfo->eClickAction = eOldClickAction;
//STRIP001 			pInfo->aBookmark    = aOldBookmark;
//STRIP001 			pInfo->bInvisibleInPresentation = bOldInvisibleInPres;
//STRIP001 			pInfo->nVerb        = nOldVerb;
//STRIP001 			pInfo->nPresOrder   = nOldPresOrder;
//STRIP001 
//STRIP001 			pInfo->eSecondEffect    = eOldSecondEffect;
//STRIP001 			pInfo->eSecondSpeed     = eOldSecondSpeed;
//STRIP001 			pInfo->bSecondSoundOn   = bOldSecondSoundOn;
//STRIP001 			pInfo->bSecondPlayFull  = bOldSecondPlayFull;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	// Info wurde durch Aktion erzeugt: Info loeschen
//STRIP001 	else
//STRIP001 	{
//STRIP001 		pObject->DeleteUserData(0);
//STRIP001 	}
//STRIP001 	// Damit ein ModelHasChanged() ausgeloest wird, um das Effekte-Window
//STRIP001 	// auf Stand zu bringen (Animations-Reihenfolge)
//STRIP001 	pObject->SendRepaintBroadcast( TRUE );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Redo()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdAnimationPrmsUndoAction::Redo()
//STRIP001 {
//STRIP001 	SdAnimationInfo* pInfo = NULL;
//STRIP001 
//STRIP001 	// nicht durch Aktion erzeugt: neue Daten eintragen
//STRIP001 	if (!bInfoCreated)
//STRIP001 	{
//STRIP001 		pInfo = (SdAnimationInfo*)pObject->GetUserData(0);
//STRIP001 	}
//STRIP001 	// Info durch Aktion erzeugt: jetzt wieder erzeugen
//STRIP001 	else
//STRIP001 	{
//STRIP001 		pInfo = new SdAnimationInfo(pDoc);
//STRIP001 		pObject->InsertUserData(pInfo);
//STRIP001 	}
//STRIP001 
//STRIP001 	pInfo->bActive      = bNewActive;
//STRIP001 	pInfo->eEffect      = eNewEffect;
//STRIP001 	pInfo->eTextEffect  = eNewTextEffect;
//STRIP001 	pInfo->eSpeed       = eNewSpeed;
//STRIP001 	pInfo->bDimPrevious = bNewDimPrevious;
//STRIP001 	pInfo->aDimColor    = aNewDimColor;
//STRIP001 	pInfo->bDimHide     = bNewDimHide;
//STRIP001 	pInfo->bSoundOn     = bNewSoundOn;
//STRIP001 	pInfo->aSoundFile   = aNewSoundFile;
//STRIP001 	pInfo->bPlayFull    = bNewPlayFull;
//STRIP001 	pInfo->SetPath(pNewPathObj);
//STRIP001 	pInfo->eClickAction = eNewClickAction;
//STRIP001 	pInfo->aBookmark    = aNewBookmark;
//STRIP001 	pInfo->bInvisibleInPresentation = bNewInvisibleInPres;
//STRIP001 	pInfo->nVerb        = nNewVerb;
//STRIP001 	pInfo->nPresOrder   = nNewPresOrder;
//STRIP001 
//STRIP001 	pInfo->eSecondEffect    = eNewSecondEffect;
//STRIP001 	pInfo->eSecondSpeed     = eNewSecondSpeed;
//STRIP001 	pInfo->bSecondSoundOn   = bNewSecondSoundOn;
//STRIP001 	pInfo->bSecondPlayFull  = bNewSecondPlayFull;
//STRIP001 
//STRIP001 	// Damit ein ModelHasChanged() ausgeloest wird, um das Effekte-Window
//STRIP001 	// auf Stand zu bringen (Animations-Reihenfolge)
//STRIP001 	pObject->SendRepaintBroadcast( TRUE );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Repeat()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdAnimationPrmsUndoAction::Repeat()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Destruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdAnimationPrmsUndoAction::~SdAnimationPrmsUndoAction()
//STRIP001 {
//STRIP001 }


}
