/*************************************************************************
 *
 *  $RCSfile: sd_unprlout.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:00:36 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

// auto strip #include "unprlout.hxx"

#include "strings.hrc"
// auto strip #include "sdpage.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "sdresid.hxx"
namespace binfilter {


//STRIP001 TYPEINIT1(SdPresentationLayoutUndoAction, SdUndoAction);
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdPresentationLayoutUndoAction::SdPresentationLayoutUndoAction(
//STRIP001 							SdDrawDocument* pTheDoc,
//STRIP001 							String          aTheOldLayoutName,
//STRIP001 							String          aTheNewLayoutName,
//STRIP001 							AutoLayout      eTheOldAutoLayout,
//STRIP001 							AutoLayout      eTheNewAutoLayout,
//STRIP001 							BOOL            bSet,
//STRIP001 							SdPage*         pThePage):
//STRIP001 					  SdUndoAction(pTheDoc)
//STRIP001 {
//STRIP001 	aOldLayoutName = aTheOldLayoutName;
//STRIP001 	aNewLayoutName = aTheNewLayoutName;
//STRIP001 	eOldAutoLayout = eTheOldAutoLayout;
//STRIP001 	eNewAutoLayout = eTheNewAutoLayout;
//STRIP001 	bSetAutoLayout = bSet;
//STRIP001 
//STRIP001 	DBG_ASSERT(pThePage, "keine Page gesetzt!");
//STRIP001 	pPage = pThePage;
//STRIP001 	aComment = String(SdResId(STR_UNDO_SET_PRESLAYOUT));
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Undo()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdPresentationLayoutUndoAction::Undo()
//STRIP001 {
//STRIP001 	pPage->SetPresentationLayout(aOldLayoutName, TRUE, TRUE, TRUE);
//STRIP001 	if (bSetAutoLayout)
//STRIP001 		pPage->SetAutoLayout(eOldAutoLayout, TRUE);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Redo()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdPresentationLayoutUndoAction::Redo()
//STRIP001 {
//STRIP001 	pPage->SetPresentationLayout(aNewLayoutName);
//STRIP001 	if (bSetAutoLayout)
//STRIP001 		pPage->SetAutoLayout(eNewAutoLayout, TRUE);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Repeat()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdPresentationLayoutUndoAction::Repeat()
//STRIP001 {
//STRIP001 	DBG_ASSERT(FALSE, "SdPresentationLayoutUndoAction::Repeat: nicht implementiert");
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Destruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdPresentationLayoutUndoAction::~SdPresentationLayoutUndoAction()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Kommentar liefern
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 String SdPresentationLayoutUndoAction::GetComment() const
//STRIP001 {
//STRIP001 	return aComment;
//STRIP001 }



}
