/*************************************************************************
 *
 *  $RCSfile: showwin.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:03:20 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SD_SHOWWIN_HXX
#define _SD_SHOWWIN_HXX

#include <limits.h>
// auto strip #include <vcl/timer.hxx>
// auto strip #include <vcl/graph.hxx>
// auto strip #ifndef _SD_SDWINDOW_HXX
// auto strip #include "sdwindow.hxx"
// auto strip #endif
namespace binfilter {

// -----------
// - Defines -
// -----------

//STRIP001 #define SLIDE_NO_TIMEOUT ULONG_MAX

// ---------
// - Enums -
// ---------

//STRIP001 enum ShowWindowMode
//STRIP001 {
//STRIP001     SHOWWINDOWMODE_NORMAL = 0,
//STRIP001     SHOWWINDOWMODE_PAUSE = 1,
//STRIP001     SHOWWINDOWMODE_END = 2,
//STRIP001     SHOWWINDOWMODE_BLANK = 3
//STRIP001 };

// ----------------
// - SdShowWindow -
// ----------------

//STRIP001 class SdViewShell;
//STRIP001 class SdPreviewWin;
//STRIP001 class FuSlideShow;

//STRIP001 class SdShowWindow : public SdWindow
//STRIP001 {
//STRIP001 private:
//STRIP001 
//STRIP001 	Timer			aPauseTimer;
//STRIP001 	Wallpaper		aShowBackground;
//STRIP001 	Graphic			aLogo;
//STRIP001 	SdPreviewWin*	pPreview;
//STRIP001 	ULONG			nPauseTimeout;
//STRIP001 	USHORT			nRestartPage;
//STRIP001     ShowWindowMode  eShowWindowMode;
//STRIP001 	BOOL			bShowNavigatorAfterSpecialMode;
//STRIP001 
//STRIP001 					DECL_LINK( PauseTimeoutHdl, Timer* pTimer );
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001 	virtual void	KeyInput(const KeyEvent& rKEvt);
//STRIP001 	virtual void	MouseMove(const MouseEvent& rMEvt);
//STRIP001 	virtual void	MouseButtonUp(const MouseEvent& rMEvt);
//STRIP001 	virtual void	MouseButtonDown(const MouseEvent& rMEvt);
//STRIP001 	virtual void	Paint(const Rectangle& rRect);
//STRIP001 	virtual long	ParentNotify(NotifyEvent& rNEvt);
//STRIP001 	virtual void	GetFocus();
//STRIP001 
//STRIP001 	void			DrawPauseScene( BOOL bTimeoutOnly );
//STRIP001 	void			DrawEndScene();
//STRIP001 	void			DrawBlankScene();
//STRIP001 
//STRIP001 	void			TerminateShow();
//STRIP001 	void			RestartShow();
//STRIP001 
//STRIP001 	BitmapEx		aWaitIcon;
//STRIP001 	Bitmap			aRestoreSpace;
//STRIP001  
//STRIP001 public:
//STRIP001 
//STRIP001 					SdShowWindow(Window* pParent, SdPreviewWin* pPreviewWin = NULL);
//STRIP001 					~SdShowWindow();
//STRIP001 
//STRIP001 	SdViewShell*	GetViewShell() const { return pViewShell; }
//STRIP001 	
//STRIP001    	BOOL			SetEndMode();
//STRIP001 	BOOL			SetPauseMode( USHORT nPageToRestart, ULONG nTimeoutSec = SLIDE_NO_TIMEOUT, Graphic* pLogo = NULL );
//STRIP001 	BOOL			SetBlankMode( USHORT nPageToRestart, const Color& rBlankColor );
//STRIP001 	
//STRIP001 	ShowWindowMode  GetShowWindowMode() const { return eShowWindowMode; }
//STRIP001 
//STRIP001 	void			DrawWaitIcon();
//STRIP001 	void			ClearWaitIcon();
//STRIP001 };

} //namespace binfilter
#endif // _SD_SHOWWIN_HXX
