/*************************************************************************
 *
 *  $RCSfile: tpoption.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:36:25 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SD_TPOPTION_HXX
#define _SD_TPOPTION_HXX


#ifndef _LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif
#ifndef _GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif
#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif
#ifndef _BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif
#ifndef _STDCTRL_HXX //autogen
#include <svtools/stdctrl.hxx>
#endif
#ifndef _SFXTABDLG_HXX //autogen
#include <bf_sfx2/tabdlg.hxx>
#endif
#ifndef _SVX_OPTGRID_HXX
#include <bf_svx/optgrid.hxx>
#endif
namespace binfilter {

/*************************************************************************
|*
|* Optionen-Tab-Page: Snap
|*
\************************************************************************/
//STRIP001 class SdTpOptionsSnap : public SvxGridTabPage
//STRIP001 {
//STRIP001 public:
//STRIP001 			SdTpOptionsSnap( Window* pParent, const SfxItemSet& rInAttrs  );
//STRIP001 			~SdTpOptionsSnap();
//STRIP001 
//STRIP001 	static	SfxTabPage* Create( Window*, const SfxItemSet& );
//STRIP001 	virtual BOOL FillItemSet( SfxItemSet& );
//STRIP001 	virtual void Reset( const SfxItemSet & );
//STRIP001 
//STRIP001 //    virtual void ActivatePage( const SfxItemSet& rSet );
//STRIP001 //    virtual int  DeactivatePage( SfxItemSet* pSet );
//STRIP001 };
/*************************************************************************
|*
|* Optionen-Tab-Page: Contents (Inhalte)
|*
\************************************************************************/
//STRIP001 class SdTpOptionsContents : public SfxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001     FixedLine aGrpViewSubstitute;
//STRIP001     CheckBox aCbxExternGraphic;
//STRIP001 	CheckBox aCbxOutlineMode;
//STRIP001 	CheckBox aCbxNoText;
//STRIP001 	CheckBox aCbxHairlineMode;
//STRIP001 
//STRIP001     FixedLine    aGrpDisplay;
//STRIP001     CheckBox    aCbxRuler;
//STRIP001 	CheckBox	aCbxDragStripes;
//STRIP001 	CheckBox	aCbxHandlesBezier;
//STRIP001 	CheckBox	aCbxMoveOutline;
//STRIP001 
//STRIP001 
//STRIP001 public:
//STRIP001 			SdTpOptionsContents( Window* pParent, const SfxItemSet& rInAttrs  );
//STRIP001 			~SdTpOptionsContents();
//STRIP001 
//STRIP001 	static	SfxTabPage* Create( Window*, const SfxItemSet& );
//STRIP001 	virtual BOOL FillItemSet( SfxItemSet& );
//STRIP001 	virtual void Reset( const SfxItemSet & );
//STRIP001 };

/*************************************************************************
|*
|* Optionen-Tab-Page: View
|*
\************************************************************************/
//STRIP001 class SdModule;
//STRIP001 class SdTpOptionsMisc : public SfxTabPage
//STRIP001 {
//STRIP001  friend class SdOptionsDlg;
//STRIP001  friend class SdModule;
//STRIP001 
//STRIP001 private:
//STRIP001     FixedLine   aGrpText;
//STRIP001     CheckBox    aCbxQuickEdit;
//STRIP001     CheckBox    aCbxPickThrough;
//STRIP001 
//STRIP001     FixedLine   aGrpProgramStart;
//STRIP001     CheckBox    aCbxStartWithTemplate;
//STRIP001 
//STRIP001     FixedLine   aGrpSettings;
//STRIP001     CheckBox    aCbxMasterPageCache;
//STRIP001     CheckBox    aCbxCopy;
//STRIP001     CheckBox    aCbxMarkedHitMovesAlways;
//STRIP001     CheckBox    aCbxCrookNoContortion;
//STRIP001 
//STRIP001     FixedText   aTxtMetric;
//STRIP001     ListBox     aLbMetric;
//STRIP001     FixedText   aTxtTabstop;
//STRIP001 	MetricField	aMtrFldTabstop;
//STRIP001 
//STRIP001     FixedLine   aGrpStartWithActualPage;
//STRIP001     CheckBox    aCbxStartWithActualPage;
//STRIP001 
//STRIP001     FixedLine   aTxtCompatibility;
//STRIP001     CheckBox    aCbxUsePrinterMetrics;
//STRIP001     CheckBox    aCbxCompatibility;
//STRIP001 
//STRIP001     //Scale
//STRIP001     FixedLine       aGrpScale;
//STRIP001     FixedText       aFtScale;
//STRIP001     ComboBox        aCbScale;
//STRIP001 
//STRIP001     FixedText       aFtOriginal;
//STRIP001     FixedText       aFtEquivalent;
//STRIP001 
//STRIP001     FixedText       aFtPageWidth;
//STRIP001 	FixedInfo		aFiInfo1;
//STRIP001     MetricField     aMtrFldOriginalWidth;
//STRIP001 
//STRIP001     FixedText       aFtPageHeight;
//STRIP001 	FixedInfo		aFiInfo2;
//STRIP001     MetricField     aMtrFldOriginalHeight;
//STRIP001 
//STRIP001     MetricField     aMtrFldInfo1;
//STRIP001 	MetricField 	aMtrFldInfo2;
//STRIP001 
//STRIP001     UINT32          nWidth;
//STRIP001 	UINT32			nHeight;
//STRIP001 	String			aInfo1;
//STRIP001 	String			aInfo2;
//STRIP001 
//STRIP001 	SfxMapUnit			ePoolUnit;
//STRIP001 
//STRIP001 	String			GetScale( INT32 nX, INT32 nY );
//STRIP001 	BOOL			SetScale( const String& aScale, INT32& rX, INT32& rY );
//STRIP001 
//STRIP001 	DECL_LINK( ModifyScaleHdl, void * );
//STRIP001 	DECL_LINK( ModifyOriginalScaleHdl, void * );
//STRIP001     DECL_LINK( SelectMetricHdl_Impl, ListBox * );
//STRIP001 
//STRIP001     /** Enable or disable the controls in the compatibility section of the
//STRIP001         'general' tab page depending on whether there is at least one
//STRIP001         document.
//STRIP001     */
//STRIP001     void UpdateCompatibilityControls (void);

//STRIP001 protected:
//STRIP001 	virtual void ActivatePage( const SfxItemSet& rSet );
//STRIP001 	virtual int	DeactivatePage( SfxItemSet* pSet );
//STRIP001 
//STRIP001 public:
//STRIP001 			SdTpOptionsMisc( Window* pParent, const SfxItemSet& rInAttrs  );
//STRIP001 			~SdTpOptionsMisc();
//STRIP001 
//STRIP001 	static	SfxTabPage* Create( Window*, const SfxItemSet& );
//STRIP001 	virtual BOOL FillItemSet( SfxItemSet& );
//STRIP001 	virtual void Reset( const SfxItemSet & );
//STRIP001 
//STRIP001     /** Hide Impress specific controls, make Draw specific controls visible
//STRIP001         and arrange the visible controls.  Do not call this method or the
//STRIP001         <member>SetImpressMode()</member> method more than once.
//STRIP001     */
//STRIP001     void SetDrawMode (void);
//STRIP001 
//STRIP001     /** Hide Draw specific controls, make Impress specific controls visible
//STRIP001         and arrange the visible controls.  Do not call this method or the
//STRIP001         <member>SetDrawMode()</member> method more than once.
//STRIP001     */
//STRIP001     void SetImpressMode (void);
//STRIP001 };


} //namespace binfilter
#endif // _SD_TPOPTION_HXX

