/*************************************************************************
 *
 *  $RCSfile: sd_drviewsf.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:15:17 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #ifndef _COM_SUN_STAR_FORM_FORMBUTTONTYPE_HPP_
// auto strip #include <com/sun/star/form/FormButtonType.hpp>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
// auto strip #include <com/sun/star/beans/XPropertySet.hpp>
// auto strip #endif

#ifndef _SVXIDS_HRC
#include <bf_svx/svxids.hrc>
#endif
// auto strip #ifndef _GLOBL3D_HXX
// auto strip #include <bf_svx/globl3d.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_HLNKITEM_HXX
// auto strip #include <bf_svx/hlnkitem.hxx>
// auto strip #endif
#ifndef _EEITEM_HXX //autogen
#include <bf_svx/eeitem.hxx>
#endif

// auto strip #ifndef _PSTM_HXX
// auto strip #include <tools/pstm.hxx>
// auto strip #endif

#ifndef _SFXPOOLITEM_HXX
#include <svtools/poolitem.hxx>
#endif

#ifndef _SVX_ITEMDATA_HXX
#include <bf_svx/itemdata.hxx>
#endif

#ifndef _DATE_HXX
#include <tools/date.hxx>
#endif

#ifndef _TOOLS_TIME_HXX
#include <tools/time.hxx>
#endif

#ifndef _FLDITEM_HXX
#define ITEMID_FIELD    EE_FEATURE_FIELD
// auto strip #include <bf_svx/flditem.hxx>
#endif
// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_WHITER_HXX //autogen
// auto strip #include <svtools/whiter.hxx>
// auto strip #endif
// auto strip #ifndef _SFXENUMITEM_HXX //autogen
// auto strip #include <svtools/eitem.hxx>
// auto strip #endif
// auto strip #ifndef _SFXITEMPOOL_HXX //autogen
// auto strip #include <svtools/itempool.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_TPLPITEM_HXX //autogen
// auto strip #include <bf_sfx2/tplpitem.hxx>
// auto strip #endif
// auto strip #ifndef _BINDING_HXX //autogen
// auto strip #include <bf_sfx2/bindings.hxx>
// auto strip #endif
// auto strip #ifndef _SFXAPP_HXX //autogen
// auto strip #include <bf_sfx2/app.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_TEMPLDLG_HXX //autogen
// auto strip #include <bf_sfx2/templdlg.hxx>
// auto strip #endif
// auto strip #ifndef _XDEF_HXX //autogen
// auto strip #include <bf_svx/xdef.hxx>
// auto strip #endif
// auto strip #ifndef _SVDDEF_HXX //autogen
// auto strip #include <bf_svx/svddef.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_FMGLOB_HXX
// auto strip #include <bf_svx/fmglob.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOUNO_HXX //autogen
// auto strip #include <bf_svx/svdouno.hxx>
// auto strip #endif
// auto strip #ifndef _URLOBJ_HXX //autogen
// auto strip #include <tools/urlobj.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_FMSHELL_HXX //autogen
// auto strip #include <bf_svx/fmshell.hxx>
// auto strip #endif
#ifndef _SFX_TOPFRM_HXX //autogen wg. SfxTopViewFrame
#include <bf_sfx2/topfrm.hxx>
#endif
#ifndef _SVTOOLS_CJKOPTIONS_HXX
#include <svtools/cjkoptions.hxx>
#endif

// auto strip #include "frmview.hxx"
// auto strip #include "sdoutl.hxx"
#include "app.hrc"

// auto strip #include "app.hxx"
#include "drviewsh.hxx"
// auto strip #include "stlsheet.hxx"
#include "drawview.hxx"
// auto strip #include "drawdoc.hxx"

#include "sdwindow.hxx"
#include "prevchld.hxx"
//STRIP001 #include "preview.hxx"
// auto strip #include "cfgids.hxx"
namespace binfilter {

using namespace ::rtl;
using namespace ::com::sun::star;


/*************************************************************************
|*
|* Status von Controller-SfxSlots setzen
|*
\************************************************************************/

/*N*/ void SdDrawViewShell::GetCtrlState(SfxItemSet &rSet)
/*N*/ {
/*N*/ //	rSet.Put(SfxUInt16Item(SID_SWITCHPAGE, aTabControl.GetCurPageId()));
/*N*/ //	rSet.Put(SfxUInt16Item(SID_SWITCHLAYER, aLayerTab.GetCurPageId()));
/*N*/ 
/*N*/ 	if (rSet.GetItemState(SID_RELOAD) != SFX_ITEM_UNKNOWN)
/*N*/ 	{
		// "Letzte Version" vom SFx en/disablen lassen
/*?*/ 		SfxViewFrame* pViewFrame = GetViewFrame();
/*?*/ 		DBG_ASSERT(pViewFrame, "ViewFrame nicht gefunden");
/*?*/ 		if (pViewFrame->ISA(SfxTopViewFrame))
/*?*/ 		{
/*?*/ 			pViewFrame->GetSlotState (SID_RELOAD, NULL, &rSet);
/*?*/ 		}
/*?*/ 		else		// MI sagt: kein MDIFrame --> disablen
/*?*/ 		{
/*?*/ 			rSet.DisableItem(SID_RELOAD);
/*?*/ 		}
/*?*/ 	}

/*N*/ 	if (SFX_ITEM_AVAILABLE == rSet.GetItemState(SID_HYPERLINK_GETLINK))
/*N*/ 	{
/*?*/ 		DBG_BF_ASSERT(0, "STRIP"); //STRIP001 SvxHyperlinkItem aHLinkItem;
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 		OutlinerView* pOLV = pDrView->GetTextEditOutlinerView();
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 		if (pOLV)
//STRIP001 /*?*/ 		{
//STRIP001 /*?*/ 			const SvxFieldItem* pFieldItem = pOLV->GetFieldAtSelection();
//STRIP001 /*?*/ 			if (pFieldItem)
//STRIP001 /*?*/ 			{
//STRIP001 /*?*/                 ESelection aSel = pOLV->GetSelection();
//STRIP001 /*?*/                 if ( abs( aSel.nEndPos - aSel.nStartPos ) == 1 )
//STRIP001 /*?*/                 {
//STRIP001 /*?*/ 				    const SvxFieldData* pField = pFieldItem->GetField();
//STRIP001 /*?*/ 				    if (pField->ISA(SvxURLField))
//STRIP001 /*?*/ 				    {
//STRIP001 /*?*/ 					    aHLinkItem.SetName(((const SvxURLField*) pField)->GetRepresentation());
//STRIP001 /*?*/ 					    aHLinkItem.SetURL(((const SvxURLField*) pField)->GetURL());
//STRIP001 /*?*/ 					    aHLinkItem.SetTargetFrame(((const SvxURLField*) pField)->GetTargetFrame());
//STRIP001 /*?*/ 				    }
//STRIP001 /*?*/                 }
//STRIP001 /*?*/ 			}
//STRIP001 /*?*/ 		}
//STRIP001 /*?*/ 		else
//STRIP001 /*?*/ 		{
//STRIP001 /*?*/ 			if (pDrView->GetMarkList().GetMarkCount() > 0)
//STRIP001 /*?*/ 			{
//STRIP001 /*?*/ 				SdrUnoObj* pUnoCtrl = PTR_CAST(SdrUnoObj, pDrView->GetMarkList().GetMark(0)->GetObj());
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 				if (pUnoCtrl && FmFormInventor == pUnoCtrl->GetObjInventor())
//STRIP001 /*?*/ 				{
//STRIP001 /*?*/ 					uno::Reference< awt::XControlModel > xControlModel( pUnoCtrl->GetUnoControlModel() );
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 					if( !xControlModel.is() )
//STRIP001 /*?*/ 						return;
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 					uno::Reference< beans::XPropertySet > xPropSet( xControlModel, uno::UNO_QUERY );
//STRIP001 /*?*/ 					if( !xPropSet.is())
//STRIP001 /*?*/ 						return;
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 					uno::Reference< beans::XPropertySetInfo > xPropInfo( xPropSet->getPropertySetInfo() );
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 					uno::Any aTmp;
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 					form::FormButtonType eButtonType = form::FormButtonType_URL;
//STRIP001 /*?*/ 					if(!xPropInfo->hasPropertyByName( ::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( "ButtonType" ))))
//STRIP001 /*?*/ 						return;
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 					aTmp = xPropSet->getPropertyValue( ::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( "ButtonType" )));
//STRIP001 /*?*/ 					if( aTmp >>= eButtonType )
//STRIP001 /*?*/ 					{
//STRIP001 /*?*/ 						OUString aString;
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 						// Label
//STRIP001 /*?*/ 						if(!xPropInfo->hasPropertyByName(::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( "Label" ))))
//STRIP001 /*?*/ 							return;
//STRIP001 /*?*/ 						aTmp = xPropSet->getPropertyValue( ::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( "Label" )));
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 						if( aTmp >>= aString )
//STRIP001 /*?*/ 							aHLinkItem.SetName(String( aString ));
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 						// URL
//STRIP001 /*?*/ 						if(!xPropInfo->hasPropertyByName(::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( "TargetURL" ))))
//STRIP001 /*?*/ 							return;
//STRIP001 /*?*/ 						aTmp = xPropSet->getPropertyValue( ::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( "TargetURL" )));
//STRIP001 /*?*/ 						if( aTmp >>= aString )
//STRIP001 /*?*/ 							aHLinkItem.SetURL(String( aString ));
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 						// Target
//STRIP001 /*?*/ 						if(!xPropInfo->hasPropertyByName(::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( "TargetFrame" ))))
//STRIP001 /*?*/ 							return;
//STRIP001 /*?*/ 						aTmp = xPropSet->getPropertyValue( ::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( "TargetFrame" )));
//STRIP001 /*?*/ 						if( aTmp >>= aString )
//STRIP001 /*?*/ 							aHLinkItem.SetTargetFrame(String( aString ));
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 						aHLinkItem.SetInsertMode(HLINK_BUTTON);
//STRIP001 /*?*/ 					}
//STRIP001 /*?*/ 				}
//STRIP001 /*?*/ 			}
//STRIP001 /*?*/ 		}
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 		rSet.Put(aHLinkItem);
/*N*/ 	}
/*N*/ 	rSet.Put( SfxBoolItem( SID_READONLY_MODE, bReadOnly ) );

	// Ausgabequalitaet
/*N*/ 	if( SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_OUTPUT_QUALITY_COLOR ) ||
/*N*/ 		SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_OUTPUT_QUALITY_GRAYSCALE ) ||
/*N*/ 		SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_OUTPUT_QUALITY_BLACKWHITE ) ||
/*N*/         SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_OUTPUT_QUALITY_CONTRAST ) )
/*N*/ 	{
/*?*/ 		ULONG   nMode = pWindow->GetDrawMode();
/*?*/ 		UINT16  nQuality = 0;
/*?*/ 		
/*?*/         if( OUTPUT_DRAWMODE_COLOR == nMode )
/*?*/ 			nQuality = 0;
/*?*/ 		else if( OUTPUT_DRAWMODE_GRAYSCALE == nMode )
/*?*/ 			nQuality = 1;
/*?*/ 		else if( OUTPUT_DRAWMODE_BLACKWHITE == nMode )
/*?*/ 			nQuality = 2;
/*?*/         else if( OUTPUT_DRAWMODE_CONTRAST == nMode )
/*?*/             nQuality = 3;
/*?*/ 
/*?*/ 		rSet.Put( SfxBoolItem( SID_OUTPUT_QUALITY_COLOR, (BOOL)(nQuality == 0) ) );
/*?*/ 		rSet.Put( SfxBoolItem( SID_OUTPUT_QUALITY_GRAYSCALE, (BOOL)(nQuality == 1) ) );
/*?*/ 		rSet.Put( SfxBoolItem( SID_OUTPUT_QUALITY_BLACKWHITE, (BOOL)(nQuality == 2) ) );
/*?*/ 		rSet.Put( SfxBoolItem( SID_OUTPUT_QUALITY_CONTRAST, (BOOL)(nQuality == 3) ) );
/*?*/ 	}

	// Preview-Fenster
/*N*/ 	if( SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_PREVIEW_QUALITY_COLOR ) ||
/*N*/ 		SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_PREVIEW_QUALITY_GRAYSCALE ) ||
/*N*/ 		SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_PREVIEW_QUALITY_BLACKWHITE ) ||
/*N*/         SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_PREVIEW_QUALITY_CONTRAST ) )
/*N*/ 	{
/*N*/ 		USHORT nId = SdPreviewChildWindow::GetChildWindowId();
/*N*/ 		
/*N*/         if( GetViewFrame()->GetChildWindow( nId ) )
		{
			DBG_BF_ASSERT(0, "STRIP"); //STRIP001 ULONG nMode = pFrameView->GetPreviewDrawMode();
//STRIP001 			rSet.Put( SfxBoolItem( SID_PREVIEW_QUALITY_COLOR, (BOOL)(nMode == PREVIEW_DRAWMODE_COLOR) ) );
//STRIP001 			rSet.Put( SfxBoolItem( SID_PREVIEW_QUALITY_GRAYSCALE, (BOOL)(nMode == PREVIEW_DRAWMODE_GRAYSCALE) ) );
//STRIP001 			rSet.Put( SfxBoolItem( SID_PREVIEW_QUALITY_BLACKWHITE, (BOOL)(nMode == PREVIEW_DRAWMODE_BLACKWHITE) ) );
//STRIP001 			rSet.Put( SfxBoolItem( SID_PREVIEW_QUALITY_CONTRAST, (BOOL)(nMode == PREVIEW_DRAWMODE_CONTRAST) ) );
		}
/*N*/ 		else
/*N*/ 		{
/*N*/ 			rSet.DisableItem( SID_PREVIEW_QUALITY_COLOR );
/*N*/ 			rSet.DisableItem( SID_PREVIEW_QUALITY_GRAYSCALE );
/*N*/ 			rSet.DisableItem( SID_PREVIEW_QUALITY_BLACKWHITE );
/*N*/ 			rSet.DisableItem( SID_PREVIEW_QUALITY_CONTRAST );
/*N*/ 		}
/*N*/ 	}

/*N*/ 	if ( SFX_ITEM_AVAILABLE == rSet.GetItemState(SID_MAIL_SCROLLBODY_PAGEDOWN) )
/*N*/ 	{
/*?*/ 		rSet.Put( SfxBoolItem( SID_MAIL_SCROLLBODY_PAGEDOWN, TRUE ) );
/*?*/ 	}

/*N*/ 	if ( SFX_ITEM_AVAILABLE == rSet.GetItemState(SID_ATTR_YEAR2000) )
/*N*/ 	{

/*?*/ 		FmFormShell* pShell = (FmFormShell*) aShellTable.Get(RID_FORMLAYER_TOOLBOX);
/*?*/ 		if( pShell )
/*?*/ 		{
/*?*/ 			DBG_BF_ASSERT(0, "STRIP"); //STRIP001 UINT16 nState = 0;
//STRIP001 /*?*/ 			if ( pShell->GetY2KState(nState) )
//STRIP001 /*?*/ 				rSet.Put( SfxUInt16Item( SID_ATTR_YEAR2000, nState ) );
//STRIP001 /*?*/ 			else
//STRIP001 /*?*/ 				rSet.DisableItem( SID_ATTR_YEAR2000 );
/*?*/ 		}
/*?*/ 	}

/*N*/ 	if ( !pView->GetTextEditOutliner() )
/*N*/ 	{
/*N*/ 		rSet.DisableItem( SID_TRANSLITERATE_UPPER );
/*N*/ 		rSet.DisableItem( SID_TRANSLITERATE_LOWER );
/*N*/ 		rSet.DisableItem( SID_TRANSLITERATE_HALFWIDTH );
/*N*/ 		rSet.DisableItem( SID_TRANSLITERATE_FULLWIDTH );
/*N*/ 		rSet.DisableItem( SID_TRANSLITERATE_HIRAGANA );
/*N*/ 		rSet.DisableItem( SID_TRANSLITERATE_KATAGANA );
/*N*/ 	}
/*N*/ 	else
/*N*/ 	{
/*?*/         SvtCJKOptions aCJKOptions;
/*?*/ 		if( !aCJKOptions.IsChangeCaseMapEnabled() )
/*?*/ 		{
/*?*/ 			rSet.DisableItem( SID_TRANSLITERATE_HALFWIDTH );
/*?*/ 			rSet.DisableItem( SID_TRANSLITERATE_FULLWIDTH );
/*?*/ 			rSet.DisableItem( SID_TRANSLITERATE_HIRAGANA );
/*?*/ 			rSet.DisableItem( SID_TRANSLITERATE_KATAGANA );
/*?*/ 		}
/*N*/ 	}
/*N*/ }


/*************************************************************************
|*
|* Status der Attribut-Items
|*
\************************************************************************/

//STRIP001 void SdDrawViewShell::GetAttrState( SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	SfxWhichIter	aIter( rSet );
//STRIP001 	USHORT			nWhich = aIter.FirstWhich();
//STRIP001 
//STRIP001 	BOOL	bAttr = FALSE;
//STRIP001 	SfxAllItemSet aAllSet( *rSet.GetPool() );
//STRIP001 
//STRIP001 	while ( nWhich )
//STRIP001 	{
//STRIP001 		USHORT nSlotId = SfxItemPool::IsWhich(nWhich)
//STRIP001 			? GetPool().GetSlotId(nWhich)
//STRIP001 			: nWhich;
//STRIP001 		switch ( nSlotId )
//STRIP001 		{
//STRIP001 			case SID_ATTR_FILL_STYLE:
//STRIP001 			case SID_ATTR_FILL_COLOR:
//STRIP001 			case SID_ATTR_FILL_GRADIENT:
//STRIP001 			case SID_ATTR_FILL_HATCH:
//STRIP001 			case SID_ATTR_FILL_BITMAP:
//STRIP001 			case SID_ATTR_FILL_SHADOW:
//STRIP001 			case SID_ATTR_LINE_STYLE:
//STRIP001 			case SID_ATTR_LINE_DASH:
//STRIP001 			case SID_ATTR_LINE_WIDTH:
//STRIP001 			case SID_ATTR_LINE_COLOR:
//STRIP001 			case SID_ATTR_TEXT_FITTOSIZE:
//STRIP001 			{
//STRIP001 				bAttr = TRUE;
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_HYPHENATION:
//STRIP001 			{
//STRIP001 				SfxItemSet aAttrs( pDoc->GetPool() );
//STRIP001 				pDrView->GetAttributes( aAttrs );
//STRIP001 				if( aAttrs.GetItemState( EE_PARA_HYPHENATE ) >= SFX_ITEM_AVAILABLE )
//STRIP001 				{
//STRIP001 					BOOL bValue = ( (const SfxBoolItem&) aAttrs.Get( EE_PARA_HYPHENATE ) ).GetValue();
//STRIP001 					rSet.Put( SfxBoolItem( SID_HYPHENATION, bValue ) );
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_STYLE_FAMILY2:
//STRIP001 			case SID_STYLE_FAMILY5:
//STRIP001 			case SID_STYLE_APPLY: // StyleControl
//STRIP001 			{
//STRIP001 				SfxStyleSheet* pStyleSheet = pDrView->GetStyleSheet();
//STRIP001 				if( pStyleSheet )
//STRIP001 				{
//STRIP001 					if( nSlotId != SID_STYLE_APPLY && !pDrView->HasMarkedObj() )
//STRIP001 					{
//STRIP001 						SfxTemplateItem aTmpItem( nWhich, String() );
//STRIP001 						aAllSet.Put( aTmpItem, aTmpItem.Which()  );
//STRIP001 					}
//STRIP001 					else
//STRIP001 					{
//STRIP001 						if (pStyleSheet->GetFamily() == SD_LT_FAMILY)
//STRIP001 							pStyleSheet = ((SdStyleSheet*)pStyleSheet)->GetPseudoStyleSheet();
//STRIP001 
//STRIP001 						if( pStyleSheet )
//STRIP001 						{
//STRIP001 							SfxStyleFamily eFamily = pStyleSheet->GetFamily();
//STRIP001 
//STRIP001 							if ((eFamily == SFX_STYLE_FAMILY_PARA &&
//STRIP001 								nSlotId == SID_STYLE_FAMILY2)        ||
//STRIP001 								(eFamily == SFX_STYLE_FAMILY_PSEUDO &&
//STRIP001 								nSlotId == SID_STYLE_FAMILY5))
//STRIP001 							{
//STRIP001 								SfxTemplateItem aTmpItem ( nWhich, pStyleSheet->GetName() );
//STRIP001 								aAllSet.Put( aTmpItem, aTmpItem.Which()  );
//STRIP001 							}
//STRIP001 							else
//STRIP001 							{
//STRIP001 								SfxTemplateItem aTmpItem(nWhich, String());
//STRIP001 								aAllSet.Put(aTmpItem,aTmpItem.Which()  );
//STRIP001 							}
//STRIP001 						}
//STRIP001 					}
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{	SfxTemplateItem aItem( nWhich, String() );
//STRIP001 					aAllSet.Put( aItem, aItem.Which() );
//STRIP001 					// rSet.DisableItem( nWhich );
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_SET_DEFAULT:
//STRIP001 			{
//STRIP001                 if( !pDrView->GetMarkList().GetMarkCount() ||
//STRIP001                     ( !pDrView->IsTextEdit() && !pDrView->GetStyleSheet() )
//STRIP001                   )
//STRIP001 					rSet.DisableItem( nWhich );
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_STYLE_WATERCAN:
//STRIP001 			{
//STRIP001 				ISfxTemplateCommon* pTemplateCommon = SFX_APP()->GetCurrentTemplateCommon(GetViewFrame()->GetBindings());
//STRIP001 				if (pTemplateCommon && pTemplateCommon->GetActualFamily() == SFX_STYLE_FAMILY_PSEUDO)
//STRIP001 					rSet.Put(SfxBoolItem(nWhich,FALSE));
//STRIP001 				else
//STRIP001 				{
//STRIP001 					SfxBoolItem aItem(nWhich, SD_MOD()->GetWaterCan());
//STRIP001 					aAllSet.Put( aItem, aItem.Which());
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_STYLE_NEW:
//STRIP001 			{
//STRIP001 				ISfxTemplateCommon* pTemplateCommon = SFX_APP()->GetCurrentTemplateCommon(GetViewFrame()->GetBindings());
//STRIP001 				if (pTemplateCommon && pTemplateCommon->GetActualFamily() == SFX_STYLE_FAMILY_PSEUDO)
//STRIP001 					rSet.DisableItem(nWhich);
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_STYLE_DRAGHIERARCHIE:
//STRIP001 			{
//STRIP001 				ISfxTemplateCommon* pTemplateCommon = SFX_APP()->GetCurrentTemplateCommon(GetViewFrame()->GetBindings());
//STRIP001 				if (pTemplateCommon && pTemplateCommon->GetActualFamily() == SFX_STYLE_FAMILY_PSEUDO)
//STRIP001 					rSet.DisableItem(nWhich);
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_STYLE_NEW_BY_EXAMPLE:
//STRIP001 			{
//STRIP001 				// PseudoStyleSheets koennen nicht 'by Example' erzeugt werden;
//STRIP001 				// normale StyleSheets brauchen dafuer ein selektiertes Objekt
//STRIP001 				ISfxTemplateCommon* pTemplCommon = SFX_APP()->GetCurrentTemplateCommon(GetViewFrame()->GetBindings());
//STRIP001 				if (pTemplCommon)
//STRIP001 				{
//STRIP001 					if (pTemplCommon->GetActualFamily() == SFX_STYLE_FAMILY_PSEUDO)
//STRIP001 					{
//STRIP001 						rSet.DisableItem(nWhich);
//STRIP001 					}
//STRIP001 					else if (pTemplCommon->GetActualFamily() == SFX_STYLE_FAMILY_PARA)
//STRIP001 					{
//STRIP001 						if (!pDrView->HasMarkedObj())
//STRIP001 						{
//STRIP001 							rSet.DisableItem(nWhich);
//STRIP001 						}
//STRIP001 					}
//STRIP001 				}
//STRIP001 				// falls (noch) kein Gestalter da ist, muessen wir uns auf den
//STRIP001 				// View-Zustand zurueckziehen; eine aktuell eingestellte Familie
//STRIP001 				// kann nicht beruecksichtigt werden
//STRIP001 				else
//STRIP001 				{
//STRIP001 					if (!pDrView->HasMarkedObj())
//STRIP001 					{
//STRIP001 						rSet.DisableItem(nWhich);
//STRIP001 					}
//STRIP001 				}
//STRIP001 
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_STYLE_UPDATE_BY_EXAMPLE:
//STRIP001 			{
//STRIP001 				if (!pDrView->HasMarkedObj())
//STRIP001 				{
//STRIP001 					rSet.DisableItem(nWhich);
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		}
//STRIP001 		nWhich = aIter.NextWhich();
//STRIP001 	}
//STRIP001 
//STRIP001 	SfxItemSet* pSet = NULL;
//STRIP001 
//STRIP001 	if( bAttr )
//STRIP001 	{
//STRIP001 		pSet = new SfxItemSet( pDoc->GetPool() );
//STRIP001 		pDrView->GetAttributes( *pSet );
//STRIP001 		rSet.Put( *pSet, FALSE );
//STRIP001 	}
//STRIP001 
//STRIP001 	rSet.Put( aAllSet, FALSE );
//STRIP001 
//STRIP001 	// Flaechen und/oder Linienattribute wurden geaendert
//STRIP001 	if( bAttr && pSet )
//STRIP001 	{
//STRIP001 		// Wenn die View selektierte Objekte besitzt, muessen entspr. Items
//STRIP001 		// von SFX_ITEM_DEFAULT (_ON) auf SFX_ITEM_DISABLED geaendert werden
//STRIP001 		if( pDrView->HasMarkedObj() )
//STRIP001 		{
//STRIP001 			SfxWhichIter aNewIter( *pSet, XATTR_LINE_FIRST, XATTR_FILL_LAST );
//STRIP001 			nWhich = aNewIter.FirstWhich();
//STRIP001 			while( nWhich )
//STRIP001 			{
//STRIP001 				if( SFX_ITEM_DEFAULT == pSet->GetItemState( nWhich ) )
//STRIP001 				{
//STRIP001 					rSet.ClearItem( nWhich );
//STRIP001 					rSet.DisableItem( nWhich );
//STRIP001 				}
//STRIP001 				nWhich = aNewIter.NextWhich();
//STRIP001 			}
//STRIP001 		}
//STRIP001 		delete pSet;
//STRIP001 	}
//STRIP001 
//STRIP001 //    const SdrMarkList& rMarkList = pDrView->GetMarkList();
//STRIP001 //    ULONG nMarkCount = rMarkList.GetMarkCount();
//STRIP001 //    BOOL bDisabled = FALSE;
//STRIP001 //
//STRIP001 //    for (ULONG i = 0;
//STRIP001 //         i < nMarkCount && !bDisabled && i < 50; i++)
//STRIP001 //    {
//STRIP001 //        SdrObject* pObj = rMarkList.GetMark(i)->GetObj();
//STRIP001 //
//STRIP001 //        if (pObj->GetObjInventor() == E3dInventor)
//STRIP001 //        {
//STRIP001 //            bDisabled = TRUE;
//STRIP001 //            rSet.ClearItem(SDRATTR_SHADOW);
//STRIP001 //            rSet.DisableItem(SDRATTR_SHADOW);
//STRIP001 //        }
//STRIP001 //    }
//STRIP001 }


/*************************************************************************
|*
|* Text der Selektion zurueckgeben
|*
\************************************************************************/

//STRIP001 String SdDrawViewShell::GetSelectionText(BOOL bCompleteWords)
//STRIP001 {
//STRIP001 	String aStrSelection;
//STRIP001 	Outliner* pOl = pDrView->GetTextEditOutliner();
//STRIP001 	OutlinerView* pOlView = pDrView->GetTextEditOutlinerView();
//STRIP001 
//STRIP001 	if (pOl && pOlView)
//STRIP001 	{
//STRIP001 		if (bCompleteWords)
//STRIP001 		{
//STRIP001 			ESelection aSel = pOlView->GetSelection();
//STRIP001 			String aStrCurrentDelimiters = pOl->GetWordDelimiters();
//STRIP001 
//STRIP001 			pOl->SetWordDelimiters( String( RTL_CONSTASCII_USTRINGPARAM( " .,;\"'" )));
//STRIP001 			aStrSelection = pOl->GetWord( aSel.nEndPara, aSel.nEndPos );
//STRIP001 			pOl->SetWordDelimiters( aStrCurrentDelimiters );
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			aStrSelection = pOlView->GetSelected();
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return (aStrSelection);
//STRIP001 }

/*************************************************************************
|*
|* Ist etwas selektiert?
|*
\************************************************************************/

//STRIP001 BOOL SdDrawViewShell::HasSelection(BOOL bText) const
//STRIP001 {
//STRIP001 	BOOL bReturn = FALSE;
//STRIP001 
//STRIP001 	if (bText)
//STRIP001 	{
//STRIP001 		OutlinerView* pOlView = pDrView->GetTextEditOutlinerView();
//STRIP001 
//STRIP001 		if (pOlView && pOlView->GetSelected().Len() != 0)
//STRIP001 		{
//STRIP001 			bReturn = TRUE;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if (pDrView->GetMarkList().GetMarkCount() != 0)
//STRIP001 	{
//STRIP001 		bReturn = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	return bReturn;
//STRIP001 }


}
