#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.3 $
#
#   last change: $Author: aw $ $Date: 2003/11/18 19:23:20 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
PRJ=..$/..$/..
BFPRJ=..$/..

PRJNAME=binfilter
TARGET=sfx2_dialog

#GEN_HID=TRUE
#GEN_HID_OTHER=TRUE
NO_HIDS=TRUE

.INCLUDE :  $(BFPRJ)$/util$/makefile.pmk
AUTOSEG=true

# --- Settings -----------------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk
INC+= -I$(PRJ)$/inc$/bf_sfx2

# --- Files --------------------------------------------------------------

IMGLST_SRS=$(SRS)$/sfx2_dialog.srs
BMP_IN=$(PRJ)$/win/res

EXCEPTIONSFILES=\
		$(SLO)$/sfx2_filtergrouping.obj	\
		$(SLO)$/sfx2_filedlghelper.obj	\
		$(SLO)$/sfx2_mailmodel.obj		\
		$(SLO)$/sfx2_partwnd.obj

SLOFILES =\
		$(EXCEPTIONSFILES)			\
		$(SLO)$/sfx2_cfg.obj				\
		$(SLO)$/sfx2_about.obj			\
		$(SLO)$/sfx2_acccfg.obj			\
		$(SLO)$/sfx2_basedlgs.obj		\
		$(SLO)$/sfx2_dinfdlg.obj			\
		$(SLO)$/sfx2_dinfedt.obj			\
		$(SLO)$/sfx2_dockwin.obj			\
		$(SLO)$/sfx2_eventdlg.obj		\
		$(SLO)$/sfx2_intro.obj			\
		$(SLO)$/sfx2_macropg.obj			\
		$(SLO)$/sfx2_mailchildwin.obj	\
		$(SLO)$/sfx2_mailwindow.obj		\
		$(SLO)$/sfx2_menucfg.obj			\
		$(SLO)$/sfx2_mgetempl.obj		\
		$(SLO)$/sfx2_navigat.obj			\
		$(SLO)$/sfx2_newstyle.obj		\
		$(SLO)$/sfx2_passwd.obj			\
		$(SLO)$/sfx2_register.obj		\
		$(SLO)$/sfx2_sfxurl.obj			\
		$(SLO)$/sfx2_slotinfo.obj		\
		$(SLO)$/sfx2_splitwin.obj		\
		$(SLO)$/sfx2_styfitem.obj		\
		$(SLO)$/sfx2_styledlg.obj		\
		$(SLO)$/sfx2_tabdlg.obj			\
		$(SLO)$/sfx2_templdlg.obj		\
		$(SLO)$/sfx2_tplcitem.obj		\
		$(SLO)$/sfx2_tplpitem.obj		\
		$(SLO)$/sfx2_versdlg.obj			\
		$(SLO)$/sfx2_printopt.obj		\
                $(SLO)$/sfx2_recfloat.obj            \
		$(SLO)$/sfx2_cfgtreelstbox.obj

SRS1NAME=$(TARGET)
SRC1FILES =\
                sfx2_recfloat.src                       \
		sfx2_about.src			\
		sfx2_cfg.src				\
		sfx2_dialog.src			\
		sfx2_dinfdlg.src			\
		sfx2_dinfedt.src			\
		sfx2_dlgrun.src			\
		sfx2_eventdlg.src		\
		sfx2_filedlghelper.src	\
		sfx2_macropg.src			\
		sfx2_mail.src			\
		sfx2_mailwindow.src		\
		sfx2_mgetempl.src		\
		sfx2_newstyle.src		\
		sfx2_passwd.src			\
		sfx2_register.src		\
		sfx2_templdlg.src		\
		sfx2_versdlg.src			\
		sfx2_printopt.src

# --- Targets -------------------------------------------------------

.INCLUDE :  target.mk

