/*************************************************************************
 *
 *  $RCSfile: sfx2_about.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:39:47 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ---------------------------------------------------------------

// auto strip #ifndef _SV_APP_HXX
// auto strip #include <vcl/svapp.hxx>
// auto strip #endif
// auto strip #ifndef _MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _PVER_HXX //autogen
// auto strip #include <svtools/pver.hxx>
// auto strip #endif
#pragma hdrstop

// auto strip #include <tools/stream.hxx>
// auto strip #include <tools/urlobj.hxx>
// auto strip #include <svtools/pathoptions.hxx>
// auto strip #include <unotools/configmgr.hxx>
// auto strip #include <unotools/bootstrap.hxx>
#ifndef _COM_SUN_STAR_UNO_ANY_H_
#include <com/sun/star/uno/Any.h>
#endif

// auto strip #include "sfxuno.hxx"
// auto strip #include "about.hxx"
// auto strip #include "sfxresid.hxx"
// auto strip #include "sfxdefs.hxx"
// auto strip #include "app.hxx"

#include "dialog.hrc"
namespace binfilter {

// defines ---------------------------------------------------------------

//STRIP001 #define SCROLL_OFFSET	((long)2)
//STRIP001 #define SPACE_OFFSET	((long)5)
//STRIP001 
//STRIP001 typedef unsigned short (*fncUshort)();
//STRIP001 typedef const char* (*fncChar)();
//STRIP001 
//STRIP001 // class AboutDialog -----------------------------------------------------
//STRIP001 
//STRIP001 AboutDialog::AboutDialog( Window* pParent, const ResId& rId, const String& rVerStr ) :
//STRIP001 
//STRIP001 	SfxModalDialog	( pParent, 	rId ),
//STRIP001 
//STRIP001 	aOKButton      	( this,		ResId( ABOUT_BTN_OK ) ),
//STRIP001 	aVersionText 	( this, 	ResId( ABOUT_FTXT_VERSION ) ),
//STRIP001 	aCopyrightText	( this, 	ResId( ABOUT_FTXT_COPYRIGHT ) ),
//STRIP001 	aDeveloperAry	( 			ResId( ABOUT_STR_DEVELOPER_ARY ) ),
//STRIP001 	aDevVersionStr	( rVerStr ),
//STRIP001 	aAccelStr		( 			ResId( ABOUT_STR_ACCEL ) ),
//STRIP001 
//STRIP001 	aTimer	(),
//STRIP001 	nOff	( 0 ),
//STRIP001 	nEnd	( 0 ),
//STRIP001 	bNormal	( TRUE )
//STRIP001 
//STRIP001 {
//STRIP001 	// load image from module path
//STRIP001 	String aBmpFileName( DEFINE_CONST_UNICODE("about.bmp") );
//STRIP001 	INetURLObject aObj( SvtPathOptions().GetModulePath(), INET_PROT_FILE );
//STRIP001 	aObj.insertName( aBmpFileName );
//STRIP001 	SvFileStream aStrm( aObj.PathToFileName(), STREAM_STD_READ );
//STRIP001 	if ( !aStrm.GetError() )
//STRIP001 	{
//STRIP001 		Bitmap aBmp;
//STRIP001 		aStrm >> aBmp;
//STRIP001 		aAppLogo = Image( aBmp );
//STRIP001 	}
//STRIP001     else
//STRIP001     {
//STRIP001         aAppLogo = Image( Bitmap( ResId( RID_DEFAULT_ABOUT_BMP_LOGO, rId.GetResMgr() ) ) );
//STRIP001     }
//STRIP001 
//STRIP001 	// Transparenter Font
//STRIP001 	Font aFont = GetFont();
//STRIP001 	aFont.SetTransparent( TRUE );
//STRIP001 	SetFont( aFont );
//STRIP001 
//STRIP001 	// ggf. Spezial Version
//STRIP001 	String aStr = aVersionText.GetText();
//STRIP001     aStr.SearchAndReplaceAscii( "$(VER)", Application::GetDisplayName() );
//STRIP001 	::rtl::OUString aDefault;
//STRIP001 	String sPatchLevel( utl::Bootstrap::getProductPatchLevel( aDefault ) );
//STRIP001 	if ( sPatchLevel.Len() > 0 )
//STRIP001 	{
//STRIP001 		aStr.EraseTrailingChars();
//STRIP001 		aStr += ' ';
//STRIP001 		aStr += sPatchLevel;
//STRIP001 	}
//STRIP001 	aVersionText.SetText( aStr );
//STRIP001 
//STRIP001 	// Initialisierung fuer Aufruf Entwickler
//STRIP001 	if ( aAccelStr.Len() && ByteString(U2S(aAccelStr)).IsAlphaAscii() )
//STRIP001 	{
//STRIP001 		Accelerator	*pAccel = 0, *pPrevAccel = 0, *pFirstAccel = 0;
//STRIP001 		aAccelStr.ToUpperAscii();
//STRIP001 
//STRIP001 		for ( USHORT i = 0; i < aAccelStr.Len(); ++i )
//STRIP001 		{
//STRIP001 			pPrevAccel = pAccel;
//STRIP001 			pAccel = new Accelerator;
//STRIP001 			aAccelList.Insert( pAccel, LIST_APPEND );
//STRIP001 			USHORT nKey = aAccelStr.GetChar(i) - 'A' + KEY_A;
//STRIP001 			pAccel->InsertItem( 1, KeyCode( nKey, KEY_MOD1 ) );
//STRIP001 			if ( i > 0 )
//STRIP001 				pPrevAccel->SetAccel( 1, pAccel );
//STRIP001 			if ( i == 0 )
//STRIP001 				pFirstAccel = pAccel;
//STRIP001 		}
//STRIP001 		pAccel->SetSelectHdl( LINK( this, AboutDialog, AccelSelectHdl ) );
//STRIP001 		GetpApp()->InsertAccel( pFirstAccel );
//STRIP001 	}
//STRIP001 
//STRIP001 	// set for background and text the correct system color
//STRIP001 	const StyleSettings& rSettings = GetSettings().GetStyleSettings();
//STRIP001 	Color aWhiteCol( rSettings.GetWindowColor() );
//STRIP001 	Wallpaper aWall( aWhiteCol );
//STRIP001 	SetBackground( aWall );
//STRIP001 	Font aNewFont( aCopyrightText.GetFont() );
//STRIP001 	aNewFont.SetTransparent( TRUE );
//STRIP001 
//STRIP001 	aVersionText.SetFont( aNewFont );
//STRIP001 	aCopyrightText.SetFont( aNewFont );
//STRIP001 
//STRIP001 	aVersionText.SetBackground( aWall );
//STRIP001 	aCopyrightText.SetBackground( aWall );
//STRIP001 
//STRIP001 	Color aTextColor( rSettings.GetWindowTextColor() );
//STRIP001 	aVersionText.SetControlForeground( aTextColor );
//STRIP001 	aCopyrightText.SetControlForeground( aTextColor );
//STRIP001 
//STRIP001 	// Gr"ossen und Positionen berechnen
//STRIP001 	Size aAppLogoSiz = aAppLogo.GetSizePixel();
//STRIP001 	Size aOutSiz = GetOutputSizePixel();
//STRIP001 	Size aTextSize = Size( GetTextWidth( DEFINE_CONST_UNICODE( "StarOfficeAbout" ) ), GetTextHeight() );
//STRIP001 
//STRIP001 	// Fenstergr"osse
//STRIP001 	aOutSiz.Width() = aAppLogoSiz.Width();
//STRIP001 
//STRIP001 	// Texte (Gr"osse und Position )
//STRIP001 	Size a6Size = aVersionText.LogicToPixel( Size( 6, 6 ), MAP_APPFONT );
//STRIP001 	long nY = 0;
//STRIP001 	Point aTextPos = aVersionText.GetPosPixel();
//STRIP001 	aTextPos.X() = a6Size.Width() * 2;
//STRIP001 	aTextPos.Y() = aAppLogoSiz.Height() + ( a6Size.Height() * 2 );
//STRIP001 	nY = aTextPos.Y();
//STRIP001 	aVersionText.SetPosPixel( aTextPos );
//STRIP001 	Size aTxtSiz = aVersionText.GetSizePixel();
//STRIP001 	aTxtSiz.Width() = aAppLogoSiz.Width() - ( a6Size.Width() * 4 );
//STRIP001 	long nTextWidth = aTxtSiz.Width();
//STRIP001     Size aCalcSize = aVersionText.CalcMinimumSize( nTextWidth );
//STRIP001 
//STRIP001     aTxtSiz.Height() = aCalcSize.Height();
//STRIP001 	aVersionText.SetSizePixel( aTxtSiz );
//STRIP001 	nY += aTxtSiz.Height() + ( a6Size.Height() / 3 );
//STRIP001 
//STRIP001 	aTextPos = aCopyrightText.GetPosPixel();
//STRIP001 	aTextPos.X() = a6Size.Width() * 2;
//STRIP001 	aTextPos.Y() = nY;
//STRIP001 	aCopyrightText.SetPosPixel( aTextPos );
//STRIP001 	aTxtSiz = aCopyrightText.GetSizePixel();
//STRIP001 	aTxtSiz.Width() = nTextWidth;
//STRIP001     aCalcSize = aCopyrightText.CalcMinimumSize( nTextWidth );
//STRIP001     aTxtSiz.Height() = aCalcSize.Height();
//STRIP001 	aCopyrightText.SetSizePixel( aTxtSiz );
//STRIP001 	nY += aTxtSiz.Height() + ( a6Size.Height() / 2 );
//STRIP001 
//STRIP001 	// OK-Button-Position (at the bottom and centered)
//STRIP001 	Size aOKSiz = aOKButton.GetSizePixel();
//STRIP001 	Point aOKPnt = aOKButton.GetPosPixel();
//STRIP001 	aOKPnt.X() = ( aOutSiz.Width() - aOKSiz.Width() ) / 2;
//STRIP001 	aOKPnt.Y() = nY + 8;
//STRIP001 	aOKButton.SetPosPixel( aOKPnt );
//STRIP001 	nY = aOKPnt.Y() + aOKSiz.Height() + a6Size.Height();
//STRIP001 	aOutSiz.Height() = nY;
//STRIP001 	SetOutputSizePixel( aOutSiz );
//STRIP001 
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	// explizite Help-Id
//STRIP001 	SetHelpId( SID_ABOUT );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 AboutDialog::~AboutDialog()
//STRIP001 {
//STRIP001 	// L"oschen des Entwickleraufrufs
//STRIP001 	if ( aAccelList.Count() )
//STRIP001 	{
//STRIP001 		GetpApp()->RemoveAccel( aAccelList.First() );
//STRIP001 		Accelerator* pAccel = aAccelList.Last();
//STRIP001 
//STRIP001 		while ( pAccel )
//STRIP001 		{
//STRIP001 			delete pAccel;
//STRIP001 			pAccel = aAccelList.Prev();
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( AboutDialog, TimerHdl, Timer *, pTimer )
//STRIP001 {
//STRIP001 	// Text scrollen
//STRIP001 	nOff -= SCROLL_OFFSET;
//STRIP001 	MapMode aMapMode( MAP_PIXEL, Point( 0, nOff ), Fraction( 1, 1 ), Fraction( 1, 1 ) );
//STRIP001 	SetMapMode( aMapMode );
//STRIP001 	Scroll( 0, -SCROLL_OFFSET );
//STRIP001 
//STRIP001 	// Wenn der Text zuende gescrollt wurde, Dialogbox beenden
//STRIP001 	if ( ( nOff * -1 ) > nEnd )
//STRIP001 	{
//STRIP001 		bNormal = TRUE;
//STRIP001 		Close();
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( AboutDialog, AccelSelectHdl, Accelerator *, pAccelerator )
//STRIP001 {
//STRIP001 	// init Timer
//STRIP001 	aTimer.SetTimeoutHdl( LINK( this, AboutDialog, TimerHdl ) );
//STRIP001 
//STRIP001 	// init scroll mode
//STRIP001 	nOff = GetOutputSizePixel().Height();
//STRIP001 	MapMode aMapMode( MAP_PIXEL, Point( 0, nOff ), Fraction( 1, 1 ), Fraction( 1, 1 ) );
//STRIP001 	SetMapMode( aMapMode );
//STRIP001 	bNormal = FALSE;
//STRIP001 
//STRIP001 	// start scroll Timer
//STRIP001 	aTimer.SetTimeout( 60 );
//STRIP001 	aTimer.Start();
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL AboutDialog::Close()
//STRIP001 {
//STRIP001 	// stop Timer and finish the dialog
//STRIP001 	aTimer.Stop();
//STRIP001 	EndDialog( RET_OK );
//STRIP001 	return( FALSE );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void AboutDialog::Paint( const Rectangle& rRect )
//STRIP001 {
//STRIP001 	if ( bNormal )
//STRIP001 	{
//STRIP001 		// not in scroll mode
//STRIP001 		DrawImage( Point(), aAppLogo );
//STRIP001 		return;
//STRIP001 	}
//STRIP001 
//STRIP001 	long nPos = 0;
//STRIP001 	long nW = GetOutputSizePixel().Width() / 2 - 5;
//STRIP001 	Size aSize = Size( GetTextWidth( aDevVersionStr ), GetTextHeight() );
//STRIP001 	USHORT nStartPos = 0;
//STRIP001 	USHORT nEndPos = 0;
//STRIP001 	Point aPnt( nW - ( aSize.Width() / 2 ), nPos );
//STRIP001 	long nPos1 = aPnt.Y(), nPos2 = nPos1 + aSize.Height(), nTop = rRect.Top();
//STRIP001 
//STRIP001 #if SUPD == 633
//STRIP001 	String aExtraText( DEFINE_CONST_UNICODE("Early Access 3") );
//STRIP001 	Size aExtraSize = Size( GetTextWidth( aExtraText ), GetTextHeight() );
//STRIP001 	long nDelta = aExtraSize.Height() + 3;
//STRIP001 	nPos2 += nDelta;
//STRIP001 #endif
//STRIP001 
//STRIP001 	if ( nPos1 <= nTop && nTop < nPos2 )
//STRIP001 	{
//STRIP001 		DrawText( aPnt, aDevVersionStr );
//STRIP001 #if SUPD == 633
//STRIP001 		aPnt.X() = nW - ( aExtraSize.Width() / 2 );
//STRIP001 		aPnt.Y() += nDelta;
//STRIP001 		nPos += nDelta;
//STRIP001 		DrawText( aPnt, aExtraText );
//STRIP001 #endif
//STRIP001 	}
//STRIP001 
//STRIP001 	nPos += aSize.Height() + 3;
//STRIP001 	USHORT nDevCnt = aDeveloperAry.Count();
//STRIP001 
//STRIP001 	if ( nDevCnt )
//STRIP001 	{
//STRIP001 		// use deactive color for some headers
//STRIP001 		Color aGrayColor = GetSettings().GetStyleSettings().GetDeactiveColor();
//STRIP001 
//STRIP001 		for ( USHORT i = 0; i < nDevCnt; ++i )
//STRIP001 		{
//STRIP001 			String aStr = aDeveloperAry.GetString(i);
//STRIP001 			long nVal = aDeveloperAry.GetValue(i);
//STRIP001 
//STRIP001 			if ( nVal )
//STRIP001 			{
//STRIP001 				// Versionsnummern gibt es nur in den fetten Zeilen
//STRIP001 				USHORT nProductVersion = (USHORT)ProductVersion::GetVersion().ToInt32();
//STRIP001 				String aVersion = String::CreateFromInt32( nProductVersion / 10 );
//STRIP001 				aVersion += '.';
//STRIP001 				aVersion += String::CreateFromInt32( nProductVersion % 10 );
//STRIP001 				USHORT nSPos = aStr.SearchAndReplaceAscii( "$(VER)", aVersion );
//STRIP001 				while ( STRING_NOTFOUND != nSPos )
//STRIP001 					nSPos = aStr.SearchAndReplaceAscii( "$(VER)", aVersion, nSPos );
//STRIP001 			}
//STRIP001 			aSize = Size( GetTextWidth( aStr ), GetTextHeight() );
//STRIP001 			aPnt = Point( nW - ( aSize.Width() / 2 ), nPos );
//STRIP001 			nPos1 = aPnt.Y();
//STRIP001 			nPos2 = nPos1 + aSize.Height();
//STRIP001 
//STRIP001 			if ( nPos1 <= nTop && nTop < nPos2 )
//STRIP001 			{
//STRIP001 				if ( nVal )
//STRIP001 				{
//STRIP001 					// emphasize the headers
//STRIP001 					Font aFont = GetFont();
//STRIP001 					FontWeight eOldWeight = aFont.GetWeight();
//STRIP001 					Color aOldCol = aFont.GetColor();
//STRIP001 					aFont.SetWeight( (FontWeight)nVal );
//STRIP001 					if ( aStr.GetChar(1) != ' ' && aStr.GetChar(aStr.Len()-2) != ' ' )
//STRIP001 						aFont.SetColor( aGrayColor );
//STRIP001 					SetFont( aFont );
//STRIP001 					long nOldW = aSize.Width();
//STRIP001 					aSize = Size(GetTextWidth( aStr ),GetTextHeight());
//STRIP001 					aPnt.X() -= ( aSize.Width() - nOldW ) / 2;
//STRIP001 					DrawText( aPnt, aStr );
//STRIP001 					aFont.SetWeight( eOldWeight );
//STRIP001 					aFont.SetColor( aOldCol );
//STRIP001 					SetFont( aFont );
//STRIP001 				}
//STRIP001 				else
//STRIP001 					DrawText( aPnt, aStr );
//STRIP001 			}
//STRIP001 			nPos += aSize.Height() + 3;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	nEnd = nPos - 4;
//STRIP001 }
//STRIP001 
}
