/*************************************************************************
 *
 *  $RCSfile: svx_confirmdelete.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 15:43:32 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc..
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #ifndef SVX_FORM_CONFIRMDELETE_HXX
// auto strip #include "confirmdelete.hxx"
// auto strip #endif

// auto strip #ifndef _SVX_DIALMGR_HXX 
// auto strip #include <dialmgr.hxx>
// auto strip #endif
#ifndef _SVX_FMHELP_HRC
#include "fmhelp.hrc"
#endif
#ifndef _SVX_FMRESIDS_HRC
#include "fmresids.hrc"
#endif
// auto strip #ifndef _UTL_CONFIGMGR_HXX_ 
// auto strip #include <unotools/configmgr.hxx>
// auto strip #endif
// auto strip #ifndef _SV_MSGBOX_HXX 
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
namespace binfilter {

//........................................................................
//STRIP001 namespace svxform
//STRIP001 {
//STRIP001 //........................................................................
//STRIP001 
//STRIP001 #define BORDER_HEIGHT	6 // default distance control-dialog
//STRIP001 #define BORDER_WIDTH	6 // default distance control-dialog
//STRIP001 
//STRIP001 	using namespace ::com::sun::star::uno;
//STRIP001 
//STRIP001 	//====================================================================
//STRIP001 	//= class ConfirmDeleteDialog
//STRIP001 	//====================================================================
//STRIP001 	//------------------------------------------------------------------------------
//STRIP001 	ConfirmDeleteDialog::ConfirmDeleteDialog(Window* pParent, const String& _rTitle)
//STRIP001 			  :ButtonDialog(pParent, WB_HORZ | WB_STDDIALOG)
//STRIP001 			  ,m_aInfoImage	(this)
//STRIP001 			  ,m_aTitle		(this, WB_WORDBREAK | WB_LEFT)
//STRIP001 			  ,m_aMessage	(this, WB_WORDBREAK | WB_LEFT)
//STRIP001 	{
//STRIP001 		String sMessage(SVX_RES(RID_STR_DELETECONFIRM));
//STRIP001 
//STRIP001 		// Changed as per BugID 79541 Branding/Configuration
//STRIP001 		::utl::ConfigManager* pMgr = ::utl::ConfigManager::GetConfigManager();
//STRIP001 		Any aProductName = pMgr->GetDirectConfigProperty(::utl::ConfigManager::PRODUCTNAME);
//STRIP001 		::rtl::OUString sProductName;
//STRIP001 		aProductName >>= sProductName;
//STRIP001 
//STRIP001 		String aTitle = sProductName;
//STRIP001 		aProductName = pMgr->GetDirectConfigProperty(::utl::ConfigManager::PRODUCTVERSION);
//STRIP001 		aProductName >>= sProductName;
//STRIP001 		aTitle.AppendAscii(" ");
//STRIP001 		aTitle += String(sProductName);
//STRIP001 		SetText(aTitle);
//STRIP001 
//STRIP001 		SetHelpId(HID_DLG_DBMSG);
//STRIP001 		SetSizePixel(LogicToPixel(Size(220, 30),MAP_APPFONT));
//STRIP001 
//STRIP001 		m_aInfoImage.SetPosSizePixel(LogicToPixel(Point(6, 6),MAP_APPFONT),
//STRIP001 								   LogicToPixel(Size(20, 20),MAP_APPFONT));
//STRIP001 		m_aInfoImage.Show();
//STRIP001 
//STRIP001 		m_aTitle.SetPosSizePixel(LogicToPixel(Point(45, 6),MAP_APPFONT),
//STRIP001 								 LogicToPixel(Size(169, 20),MAP_APPFONT));
//STRIP001 
//STRIP001 		Font  aFont = m_aTitle.GetFont();
//STRIP001 		aFont.SetWeight(WEIGHT_SEMIBOLD);
//STRIP001 		m_aTitle.SetFont(aFont);
//STRIP001 		m_aTitle.Show();
//STRIP001 
//STRIP001 		m_aMessage.SetPosSizePixel(LogicToPixel(Point(45, 29),MAP_APPFONT),
//STRIP001 								   LogicToPixel(Size(169, 1),MAP_APPFONT));
//STRIP001 		m_aMessage.Show();
//STRIP001 
//STRIP001 		// Image festlegen
//STRIP001 		m_aInfoImage.SetImage(WarningBox::GetStandardImage());
//STRIP001 
//STRIP001 		// Title setzen
//STRIP001 		m_aTitle.SetText(_rTitle);
//STRIP001 
//STRIP001 		// Ermitteln der Hoehe des Textfeldes und des Dialogs
//STRIP001 		Size aBorderSize = LogicToPixel(Size(BORDER_WIDTH, BORDER_HEIGHT),MAP_APPFONT);
//STRIP001 		Rectangle aDlgRect(GetPosPixel(),GetSizePixel());
//STRIP001 		Rectangle aMessageRect(m_aMessage.GetPosPixel(),m_aMessage.GetSizePixel());
//STRIP001 		Rectangle aTextRect =
//STRIP001 			GetTextRect(aMessageRect, sMessage, TEXT_DRAW_WORDBREAK | TEXT_DRAW_MULTILINE | TEXT_DRAW_LEFT);
//STRIP001 
//STRIP001 		long nHText	= aTextRect.Bottom() > aMessageRect.Bottom() ? aTextRect.Bottom() - aMessageRect.Bottom() : 0;
//STRIP001 
//STRIP001 		aDlgRect.Bottom() += nHText + 2 * aBorderSize.Height();
//STRIP001 		aMessageRect.Bottom() += nHText;
//STRIP001 
//STRIP001 		// Dialog anpassen
//STRIP001 		SetSizePixel(aDlgRect.GetSize());
//STRIP001 		SetPageSizePixel(aDlgRect.GetSize());
//STRIP001 
//STRIP001 		// Message Text anpassen und setzen
//STRIP001 		m_aMessage.SetSizePixel(aMessageRect.GetSize());
//STRIP001 		m_aMessage.SetText(sMessage);
//STRIP001 
//STRIP001 		// Buttons anlegen
//STRIP001 		sal_uInt16 nDefId = BUTTONID_NO;
//STRIP001 
//STRIP001 		AddButton(BUTTON_YES, BUTTONID_YES, 0);
//STRIP001 		AddButton(BUTTON_NO, BUTTONID_NO, BUTTONDIALOG_DEFBUTTON | BUTTONDIALOG_FOCUSBUTTON);
//STRIP001 	}
//STRIP001 
//STRIP001 	//------------------------------------------------------------------------------
//STRIP001 	ConfirmDeleteDialog::~ConfirmDeleteDialog()
//STRIP001 	{
//STRIP001 	}
//STRIP001 
//STRIP001 //........................................................................
//STRIP001 }	// namespace svxform
//........................................................................



}
