/*************************************************************************
 *
 *  $RCSfile: svx_optextbr.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:45:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#ifdef WNT
#include <tools/prewin.h>
#include <shellapi.h>
#include <tools/postwin.h>
#endif

#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif
#ifndef _SV_SOUND_HXX //autogen
#include <vcl/sound.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _SV_GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif
#ifndef _SFXSLSTITM_HXX //autogen
#include <svtools/slstitm.hxx>
#endif
#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif
#ifndef _SFXAPP_HXX //autogen
#include <bf_sfx2/app.hxx>
#endif
#ifndef _FILEDLGHELPER_HXX
#include <bf_sfx2/filedlghelper.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#pragma hdrstop

#define _SVSTDARR_STRINGS
#include <svtools/svstdarr.hxx>

#define _SVX_OPTEXTBR_CXX

#include "optextbr.hxx"
#include "dialmgr.hxx"

#include "optextbr.hrc"
#include "dialogs.hrc"
namespace binfilter {

// -----------------------------------------------------------------------

//STRIP001 const char* INIKEY_NO_WARNING 	= "NoExternBrowserWarning";
//STRIP001 const char* STAROFFICE_BROWSER	= "StarOffice";
//STRIP001 const char* IE_BROWSER			= "Internet Explorer";
//STRIP001 
//STRIP001 // class ExternBrowserQueryBox_Impl --------------------------------------
//STRIP001 
//STRIP001 class ExternBrowserQueryBox_Impl : public ModalDialog
//STRIP001 {
//STRIP001 private:
//STRIP001 	FixedImage		aImage;
//STRIP001 	FixedText		aWarningFT;
//STRIP001 	CheckBox		aDisableCB;
//STRIP001 	OKButton		aYesBtn;
//STRIP001 	CancelButton	aNoBtn;
//STRIP001 
//STRIP001 public:
//STRIP001 	ExternBrowserQueryBox_Impl( Window* pParent );
//STRIP001 
//STRIP001 	BOOL		IsWarningDisabled() const { return aDisableCB.IsChecked(); }
//STRIP001 };
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 ExternBrowserQueryBox_Impl::ExternBrowserQueryBox_Impl( Window* pParent ) :
//STRIP001 
//STRIP001 	ModalDialog( pParent, SVX_RES( RID_SVXDLG_OPT_EXTERN_BROWSER ) ),
//STRIP001 
//STRIP001 	aImage		( this, ResId( IMG_EXTBRW_WARNING ) ),
//STRIP001 	aWarningFT	( this, ResId( FT_EXTBRW_WARNING ) ),
//STRIP001 	aDisableCB	( this, ResId( CB_EXTBRW_DISABLE ) ),
//STRIP001 	aYesBtn		( this, ResId( BTN_EXTBRW_YES ) ),
//STRIP001 	aNoBtn		( this, ResId( BTN_EXTBRW_NO ) )
//STRIP001 
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aYesBtn.SetText( Button::GetStandardText( BUTTON_YES ) );
//STRIP001 	aNoBtn.SetText( Button::GetStandardText( BUTTON_NO ) );
//STRIP001 	aImage.SetImage( WarningBox::GetStandardImage() );
//STRIP001 }
//STRIP001 
//STRIP001 // class SvxExternBrowserTabPage -----------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SvxExternBrowserTabPage, CheckHdl_Impl, CheckBox *, pBox )
//STRIP001 {
//STRIP001 /*!!! (pb) obsolete
//STRIP001 	USHORT i;
//STRIP001 	FASTBOOL bOn = pCheckBox->IsChecked();
//STRIP001 	EnableControls();
//STRIP001 	String aNewText = aExceptionText;
//STRIP001 	if ( HAS_IE() )
//STRIP001 		aNewText.SearchAndReplaceAscii( "%1", bOn ? String::CreateFromAscii(STAROFFICE_BROWSER) : String::CreateFromAscii(IE_BROWSER) );
//STRIP001 	else
//STRIP001 	{
//STRIP001 		if ( bOn )
//STRIP001 			aNewText.SearchAndReplaceAscii( "%1", String::CreateFromAscii(STAROFFICE_BROWSER));
//STRIP001 		else
//STRIP001 			aNewText.SearchAndReplaceAscii( "%1", aExternBrowserText );
//STRIP001 	}
//STRIP001 	aExceptionFT.SetText( aNewText );
//STRIP001 
//STRIP001 	if ( !pBox )
//STRIP001 		return 0;
//STRIP001 
//STRIP001 	SvStrings* pList = new SvStrings;
//STRIP001 	for ( i = 0; i < aExceptionLB.GetEntryCount(); ++i )
//STRIP001 		pList->Insert( new String( aExceptionLB.GetEntry(i) ), i );
//STRIP001 
//STRIP001 	if ( bOn )
//STRIP001 	{
//STRIP001 		for ( i = 0; i < pOffExceptionList->Count(); ++i )
//STRIP001 			delete pOffExceptionList->GetObject(i);
//STRIP001 		delete pOffExceptionList;
//STRIP001 		pOffExceptionList = pList;
//STRIP001 		pList = pOnExceptionList;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		for ( i = 0; i < pOnExceptionList->Count(); ++i )
//STRIP001 			delete pOnExceptionList->GetObject(i);
//STRIP001 		delete pOnExceptionList;
//STRIP001 		pOnExceptionList = pList;
//STRIP001 		pList = pOffExceptionList;
//STRIP001 	}
//STRIP001 
//STRIP001 	aExceptionLB.Clear();
//STRIP001 
//STRIP001 	for ( i = 0; i < pList->Count(); ++i )
//STRIP001 		aExceptionLB.InsertEntry( *pList->GetObject(i) );
//STRIP001 	aExceptionED.SetText( String() );
//STRIP001 */
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SvxExternBrowserTabPage, ModifyHdl_Impl, Edit *, pEdit )
//STRIP001 {
//STRIP001 	String aTxt = pEdit->GetText().EraseLeadingChars().EraseTrailingChars();
//STRIP001 	aAddBtn.Enable( aTxt.Len() > 0 );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SvxExternBrowserTabPage, SelectHdl_Impl, ListBox *, pBox )
//STRIP001 {
//STRIP001 	aDeleteBtn.Enable( pBox->GetSelectEntryPos() != LISTBOX_ENTRY_NOTFOUND );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SvxExternBrowserTabPage, ClickHdl_Impl, PushButton *, pBtn )
//STRIP001 {
//STRIP001 	if ( !pBtn || pBtn == &aAddBtn )
//STRIP001 	{
//STRIP001 		TakeServerName();
//STRIP001 
//STRIP001 		if ( !pBtn )
//STRIP001 		{
//STRIP001 			// letzte "Anderung f"ur FillItemSet speichern
//STRIP001 			SvStrings* pList = new SvStrings;
//STRIP001 			USHORT i;
//STRIP001 
//STRIP001 			for ( i = 0; i < aExceptionLB.GetEntryCount(); ++i )
//STRIP001 				pList->Insert( new String( aExceptionLB.GetEntry(i) ), i );
//STRIP001 
//STRIP001 			if ( pCheckBox->IsChecked() )
//STRIP001 			{
//STRIP001 				for ( i = 0; i < pOnExceptionList->Count(); ++i )
//STRIP001 					delete pOnExceptionList->GetObject(i);
//STRIP001 				delete pOnExceptionList;
//STRIP001 				pOnExceptionList = pList;
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				for ( i = 0; i < pOffExceptionList->Count(); ++i )
//STRIP001 					delete pOffExceptionList->GetObject(i);
//STRIP001 				delete pOffExceptionList;
//STRIP001 				pOffExceptionList = pList;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		aExceptionED.SetText( String() );
//STRIP001 	}
//STRIP001 	else if ( pBtn == &aFileBtn )
//STRIP001 	{
//STRIP001     	sfx2::FileDialogHelper aDlg( ::sfx2::FILEOPEN_SIMPLE, 0 );
//STRIP001 
//STRIP001     	if ( aDlg.Execute() == ERRCODE_NONE )
//STRIP001 		{
//STRIP001 			aFileED.SetText( INetURLObject( aDlg.GetPath() ).getFSysPath( INetURLObject::FSYS_DETECT ) );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if ( pBtn == &aIEOptionsBtn )
//STRIP001 	{
//STRIP001 #ifdef WNT
//STRIP001 		ShellExecute( ::GetFocus(), NULL, "control.exe", "inetcpl.cpl", "", SW_SHOW );
//STRIP001 #endif
//STRIP001 		return 0;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		USHORT nPos = aExceptionLB.GetSelectEntryPos();
//STRIP001 
//STRIP001 		if ( nPos != LISTBOX_ENTRY_NOTFOUND )
//STRIP001 		{
//STRIP001 			aExceptionLB.RemoveEntry( nPos );
//STRIP001 			USHORT nCount = aExceptionLB.GetEntryCount();
//STRIP001 
//STRIP001 			if ( nCount )
//STRIP001 			{
//STRIP001 				if ( nPos > nCount - 1 )
//STRIP001 					nPos = nCount - 1;
//STRIP001 				aExceptionLB.SelectEntryPos( nPos );
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	ModifyHdl_Impl( &aExceptionED );
//STRIP001 	SelectHdl_Impl( &aExceptionLB );
//STRIP001 	EnableControls();
//STRIP001 	if ( pBtn == &aAddBtn )
//STRIP001 		aExceptionED.GrabFocus();
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SvxExternBrowserTabPage::TakeServerName()
//STRIP001 {
//STRIP001 	String aText = aExceptionED.GetText().EraseLeadingChars().EraseTrailingChars();
//STRIP001 
//STRIP001 	if ( !aText.Len() )
//STRIP001 		return;
//STRIP001 
//STRIP001 	aExceptionED.SetText( aText );
//STRIP001 	FASTBOOL bFound = FALSE;
//STRIP001 
//STRIP001 	for ( USHORT i = 0; i < aExceptionLB.GetEntryCount(); ++i )
//STRIP001 	{
//STRIP001 		if ( aExceptionLB.GetEntry(i) == aText )
//STRIP001 		{
//STRIP001 			bFound = TRUE;
//STRIP001 			break;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( !bFound )
//STRIP001 	{
//STRIP001 		aExceptionLB.InsertEntry( aText );
//STRIP001 		aExceptionED.SetSelection( Selection( 0, aExceptionED.GetText().Len() ) );
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SvxExternBrowserTabPage::EnableControls()
//STRIP001 {
//STRIP001 	if ( &aOnCB == pCheckBox )
//STRIP001 	{
//STRIP001 		BOOL bEnable = pCheckBox->IsChecked() || ( aExceptionLB.GetEntryCount() > 0 );
//STRIP001 		aIEOptionsBtn.Enable( bEnable );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aFileED.Enable( pCheckBox->IsChecked() );
//STRIP001 		aFileBtn.Enable( pCheckBox->IsChecked() );
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SvxExternBrowserTabPage::ActivatePage( const SfxItemSet& )
//STRIP001 {
//STRIP001 	BOOL bNoHint = TRUE /*!!!(BOOL)(USHORT)SFX_INIMANAGER()->Get( SFX_KEY_EXTBRW_NO_HINT ).ToInt32()*/;
//STRIP001 	aNoHintCB.Check( bNoHint );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 int SvxExternBrowserTabPage::DeactivatePage( SfxItemSet* pSet )
//STRIP001 {
//STRIP001 /*!!! (PB) obsolete
//STRIP001 	const SfxPoolItem* pItem;
//STRIP001 
//STRIP001 	if ( !bNoWarning && SFX_ITEM_SET == GetItemSet().GetItemState( SID_OPT_EXTBRW_ON, FALSE, &pItem ) )
//STRIP001 	{
//STRIP001 		DBG_ASSERT( pItem->ISA(SfxBoolItem), "SfxBoolItem erwartet" );
//STRIP001 		BOOL bCheck = pCheckBox->IsChecked();
//STRIP001 		SfxIniManager* pIniMgr = SFX_APP()->GetIniManager();
//STRIP001 		bNoWarning = (BOOL)(USHORT)pIniMgr->Get( SFX_GROUP_EXTBRW, INIKEY_NO_WARNING );
//STRIP001 
//STRIP001 		if ( !bNoWarning && bCheck && bCheck != ( (SfxBoolItem*)pItem )->GetValue() )
//STRIP001 		{
//STRIP001 			ExternBrowserQueryBox_Impl aQBox( this );
//STRIP001 			aQBox.SetText( GetText() );
//STRIP001 			short nRet = aQBox.Execute();
//STRIP001 
//STRIP001 			if ( aQBox.IsWarningDisabled() )
//STRIP001 				pIniMgr->Set( "1", SFX_GROUP_EXTBRW, INIKEY_NO_WARNING );
//STRIP001 
//STRIP001 			if ( RET_CANCEL == nRet )
//STRIP001 			{
//STRIP001 				pCheckBox->Check( FALSE );
//STRIP001 				CheckHdl_Impl( pCheckBox );
//STRIP001 				return KEEP_PAGE;
//STRIP001 			}
//STRIP001 			else
//STRIP001 				bNoWarning = TRUE;
//STRIP001 		}
//STRIP001 	}
//STRIP001 */
//STRIP001 	if ( pSet )
//STRIP001 		FillItemSet( *pSet );
//STRIP001 	return LEAVE_PAGE;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SvxExternBrowserTabPage::SvxExternBrowserTabPage( Window* pParent, const SfxItemSet& rSet ) :
//STRIP001 
//STRIP001 	SfxTabPage( pParent, SVX_RES( RID_SVXPAGE_OPT_EXTERN_BROWSER ), rSet ),
//STRIP001 
//STRIP001 	aOnCB				( this, ResId( CB_EXTBRW_ON ) ),
//STRIP001 	aFileCB				( this, ResId( CB_EXTBRW_FILE ) ),
//STRIP001 	aFileED				( this, ResId( ED_EXTBRW_FILE ) ),
//STRIP001 	aFileBtn			( this, ResId( PB_EXTBRW_FILE ) ),
//STRIP001 	aIEOptionsBtn		( this, ResId( PB_EXTBRW_IEOPTIONS ) ),
//STRIP001 	aExceptionFT		( this, ResId( FT_EXTBRW_EXCEPTION ) ),
//STRIP001 	aExceptionED		( this, ResId( ED_EXTBRW_EXCEPTION ) ),
//STRIP001 	aExceptionLB		( this, ResId( LB_EXTBRW_EXCEPTION ) ),
//STRIP001 	aAddBtn				( this, ResId( PB_EXTBRW_ADD ) ),
//STRIP001 	aDeleteBtn			( this, ResId( PB_EXTBRW_DELETE ) ),
//STRIP001 	aNoHintCB			( this, ResId( CB_EXTBRW_NOHINT ) ),
//STRIP001 	aExternBrowserText  ( 		ResId( STR_EXTBRW_FILE ) ),
//STRIP001 
//STRIP001 	bNoWarning			( FALSE ),
//STRIP001 	bOldNoHintValue		( FALSE ),
//STRIP001 	pOnExceptionList    ( NULL ),
//STRIP001 	pOffExceptionList   ( NULL )
//STRIP001 
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 	SetExchangeSupport(); // damit DeactivatePage() gerufen wird
//STRIP001 
//STRIP001 	aExceptionText = aExceptionFT.GetText();
//STRIP001 	Link aLink = LINK( this, SvxExternBrowserTabPage, CheckHdl_Impl );
//STRIP001 	aOnCB.SetClickHdl( aLink );
//STRIP001 	aFileCB.SetClickHdl( aLink );
//STRIP001 	aExceptionED.SetModifyHdl( LINK( this, SvxExternBrowserTabPage, ModifyHdl_Impl ) );
//STRIP001 	aExceptionLB.SetSelectHdl( LINK( this, SvxExternBrowserTabPage, SelectHdl_Impl ) );
//STRIP001 	aLink = LINK( this, SvxExternBrowserTabPage, ClickHdl_Impl );
//STRIP001 	aFileBtn.SetClickHdl( aLink );
//STRIP001 	aIEOptionsBtn.SetClickHdl( aLink );
//STRIP001 	aAddBtn.SetClickHdl( aLink );
//STRIP001 	aDeleteBtn.SetClickHdl( aLink );
//STRIP001 
//STRIP001 	if ( FALSE /*!!!HAS_IE()*/ )
//STRIP001 	{
//STRIP001 		aFileCB.Hide();
//STRIP001 		aFileED.Hide();
//STRIP001 		aFileBtn.Hide();
//STRIP001 		pCheckBox = &aOnCB;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aOnCB.Hide();
//STRIP001 		aIEOptionsBtn.Hide();
//STRIP001 		pCheckBox = &aFileCB;
//STRIP001 	}
//STRIP001 
//STRIP001 	ModifyHdl_Impl( &aExceptionED );
//STRIP001 	SelectHdl_Impl( &aExceptionLB );
//STRIP001 	bOldNoHintValue = FALSE /*!!!(BOOL)(USHORT)SFX_INIMANAGER()->Get( SFX_KEY_EXTBRW_NO_HINT ).ToInt32()*/;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SvxExternBrowserTabPage::~SvxExternBrowserTabPage()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxTabPage* SvxExternBrowserTabPage::Create( Window* pParent, const SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	return ( new SvxExternBrowserTabPage( pParent, rSet ) );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL SvxExternBrowserTabPage::FillItemSet( SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	// ggf. neuen Eintrag einf"ugen
//STRIP001 	ClickHdl_Impl( NULL );
//STRIP001 	BOOL bModified = FALSE, bTemp = FALSE;
//STRIP001 
//STRIP001 	// Vergleichen mit alter Liste
//STRIP001 	const SfxItemSet& rOldSet = GetItemSet();
//STRIP001 	const SfxPoolItem* pItem;
//STRIP001 
//STRIP001 	if ( SFX_ITEM_SET == rOldSet.GetItemState( SID_OPT_EXTBRW_ON_EXCEPTION, FALSE, &pItem ) )
//STRIP001 	{
//STRIP001 		DBG_ASSERT( pItem->ISA(SfxStringListItem), "SfxStringListItem erwartet" );
//STRIP001 		List* pList = ( (SfxStringListItem*)pItem )->GetList();
//STRIP001 
//STRIP001 		if ( pList )
//STRIP001 		{
//STRIP001 			ULONG nOldCount = pList->Count();
//STRIP001 
//STRIP001 			if ( nOldCount != pOnExceptionList->Count() )
//STRIP001 				bTemp = TRUE;
//STRIP001 
//STRIP001 			for ( USHORT i = 0; i < nOldCount && !bTemp; ++i )
//STRIP001 			{
//STRIP001 				const String* pNew = pOnExceptionList->GetObject(i);
//STRIP001 				const String* pOld = (String*)pList->GetObject(i);
//STRIP001 
//STRIP001 				if ( *pNew != *pOld )
//STRIP001 					bTemp = TRUE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( bTemp )
//STRIP001 	{
//STRIP001 		List aList;
//STRIP001 		for ( USHORT i = 0; i < pOnExceptionList->Count(); ++i )
//STRIP001 			aList.Insert( pOnExceptionList->GetObject(i), LIST_APPEND );
//STRIP001 		rSet.Put( SfxStringListItem( SID_OPT_EXTBRW_ON_EXCEPTION, &aList ) );
//STRIP001 		bModified = TRUE;
//STRIP001 		bTemp = FALSE;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		rSet.ClearItem( SID_OPT_EXTBRW_ON_EXCEPTION );
//STRIP001 
//STRIP001 	if ( SFX_ITEM_SET == rOldSet.GetItemState( SID_OPT_EXTBRW_OFF_EXCEPTION, FALSE, &pItem ) )
//STRIP001 	{
//STRIP001 		DBG_ASSERT( pItem->ISA(SfxStringListItem), "SfxStringListItem erwartet" );
//STRIP001 		List* pList = ( (SfxStringListItem*)pItem )->GetList();
//STRIP001 
//STRIP001 		if ( pList )
//STRIP001 		{
//STRIP001 			ULONG nOldCount = pList->Count();
//STRIP001 
//STRIP001 			if ( nOldCount != pOffExceptionList->Count() )
//STRIP001 				bTemp = TRUE;
//STRIP001 
//STRIP001 			for ( USHORT i = 0; i < nOldCount && !bTemp; ++i )
//STRIP001 			{
//STRIP001 				const String* pNew = pOffExceptionList->GetObject(i);
//STRIP001 				const String* pOld = (String*)pList->GetObject(i);
//STRIP001 
//STRIP001 				if ( *pNew != *pOld )
//STRIP001 					bTemp = TRUE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( bTemp )
//STRIP001 	{
//STRIP001 		List aList;
//STRIP001 		for ( USHORT i = 0; i < pOffExceptionList->Count(); ++i )
//STRIP001 			aList.Insert( pOffExceptionList->GetObject(i), LIST_APPEND );
//STRIP001 		rSet.Put( SfxStringListItem( SID_OPT_EXTBRW_OFF_EXCEPTION, &aList ) );
//STRIP001 		bModified = TRUE;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		rSet.ClearItem( SID_OPT_EXTBRW_OFF_EXCEPTION );
//STRIP001 
//STRIP001 	if ( SFX_ITEM_SET == rOldSet.GetItemState( SID_OPT_EXTBRW_ON, FALSE, &pItem ) )
//STRIP001 	{
//STRIP001 		DBG_ASSERT( pItem->ISA(SfxBoolItem), "SfxBoolItem erwartet" );
//STRIP001 
//STRIP001 		if ( pCheckBox->IsChecked() != ( (SfxBoolItem*)pItem )->GetValue() )
//STRIP001 		{
//STRIP001 			rSet.Put( SfxBoolItem( SID_OPT_EXTBRW_ON, pCheckBox->IsChecked() ) );
//STRIP001 			bModified = TRUE;
//STRIP001 		}
//STRIP001 		else
//STRIP001 			rSet.ClearItem( SID_OPT_EXTBRW_ON );
//STRIP001 	}
//STRIP001 /*!!! (pb) obsolete
//STRIP001 	SfxIniManager* pIniMgr = SFX_INIMANAGER();
//STRIP001 	if ( aFileED.IsReallyVisible() && aFileED.IsEnabled() )
//STRIP001 	{
//STRIP001 		XubString aExtBrwFile = pIniMgr->Get( SFX_KEY_EXTBRW_FILE );
//STRIP001 		XubString aNewFile = aFileED.GetText();
//STRIP001 		if ( aNewFile != aExtBrwFile )
//STRIP001 		{
//STRIP001 			pIniMgr->Set( aNewFile, SFX_KEY_EXTBRW_FILE );
//STRIP001 			bModified = TRUE;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	pIniMgr->Set( aNoHintCB.IsChecked() ? String('1') : String('0'), SFX_KEY_EXTBRW_NO_HINT );
//STRIP001 */
//STRIP001 	return bModified;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SvxExternBrowserTabPage::Reset( const SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	const SfxPoolItem* pItem;
//STRIP001 	USHORT i;
//STRIP001 
//STRIP001 	if ( SFX_ITEM_SET == rSet.GetItemState(SID_OPT_EXTBRW_ON_EXCEPTION, FALSE, &pItem) )
//STRIP001 	{
//STRIP001 		DBG_ASSERT( pItem->ISA(SfxStringListItem), "StringListItem erwartet" );
//STRIP001 		List* pList = ( (SfxStringListItem*)pItem )->GetList();
//STRIP001 
//STRIP001 		for ( i = 0; pOnExceptionList && i < pOnExceptionList->Count(); ++i )
//STRIP001 			delete pOnExceptionList->GetObject(i);
//STRIP001 		delete pOnExceptionList;
//STRIP001 		pOnExceptionList = new SvStrings;
//STRIP001 		ULONG nCount = pList ? pList->Count() : 0;
//STRIP001 
//STRIP001 		for ( i = 0; i < nCount; i++ )
//STRIP001 		{
//STRIP001 #if OSL_DEBUG_LEVEL > 1
//STRIP001 			const String* pStr = (String*)pList->GetObject(i);
//STRIP001 #endif
//STRIP001 			pOnExceptionList->Insert( new String( *(String*)pList->GetObject(i) ), i );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( SFX_ITEM_SET == rSet.GetItemState(SID_OPT_EXTBRW_OFF_EXCEPTION, FALSE, &pItem) )
//STRIP001 	{
//STRIP001 		DBG_ASSERT( pItem->ISA(SfxStringListItem), "StringListItem erwartet" );
//STRIP001 		List* pList = ( (SfxStringListItem*)pItem )->GetList();
//STRIP001 
//STRIP001 		for ( i = 0; pOffExceptionList && i < pOffExceptionList->Count(); ++i )
//STRIP001 			delete pOffExceptionList->GetObject(i);
//STRIP001 		delete pOffExceptionList;
//STRIP001 		pOffExceptionList = new SvStrings;
//STRIP001 		ULONG nCount = pList ? pList->Count() : 0;
//STRIP001 
//STRIP001 		for ( i = 0; i < nCount; i++ )
//STRIP001 		{
//STRIP001 #if OSL_DEBUG_LEVEL > 1
//STRIP001 			const String* pStr = (String*)pList->GetObject(i);
//STRIP001 #endif
//STRIP001 			pOffExceptionList->Insert( new String( *(String*)pList->GetObject(i) ), i );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	String aExtBrwFile /*!!!= SFX_INIMANAGER()->Get( SFX_KEY_EXTBRW_FILE )*/;
//STRIP001 	aFileED.SetText( aExtBrwFile );
//STRIP001 	BOOL bOn = FALSE;
//STRIP001 
//STRIP001 	if ( SFX_ITEM_SET == rSet.GetItemState(SID_OPT_EXTBRW_ON, FALSE, &pItem) )
//STRIP001 	{
//STRIP001 		DBG_ASSERT( pItem->ISA(SfxBoolItem), "BoolItem erwartet" );
//STRIP001 		bOn = ( (SfxBoolItem*)pItem )->GetValue();
//STRIP001 	}
//STRIP001 
//STRIP001 	pCheckBox->Check( bOn );
//STRIP001 	EnableControls();
//STRIP001 	String aNewText = aExceptionText;
//STRIP001 	aNewText.SearchAndReplaceAscii( "%1", bOn ? String::CreateFromAscii(STAROFFICE_BROWSER) : String::CreateFromAscii(IE_BROWSER) );
//STRIP001 	aExceptionFT.SetText( aNewText );
//STRIP001 	SvStrings* pExcptList = bOn ? pOnExceptionList : pOffExceptionList;
//STRIP001 
//STRIP001 	for ( i = 0; i < pExcptList->Count(); ++i )
//STRIP001 		aExceptionLB.InsertEntry( *pExcptList->GetObject(i) );
//STRIP001 
//STRIP001 	aNoHintCB.Check( bOldNoHintValue );
//STRIP001 	CheckHdl_Impl( NULL );
//STRIP001 }


}
