/*************************************************************************
 *
 *  $RCSfile: svx_optsave.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:45:48 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#ifndef _SHL_HXX
#include <tools/shl.hxx>
#endif
#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif
#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif
#pragma hdrstop

#define _SVX_OPTSAVE_CXX

#include "optsave.hrc"
#include "dialogs.hrc"

#include "optsave.hxx"
#include "dialmgr.hxx"

#ifndef _COMPHELPER_PROCESSFACTORY_HXX_
#include <comphelper/processfactory.hxx>
#endif
#ifndef INCLUDED_SVTOOLS_MODULEOPTIONS_HXX
#include <svtools/moduleoptions.hxx>
#endif
#ifndef INCLUDED_SVTOOLS_SAVEOPT_HXX
#include <svtools/saveopt.hxx>
#endif
#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XNAMECONTAINER_HPP_
#include <com/sun/star/container/XNameContainer.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP_
#include <com/sun/star/beans/PropertyValue.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XFLUSHABLE_HPP_
#include <com/sun/star/util/XFlushable.hpp>
#endif
#ifndef _SFX_DOCFILT_HACK_HXX
#include <bf_sfx2/docfilt.hxx>
#endif
#ifndef _STDCTRL_HXX
#include <svtools/stdctrl.hxx>
#endif
#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif
#ifndef _UTL_CONFIGITEM_HXX_
#include <unotools/configitem.hxx>
#endif
#ifndef _LEGACYBINFILTERMGR_HXX
#include <legacysmgr/legacy_binfilters_smgr.hxx>	//STRIP002 
#endif
namespace binfilter {

using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::util;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::beans;
using namespace ::com::sun::star::container;
using namespace rtl;

//STRIP001 #define C2U(cChar) OUString::createFromAscii(cChar)
//STRIP001 // -------------------- --------------------------------------------------
//STRIP001 class FilterWarningDialog_Impl : public ModalDialog
//STRIP001 {
//STRIP001     OKButton        aOk;
//STRIP001     CancelButton    aCancel;
//STRIP001     FixedImage      aImage;
//STRIP001     FixedInfo       aFilterWarningFT;
//STRIP001 //    CheckBox        aDontShowAgainCB;
//STRIP001 
//STRIP001     public:
//STRIP001         FilterWarningDialog_Impl(Window* pParent);
//STRIP001 
//STRIP001         void        SetFilterName(const String& rFilterUIName);
//STRIP001 //        sal_Bool    IsCheckBoxSet() {return aDontShowAgainCB.IsChecked();}
//STRIP001 };
//STRIP001 // ----------------------------------------------------------------------
//STRIP001 FilterWarningDialog_Impl::FilterWarningDialog_Impl(Window* pParent) :
//STRIP001     ModalDialog(pParent, SVX_RES( RID_SVXDLG_FILTER_WARNING ) ),
//STRIP001     aOk(                this, ResId(PB_OK               )),
//STRIP001     aCancel(            this, ResId(PB_CANCEL           )),
//STRIP001     aImage(             this, ResId(IMG_WARNING         )),
//STRIP001     aFilterWarningFT(   this, ResId(FT_FILTER_WARNING   ))
//STRIP001 //    ,aDontShowAgainCB(   this, ResId(CB_DONT_SHOW_AGAIN  ))
//STRIP001 {
//STRIP001     FreeResource();
//STRIP001     aImage.SetImage(WarningBox::GetStandardImage());
//STRIP001 }
//STRIP001 // ----------------------------------------------------------------------
//STRIP001 void    FilterWarningDialog_Impl::SetFilterName(const String& rFilterUIName)
//STRIP001 {
//STRIP001     String sTmp(aFilterWarningFT.GetText());
//STRIP001 	sTmp.SearchAndReplaceAscii("%1", rFilterUIName);
//STRIP001 	aFilterWarningFT.SetText(sTmp);
//STRIP001 }
//STRIP001 // ----------------------------------------------------------------------
//STRIP001 #ifdef FILTER_WARNING_ENABLED
//STRIP001 class SvxAlienFilterWarningConfig_Impl : public utl::ConfigItem
//STRIP001 {
//STRIP001     sal_Bool bWarning;
//STRIP001 	::com::sun::star::uno::Sequence<rtl::OUString> aPropNames;
//STRIP001 
//STRIP001 	public:
//STRIP001         SvxAlienFilterWarningConfig_Impl();
//STRIP001         ~SvxAlienFilterWarningConfig_Impl();
//STRIP001 
//STRIP001 	virtual void			::com::mit();
//STRIP001 
//STRIP001     void                    ResetWarning()
//STRIP001                             {
//STRIP001                                 if(bWarning)
//STRIP001                                 {
//STRIP001                                     bWarning = sal_False;
//STRIP001                                     ConfigItem::SetModified();
//STRIP001                                 }
//STRIP001 
//STRIP001                             }
//STRIP001     sal_Bool                IsWarning()const{return bWarning;}
//STRIP001 };
//STRIP001 // ----------------------------------------------------------------------
//STRIP001 SvxAlienFilterWarningConfig_Impl::SvxAlienFilterWarningConfig_Impl() :
//STRIP001     ConfigItem(C2U("Office.TypeDetection/Defaults"),
//STRIP001         CONFIG_MODE_IMMEDIATE_UPDATE),
//STRIP001     aPropNames(1),
//STRIP001     bWarning(sal_True)
//STRIP001 {
//STRIP001     aPropNames.getArray()[0] = C2U("ShowAlienFilterWarning");
//STRIP001     Sequence<Any> aValues = GetProperties(aPropNames);
//STRIP001 	const Any* pValues = aValues.getConstArray();
//STRIP001 	DBG_ASSERT(aValues.getLength() == aPropNames.getLength(), "GetProperties failed")
//STRIP001     if(aValues.getLength() == aPropNames.getLength() &&
//STRIP001         pValues[0].hasValue() &&
//STRIP001             pValues[0].getValueType() == ::getBooleanCppuType())
//STRIP001         bWarning = *(sal_Bool*)pValues[0].getValue();
//STRIP001 }
//STRIP001 // ----------------------------------------------------------------------
//STRIP001 SvxAlienFilterWarningConfig_Impl::~SvxAlienFilterWarningConfig_Impl()
//STRIP001 {
//STRIP001     if(IsModified())
//STRIP001         Commit();
//STRIP001 }
//STRIP001 // ----------------------------------------------------------------------
//STRIP001 void SvxAlienFilterWarningConfig_Impl::Commit()
//STRIP001 {
//STRIP001 	Sequence<Any> aValues(aPropNames.getLength());
//STRIP001 	Any* pValues = aValues.getArray();
//STRIP001     pValues[0].setValue(&bWarning, ::getBooleanCppuType());
//STRIP001 	PutProperties(aPropNames, aValues);
//STRIP001 }
//STRIP001 #endif FILTER_WARNING_ENABLED
//STRIP001 // ----------------------------------------------------------------------
//STRIP001 // ----------------------------------------------------------------------
//STRIP001 
//STRIP001 struct SvxSaveTabPage_Impl
//STRIP001 {
//STRIP001     Reference<XNameContainer>   xFact;
//STRIP001     Sequence<OUString>          aFilterArr[APP_COUNT];
//STRIP001     Sequence<OUString>          aUIFilterArr[APP_COUNT];
//STRIP001 	CheckBox*					m_pNoPrettyPrinting;
//STRIP001     int                         aDefaultIdxArr[APP_COUNT];
//STRIP001 	sal_Bool					bInitialized;
//STRIP001 
//STRIP001     SvxSaveTabPage_Impl();
//STRIP001 	~SvxSaveTabPage_Impl();
//STRIP001 };
//STRIP001 
//STRIP001 SvxSaveTabPage_Impl::SvxSaveTabPage_Impl()
//STRIP001 	:m_pNoPrettyPrinting( NULL )
//STRIP001 	,bInitialized( sal_False )
//STRIP001 {
//STRIP001 	for (int i = 0; i < APP_COUNT; ++i)
//STRIP001 		aDefaultIdxArr[i] = 0;
//STRIP001 }
//STRIP001 
//STRIP001 SvxSaveTabPage_Impl::~SvxSaveTabPage_Impl()
//STRIP001 {
//STRIP001 	delete m_pNoPrettyPrinting;
//STRIP001 }
//STRIP001 
//STRIP001 // class SvxSaveTabPage --------------------------------------------------
//STRIP001 
//STRIP001 SfxSaveTabPage::SfxSaveTabPage( Window* pParent, const SfxItemSet& rCoreSet ) :
//STRIP001 
//STRIP001 	SfxTabPage( pParent, SVX_RES( RID_SFXPAGE_SAVE ), rCoreSet ),
//STRIP001     aLoadFL(              this, ResId(  LB_LOAD         ) ),
//STRIP001     aLoadUserSettingsCB(  this, ResId(  CB_LOAD_SETTINGS) ),
//STRIP001 	aSaveBox			( this,	ResId( GB_SAVE ) ),
//STRIP001 	aDocInfoBtn			( this, ResId( BTN_DOCINFO ) ),
//STRIP001 	aBackupBtn			( this,	ResId( BTN_BACKUP ) ),
//STRIP001 	aAutoSaveBtn		( this,	ResId( BTN_AUTOSAVE ) ),
//STRIP001 	aAutoSaveEdit		( this,	ResId( ED_AUTOSAVE ) ),
//STRIP001 	aMinuteText			( this,	ResId( FT_MINUTE ) ),
//STRIP001 	aAutoSavePromptBtn	( this,	ResId( BTN_AUTOSAVEPROMPT ) ),
//STRIP001     aRelBox             ( this, ResId( GB_RELATIVE ) ),
//STRIP001 	aRelFsysBtn			( this, ResId( BTN_RELATIVE_FSYS ) ),
//STRIP001     aRelInetBtn         ( this, ResId( BTN_RELATIVE_INET ) ),
//STRIP001     aFilterFL           ( this, ResId( FL_FILTER ) ),
//STRIP001     aApplicationFT      ( this, ResId( FT_APP   ) ),
//STRIP001     aApplicationLB      ( this, ResId( LB_APP    ) ),
//STRIP001     aFiltersFT          ( this, ResId( FT_FILTER ) ),
//STRIP001     aFiltersLB          ( this, ResId( LB_FILTER ) ),
//STRIP001     pImpl(0)
//STRIP001 {
//STRIP001 	pImpl = new SvxSaveTabPage_Impl;
//STRIP001 	pImpl->m_pNoPrettyPrinting = new CheckBox( this, ResId( BTN_NOPRETTYPRINTING ) );
//STRIP001 
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	// correct the z-order for the no-pretty-printing checkbox
//STRIP001 	Window* pNewPrev = &aAutoSavePromptBtn;
//STRIP001 	Window* pNewNext = pNewPrev->GetWindow( WINDOW_NEXT );
//STRIP001 	pImpl->m_pNoPrettyPrinting->SetZOrder( pNewNext, WINDOW_ZORDER_BEFOR );
//STRIP001 	pNewPrev->SetZOrder( pImpl->m_pNoPrettyPrinting, WINDOW_ZORDER_BEFOR );
//STRIP001 
//STRIP001 	Link aLink = LINK( this, SfxSaveTabPage, AutoClickHdl_Impl );
//STRIP001 	aAutoSaveBtn.SetClickHdl( aLink );
//STRIP001 	aAutoSaveEdit.SetMaxTextLen( 2 );
//STRIP001 
//STRIP001     SvtModuleOptions aModuleOpt;
//STRIP001     if ( !aModuleOpt.IsMath() )
//STRIP001         aFiltersLB.RemoveEntry(aFiltersLB.GetEntryPos( (void*) APP_MATH ));
//STRIP001     if ( !aModuleOpt.IsDraw() )
//STRIP001         aFiltersLB.RemoveEntry(aFiltersLB.GetEntryPos( (void*) APP_DRAW ));
//STRIP001     if ( !aModuleOpt.IsImpress() )
//STRIP001         aFiltersLB.RemoveEntry(aFiltersLB.GetEntryPos( (void*) APP_IMPRESS ));
//STRIP001     if ( !aModuleOpt.IsCalc() )
//STRIP001         aFiltersLB.RemoveEntry(aFiltersLB.GetEntryPos( (void*) APP_CALC ));
//STRIP001     if ( !aModuleOpt.IsWriter() )
//STRIP001     {
//STRIP001         aFiltersLB.RemoveEntry(aFiltersLB.GetEntryPos( (void*) APP_WRITER ));
//STRIP001         aFiltersLB.RemoveEntry(aFiltersLB.GetEntryPos( (void*) APP_WRITER_WEB ));
//STRIP001     }
//STRIP001 
//STRIP001     Link aLk = LINK(this, SfxSaveTabPage, FilterHdl_Impl);
//STRIP001     aApplicationLB.SetSelectHdl(aLk);
//STRIP001     aFiltersLB.SetSelectHdl(aLk);
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxSaveTabPage::~SfxSaveTabPage()
//STRIP001 {
//STRIP001     delete pImpl;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxTabPage*	SfxSaveTabPage::Create( Window* pParent,
//STRIP001 									const SfxItemSet& rAttrSet )
//STRIP001 {
//STRIP001 	return ( new SfxSaveTabPage( pParent, rAttrSet ) );
//STRIP001 }
//STRIP001 
//STRIP001 /* -----------------------------05.04.01 13:10--------------------------------
//STRIP001 
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 OUString lcl_ExtractUIName(const Sequence<PropertyValue> rProperties)
//STRIP001 {
//STRIP001     OUString sRet;
//STRIP001     const PropertyValue* pProperties = rProperties.getConstArray();
//STRIP001     for(int nProp = 0; nProp < rProperties.getLength(); nProp++)
//STRIP001     {
//STRIP001         if(!pProperties[nProp].Name.compareToAscii("UIName"))
//STRIP001         {
//STRIP001             pProperties[nProp].Value >>= sRet;
//STRIP001             break;
//STRIP001         }
//STRIP001     }
//STRIP001     return sRet;
//STRIP001 }
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 sal_Bool SfxSaveTabPage::SetDefaultFilter_Impl(Sequence<PropertyValue>& rProperties,
//STRIP001         sal_Bool bSet/*, sal_Bool& bShowWarning*/)
//STRIP001 {
//STRIP001     BOOL bRet = TRUE;
//STRIP001     PropertyValue* pProperties = rProperties.getArray();
//STRIP001     for(int nProp = 0; nProp < rProperties.getLength(); nProp++)
//STRIP001     {
//STRIP001         if(!pProperties[nProp].Name.compareToAscii("Flags"))
//STRIP001         {
//STRIP001             sal_Int32 nFlags; pProperties[nProp].Value >>= nFlags;
//STRIP001             if(bSet)
//STRIP001                 nFlags |= SFX_FILTER_DEFAULT;
//STRIP001             else
//STRIP001                 nFlags &= ~SFX_FILTER_DEFAULT;
//STRIP001             if(/*bShowWarning & */bSet && (nFlags & SFX_FILTER_ALIEN))
//STRIP001             {
//STRIP001                 FilterWarningDialog_Impl aDlg(this);
//STRIP001                 aDlg.SetFilterName(lcl_ExtractUIName(rProperties));
//STRIP001                 if(RET_OK != aDlg.Execute())
//STRIP001                     bRet = FALSE;
//STRIP001 //                if(aDlg.IsCheckBoxSet())
//STRIP001 //                    bShowWarning = sal_False;
//STRIP001             }
//STRIP001             if(bRet)
//STRIP001                 pProperties[nProp].Value <<= nFlags;
//STRIP001             return bRet;
//STRIP001         }
//STRIP001     }
//STRIP001     DBG_ERROR("Property not found");
//STRIP001     return bRet;
//STRIP001 }
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 BOOL SfxSaveTabPage::FillItemSet( SfxItemSet& rSet )
//STRIP001 {
//STRIP001     if(aLoadUserSettingsCB.IsChecked() != aLoadUserSettingsCB.GetSavedValue())
//STRIP001     {
//STRIP001         SvtSaveOptions aSaveOpt;
//STRIP001         aSaveOpt.SetLoadUserSettings(aLoadUserSettingsCB.IsChecked());
//STRIP001     }
//STRIP001 
//STRIP001     BOOL bModified = FALSE;
//STRIP001 
//STRIP001 	if ( aDocInfoBtn.IsChecked() != aDocInfoBtn.GetSavedValue() )
//STRIP001 	{
//STRIP001 		rSet.Put( SfxBoolItem( GetWhich( SID_ATTR_DOCINFO ),
//STRIP001 							   aDocInfoBtn.IsChecked() ) );
//STRIP001 		bModified |= TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001     if ( aBackupBtn.IsEnabled() && aBackupBtn.IsChecked() != aBackupBtn.GetSavedValue() )
//STRIP001 	{
//STRIP001 		rSet.Put( SfxBoolItem( GetWhich( SID_ATTR_BACKUP ),
//STRIP001 							   aBackupBtn.IsChecked() ) );
//STRIP001 		bModified |= TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( pImpl->m_pNoPrettyPrinting->IsChecked() != pImpl->m_pNoPrettyPrinting->GetSavedValue() )
//STRIP001 	{
//STRIP001 		rSet.Put( SfxBoolItem( GetWhich( SID_ATTR_PRETTYPRINTING ), !pImpl->m_pNoPrettyPrinting->IsChecked() ) );
//STRIP001 		bModified |= TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( aAutoSaveBtn.IsChecked() != aAutoSaveBtn.GetSavedValue() )
//STRIP001 	{
//STRIP001 		rSet.Put( SfxBoolItem( GetWhich( SID_ATTR_AUTOSAVE ),
//STRIP001 							   aAutoSaveBtn.IsChecked() ) );
//STRIP001 		bModified |= TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( aAutoSavePromptBtn.IsChecked() != aAutoSavePromptBtn.GetSavedValue() )
//STRIP001 	{
//STRIP001 		rSet.Put( SfxBoolItem( GetWhich( SID_ATTR_AUTOSAVEPROMPT ),
//STRIP001 							   aAutoSavePromptBtn.IsChecked() ) );
//STRIP001 		bModified |= TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( aAutoSaveEdit.GetText() != aAutoSaveEdit.GetSavedValue() )
//STRIP001 	{
//STRIP001 		rSet.Put( SfxUInt16Item( GetWhich( SID_ATTR_AUTOSAVEMINUTE ),
//STRIP001 								 (UINT16)aAutoSaveEdit.GetValue() ) );
//STRIP001 		bModified |= TRUE;
//STRIP001 	}
//STRIP001 	// relativ speichern
//STRIP001 	if ( aRelFsysBtn.IsChecked() != aRelFsysBtn.GetSavedValue() )
//STRIP001 	{
//STRIP001 		rSet.Put( SfxBoolItem( GetWhich( SID_SAVEREL_FSYS ),
//STRIP001 							   aRelFsysBtn.IsChecked() ) );
//STRIP001 		bModified |= TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( aRelInetBtn.IsChecked() != aRelInetBtn.GetSavedValue() )
//STRIP001 	{
//STRIP001 		rSet.Put( SfxBoolItem( GetWhich( SID_SAVEREL_INET ),
//STRIP001 							   aRelInetBtn.IsChecked() ) );
//STRIP001 		bModified |= TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001     if(pImpl->xFact.is())
//STRIP001     {
//STRIP001         sal_Bool bFlush = sal_False;
//STRIP001 //        SvxAlienFilterWarningConfig_Impl aWarningConfig;
//STRIP001         for(int n = 0; n < aApplicationLB.GetEntryCount() && n < APP_COUNT; n++)
//STRIP001         {
//STRIP001             if(pImpl->aDefaultIdxArr[n])
//STRIP001             {
//STRIP001                 bFlush = sal_True;
//STRIP001                 OUString sOldFilter = pImpl->aFilterArr[n].getConstArray()[0];
//STRIP001                 OUString sNewFilter = pImpl->aFilterArr[n].getConstArray()[pImpl->aDefaultIdxArr[n]];
//STRIP001 
//STRIP001                 Sequence<PropertyValue> aOldProperties;
//STRIP001                 Sequence<PropertyValue> aNewProperties;
//STRIP001                 Any aOldProps;
//STRIP001                 aOldProps = pImpl->xFact->getByName(sOldFilter);
//STRIP001                 aOldProps >>= aOldProperties;
//STRIP001 
//STRIP001                 Any aNewProps;
//STRIP001                 aNewProps = pImpl->xFact->getByName(sNewFilter);
//STRIP001                 aNewProps >>= aNewProperties;
//STRIP001 //                sal_Bool bWarning = aWarningConfig.IsWarning();
//STRIP001                 SetDefaultFilter_Impl(aOldProperties, sal_False/*, bWarning*/);
//STRIP001                 if(SetDefaultFilter_Impl(aNewProperties, sal_True/*, bWarning*/))
//STRIP001                 {
//STRIP001                     aOldProps <<= aOldProperties;
//STRIP001                     pImpl->xFact->replaceByName(sOldFilter, aOldProps);
//STRIP001                     aNewProps <<= aNewProperties;
//STRIP001                     pImpl->xFact->replaceByName(sNewFilter, aNewProps);
//STRIP001                 }
//STRIP001 //                if(!bWarning)
//STRIP001 //                    aWarningConfig.ResetWarning();
//STRIP001             }
//STRIP001         }
//STRIP001         Reference<XFlushable> xFlush(pImpl->xFact, UNO_QUERY);
//STRIP001         if(xFlush.is())
//STRIP001             xFlush->flush();
//STRIP001     }
//STRIP001 
//STRIP001     return bModified;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SfxSaveTabPage::Reset( const SfxItemSet& rSet )
//STRIP001 {
//STRIP001     SvtSaveOptions aSaveOpt;
//STRIP001     aLoadUserSettingsCB.Check(aSaveOpt.IsLoadUserSettings());
//STRIP001     aLoadUserSettingsCB.SaveValue();
//STRIP001 
//STRIP001     if ( !pImpl->bInitialized )
//STRIP001     {
//STRIP001         try
//STRIP001         {
//STRIP001             Reference< XMultiServiceFactory > xMSF = ::legacy_binfilters::getLegacyProcessServiceFactory();
//STRIP001             pImpl->xFact = Reference<XNameContainer>(
//STRIP001                     xMSF->createInstance(C2U("com.sun.star.document.FilterFactory")), UNO_QUERY);
//STRIP001 
//STRIP001             DBG_ASSERT(pImpl->xFact.is(), "service com.sun.star.document.FilterFactory unavailable")
//STRIP001             if(pImpl->xFact.is())
//STRIP001             {
//STRIP001                 for(int n = 0; n < aApplicationLB.GetEntryCount(); n++)
//STRIP001                 {
//STRIP001                     long nData = (long) aApplicationLB.GetEntryData(n);
//STRIP001                     OUString sCommand;
//STRIP001                     sCommand = C2U("_query_%1:iflags=");
//STRIP001                     sCommand += String::CreateFromInt32(SFX_FILTER_IMPORT|SFX_FILTER_EXPORT);
//STRIP001                     sCommand += C2U(":eflags=");
//STRIP001                     sCommand += String::CreateFromInt32(SFX_FILTER_NOTINFILEDLG);
//STRIP001                     sCommand += C2U(":default_first");
//STRIP001                     String sReplace;
//STRIP001                     switch(nData)
//STRIP001                     {
//STRIP001                         case  APP_WRITER     : sReplace = C2U("writer");  break;
//STRIP001                         case  APP_WRITER_WEB : sReplace = C2U("web");   break;
//STRIP001                         case  APP_CALC       : sReplace = C2U("calc");break;
//STRIP001                         case  APP_IMPRESS    : sReplace = C2U("impress");break;
//STRIP001                         case  APP_DRAW       : sReplace = C2U("draw");break;
//STRIP001                         case  APP_MATH       : sReplace = C2U("math");break;
//STRIP001                         default: DBG_ERROR("illegal user data");
//STRIP001                     }
//STRIP001                     String sTmp(sCommand);
//STRIP001                     sTmp.SearchAndReplaceAscii("%1", sReplace);
//STRIP001                     sCommand = sTmp;
//STRIP001                     Any aVal = pImpl->xFact->getByName(sCommand);
//STRIP001                     aVal >>= pImpl->aFilterArr[nData];
//STRIP001                 }
//STRIP001             }
//STRIP001             aApplicationLB.SelectEntryPos(0);
//STRIP001             FilterHdl_Impl(&aApplicationLB);
//STRIP001         }
//STRIP001         catch(Exception& )
//STRIP001         {
//STRIP001             DBG_ERROR("exception in FilterFactory access")
//STRIP001         }
//STRIP001 
//STRIP001 		pImpl->bInitialized = sal_True;
//STRIP001     }
//STRIP001 
//STRIP001     SfxItemState eItemState = SFX_ITEM_UNKNOWN;
//STRIP001 //	const SfxItemSet& rSet = GetItemSet();
//STRIP001 	const SfxBoolItem* pAttr = NULL;
//STRIP001 	const SfxUInt16Item* pMinAttr = NULL;
//STRIP001 
//STRIP001     // if an item does not exist inside item set -> disable the corresponding control!
//STRIP001     aDocInfoBtn.Enable(FALSE);
//STRIP001     aBackupBtn.Enable(FALSE);
//STRIP001     aAutoSaveBtn.Enable(FALSE);
//STRIP001     aAutoSavePromptBtn.Enable(FALSE);
//STRIP001 
//STRIP001     for ( USHORT i = SID_ATTR_DOCINFO; i < SID_ATTR_AUTOSAVEMINUTE; ++i  )
//STRIP001 	{
//STRIP001 		pAttr = (SfxBoolItem*)GetItem( rSet, i );
//STRIP001 
//STRIP001 		CheckBox* pBox		= NULL;
//STRIP001 		sal_Bool bInverse	= sal_False;
//STRIP001 
//STRIP001 		switch ( i )
//STRIP001 		{
//STRIP001 			case SID_ATTR_DOCINFO:
//STRIP001 				pBox = &aDocInfoBtn;
//STRIP001 				break;
//STRIP001 
//STRIP001 			case SID_ATTR_BACKUP:
//STRIP001 				pBox = &aBackupBtn;
//STRIP001 				break;
//STRIP001 
//STRIP001 			case SID_ATTR_AUTOSAVE:
//STRIP001 				pBox = &aAutoSaveBtn;
//STRIP001 				break;
//STRIP001 
//STRIP001 			case SID_ATTR_AUTOSAVEPROMPT:
//STRIP001 				pBox = &aAutoSavePromptBtn;
//STRIP001 				break;
//STRIP001 
//STRIP001 			case SID_ATTR_INDEP_METAFILE:
//STRIP001 				// neue ID
//STRIP001 				break;
//STRIP001 		}
//STRIP001 
//STRIP001 		if ( pBox )
//STRIP001         {
//STRIP001 			pBox->Check( pAttr ? pAttr->GetValue() : FALSE );
//STRIP001             pBox->Enable( pAttr ? TRUE : FALSE );
//STRIP001         }
//STRIP001 	}
//STRIP001 
//STRIP001 	// the pretty printing
//STRIP001 	{
//STRIP001 		const SfxPoolItem* pPrettyPrinting = GetItem( rSet, SID_ATTR_PRETTYPRINTING );
//STRIP001 		pAttr = PTR_CAST( SfxBoolItem, pPrettyPrinting );
//STRIP001 		pImpl->m_pNoPrettyPrinting->Check( pAttr ? !pAttr->GetValue() : sal_True );
//STRIP001 	}
//STRIP001 
//STRIP001 
//STRIP001 	USHORT nWhich = GetWhich( SID_ATTR_AUTOSAVEMINUTE );
//STRIP001 	eItemState =
//STRIP001 		rSet.GetItemState( nWhich, FALSE, (const SfxPoolItem**)&pMinAttr );
//STRIP001 
//STRIP001 	// handelt es sich um ein Default-Item?
//STRIP001 	if ( eItemState == SFX_ITEM_DEFAULT )
//STRIP001 		pMinAttr = (const SfxUInt16Item*)&( rSet.Get( nWhich ) );
//STRIP001 	else if ( eItemState == SFX_ITEM_DONTCARE )
//STRIP001 		pMinAttr = NULL;
//STRIP001 
//STRIP001 	aAutoSaveEdit.SetValue( pMinAttr ? (long)pMinAttr->GetValue() : 15 );
//STRIP001 
//STRIP001 	const SfxPoolItem* pItem = 0;
//STRIP001 
//STRIP001     // relativ speichern
//STRIP001 	nWhich = GetWhich( SID_SAVEREL_FSYS );
//STRIP001 
//STRIP001 	if ( SFX_ITEM_SET == rSet.GetItemState( nWhich, FALSE, &pItem ) )
//STRIP001 		aRelFsysBtn.Check( ( (const SfxBoolItem*)pItem )->GetValue() );
//STRIP001 
//STRIP001 	nWhich = GetWhich( SID_SAVEREL_INET );
//STRIP001 
//STRIP001 	if ( SFX_ITEM_SET == rSet.GetItemState( nWhich, FALSE, &pItem ) )
//STRIP001 		aRelInetBtn.Check( ( (const SfxBoolItem*)pItem )->GetValue() );
//STRIP001 
//STRIP001     AutoClickHdl_Impl( &aAutoSaveBtn );
//STRIP001 
//STRIP001 	aDocInfoBtn.SaveValue();
//STRIP001 	aBackupBtn.SaveValue();
//STRIP001 	pImpl->m_pNoPrettyPrinting->SaveValue();
//STRIP001 	aAutoSaveBtn.SaveValue();
//STRIP001 	aAutoSaveEdit.SaveValue();
//STRIP001 	aAutoSavePromptBtn.SaveValue();
//STRIP001 
//STRIP001     aRelFsysBtn.SaveValue();
//STRIP001 	aRelInetBtn.SaveValue();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SfxSaveTabPage, AutoClickHdl_Impl, CheckBox *, pBox )
//STRIP001 {
//STRIP001 	if ( pBox == &aAutoSaveBtn )
//STRIP001 	{
//STRIP001 		if ( aAutoSaveBtn.IsChecked() )
//STRIP001 		{
//STRIP001 			aAutoSaveEdit.Enable();
//STRIP001 			aMinuteText.Enable();
//STRIP001 			aAutoSavePromptBtn.Enable();
//STRIP001 			aAutoSaveEdit.GrabFocus();
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			aAutoSaveEdit.Disable();
//STRIP001 			aMinuteText.Disable();
//STRIP001 			aAutoSavePromptBtn.Disable();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 /* -----------------------------05.04.01 13:10--------------------------------
//STRIP001 
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 OUString lcl_ExtracUIName(const Sequence<PropertyValue> rProperties)
//STRIP001 {
//STRIP001     OUString sRet;
//STRIP001     const PropertyValue* pProperties = rProperties.getConstArray();
//STRIP001     for(int nProp = 0; nProp < rProperties.getLength(); nProp++)
//STRIP001     {
//STRIP001         if(!pProperties[nProp].Name.compareToAscii("UIName"))
//STRIP001         {
//STRIP001             pProperties[nProp].Value >>= sRet;
//STRIP001             break;
//STRIP001         }
//STRIP001     }
//STRIP001     return sRet;
//STRIP001 }
//STRIP001 /* -----------------------------05.04.01 13:37--------------------------------
//STRIP001 
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 IMPL_LINK( SfxSaveTabPage, FilterHdl_Impl, ListBox *, pBox )
//STRIP001 {
//STRIP001     if(&aApplicationLB == pBox)
//STRIP001     {
//STRIP001         USHORT nPos = pBox->GetSelectEntryPos();
//STRIP001         if(nPos < APP_COUNT)
//STRIP001         {
//STRIP001             aFiltersLB.Clear();
//STRIP001             OUString sSelect;
//STRIP001             if(!pImpl->aUIFilterArr[nPos].getLength())
//STRIP001             {
//STRIP001                 pImpl->aUIFilterArr[nPos].realloc(pImpl->aFilterArr[nPos].getLength());
//STRIP001                 const OUString* pFilters = pImpl->aFilterArr[nPos].getConstArray();
//STRIP001                 OUString* pUIFilters = pImpl->aUIFilterArr[nPos].getArray();
//STRIP001                 for(int nFilter = 0; nFilter < pImpl->aFilterArr[nPos].getLength(); nFilter++)
//STRIP001                 {
//STRIP001                     Any aProps = pImpl->xFact->getByName(pFilters[nFilter]);
//STRIP001                     Sequence<PropertyValue> aProperties;
//STRIP001                     aProps >>= aProperties;
//STRIP001                     pUIFilters[nFilter] = lcl_ExtracUIName(aProperties);
//STRIP001                 }
//STRIP001             }
//STRIP001             const OUString* pUIFilters = pImpl->aUIFilterArr[nPos].getConstArray();
//STRIP001             for(int i = 0; i < pImpl->aUIFilterArr[nPos].getLength(); i++)
//STRIP001             {
//STRIP001                 aFiltersLB.InsertEntry(pUIFilters[i]);
//STRIP001                 if(i == pImpl->aDefaultIdxArr[nPos])
//STRIP001                     sSelect = pUIFilters[i];
//STRIP001             }
//STRIP001             aFiltersLB.SelectEntry(sSelect);
//STRIP001         }
//STRIP001     }
//STRIP001     else
//STRIP001     {
//STRIP001         OUString sSelect = pBox->GetSelectEntry();
//STRIP001         USHORT nPos = aApplicationLB.GetSelectEntryPos();
//STRIP001         const OUString* pUIFilters = pImpl->aUIFilterArr[nPos].getConstArray();
//STRIP001         for(int i = 0; i < pImpl->aUIFilterArr[nPos].getLength(); i++)
//STRIP001         {
//STRIP001             if(sSelect == pUIFilters[i])
//STRIP001                 pImpl->aDefaultIdxArr[nPos] = i;
//STRIP001         }
//STRIP001     }
//STRIP001     return 0;
//STRIP001 };

}
