/*************************************************************************
 *
 *  $RCSfile: sw_virtoutp.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 17:40:04 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

// auto strip #ifndef _SV_WINDOW_HXX //autogen
// auto strip #include <vcl/window.hxx>
// auto strip #endif

// auto strip #include "hintids.hxx"
// auto strip #include "viewsh.hxx"
// auto strip #include "virtoutp.hxx"
// auto strip #include "viewopt.hxx"
// auto strip #include "rootfrm.hxx"
// OD 12.11.2002 #96272# - include declaration for <SetMappingForVirtDev>
// auto strip #include "setmapvirtdev.hxx"
namespace binfilter {

//STRIP001 static const ViewShell *pVsh = 0;

#ifndef PRODUCT

/*************************************************************************
 *							class DbgRect
 *************************************************************************/

//STRIP001 class DbgRect
//STRIP001 {
//STRIP001 		OutputDevice *pOut;
//STRIP001 public:
//STRIP001 		DbgRect( OutputDevice *pOut, const Rectangle &rRect,
//STRIP001 				 const ColorData eColor = COL_LIGHTBLUE );
//STRIP001 };

//STRIP001 inline DbgRect::DbgRect( OutputDevice *pOutDev, const Rectangle &rRect,
//STRIP001 						 const ColorData eColor )
//STRIP001    :pOut( pOutDev )
//STRIP001 {
//STRIP001 	if( pOut )
//STRIP001 	{
//STRIP001 		pOut->Push( PUSH_FILLCOLOR|PUSH_LINECOLOR );
//STRIP001 		pOut->SetLineColor( eColor );
//STRIP001 		pOut->SetFillColor();
//STRIP001 		pOut->DrawRect( rRect );
//STRIP001 		pOut->Pop();
//STRIP001 	}
//STRIP001 }

#endif

/* class SwLayVout verwaltet das virtuelle Outputdevice
 * Es gibt von dieser Klasse einen statischen Member am RootFrm,
 * dieser wird in _FrmInit angelegt und in _FrmFinit zerstoert.
 * */

//STRIP001 BOOL SwRootFrm::FlushVout()
//STRIP001 {
//STRIP001 	if( SwRootFrm::pVout->IsFlushable() )
//STRIP001 	{
//STRIP001 		SwRootFrm::pVout->_Flush();
//STRIP001 		return TRUE;
//STRIP001 	}
//STRIP001 	return FALSE;
//STRIP001 }

//STRIP001 BOOL SwRootFrm::HasSameRect( const SwRect& rRect )
//STRIP001 {
//STRIP001 	if( SwRootFrm::pVout->IsFlushable() )
//STRIP001 		return ( rRect == SwRootFrm::pVout->GetOrgRect() );
//STRIP001 	return FALSE;
//STRIP001 }

/** method to set mapping/pixel offset for virtual output device

    OD 12.11.2002 #96272# - method implements two solutions for the mapping of
    the virtual output device:
    The old solution set the origin of the mapping mode, which will be used in
    the virtual output device. This causes several paint errors, because of the
    different roundings in the virtual output device and the original output device.
    The new solution avoids the rounding differences between virtual and original
    output device by setting a pixel offset at the virtual output device.
    A define controls, which solution is used, in order to switch in escalation
    back to old solution.

    @author OD

    @param _pOrgOutDev
    input parameter - constant instance of the original output device, for which
    the virtual output device is created.

    @param _pVirDev
    input/output parameter - instance of the virtual output device.

    @param _pMapMode
    input/output parameter - instance of the mapping mode, which will be set
    at the virtual output device.

    @param _rNewOrigin
    input parameter - constant instance of the origin, which will be used in
    the virtual output device
*/
// define to control, if old or new solution for setting the mapping for
// an virtual output device is used.
//STRIP001 #define USE_NEW_MAPPING
//STRIP001 void SetMappingForVirtDev(  const Point&    _rNewOrigin,
//STRIP001                             MapMode*        _pMapMode,
//STRIP001                             const OutputDevice* _pOrgOutDev,
//STRIP001                             VirtualDevice*  _pVirDev )
//STRIP001 {
//STRIP001 #ifndef USE_NEW_MAPPING
//STRIP001         // old solution: set origin at the mapping mode
//STRIP001         _pMapMode->SetOrigin( Point(0,0) - _rNewOrigin );
//STRIP001 #else
//STRIP001         // new solution: set pixel offset at virtual output device
//STRIP001         Point aPixelOffset = _pOrgOutDev->LogicToPixel( _rNewOrigin );
//STRIP001         _pVirDev->SetPixelOffset( Size( -aPixelOffset.X(), -aPixelOffset.Y() ) );
//STRIP001 #endif
//STRIP001 }


/*************************************************************************
 *							SwVOut::DoesFit()
 *************************************************************************/

// rSize muss in Pixel-Koordinaten vorliegen!
//STRIP001 BOOL SwLayVout::DoesFit( const Size &rNew )
//STRIP001 {
//STRIP001 	if( rNew.Height() > VIRTUALHEIGHT )
//STRIP001 		return FALSE;
//STRIP001 	if( rNew.Width() <= 0 || rNew.Height() <= 0 )
//STRIP001 		return FALSE;
//STRIP001 	if( rNew.Width() <= aSize.Width() )
//STRIP001 		return TRUE;
//STRIP001 	if( !pVirDev )
//STRIP001 	{
//STRIP001 		pVirDev = new VirtualDevice();
//STRIP001 		pVirDev->SetLineColor();
//STRIP001 		if( pOut )
//STRIP001 		{
//STRIP001 			if( pVirDev->GetFillColor() != pOut->GetFillColor() )
//STRIP001 				pVirDev->SetFillColor( pOut->GetFillColor() );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if( rNew.Width() > aSize.Width() )
//STRIP001 	{
//STRIP001 		aSize.Width() = rNew.Width();
//STRIP001 		if( !pVirDev->SetOutputSizePixel( aSize ) )
//STRIP001 		{
//STRIP001 			delete pVirDev;
//STRIP001 			pVirDev = NULL;
//STRIP001 			aSize.Width() = 0;
//STRIP001 			return FALSE;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return TRUE;
//STRIP001 }

/*************************************************************************
 *						   SwLayVout::Enter
 *************************************************************************/
/// OD 27.09.2002 #103636# - change 2nd parameter <rRect> - no longer <const>
///     in order to return value of class member variable <aRect>, if virtual
///     output is used.
///     <aRect> contains the rectangle that represents the area the virtual
///     output device is used for and that is flushed at the end.
//STRIP001 void SwLayVout::Enter(  ViewShell *pShell, SwRect &rRect, BOOL bOn )
//STRIP001 {
//STRIP001     Flush();
//STRIP001 
//STRIP001 #ifndef PRODUCT
//STRIP001 		if( pShell->GetViewOptions()->IsTest3() )
//STRIP001 		{
//STRIP001 			++nCount;
//STRIP001 			return;
//STRIP001 		}
//STRIP001 #endif
//STRIP001 
//STRIP001 	bOn = bOn && !nCount && rRect.HasArea() && pShell->GetWin();
//STRIP001 	++nCount;
//STRIP001 	if( bOn )
//STRIP001 	{
//STRIP001 		pSh = pShell;
//STRIP001 		pOut = NULL;
//STRIP001 		OutputDevice *pO = pSh->GetOut();
//STRIP001 // Auf dem Drucker oder einem virt. Outputdevice wird nicht getrickst...
//STRIP001 		if( OUTDEV_WINDOW != pO->GetOutDevType() )
//STRIP001 			return;
//STRIP001 
//STRIP001 		pOut = pO;
//STRIP001 		Size aPixSz( pOut->PixelToLogic( Size( 1,1 )) );
//STRIP001 		SwRect aTmp( rRect );
//STRIP001 		aTmp.SSize().Width() += aPixSz.Width()/2 + 1;
//STRIP001 		aTmp.SSize().Height()+= aPixSz.Height()/2 + 1;
//STRIP001 		Rectangle aTmpRect( pO->LogicToPixel( aTmp.SVRect() ) );
//STRIP001 
//STRIP001 		ASSERT( aTmpRect.GetWidth() <=
//STRIP001 				pSh->GetWin()->GetOutputSizePixel().Width() + 2,
//STRIP001 				"Paintwidth bigger than visarea?" );
//STRIP001 		// Passt das Rechteck in unseren Buffer ?
//STRIP001 		if( !DoesFit( aTmpRect.GetSize() ) )
//STRIP001 		{
//STRIP001 			pOut = NULL;
//STRIP001 			return;
//STRIP001 		}
//STRIP001 
//STRIP001         aRect = SwRect( pO->PixelToLogic( aTmpRect ) );
//STRIP001 
//STRIP001 #ifdef USED
//STRIP001 		Rectangle aBla( rRect.SVRect() );
//STRIP001 		DbgRect aDbg1( pO, aBla, COL_LIGHTRED );
//STRIP001 #endif
//STRIP001 		SetOutDev( pSh, pVirDev );
//STRIP001 
//STRIP001 		if( pVirDev->GetFillColor() != pOut->GetFillColor() )
//STRIP001 			pVirDev->SetFillColor( pOut->GetFillColor() );
//STRIP001 
//STRIP001         MapMode aMapMode( pOut->GetMapMode() );
//STRIP001         // OD 12.11.2002 #96272# - use method to set mapping
//STRIP001         //aMapMode.SetOrigin( Point(0,0) - aRect.Pos() );
//STRIP001         ::SetMappingForVirtDev( aRect.Pos(), &aMapMode, pOut, pVirDev );
//STRIP001 
//STRIP001         if( aMapMode != pVirDev->GetMapMode() )
//STRIP001 			pVirDev->SetMapMode( aMapMode );
//STRIP001 
//STRIP001         /// OD 27.09.2002 #103636# - set value of parameter <rRect>
//STRIP001         rRect = aRect;
//STRIP001 	}
//STRIP001 }

/*************************************************************************
 *						   SwLayVout::Flush()
 *************************************************************************/

//STRIP001 void SwLayVout::_Flush()
//STRIP001 {
//STRIP001 	ASSERT( pVirDev, "SwLayVout::DrawOut: nothing left Toulouse" );
//STRIP001 	Rectangle aTmp( aRect.SVRect() );
//STRIP001 #ifdef USED
//STRIP001 	DbgRect aDbg1( pOut, aTmp );
//STRIP001 	DbgRect aDbg2( pVirDev, aTmp, COL_YELLOW );
//STRIP001 #endif
//STRIP001     pOut->DrawOutDev( aRect.Pos(), aRect.SSize(),
//STRIP001                       aRect.Pos(), aRect.SSize(), *pVirDev );
//STRIP001     SetOutDev( pSh, pOut );
//STRIP001 	pOut = NULL;
//STRIP001 }


}
