/*************************************************************************
 *
 *  $RCSfile: sw_docstdlg.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:54:18 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {


//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #include <stdio.h>
//STRIP001 #include <ctype.h>
//STRIP001 
//STRIP001 #ifndef _SWWAIT_HXX
//STRIP001 #include <swwait.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _WRTSH_HXX
//STRIP001 #include <wrtsh.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _VIEW_HXX
//STRIP001 #include <view.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SWMODULE_HXX
//STRIP001 #include <swmodule.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _GLOBALS_HRC
//STRIP001 #include <globals.hrc>
//STRIP001 #endif
//STRIP001 #ifndef _DOCSH_HXX
//STRIP001 #include <docsh.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _FESH_HXX
//STRIP001 #include <fesh.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _PVIEW_HXX
//STRIP001 #include <pview.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _DOC_HXX
//STRIP001 #include <doc.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _DOCSTDLG_HXX
//STRIP001 #include <docstdlg.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _DOCSTAT_HXX
//STRIP001 #include <docstat.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _MODCFG_HXX
//STRIP001 #include <modcfg.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 // fuer Statistikfelder
//STRIP001 #ifndef _FLDMGR_HXX
//STRIP001 #include <fldmgr.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _FLDBAS_HXX
//STRIP001 #include <fldbas.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _DOCSTDLG_HRC
//STRIP001 #include <docstdlg.hrc>
//STRIP001 #endif


/*--------------------------------------------------------------------
	Beschreibung: Create
 --------------------------------------------------------------------*/


//STRIP001 SfxTabPage *  SwDocStatPage::Create(Window *pParent, const SfxItemSet &rSet)
//STRIP001 {
//STRIP001 	return new SwDocStatPage(pParent, rSet);
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:	Ctor
 --------------------------------------------------------------------*/


//STRIP001 SwDocStatPage::SwDocStatPage(Window *pParent, const SfxItemSet &rSet) :
//STRIP001 
//STRIP001 	SfxTabPage	(pParent, SW_RES(TP_DOC_STAT), rSet),
//STRIP001 
//STRIP001 	aTableLbl	(this, SW_RES( FT_TABLE		 )),
//STRIP001 	aGrfLbl		(this, SW_RES( FT_GRF		 )),
//STRIP001 	aOLELbl		(this, SW_RES( FT_OLE		 )),
//STRIP001 	aPageLbl	(this, SW_RES( FT_PAGE		 )),
//STRIP001 	aParaLbl	(this, SW_RES( FT_PARA		 )),
//STRIP001 	aWordLbl	(this, SW_RES( FT_WORD		 )),
//STRIP001 	aCharLbl	(this, SW_RES( FT_CHAR 	     )),
//STRIP001 	aTableNo	(this, SW_RES( FT_TABLE_COUNT)),
//STRIP001 	aGrfNo		(this, SW_RES( FT_GRF_COUNT  )),
//STRIP001 	aOLENo		(this, SW_RES( FT_OLE_COUNT  )),
//STRIP001 	aPageNo		(this, SW_RES( FT_PAGE_COUNT )),
//STRIP001 	aParaNo		(this, SW_RES( FT_PARA_COUNT )),
//STRIP001 	aWordNo		(this, SW_RES( FT_WORD_COUNT )),
//STRIP001 	aCharNo		(this, SW_RES( FT_CHAR_COUNT )),
//STRIP001 	aLineLbl	(this, SW_RES( FT_LINE       )),
//STRIP001 	aLineNo		(this, SW_RES( FT_LINE_COUNT )),
//STRIP001 	aUpdatePB	(this, SW_RES( PB_PDATE      ))
//STRIP001 {
//STRIP001     Update();
//STRIP001 	FreeResource();
//STRIP001 	aUpdatePB.SetClickHdl(LINK(this, SwDocStatPage, UpdateHdl));
//STRIP001 }


//STRIP001  SwDocStatPage::~SwDocStatPage()
//STRIP001 {
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:	ItemSet fuellen bei Aenderung
 --------------------------------------------------------------------*/


//STRIP001 BOOL  SwDocStatPage::FillItemSet(SfxItemSet &rSet)
//STRIP001 {
//STRIP001 	return FALSE;
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/


//STRIP001 void  SwDocStatPage::Reset(const SfxItemSet &rSet)
//STRIP001 {
//STRIP001 }
/*------------------------------------------------------------------------
 Beschreibung:	Aktualisieren / Setzen der Daten
------------------------------------------------------------------------*/


//STRIP001 void SwDocStatPage::SetData(const SwDocStat &rStat)
//STRIP001 {
//STRIP001 	aTableNo.SetText(String::CreateFromInt32( rStat.nTbl ));
//STRIP001 	aGrfNo.SetText(String::CreateFromInt32( rStat.nGrf ));
//STRIP001 	aOLENo.SetText(String::CreateFromInt32( rStat.nOLE ));
//STRIP001 	aPageNo.SetText(String::CreateFromInt32( rStat.nPage ));
//STRIP001 	aParaNo.SetText(String::CreateFromInt32( rStat.nPara ));
//STRIP001 	aWordNo.SetText(String::CreateFromInt32( rStat.nWord ));
//STRIP001 	aCharNo.SetText(String::CreateFromInt32( rStat.nChar ));
//STRIP001 }

/*------------------------------------------------------------------------
 Beschreibung:	Aktualisieren der Statistik
------------------------------------------------------------------------*/


//STRIP001 void SwDocStatPage::Update()
//STRIP001 {
//STRIP001 	SfxViewShell *pVSh = SfxViewShell::Current();
//STRIP001 	ViewShell *pSh = 0;
//STRIP001 	if ( pVSh->ISA(SwView) )
//STRIP001 		pSh = ((SwView*)pVSh)->GetWrtShellPtr();
//STRIP001 	else if ( pVSh->ISA(SwPagePreView) )
//STRIP001         pSh = ((SwPagePreView*)pVSh)->GetViewShell();
//STRIP001 
//STRIP001 	ASSERT( pSh, "Shell not found" );
//STRIP001 
//STRIP001 	SwWait aWait( *pSh->GetDoc()->GetDocShell(), TRUE );
//STRIP001 	pSh->StartAction();
//STRIP001 	pSh->GetDoc()->UpdateDocStat( aDocStat );
//STRIP001 	pSh->EndAction();
//STRIP001 
//STRIP001 	SetData(aDocStat);
//STRIP001 }

/*-----------------19.06.97 16.37-------------------
	Zeilennummer aktualisieren
--------------------------------------------------*/
//STRIP001 IMPL_LINK( SwDocStatPage, UpdateHdl, PushButton*, pButton)
//STRIP001 {
//STRIP001 	Update();
//STRIP001 	SwDocShell* pDocShell = (SwDocShell*) SfxObjectShell::Current();
//STRIP001 	SwFEShell* pFEShell = pDocShell->GetFEShell();
//STRIP001 	aLineNo.SetText( String::CreateFromInt32( pFEShell->GetLineCount(FALSE)));
//STRIP001 	//pButton->Disable();
//STRIP001 	return 0;
//STRIP001 }

}
