/*************************************************************************
 *
 *  $RCSfile: sw_labelexp.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:54:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


//STRIP001 #pragma hdrstop

//STRIP001 #ifndef _COM_SUN_STAR_TEXT_XTEXTFIELDSSUPPLIER_HPP_
//STRIP001 #include <com/sun/star/text/XTextFieldsSupplier.hpp>
//STRIP001 #endif
//STRIP001 #ifndef _COM_SUN_STAR_UTIL_XREFRESHABLE_HPP_
//STRIP001 #include <com/sun/star/util/XRefreshable.hpp>
//STRIP001 #endif
//STRIP001 #ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
//STRIP001 #include <com/sun/star/lang/XMultiServiceFactory.hpp>
//STRIP001 #endif
//STRIP001 #ifndef _COM_SUN_STAR_CONTAINER_XNAMEACCESS_HPP_
//STRIP001 #include <com/sun/star/container/XNameAccess.hpp>
//STRIP001 #endif
//STRIP001 #ifndef _COMPHELPER_PROCESSFACTORY_HXX_
//STRIP001 #include <comphelper/processfactory.hxx>
//STRIP001 #endif

//STRIP001 #ifndef _SWTYPES_HXX
//STRIP001 #include <swtypes.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _LABFMT_HXX
//STRIP001 #include <labfmt.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _UNOTOOLS_HXX
//STRIP001 #include <unotools.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _UNOATXT_HXX //autogen wg. SwXAutoTextEntry
//STRIP001 #include <unoatxt.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _UNOOBJ_HXX //
//STRIP001 #include <unoobj.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _UNOPRNMS_HXX //
//STRIP001 #include <unoprnms.hxx>
//STRIP001 #endif
#ifndef _LEGACYBINFILTERMGR_HXX
#include <legacysmgr/legacy_binfilters_smgr.hxx>	//STRIP002 
#endif

//STRIP001 using namespace ::com::sun::star;
//STRIP001 using namespace ::com::sun::star::lang;
//STRIP001 using namespace ::com::sun::star::container;
//STRIP001 using namespace ::com::sun::star::uno;
//STRIP001 using namespace ::comphelper;
//STRIP001 using namespace ::rtl;
//STRIP001 
//STRIP001 #define C2U(char) ::rtl::OUString::createFromAscii(char)

/* -----------------08.07.99 15:15-------------------

 --------------------------------------------------*/
//STRIP001 void SwVisitingCardPage::InitFrameControl()
//STRIP001 {
//STRIP001 	Link aLink(LINK(this, SwVisitingCardPage, FrameControlInitializedHdl));
//STRIP001 	pExampleFrame = new SwOneExampleFrame( aExampleWIN,
//STRIP001 									EX_SHOW_BUSINESS_CARDS, &aLink );
//STRIP001 
//STRIP001 	uno::Reference< lang::XMultiServiceFactory >  xMgr =
//STRIP001 											::legacy_binfilters::getLegacyProcessServiceFactory();
//STRIP001 	//now the AutoText ListBoxes have to be filled
//STRIP001 
//STRIP001 	uno::Reference< uno::XInterface >  xAText =
//STRIP001 		xMgr->createInstance( C2U("com.sun.star.text.AutoTextContainer") );
//STRIP001 	_xAutoText = uno::Reference< container::XNameAccess >(xAText, uno::UNO_QUERY);
//STRIP001 
//STRIP001 	uno::Sequence<OUString> aNames = _xAutoText->getElementNames();
//STRIP001 	const OUString* pGroups = aNames.getConstArray();
//STRIP001 	OUString uTitleName( C2U(SW_PROP_NAME_STR(UNO_NAME_TITLE)) );
//STRIP001 
//STRIP001 	for(sal_uInt16 i = 0; i < aNames.getLength(); i++)
//STRIP001 	{
//STRIP001 		uno::Any aGroup = _xAutoText->getByName(pGroups[i]);
//STRIP001         uno::Reference< text::XAutoTextGroup >  xGroup;
//STRIP001         aGroup >>= xGroup;
//STRIP001 		uno::Reference< container::XIndexAccess >  xIdxAcc(xGroup, uno::UNO_QUERY);
//STRIP001         try
//STRIP001         {
//STRIP001             if(!xIdxAcc.is() || xIdxAcc->getCount())
//STRIP001             {
//STRIP001                 uno::Reference< beans::XPropertySet >  xPrSet(xGroup, uno::UNO_QUERY);
//STRIP001                 uno::Any aTitle = xPrSet->getPropertyValue( uTitleName );
//STRIP001                 OUString uTitle;
//STRIP001                 aTitle >>= uTitle;
//STRIP001                 String sGroup(pGroups[i]);
//STRIP001                 sal_uInt16 nEntry = aAutoTextGroupLB.InsertEntry(uTitle);
//STRIP001                 aAutoTextGroupLB.SetEntryData(nEntry, new String(sGroup));
//STRIP001             }
//STRIP001         }
//STRIP001         catch(Exception&)
//STRIP001         {
//STRIP001         }
//STRIP001 	}
//STRIP001 	if(aAutoTextGroupLB.GetEntryCount())
//STRIP001 	{
//STRIP001 		if(LISTBOX_ENTRY_NOTFOUND == aAutoTextGroupLB.GetSelectEntryPos())
//STRIP001 			aAutoTextGroupLB.SelectEntryPos(0);
//STRIP001 		String sCurGroupName(
//STRIP001 			*(String*)aAutoTextGroupLB.GetEntryData(aAutoTextGroupLB.GetSelectEntryPos()));
//STRIP001 		if(_xAutoText->hasByName(sCurGroupName))
//STRIP001 		{
//STRIP001 			uno::Any aGroup = _xAutoText->getByName(sCurGroupName);
//STRIP001 			try
//STRIP001 			{
//STRIP001                 uno::Reference< text::XAutoTextGroup >  xGroup;
//STRIP001                 aGroup >>= xGroup;
//STRIP001 				uno::Sequence< OUString > aBlockNames = xGroup->getElementNames();
//STRIP001 				uno::Sequence< OUString > aTitles = xGroup->getTitles() ;
//STRIP001 
//STRIP001 				SetUserData( aBlockNames.getLength(), aTitles.getConstArray(),
//STRIP001 							aBlockNames.getConstArray() );
//STRIP001 			}
//STRIP001 			catch( uno::RuntimeException& )
//STRIP001 			{
//STRIP001 				// we'll be her if path settings were wrong
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
/* -----------------01.10.99 13:19-------------------

 --------------------------------------------------*/
//STRIP001 IMPL_LINK( SwVisitingCardPage, FrameControlInitializedHdl, void*, EMPTYARG )
//STRIP001 {
//STRIP001 	SvLBoxEntry* pSel = aAutoTextLB.FirstSelected();
//STRIP001 	String sEntry;
//STRIP001 	if( pSel )
//STRIP001 		sEntry = *(String*)pSel->GetUserData();
//STRIP001 	uno::Reference< text::XTextCursor > & xCrsr = pExampleFrame->GetTextCursor();
//STRIP001 	OUString uEntry(sEntry);
//STRIP001 
//STRIP001     if(LISTBOX_ENTRY_NOTFOUND != aAutoTextGroupLB.GetSelectEntryPos())
//STRIP001     {
//STRIP001         String sGroup( *(String*)aAutoTextGroupLB.GetEntryData(
//STRIP001                                     aAutoTextGroupLB.GetSelectEntryPos() ) );
//STRIP001         uno::Any aGroup = _xAutoText->getByName(sGroup);
//STRIP001         uno::Reference< text::XAutoTextGroup >  xGroup;
//STRIP001         aGroup >>= xGroup;
//STRIP001 
//STRIP001         if( sEntry.Len() && xGroup->hasByName( uEntry ) )
//STRIP001         {
//STRIP001             uno::Any aEntry(xGroup->getByName(uEntry));
//STRIP001             uno::Reference< text::XAutoTextEntry >  xEntry;
//STRIP001             aEntry >>= xEntry;
//STRIP001             if(xEntry.is())
//STRIP001             {
//STRIP001                 uno::Reference< text::XTextRange >  xRange(xCrsr, uno::UNO_QUERY);
//STRIP001                 xEntry->applyTo(xRange);
//STRIP001             }
//STRIP001             UpdateFields();
//STRIP001         }
//STRIP001     }
//STRIP001 	return 0;
//STRIP001 }
/* -----------------22.07.99 11:06-------------------

 --------------------------------------------------*/
//STRIP001 IMPL_LINK( SwVisitingCardPage, AutoTextSelectHdl, void*, pBox )
//STRIP001 {
//STRIP001 	if(_xAutoText.is())
//STRIP001 	{
//STRIP001 		if( &aAutoTextGroupLB == pBox )
//STRIP001 		{
//STRIP001 			String sGroup( *(String*)aAutoTextGroupLB.GetEntryData(
//STRIP001 									aAutoTextGroupLB.GetSelectEntryPos()));
//STRIP001 			uno::Any aGroup = _xAutoText->getByName(sGroup);
//STRIP001 			uno::Reference< text::XAutoTextGroup >  xGroup;
//STRIP001 			aGroup >>= xGroup;
//STRIP001 
//STRIP001 			ClearUserData();
//STRIP001 			aAutoTextLB.Clear();
//STRIP001 
//STRIP001 			uno::Sequence<OUString> aBlockNames = xGroup->getElementNames();
//STRIP001 			uno::Sequence< OUString > aTitles = xGroup->getTitles() ;
//STRIP001 			SetUserData( aBlockNames.getLength(), aTitles.getConstArray(),
//STRIP001 						aBlockNames.getConstArray() );
//STRIP001 		}
//STRIP001 		if(pExampleFrame->IsInitialized())
//STRIP001 			pExampleFrame->ClearDocument( TRUE );
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }

/* -----------------01.10.99 11:59-------------------

 --------------------------------------------------*/
//STRIP001 void SwVisitingCardPage::UpdateFields()
//STRIP001 {
//STRIP001 	uno::Reference< frame::XModel >  xModel;
//STRIP001 	if( pExampleFrame && (xModel = pExampleFrame->GetModel()).is())
//STRIP001 	{
//STRIP001 		SwLabDlg::UpdateFieldInformation(xModel, aLabItem);
//STRIP001 	}
//STRIP001 }
/* -----------------01.10.99 15:16-------------------

 --------------------------------------------------*/
//STRIP001 void SwLabDlg::UpdateFieldInformation(uno::Reference< frame::XModel > & xModel, const SwLabItem& rItem)
//STRIP001 {
//STRIP001 	uno::Reference< text::XTextFieldsSupplier >  xFlds(xModel, uno::UNO_QUERY);
//STRIP001 	uno::Reference< container::XNameAccess >  xFldMasters = xFlds->getTextFieldMasters();
//STRIP001 
//STRIP001 	static const struct _SwLabItemMap {
//STRIP001 		const char* pName;
//STRIP001 		::rtl::OUString SwLabItem:: *pValue;
//STRIP001 	}  aArr[] = {
//STRIP001 		{ "BC_PRIV_FIRSTNAME"  , &SwLabItem::aPrivFirstName },
//STRIP001 		{ "BC_PRIV_NAME"       , &SwLabItem::aPrivName },
//STRIP001 		{ "BC_PRIV_INITIALS"   , &SwLabItem::aPrivShortCut },
//STRIP001 		{ "BC_PRIV_FIRSTNAME_2", &SwLabItem::aPrivFirstName2 },
//STRIP001 		{ "BC_PRIV_NAME_2"     , &SwLabItem::aPrivName2 },
//STRIP001 		{ "BC_PRIV_INITIALS_2" , &SwLabItem::aPrivShortCut2 },
//STRIP001 		{ "BC_PRIV_STREET"     , &SwLabItem::aPrivStreet },
//STRIP001 		{ "BC_PRIV_ZIP"        , &SwLabItem::aPrivZip },
//STRIP001 		{ "BC_PRIV_CITY"       , &SwLabItem::aPrivCity },
//STRIP001 		{ "BC_PRIV_COUNTRY"    , &SwLabItem::aPrivCountry },
//STRIP001 		{ "BC_PRIV_STATE"      , &SwLabItem::aPrivState },
//STRIP001 		{ "BC_PRIV_TITLE"      , &SwLabItem::aPrivTitle },
//STRIP001 		{ "BC_PRIV_PROFESSION" , &SwLabItem::aPrivProfession },
//STRIP001 		{ "BC_PRIV_PHONE"      , &SwLabItem::aPrivPhone },
//STRIP001 		{ "BC_PRIV_MOBILE"     , &SwLabItem::aPrivMobile },
//STRIP001 		{ "BC_PRIV_FAX"        , &SwLabItem::aPrivFax },
//STRIP001 		{ "BC_PRIV_WWW"        , &SwLabItem::aPrivWWW },
//STRIP001 		{ "BC_PRIV_MAIL"       , &SwLabItem::aPrivMail },
//STRIP001 		{ "BC_COMP_COMPANY"    , &SwLabItem::aCompCompany },
//STRIP001 		{ "BC_COMP_COMPANYEXT" , &SwLabItem::aCompCompanyExt },
//STRIP001 		{ "BC_COMP_SLOGAN"     , &SwLabItem::aCompSlogan },
//STRIP001 		{ "BC_COMP_STREET"     , &SwLabItem::aCompStreet },
//STRIP001 		{ "BC_COMP_ZIP"        , &SwLabItem::aCompZip },
//STRIP001 		{ "BC_COMP_CITY"       , &SwLabItem::aCompCity },
//STRIP001 		{ "BC_COMP_COUNTRY"    , &SwLabItem::aCompCountry },
//STRIP001 		{ "BC_COMP_STATE"      , &SwLabItem::aCompState },
//STRIP001 		{ "BC_COMP_POSITION"   , &SwLabItem::aCompPosition },
//STRIP001 		{ "BC_COMP_PHONE"      , &SwLabItem::aCompPhone },
//STRIP001 		{ "BC_COMP_MOBILE"     , &SwLabItem::aCompMobile },
//STRIP001 		{ "BC_COMP_FAX"        , &SwLabItem::aCompFax },
//STRIP001 		{ "BC_COMP_WWW"        , &SwLabItem::aCompWWW },
//STRIP001 		{ "BC_COMP_MAIL"       , &SwLabItem::aCompMail },
//STRIP001 		{ 0, 0 }
//STRIP001 	};
//STRIP001 
//STRIP001 	try
//STRIP001 	{
//STRIP001 		String sFldName( String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM(
//STRIP001 							"com.sun.star.text.FieldMaster.User." )));
//STRIP001 		OUString uCntName( C2U( SW_PROP_NAME_STR(UNO_NAME_CONTENT )));
//STRIP001 		for( const _SwLabItemMap* p = aArr; p->pName; ++p )
//STRIP001 		{
//STRIP001 			String sCurFldName( sFldName );
//STRIP001 			sCurFldName.AppendAscii( p->pName );
//STRIP001 			OUString uFldName( sCurFldName );
//STRIP001 			if( xFldMasters->hasByName( uFldName ))
//STRIP001 			{
//STRIP001 				uno::Any aFirstName = xFldMasters->getByName( uFldName );
//STRIP001                 uno::Reference< beans::XPropertySet >  xFld;
//STRIP001                 aFirstName >>= xFld;
//STRIP001 				uno::Any aContent;
//STRIP001 				aContent <<= rItem.*p->pValue;
//STRIP001 				xFld->setPropertyValue( uCntName, aContent );
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	catch( uno::RuntimeException&)
//STRIP001 	{
//STRIP001 		//
//STRIP001 	}
//STRIP001 
//STRIP001 	uno::Reference< container::XEnumerationAccess >  xFldAcc = xFlds->getTextFields();
//STRIP001 	uno::Reference< util::XRefreshable >  xRefresh(xFldAcc, uno::UNO_QUERY);
//STRIP001 	xRefresh->refresh();
//STRIP001 }

