/*************************************************************************
 *
 *  $RCSfile: sw_changedb.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 18:47:55 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#define _CHANGEDB_CXX

// auto strip #include <svtools/stdctrl.hxx>
// auto strip #ifndef _MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif

// auto strip #ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
// auto strip #include <com/sun/star/lang/XMultiServiceFactory.hpp>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_CONTAINER_XNAMEACCESS_HPP_
// auto strip #include <com/sun/star/container/XNameAccess.hpp>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_SDB_XDATABASEACCESS_HPP_
// auto strip #include <com/sun/star/sdb/XDatabaseAccess.hpp>
// auto strip #endif
// auto strip #ifndef _COMPHELPER_PROCESSFACTORY_HXX_
// auto strip #include <comphelper/processfactory.hxx>
// auto strip #endif

// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif

// auto strip #ifndef _VIEW_HXX
// auto strip #include <view.hxx>
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

// auto strip #ifndef _WRTSH_HXX
// auto strip #include <wrtsh.hxx>
// auto strip #endif
// auto strip #ifndef _DBMGR_HXX
// auto strip #include <dbmgr.hxx>
// auto strip #endif
// auto strip #ifndef _FLDMGR_HXX
// auto strip #include <fldmgr.hxx>
// auto strip #endif
// auto strip #ifndef _EXPFLD_HXX
// auto strip #include <expfld.hxx>
// auto strip #endif
#ifndef _TXTATR_HXX
#include <txtatr.hxx>
#endif
// auto strip #ifndef _NDTXT_HXX
// auto strip #include <ndtxt.hxx>
// auto strip #endif
// auto strip #ifndef _FLDBAS_HXX
// auto strip #include <fldbas.hxx>
// auto strip #endif
// auto strip #ifndef _DBFLD_HXX
// auto strip #include <dbfld.hxx>
// auto strip #endif
#ifndef _CHANGEDB_HXX
#include <changedb.hxx>
#endif

#ifndef _FLDUI_HRC
#include <fldui.hrc>
#endif
#ifndef _UTLUI_HRC
#include <utlui.hrc>
#endif
#ifndef _CHANGEDB_HRC
#include <changedb.hrc>
#endif
// auto strip #ifndef _LEGACYBINFILTERMGR_HXX
// auto strip #include <legacysmgr/legacy_binfilters_smgr.hxx>	//STRIP002 
// auto strip #endif
namespace binfilter {
using namespace rtl;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::container;
using namespace ::com::sun::star::lang;
//STRIP001 #define C2U(cChar) OUString::createFromAscii(cChar)

/*--------------------------------------------------------------------
	Beschreibung: Feldeinfuegen bearbeiten
 --------------------------------------------------------------------*/


//STRIP001 SwChangeDBDlg::SwChangeDBDlg(SwView& rVw) :
//STRIP001 	SvxStandardDialog(&rVw.GetViewFrame()->GetWindow(), SW_RES(DLG_CHANGE_DB)),
//STRIP001 
//STRIP001     aDBListFL   (this, SW_RES(FL_DBLIST     )),
//STRIP001 	aUsedDBFT	(this, SW_RES(FT_USEDDB  	)),
//STRIP001 	aAvailDBFT	(this, SW_RES(FT_AVAILDB 	)),
//STRIP001 	aUsedDBTLB	(this, SW_RES(TLB_USEDDB  	)),
//STRIP001     aAvailDBTLB (this, SW_RES(TLB_AVAILDB   ), rVw.GetWrtShell()),
//STRIP001 	aDescFT		(this, SW_RES(FT_DESC		)),
//STRIP001 	aDocDBTextFT(this, SW_RES(FT_DOCDBTEXT	)),
//STRIP001 	aDocDBNameFT(this, SW_RES(FT_DOCDBNAME	)),
//STRIP001 	aOKBT		(this, SW_RES(BT_OK      	)),
//STRIP001 	aCancelBT	(this, SW_RES(BT_CANCEL  	)),
//STRIP001 	aHelpBT		(this, SW_RES(BT_HELP    	)),
//STRIP001 //	aChangeBT	(this, SW_RES(BT_CHANGEDB    )),
//STRIP001     aImageList      (SW_RES(ILIST_DB_DLG    )),
//STRIP001     aImageListHC    (SW_RES(ILIST_DB_DLG_HC )),
//STRIP001 
//STRIP001 	pMgr( new SwFldMgr() ),
//STRIP001 	pSh(rVw.GetWrtShellPtr())
//STRIP001 {
//STRIP001 	FillDBPopup();
//STRIP001 
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	ShowDBName(pSh->GetDBData());
//STRIP001 	aOKBT.SetClickHdl(LINK(this, SwChangeDBDlg, ButtonHdl));
//STRIP001 
//STRIP001 	aUsedDBTLB.SetSelectionMode(MULTIPLE_SELECTION);
//STRIP001 	aUsedDBTLB.SetWindowBits(WB_HASLINES|WB_CLIPCHILDREN|WB_SORT|WB_HASBUTTONS|WB_HASBUTTONSATROOT|WB_HSCROLL);
//STRIP001 	aUsedDBTLB.SetSpaceBetweenEntries(0);
//STRIP001 
//STRIP001     aUsedDBTLB.SetNodeBitmaps( aImageList.GetImage(IMG_COLLAPSE),
//STRIP001                     aImageList.GetImage(IMG_EXPAND  ), BMP_COLOR_NORMAL );
//STRIP001     aUsedDBTLB.SetNodeBitmaps( aImageListHC.GetImage(IMG_COLLAPSE),
//STRIP001                     aImageListHC.GetImage(IMG_EXPAND  ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 
//STRIP001 	Link aLink = LINK(this, SwChangeDBDlg, TreeSelectHdl);
//STRIP001 
//STRIP001 	aUsedDBTLB.SetSelectHdl(aLink);
//STRIP001 	aUsedDBTLB.SetDeselectHdl(aLink);
//STRIP001 	aAvailDBTLB.SetSelectHdl(aLink);
//STRIP001 	aAvailDBTLB.SetDeselectHdl(aLink);
//STRIP001 	TreeSelectHdl();
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung: Datenbank-Listboxen initialisieren
 --------------------------------------------------------------------*/


//STRIP001 void SwChangeDBDlg::FillDBPopup()
//STRIP001 {
//STRIP001 	Reference<XNameAccess> xDBContext;
//STRIP001 	Reference< XMultiServiceFactory > xMgr( ::legacy_binfilters::getLegacyProcessServiceFactory() );
//STRIP001 	if( xMgr.is() )
//STRIP001 	{
//STRIP001 		Reference<XInterface> xInstance = xMgr->createInstance( C2U( "com.sun.star.sdb.DatabaseContext" ));
//STRIP001 		xDBContext = Reference<XNameAccess>(xInstance, UNO_QUERY) ;
//STRIP001 	}
//STRIP001 	DBG_ASSERT(xDBContext.is(), "com.sun.star.sdb.DataBaseContext: service not available")
//STRIP001 
//STRIP001 	const SwDBData& rDBData = pSh->GetDBData();
//STRIP001 	String sDBName(rDBData.sDataSource);
//STRIP001 	String sTableName(rDBData.sCommand);
//STRIP001 	aAvailDBTLB.Select(sDBName, sTableName, aEmptyStr);
//STRIP001 
//STRIP001 	SvStringsDtor aAllDBNames(5, 5);
//STRIP001 
//STRIP001 	Sequence<OUString> aDBNames = xDBContext->getElementNames();
//STRIP001 	const OUString* pDBNames = aDBNames.getConstArray();
//STRIP001 	long nDBCount = aDBNames.getLength();
//STRIP001 
//STRIP001 	for(long i = 0; i < nDBCount; i++)
//STRIP001 	{
//STRIP001 		String sDBName(pDBNames[i]);
//STRIP001 		aAllDBNames.Insert(new String(sDBName), aAllDBNames.Count());
//STRIP001 	}
//STRIP001 
//STRIP001 	SvStringsDtor aDBNameList(5, 1);
//STRIP001 	pSh->GetAllUsedDB( aDBNameList, &aAllDBNames );
//STRIP001 
//STRIP001 	USHORT nCount = aDBNameList.Count();
//STRIP001 	aUsedDBTLB.Clear();
//STRIP001 	SvLBoxEntry *pFirst = 0;
//STRIP001 	SvLBoxEntry *pLast = 0;
//STRIP001 
//STRIP001 	for (i = 0; i < nCount; i++)
//STRIP001 	{
//STRIP001 		sDBName = *aDBNameList.GetObject(i);
//STRIP001 		sDBName = sDBName.GetToken(0);
//STRIP001 		pLast = Insert(sDBName);
//STRIP001 		if (!pFirst)
//STRIP001 			pFirst = pLast;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pFirst)
//STRIP001 	{
//STRIP001 		aUsedDBTLB.MakeVisible(pFirst);
//STRIP001 		aUsedDBTLB.Select(pFirst);
//STRIP001 	}
//STRIP001 
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/


//STRIP001 SvLBoxEntry* SwChangeDBDlg::Insert(const String& rDBName)
//STRIP001 {
//STRIP001 	String sDBName(rDBName.GetToken(0, DB_DELIM));
//STRIP001 	String sTableName(rDBName.GetToken(1, DB_DELIM));
//STRIP001 	int nCommandType = rDBName.GetToken(2, DB_DELIM).ToInt32();
//STRIP001 	SvLBoxEntry* pParent;
//STRIP001 	SvLBoxEntry* pChild;
//STRIP001 
//STRIP001 	USHORT nParent = 0;
//STRIP001 	USHORT nChild = 0;
//STRIP001
//STRIP001     Image aTableImg = aImageList.GetImage(IMG_DBTABLE);
//STRIP001     Image aDBImg = aImageList.GetImage(IMG_DB);
//STRIP001     Image aQueryImg = aImageList.GetImage(IMG_DBQUERY);
//STRIP001     Image aHCTableImg = aImageListHC.GetImage(IMG_DBTABLE);
//STRIP001     Image aHCDBImg = aImageListHC.GetImage(IMG_DB);
//STRIP001     Image aHCQueryImg = aImageListHC.GetImage(IMG_DBQUERY);
//STRIP001     Image& rToInsert = nCommandType ? aQueryImg : aTableImg;
//STRIP001     Image& rHCToInsert = nCommandType ? aHCQueryImg : aHCTableImg;
//STRIP001     while ((pParent = aUsedDBTLB.GetEntry(nParent++)) != NULL)
//STRIP001 	{
//STRIP001 		if (sDBName == aUsedDBTLB.GetEntryText(pParent))
//STRIP001 		{
//STRIP001 			while ((pChild = aUsedDBTLB.GetEntry(pParent, nChild++)) != NULL)
//STRIP001 			{
//STRIP001 				if (sTableName == aUsedDBTLB.GetEntryText(pChild))
//STRIP001 					return pChild;
//STRIP001 			}
//STRIP001             SvLBoxEntry* pRet = aUsedDBTLB.InsertEntry(sTableName, rToInsert, rToInsert, pParent);
//STRIP001             aUsedDBTLB.SetExpandedEntryBmp(pRet, rHCToInsert, BMP_COLOR_HIGHCONTRAST);
//STRIP001             aUsedDBTLB.SetCollapsedEntryBmp(pRet, rHCToInsert, BMP_COLOR_HIGHCONTRAST);
//STRIP001             pRet->SetUserData((void*)nCommandType);
//STRIP001 			return pRet;
//STRIP001 		}
//STRIP001 	}
//STRIP001     pParent = aUsedDBTLB.InsertEntry(sDBName, aDBImg, aDBImg);
//STRIP001     aUsedDBTLB.SetExpandedEntryBmp(pParent, aHCDBImg, BMP_COLOR_HIGHCONTRAST);
//STRIP001     aUsedDBTLB.SetCollapsedEntryBmp(pParent, aHCDBImg, BMP_COLOR_HIGHCONTRAST);
//STRIP001 
//STRIP001     SvLBoxEntry* pRet = aUsedDBTLB.InsertEntry(sTableName, rToInsert, rToInsert, pParent);
//STRIP001     aUsedDBTLB.SetExpandedEntryBmp(pRet, rHCToInsert, BMP_COLOR_HIGHCONTRAST);
//STRIP001     aUsedDBTLB.SetCollapsedEntryBmp(pRet, rHCToInsert, BMP_COLOR_HIGHCONTRAST);
//STRIP001     pRet->SetUserData((void*)nCommandType);
//STRIP001 	return pRet;
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung: Dialog zerstoeren
 --------------------------------------------------------------------*/
//STRIP001 __EXPORT SwChangeDBDlg::~SwChangeDBDlg()
//STRIP001 {
//STRIP001 	delete pMgr;
//STRIP001 }

/*--------------------------------------------------------------------
	 Beschreibung:	Schliessen
 --------------------------------------------------------------------*/
//STRIP001 void __EXPORT SwChangeDBDlg::Apply()
//STRIP001 {
//STRIP001 	UpdateFlds();
//STRIP001 }
/*--------------------------------------------------------------------
	 Beschreibung:
 --------------------------------------------------------------------*/
//STRIP001 void SwChangeDBDlg::UpdateFlds()
//STRIP001 {
//STRIP001 	SvStringsDtor aDBNames( (BYTE)aUsedDBTLB.GetSelectionCount(), 1 );
//STRIP001 	SvLBoxEntry* pEntry = aUsedDBTLB.FirstSelected();
//STRIP001 
//STRIP001 	while( pEntry )
//STRIP001 	{
//STRIP001 		if( aUsedDBTLB.GetParent( pEntry ))
//STRIP001 		{
//STRIP001 			String* pTmp = new String( aUsedDBTLB.GetEntryText(
//STRIP001 											aUsedDBTLB.GetParent( pEntry )));
//STRIP001 			*pTmp += DB_DELIM;
//STRIP001 			*pTmp += aUsedDBTLB.GetEntryText( pEntry );
//STRIP001 			*pTmp += DB_DELIM;
//STRIP001 			int nCommandType = (int)(ULONG)pEntry->GetUserData();
//STRIP001             *pTmp += String::CreateFromInt32(nCommandType);
//STRIP001 			aDBNames.Insert(pTmp, aDBNames.Count() );
//STRIP001 		}
//STRIP001 		pEntry = aUsedDBTLB.NextSelected(pEntry);
//STRIP001 	}
//STRIP001 
//STRIP001 	pSh->StartAllAction();
//STRIP001 	String sTableName, sColumnName;
//STRIP001     sal_Bool bIsTable = sal_False;
//STRIP001     String sTemp(aAvailDBTLB.GetDBName(sTableName, sColumnName, &bIsTable));
//STRIP001 	sTemp += DB_DELIM;
//STRIP001 	sTemp += sTableName;
//STRIP001     sTemp += DB_DELIM;
//STRIP001     sTemp += bIsTable ? '0' : '1';
//STRIP001 	pSh->ChangeDBFields( aDBNames, sTemp);
//STRIP001 	pSh->EndAllAction();
//STRIP001 }

/*------------------------------------------------------------------------
 Beschreibung:
------------------------------------------------------------------------*/


//STRIP001 IMPL_LINK( SwChangeDBDlg, ButtonHdl, Button *, pBtn )
//STRIP001 {
//STRIP001 	String sTableName, sColumnName;
//STRIP001 	SwDBData aData;
//STRIP001     sal_Bool bIsTable = sal_False;
//STRIP001     aData.sDataSource = aAvailDBTLB.GetDBName(sTableName, sColumnName, &bIsTable);
//STRIP001 	aData.sCommand = sTableName;
//STRIP001     aData.nCommandType = bIsTable ? 0 : 1;;
//STRIP001     pSh->ChgDBData(aData);
//STRIP001 	ShowDBName(pSh->GetDBData());
//STRIP001 	EndDialog(RET_OK);
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }

/*------------------------------------------------------------------------
 Beschreibung:
------------------------------------------------------------------------*/


//STRIP001 IMPL_LINK( SwChangeDBDlg, TreeSelectHdl, SvTreeListBox *, pBox )
//STRIP001 {
//STRIP001 	BOOL bEnable = FALSE;
//STRIP001 
//STRIP001 	SvLBoxEntry* pEntry = aAvailDBTLB.GetCurEntry();
//STRIP001 
//STRIP001 	if (pEntry)
//STRIP001 	{
//STRIP001 		if (aAvailDBTLB.GetParent(pEntry))
//STRIP001 			bEnable = TRUE;
//STRIP001 		aOKBT.Enable( bEnable );
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung: Datenbankname fuer Anzeige wandeln
 --------------------------------------------------------------------*/

//STRIP001 void SwChangeDBDlg::ShowDBName(const SwDBData& rDBData)
//STRIP001 {
//STRIP001 	String sTmp(rDBData.sDataSource);
//STRIP001 	String sName;
//STRIP001 	sTmp += '.';
//STRIP001 	sTmp += (String)rDBData.sCommand;
//STRIP001 
//STRIP001 	for (USHORT i = 0; i < sTmp.Len(); i++)
//STRIP001 	{
//STRIP001 		sName += sTmp.GetChar(i);
//STRIP001 		if (sTmp.GetChar(i) == '~')
//STRIP001 			sName += '~';
//STRIP001 	}
//STRIP001 
//STRIP001 	aDocDBNameFT.SetText(sName);
//STRIP001 }


}
