/*************************************************************************
 *
 *  $RCSfile: sw_docfnote.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:56:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {


//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #ifndef _SFXSTYLE_HXX //autogen
//STRIP001 #include <svtools/style.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _ERRHDL_HXX
//STRIP001 #include <errhdl.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _WRTSH_HXX
//STRIP001 #include <wrtsh.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _VIEW_HXX
//STRIP001 #include <view.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _DOCSH_HXX
//STRIP001 #include <docsh.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _DOCFNOTE_HXX
//STRIP001 #include <docfnote.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _IMPFNOTE_HXX
//STRIP001 #include <impfnote.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _FTNINFO_HXX
//STRIP001 #include <ftninfo.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _FMTCOL_HXX
//STRIP001 #include <fmtcol.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _PAGEDESC_HXX
//STRIP001 #include <pagedesc.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _CHARFMT_HXX //autogen
//STRIP001 #include <charfmt.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _DOCSTYLE_HXX //autogen
//STRIP001 #include <docstyle.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SWWDOCSH_HXX //autogen
//STRIP001 #include <wdocsh.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _UITOOL_HXX
//STRIP001 #include <uitool.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _POOLFMT_HXX
//STRIP001 #include <poolfmt.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _SWSTYLE_H
//STRIP001 #include <swstyle.h>
//STRIP001 #endif
//STRIP001 #ifndef _HELPID_H
//STRIP001 #include <helpid.h>
//STRIP001 #endif
//STRIP001 #ifndef _MISC_HRC
//STRIP001 #include <misc.hrc>
//STRIP001 #endif
//STRIP001 #ifndef _DOCFNOTE_HRC
//STRIP001 #include <docfnote.hrc>
//STRIP001 #endif
//STRIP001 #ifndef _FRMUI_HRC
//STRIP001 #include <frmui.hrc>
//STRIP001 #endif
//STRIP001 #ifndef _SWSTYLENAMEMAPPER_HXX
//STRIP001 #include <SwStyleNameMapper.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 SwFootNoteOptionDlg::SwFootNoteOptionDlg( Window *pParent, SwWrtShell &rS ) :
//STRIP001 	SfxTabDialog( pParent, SW_RES(DLG_DOC_FOOTNOTE) ),
//STRIP001 	rSh( rS )
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 	RemoveResetButton();
//STRIP001 
//STRIP001 	aOldOkHdl = GetOKButton().GetClickHdl();
//STRIP001 	GetOKButton().SetClickHdl( LINK( this, SwFootNoteOptionDlg, OkHdl ) );
//STRIP001 
//STRIP001 	AddTabPage( TP_FOOTNOTEOPTION, SwFootNoteOptionPage::Create, 0 );
//STRIP001 	AddTabPage( TP_ENDNOTEOPTION,  SwEndNoteOptionPage::Create, 0 );
//STRIP001 }
//STRIP001 
//STRIP001 void SwFootNoteOptionDlg::PageCreated( USHORT nId, SfxTabPage &rPage )
//STRIP001 {
//STRIP001 	((SwEndNoteOptionPage&)rPage).SetShell( rSh );
//STRIP001 }
//STRIP001 
//STRIP001 SwFootNoteOptionDlg::~SwFootNoteOptionDlg()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 IMPL_LINK( SwFootNoteOptionDlg, OkHdl, Button *, pBtn )
//STRIP001 {
//STRIP001 	SfxItemSet *pSet = 0;
//STRIP001 	SfxTabPage *pPage = GetTabPage( TP_FOOTNOTEOPTION );
//STRIP001 	if ( pPage )
//STRIP001 		pPage->FillItemSet( (SfxItemSet&)pSet );
//STRIP001 	pPage = GetTabPage( TP_ENDNOTEOPTION  );
//STRIP001 	if ( pPage )
//STRIP001 		pPage->FillItemSet( (SfxItemSet&)pSet );
//STRIP001 	aOldOkHdl.Call( pBtn );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 //----------------------------------------------------------------------
//STRIP001 
//STRIP001 
//STRIP001 SwEndNoteOptionPage::SwEndNoteOptionPage( Window *pParent, BOOL bEN,
//STRIP001 										  const SfxItemSet &rSet ) :
//STRIP001 	SfxTabPage( pParent, SW_RES(bEN ? TP_ENDNOTEOPTION : TP_FOOTNOTEOPTION), rSet ),
//STRIP001 	aNumTypeFT      (this, ResId( FT_NUMTYPE	)),
//STRIP001 	aNumViewBox		(this, ResId( LB_NUMVIEW	), INSERT_NUM_EXTENDED_TYPES),
//STRIP001 	aOffsetLbl		(this, ResId( FT_OFFSET	)),
//STRIP001 	aOffsetFld		(this, ResId( FLD_OFFSET   )),
//STRIP001 	aNumCountFT     (this, ResId( FT_NUMCOUNT   )),
//STRIP001 	aNumCountBox	(this, ResId( LB_NUMCOUNT	)),
//STRIP001 	aPrefixFT		(this, ResId( FT_PREFIX  	)),
//STRIP001 	aPrefixED		(this, ResId( ED_PREFIX    )),
//STRIP001 	aSuffixFT		(this, ResId( FT_SUFFIX    )),
//STRIP001 	aSuffixED		(this, ResId( ED_SUFFIX    )),
//STRIP001 	aPosFT          (this, ResId( FT_POS    )),
//STRIP001 	aPosPageBox		(this, ResId( RB_POS_PAGE	 )),
//STRIP001 	aPosChapterBox	(this, ResId( RB_POS_CHAPTER)),
//STRIP001     aNumFL         (this, ResId( FL_NUM        )),
//STRIP001 
//STRIP001 	aParaTemplLbl	(this, ResId( FT_PARA_TEMPL)),
//STRIP001 	aParaTemplBox	(this, ResId( LB_PARA_TEMPL)),
//STRIP001 	aPageTemplLbl	(this, ResId( FT_PAGE_TEMPL)),
//STRIP001 	aPageTemplBox	(this, ResId( LB_PAGE_TEMPL)),
//STRIP001     aTemplFL       (this, ResId( FL_TEMPL      )),
//STRIP001 
//STRIP001 	aFtnCharTextTemplLbl(	this, ResId( FT_TEXT_CHARFMT)),
//STRIP001 	aFtnCharTextTemplBox(	this, ResId( LB_TEXT_CHARFMT)),
//STRIP001 	aFtnCharAnchorTemplLbl(	this, ResId( FT_ANCHR_CHARFMT)),
//STRIP001 	aFtnCharAnchorTemplBox(	this, ResId( LB_ANCHR_CHARFMT)),
//STRIP001     aCharTemplFL(          this, ResId(FL_CHAR_TEMPL)),
//STRIP001 
//STRIP001 	aContLbl		(this, ResId( FT_CONT		)),
//STRIP001 	aContEdit		(this, ResId( ED_CONT	    )),
//STRIP001 	aContFromLbl	(this, ResId( FT_CONT_FROM )),
//STRIP001 	aContFromEdit	(this, ResId( ED_CONT_FROM )),
//STRIP001     aContFL        (this, ResId( FL_CONT       )),
//STRIP001 
//STRIP001     aNumDoc(aNumCountBox.GetEntry(FTNNUM_DOC)),
//STRIP001     aNumPage(aNumCountBox.GetEntry(FTNNUM_PAGE)),
//STRIP001     aNumChapter(aNumCountBox.GetEntry(FTNNUM_CHAPTER)),
//STRIP001     pSh( 0 ),
//STRIP001 	bPosDoc(FALSE),
//STRIP001 	bEndNote( bEN )
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001     aPosPageBox.SetClickHdl(LINK(this, SwEndNoteOptionPage, PosPageHdl));
//STRIP001     aPosChapterBox.SetClickHdl(LINK(this, SwEndNoteOptionPage, PosChapterHdl));
//STRIP001     aNumCountBox.SetSelectHdl(LINK(this, SwEndNoteOptionPage, NumCountHdl));
//STRIP001 
//STRIP001 }
//STRIP001 
//STRIP001 void SwEndNoteOptionPage::Reset( const SfxItemSet& )
//STRIP001 {
//STRIP001 	SwEndNoteInfo *pInf = bEndNote ? new SwEndNoteInfo( pSh->GetEndNoteInfo() )
//STRIP001 								   : new SwFtnInfo( pSh->GetFtnInfo() );
//STRIP001 	SfxObjectShell * pDocSh = SfxObjectShell::Current();
//STRIP001 	if(PTR_CAST(SwWebDocShell, pDocSh))
//STRIP001 	{
//STRIP001 		aParaTemplLbl	.Hide();
//STRIP001 		aParaTemplBox	.Hide();
//STRIP001 		aPageTemplLbl	.Hide();
//STRIP001 		aPageTemplBox	.Hide();
//STRIP001 		aFtnCharTextTemplLbl.Hide();
//STRIP001 		aFtnCharTextTemplBox.Hide();
//STRIP001 		aFtnCharAnchorTemplLbl.Hide();
//STRIP001 		aFtnCharAnchorTemplBox.Hide();
//STRIP001         aCharTemplFL   .Hide();
//STRIP001         aTemplFL       .Hide();
//STRIP001 	}
//STRIP001 	if ( bEndNote )
//STRIP001 	{
//STRIP001 		aPosPageBox.Hide();
//STRIP001 		aPosChapterBox.Hide();
//STRIP001 		aNumCountBox.Hide();
//STRIP001 		aContLbl.Hide();
//STRIP001 		aContEdit.Hide();
//STRIP001 		aContFromLbl.Hide();
//STRIP001 		aContFromEdit.Hide();
//STRIP001         aContFL.Hide();
//STRIP001 		bPosDoc = TRUE;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		const SwFtnInfo &rInf = pSh->GetFtnInfo();
//STRIP001 		// Position (Seite, Kapitel) setzen
//STRIP001 		if ( rInf.ePos == FTNPOS_PAGE )
//STRIP001 		{
//STRIP001 			aPosPageBox.Check();
//STRIP001 			aPageTemplLbl.Enable(FALSE);
//STRIP001 			aPageTemplBox.Enable(FALSE);
//STRIP001 		}
//STRIP001 		else // if ( rInf.ePos == FTNPOS_CHAPTER )
//STRIP001 		{
//STRIP001 			aPosChapterBox.Check();
//STRIP001 			aNumCountBox.RemoveEntry(aNumPage);
//STRIP001             aNumCountBox.RemoveEntry(aNumChapter);
//STRIP001 			bPosDoc = TRUE;
//STRIP001 		}
//STRIP001 			// Verweistexte
//STRIP001 		aContEdit.SetText(rInf.aQuoVadis);
//STRIP001 		aContFromEdit.SetText(rInf.aErgoSum);
//STRIP001 
//STRIP001 			// gesammelt wo
//STRIP001 		SelectNumbering(rInf.eNum);
//STRIP001 	}
//STRIP001 
//STRIP001 		// Numerierung
//STRIP001 		// Art
//STRIP001 	aNumViewBox.SelectNumberingType( pInf->aFmt.GetNumberingType());
//STRIP001 	aOffsetFld.SetValue(pInf->nFtnOffset + 1);
//STRIP001 	aPrefixED.SetText(pInf->GetPrefix());
//STRIP001 	aSuffixED.SetText(pInf->GetSuffix());
//STRIP001 
//STRIP001 	const SwCharFmt* pCharFmt = pInf->GetCharFmt(
//STRIP001 						*pSh->GetView().GetDocShell()->GetDoc());
//STRIP001 	aFtnCharTextTemplBox.SelectEntry(pCharFmt->GetName());
//STRIP001 	aFtnCharTextTemplBox.SaveValue();
//STRIP001 
//STRIP001 	pCharFmt = pInf->GetAnchorCharFmt( *pSh->GetDoc() );
//STRIP001 	aFtnCharAnchorTemplBox.SelectEntry( pCharFmt->GetName() );
//STRIP001 	aFtnCharAnchorTemplBox.SaveValue();
//STRIP001 
//STRIP001 		// Vorlagen - Sonderbereiche
//STRIP001 		// Absatz
//STRIP001 	SfxStyleSheetBasePool* pStyleSheetPool = pSh->GetView().GetDocShell()->GetStyleSheetPool();
//STRIP001 	pStyleSheetPool->SetSearchMask(SFX_STYLE_FAMILY_PARA, SWSTYLEBIT_EXTRA);
//STRIP001 	SfxStyleSheetBase *pStyle = pStyleSheetPool->First();
//STRIP001 	while(pStyle)
//STRIP001 	{
//STRIP001 		aParaTemplBox.InsertEntry(pStyle->GetName());
//STRIP001 		pStyle = pStyleSheetPool->Next();
//STRIP001 	}
//STRIP001 
//STRIP001 	String sStr;
//STRIP001 	SwStyleNameMapper::FillUIName( bEndNote ? RES_POOLCOLL_ENDNOTE
//STRIP001 						   : RES_POOLCOLL_FOOTNOTE, sStr );
//STRIP001 	if(LISTBOX_ENTRY_NOTFOUND == aParaTemplBox.GetEntryPos( sStr ) )
//STRIP001 		aParaTemplBox.InsertEntry( sStr );
//STRIP001 
//STRIP001 	SwTxtFmtColl* pColl = pInf->GetFtnTxtColl();
//STRIP001 	if( !pColl )
//STRIP001 		aParaTemplBox.SelectEntry( sStr );		// Default
//STRIP001 	else
//STRIP001 	{
//STRIP001 		ASSERT(!pColl->IsDefault(), "Defaultvorlage fuer Fussnoten ist falsch.");
//STRIP001 		const USHORT nPos = aParaTemplBox.GetEntryPos(pColl->GetName());
//STRIP001 		if( LISTBOX_ENTRY_NOTFOUND != nPos )
//STRIP001 			aParaTemplBox.SelectEntryPos( nPos );
//STRIP001 		else
//STRIP001 		{
//STRIP001 			aParaTemplBox.InsertEntry(pColl->GetName());
//STRIP001 			aParaTemplBox.SelectEntry(pColl->GetName());
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 		// Seite
//STRIP001 	for( USHORT i = RES_POOLPAGE_BEGIN; i <= RES_POOLPAGE_ENDNOTE; ++i )
//STRIP001 		aPageTemplBox.InsertEntry(SwStyleNameMapper::GetUIName( i, aEmptyStr ));
//STRIP001 
//STRIP001 	USHORT nCount = pSh->GetPageDescCnt();
//STRIP001 	for(i = 0; i < nCount; ++i)
//STRIP001 	{
//STRIP001 		const SwPageDesc &rPageDesc = pSh->GetPageDesc(i);
//STRIP001 		if(LISTBOX_ENTRY_NOTFOUND == aPageTemplBox.GetEntryPos(rPageDesc.GetName()))
//STRIP001 			aPageTemplBox.InsertEntry(rPageDesc.GetName());
//STRIP001 	}
//STRIP001 
//STRIP001 	aPageTemplBox.SelectEntry( pInf->GetPageDesc( *pSh->GetDoc() )->GetName());
//STRIP001 	delete pInf;
//STRIP001 }
//STRIP001 
//STRIP001 SwEndNoteOptionPage::~SwEndNoteOptionPage()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 SfxTabPage *SwEndNoteOptionPage::Create( Window *pParent, const SfxItemSet &rSet )
//STRIP001 {
//STRIP001 	return new SwEndNoteOptionPage( pParent, TRUE, rSet );
//STRIP001 }
//STRIP001 
//STRIP001 /*------------------------------------------------------------------------
//STRIP001  Beschreibung:	Unterschiedliche Arten der Numerierung; da die Listbox
//STRIP001 				unterschiedlich viele Eintraege hat, hier Funktionen
//STRIP001 				fuer das Setzen und Erfragen der gemeinten Art
//STRIP001 				der Numerierung.
//STRIP001 ------------------------------------------------------------------------*/
//STRIP001 void SwEndNoteOptionPage::SelectNumbering(int eNum)
//STRIP001 {
//STRIP001     String sSelect;
//STRIP001     switch(eNum)
//STRIP001     {
//STRIP001         case FTNNUM_DOC:
//STRIP001             sSelect = aNumDoc;
//STRIP001         break;
//STRIP001         case FTNNUM_PAGE:
//STRIP001             sSelect = aNumPage;
//STRIP001         break;
//STRIP001         case FTNNUM_CHAPTER:
//STRIP001             sSelect = aNumChapter;
//STRIP001         break;
//STRIP001 #ifdef DBG_UTIL
//STRIP001         default:
//STRIP001             DBG_ERROR("Which numbering type?")
//STRIP001 #endif
//STRIP001     }
//STRIP001     aNumCountBox.SelectEntry(sSelect);
//STRIP001     NumCountHdl( &aNumCountBox );
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 int SwEndNoteOptionPage::GetNumbering() const
//STRIP001 {
//STRIP001 	const USHORT nPos = aNumCountBox.GetSelectEntryPos();
//STRIP001 	return (int) bPosDoc? nPos + 1: nPos;
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------09.02.98 11:17-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 void SwEndNoteOptionPage::SetShell( SwWrtShell &rShell )
//STRIP001 {
//STRIP001 	pSh = &rShell;
//STRIP001 	// Zeichenvorlagen sammeln
//STRIP001 	aFtnCharTextTemplBox.Clear();
//STRIP001 	aFtnCharAnchorTemplBox.Clear();
//STRIP001 	::FillCharStyleListBox(aFtnCharTextTemplBox,
//STRIP001 						pSh->GetView().GetDocShell());
//STRIP001 
//STRIP001 	::FillCharStyleListBox(aFtnCharAnchorTemplBox,
//STRIP001 						pSh->GetView().GetDocShell());
//STRIP001 }
//STRIP001 
//STRIP001 /*------------------------------------------------------------------------
//STRIP001  Beschreibung:	Handler hinter dem Button fuer Sammeln der Fussnote
//STRIP001 				auf der Seite.
//STRIP001 				In diesem Fall koennen alle Numerierungsarten verwendet
//STRIP001 				werden.
//STRIP001 ------------------------------------------------------------------------*/
//STRIP001 
//STRIP001 
//STRIP001 IMPL_LINK( SwEndNoteOptionPage, PosPageHdl, Button *, EMPTYARG )
//STRIP001 {
//STRIP001 	const SwFtnNum eNum = (const SwFtnNum)GetNumbering();
//STRIP001 	bPosDoc = FALSE;
//STRIP001     if(LISTBOX_ENTRY_NOTFOUND == aNumCountBox.GetEntryPos(aNumPage))
//STRIP001     {
//STRIP001 		aNumCountBox.InsertEntry(aNumPage, FTNNUM_PAGE);
//STRIP001         aNumCountBox.InsertEntry(aNumChapter, FTNNUM_CHAPTER);
//STRIP001         SelectNumbering(eNum);
//STRIP001 	}
//STRIP001 	aPageTemplLbl.Enable(FALSE);
//STRIP001 	aPageTemplBox.Enable(FALSE);
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*------------------------------------------------------------------------
//STRIP001  Beschreibung:
//STRIP001 ------------------------------------------------------------------------*/
//STRIP001 
//STRIP001 
//STRIP001 IMPL_LINK( SwEndNoteOptionPage, NumCountHdl, ListBox*, EMPTYARG )
//STRIP001 {
//STRIP001 	BOOL bEnable = TRUE;
//STRIP001 	if( aNumCountBox.GetEntryCount() - 1 != aNumCountBox.GetSelectEntryPos() )
//STRIP001 	{
//STRIP001 		bEnable = FALSE;
//STRIP001 		aOffsetFld.SetValue(1);
//STRIP001 	}
//STRIP001 	aOffsetLbl.Enable(bEnable);
//STRIP001 	aOffsetFld.Enable(bEnable);
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*------------------------------------------------------------------------
//STRIP001  Beschreibung:	Handler hinter dem Button fuer Sammeln der Fussnote
//STRIP001 				am Kapitel oder Dokumentende.
//STRIP001 				In diesem Fall kann keine seitenweise Numerierung verwendet
//STRIP001 				werden.
//STRIP001 ------------------------------------------------------------------------*/
//STRIP001 
//STRIP001 
//STRIP001 IMPL_LINK_INLINE_START( SwEndNoteOptionPage, PosChapterHdl, Button *, EMPTYARG )
//STRIP001 {
//STRIP001 	if ( !bPosDoc )
//STRIP001 		SelectNumbering(FTNNUM_DOC);
//STRIP001 
//STRIP001 	bPosDoc = TRUE;
//STRIP001 	aNumCountBox.RemoveEntry(aNumPage);
//STRIP001     aNumCountBox.RemoveEntry(aNumChapter);
//STRIP001     aPageTemplLbl.Enable();
//STRIP001 	aPageTemplBox.Enable();
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 IMPL_LINK_INLINE_END( SwEndNoteOptionPage, PosChapterHdl, Button *, EMPTYARG )
//STRIP001 
//STRIP001 SwCharFmt* lcl_GetCharFormat( SwWrtShell* pSh, const String& rCharFmtName )
//STRIP001 {
//STRIP001 	SwCharFmt* pFmt = 0;
//STRIP001 	USHORT nChCount = pSh->GetCharFmtCount();
//STRIP001 	for(USHORT i = 0; i< nChCount; i++)
//STRIP001 	{
//STRIP001 		SwCharFmt& rChFmt = pSh->GetCharFmt(i);
//STRIP001 		if(rChFmt.GetName() == rCharFmtName )
//STRIP001 		{
//STRIP001 			pFmt = &rChFmt;
//STRIP001 			break;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	if(!pFmt)
//STRIP001 	{
//STRIP001 		SfxStyleSheetBasePool* pPool = pSh->GetView().GetDocShell()->GetStyleSheetPool();
//STRIP001 		SfxStyleSheetBase* pBase;
//STRIP001 		pBase = pPool->Find(rCharFmtName, SFX_STYLE_FAMILY_CHAR);
//STRIP001 		if(!pBase)
//STRIP001 			pBase = &pPool->Make(rCharFmtName, SFX_STYLE_FAMILY_CHAR);
//STRIP001 		pFmt = ((SwDocStyleSheet*)pBase)->GetCharFmt();
//STRIP001 	}
//STRIP001 	return pFmt;
//STRIP001 }
//STRIP001 
//STRIP001 BOOL SwEndNoteOptionPage::FillItemSet( SfxItemSet &rSet )
//STRIP001 {
//STRIP001 	SwEndNoteInfo *pInf = bEndNote ? new SwEndNoteInfo() : new SwFtnInfo();
//STRIP001 
//STRIP001 	pInf->nFtnOffset = aOffsetFld.GetValue() -1;
//STRIP001 	pInf->aFmt.SetNumberingType(aNumViewBox.GetSelectedNumberingType() );
//STRIP001 	pInf->SetPrefix(aPrefixED.GetText());
//STRIP001 	pInf->SetSuffix(aSuffixED.GetText());
//STRIP001 
//STRIP001 	pInf->SetCharFmt( lcl_GetCharFormat( pSh,
//STRIP001 						aFtnCharTextTemplBox.GetSelectEntry() ) );
//STRIP001 	pInf->SetAnchorCharFmt( lcl_GetCharFormat( pSh,
//STRIP001 						aFtnCharAnchorTemplBox.GetSelectEntry() ) );
//STRIP001 
//STRIP001 	// Absatzvorlage
//STRIP001 	USHORT nPos = aParaTemplBox.GetSelectEntryPos();
//STRIP001 	if(LISTBOX_ENTRY_NOTFOUND != nPos)
//STRIP001 	{
//STRIP001 		const String aFmtName( aParaTemplBox.GetSelectEntry() );
//STRIP001 		SwTxtFmtColl *pColl = pSh->GetParaStyle(aFmtName, SwWrtShell::GETSTYLE_CREATEANY);
//STRIP001 		ASSERT(pColl, "Absatzvorlage nicht gefunden.");
//STRIP001 		pInf->SetFtnTxtColl(*pColl);
//STRIP001 	}
//STRIP001 
//STRIP001 	// Seitenvorlage
//STRIP001 	pInf->ChgPageDesc( pSh->FindPageDescByName(
//STRIP001 								aPageTemplBox.GetSelectEntry(), TRUE ) );
//STRIP001 
//STRIP001 	if ( bEndNote )
//STRIP001 	{
//STRIP001 		if ( !(*pInf == pSh->GetEndNoteInfo()) )
//STRIP001 			pSh->SetEndNoteInfo( *pInf );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		SwFtnInfo *pI = (SwFtnInfo*)pInf;
//STRIP001 		pI->ePos = aPosPageBox.IsChecked() ? FTNPOS_PAGE : FTNPOS_CHAPTER;
//STRIP001 		pI->eNum = (SwFtnNum)GetNumbering();
//STRIP001 		pI->aQuoVadis = aContEdit.GetText();
//STRIP001 		pI->aErgoSum = aContFromEdit.GetText();
//STRIP001 		if ( !(*pI == pSh->GetFtnInfo()) )
//STRIP001 			pSh->SetFtnInfo( *pI );
//STRIP001 	}
//STRIP001 	delete pInf;
//STRIP001 	return TRUE;
//STRIP001 }
//STRIP001 
//STRIP001 SwFootNoteOptionPage::SwFootNoteOptionPage( Window *pParent, const SfxItemSet &rSet ) :
//STRIP001 	SwEndNoteOptionPage( pParent, FALSE, rSet )
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 SwFootNoteOptionPage::~SwFootNoteOptionPage()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 SfxTabPage *SwFootNoteOptionPage::Create(Window *pParent, const SfxItemSet &rSet )
//STRIP001 {
//STRIP001 	return new SwFootNoteOptionPage( pParent, rSet );
//STRIP001 }







}
