/*************************************************************************
 *
 *  $RCSfile: sw_textsh1.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 19:21:16 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _COM_SUN_STAR_UI_DIALOGS_XEXECUTABLEDIALOG_HPP_
#include <com/sun/star/ui/dialogs/XExecutableDialog.hpp>
#endif
#ifndef _COMPHELPER_PROCESSFACTORY_HXX_
#include <comphelper/processfactory.hxx>
#endif

#pragma hdrstop

#ifndef _HINTIDS_HXX
#include <hintids.hxx>
#endif
#ifndef _CMDID_H
#include <cmdid.h>
#endif
#ifndef _HELPID_H
#include <helpid.h>
#endif

#ifndef _SFXSTRITEM_HXX
#include <svtools/stritem.hxx>
#endif
#ifndef _SVX_HTMLMODE_HXX //autogen
#include <bf_svx/htmlmode.hxx>
#endif
#ifndef _SFX_WHITER_HXX //autogen
#include <svtools/whiter.hxx>
#endif
#ifndef _SFX_BINDINGS_HXX //autogen
#include <bf_sfx2/bindings.hxx>
#endif
#ifndef _SFXDISPATCH_HXX //autogen
#include <bf_sfx2/dispatch.hxx>
#endif
#ifndef _SFX_OBJITEM_HXX //autogen
#include <bf_sfx2/objitem.hxx>
#endif
#ifndef _OFF_APP_HXX //autogen
#include <bf_offmgr/app.hxx>
#endif
#ifndef _OFAACCFG_HXX //autogen
#include <bf_offmgr/ofaaccfg.hxx>
#endif
#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _SFXREQUEST_HXX //autogen
#include <bf_sfx2/request.hxx>
#endif
#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif
#ifndef _SFXMACITEM_HXX
#include <svtools/macitem.hxx>
#endif
#ifndef _SVX_LRSPITEM_HXX //autogen
#include <bf_svx/lrspitem.hxx>
#endif
#ifndef _SVX_ULSPITEM_HXX //autogen
#include <bf_svx/ulspitem.hxx>
#endif
#ifndef _SVX_COLRITEM_HXX //autogen
#include <bf_svx/colritem.hxx>
#endif
#ifndef _SVX_TSTPITEM_HXX //autogen
#include <bf_svx/tstpitem.hxx>
#endif
#ifndef _SVX_BRSHITEM_HXX //autogen
#include <bf_svx/brshitem.hxx>
#endif
#ifndef _MySVXACORR_HXX //autogen
#include <bf_svx/svxacorr.hxx>
#endif
#ifndef _SVTOOLS_CJKOPTIONS_HXX
#include <svtools/cjkoptions.hxx>
#endif

#ifndef _CHARFMT_HXX
#include <charfmt.hxx>
#endif
#ifndef _SVX_FONTITEM_HXX
#include <bf_svx/fontitem.hxx>
#endif
#ifndef _SVX_DIALMGR_HXX
#include <bf_svx/dialmgr.hxx>
#endif
#ifndef _FMTINFMT_HXX //autogen
#include <fmtinfmt.hxx>
#endif
#ifndef _SWWAIT_HXX
#include <swwait.hxx>
#endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

#ifndef _WRTSH_HXX
#include <wrtsh.hxx>
#endif
#ifndef _WVIEW_HXX
#include <wview.hxx>
#endif
#ifndef _SWMODULE_HXX
#include <swmodule.hxx>
#endif
#ifndef _VIEWOPT_HXX
#include <viewopt.hxx>
#endif
#ifndef _UITOOL_HXX
#include <uitool.hxx>
#endif
#ifndef _UIPARAM_HXX
#include <uiparam.hxx>
#endif
#ifndef _SWEVENT_HXX
#include <swevent.hxx>
#endif
#ifndef _FMTHDFT_HXX //autogen
#include <fmthdft.hxx>
#endif
#ifndef _PAGEDESC_HXX
#include <pagedesc.hxx>
#endif
#ifndef _TEXTSH_HXX
#include <textsh.hxx>
#endif
#ifndef _BOOKMARK_HXX
#include <bookmark.hxx>
#endif
#ifndef _BOOKMRK_HXX
#include <bookmrk.hxx>
#endif
#ifndef _BREAK_HXX
#include <break.hxx>
#endif
#ifndef _SWDTFLVR_HXX
#include <swdtflvr.hxx>
#endif
#ifndef _DOCSTAT_HXX
#include <docstat.hxx>
#endif
#ifndef _INSFNOTE_HXX
#include <insfnote.hxx>
#endif
#ifndef _OUTLINE_HXX
#include <outline.hxx>
#endif
#ifndef _SRTDLG_HXX
#include <srtdlg.hxx>
#endif
#ifndef _TABLEMGR_HXX
#include <tablemgr.hxx>
#endif
#ifndef _SWUNDO_HXX
#include <swundo.hxx>		// fuer Undo-IDs
#endif
#ifndef _REFFLD_HXX
#include <reffld.hxx>
#endif
#ifndef _DOCSH_HXX
#include <docsh.hxx>
#endif
#ifndef _MDIEXP_HXX
#include <mdiexp.hxx>
#endif
#ifndef _INPUTWIN_HXX
#include <inputwin.hxx>
#endif
#ifndef _PARDLG_HXX
#include <pardlg.hxx>
#endif
#ifndef _CHRDLG_HXX
#include <chrdlg.hxx>
#endif
#ifndef _DOCFNOTE_HXX
#include <docfnote.hxx>
#endif
#ifndef _FRMATR_HXX
#include <frmatr.hxx>
#endif
#ifndef _FMTCOL_HXX
#include <fmtcol.hxx>
#endif
#ifndef _CELLATR_HXX
#include <cellatr.hxx>
#endif
#ifndef _EDTWIN_HXX
#include <edtwin.hxx>
#endif
#ifndef _REDLNDLG_HXX
#include <redlndlg.hxx>
#endif
#ifndef _REDLENUM_HXX
#include <redlenum.hxx>
#endif
#include "fldmgr.hxx"

#ifndef _GLOBALS_HRC
#include <globals.hrc>
#endif
#ifndef _SHELLS_HRC
#include <shells.hrc>
#endif
#ifndef _APP_HRC
#include <app.hrc>
#endif
#ifndef _WEB_HRC
#include <web.hrc>
#endif
#ifndef _PARATR_HXX
#include "paratr.hxx"
#endif
#ifndef _CRSSKIP_HXX
#include <crsskip.hxx>
#endif
#ifndef _LEGACYBINFILTERMGR_HXX
#include <legacysmgr/legacy_binfilters_smgr.hxx>	//STRIP002 
#endif
namespace binfilter {
/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 short lcl_AskRedlineMode(Window *pWin)
//STRIP001 {
//STRIP001 	MessBox aQBox( pWin, 0,
//STRIP001 					String( SW_RES( STR_REDLINE_TITLE ) ),
//STRIP001 					String( SW_RES( STR_REDLINE_MSG ) ) );
//STRIP001 	aQBox.SetImage( QueryBox::GetStandardImage() );
//STRIP001 	USHORT nBtnFlags = BUTTONDIALOG_DEFBUTTON |
//STRIP001 						BUTTONDIALOG_OKBUTTON |
//STRIP001 						BUTTONDIALOG_FOCUSBUTTON;
//STRIP001 
//STRIP001 	aQBox.AddButton(String(SW_RES(STR_REDLINE_ACCEPT_ALL)), RET_OK, nBtnFlags);
//STRIP001 	aQBox.GetPushButton( RET_OK )->SetHelpId(HID_AUTOFORMAT_ACCEPT);
//STRIP001 	aQBox.AddButton(String(SW_RES(STR_REDLINE_REJECT_ALL)), RET_CANCEL, BUTTONDIALOG_CANCELBUTTON);
//STRIP001 	aQBox.GetPushButton( RET_CANCEL )->SetHelpId(HID_AUTOFORMAT_REJECT  );
//STRIP001 	aQBox.AddButton(String(SW_RES(STR_REDLINE_EDIT)), 2, 0);
//STRIP001 	aQBox.GetPushButton( 2 )->SetHelpId(HID_AUTOFORMAT_EDIT_CHG);
//STRIP001 	aQBox.SetButtonHelpText( RET_OK, aEmptyStr );
//STRIP001 
//STRIP001 	return aQBox.Execute();
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 void SwTextShell::Execute(SfxRequest &rReq)
//STRIP001 {
//STRIP001     BOOL bUseDialog = TRUE;
//STRIP001 	const SfxItemSet *pArgs = rReq.GetArgs();
//STRIP001 	SwWrtShell& rWrtSh = GetShell();
//STRIP001 	const SfxPoolItem* pItem = 0;
//STRIP001 	USHORT nSlot = rReq.GetSlot();
//STRIP001 	if(pArgs)
//STRIP001 		pArgs->GetItemState(GetPool().GetWhich(nSlot), FALSE, &pItem);
//STRIP001 	switch( nSlot )
//STRIP001 	{
//STRIP001 		case FN_INSERT_SYMBOL:
//STRIP001 		{
//STRIP001             InsertSymbol( rReq );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_INSERT_FOOTNOTE:
//STRIP001 		case FN_INSERT_ENDNOTE:
//STRIP001         {
//STRIP001             String aStr;
//STRIP001             SFX_REQUEST_ARG( rReq, pFont, SfxStringItem, FN_PARAM_1 , sal_False );
//STRIP001             SFX_REQUEST_ARG( rReq, pCharset, SfxInt16Item, FN_PARAM_2 , sal_False );
//STRIP001             SFX_REQUEST_ARG( rReq, pItem, SfxStringItem, nSlot , sal_False );
//STRIP001             if ( pItem )
//STRIP001                 aStr = pItem->GetValue();
//STRIP001             BOOL bFont = pFont && pFont->GetValue().Len();
//STRIP001             rWrtSh.StartUndo( UIUNDO_INSERT_FOOTNOTE );
//STRIP001             rWrtSh.InsertFootnote( aStr, nSlot == FN_INSERT_ENDNOTE, !bFont );
//STRIP001             if ( bFont )
//STRIP001             {
//STRIP001                 rWrtSh.Left( CRSR_SKIP_CHARS, TRUE, 1, FALSE );
//STRIP001                 SfxItemSet aSet( rWrtSh.GetAttrPool(), RES_CHRATR_FONT, RES_CHRATR_FONT );
//STRIP001                 rWrtSh.GetAttr( aSet );
//STRIP001                 SvxFontItem &rFont = (SvxFontItem &) aSet.Get( RES_CHRATR_FONT );
//STRIP001                 SvxFontItem aFont( rFont.GetFamily(), pFont->GetValue(),
//STRIP001                                     rFont.GetStyleName(), rFont.GetPitch() );
//STRIP001                                     //pCharset ? (CharSet) pCharset->GetValue() : RTL_TEXTENCODING_DONTKNOW );
//STRIP001                 rWrtSh.SetAttr( aSet, SETATTR_DONTEXPAND );
//STRIP001                 rWrtSh.ResetSelect(0, FALSE);
//STRIP001                 rWrtSh.EndSelect();
//STRIP001                 rWrtSh.GotoFtnTxt();
//STRIP001             }
//STRIP001             rWrtSh.EndUndo( UIUNDO_INSERT_FOOTNOTE );
//STRIP001             rReq.Done();
//STRIP001         }
//STRIP001 		break;
//STRIP001 		case FN_INSERT_FOOTNOTE_DLG:
//STRIP001 		{
//STRIP001             SwInsFootNoteDlg *pDlg = new SwInsFootNoteDlg( GetView().GetWindow(), rWrtSh, FALSE );
//STRIP001 			pDlg->SetHelpId(nSlot);
//STRIP001             if ( pDlg->Execute() == RET_OK )
//STRIP001             {
//STRIP001                 USHORT nId = pDlg->IsEndNote() ? FN_INSERT_ENDNOTE : FN_INSERT_FOOTNOTE;
//STRIP001                 SfxRequest aReq( GetView().GetViewFrame(), nId );
//STRIP001                 if ( pDlg->GetStr().Len() )
//STRIP001                     aReq.AppendItem( SfxStringItem( nId, pDlg->GetStr() ) );
//STRIP001                 if ( pDlg->GetFontName().Len() )
//STRIP001                     aReq.AppendItem( SfxStringItem( FN_PARAM_1, pDlg->GetFontName() ) );
//STRIP001                 //aReq.AppendItem( SfxStringItem( FN_PARAM_2, pDlg->GetCharSet() ) );
//STRIP001                 ExecuteSlot( aReq );
//STRIP001             }
//STRIP001 
//STRIP001             rReq.Ignore();
//STRIP001             delete pDlg;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_FORMAT_FOOTNOTE_DLG:
//STRIP001 		{
//STRIP001 			SwFootNoteOptionDlg *pDlg = new SwFootNoteOptionDlg(GetView().GetWindow(), rWrtSh);
//STRIP001 			pDlg->Execute();
//STRIP001 			delete pDlg;
//STRIP001 			break;
//STRIP001 		}
//STRIP001 		case SID_INSERT_GRAPHIC:
//STRIP001             //if (!pItem)
//STRIP001 			{
//STRIP001                 rReq.SetReturnValue(SfxBoolItem(nSlot, InsertGraphicDlg( rReq )));
//STRIP001 			}
//STRIP001 /*
//STRIP001 			else
//STRIP001 			{
//STRIP001 				String rName = aEmptyStr;
//STRIP001 				BOOL bLink = FALSE;
//STRIP001 				rName = ((const SfxStringItem *)pItem)->GetValue();
//STRIP001 				String rFilter = aEmptyStr;
//STRIP001 
//STRIP001                 if ( SFX_ITEM_SET == pArgs->GetItemState(FN_PARAM_FILTER, TRUE, &pItem) )
//STRIP001 					rFilter = ((const SfxStringItem *)pItem)->GetValue();
//STRIP001                 if ( SFX_ITEM_SET == pArgs->GetItemState(FN_PARAM_1, TRUE, &pItem) )
//STRIP001 					bLink = ((const SfxBoolItem *)pItem)->GetValue();
//STRIP001 
//STRIP001 				if ( !rName.Len() )
//STRIP001                     rReq.SetReturnValue(SfxBoolItem(nSlot, InsertGraphicDlg()));
//STRIP001 				else
//STRIP001 					rReq.SetReturnValue(SfxBoolItem(nSlot, InsertGraphic( rName, rFilter, bLink )));
//STRIP001 			}
//STRIP001 */
//STRIP001 			break;
//STRIP001 		case SID_INSERTDOC:
//STRIP001 			if (!pItem)
//STRIP001             {
//STRIP001 				rReq.SetReturnValue(SfxBoolItem(nSlot, GetView().InsertDoc(nSlot, aEmptyStr, aEmptyStr) != -1));
//STRIP001                 rReq.Ignore();
//STRIP001             }
//STRIP001 			else
//STRIP001 			{
//STRIP001 				String aFile 	= aEmptyStr;
//STRIP001 				String aFilter	= aEmptyStr;
//STRIP001 				aFile = ((const SfxStringItem *)pItem)->GetValue();
//STRIP001 				if(SFX_ITEM_SET == pArgs->GetItemState(FN_PARAM_1, TRUE, &pItem ))
//STRIP001 					aFilter = ((const SfxStringItem *)pItem)->GetValue();
//STRIP001 
//STRIP001 				rReq.SetReturnValue(SfxBoolItem(nSlot, GetView().InsertDoc( nSlot, aFile, aFilter ) != -1));
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		case FN_FORMAT_RESET:
//STRIP001 			rWrtSh.ResetAttr();
//STRIP001 			break;
//STRIP001 		case FN_INSERT_BREAK_DLG:
//STRIP001 		{
//STRIP001             USHORT nKind=0, nPageNumber=0;
//STRIP001             String aTemplateName;
//STRIP001             if ( pItem )
//STRIP001             {
//STRIP001                 nKind = ((SfxInt16Item*)pItem)->GetValue();
//STRIP001                 SFX_REQUEST_ARG( rReq, pTemplate, SfxStringItem, FN_PARAM_1 , sal_False );
//STRIP001                 SFX_REQUEST_ARG( rReq, pNumber, SfxUInt16Item, FN_PARAM_2 , sal_False );
//STRIP001                 if ( pTemplate )
//STRIP001                     aTemplateName = pTemplate->GetValue();
//STRIP001                 if ( pNumber )
//STRIP001                     nPageNumber = pNumber->GetValue();
//STRIP001             }
//STRIP001             else
//STRIP001             {
//STRIP001                 SwBreakDlg *pDlg = new SwBreakDlg(GetView().GetWindow(), rWrtSh);
//STRIP001                 if ( pDlg->Execute() == RET_OK )
//STRIP001                 {
//STRIP001                     nKind = pDlg->GetKind();
//STRIP001                     aTemplateName = pDlg->GetTemplateName();
//STRIP001                     nPageNumber = pDlg->GetPageNumber();
//STRIP001                     rReq.AppendItem( SfxInt16Item( FN_INSERT_BREAK_DLG, nKind ) );
//STRIP001                     rReq.AppendItem( SfxUInt16Item( FN_PARAM_2, nPageNumber ) );
//STRIP001                     rReq.AppendItem( SfxStringItem( FN_PARAM_1, aTemplateName ) );
//STRIP001                     rReq.Done();
//STRIP001                 }
//STRIP001                 else
//STRIP001                     rReq.Ignore();
//STRIP001                 delete pDlg;
//STRIP001             }
//STRIP001 
//STRIP001             switch ( nKind )
//STRIP001             {
//STRIP001                 case 1 :
//STRIP001                     rWrtSh.InsertLineBreak(); break;
//STRIP001                 case 2 :
//STRIP001                     rWrtSh.InsertColumnBreak(); break;
//STRIP001                 case 3 :
//STRIP001                 {
//STRIP001                     rWrtSh.StartAllAction();
//STRIP001                     if( aTemplateName.Len() )
//STRIP001                         rWrtSh.InsertPageBreak( &aTemplateName, nPageNumber );
//STRIP001                     else
//STRIP001                         rWrtSh.InsertPageBreak();
//STRIP001                     rWrtSh.EndAllAction();
//STRIP001                 }
//STRIP001             }
//STRIP001 
//STRIP001 			break;
//STRIP001 		}
//STRIP001 		case FN_INSERT_BOOKMARK:
//STRIP001 		{
//STRIP001             if ( pItem )
//STRIP001             {
//STRIP001                 String sName = ((SfxStringItem*)pItem)->GetValue();
//STRIP001                 rWrtSh.MakeUniqueBookmarkName(sName);
//STRIP001                 rWrtSh.SetBookmark( KeyCode(), sName, aEmptyStr );
//STRIP001             }
//STRIP001             else
//STRIP001             {
//STRIP001                 SwInsertBookmarkDlg *pDlg = new SwInsertBookmarkDlg( GetView().GetWindow(), rWrtSh, rReq );
//STRIP001                 pDlg->Execute();
//STRIP001                 delete pDlg;
//STRIP001             }
//STRIP001 
//STRIP001             break;
//STRIP001 		}
//STRIP001         case FN_DELETE_BOOKMARK:
//STRIP001         {
//STRIP001             if ( pItem )
//STRIP001                 rWrtSh.DelBookmark( ((SfxStringItem*)pItem)->GetValue() );
//STRIP001             break;
//STRIP001         }
//STRIP001 		case FN_AUTOFORMAT_REDLINE_APPLY:
//STRIP001 		{
//STRIP001 			SvxSwAutoFmtFlags aFlags(OFF_APP()->GetAutoCorrect()->GetSwFlags());
//STRIP001 			// das muss fuer die Nachbearbeitung immer FALSE sein
//STRIP001 			aFlags.bAFmtByInput = FALSE;
//STRIP001 			aFlags.bWithRedlining = TRUE;
//STRIP001 			rWrtSh.AutoFormat( &aFlags );
//STRIP001 			aFlags.bWithRedlining = FALSE;
//STRIP001 
//STRIP001 			SfxViewFrame* pVFrame = GetView().GetViewFrame();
//STRIP001 			if (pVFrame->HasChildWindow(FN_REDLINE_ACCEPT))
//STRIP001 				pVFrame->ToggleChildWindow(FN_REDLINE_ACCEPT);
//STRIP001 
//STRIP001 			SwModalRedlineAcceptDlg aDlg(&GetView().GetEditWin());
//STRIP001 
//STRIP001 			switch (lcl_AskRedlineMode(&GetView().GetEditWin()))
//STRIP001 			{
//STRIP001 				case RET_OK:
//STRIP001                 {
//STRIP001 					aDlg.AcceptAll(TRUE);
//STRIP001                     SfxRequest aReq( pVFrame, FN_AUTOFORMAT_APPLY );
//STRIP001                     aReq.Done();
//STRIP001                     rReq.Ignore();
//STRIP001 					break;
//STRIP001                 }
//STRIP001 
//STRIP001 				case RET_CANCEL:
//STRIP001 					aDlg.AcceptAll(FALSE);
//STRIP001                     rReq.Ignore();
//STRIP001 					break;
//STRIP001 
//STRIP001 				case 2:
//STRIP001 					aDlg.Execute();
//STRIP001                     rReq.Done();
//STRIP001 					break;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case FN_AUTOFORMAT_APPLY:
//STRIP001 		{
//STRIP001 			SvxSwAutoFmtFlags aFlags(OFF_APP()->GetAutoCorrect()->GetSwFlags());
//STRIP001 			// das muss fuer die Nachbearbeitung immer FALSE sein
//STRIP001 			aFlags.bAFmtByInput = FALSE;
//STRIP001 			rWrtSh.AutoFormat( &aFlags );
//STRIP001             rReq.Done();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_AUTOFORMAT_AUTO:
//STRIP001 		{
//STRIP001 			OfaAutoCorrCfg*	pACfg = OFF_APP()->GetAutoCorrConfig();
//STRIP001             BOOL bSet = pItem ? ((const SfxBoolItem*)pItem)->GetValue() : !pACfg->IsAutoFmtByInput();
//STRIP001 			if( bSet != pACfg->IsAutoFmtByInput() )
//STRIP001             {
//STRIP001 				pACfg->SetAutoFmtByInput( bSet );
//STRIP001                 GetView().GetViewFrame()->GetBindings().Invalidate( nSlot );
//STRIP001                 if ( !pItem )
//STRIP001                     rReq.AppendItem( SfxBoolItem( GetPool().GetWhich(nSlot), bSet ) );
//STRIP001                 rReq.Done();
//STRIP001             }
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_AUTO_CORRECT:
//STRIP001 		{
//STRIP001 			// erstmal auf Blank defaulten
//STRIP001 			sal_Unicode cChar = ' ';
//STRIP001 			rWrtSh.AutoCorrect( *OFF_APP()->GetAutoCorrect(), cChar );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case FN_SORTING_DLG:
//STRIP001 		{
//STRIP001 			SwSortDlg *pDlg = new SwSortDlg(GetView().GetWindow(), rWrtSh );
//STRIP001 			pDlg->Execute();
//STRIP001 			delete pDlg;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_NUMBERING_OUTLINE_DLG:
//STRIP001 		{
//STRIP001 			SfxItemSet aTmp(GetPool(), FN_PARAM_1, FN_PARAM_1);
//STRIP001 			SwOutlineTabDialog* pDlg = new SwOutlineTabDialog(GetView().GetWindow(), &aTmp, rWrtSh);
//STRIP001 			pDlg->Execute();
//STRIP001 			delete pDlg;
//STRIP001 		}
//STRIP001 			break;
//STRIP001 		case FN_CALCULATE:
//STRIP001 			{
//STRIP001 				SwTransferable* pTransfer = new SwTransferable( rWrtSh );
//STRIP001 /*??*/			::com::sun::star::uno::Reference<
//STRIP001 					::com::sun::star::datatransfer::XTransferable > xRef(
//STRIP001 													pTransfer );
//STRIP001 				pTransfer->CalculateAndCopy();
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		case FN_GOTO_REFERENCE:
//STRIP001 		{
//STRIP001 			SwField *pFld = rWrtSh.GetCurFld();
//STRIP001 			if(pFld && pFld->GetTypeId() == TYP_GETREFFLD)
//STRIP001 			{
//STRIP001 				rWrtSh.StartAllAction();
//STRIP001 				rWrtSh.SwCrsrShell::GotoRefMark( ((SwGetRefField*)pFld)->GetSetRefName(),
//STRIP001 									((SwGetRefField*)pFld)->GetSubType(),
//STRIP001 									((SwGetRefField*)pFld)->GetSeqNo() );
//STRIP001 				rWrtSh.EndAllAction();
//STRIP001 			}
//STRIP001 		}
//STRIP001 			break;
//STRIP001 		case FN_EDIT_FORMULA:
//STRIP001 		{
//STRIP001             const USHORT nId = SwInputChild::GetChildWindowId();
//STRIP001             SfxViewFrame* pVFrame = GetView().GetViewFrame();
//STRIP001             if(pItem)
//STRIP001             {
//STRIP001                 //if the ChildWindow is active it has to be removed
//STRIP001                 if( pVFrame->HasChildWindow( nId ) )
//STRIP001                 {
//STRIP001                     pVFrame->ToggleChildWindow( nId );
//STRIP001                     pVFrame->GetBindings().InvalidateAll( TRUE );
//STRIP001                 }
//STRIP001 
//STRIP001                 String sFormula(((const SfxStringItem*)pItem)->GetValue());
//STRIP001                 SwFldMgr aFldMgr;
//STRIP001                 rWrtSh.StartAllAction();
//STRIP001                 BOOL bDelSel;
//STRIP001                 if( 0 != (bDelSel = rWrtSh.HasSelection()) )
//STRIP001                 {
//STRIP001                     rWrtSh.StartUndo( UNDO_START );
//STRIP001                     rWrtSh.DelRight();
//STRIP001                 }
//STRIP001                 else
//STRIP001                 {
//STRIP001                     rWrtSh.EnterStdMode();
//STRIP001                 }
//STRIP001 
//STRIP001                 if( !bDelSel && aFldMgr.GetCurFld() && TYP_FORMELFLD == aFldMgr.GetCurTypeId() )
//STRIP001                     aFldMgr.UpdateCurFld( aFldMgr.GetCurFld()->GetFormat(), aEmptyStr, sFormula );
//STRIP001                 else if( sFormula.Len() )
//STRIP001                 {
//STRIP001                     if( rWrtSh.IsCrsrInTbl() )
//STRIP001                     {
//STRIP001                         SfxItemSet aSet( rWrtSh.GetAttrPool(), RES_BOXATR_FORMULA, RES_BOXATR_FORMULA );
//STRIP001                         aSet.Put( SwTblBoxFormula( sFormula ));
//STRIP001                         rWrtSh.SetTblBoxFormulaAttrs( aSet );
//STRIP001                         rWrtSh.UpdateTable();
//STRIP001                     }
//STRIP001                     else
//STRIP001                     {
//STRIP001                         SvNumberFormatter* pFormatter = rWrtSh.GetNumberFormatter();
//STRIP001                         ULONG nSysNumFmt = pFormatter->GetFormatIndex( NF_NUMBER_STANDARD, LANGUAGE_SYSTEM);
//STRIP001                         SwInsertFld_Data aData(TYP_FORMELFLD, GSE_FORMULA, aEmptyStr, sFormula, nSysNumFmt);
//STRIP001                         aFldMgr.InsertFld(aData);
//STRIP001                     }
//STRIP001                 }
//STRIP001 
//STRIP001                 if( bDelSel )
//STRIP001                     rWrtSh.EndUndo( UNDO_END );
//STRIP001                 rWrtSh.EndAllAction();
//STRIP001                 rReq.Done();
//STRIP001             }
//STRIP001             else
//STRIP001             {
//STRIP001                 rWrtSh.EndAllTblBoxEdit();
//STRIP001                 pVFrame->ToggleChildWindow( nId );
//STRIP001                 if( !pVFrame->HasChildWindow( nId ) )
//STRIP001                     pVFrame->GetBindings().InvalidateAll( TRUE );
//STRIP001                 rReq.Ignore();
//STRIP001             }
//STRIP001 		}
//STRIP001 
//STRIP001 		break;
//STRIP001 		case FN_TABLE_UNSET_READ_ONLY:
//STRIP001 		{
//STRIP001 			rWrtSh.UnProtectTbls();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_EDIT_HYPERLINK:
//STRIP001 			GetView().GetViewFrame()->ToggleChildWindow(SID_HYPERLINK_DIALOG);
//STRIP001 		break;
//STRIP001         case SID_ATTR_BRUSH_CHAR :
//STRIP001         case SID_ATTR_CHAR_SCALEWIDTH :
//STRIP001         case SID_ATTR_CHAR_ROTATED :
//STRIP001         case FN_TXTATR_INET :
//STRIP001 		case FN_INSERT_HYPERLINK:
//STRIP001         {
//STRIP001             USHORT nWhich = GetPool().GetWhich( nSlot );
//STRIP001             if ( pArgs && pArgs->GetItemState( nWhich ) == SFX_ITEM_SET )
//STRIP001                 bUseDialog = FALSE;
//STRIP001             // intentionally no break
//STRIP001         }
//STRIP001 		case SID_CHAR_DLG:
//STRIP001 		{
//STRIP001             FieldUnit eMetric = ::GetDfltMetric(0 != PTR_CAST(SwWebView, &GetView()));
//STRIP001             SW_MOD()->PutItem(SfxUInt16Item(SID_ATTR_METRIC, eMetric));
//STRIP001             SfxItemSet aCoreSet( GetPool(),
//STRIP001                                 RES_CHRATR_BEGIN,      RES_CHRATR_END-1,
//STRIP001                                 RES_TXTATR_INETFMT,    RES_TXTATR_INETFMT,
//STRIP001                                 RES_BACKGROUND,        RES_BACKGROUND,
//STRIP001                                 FN_PARAM_SELECTION,    FN_PARAM_SELECTION,
//STRIP001                                 SID_HTML_MODE,         SID_HTML_MODE,
//STRIP001                                 SID_ATTR_CHAR_WIDTH_FIT_TO_LINE,   SID_ATTR_CHAR_WIDTH_FIT_TO_LINE,
//STRIP001                                 0 );
//STRIP001             rWrtSh.GetAttr( aCoreSet );
//STRIP001             BOOL bSel = rWrtSh.HasSelection();
//STRIP001             BOOL bSelectionPut = FALSE;
//STRIP001             if(bSel || rWrtSh.IsInWord())
//STRIP001             {
//STRIP001                 if(!bSel)
//STRIP001                 {
//STRIP001                     rWrtSh.StartAction();
//STRIP001                     rWrtSh.Push();
//STRIP001                     if(!rWrtSh.SelectTxtAttr( RES_TXTATR_INETFMT ))
//STRIP001                         rWrtSh.SelWrd();
//STRIP001                 }
//STRIP001                 aCoreSet.Put(SfxStringItem(FN_PARAM_SELECTION, rWrtSh.GetSelTxt()));
//STRIP001                 bSelectionPut = TRUE;
//STRIP001                 if(!bSel)
//STRIP001                 {
//STRIP001                     rWrtSh.Pop(FALSE);
//STRIP001                     rWrtSh.EndAction();
//STRIP001                 }
//STRIP001             }
//STRIP001 
//STRIP001             aCoreSet.Put( SfxUInt16Item( SID_ATTR_CHAR_WIDTH_FIT_TO_LINE,
//STRIP001                             rWrtSh.GetScalingOfSelectedText() ) );
//STRIP001 
//STRIP001             // Das CHRATR_BACKGROUND-Attribut wird fuer den Dialog in
//STRIP001             // ein RES_BACKGROUND verwandelt und wieder zurueck ...
//STRIP001             const SfxPoolItem *pTmpBrush;
//STRIP001             if( SFX_ITEM_SET == aCoreSet.GetItemState( RES_CHRATR_BACKGROUND, TRUE, &pTmpBrush ) )
//STRIP001             {
//STRIP001                 SvxBrushItem aTmpBrush( *((SvxBrushItem*)pTmpBrush) );
//STRIP001                 aTmpBrush.SetWhich( RES_BACKGROUND );
//STRIP001                 aCoreSet.Put( aTmpBrush );
//STRIP001             }
//STRIP001 
//STRIP001             aCoreSet.Put(SfxUInt16Item(SID_HTML_MODE, ::binfilter::GetHtmlMode(GetView().GetDocShell())));
//STRIP001             SwCharDlg* pDlg = NULL;
//STRIP001             if ( bUseDialog && GetActiveView() )
//STRIP001             {
//STRIP001                 pDlg = new SwCharDlg(GetView().GetWindow(), GetView(), aCoreSet);
//STRIP001                 if( FN_INSERT_HYPERLINK == nSlot )
//STRIP001                     pDlg->SetCurPageId(TP_CHAR_URL);
//STRIP001             }
//STRIP001 
//STRIP001             const SfxItemSet* pSet = NULL;
//STRIP001             if ( !bUseDialog )
//STRIP001                 pSet = pArgs;
//STRIP001             else if ( NULL != pDlg && pDlg->Execute() == RET_OK ) /* #110771# pDlg can be NULL */
//STRIP001             {
//STRIP001                 pSet = pDlg->GetOutputItemSet();
//STRIP001             }
//STRIP001 
//STRIP001             if ( pSet)
//STRIP001             {
//STRIP001                 SfxItemSet aTmpSet( *pSet );
//STRIP001                 if( SFX_ITEM_SET == aTmpSet.GetItemState( RES_BACKGROUND, FALSE, &pTmpBrush ) )
//STRIP001                 {
//STRIP001                     SvxBrushItem aTmpBrush( *((SvxBrushItem*)pTmpBrush) );
//STRIP001                     aTmpBrush.SetWhich( RES_CHRATR_BACKGROUND );
//STRIP001                     aTmpSet.Put( aTmpBrush );
//STRIP001                 }
//STRIP001 
//STRIP001                 aTmpSet.ClearItem( RES_BACKGROUND );
//STRIP001 
//STRIP001                 const SfxPoolItem* pItem;
//STRIP001                 BOOL bInsert = FALSE;
//STRIP001 				xub_StrLen nInsert = 0;
//STRIP001 
//STRIP001                 // aus ungeklaerter Ursache ist das alte Item wieder im Set
//STRIP001                 if( !bSelectionPut && SFX_ITEM_SET == aTmpSet.GetItemState(FN_PARAM_SELECTION, FALSE, &pItem) )
//STRIP001                 {
//STRIP001                     String sInsert = ((const SfxStringItem*)pItem)->GetValue();
//STRIP001                     bInsert = sInsert.Len() != 0;
//STRIP001                     if(bInsert)
//STRIP001                     {
//STRIP001                         nInsert = sInsert.Len();
//STRIP001 						rWrtSh.StartAction();
//STRIP001                         rWrtSh.Insert( sInsert );
//STRIP001                         rWrtSh.SetMark();
//STRIP001                         rWrtSh.ExtendSelection(FALSE, sInsert.Len());
//STRIP001                         SfxRequest aReq( GetView().GetViewFrame(), FN_INSERT_STRING );
//STRIP001                         aReq.AppendItem( SfxStringItem( FN_INSERT_STRING, sInsert ) );
//STRIP001                         aReq.Done();
//STRIP001                         SfxRequest aReq1( GetView().GetViewFrame(), FN_CHAR_LEFT );
//STRIP001                         aReq1.AppendItem( SfxInt16Item(FN_PARAM_MOVE_COUNT, nInsert) );
//STRIP001                         aReq1.AppendItem( SfxBoolItem(FN_PARAM_MOVE_SELECTION, TRUE) );
//STRIP001                         aReq1.Done();
//STRIP001                     }
//STRIP001                 }
//STRIP001                 aTmpSet.ClearItem(FN_PARAM_SELECTION);
//STRIP001 
//STRIP001                 SwTxtFmtColl* pColl = rWrtSh.GetCurTxtFmtColl();
//STRIP001                 if(bSel && rWrtSh.IsSelFullPara() && pColl && pColl->IsAutoUpdateFmt())
//STRIP001                 {
//STRIP001                     rWrtSh.AutoUpdatePara(pColl, aTmpSet);
//STRIP001                 }
//STRIP001                 else
//STRIP001                     rWrtSh.SetAttr( aTmpSet );
//STRIP001                 rReq.Done(aTmpSet);
//STRIP001                 if(bInsert)
//STRIP001                 {
//STRIP001                     SfxRequest aReq1( GetView().GetViewFrame(), FN_CHAR_RIGHT );
//STRIP001                     aReq1.AppendItem( SfxInt16Item(FN_PARAM_MOVE_COUNT, nInsert) );
//STRIP001                     aReq1.AppendItem( SfxBoolItem(FN_PARAM_MOVE_SELECTION, FALSE) );
//STRIP001                     aReq1.Done();
//STRIP001                     rWrtSh.SwapPam();
//STRIP001                     rWrtSh.ClearMark();
//STRIP001                     rWrtSh.DontExpandFmt();
//STRIP001                     rWrtSh.EndAction();
//STRIP001                 }
//STRIP001             }
//STRIP001 
//STRIP001             delete pDlg;
//STRIP001 		}
//STRIP001 		break;
//STRIP001         case SID_ATTR_LRSPACE :
//STRIP001 		case SID_ATTR_ULSPACE :
//STRIP001         case SID_ATTR_BRUSH :
//STRIP001 		case SID_PARA_VERTALIGN :
//STRIP001         case SID_ATTR_PARA_NUMRULE :
//STRIP001 		case SID_ATTR_PARA_REGISTER :
//STRIP001         case SID_ATTR_PARA_PAGENUM :
//STRIP001         case FN_FORMAT_LINENUMBER :
//STRIP001         case FN_NUMBER_NEWSTART :
//STRIP001         case FN_NUMBER_NEWSTART_AT :
//STRIP001         case FN_FORMAT_DROPCAPS :
//STRIP001         case FN_DROP_TEXT:
//STRIP001         {
//STRIP001             USHORT nWhich = GetPool().GetWhich( nSlot );
//STRIP001             if ( pArgs && pArgs->GetItemState( nWhich ) == SFX_ITEM_SET )
//STRIP001                 bUseDialog = FALSE;
//STRIP001             // intentionally no break
//STRIP001 
//STRIP001         }
//STRIP001 		case SID_PARA_DLG:
//STRIP001 		{
//STRIP001             FieldUnit eMetric = ::GetDfltMetric(0 != PTR_CAST(SwWebView, &GetView()));
//STRIP001             SW_MOD()->PutItem(SfxUInt16Item(SID_ATTR_METRIC, eMetric));
//STRIP001             SfxItemSet aCoreSet( GetPool(),
//STRIP001                             RES_PARATR_BEGIN,           RES_PARATR_END - 1,
//STRIP001                             RES_FRMATR_BEGIN,           RES_FRMATR_END - 1,
//STRIP001                             SID_ATTR_TABSTOP_POS,       SID_ATTR_TABSTOP_POS,
//STRIP001                             SID_ATTR_TABSTOP_DEFAULTS,  SID_ATTR_TABSTOP_DEFAULTS,
//STRIP001                             SID_ATTR_TABSTOP_OFFSET,    SID_ATTR_TABSTOP_OFFSET,
//STRIP001                             SID_ATTR_BORDER_INNER,      SID_ATTR_BORDER_INNER,
//STRIP001                             SID_ATTR_PARA_MODEL,        SID_ATTR_PARA_KEEP,
//STRIP001                             SID_ATTR_PARA_PAGENUM,      SID_ATTR_PARA_PAGENUM,
//STRIP001                             SID_HTML_MODE,              SID_HTML_MODE,
//STRIP001                             FN_PARAM_1,                 FN_PARAM_1,
//STRIP001                             FN_NUMBER_NEWSTART,         FN_NUMBER_NEWSTART_AT,
//STRIP001                             FN_DROP_TEXT,               FN_DROP_CHAR_STYLE_NAME,
//STRIP001                             0);
//STRIP001             rWrtSh.GetAttr( aCoreSet );
//STRIP001             aCoreSet.Put(SfxUInt16Item(SID_HTML_MODE,
//STRIP001                             ::binfilter::GetHtmlMode(GetView().GetDocShell())));
//STRIP001 
//STRIP001             // Tabulatoren, DefaultTabs ins ItemSet Stecken
//STRIP001             const SvxTabStopItem& rDefTabs = (const SvxTabStopItem&)
//STRIP001                             GetPool().GetDefaultItem(RES_PARATR_TABSTOP);
//STRIP001 
//STRIP001             USHORT nDefDist = ::binfilter::GetTabDist( rDefTabs );
//STRIP001             SfxUInt16Item aDefDistItem( SID_ATTR_TABSTOP_DEFAULTS, nDefDist );
//STRIP001             aCoreSet.Put( aDefDistItem );
//STRIP001 
//STRIP001             // Aktueller Tab
//STRIP001             SfxUInt16Item aTabPos( SID_ATTR_TABSTOP_POS, 0 );
//STRIP001             aCoreSet.Put( aTabPos );
//STRIP001 
//STRIP001             // linker Rand als Offset
//STRIP001             const long nOff = ((SvxLRSpaceItem&)aCoreSet.Get( RES_LR_SPACE )).
//STRIP001                                                                 GetTxtLeft();
//STRIP001             SfxInt32Item aOff( SID_ATTR_TABSTOP_OFFSET, nOff );
//STRIP001             aCoreSet.Put( aOff );
//STRIP001 
//STRIP001 
//STRIP001             // BoxInfo setzen
//STRIP001             ::PrepareBoxInfo( aCoreSet, rWrtSh );
//STRIP001 
//STRIP001             //aktuelles Seitenformat
//STRIP001             ::SwToSfxPageDescAttr( aCoreSet );
//STRIP001 
//STRIP001             UINT16 nDefPage = 0;
//STRIP001             if( pItem )
//STRIP001                 nDefPage = ((SfxUInt16Item *)pItem)->GetValue();
//STRIP001 
//STRIP001             // Numerierungseigenschaften
//STRIP001             if(rWrtSh.GetCurNumRule())
//STRIP001             {
//STRIP001                 SfxBoolItem aStart(FN_NUMBER_NEWSTART,
//STRIP001                                     rWrtSh.IsNumRuleStart());
//STRIP001                 aCoreSet.Put(aStart);
//STRIP001                 SfxUInt16Item aStartAt(FN_NUMBER_NEWSTART_AT,
//STRIP001                                                 rWrtSh.IsNodeNumStart());
//STRIP001                 aCoreSet.Put(aStartAt);
//STRIP001             }
//STRIP001             SwParaDlg *pDlg = NULL;
//STRIP001             if ( bUseDialog && GetActiveView() )
//STRIP001                 pDlg = new SwParaDlg( GetView().GetWindow(),
//STRIP001                                                 GetView(), aCoreSet, DLG_STD,
//STRIP001                                                 NULL, FALSE, nDefPage );
//STRIP001 
//STRIP001             SfxItemSet* pSet = NULL;
//STRIP001             if ( !bUseDialog )
//STRIP001             {
//STRIP001                 pSet = (SfxItemSet*) pArgs;
//STRIP001 
//STRIP001             }
//STRIP001             else if ( pDlg->Execute() == RET_OK )
//STRIP001             {
//STRIP001                 // Defaults evtl umsetzen
//STRIP001                 pSet = (SfxItemSet*)pDlg->GetOutputItemSet();
//STRIP001                 USHORT nNewDist;
//STRIP001                 if( SFX_ITEM_SET == pSet->GetItemState( SID_ATTR_TABSTOP_DEFAULTS, FALSE, &pItem ) &&
//STRIP001                     nDefDist != (nNewDist = ((SfxUInt16Item*)pItem)->GetValue()) )
//STRIP001                 {
//STRIP001                     SvxTabStopItem aDefTabs( 0, 0 );
//STRIP001                     MakeDefTabs( nNewDist, aDefTabs );
//STRIP001                     rWrtSh.SetDefault( aDefTabs );
//STRIP001                     pSet->ClearItem( SID_ATTR_TABSTOP_DEFAULTS );
//STRIP001                 }
//STRIP001 
//STRIP001                 if ( SFX_ITEM_SET == pSet->GetItemState(FN_PARAM_1,FALSE,&pItem) )
//STRIP001                 {
//STRIP001                     pSet->Put(SfxStringItem(FN_DROP_TEXT, ((const SfxStringItem*)pItem)->GetValue()));
//STRIP001                     pSet->ClearItem(FN_PARAM_1);
//STRIP001                 }
//STRIP001 
//STRIP001                 if( SFX_ITEM_SET == pSet->GetItemState( RES_PARATR_DROP, FALSE, &pItem ))
//STRIP001                 {
//STRIP001                     String sCharStyleName;
//STRIP001                     if(((const SwFmtDrop*)pItem)->GetCharFmt())
//STRIP001                         sCharStyleName = ((const SwFmtDrop*)pItem)->GetCharFmt()->GetName();
//STRIP001                     pSet->Put(SfxStringItem(FN_DROP_CHAR_STYLE_NAME, sCharStyleName));
//STRIP001                 }
//STRIP001             }
//STRIP001 
//STRIP001             if ( pSet )
//STRIP001             {
//STRIP001                 rReq.Done( *pSet );
//STRIP001                 ::SfxToSwPageDescAttr( rWrtSh, *pSet );
//STRIP001                 if( pSet->Count() )
//STRIP001                 {
//STRIP001                     rWrtSh.StartAction();
//STRIP001                     rWrtSh.StartUndo( UNDO_START );
//STRIP001                     if ( SFX_ITEM_SET == pSet->GetItemState(FN_DROP_TEXT, FALSE, &pItem) )
//STRIP001                     {
//STRIP001                         if ( ((SfxStringItem*)pItem)->GetValue().Len() )
//STRIP001                             rWrtSh.ReplaceDropTxt(((SfxStringItem*)pItem)->GetValue());
//STRIP001                     }
//STRIP001                     rWrtSh.SetAttr( *pSet );
//STRIP001                     rWrtSh.EndUndo( UNDO_END );
//STRIP001                     rWrtSh.EndAction();
//STRIP001                     SwTxtFmtColl* pColl = rWrtSh.GetCurTxtFmtColl();
//STRIP001                     if(pColl && pColl->IsAutoUpdateFmt())
//STRIP001                     {
//STRIP001                         rWrtSh.AutoUpdatePara(pColl, *pSet);
//STRIP001                     }
//STRIP001                 }
//STRIP001 
//STRIP001                 if( SFX_ITEM_SET == pSet->GetItemState(FN_NUMBER_NEWSTART) )
//STRIP001                 {
//STRIP001                     //SetNumRuleStart(TRUE) restarts the numbering at the value
//STRIP001                     //that is defined at the starting point of the numbering level
//STRIP001                     //otherwise the SetNodeNumStart() value determines the start
//STRIP001                     //if it's set to something different than USHRT_MAX
//STRIP001                     
//STRIP001                     BOOL bStart = ((SfxBoolItem&)pSet->Get(FN_NUMBER_NEWSTART)).GetValue();
//STRIP001                     USHORT nNumStart = USHRT_MAX;
//STRIP001 					if( SFX_ITEM_SET == pSet->GetItemState(FN_NUMBER_NEWSTART_AT) )
//STRIP001                     {
//STRIP001                         nNumStart = ((SfxUInt16Item&)pSet->Get(FN_NUMBER_NEWSTART_AT)).GetValue();
//STRIP001                         if(USHRT_MAX != nNumStart)
//STRIP001                             bStart = FALSE;
//STRIP001                     }
//STRIP001                     rWrtSh.SetNumRuleStart(bStart);
//STRIP001                     rWrtSh.SetNodeNumStart(nNumStart);
//STRIP001                 }
//STRIP001                 else if( SFX_ITEM_SET == pSet->GetItemState(FN_NUMBER_NEWSTART_AT) )
//STRIP001                 {
//STRIP001                     USHORT nNumStart = ((SfxUInt16Item&)pSet->Get(FN_NUMBER_NEWSTART_AT)).GetValue();
//STRIP001                     rWrtSh.SetNodeNumStart(nNumStart);
//STRIP001                     rWrtSh.SetNumRuleStart(FALSE);
//STRIP001                 }
//STRIP001             }
//STRIP001 
//STRIP001             delete pDlg;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_SELECT_PARA:
//STRIP001 		{
//STRIP001 			if(!rWrtSh.IsSttOfPara())
//STRIP001 				rWrtSh.SttPara(FALSE);
//STRIP001 			else
//STRIP001 				rWrtSh.EnterStdMode();
//STRIP001 			rWrtSh.EndPara(TRUE);
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DEC_INDENT:
//STRIP001 		case SID_INC_INDENT:
//STRIP001 			rWrtSh.MoveLeftMargin( SID_INC_INDENT == nSlot,
//STRIP001 									rReq.GetModifier() != KEY_MOD1 );
//STRIP001 			break;
//STRIP001 		case FN_DEC_INDENT_OFFSET:
//STRIP001 		case FN_INC_INDENT_OFFSET:
//STRIP001 			rWrtSh.MoveLeftMargin( FN_INC_INDENT_OFFSET == nSlot,
//STRIP001 									rReq.GetModifier() == KEY_MOD1 );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_ATTR_CHAR_COLOR2:
//STRIP001 		{
//STRIP001 			if(pItem)
//STRIP001 			{
//STRIP001 				Color aSet = ((const SvxColorItem*)pItem)->GetValue();
//STRIP001 				SwView& rView = GetView();
//STRIP001 				SwEditWin& rEditWin = rView.GetEditWin();
//STRIP001 				rEditWin.SetTextColor(aSet);
//STRIP001 				SwApplyTemplate* pApply = rEditWin.GetApplyTemplate();
//STRIP001 				SvxColorItem aItem(aSet, RES_CHRATR_COLOR);
//STRIP001 
//STRIP001 				// besteht eine Selektion, wird sie gleich gefaerbt
//STRIP001 				if(!pApply && rWrtSh.HasSelection())
//STRIP001 				{
//STRIP001 					SvxColorItem aItem(aSet, RES_CHRATR_COLOR);
//STRIP001 					rWrtSh.SetAttr(aItem);
//STRIP001 				}
//STRIP001 				else if(!pApply || pApply->nColor != SID_ATTR_CHAR_COLOR_EXT)
//STRIP001 				{
//STRIP001 					rView.GetViewFrame()->GetDispatcher()->Execute(SID_ATTR_CHAR_COLOR_EXT);
//STRIP001 				}
//STRIP001 
//STRIP001                 rReq.Done();
//STRIP001 /*		 		OS 22.02.97 18:40 Das alte Verhalten ist unerwuenscht
//STRIP001 				SwEditWin& rEdtWin = GetView().GetEditWin();
//STRIP001 
//STRIP001 				SwApplyTemplate* pApply = rEdtWin.GetApplyTemplate();
//STRIP001 				SvxColorItem aItem(aSet, RES_CHRATR_COLOR);
//STRIP001 
//STRIP001 				if(!pApply || pApply->nColor != SID_ATTR_CHAR_COLOR_EXT)
//STRIP001 				{
//STRIP001 					GetShell().SetAttr(aItem);
//STRIP001 				}
//STRIP001 */
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case SID_ATTR_CHAR_COLOR_BACKGROUND:
//STRIP001 		{
//STRIP001 			SwView& rView = GetView();
//STRIP001 			SwEditWin& rEdtWin = rView.GetEditWin();
//STRIP001 			SwApplyTemplate* pApply = rEdtWin.GetApplyTemplate();
//STRIP001 			rEdtWin.SetTextBackColorTransparent(0 == pItem);
//STRIP001 			Color aSet;
//STRIP001 			if(pItem)
//STRIP001 			{
//STRIP001 				aSet = ((const SvxColorItem*)pItem)->GetValue();
//STRIP001 				rEdtWin.SetTextBackColor(aSet);
//STRIP001 			}
//STRIP001 			if(!pApply && (rWrtSh.HasSelection() || rReq.IsAPI()))
//STRIP001 			{
//STRIP001 				SvxBrushItem aBrushItem(RES_CHRATR_BACKGROUND);
//STRIP001 				if(pItem)
//STRIP001 					aBrushItem.SetColor(aSet);
//STRIP001 				else
//STRIP001 					aBrushItem.SetColor(Color(COL_TRANSPARENT));
//STRIP001 				rWrtSh.SetAttr( aBrushItem );
//STRIP001 			}
//STRIP001 			else if(!pApply || pApply->nColor != SID_ATTR_CHAR_COLOR_BACKGROUND_EXT)
//STRIP001 			{
//STRIP001 				rView.GetViewFrame()->GetDispatcher()->Execute(SID_ATTR_CHAR_COLOR_BACKGROUND_EXT);
//STRIP001 			}
//STRIP001 
//STRIP001             rReq.Done();
//STRIP001 
//STRIP001 /*			OS 22.02.97 18:40 Das alte Verhalten ist unerwuenscht
//STRIP001 			if(!pApply || pApply->nColor != SID_ATTR_CHAR_COLOR_BACKGROUND_EXT)
//STRIP001 			{
//STRIP001 				Brush aBrush(pItem ? BRUSH_SOLID : BRUSH_NULL);
//STRIP001 				if(pItem)
//STRIP001 					aBrush.SetColor( aSet );
//STRIP001 				GetShell().SetAttr( SvxBrushItem(aBrush, RES_CHRATR_BACKGROUND) );
//STRIP001 			}
//STRIP001 */
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case SID_ATTR_CHAR_COLOR_BACKGROUND_EXT:
//STRIP001 		case SID_ATTR_CHAR_COLOR_EXT:
//STRIP001 		{
//STRIP001 			SwEditWin& rEdtWin = GetView().GetEditWin();
//STRIP001 			SwApplyTemplate* pApply = rEdtWin.GetApplyTemplate();
//STRIP001 			SwApplyTemplate aTempl;
//STRIP001 			BOOL bSelection = rWrtSh.HasSelection();
//STRIP001 			if(bSelection)
//STRIP001 			{
//STRIP001 
//STRIP001 				if(nSlot == SID_ATTR_CHAR_COLOR_BACKGROUND_EXT)
//STRIP001 				{
//STRIP001 					rWrtSh.SetAttr( SvxBrushItem(
//STRIP001 						rEdtWin.GetTextBackColor(), RES_CHRATR_BACKGROUND) );
//STRIP001 				}
//STRIP001 				else
//STRIP001 					rWrtSh.SetAttr( SvxColorItem( rEdtWin.GetTextColor(),
//STRIP001 																RES_CHRATR_COLOR) );
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				if(!pApply || pApply->nColor != nSlot)
//STRIP001 					aTempl.nColor = nSlot;
//STRIP001 				rEdtWin.SetApplyTemplate(aTempl);
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case FN_NUM_BULLET_MOVEDOWN:
//STRIP001 			if (!rWrtSh.IsAddMode())
//STRIP001 				rWrtSh.MoveParagraph(1);
//STRIP001 			break;
//STRIP001 
//STRIP001 		case FN_NUM_BULLET_MOVEUP:
//STRIP001 			if (!rWrtSh.IsAddMode())
//STRIP001 				rWrtSh.MoveParagraph(-1);
//STRIP001 			break;
//STRIP001 		case SID_RUBY_DIALOG:
//STRIP001 		case SID_HYPERLINK_DIALOG:
//STRIP001 		{
//STRIP001 			SfxRequest aReq(nSlot, SFX_CALLMODE_SLOT, SFX_APP()->GetPool());
//STRIP001 		    GetView().GetViewFrame()->ExecuteSlot( aReq);
//STRIP001             rReq.Ignore();
//STRIP001 		}
//STRIP001 		break;
//STRIP001     case FN_INSERT_PAGEHEADER:
//STRIP001     case FN_INSERT_PAGEFOOTER:
//STRIP001     if(pItem)
//STRIP001     {
//STRIP001         String sStyleName = ((const SfxStringItem*)pItem)->GetValue();
//STRIP001         BOOL bOn = TRUE;
//STRIP001         if( SFX_ITEM_SET == pArgs->GetItemState(FN_PARAM_1, FALSE, &pItem))
//STRIP001             bOn = ((const SfxBoolItem*)pItem)->GetValue();
//STRIP001         ChangeHeaderOrFooter(sStyleName, FN_INSERT_PAGEHEADER == nSlot, bOn, !rReq.IsAPI());
//STRIP001         rReq.Done();
//STRIP001     }
//STRIP001     break;
//STRIP001     case FN_READONLY_SELECTION_MODE :
//STRIP001         if(GetView().GetDocShell()->IsReadOnly())
//STRIP001         {
//STRIP001             rWrtSh.SetReadonlySelectionOption(
//STRIP001                 !rWrtSh.GetViewOptions()->IsSelectionInReadonly());
//STRIP001             rWrtSh.ShowCrsr();
//STRIP001         }
//STRIP001     break;
//STRIP001     case SID_OPEN_HYPERLINK:
//STRIP001     {
//STRIP001         SfxItemSet aSet(GetPool(),
//STRIP001                         RES_TXTATR_INETFMT,
//STRIP001                         RES_TXTATR_INETFMT);
//STRIP001         rWrtSh.GetAttr(aSet);
//STRIP001         if(SFX_ITEM_SET <= aSet.GetItemState( RES_TXTATR_INETFMT, TRUE ))
//STRIP001         {        
//STRIP001             const SfxPoolItem& rItem = aSet.Get(RES_TXTATR_INETFMT, TRUE);
//STRIP001             rWrtSh.ClickToINetAttr((const SwFmtINetFmt&)rItem, URLLOAD_NOFILTER);
//STRIP001         }
//STRIP001     }
//STRIP001 
//STRIP001     break;        
//STRIP001 
//STRIP001     case SID_OPEN_XML_FILTERSETTINGS:
//STRIP001     {
//STRIP001 		try
//STRIP001 		{
//STRIP001 			::com::sun::star::uno::Reference < ::com::sun::star::ui::dialogs::XExecutableDialog > xDialog(::legacy_binfilters::getLegacyProcessServiceFactory()->createInstance(::rtl::OUString::createFromAscii("com.sun.star.comp.ui.XSLTFilterDialog")), ::com::sun::star::uno::UNO_QUERY);
//STRIP001 			if( xDialog.is() )
//STRIP001 			{
//STRIP001 				xDialog->execute();
//STRIP001 			}
//STRIP001 		}
//STRIP001 		catch( ::com::sun::star::uno::Exception& )
//STRIP001 		{
//STRIP001 		}
//STRIP001 		rReq.Ignore ();
//STRIP001 	}
//STRIP001 	break;
//STRIP001     default:
//STRIP001 		ASSERT(!this, falscher Dispatcher);
//STRIP001 		return;
//STRIP001 	}
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/


/*M*/ void SwTextShell::GetState( SfxItemSet &rSet )
/*M*/ {
/*M*/ 	SwWrtShell &rSh = GetShell();
/*M*/ 	SfxWhichIter aIter( rSet );
/*M*/ 	USHORT nWhich = aIter.FirstWhich();
/*M*/ 	while ( nWhich )
/*M*/ 	{
/*M*/ 		switch ( nWhich )
/*M*/ 		{
/*M*/ 		case FN_NUM_NUMBERING_ON:
/*M*/ 		case FN_NUM_BULLET_ON:
/*M*/ 			if ( rSh.IsTableMode() )
/*M*/ 				rSet.DisableItem( nWhich );
/*M*/ 			break;
/*M*/ 
/*M*/ 		case FN_NUMBER_BULLETS:
/*M*/ 			if ( rSh.IsTableMode() )
/*M*/ 				rSet.DisableItem(nWhich);
/*M*/ 			break;
/*M*/ 
/*M*/         case FN_NUMBER_NEWSTART :
/*?*/            DBG_BF_ASSERT(0, "STRIP"); //STRIP001  rSet.Put(SfxBoolItem(FN_NUMBER_NEWSTART,
//STRIP001 /*?*/                 rSh.IsNumRuleStart()||USHRT_MAX != rSh.IsNodeNumStart()));
/*M*/         break;
/*M*/ 		case FN_EDIT_FORMULA:
/*M*/ 		case FN_INSERT_SYMBOL:
/*M*/ 			{
/*?*/ 				const int nType = rSh.GetSelectionType();
/*?*/ 				if (!(nType & SwWrtShell::SEL_TXT) &&
/*?*/ 					!(nType & SwWrtShell::SEL_TBL) &&
/*?*/ 					!(nType & SwWrtShell::SEL_NUM))
/*?*/ 					rSet.DisableItem(nWhich);
/*M*/ 			}
/*M*/ 			break;
/*M*/ 
/*M*/ 		case FN_INSERT_ENDNOTE:
/*M*/ 		case FN_INSERT_FOOTNOTE:
/*M*/ 		case FN_INSERT_FOOTNOTE_DLG:
/*M*/ 			{
/*?*/ 				const USHORT nNoType = FRMTYPE_FLY_ANY | FRMTYPE_HEADER |
/*?*/ 										FRMTYPE_FOOTER  | FRMTYPE_FOOTNOTE;
/*?*/ 				if ( (rSh.GetFrmType(0,TRUE) & nNoType) )
/*?*/ 					rSet.DisableItem(nWhich);
/*M*/ 			}
/*M*/ 			break;
/*M*/ 		case FN_INSERT_TABLE:
/*?*/ 			if ( rSh.GetTableFmt() ||
/*?*/ 					(rSh.GetFrmType(0,TRUE) & FRMTYPE_FOOTNOTE) )
/*?*/ 				rSet.DisableItem( nWhich );
/*M*/ 			break;
/*M*/ 
/*M*/ 		case FN_CALCULATE:
/*?*/ 			if ( !rSh.IsSelection() )
/*?*/ 				rSet.DisableItem(nWhich);
/*M*/ 			break;
/*M*/ 		case FN_GOTO_REFERENCE:
/*M*/ 			{
/*?*/ 				DBG_BF_ASSERT(0, "STRIP"); //STRIP001 SwField *pFld = rSh.GetCurFld();
//STRIP001 /*?*/ 				if ( !pFld || (pFld &&  pFld->GetTypeId() != TYP_GETREFFLD) )
//STRIP001 /*?*/ 					rSet.DisableItem(nWhich);
/*M*/ 			}
/*M*/ 			break;
/*M*/ 		case FN_AUTOFORMAT_AUTO:
/*M*/ 			{
/*M*/ 				rSet.Put( SfxBoolItem( nWhich, OFF_APP()->
/*M*/ 								GetAutoCorrConfig()->IsAutoFmtByInput() ));
/*M*/ 			}
/*M*/ 			break;
/*M*/ 		case FN_GLOSSARY_DLG:
/*M*/ 			{
/*M*/ 				rSet.Put(SfxBoolItem(nWhich), TRUE);
/*M*/ 			}
/*M*/ 			break;
/*M*/ 
/*M*/ 		case SID_DEC_INDENT:
/*M*/ 		case SID_INC_INDENT:
/*M*/ 			{
/*M*/ 				USHORT nHtmlMode = ::binfilter::GetHtmlMode(GetView().GetDocShell());
/*M*/ 				nHtmlMode &= HTMLMODE_ON|HTMLMODE_SOME_STYLES;
/*M*/ 				if( (nHtmlMode == HTMLMODE_ON) || !rSh.IsMoveLeftMargin(
/*M*/ 										SID_INC_INDENT == nWhich, TRUE ))
/*M*/ 					rSet.DisableItem( nWhich );
/*M*/ 			}
/*M*/ 			break;
/*M*/ 
/*M*/ 		case FN_DEC_INDENT_OFFSET:
/*M*/ 		case FN_INC_INDENT_OFFSET:
/*M*/ 			{
/*M*/ 				USHORT nHtmlMode = ::binfilter::GetHtmlMode(GetView().GetDocShell());
/*M*/ 				nHtmlMode &= HTMLMODE_ON|HTMLMODE_SOME_STYLES;
/*M*/ 				if( (nHtmlMode == HTMLMODE_ON) ||
/*M*/ 					!rSh.IsMoveLeftMargin( FN_INC_INDENT_OFFSET == nWhich,
/*M*/ 											FALSE ))
/*M*/ 					rSet.DisableItem( nWhich );
/*M*/ 			}
/*M*/ 			break;
/*M*/ 
/*M*/ 		case SID_ATTR_CHAR_COLOR2:
/*M*/ 			{
/*M*/ 				rSet.Put(SvxColorItem(GetView().GetEditWin().GetTextColor(), SID_ATTR_CHAR_COLOR2));
/*M*/ 			}
/*M*/ 			break;
/*M*/ 		case SID_ATTR_CHAR_COLOR_BACKGROUND:
/*M*/ 			{
/*M*/               if(GetView().GetEditWin().IsTextBackColorTransparent())
/*M*/                   rSet.Put(SvxColorItem(Color(COL_TRANSPARENT), SID_ATTR_CHAR_COLOR_BACKGROUND));
/*M*/               else
/*M*/ 					rSet.Put(SvxColorItem(GetView().GetEditWin().GetTextBackColor(), SID_ATTR_CHAR_COLOR_BACKGROUND));
/*M*/ 			}
/*M*/ 			break;
/*M*/ 		case SID_ATTR_CHAR_COLOR_BACKGROUND_EXT:
/*M*/ 		case SID_ATTR_CHAR_COLOR_EXT:
/*M*/ 			{
/*M*/ 				SwEditWin& rEdtWin = GetView().GetEditWin();
/*M*/ 				SwApplyTemplate* pApply = rEdtWin.GetApplyTemplate();
/*M*/ 				rSet.Put(SfxBoolItem(nWhich, pApply && pApply->nColor == nWhich));
/*M*/ 			}
/*M*/ 			break;
/*M*/ 		case FN_INSERT_BOOKMARK:
/*M*/ 			if( rSh.IsTableMode() )
/*M*/ 				rSet.DisableItem( nWhich );
/*M*/ 			break;
/*M*/ 
/*M*/ 		case FN_INSERT_PAGEHEADER:
/*M*/ 		case FN_INSERT_PAGEFOOTER:
/*M*/ 			{
/*M*/ #ifndef CHECK_MENU
/*M*/ 				rSet.Put( SfxObjectItem( nWhich, GetView().GetDocShell() ));
/*M*/ #else
/*M*/ 				// Seitenvorlagen besorgen
/*M*/ 				BOOL bFound = FALSE;
/*M*/ 				USHORT n, nCnt = rSh.GetPageDescCnt();
/*M*/ 				for( n = 0; n < nCnt; ++n )
/*M*/ 				{
/*M*/ 					const SwPageDesc& rDesc = rSh.GetPageDesc( n );
/*M*/ 					if( FN_INSERT_PAGEHEADER == nWhich
/*M*/ 						? !rDesc.GetMaster().GetHeader().IsActive()
/*M*/ 						: !rDesc.GetMaster().GetFooter().IsActive() )
/*M*/ 					{
/*M*/ 						bFound = TRUE;
/*M*/ 						break;
/*M*/ 					}
/*M*/ 				}
/*M*/ 
/*M*/ 				if( bFound )
/*M*/ 					rSet.Put( SfxObjectItem( nWhich, GetView().GetDocShell() ));
/*M*/ 				else
/*M*/ 					rSet.DisableItem( nWhich );
/*M*/ #endif
/*M*/ 			}
/*M*/ 			break;
/*M*/ 			case FN_SORTING_DLG:
/*M*/ 				if(!rSh.HasSelection())
/*M*/ 					rSet.DisableItem( nWhich );
/*M*/ 			break;
/*M*/ 			case SID_RUBY_DIALOG:
/*M*/             {
/*M*/                 SvtCJKOptions aCJKOptions;
/*M*/                 if(!aCJKOptions.IsRubyEnabled())
/*M*/                 {
/*M*/                     rSet.DisableItem(nWhich);
/*M*/                     break;
/*M*/                 }
/*M*/             }
/*M*/             //no break!
/*M*/ 			case SID_HYPERLINK_DIALOG:
/*M*/ 				if( GetView().GetDocShell()->IsReadOnly() ||
/*M*/ 					(!GetView().GetViewFrame()->HasChildWindow(nWhich) &&
/*M*/ 					 rSh.HasReadonlySel()) )
/*M*/ 					rSet.DisableItem(nWhich);
/*M*/ 				else
/*M*/ 					rSet.Put(SfxBoolItem( nWhich, 0 != GetView().
/*M*/ 								GetViewFrame()->GetChildWindow( nWhich ) ));
/*M*/ 				break;
/*M*/ 			case FN_EDIT_HYPERLINK:
/*M*/ 			{
/*M*/ 				SfxItemSet aSet(GetPool(),
/*M*/ 								RES_TXTATR_INETFMT,
/*M*/ 								RES_TXTATR_INETFMT);
/*M*/ 				rSh.GetAttr(aSet);
/*M*/ 				if(SFX_ITEM_SET > aSet.GetItemState( RES_TXTATR_INETFMT, TRUE ) || rSh.HasReadonlySel())
/*M*/ 				{
/*M*/ 					rSet.DisableItem(FN_EDIT_HYPERLINK);
/*M*/ 				}
/*M*/ 			}
/*M*/ 			break;
/*M*/             case SID_TRANSLITERATE_HALFWIDTH:
/*M*/             case SID_TRANSLITERATE_FULLWIDTH:
/*M*/             case SID_TRANSLITERATE_HIRAGANA:
/*M*/             case SID_TRANSLITERATE_KATAGANA:
/*M*/             {
/*M*/                 SvtCJKOptions aCJKOptions;
/*M*/                 if(!aCJKOptions.IsChangeCaseMapEnabled())
/*M*/                     rSet.DisableItem(nWhich);
/*M*/             }
/*M*/             break;
/*M*/             case FN_READONLY_SELECTION_MODE :
/*M*/                 if(!GetView().GetDocShell()->IsReadOnly())
/*M*/                     rSet.DisableItem( nWhich );
/*M*/                 else
/*M*/                 {
/*M*/                     rSet.Put(SfxBoolItem(nWhich, rSh.GetViewOptions()->IsSelectionInReadonly()));
/*M*/                 }
/*M*/             break;
/*N*/             case  SID_OPEN_HYPERLINK:
/*N*/             {
/*N*/                 SfxItemSet aSet(GetPool(),
/*N*/                                 RES_TXTATR_INETFMT,
/*N*/                                 RES_TXTATR_INETFMT);
/*N*/                 rSh.GetAttr(aSet);
/*N*/                 if(SFX_ITEM_SET > aSet.GetItemState( RES_TXTATR_INETFMT, FALSE ))
/*N*/                     rSet.DisableItem(nWhich);
/*N*/             }        
/*N*/             break;
/*M*/         }
/*M*/         nWhich = aIter.NextWhich();
/*M*/ 	}
/*M*/ }
/* -----------------------------2002/07/05 10:31------------------------------
    Switch on/off header of footer of a page style - if an empty name is
    given all styles are changed
 ---------------------------------------------------------------------------*/
//STRIP001 void SwTextShell::ChangeHeaderOrFooter(
//STRIP001     const String& rStyleName, BOOL bHeader, BOOL bOn, BOOL bShowWarning)
//STRIP001 {
//STRIP001     SwWrtShell& rSh = GetShell();
//STRIP001     rSh.StartAllAction();
//STRIP001     rSh.StartUndo( 0 );
//STRIP001     BOOL bExecute = TRUE;
//STRIP001     BOOL bCrsrSet = FALSE;
//STRIP001     for( USHORT nFrom = 0, nTo = rSh.GetPageDescCnt();
//STRIP001             nFrom < nTo; ++nFrom )
//STRIP001     {
//STRIP001         int bChgd = FALSE;
//STRIP001         SwPageDesc aDesc( rSh.GetPageDesc( nFrom ));
//STRIP001         String sTmp(aDesc.GetName());
//STRIP001         if( !rStyleName.Len() || rStyleName == sTmp )
//STRIP001         {
//STRIP001             if( bShowWarning && !bOn && GetActiveView() && GetActiveView() == &GetView() &&
//STRIP001                     (bHeader && aDesc.GetMaster().GetHeader().IsActive() ||
//STRIP001                         !bHeader && aDesc.GetMaster().GetFooter().IsActive()))
//STRIP001             {
//STRIP001                 bShowWarning = FALSE;
//STRIP001                 //Actions have to be closed while the dialog is showing
//STRIP001                 rSh.EndAllAction();
//STRIP001 
//STRIP001                 Window* pParent = &GetView().GetViewFrame()->GetWindow();
//STRIP001                 BOOL bRet = RET_YES == QueryBox( pParent, ResId( RID_SVXQBX_DELETE_HEADFOOT,
//STRIP001                                         DIALOG_MGR() ) ).Execute();
//STRIP001                 bExecute = bRet;
//STRIP001                 rSh.StartAllAction();
//STRIP001             }
//STRIP001             if( bExecute )
//STRIP001             {
//STRIP001                 bChgd = TRUE;
//STRIP001                 SwFrmFmt &rMaster = aDesc.GetMaster();
//STRIP001                 if(bHeader)
//STRIP001                     rMaster.SetAttr( SwFmtHeader( bOn ));
//STRIP001                 else
//STRIP001                     rMaster.SetAttr( SwFmtFooter( bOn ));
//STRIP001                 if( bOn )
//STRIP001                 {
//STRIP001                     SvxULSpaceItem aUL(bHeader ? 0 : MM50, bHeader ? MM50 : 0 );
//STRIP001                     SwFrmFmt* pFmt = bHeader ?
//STRIP001                         (SwFrmFmt*)rMaster.GetHeader().GetHeaderFmt() :
//STRIP001                         (SwFrmFmt*)rMaster.GetFooter().GetFooterFmt();
//STRIP001                     pFmt->SetAttr( aUL );
//STRIP001                 }
//STRIP001             }
//STRIP001             if( bChgd )
//STRIP001             {
//STRIP001                 rSh.ChgPageDesc( nFrom, aDesc );
//STRIP001 
//STRIP001                 if( !bCrsrSet && bOn )
//STRIP001                     bCrsrSet = rSh.SetCrsrInHdFt(
//STRIP001                             !rStyleName.Len() ? USHRT_MAX : nFrom,
//STRIP001                             bHeader );
//STRIP001             }
//STRIP001         }
//STRIP001     }
//STRIP001     rSh.EndUndo( 0 );
//STRIP001     rSh.EndAllAction();
//STRIP001 }

}
