/*************************************************************************
 *
 *  $RCSfile: ctredlin.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:10:11 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SVX_CTREDLIN_HXX
#define _SVX_CTREDLIN_HXX

#ifndef _MOREBTN_HXX //autogen
#include <vcl/morebtn.hxx>
#endif
#ifndef _COMBOBOX_HXX //autogen
#include <vcl/combobox.hxx>
#endif

#ifndef _HEADBAR_HXX //autogen
#include <svtools/headbar.hxx>
#endif

#ifndef _SVTABBX_HXX //autogen
#include <svtools/svtabbx.hxx>
#endif

#ifndef _SV_LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif

#ifndef _SV_TABPAGE_HXX //autogen
#include <vcl/tabpage.hxx>
#endif

#ifndef _SV_FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif

#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

// auto strip #ifndef _SVX_SIMPTABL
// auto strip #include <bf_svx/simptabl.hxx>
// auto strip #endif

// auto strip #ifndef _SV_TABCTRL_HXX //autogen
// auto strip #include <vcl/tabctrl.hxx>
// auto strip #endif

// auto strip #ifndef _DATETIME_HXX //autogen
// auto strip #include <tools/datetime.hxx>
// auto strip #endif

// auto strip #ifndef _TXTCMP_HXX //autogen
// auto strip #include <svtools/txtcmp.hxx>
// auto strip #endif
namespace binfilter {

//STRIP001 #define FLT_DATE_BEFORE		0
//STRIP001 #define FLT_DATE_SINCE		1
//STRIP001 #define FLT_DATE_EQUAL		2
//STRIP001 #define FLT_DATE_NOTEQUAL	3
//STRIP001 #define FLT_DATE_BETWEEN	4
//STRIP001 #define FLT_DATE_SAVE		5

//	Struct fuer Datums-Sortierung

//STRIP001 class RedlinData
//STRIP001 {
//STRIP001 public:
//STRIP001 					RedlinData();
//STRIP001 	virtual			~RedlinData();
//STRIP001 	BOOL			bDisabled;
//STRIP001 	DateTime		aDateTime;
//STRIP001 	void*			pData;
//STRIP001 };

//STRIP001 class SvxRedlinEntry : public SvLBoxEntry
//STRIP001 {
//STRIP001 public:
//STRIP001 					SvxRedlinEntry();
//STRIP001 		virtual		~SvxRedlinEntry();
//STRIP001 };

// Klasse fuer die Darstellung von schriftabhaengigen Strings
//STRIP001 class SvLBoxColorString : public SvLBoxString
//STRIP001 {
//STRIP001 private:
//STRIP001 
//STRIP001 	Color			aPrivColor;
//STRIP001 
//STRIP001 public:
//STRIP001 					SvLBoxColorString( SvLBoxEntry*,USHORT nFlags,const XubString& rStr,
//STRIP001 									const Color& rCol);
//STRIP001 					SvLBoxColorString();
//STRIP001 					~SvLBoxColorString();
//STRIP001 
//STRIP001 	void			Paint( const Point&, SvLBox& rDev, USHORT nFlags,SvLBoxEntry* );
//STRIP001 	SvLBoxItem* 	Create() const;
//STRIP001 };

//STRIP001 class SvxRedlinTable : public SvxSimpleTable
//STRIP001 {
//STRIP001 private:
//STRIP001 
//STRIP001 	BOOL			bIsCalc;
//STRIP001 	USHORT			nDatePos;
//STRIP001 	BOOL			bAuthor;
//STRIP001 	BOOL			bDate;
//STRIP001 	BOOL			bComment;
//STRIP001 	USHORT			nDaTiMode;
//STRIP001 	DateTime		aDaTiFirst;
//STRIP001 	DateTime		aDaTiLast;
//STRIP001 	DateTime		aDaTiFilterFirst;
//STRIP001 	DateTime		aDaTiFilterLast;
//STRIP001 	String			aAuthor;
//STRIP001 	Color			aEntryColor;
//STRIP001 	String			aCurEntry;
//STRIP001 	utl::TextSearch* pCommentSearcher;
//STRIP001 	Link			aColCompareLink;
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001 	virtual StringCompare	ColCompare(SvLBoxEntry*,SvLBoxEntry*);
//STRIP001 	virtual void			InitEntry(SvLBoxEntry*,const XubString&,const Image&,const Image&);
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 					SvxRedlinTable( Window* pParent,WinBits nBits );
//STRIP001 					SvxRedlinTable( Window* pParent,const ResId& rResId);
//STRIP001 					~SvxRedlinTable();
//STRIP001 
//STRIP001 	// For FilterPage only {
//STRIP001 	void			SetFilterDate(BOOL bFlag=TRUE);
//STRIP001 	void			SetDateTimeMode(USHORT nMode);
//STRIP001 	void			SetFirstDate(const Date&);
//STRIP001 	void			SetLastDate(const Date&);
//STRIP001 	void			SetFirstTime(const Time&);
//STRIP001 	void			SetLastTime(const Time&);
//STRIP001 	void			SetFilterAuthor(BOOL bFlag=TRUE);
//STRIP001 	void			SetAuthor(const String &);
//STRIP001 	void			SetFilterComment(BOOL bFlag=TRUE);
//STRIP001 	void			SetCommentParams( const utl::SearchParam* pSearchPara );
//STRIP001 
//STRIP001 	void			UpdateFilterTest();
//STRIP001 	// } For FilterPage only
//STRIP001 
//STRIP001 	void			SetCalcView(BOOL bFlag=TRUE);
//STRIP001 	BOOL			IsValidCalcEntry(const String& ,RedlinData *pUserData);
//STRIP001 	BOOL			IsValidWriterEntry(const String& ,RedlinData *pUserData);
//STRIP001 
//STRIP001 	// keine NULL-Ptr. ueberpruefung {
//STRIP001 	BOOL			IsValidEntry(const String* pAuthor,const DateTime *pDateTime,const String* pComment);
//STRIP001 	BOOL			IsValidEntry(const String* pAuthor,const DateTime *pDateTime);
//STRIP001 	BOOL			IsValidComment(const String* pComment);
//STRIP001 	// }
//STRIP001 
//STRIP001 	SvLBoxEntry*	InsertEntry(const String& ,RedlinData *pUserData,
//STRIP001 								SvLBoxEntry* pParent=NULL,ULONG nPos=LIST_APPEND);
//STRIP001 
//STRIP001 	SvLBoxEntry*	InsertEntry(const String& ,RedlinData *pUserData,const Color&,
//STRIP001 								SvLBoxEntry* pParent=NULL,ULONG nPos=LIST_APPEND);
//STRIP001 
//STRIP001 
//STRIP001 	virtual	SvLBoxEntry* CreateEntry() const;
//STRIP001 
//STRIP001 	void			SetColCompareHdl(const Link& rLink ) { aColCompareLink = rLink; }
//STRIP001 	const Link&     GetColCompareHdl() const { return aColCompareLink; }
//STRIP001 
//STRIP001 
//STRIP001 };

//==================================================================
//	Filter- Tabpage
//==================================================================
//STRIP001 class SvxTPFilter: public TabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 
//STRIP001 	Link			aReadyLink;
//STRIP001 	Link			aModifyLink;
//STRIP001 	Link			aModifyDateLink;
//STRIP001 	Link			aModifyAuthorLink;
//STRIP001 	Link			aModifyRefLink;
//STRIP001 	Link			aRefLink;
//STRIP001 	Link			aModifyComLink;
//STRIP001 
//STRIP001 	SvxRedlinTable*	pRedlinTable;
//STRIP001 	CheckBox		aCbDate;
//STRIP001 	ListBox			aLbDate;
//STRIP001 	DateField		aDfDate;
//STRIP001 	TimeField		aTfDate;
//STRIP001 	ImageButton     aIbClock;
//STRIP001 	FixedText		aFtDate2;
//STRIP001 	DateField		aDfDate2;
//STRIP001 	TimeField		aTfDate2;
//STRIP001 	ImageButton     aIbClock2;
//STRIP001 	CheckBox		aCbAuthor;
//STRIP001 	ListBox			aLbAuthor;
//STRIP001 	CheckBox		aCbRange;
//STRIP001 	Edit			aEdRange;
//STRIP001 	PushButton		aBtnRange;
//STRIP001 	ListBox			aLbAction;
//STRIP001 	CheckBox		aCbComment;
//STRIP001 	Edit			aEdComment;
//STRIP001 	String			aActionStr;
//STRIP001 	String			aRangeStr;
//STRIP001 	String			aStrMyName;
//STRIP001 	BOOL			bModified;
//STRIP001 
//STRIP001 	DECL_LINK( SelDateHdl, ListBox* );
//STRIP001 	DECL_LINK( RowEnableHdl, CheckBox* );
//STRIP001 	DECL_LINK( TimeHdl, ImageButton* );
//STRIP001 	DECL_LINK( ModifyHdl, void* );
//STRIP001 	DECL_LINK( ModifyDate, void* );
//STRIP001 	DECL_LINK( RefHandle, PushButton* );
//STRIP001 
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001 	void			ShowDateFields(USHORT nKind);
//STRIP001 	void			EnableDateLine1(BOOL bFlag);
//STRIP001 	void			EnableDateLine2(BOOL bFlag);
//STRIP001 
//STRIP001 public:
//STRIP001 					SvxTPFilter( Window * pParent);
//STRIP001 
//STRIP001 	virtual void    DeactivatePage();
//STRIP001 	void			SetRedlinTable(SvxRedlinTable*);
//STRIP001 
//STRIP001 	String			GetMyName() const;
//STRIP001 	Date			GetFirstDate() const;
//STRIP001 	void			SetFirstDate(const Date &aDate);
//STRIP001 	Time			GetFirstTime() const;
//STRIP001 	void			SetFirstTime(const Time &aTime);
//STRIP001 
//STRIP001 	Date			GetLastDate() const;
//STRIP001 	void			SetLastDate(const Date &aDate);
//STRIP001 	Time			GetLastTime() const;
//STRIP001 	void			SetLastTime(const Time &aTime);
//STRIP001 
//STRIP001 	void			SetDateMode(USHORT nMode);
//STRIP001 	USHORT			GetDateMode();
//STRIP001 
//STRIP001 	void			ClearAuthors();
//STRIP001 	void			InsertAuthor( const String& rString, USHORT nPos = LISTBOX_APPEND );
//STRIP001 	USHORT			GetSelectedAuthorPos();
//STRIP001 	String			GetSelectedAuthor()const;
//STRIP001 	void			SelectedAuthorPos(USHORT nPos);
//STRIP001 	USHORT			SelectAuthor(const String& aString);
//STRIP001 	void			SetComment(const String &rComment);
//STRIP001 	String			GetComment()const;
//STRIP001 
//STRIP001 
//STRIP001 	// Methoden fuer Calc {
//STRIP001 	void			SetRange(const String& rString);
//STRIP001 	String			GetRange() const;
//STRIP001 	void			HideRange(BOOL bHide=TRUE);
//STRIP001 	void			DisableRange(BOOL bFlag=TRUE);
//STRIP001 	void			SetFocusToRange();
//STRIP001 	// } Methoden fuer Calc
//STRIP001 
//STRIP001 	void			HideClocks(BOOL bHide=TRUE);
//STRIP001 	void			DisableRef(BOOL bFlag);
//STRIP001 
//STRIP001 	BOOL			IsDate();
//STRIP001 	BOOL			IsAuthor();
//STRIP001 	BOOL			IsRange();
//STRIP001 	BOOL			IsAction();
//STRIP001 	BOOL			IsComment();
//STRIP001 
//STRIP001 	void			ShowAction(BOOL bShow=TRUE);
//STRIP001 
//STRIP001 	void			CheckDate(BOOL bFlag=TRUE);
//STRIP001 	void			CheckAuthor(BOOL bFlag=TRUE);
//STRIP001 	void			CheckRange(BOOL bFlag=TRUE);
//STRIP001 	void			CheckAction(BOOL bFlag=TRUE);
//STRIP001 	void			CheckComment(BOOL bFlag=TRUE);
//STRIP001 
//STRIP001 	ListBox*		GetLbAction();
//STRIP001 
//STRIP001 	void            SetReadyHdl( const Link& rLink ) { aReadyLink= rLink; }
//STRIP001 	const Link&     GetReadyHdl() const { return aReadyLink; }
//STRIP001 
//STRIP001 	void            SetModifyHdl( const Link& rLink ) { aModifyLink = rLink; }
//STRIP001 	const Link&     GetModifyHdl() const { return aModifyLink; }
//STRIP001 
//STRIP001 	void            SetModifyDateHdl( const Link& rLink ) { aModifyDateLink = rLink; }
//STRIP001 	const Link&     GetModifyDateHdl() const { return aModifyDateLink; }
//STRIP001 
//STRIP001 	void            SetModifyAuthorHdl( const Link& rLink ) { aModifyAuthorLink = rLink; }
//STRIP001 	const Link&     GetModifyAuthorHdl() const { return aModifyAuthorLink; }
//STRIP001 
//STRIP001 	void			SetModifyCommentHdl(const Link& rLink ) { aModifyComLink = rLink; }
//STRIP001 	const Link&     GetModifyCommentHdl() const { return aModifyComLink; }
//STRIP001 
//STRIP001 
//STRIP001 	// Methoden fuer Calc {
//STRIP001 	void            SetModifyRangeHdl( const Link& rLink ) { aModifyRefLink = rLink; }
//STRIP001 	const Link&     GetModifyRangeHdl() const { return aModifyRefLink; }
//STRIP001 
//STRIP001 	void            SetRefHdl( const Link& rLink ) { aRefLink = rLink; }
//STRIP001 	const Link&     GetRefHdl() const { return aRefLink; }
//STRIP001 
//STRIP001 	void			Enable( BOOL bEnable = TRUE, BOOL bChild = TRUE );
//STRIP001 	void			Disable( BOOL bChild = TRUE );
//STRIP001 
//STRIP001 	// } Methoden fuer Calc
//STRIP001 };

//==================================================================
//	View- Tabpage
//==================================================================

//STRIP001 class SvxTPView: public TabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 
//STRIP001 	Link			AcceptClickLk;
//STRIP001 	Link			AcceptAllClickLk;
//STRIP001 	Link			RejectClickLk;
//STRIP001 	Link			RejectAllClickLk;
//STRIP001 	Link			UndoClickLk;
//STRIP001 
//STRIP001 	SvxRedlinTable 	aViewData;
//STRIP001 	PushButton		PbAccept;
//STRIP001 	PushButton		PbReject;
//STRIP001 	PushButton		PbAcceptAll;
//STRIP001 	PushButton		PbRejectAll;
//STRIP001 	PushButton		PbUndo;
//STRIP001 	String			aTitle1;
//STRIP001 	String			aTitle2;
//STRIP001 	String			aTitle3;
//STRIP001 	String			aTitle4;
//STRIP001 	String			aTitle5;
//STRIP001 	String			aStrMyName;
//STRIP001 	USHORT			nDistance;
//STRIP001 	Size			aMinSize;
//STRIP001 
//STRIP001 	DECL_LINK( PbClickHdl, PushButton* );
//STRIP001 
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001 	void			Resize();
//STRIP001 
//STRIP001 public:
//STRIP001 					SvxTPView( Window * pParent);
//STRIP001 
//STRIP001 	String			GetMyName() const;
//STRIP001 
//STRIP001 	void			InsertWriterHeader();
//STRIP001 	void			InsertCalcHeader();
//STRIP001 	SvxRedlinTable* GetTableControl();
//STRIP001 
//STRIP001 	void			EnableAccept(BOOL nFlag=TRUE);
//STRIP001 	void			EnableAcceptAll(BOOL nFlag=TRUE);
//STRIP001 	void			EnableReject(BOOL nFlag=TRUE);
//STRIP001 	void			EnableRejectAll(BOOL nFlag=TRUE);
//STRIP001 	void			EnableUndo(BOOL nFlag=TRUE);
//STRIP001 
//STRIP001 	void			DisableAccept()		{EnableAccept(FALSE);}
//STRIP001 	void			DisableAcceptAll()	{EnableAcceptAll(FALSE);}
//STRIP001 	void			DisableReject()		{EnableReject(FALSE);}
//STRIP001 	void			DisableRejectAll()	{EnableRejectAll(FALSE);}
//STRIP001 	void			DisableUndo()		{EnableUndo(FALSE);}
//STRIP001 
//STRIP001 	void			ShowUndo(BOOL nFlag=TRUE);
//STRIP001 	void			HideUndo()			{ShowUndo(FALSE);}
//STRIP001 	BOOL			IsUndoVisible();
//STRIP001 
//STRIP001 	Size			GetMinSizePixel();
//STRIP001 
//STRIP001 	void            SetAcceptClickHdl( const Link& rLink ) { AcceptClickLk = rLink; }
//STRIP001 	const Link&     GetAcceptClickHdl() const { return AcceptClickLk; }
//STRIP001 
//STRIP001 	void            SetAcceptAllClickHdl( const Link& rLink ) { AcceptAllClickLk = rLink; }
//STRIP001 	const Link&     GetAcceptAllClickHdl() const { return AcceptAllClickLk; }
//STRIP001 
//STRIP001 	void            SetRejectClickHdl( const Link& rLink ) { RejectClickLk = rLink; }
//STRIP001 	const Link&     GetRejectClickHdl() const { return RejectClickLk; }
//STRIP001 
//STRIP001 	void            SetRejectAllClickHdl( const Link& rLink ) { RejectAllClickLk = rLink; }
//STRIP001 	const Link&     GetRejectAllClickHdl() const { return RejectAllClickLk; }
//STRIP001 
//STRIP001 	void            SetUndoClickHdl( const Link& rLink ) { UndoClickLk = rLink; }
//STRIP001 	const Link&     GetUndoAllClickHdl() const { return UndoClickLk; }
//STRIP001 };

//==================================================================
//	Redlining - Control (Accept- Changes)
//==================================================================

//STRIP001 class SvxAcceptChgCtr : public Control
//STRIP001 {
//STRIP001 private:
//STRIP001 
//STRIP001 	Link			aMinSizeLink;
//STRIP001 	TabControl		aTCAccept;
//STRIP001 	SvxTPFilter*	pTPFilter;
//STRIP001 	SvxTPView*		pTPView;
//STRIP001 	Size			aMinSize;
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001 	virtual void	Resize();
//STRIP001 
//STRIP001 public:
//STRIP001 					SvxAcceptChgCtr( Window* pParent, WinBits nWinStyle = 0 );
//STRIP001 					SvxAcceptChgCtr( Window* pParent, const ResId& rResId );
//STRIP001 
//STRIP001 					~SvxAcceptChgCtr();
//STRIP001 
//STRIP001 	Size			GetMinSizePixel() const;
//STRIP001 
//STRIP001 	void			ShowFilterPage();
//STRIP001 	void			ShowViewPage();
//STRIP001 
//STRIP001 	BOOL			IsFilterPageVisible();
//STRIP001 	BOOL			IsViewPageVisible();
//STRIP001 
//STRIP001 	SvxTPFilter*	GetFilterPage();
//STRIP001 	SvxTPView*		GetViewPage();
//STRIP001 	SvxRedlinTable* GetViewTable();
//STRIP001 
//STRIP001 	void            SetMinSizeHdl( const Link& rLink ) { aMinSizeLink= rLink; }
//STRIP001 	const Link&     GetMinSizeHdl() const { return aMinSizeLink; }
//STRIP001 };

}//end of namespace binfilter
#endif // _SVX_CTREDLIN_HXX

