/*************************************************************************
 *
 *  $RCSfile: hdft2.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 08:27:55 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_HDFT_HXX
#define _SVX_HDFT_HXX

// include ---------------------------------------------------------------

#ifndef _SFXTABDLG_HXX //autogen
#include <bf_sfx2/tabdlg.hxx>
#endif

#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif

#ifndef _GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif

#ifndef _SVX_PAGECTRL_HXX //autogen
#include <bf_svx/pagectrl.hxx>
#endif
namespace binfilter {

// class  SvxHFPage ------------------------------------------------------

//STRIP001 class SvxHFPage: public SfxTabPage
//STRIP001 {
//STRIP001 public:
//STRIP001 
//STRIP001 	virtual BOOL 	FillItemSet( SfxItemSet& rOutSet );
//STRIP001 	virtual void	Reset( const SfxItemSet& rSet );
//STRIP001 
//STRIP001 	virtual 		~SvxHFPage();
//STRIP001 
//STRIP001 	void			DisableDeleteQueryBox() { bDisableQueryBox = TRUE; }
//STRIP001 	void			EnableBackgroundSelector( BOOL bNew ) { bEnableBackgroundSelector = bNew; }
//STRIP001     void            EnableDynamicSpacing();
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void	ActivatePage( const SfxItemSet& rSet );
//STRIP001 	virtual int		DeactivatePage( SfxItemSet* pSet = 0 );
//STRIP001 
//STRIP001 	SvxHFPage( Window* pParent, USHORT nResId, const SfxItemSet& rSet,
//STRIP001 			   USHORT nSetId );
//STRIP001 
//STRIP001 	CheckBox        aTurnOnBox;
//STRIP001 	CheckBox        aCntSharedBox;
//STRIP001 	FixedText       aLMLbl;
//STRIP001 	MetricField     aLMEdit;
//STRIP001 	FixedText       aRMLbl;
//STRIP001 	MetricField     aRMEdit;
//STRIP001 	FixedText		aDistFT;
//STRIP001 	MetricField     aDistEdit;
//STRIP001     CheckBox        aDynSpacingCB;
//STRIP001 	FixedText		aHeightFT;
//STRIP001 	MetricField     aHeightEdit;
//STRIP001 	CheckBox     	aHeightDynBtn;
//STRIP001 	FixedLine       aFrm;
//STRIP001 	SvxPageWindow	aBspWin;
//STRIP001 	PushButton		aBackgroundBtn;
//STRIP001 
//STRIP001 	USHORT			nId;
//STRIP001 	SfxItemSet*		pBBSet;
//STRIP001 	BOOL			bDisableQueryBox;
//STRIP001 	BOOL			bEnableBackgroundSelector;
//STRIP001 	FASTBOOL		bInReset;
//STRIP001 
//STRIP001 	void 			InitHandler();
//STRIP001 	DECL_LINK( TurnOnHdl, CheckBox*);
//STRIP001 	DECL_LINK( DistModify, MetricField*);
//STRIP001 	DECL_LINK( HeightModify, MetricField*);
//STRIP001 	DECL_LINK( BorderModify, MetricField*);
//STRIP001 	DECL_LINK( BackgroundHdl, Button*);
//STRIP001 
//STRIP001 	void			UpdateExample();
//STRIP001 	DECL_LINK( RangeHdl, Edit*);
//STRIP001 
//STRIP001 private:
//STRIP001 #ifdef _SVX_HDFT_CXX
//STRIP001 	void			ResetBackground_Impl( const SfxItemSet& rSet );
//STRIP001 #endif
//STRIP001 };

// class SvxHeaderPage ---------------------------------------------------

//STRIP001 class SvxHeaderPage : public SvxHFPage
//STRIP001 {
//STRIP001 public:
//STRIP001 	static SfxTabPage* 	Create(	Window* pParent, const SfxItemSet& rSet );
//STRIP001 	static USHORT*		GetRanges();
//STRIP001 
//STRIP001 private:
//STRIP001 	SvxHeaderPage( Window* pParent, const SfxItemSet& rSet );
//STRIP001 };

// class SvxFooterPage ---------------------------------------------------

//STRIP001 class SvxFooterPage : public SvxHFPage
//STRIP001 {
//STRIP001 public:
//STRIP001 	static SfxTabPage* 	Create(	Window* pParent, const SfxItemSet& rSet );
//STRIP001 	static USHORT*		GetRanges();
//STRIP001 
//STRIP001 private:
//STRIP001 	SvxFooterPage( 	Window* pParent, const SfxItemSet& rSet );
//STRIP001 };

}//end of namespace binfilter
#endif

