/*************************************************************************
 *
 *  $RCSfile: numpages.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 08:28:15 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_NUMPAGES_HXX
#define _SVX_NUMPAGES_HXX

// include ---------------------------------------------------------------

#ifndef _SFXTABDLG_HXX //autogen
#include <bf_sfx2/tabdlg.hxx>
#endif
#ifndef _SV_GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif
#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_MENUBTN_HXX //autogen
#include <vcl/menubtn.hxx>
#endif
#ifndef _SV_LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif
#ifndef _SV_EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif
#ifndef _SV_FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif
#ifndef _SVX_NUMDEF_HXX
#include <bf_svx/numdef.hxx>
#endif
#ifndef _CTRLBOX_HXX //autogen
#include <svtools/ctrlbox.hxx>
#endif
#ifndef _SVARRAY_HXX //autogen
#include <svtools/svarray.hxx>
#endif
namespace binfilter {

// -----------------------------------------------------------------------
//STRIP001 class SvxNumRule;
//STRIP001 class SvxBmpNumValueSet;
//STRIP001 class SvxNumValueSet;
//STRIP001 class ValueSet;
//STRIP001 class SvxNumberingPreview;
//STRIP001 class SvxBrushItem;

#if SUPD>642
#else
//assert compatibility to removed NumMenuButton
//STRIP001 class NumLocalExtMenuButton : public MenuButton
//STRIP001 {
//STRIP001 	Link            maClickHdl_Impl;
//STRIP001 	public:
//STRIP001         NumLocalExtMenuButton(Window* pParent, const ResId& rResId) :
//STRIP001 			MenuButton(pParent, rResId){}
//STRIP001 
//STRIP001 };
#endif
/*-----------------13.02.97 14.02-------------------

--------------------------------------------------*/

//STRIP001 struct SvxNumSettings_Impl
//STRIP001 {
//STRIP001 	short			nNumberType;
//STRIP001 	short 			nParentNumbering;
//STRIP001 	::rtl::OUString	sPrefix;
//STRIP001 	::rtl::OUString	sSuffix;
//STRIP001 	::rtl::OUString	sBulletChar;
//STRIP001 	::rtl::OUString	sBulletFont;
//STRIP001 	SvxNumSettings_Impl() :
//STRIP001 		nNumberType(0),
//STRIP001 		nParentNumbering(0)
//STRIP001 		{}
//STRIP001 };

//STRIP001 typedef SvxNumSettings_Impl* SvxNumSettings_ImplPtr;
//STRIP001 SV_DECL_PTRARR_DEL(SvxNumSettingsArr_Impl,SvxNumSettings_ImplPtr,8,4)

/*-----------------07.02.97 11.36-------------------

--------------------------------------------------*/
//STRIP001 class SvxSingleNumPickTabPage : public SfxTabPage
//STRIP001 {
//STRIP001     FixedLine               aValuesFL;
//STRIP001 	SvxNumValueSet* 		pExamplesVS;
//STRIP001 	SvxNumSettingsArr_Impl	aNumSettingsArr;
//STRIP001 	SvxNumRule* 			pActNum;
//STRIP001 	SvxNumRule* 			pSaveNum;
//STRIP001 	USHORT					nActNumLvl;
//STRIP001 	BOOL					bModified 	: 1;
//STRIP001 	BOOL					bHasChild 	: 1;
//STRIP001 	BOOL					bPreset		: 1;
//STRIP001 
//STRIP001 	String				sNumCharFmtName;
//STRIP001 	USHORT 				nNumItemId;
//STRIP001 
//STRIP001 	protected:
//STRIP001 		DECL_LINK( NumSelectHdl_Impl, ValueSet*);
//STRIP001 		DECL_LINK( DoubleClickHdl_Impl, ValueSet* );
//STRIP001 
//STRIP001 	public:
//STRIP001 		SvxSingleNumPickTabPage(Window* pParent,
//STRIP001 							   const SfxItemSet& rSet);
//STRIP001 		~SvxSingleNumPickTabPage();
//STRIP001 
//STRIP001 	static SfxTabPage*	Create( Window* pParent,
//STRIP001 								const SfxItemSet& rAttrSet);
//STRIP001 
//STRIP001 	virtual void 		ActivatePage(const SfxItemSet& rSet);
//STRIP001 	virtual int 		DeactivatePage(SfxItemSet *pSet);
//STRIP001 	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual	void 		Reset( const SfxItemSet& rSet );
//STRIP001 
//STRIP001 	void				SetNumCharFmtName(const String& rName){sNumCharFmtName = rName;}
//STRIP001 };

/*-----------------07.02.97 11.36-------------------

--------------------------------------------------*/

//STRIP001 class SvxBulletPickTabPage : public SfxTabPage
//STRIP001 {
//STRIP001     FixedLine           aValuesFL;
//STRIP001 	SvxNumValueSet*		pExamplesVS;
//STRIP001 	SvxNumRule* 		pActNum;
//STRIP001 	SvxNumRule* 		pSaveNum;
//STRIP001 	USHORT 				nActNumLvl;
//STRIP001 	BOOL				bModified 	: 1;
//STRIP001 	BOOL				bHasChild 	: 1;
//STRIP001 	BOOL				bPreset		: 1;
//STRIP001 	USHORT 				nNumItemId;
//STRIP001 
//STRIP001 	String				sBulletCharFmtName;
//STRIP001 	protected:
//STRIP001 		DECL_LINK(NumSelectHdl_Impl, ValueSet*);
//STRIP001 		DECL_LINK( DoubleClickHdl_Impl, ValueSet* );
//STRIP001 	public:
//STRIP001 		SvxBulletPickTabPage(Window* pParent,
//STRIP001 							   const SfxItemSet& rSet);
//STRIP001 		~SvxBulletPickTabPage();
//STRIP001 
//STRIP001 	static SfxTabPage*	Create( Window* pParent,
//STRIP001 								const SfxItemSet& rAttrSet);
//STRIP001 
//STRIP001 	virtual void 		ActivatePage(const SfxItemSet& rSet);
//STRIP001 	virtual int 		DeactivatePage(SfxItemSet *pSet);
//STRIP001 	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual	void 		Reset( const SfxItemSet& rSet );
//STRIP001 
//STRIP001 	void				SetCharFmtName(const String& rName){sBulletCharFmtName = rName;}
//STRIP001 };

/*-----------------07.02.97 11.36-------------------
	TabPage fuer vollstaendig Numerierung
--------------------------------------------------*/
//STRIP001 #define NUMTYPE_MEMBER 4   // Anzahl der Elemente des FormatStrings je Ebene
//STRIP001 #define NUM_VALUSET_COUNT 8
//STRIP001 class SvxNumPickTabPage : public SfxTabPage
//STRIP001 {
//STRIP001     FixedLine           aValuesFL;
//STRIP001 	SvxNumValueSet*		pExamplesVS;
//STRIP001 	String				sNumCharFmtName;
//STRIP001 	String				sBulletCharFmtName;
//STRIP001 
//STRIP001 	SvxNumSettingsArr_Impl	aNumSettingsArrays[NUM_VALUSET_COUNT];	// wird mit den fuenf Formaten initialisiert
//STRIP001 
//STRIP001 	SvxNumRule* 		pActNum;
//STRIP001 	SvxNumRule* 		pSaveNum;
//STRIP001 	USHORT 				nActNumLvl;
//STRIP001 	USHORT 				nNumItemId;
//STRIP001 	BOOL				bModified 	: 1;
//STRIP001 	BOOL				bPreset		: 1;
//STRIP001 
//STRIP001 
//STRIP001 	protected:
//STRIP001 		DECL_LINK(NumSelectHdl_Impl, ValueSet*);
//STRIP001 		DECL_LINK( DoubleClickHdl_Impl, ValueSet* );
//STRIP001 
//STRIP001 	public:
//STRIP001 		SvxNumPickTabPage(Window* pParent,
//STRIP001 							   const SfxItemSet& rSet);
//STRIP001 		~SvxNumPickTabPage();
//STRIP001 
//STRIP001 	static SfxTabPage*	Create( Window* pParent,
//STRIP001 								const SfxItemSet& rAttrSet);
//STRIP001 
//STRIP001 	virtual void 		ActivatePage(const SfxItemSet& rSet);
//STRIP001 	virtual int 		DeactivatePage(SfxItemSet *pSet);
//STRIP001 	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual	void 		Reset( const SfxItemSet& rSet );
//STRIP001 
//STRIP001 	void				SetCharFmtNames(const String& rCharName, const String& rBulName)
//STRIP001 							{	sNumCharFmtName = rCharName;
//STRIP001 								sBulletCharFmtName = rBulName;}
//STRIP001 };

/*-----------------12.02.97 07.42-------------------

--------------------------------------------------*/
//STRIP001 class SvxBitmapPickTabPage : public SfxTabPage
//STRIP001 {
//STRIP001     FixedLine           aValuesFL;
//STRIP001 	SvxBmpNumValueSet* 	pExamplesVS;
//STRIP001 	FixedText			aErrorText;
//STRIP001 	CheckBox			aLinkedCB;
//STRIP001 
//STRIP001 	List				aGrfNames;
//STRIP001 	String				sNumCharFmtName;
//STRIP001 
//STRIP001 	SvxNumRule* 		pActNum;
//STRIP001 	SvxNumRule* 		pSaveNum;
//STRIP001 	USHORT 				nActNumLvl;
//STRIP001 	USHORT 				nNumItemId;
//STRIP001 	SfxMapUnit			eCoreUnit;
//STRIP001 	BOOL				bModified 	: 1;
//STRIP001 	BOOL				bHasChild 	: 1;
//STRIP001 	BOOL				bPreset		: 1;
//STRIP001 
//STRIP001 	protected:
//STRIP001 		DECL_LINK( NumSelectHdl_Impl, ValueSet*);
//STRIP001 		DECL_LINK( DoubleClickHdl_Impl, ValueSet* );
//STRIP001 		DECL_LINK( LinkBmpHdl_Impl, CheckBox* );
//STRIP001 
//STRIP001 	public:
//STRIP001 		SvxBitmapPickTabPage(Window* pParent,
//STRIP001 							   const SfxItemSet& rSet);
//STRIP001 		~SvxBitmapPickTabPage();
//STRIP001 
//STRIP001 	static SfxTabPage*	Create( Window* pParent,
//STRIP001 								const SfxItemSet& rAttrSet);
//STRIP001 
//STRIP001 	virtual void 		ActivatePage(const SfxItemSet& rSet);
//STRIP001 	virtual int 		DeactivatePage(SfxItemSet *pSet);
//STRIP001 	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual	void 		Reset( const SfxItemSet& rSet );
//STRIP001 
//STRIP001 	void				SetNumCharFmtName(const String& rName){sNumCharFmtName = rName;}
//STRIP001 };

/*-----------------01.12.97 16:13-------------------

--------------------------------------------------*/
//STRIP001 class SvxNumOptionsTabPage : public SfxTabPage
//STRIP001 {
//STRIP001     FixedLine       aFormatFL;
//STRIP001     FixedText       aLevelFT;
//STRIP001 	MultiListBox	aLevelLB;
//STRIP001 
//STRIP001     FixedText       aFmtFT;
//STRIP001 	ListBox     	aFmtLB;
//STRIP001 	FixedText   	aPrefixFT;
//STRIP001 	Edit        	aPrefixED;
//STRIP001 	FixedText   	aSuffixFT;
//STRIP001 	Edit        	aSuffixED;
//STRIP001 	FixedText		aCharFmtFT;
//STRIP001 	ListBox			aCharFmtLB;
//STRIP001 	FixedText		aBulColorFT;
//STRIP001 	ColorListBox	aBulColLB;
//STRIP001 	FixedText 		aBulRelSizeFT;
//STRIP001 	MetricField		aBulRelSizeMF;
//STRIP001 	FixedText       aAllLevelFT;
//STRIP001 	NumericField	aAllLevelNF;
//STRIP001 	FixedText       aStartFT;
//STRIP001 	NumericField    aStartED;
//STRIP001 	PushButton      aBulletPB;
//STRIP001 	TriStateBox		aUseBulletCB;
//STRIP001 	FixedText		aAlignFT;
//STRIP001 	ListBox			aAlignLB;
//STRIP001 
//STRIP001 	FixedText 		aBitmapFT;
//STRIP001 #if SUPD>642
//STRIP001     MenuButton      aBitmapMB;
//STRIP001 #else
//STRIP001     NumLocalExtMenuButton aBitmapMB;
//STRIP001 #endif
//STRIP001 	FixedText 		aSizeFT;
//STRIP001 	MetricField		aWidthMF;
//STRIP001 	FixedText		aMultFT;
//STRIP001 	MetricField		aHeightMF;
//STRIP001 	CheckBox		aRatioCB;
//STRIP001 	FixedText		aOrientFT;
//STRIP001 	ListBox			aOrientLB;
//STRIP001 
//STRIP001     FixedLine       aSameLevelFL;
//STRIP001 	CheckBox		aSameLevelCB;
//STRIP001 
//STRIP001 	String 			sNumCharFmtName;
//STRIP001 	String 			sBulletCharFmtName;
//STRIP001 
//STRIP001     Timer           aInvalidateTimer;
//STRIP001 
//STRIP001 	SvxNumberingPreview*	pPreviewWIN;
//STRIP001 
//STRIP001 	SvxNumRule* 		pActNum;
//STRIP001 	SvxNumRule* 		pSaveNum;
//STRIP001 	//SwWrtShell* 		pWrtSh;
//STRIP001 	//SwDocShell*			pDocSh;
//STRIP001 	Size				aInitSize[SVX_MAX_NUM];
//STRIP001 
//STRIP001 	BOOL				bHasChild 			: 1;
//STRIP001 	BOOL				bLastWidthModified 	: 1;
//STRIP001 	BOOL				bModified 			: 1;
//STRIP001 	BOOL				bPreset				: 1;
//STRIP001 	BOOL				bAutomaticCharStyles: 1;
//STRIP001 	BOOL 				bHTMLMode 			: 1;
//STRIP001 	BOOL				bMenuButtonInitialized : 1;
//STRIP001 
//STRIP001 	List				aGrfNames;
//STRIP001 	Font            	aActBulletFont;
//STRIP001 	String				sBullet;
//STRIP001 	String				sStartWith;
//STRIP001 
//STRIP001 	BYTE            	nBullet;
//STRIP001 	USHORT				nActNumLvl;
//STRIP001 	USHORT 				nNumItemId;
//STRIP001 	SfxMapUnit			eCoreUnit;
//STRIP001 
//STRIP001 	void				InitControls();
//STRIP001 	void				SwitchNumberType( BYTE nType, BOOL bBmp = FALSE );
//STRIP001     void                CheckForStartValue_Impl(sal_uInt16 nNumberingType);
//STRIP001 
//STRIP001 		DECL_LINK( NumberTypeSelectHdl_Impl, ListBox * );
//STRIP001 		DECL_LINK( LevelHdl_Impl, ListBox * );
//STRIP001 		DECL_LINK( PopupActivateHdl_Impl, Menu * );
//STRIP001 		DECL_LINK( GraphicHdl_Impl, MenuButton * );
//STRIP001 		DECL_LINK( BulletHdl_Impl, Button * );
//STRIP001 		DECL_LINK( SizeHdl_Impl, MetricField * );
//STRIP001 		DECL_LINK( RatioHdl_Impl, CheckBox * );
//STRIP001 		DECL_LINK( CharFmtHdl_Impl, ListBox * );
//STRIP001 		DECL_LINK( EditModifyHdl_Impl, Edit * );
//STRIP001 		DECL_LINK( AllLevelHdl_Impl, NumericField * );
//STRIP001 		DECL_LINK( OrientHdl_Impl, ListBox * );
//STRIP001 		DECL_LINK( SameLevelHdl_Impl, CheckBox * );
//STRIP001 		DECL_LINK( BulColorHdl_Impl, ColorListBox* );
//STRIP001 		DECL_LINK( BulRelSizeHdl_Impl, MetricField *);
//STRIP001 		DECL_LINK( UseBulletHdl_Impl, TriStateBox* );
//STRIP001         DECL_LINK( PreviewInvalidateHdl_Impl, Timer* );
//STRIP001 
//STRIP001 		DECL_STATIC_LINK( SvxNumOptionsTabPage, GraphicArrivedHdl_Impl, SvxBrushItem* );
//STRIP001 
//STRIP001 	public:
//STRIP001 		SvxNumOptionsTabPage(Window* pParent,
//STRIP001 							   const SfxItemSet& rSet);
//STRIP001 		~SvxNumOptionsTabPage();
//STRIP001 
//STRIP001 	static SfxTabPage*	Create( Window* pParent,
//STRIP001 								const SfxItemSet& rAttrSet);
//STRIP001 
//STRIP001 	virtual void 		ActivatePage(const SfxItemSet& rSet);
//STRIP001 	virtual int 		DeactivatePage(SfxItemSet *pSet);
//STRIP001 	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual	void 		Reset( const SfxItemSet& rSet );
//STRIP001 
//STRIP001 //???	void				SetWrtShell(SwWrtShell* pSh);
//STRIP001 	void				SetCharFmts(const String& rNumName, const String& rBulletName )
//STRIP001 								{
//STRIP001 									sNumCharFmtName = rNumName;
//STRIP001 									sBulletCharFmtName = rBulletName;
//STRIP001 								}
//STRIP001 	void				SetMetric(FieldUnit eSet);
//STRIP001 
//STRIP001 	ListBox&			GetCharFmtListBox() {return aCharFmtLB;}
//STRIP001 	void				SetModified(BOOL bRepaint = TRUE);
//STRIP001 };

/*-----------------03.12.97 10:18-------------------

--------------------------------------------------*/
//STRIP001 class SvxNumPositionTabPage : public SfxTabPage
//STRIP001 {
//STRIP001     FixedLine           aPositionFL;
//STRIP001     FixedText           aLevelFT;
//STRIP001     MultiListBox        aLevelLB;
//STRIP001 
//STRIP001 	FixedText       	aDistBorderFT;
//STRIP001 	MetricField			aDistBorderMF;
//STRIP001 	CheckBox			aRelativeCB;
//STRIP001 
//STRIP001 
//STRIP001 	FixedText			aIndentFT;
//STRIP001 	MetricField			aIndentMF;
//STRIP001 	FixedText       	aDistNumFT;
//STRIP001 	MetricField			aDistNumMF;
//STRIP001 
//STRIP001 	FixedText			aAlignFT;
//STRIP001 	ListBox				aAlignLB;
//STRIP001 
//STRIP001 	PushButton			aStandardPB;
//STRIP001 
//STRIP001 #if OSL_DEBUG_LEVEL > 1
//STRIP001 	FixedText* 			pDebugFixedText;
//STRIP001 #endif
//STRIP001 	SvxNumberingPreview* pPreviewWIN;
//STRIP001 
//STRIP001 	SvxNumRule* 		pActNum;
//STRIP001 	SvxNumRule* 		pSaveNum;
//STRIP001 
//STRIP001 	USHORT				nActNumLvl;
//STRIP001 	USHORT 				nNumItemId;
//STRIP001 	SfxMapUnit			eCoreUnit;
//STRIP001 
//STRIP001 	BOOL				bModified 			: 1;
//STRIP001 	BOOL				bHasChild 			: 1;
//STRIP001 	BOOL				bPreset				: 1;
//STRIP001 	BOOL				bInInintControl		: 1;  //Modify-Fehler umgehen, soll ab 391 behoben sein
//STRIP001 
//STRIP001 //	void 				SetMinDist();
//STRIP001 	void				InitControls();
//STRIP001 
//STRIP001 	DECL_LINK( LevelHdl_Impl, ListBox * );
//STRIP001 	DECL_LINK( EditModifyHdl_Impl, Edit*);
//STRIP001 	DECL_LINK( DistanceHdl_Impl, MetricField * );
//STRIP001 	DECL_LINK( RelativeHdl_Impl, CheckBox * );
//STRIP001 	DECL_LINK( StandardHdl_Impl, PushButton * );
//STRIP001 
//STRIP001 	public:
//STRIP001 		SvxNumPositionTabPage(Window* pParent,
//STRIP001 							   const SfxItemSet& rSet);
//STRIP001 		~SvxNumPositionTabPage();
//STRIP001 
//STRIP001 	virtual void 		ActivatePage(const SfxItemSet& rSet);
//STRIP001 	virtual int 		DeactivatePage(SfxItemSet *pSet);
//STRIP001 	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual	void 		Reset( const SfxItemSet& rSet );
//STRIP001 
//STRIP001 	static SfxTabPage*	Create( Window* pParent,
//STRIP001 								const SfxItemSet& rAttrSet);
//STRIP001 
//STRIP001 	void				SetMetric(FieldUnit eSet);
//STRIP001 	void				SetModified(BOOL bRepaint = TRUE);
//STRIP001 };

}//end of namespace binfilter
#endif

