/*************************************************************************
 *
 *  $RCSfile: svddrgmt.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:29:08 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SVDDRGMT_HXX
#define _SVDDRGMT_HXX

// auto strip #ifndef _SVDDRGV_HXX
// auto strip #include <bf_svx/svddrgv.hxx>
// auto strip #endif
namespace binfilter {

////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  @@@@@  @@@@@   @@@@   @@@@   @@   @@ @@@@@ @@@@@@ @@  @@  @@@@  @@@@@   @@@@
//  @@  @@ @@  @@ @@  @@ @@  @@  @@@ @@@ @@      @@   @@  @@ @@  @@ @@  @@ @@  @@
//  @@  @@ @@  @@ @@  @@ @@      @@@@@@@ @@      @@   @@  @@ @@  @@ @@  @@ @@
//  @@  @@ @@@@@  @@@@@@ @@ @@@  @@@@@@@ @@@@    @@   @@@@@@ @@  @@ @@  @@  @@@@
//  @@  @@ @@  @@ @@  @@ @@  @@  @@ @ @@ @@      @@   @@  @@ @@  @@ @@  @@     @@
//  @@  @@ @@  @@ @@  @@ @@  @@  @@   @@ @@      @@   @@  @@ @@  @@ @@  @@ @@  @@
//  @@@@@  @@  @@ @@  @@  @@@@@  @@   @@ @@@@@   @@   @@  @@  @@@@  @@@@@   @@@@
//
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

class SdrDragView;
class SdrDragStat;

//STRIP001 class SdrDragMethod {
//STRIP001 protected:
//STRIP001 	SdrDragView& rView;
//STRIP001 	FASTBOOL     bMoveOnly;
//STRIP001 protected:
//STRIP001 #if _SOLAR__PRIVATE
//STRIP001 	void               ImpTakeDescriptionStr(USHORT nStrCacheID, String& rStr, USHORT nVal=0) const;
//STRIP001 #endif // __PRIVATE
//STRIP001 	SdrHdl*            GetDragHdl() const              { return rView.pDragHdl; }
//STRIP001 	SdrHdlKind         GetDragHdlKind() const          { return rView.eDragHdl; }
//STRIP001 	SdrDragStat&       DragStat()                      { return rView.aDragStat; }
//STRIP001 	const SdrDragStat& DragStat() const                { return rView.aDragStat; }
//STRIP001 	Point&             Ref1() const                    { return rView.aRef1; }
//STRIP001 	Point&             Ref2() const                    { return rView.aRef2; }
//STRIP001 	const SdrHdlList&  GetHdlList() const              { return rView.aHdl; }
//STRIP001 	void               AddUndo(SdrUndoAction* pUndo)   { rView.AddUndo(pUndo); }
//STRIP001 	void               SetStripes(FASTBOOL bOn)        { rView.aAni.SetStripes(bOn); }
//STRIP001 	void               SetDragPolys()                  { rView.SetDragPolys(FALSE); }
//STRIP001 	void               SetDragPolysSeparated()         { rView.SetDragPolys(FALSE,TRUE); }
//STRIP001 	FASTBOOL           IsDragLimit()                   { return rView.bDragLimit; }
//STRIP001 	const Rectangle&   GetDragLimitRect()              { return rView.aDragLimit; }
//STRIP001 	const SdrMarkList& GetMarkList()                   { return rView.aMark; }
//STRIP001 	Point              GetSnapPos(const Point& rPt) const { return rView.GetSnapPos(rPt,rView.pMarkedPV); }
//STRIP001 	USHORT             SnapPos(Point& rPt) const       { return rView.SnapPos(rPt,rView.pMarkedPV); }
//STRIP001 	inline const Rectangle& GetMarkedRect() const;
//STRIP001 	SdrPageView*       GetDragPV() const;
//STRIP001 	SdrObject*         GetDragObj() const;
//STRIP001 	OutputDevice*      GetDragWin() const              { return rView.pDragWin; }
//STRIP001 	FASTBOOL           IsDraggingPoints() const        { return rView.IsDraggingPoints(); }
//STRIP001 	FASTBOOL           IsDraggingGluePoints() const    { return rView.IsDraggingGluePoints(); }
//STRIP001 public:
//STRIP001 	TYPEINFO();
//STRIP001 	SdrDragMethod(SdrDragView& rNewView): rView(rNewView),bMoveOnly(FALSE) {}
//STRIP001 	virtual void Draw() const;
//STRIP001 	virtual void Show();
//STRIP001 	virtual void Hide();
//STRIP001 	virtual void TakeComment(String& rStr) const=0;
//STRIP001 	virtual FASTBOOL Beg()=0;
//STRIP001 	virtual void MovAllPoints();
//STRIP001 	virtual void MovPoint(Point& rPnt, const Point& rPvOfs);
//STRIP001 	virtual void Mov(const Point& rPnt)=0;
//STRIP001 	virtual FASTBOOL End(FASTBOOL bCopy)=0;
//STRIP001 	virtual void Brk();
//STRIP001 	virtual Pointer GetPointer() const=0;
//STRIP001 	virtual FASTBOOL IsMoveOnly() const; // TRUE, wenn nur verschoben wird
//STRIP001 	virtual void DrawXor(ExtOutputDevice& rXOut, FASTBOOL bFull) const;
//STRIP001 };

//STRIP001 inline const Rectangle& SdrDragMethod::GetMarkedRect() const
//STRIP001 {
//STRIP001 	return rView.eDragHdl==HDL_POLY ? rView.GetMarkedPointsRect() :
//STRIP001 		   rView.eDragHdl==HDL_GLUE ? rView.GetMarkedGluePointsRect() :
//STRIP001 		   rView.GetMarkedObjRect();
//STRIP001 }

////////////////////////////////////////////////////////////////////////////////////////////////////

}//end of namespace binfilter
#endif //_SVDDRGMT_HXX

